Option Explicit On 
Option Strict On

Imports System.Windows.Forms

Public Class frmCiteInfo
    Inherits System.Windows.Forms.Form

    Public Shared newCite As New CiteInfo      'main citation
    Public Shared bUpdate As Boolean       'tells whether citation was changed
    Public Shared newLWC As New CiteInfo       'larger work citation
    Public Shared bLWC As Boolean          'tells whether there is a larger work citation to process
    Public Shared intTimeStyle As Integer  'tells what format is in use for time
    Private Shared dYear As Decimal
    Friend WithEvents button_example As System.Windows.Forms.Button
    Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip        'current year
    Private Shared bDisplayLWC As Boolean  'tells whether form is for primary or larger work citation

#Region " Windows Form Designer generated code "

    Public Sub New(ByVal inCite As CiteInfo, ByVal inLWC As CiteInfo, ByVal binLWC As Boolean, ByVal inTime As Integer)
        MyBase.New()
        InitializeComponent()

        'this call brings in the primary and larger work citations to be modified
        newCite = New CiteInfo
        newCite = inCite
        bLWC = binLWC
        If (bLWC = True) Then
            newLWC = New CiteInfo
            newLWC = inLWC
        Else
            newLWC = New CiteInfo
        End If

        'bUpdate tells the calling routine whether it needs to update the main form and XML node(s)
        bUpdate = False

        'initialize values of public variables
        intTimeStyle = inTime

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents txtAuthor As System.Windows.Forms.TextBox
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    Friend WithEvents rdoDateUnk As System.Windows.Forms.RadioButton
    Friend WithEvents rdoDateUnpub As System.Windows.Forms.RadioButton
    Friend WithEvents rdoDateCal As System.Windows.Forms.RadioButton
    Friend WithEvents Panel2 As System.Windows.Forms.Panel
    Friend WithEvents Label5 As System.Windows.Forms.Label
    Friend WithEvents Label6 As System.Windows.Forms.Label
    Friend WithEvents Label7 As System.Windows.Forms.Label
    Friend WithEvents cboxMonth As System.Windows.Forms.ComboBox
    Friend WithEvents cboxDay As System.Windows.Forms.ComboBox
    Friend WithEvents lblTime1 As System.Windows.Forms.Label
    Friend WithEvents txtTime As System.Windows.Forms.TextBox
    Friend WithEvents cboxTimeDiff As System.Windows.Forms.ComboBox
    Friend WithEvents lblTdiff As System.Windows.Forms.Label
    Friend WithEvents txtTitle As System.Windows.Forms.TextBox
    Friend WithEvents Label8 As System.Windows.Forms.Label
    Friend WithEvents txtEdition As System.Windows.Forms.TextBox
    Friend WithEvents Label9 As System.Windows.Forms.Label
    Friend WithEvents Label10 As System.Windows.Forms.Label
    Friend WithEvents Panel3 As System.Windows.Forms.Panel
    Friend WithEvents Label11 As System.Windows.Forms.Label
    Friend WithEvents Label12 As System.Windows.Forms.Label
    Friend WithEvents txtSeries As System.Windows.Forms.TextBox
    Friend WithEvents txtSeriesID As System.Windows.Forms.TextBox
    Friend WithEvents Label13 As System.Windows.Forms.Label
    Friend WithEvents Panel4 As System.Windows.Forms.Panel
    Friend WithEvents Label14 As System.Windows.Forms.Label
    Friend WithEvents Label15 As System.Windows.Forms.Label
    Friend WithEvents txtPubPlace As System.Windows.Forms.TextBox
    Friend WithEvents txtPublish As System.Windows.Forms.TextBox
    Friend WithEvents Label16 As System.Windows.Forms.Label
    Friend WithEvents txtOther As System.Windows.Forms.TextBox
    Friend WithEvents Label17 As System.Windows.Forms.Label
    Friend WithEvents txtLink As System.Windows.Forms.TextBox
    Friend WithEvents cboxDForm As System.Windows.Forms.ComboBox
    Friend WithEvents btnOK As System.Windows.Forms.Button
    Friend WithEvents btnCancel As System.Windows.Forms.Button
    Friend WithEvents pnlLWC As System.Windows.Forms.Panel
    Friend WithEvents Panel6 As System.Windows.Forms.Panel
    Friend WithEvents rdoLWCno As System.Windows.Forms.RadioButton
    Friend WithEvents rdoLWCyes As System.Windows.Forms.RadioButton
    Friend WithEvents numYear As System.Windows.Forms.NumericUpDown
    Friend WithEvents lblTitle As System.Windows.Forms.Label
    Friend WithEvents lblLWC As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(frmCiteInfo))
        Me.Label1 = New System.Windows.Forms.Label
        Me.Label2 = New System.Windows.Forms.Label
        Me.Label3 = New System.Windows.Forms.Label
        Me.Label4 = New System.Windows.Forms.Label
        Me.txtAuthor = New System.Windows.Forms.TextBox
        Me.Panel1 = New System.Windows.Forms.Panel
        Me.rdoDateCal = New System.Windows.Forms.RadioButton
        Me.rdoDateUnpub = New System.Windows.Forms.RadioButton
        Me.rdoDateUnk = New System.Windows.Forms.RadioButton
        Me.Panel2 = New System.Windows.Forms.Panel
        Me.numYear = New System.Windows.Forms.NumericUpDown
        Me.cboxDay = New System.Windows.Forms.ComboBox
        Me.cboxMonth = New System.Windows.Forms.ComboBox
        Me.Label7 = New System.Windows.Forms.Label
        Me.Label6 = New System.Windows.Forms.Label
        Me.Label5 = New System.Windows.Forms.Label
        Me.lblTime1 = New System.Windows.Forms.Label
        Me.txtTime = New System.Windows.Forms.TextBox
        Me.lblTdiff = New System.Windows.Forms.Label
        Me.cboxTimeDiff = New System.Windows.Forms.ComboBox
        Me.btnOK = New System.Windows.Forms.Button
        Me.txtTitle = New System.Windows.Forms.TextBox
        Me.Label8 = New System.Windows.Forms.Label
        Me.txtEdition = New System.Windows.Forms.TextBox
        Me.Label9 = New System.Windows.Forms.Label
        Me.cboxDForm = New System.Windows.Forms.ComboBox
        Me.Label10 = New System.Windows.Forms.Label
        Me.Panel3 = New System.Windows.Forms.Panel
        Me.txtSeriesID = New System.Windows.Forms.TextBox
        Me.txtSeries = New System.Windows.Forms.TextBox
        Me.Label12 = New System.Windows.Forms.Label
        Me.Label11 = New System.Windows.Forms.Label
        Me.Label13 = New System.Windows.Forms.Label
        Me.Panel4 = New System.Windows.Forms.Panel
        Me.txtPublish = New System.Windows.Forms.TextBox
        Me.txtPubPlace = New System.Windows.Forms.TextBox
        Me.Label15 = New System.Windows.Forms.Label
        Me.Label14 = New System.Windows.Forms.Label
        Me.Label16 = New System.Windows.Forms.Label
        Me.txtOther = New System.Windows.Forms.TextBox
        Me.Label17 = New System.Windows.Forms.Label
        Me.txtLink = New System.Windows.Forms.TextBox
        Me.lblTitle = New System.Windows.Forms.Label
        Me.btnCancel = New System.Windows.Forms.Button
        Me.pnlLWC = New System.Windows.Forms.Panel
        Me.Panel6 = New System.Windows.Forms.Panel
        Me.rdoLWCno = New System.Windows.Forms.RadioButton
        Me.rdoLWCyes = New System.Windows.Forms.RadioButton
        Me.lblLWC = New System.Windows.Forms.Label
        Me.button_example = New System.Windows.Forms.Button
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.Panel1.SuspendLayout()
        Me.Panel2.SuspendLayout()
        CType(Me.numYear, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.Panel3.SuspendLayout()
        Me.Panel4.SuspendLayout()
        Me.pnlLWC.SuspendLayout()
        Me.Panel6.SuspendLayout()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label1.Location = New System.Drawing.Point(12, 23)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(72, 16)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "Author(s)"
        Me.ToolTip1.SetToolTip(Me.Label1, "The name of an organization or individual that developed the data set.")
        '
        'Label2
        '
        Me.Label2.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label2.Location = New System.Drawing.Point(12, 152)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(128, 18)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Publication Date"
        Me.ToolTip1.SetToolTip(Me.Label2, "the date when the data set is published or otherwise made available for release. " & _
                "")
        '
        'Label3
        '
        Me.Label3.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label3.Location = New System.Drawing.Point(12, 287)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(184, 16)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Publication Time (optional)"
        Me.ToolTip1.SetToolTip(Me.Label3, "the time of day when the data set is published or otherwise made available for re" & _
                "lease")
        '
        'Label4
        '
        Me.Label4.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label4.Location = New System.Drawing.Point(12, 366)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(56, 16)
        Me.Label4.TabIndex = 3
        Me.Label4.Text = "Title"
        Me.ToolTip1.SetToolTip(Me.Label4, resources.GetString("Label4.ToolTip"))
        '
        'txtAuthor
        '
        Me.txtAuthor.AcceptsReturn = True
        Me.txtAuthor.Location = New System.Drawing.Point(12, 42)
        Me.txtAuthor.Multiline = True
        Me.txtAuthor.Name = "txtAuthor"
        Me.txtAuthor.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtAuthor.Size = New System.Drawing.Size(328, 96)
        Me.txtAuthor.TabIndex = 4
        Me.ToolTip1.SetToolTip(Me.txtAuthor, resources.GetString("txtAuthor.ToolTip"))
        '
        'Panel1
        '
        Me.Panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Panel1.Controls.Add(Me.rdoDateCal)
        Me.Panel1.Controls.Add(Me.rdoDateUnpub)
        Me.Panel1.Controls.Add(Me.rdoDateUnk)
        Me.Panel1.Location = New System.Drawing.Point(12, 171)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(160, 104)
        Me.Panel1.TabIndex = 5
        Me.ToolTip1.SetToolTip(Me.Panel1, resources.GetString("Panel1.ToolTip"))
        '
        'rdoDateCal
        '
        Me.rdoDateCal.Location = New System.Drawing.Point(8, 72)
        Me.rdoDateCal.Name = "rdoDateCal"
        Me.rdoDateCal.Size = New System.Drawing.Size(104, 24)
        Me.rdoDateCal.TabIndex = 2
        Me.rdoDateCal.Text = "Specify date"
        '
        'rdoDateUnpub
        '
        Me.rdoDateUnpub.Location = New System.Drawing.Point(8, 40)
        Me.rdoDateUnpub.Name = "rdoDateUnpub"
        Me.rdoDateUnpub.Size = New System.Drawing.Size(144, 24)
        Me.rdoDateUnpub.TabIndex = 1
        Me.rdoDateUnpub.Text = "Unpublished material"
        '
        'rdoDateUnk
        '
        Me.rdoDateUnk.Location = New System.Drawing.Point(8, 8)
        Me.rdoDateUnk.Name = "rdoDateUnk"
        Me.rdoDateUnk.Size = New System.Drawing.Size(80, 24)
        Me.rdoDateUnk.TabIndex = 0
        Me.rdoDateUnk.Text = "Unknown"
        '
        'Panel2
        '
        Me.Panel2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Panel2.Controls.Add(Me.numYear)
        Me.Panel2.Controls.Add(Me.cboxDay)
        Me.Panel2.Controls.Add(Me.cboxMonth)
        Me.Panel2.Controls.Add(Me.Label7)
        Me.Panel2.Controls.Add(Me.Label6)
        Me.Panel2.Controls.Add(Me.Label5)
        Me.Panel2.Location = New System.Drawing.Point(178, 171)
        Me.Panel2.Name = "Panel2"
        Me.Panel2.Size = New System.Drawing.Size(162, 104)
        Me.Panel2.TabIndex = 6
        Me.Panel2.Visible = False
        '
        'numYear
        '
        Me.numYear.Location = New System.Drawing.Point(56, 8)
        Me.numYear.Maximum = New Decimal(New Integer() {2100, 0, 0, 0})
        Me.numYear.Name = "numYear"
        Me.numYear.Size = New System.Drawing.Size(96, 21)
        Me.numYear.TabIndex = 3
        Me.numYear.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.numYear.Value = New Decimal(New Integer() {2004, 0, 0, 0})
        '
        'cboxDay
        '
        Me.cboxDay.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cboxDay.Items.AddRange(New Object() {"00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31"})
        Me.cboxDay.Location = New System.Drawing.Point(56, 64)
        Me.cboxDay.Name = "cboxDay"
        Me.cboxDay.Size = New System.Drawing.Size(96, 23)
        Me.cboxDay.TabIndex = 5
        '
        'cboxMonth
        '
        Me.cboxMonth.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cboxMonth.Items.AddRange(New Object() {"00 Unknown", "01 Jan", "02 Feb", "03 March", "04 April", "05 May", "06 June", "07 July", "08 August", "09 Sept", "10 Oct", "11 Nov", "12 Dec"})
        Me.cboxMonth.Location = New System.Drawing.Point(56, 35)
        Me.cboxMonth.Name = "cboxMonth"
        Me.cboxMonth.Size = New System.Drawing.Size(96, 23)
        Me.cboxMonth.TabIndex = 4
        '
        'Label7
        '
        Me.Label7.Location = New System.Drawing.Point(8, 67)
        Me.Label7.Name = "Label7"
        Me.Label7.Size = New System.Drawing.Size(48, 16)
        Me.Label7.TabIndex = 2
        Me.Label7.Text = "Day"
        '
        'Label6
        '
        Me.Label6.Location = New System.Drawing.Point(8, 38)
        Me.Label6.Name = "Label6"
        Me.Label6.Size = New System.Drawing.Size(48, 16)
        Me.Label6.TabIndex = 1
        Me.Label6.Text = "Month"
        '
        'Label5
        '
        Me.Label5.Location = New System.Drawing.Point(8, 10)
        Me.Label5.Name = "Label5"
        Me.Label5.Size = New System.Drawing.Size(40, 16)
        Me.Label5.TabIndex = 0
        Me.Label5.Text = "Year"
        '
        'lblTime1
        '
        Me.lblTime1.Location = New System.Drawing.Point(12, 312)
        Me.lblTime1.Name = "lblTime1"
        Me.lblTime1.Size = New System.Drawing.Size(168, 16)
        Me.lblTime1.TabIndex = 7
        Me.lblTime1.Text = "Universal Time (HHMMSS):"
        Me.ToolTip1.SetToolTip(Me.lblTime1, "the time of day when the data set is published or otherwise made available for re" & _
                "lease")
        '
        'txtTime
        '
        Me.txtTime.Location = New System.Drawing.Point(178, 309)
        Me.txtTime.MaxLength = 6
        Me.txtTime.Name = "txtTime"
        Me.txtTime.Size = New System.Drawing.Size(88, 21)
        Me.txtTime.TabIndex = 7
        Me.ToolTip1.SetToolTip(Me.txtTime, "the time of day when the data set is published or otherwise made available for re" & _
                "lease")
        '
        'lblTdiff
        '
        Me.lblTdiff.Location = New System.Drawing.Point(12, 337)
        Me.lblTdiff.Name = "lblTdiff"
        Me.lblTdiff.Size = New System.Drawing.Size(100, 23)
        Me.lblTdiff.TabIndex = 9
        Me.lblTdiff.Text = "Time Differential:"
        Me.ToolTip1.SetToolTip(Me.lblTdiff, "Time Differential")
        Me.lblTdiff.Visible = False
        '
        'cboxTimeDiff
        '
        Me.cboxTimeDiff.Items.AddRange(New Object() {"-0500  Eastern Standard Time", "-0400  Eastern Daylight Time", "-0600  Central Standard Time", "-0500  Central Daylight Time", "-0700  Mountain Standard Time", "-0600  Mountain Daylight Time", "-0800  Pacific Standard Time", "-0700  Pacific Daylight Time", "-0900  Alaska", "-1000  Hawaii"})
        Me.cboxTimeDiff.Location = New System.Drawing.Point(130, 334)
        Me.cboxTimeDiff.MaxDropDownItems = 6
        Me.cboxTimeDiff.Name = "cboxTimeDiff"
        Me.cboxTimeDiff.Size = New System.Drawing.Size(210, 23)
        Me.cboxTimeDiff.TabIndex = 8
        Me.ToolTip1.SetToolTip(Me.cboxTimeDiff, "Time Differential")
        Me.cboxTimeDiff.Visible = False
        '
        'btnOK
        '
        Me.btnOK.Enabled = False
        Me.btnOK.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.5!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnOK.Image = Global.MetaDoc.My.Resources.Resources.Ok_16x16
        Me.btnOK.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnOK.Location = New System.Drawing.Point(520, 460)
        Me.btnOK.Name = "btnOK"
        Me.btnOK.Size = New System.Drawing.Size(75, 23)
        Me.btnOK.TabIndex = 18
        Me.btnOK.Text = "OK"
        Me.btnOK.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'txtTitle
        '
        Me.txtTitle.Location = New System.Drawing.Point(68, 363)
        Me.txtTitle.MaxLength = 200
        Me.txtTitle.Name = "txtTitle"
        Me.txtTitle.Size = New System.Drawing.Size(272, 21)
        Me.txtTitle.TabIndex = 9
        Me.ToolTip1.SetToolTip(Me.txtTitle, resources.GetString("txtTitle.ToolTip"))
        '
        'Label8
        '
        Me.Label8.Location = New System.Drawing.Point(12, 393)
        Me.Label8.Name = "Label8"
        Me.Label8.Size = New System.Drawing.Size(56, 16)
        Me.Label8.TabIndex = 13
        Me.Label8.Text = "Edition"
        Me.ToolTip1.SetToolTip(Me.Label8, "the version of the title. ")
        '
        'txtEdition
        '
        Me.txtEdition.Location = New System.Drawing.Point(68, 390)
        Me.txtEdition.MaxLength = 25
        Me.txtEdition.Name = "txtEdition"
        Me.txtEdition.Size = New System.Drawing.Size(72, 21)
        Me.txtEdition.TabIndex = 10
        Me.ToolTip1.SetToolTip(Me.txtEdition, "the version of the title. ")
        '
        'Label9
        '
        Me.Label9.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label9.Location = New System.Drawing.Point(12, 424)
        Me.Label9.Name = "Label9"
        Me.Label9.Size = New System.Drawing.Size(152, 23)
        Me.Label9.TabIndex = 15
        Me.Label9.Text = "Data Presentation Form"
        Me.ToolTip1.SetToolTip(Me.Label9, resources.GetString("Label9.ToolTip"))
        '
        'cboxDForm
        '
        Me.cboxDForm.Items.AddRange(New Object() {"atlas", "audio", "book chapter", "CAD data", "conference proceedings", "database", "diagram", "document", "figure", "globe", "hologram", "journal article", "map", "model", "multimedia presentation", "pamphlet", "profile", "raster digital data", "remote-sensing image", "section", "spreadsheet", "table (non-digital)", "tabular digital data", "vector digital data", "video", "view"})
        Me.cboxDForm.Location = New System.Drawing.Point(172, 421)
        Me.cboxDForm.Name = "cboxDForm"
        Me.cboxDForm.Size = New System.Drawing.Size(168, 23)
        Me.cboxDForm.TabIndex = 11
        Me.ToolTip1.SetToolTip(Me.cboxDForm, resources.GetString("cboxDForm.ToolTip"))
        '
        'Label10
        '
        Me.Label10.Location = New System.Drawing.Point(361, 23)
        Me.Label10.Name = "Label10"
        Me.Label10.Size = New System.Drawing.Size(112, 16)
        Me.Label10.TabIndex = 17
        Me.Label10.Text = "Series information"
        Me.ToolTip1.SetToolTip(Me.Label10, "the identification of the series publication of which the data set is a part. ")
        '
        'Panel3
        '
        Me.Panel3.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Panel3.Controls.Add(Me.txtSeriesID)
        Me.Panel3.Controls.Add(Me.txtSeries)
        Me.Panel3.Controls.Add(Me.Label12)
        Me.Panel3.Controls.Add(Me.Label11)
        Me.Panel3.Location = New System.Drawing.Point(364, 42)
        Me.Panel3.Name = "Panel3"
        Me.Panel3.Size = New System.Drawing.Size(316, 72)
        Me.Panel3.TabIndex = 12
        Me.ToolTip1.SetToolTip(Me.Panel3, "the identification of the series publication of which the data set is a part. ")
        '
        'txtSeriesID
        '
        Me.txtSeriesID.Location = New System.Drawing.Point(100, 34)
        Me.txtSeriesID.MaxLength = 50
        Me.txtSeriesID.Name = "txtSeriesID"
        Me.txtSeriesID.Size = New System.Drawing.Size(128, 21)
        Me.txtSeriesID.TabIndex = 3
        Me.ToolTip1.SetToolTip(Me.txtSeriesID, "information identifying the issue of the series publication of which the data set" & _
                " is a part. ")
        '
        'txtSeries
        '
        Me.txtSeries.Location = New System.Drawing.Point(100, 5)
        Me.txtSeries.MaxLength = 200
        Me.txtSeries.Name = "txtSeries"
        Me.txtSeries.Size = New System.Drawing.Size(204, 21)
        Me.txtSeries.TabIndex = 2
        Me.ToolTip1.SetToolTip(Me.txtSeries, "the name of the series publication of which the data set is a part. ")
        '
        'Label12
        '
        Me.Label12.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label12.Location = New System.Drawing.Point(8, 37)
        Me.Label12.Name = "Label12"
        Me.Label12.Size = New System.Drawing.Size(48, 23)
        Me.Label12.TabIndex = 1
        Me.Label12.Text = "Issue:"
        Me.ToolTip1.SetToolTip(Me.Label12, "information identifying the issue of the series publication of which the data set" & _
                " is a part. ")
        '
        'Label11
        '
        Me.Label11.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label11.Location = New System.Drawing.Point(8, 8)
        Me.Label11.Name = "Label11"
        Me.Label11.Size = New System.Drawing.Size(99, 29)
        Me.Label11.TabIndex = 0
        Me.Label11.Text = "Series name:"
        Me.ToolTip1.SetToolTip(Me.Label11, "the name of the series publication of which the data set is a part. ")
        '
        'Label13
        '
        Me.Label13.Location = New System.Drawing.Point(361, 122)
        Me.Label13.Name = "Label13"
        Me.Label13.Size = New System.Drawing.Size(144, 16)
        Me.Label13.TabIndex = 19
        Me.Label13.Text = "Publication information"
        Me.ToolTip1.SetToolTip(Me.Label13, "publication details for published data sets. ")
        '
        'Panel4
        '
        Me.Panel4.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Panel4.Controls.Add(Me.txtPublish)
        Me.Panel4.Controls.Add(Me.txtPubPlace)
        Me.Panel4.Controls.Add(Me.Label15)
        Me.Panel4.Controls.Add(Me.Label14)
        Me.Panel4.Location = New System.Drawing.Point(364, 141)
        Me.Panel4.Name = "Panel4"
        Me.Panel4.Size = New System.Drawing.Size(316, 72)
        Me.Panel4.TabIndex = 13
        Me.ToolTip1.SetToolTip(Me.Panel4, "publication details for published data sets. ")
        '
        'txtPublish
        '
        Me.txtPublish.Location = New System.Drawing.Point(88, 33)
        Me.txtPublish.Name = "txtPublish"
        Me.txtPublish.Size = New System.Drawing.Size(216, 21)
        Me.txtPublish.TabIndex = 3
        Me.ToolTip1.SetToolTip(Me.txtPublish, "the name of the individual or organization that published the data set. ")
        '
        'txtPubPlace
        '
        Me.txtPubPlace.Location = New System.Drawing.Point(124, 6)
        Me.txtPubPlace.Name = "txtPubPlace"
        Me.txtPubPlace.Size = New System.Drawing.Size(180, 21)
        Me.txtPubPlace.TabIndex = 2
        Me.ToolTip1.SetToolTip(Me.txtPubPlace, "the name of the city (and state or province, and country, if needed to identify t" & _
                "he city)" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "where the data set was published or released. ")
        '
        'Label15
        '
        Me.Label15.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label15.Location = New System.Drawing.Point(8, 36)
        Me.Label15.Name = "Label15"
        Me.Label15.Size = New System.Drawing.Size(84, 23)
        Me.Label15.TabIndex = 1
        Me.Label15.Text = "Publisher"
        Me.ToolTip1.SetToolTip(Me.Label15, "the name of the individual or organization that published the data set. ")
        '
        'Label14
        '
        Me.Label14.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label14.Location = New System.Drawing.Point(8, 8)
        Me.Label14.Name = "Label14"
        Me.Label14.Size = New System.Drawing.Size(123, 28)
        Me.Label14.TabIndex = 0
        Me.Label14.Text = "Publication place"
        Me.ToolTip1.SetToolTip(Me.Label14, "the name of the city (and state or province, and country, if needed to identify t" & _
                "he city)" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "where the data set was published or released. " & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10))
        '
        'Label16
        '
        Me.Label16.Location = New System.Drawing.Point(361, 221)
        Me.Label16.Name = "Label16"
        Me.Label16.Size = New System.Drawing.Size(136, 16)
        Me.Label16.TabIndex = 21
        Me.Label16.Text = "Other Citation Details"
        Me.ToolTip1.SetToolTip(Me.Label16, resources.GetString("Label16.ToolTip"))
        '
        'txtOther
        '
        Me.txtOther.Location = New System.Drawing.Point(364, 240)
        Me.txtOther.Multiline = True
        Me.txtOther.Name = "txtOther"
        Me.txtOther.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtOther.Size = New System.Drawing.Size(316, 56)
        Me.txtOther.TabIndex = 14
        Me.ToolTip1.SetToolTip(Me.txtOther, resources.GetString("txtOther.ToolTip"))
        '
        'Label17
        '
        Me.Label17.Location = New System.Drawing.Point(361, 309)
        Me.Label17.Name = "Label17"
        Me.Label17.Size = New System.Drawing.Size(200, 16)
        Me.Label17.TabIndex = 23
        Me.Label17.Text = "Online Linkages [URLs] (optional)"
        '
        'txtLink
        '
        Me.txtLink.Location = New System.Drawing.Point(364, 326)
        Me.txtLink.Multiline = True
        Me.txtLink.Name = "txtLink"
        Me.txtLink.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtLink.Size = New System.Drawing.Size(316, 56)
        Me.txtLink.TabIndex = 15
        Me.ToolTip1.SetToolTip(Me.txtLink, resources.GetString("txtLink.ToolTip"))
        '
        'lblTitle
        '
        Me.lblTitle.Dock = System.Windows.Forms.DockStyle.Top
        Me.lblTitle.Font = New System.Drawing.Font("Microsoft Sans Serif", 12.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblTitle.Location = New System.Drawing.Point(0, 0)
        Me.lblTitle.Name = "lblTitle"
        Me.lblTitle.Size = New System.Drawing.Size(811, 23)
        Me.lblTitle.TabIndex = 29
        Me.lblTitle.Text = "Primary Citation"
        Me.lblTitle.TextAlign = System.Drawing.ContentAlignment.TopCenter
        Me.ToolTip1.SetToolTip(Me.lblTitle, resources.GetString("lblTitle.ToolTip"))
        '
        'btnCancel
        '
        Me.btnCancel.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.5!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnCancel.Image = Global.MetaDoc.My.Resources.Resources.Cancel_16x16
        Me.btnCancel.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnCancel.Location = New System.Drawing.Point(601, 460)
        Me.btnCancel.Name = "btnCancel"
        Me.btnCancel.Size = New System.Drawing.Size(75, 23)
        Me.btnCancel.TabIndex = 19
        Me.btnCancel.Text = "Cancel"
        Me.btnCancel.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'pnlLWC
        '
        Me.pnlLWC.Controls.Add(Me.Panel6)
        Me.pnlLWC.Controls.Add(Me.lblLWC)
        Me.pnlLWC.Location = New System.Drawing.Point(364, 390)
        Me.pnlLWC.Name = "pnlLWC"
        Me.pnlLWC.Size = New System.Drawing.Size(312, 64)
        Me.pnlLWC.TabIndex = 16
        '
        'Panel6
        '
        Me.Panel6.Controls.Add(Me.rdoLWCno)
        Me.Panel6.Controls.Add(Me.rdoLWCyes)
        Me.Panel6.Location = New System.Drawing.Point(144, 8)
        Me.Panel6.Name = "Panel6"
        Me.Panel6.Size = New System.Drawing.Size(144, 40)
        Me.Panel6.TabIndex = 17
        '
        'rdoLWCno
        '
        Me.rdoLWCno.Checked = True
        Me.rdoLWCno.Location = New System.Drawing.Point(64, 8)
        Me.rdoLWCno.Name = "rdoLWCno"
        Me.rdoLWCno.Size = New System.Drawing.Size(64, 24)
        Me.rdoLWCno.TabIndex = 1
        Me.rdoLWCno.TabStop = True
        Me.rdoLWCno.Text = "No"
        '
        'rdoLWCyes
        '
        Me.rdoLWCyes.Location = New System.Drawing.Point(8, 8)
        Me.rdoLWCyes.Name = "rdoLWCyes"
        Me.rdoLWCyes.Size = New System.Drawing.Size(56, 24)
        Me.rdoLWCyes.TabIndex = 0
        Me.rdoLWCyes.Text = "Yes"
        Me.ToolTip1.SetToolTip(Me.rdoLWCyes, "the information identifying a larger work in which the data set is included")
        '
        'lblLWC
        '
        Me.lblLWC.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblLWC.Location = New System.Drawing.Point(8, 14)
        Me.lblLWC.Name = "lblLWC"
        Me.lblLWC.Size = New System.Drawing.Size(136, 40)
        Me.lblLWC.TabIndex = 28
        Me.lblLWC.Text = "Display Larger Work Citation?"
        Me.ToolTip1.SetToolTip(Me.lblLWC, "the information identifying a larger work in which the data set is included")
        '
        'button_example
        '
        Me.button_example.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.button_example.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.button_example.Image = Global.MetaDoc.My.Resources.Resources.app_help_48x48
        Me.button_example.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.button_example.Location = New System.Drawing.Point(689, 12)
        Me.button_example.Name = "button_example"
        Me.button_example.Size = New System.Drawing.Size(110, 48)
        Me.button_example.TabIndex = 30
        Me.button_example.Text = "EXAMPLE"
        Me.button_example.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        Me.button_example.UseVisualStyleBackColor = True
        '
        'ToolTip1
        '
        Me.ToolTip1.IsBalloon = True
        Me.ToolTip1.ShowAlways = True
        Me.ToolTip1.ToolTipIcon = System.Windows.Forms.ToolTipIcon.Info
        '
        'frmCiteInfo
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(6, 14)
        Me.AutoScroll = True
        Me.ClientSize = New System.Drawing.Size(811, 492)
        Me.ControlBox = False
        Me.Controls.Add(Me.button_example)
        Me.Controls.Add(Me.pnlLWC)
        Me.Controls.Add(Me.lblTitle)
        Me.Controls.Add(Me.txtLink)
        Me.Controls.Add(Me.Label17)
        Me.Controls.Add(Me.txtOther)
        Me.Controls.Add(Me.Label16)
        Me.Controls.Add(Me.Panel4)
        Me.Controls.Add(Me.Label13)
        Me.Controls.Add(Me.Panel3)
        Me.Controls.Add(Me.Label10)
        Me.Controls.Add(Me.cboxDForm)
        Me.Controls.Add(Me.Label9)
        Me.Controls.Add(Me.txtEdition)
        Me.Controls.Add(Me.Label8)
        Me.Controls.Add(Me.txtTitle)
        Me.Controls.Add(Me.cboxTimeDiff)
        Me.Controls.Add(Me.lblTdiff)
        Me.Controls.Add(Me.txtTime)
        Me.Controls.Add(Me.lblTime1)
        Me.Controls.Add(Me.Panel2)
        Me.Controls.Add(Me.Panel1)
        Me.Controls.Add(Me.txtAuthor)
        Me.Controls.Add(Me.Label4)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.btnOK)
        Me.Controls.Add(Me.btnCancel)
        Me.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "frmCiteInfo"
        Me.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Citation Information"
        Me.ToolTip1.SetToolTip(Me, resources.GetString("$this.ToolTip"))
        Me.Panel1.ResumeLayout(False)
        Me.Panel2.ResumeLayout(False)
        CType(Me.numYear, System.ComponentModel.ISupportInitialize).EndInit()
        Me.Panel3.ResumeLayout(False)
        Me.Panel3.PerformLayout()
        Me.Panel4.ResumeLayout(False)
        Me.Panel4.PerformLayout()
        Me.pnlLWC.ResumeLayout(False)
        Me.Panel6.ResumeLayout(False)
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Private Sub frmCiteInfo_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim strDate As String = ""
        Dim intDate As Integer = 0
        Dim strYr As String = ""
        Dim strMth As String = ""
        Dim strMthCount As String = ""
        Dim strDay As String = ""
        Dim icount As Integer = 0  ' loop counter

        rdoLWCno.Checked = True
        If (bLWC = True) Then  'larger work citation present on load
            lblLWC.Text = "Display Larger Work Citation?"
        Else
            lblLWC.Text = "Create Larger Work Citation?"
        End If

        If (bDisplayLWC = True) Then
            lblTitle.Text = "Larger Work Citation"
            pnlLWC.Visible = False
        Else
            lblTitle.Text = "Primary Citation"
            pnlLWC.Visible = True
        End If

        'set the Authors control
        txtAuthor.Text = newCite.Author

        'find current year, convert to decimal and initialize the Year numeric box
        Dim dtYear As Date = Now
        Dim strCurYear As String = dtYear.ToString("yyyy")
        dYear = CType(strCurYear, Decimal)
        numYear.Value = dYear

        'set the Publication Date control
        rdoDateUnk.Checked = True
        If (newCite.PubDate = "Unknown" Or newCite.PubDate = "") Then
            rdoDateUnk.Checked = True
        ElseIf (newCite.PubDate = "Unpublished material") Then
            rdoDateUnpub.Checked = True
        Else
            rdoDateCal.Checked = True
            strDate = newCite.PubDate
            intDate = Len(strDate)
            strYr = Microsoft.VisualBasic.Left(strDate, 4) 'set Year numeric value
            numYear.Value = CType(strYr, Decimal)
            If (intDate > 4) Then  ' set Month combo box if known
                strMth = Mid(strDate, 5, 2)
                icount = cboxMonth.FindString(strMth)
                cboxMonth.SelectedIndex = icount
            End If
            If (intDate > 6) Then  ' set Day combo box if known
                strDay = Mid(strDate, 7, 2)
                icount = cboxDay.FindString(strDay)
                cboxDay.SelectedIndex = icount
            End If
        End If

        'set optional Publication Time controls
        Dim strBaseTime As String = newCite.PubTime
        Dim strTimDiff As String = ""
        lblTdiff.Visible = False
        cboxTimeDiff.Visible = False

        If (intTimeStyle = 1) Then
            lblTime1.Text = "Local time (HHMMSS):"
            txtTime.Text = strBaseTime
        ElseIf (intTimeStyle = 2) Then
            lblTime1.Text = "Local time (HHMMSS):"
            If (Len(strBaseTime) > 0) Then
                icount = InStr(strBaseTime, "+")
                If (icount = 0) Then
                    icount = InStr(strBaseTime, "-")
                End If
                If (icount = 0) Then
                    txtTime.Text = ""
                Else
                    txtTime.Text = Microsoft.VisualBasic.Left(strBaseTime, icount - 1)
                    strTimDiff = Mid(strBaseTime, icount)
                End If
                intDate = cboxTimeDiff.FindString(strTimDiff)
                If (intDate = -1) Then
                    cboxTimeDiff.Items.Add(strTimDiff)
                    cboxTimeDiff.SelectedItem = strTimDiff
                Else
                    cboxTimeDiff.SelectedIndex = intDate
                End If
            End If
            lblTdiff.Visible = True
            cboxTimeDiff.Visible = True
        Else
            lblTime1.Text = "Universal Time (HHMMSS):"
            intDate = Len(strBaseTime)
            If (intDate > 0) Then
                txtTime.Text = Microsoft.VisualBasic.Left(strBaseTime, intDate - 1)
            Else
            End If
        End If

        'set Title text control
        txtTitle.Text = newCite.Title

        'set Edition text control
        txtEdition.Text = newCite.Edition

        'set Geoform Data Presentation combo box
        Dim strDataForm As String = newCite.Geoform
        If (strDataForm = "") Then
            cboxDForm.SelectedIndex = -1
        Else
            icount = cboxDForm.FindStringExact(strDataForm)
            If (icount = -1) Then
                icount = 0
                cboxDForm.Items.Insert(icount, strDataForm)
            End If
            cboxDForm.SelectedIndex = icount
        End If

        'set Serial Information
        txtSeries.Text = newCite.SerialName
        txtSeriesID.Text = newCite.Issue

        'set Publishing Information
        txtPubPlace.Text = newCite.PubPlace
        txtPublish.Text = newCite.Publisher

        'set Other info and linkage text controls
        txtOther.Text = newCite.OtherCit
        txtLink.Text = newCite.URLink

    End Sub

    Private Sub rdoDateCal_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoDateCal.CheckedChanged
        If (rdoDateCal.Checked = True) Then
            Panel2.Visible = True
            numYear.Value = dYear
        Else
            Panel2.Visible = False
            numYear.Value = 0
            cboxMonth.SelectedIndex = -1
            cboxDay.SelectedIndex = -1
        End If
    End Sub

    Private Sub rdoLWCyes_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoLWCyes.CheckedChanged
        If (rdoLWCyes.Checked = True) Then
            'display the larger work citation for editing
            Dim frmLWCshow As New frmCiteInfoLWC(newLWC, bLWC, intTimeStyle)
            frmLWCshow.ShowDialog()
            If frmLWCshow.getUpdated() Then
                'update the larger work citation
                bLWC = frmLWCshow.getLWC()
                If (bLWC = True) Then
                    newLWC = frmLWCshow.getNewCite() 'retrieve updated LWC
                    lblLWC.Text = "Display Larger Work Citation?"
                Else
                    lblLWC.Text = "Create Larger Work Citation?"
                End If
            End If
            rdoLWCno.Checked = True 'reset the radio button
        End If
    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        Dim s1 As String = ""
        Dim sYr As String = ""
        Dim sMonth As String = ""
        Dim sTime As String = ""
        Dim sDay As String = ""
        bUpdate = True  'citation has changed

        'update author
        newCite.Author = txtAuthor.Text

        'update publication date
        If (rdoDateUnk.Checked = True) Then
            newCite.PubDate = "Unknown"
        ElseIf (rdoDateUnpub.Checked = True) Then
            newCite.PubDate = "Unpublished material"
        Else
            sYr = numYear.Value.ToString
            s1 = CType(cboxMonth.SelectedItem, String)
            sMonth = Microsoft.VisualBasic.Left(s1, 2)
            If (sMonth = "00") Then
                sMonth = ""
            End If
            sDay = CType(cboxDay.SelectedItem, String)
            If (sDay = "00") Then
                sDay = ""
            End If
            sYr = sYr & sMonth & sDay
            newCite.PubDate = sYr
        End If

        'update publication time (may be blank)
        sTime = txtTime.Text
        If (intTimeStyle = 1) Then
        ElseIf (intTimeStyle = 2) Then
            sDay = cboxTimeDiff.Text
            sTime = sTime & Microsoft.VisualBasic.Left(sDay, 5)
        Else
            sTime = sTime & "Z"
        End If
        newCite.PubTime = sTime

        'update publication title and edition
        newCite.Title = txtTitle.Text
        newCite.Edition = txtEdition.Text

        'update geospatial data presentation form
        newCite.Geoform = cboxDForm.Text

        'update series information
        newCite.SerialName = txtSeries.Text
        newCite.Issue = txtSeriesID.Text

        'update publication information
        newCite.PubPlace = txtPubPlace.Text
        newCite.Publisher = txtPublish.Text

        'update other citation details and online links
        newCite.OtherCit = txtOther.Text
        newCite.URLink = txtLink.Text

        Me.Close()
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        bUpdate = False
        Me.Close()
    End Sub

    Public Function getUpdated() As Boolean
        Return bUpdate
    End Function

    Public Function getNewCite() As CiteInfo
        Return newCite
    End Function

    Public Function getLWC() As Boolean
        Return bLWC
    End Function

    Public Function getNewLWC() As CiteInfo
        Return newLWC
    End Function

    Private Sub txtAuthor_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtAuthor.TextChanged
        validateOK()
    End Sub

    Private Sub txtTitle_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtTitle.TextChanged
        validateOK()
    End Sub

    Private Sub cboxDForm_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboxDForm.SelectedIndexChanged
        validateOK()
    End Sub
    Private Sub validateOK()
        If txtAuthor.Text.Trim() = "" Or txtTitle.Text.Trim() = "" Or cboxDForm.SelectedIndex = -1 Then btnOK.Enabled = False Else btnOK.Enabled = True
    End Sub

    Private Sub button_example_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_example.Click
        Dim helpForm As dialog_help = New dialog_help("CiteInfo")
        helpForm.ShowDialog()
    End Sub
End Class
