Option Explicit On 
Option Strict On

Imports System.Collections.Specialized

Public Class frmGPoly
    Inherits System.Windows.Forms.Form
    Public Shared sPolyCol As StringCollection 'string collection holding polygon information
    '1st string is "string" or "points" to tell how the polygon is described
    '2nd string is the ring or points describing the outer polygon
    'ring descriptions are single run of text; points are lat, long order space delimited with points -delimited
    'following 2*n strings have same structure as first two, but for the associated exclusion strings

    Public Shared iNpolyEx As Integer = 0 'number of exclusion polygons in the outer polygon
    Public Shared bChange As Boolean = False
    Friend WithEvents button_example As System.Windows.Forms.Button
    Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip 'indicates whether any changes were made to polygon info
    Public Shared sPdelim As String = ""



#Region " Windows Form Designer generated code "

    Public Sub New() 'for new Outer G-Polygons
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        sPolyCol = New StringCollection
        iNpolyEx = 0

    End Sub

    Public Sub New(ByVal sToEdit As StringCollection) 'to edit existing Outer G-Polygons
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        sPolyCol = sToEdit
        iNpolyEx = sPolyCol.Count
        If (iNpolyEx > 1) Then
            iNpolyEx = CInt((sPolyCol.Count - 2) / 2)
        End If

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents txtOuter As System.Windows.Forms.TextBox
    Friend WithEvents btnOuterEdit As System.Windows.Forms.Button
    Friend WithEvents lboxExRing As System.Windows.Forms.ListBox
    Friend WithEvents btnExAdd As System.Windows.Forms.Button
    Friend WithEvents btnExEdit As System.Windows.Forms.Button
    Friend WithEvents btnExDel As System.Windows.Forms.Button
    Friend WithEvents btnOK As System.Windows.Forms.Button
    Friend WithEvents btnCancel As System.Windows.Forms.Button
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    Friend WithEvents Label3 As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(frmGPoly))
        Me.Label1 = New System.Windows.Forms.Label
        Me.txtOuter = New System.Windows.Forms.TextBox
        Me.btnOuterEdit = New System.Windows.Forms.Button
        Me.lboxExRing = New System.Windows.Forms.ListBox
        Me.btnExAdd = New System.Windows.Forms.Button
        Me.btnExEdit = New System.Windows.Forms.Button
        Me.btnExDel = New System.Windows.Forms.Button
        Me.btnOK = New System.Windows.Forms.Button
        Me.btnCancel = New System.Windows.Forms.Button
        Me.Panel1 = New System.Windows.Forms.Panel
        Me.Label3 = New System.Windows.Forms.Label
        Me.button_example = New System.Windows.Forms.Button
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.Panel1.SuspendLayout()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label1.Location = New System.Drawing.Point(12, 9)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(100, 23)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "Outer G-Polygon"
        Me.ToolTip1.SetToolTip(Me.Label1, "the closed nonintersecting boundary of an interior area. ")
        '
        'txtOuter
        '
        Me.txtOuter.Location = New System.Drawing.Point(118, 6)
        Me.txtOuter.Name = "txtOuter"
        Me.txtOuter.ReadOnly = True
        Me.txtOuter.Size = New System.Drawing.Size(230, 20)
        Me.txtOuter.TabIndex = 1
        Me.txtOuter.TabStop = False
        Me.ToolTip1.SetToolTip(Me.txtOuter, "the closed nonintersecting boundary of an interior area. ")
        '
        'btnOuterEdit
        '
        Me.btnOuterEdit.Image = CType(resources.GetObject("btnOuterEdit.Image"), System.Drawing.Image)
        Me.btnOuterEdit.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnOuterEdit.Location = New System.Drawing.Point(354, 4)
        Me.btnOuterEdit.Name = "btnOuterEdit"
        Me.btnOuterEdit.Size = New System.Drawing.Size(75, 23)
        Me.btnOuterEdit.TabIndex = 2
        Me.btnOuterEdit.Text = "Edit"
        '
        'lboxExRing
        '
        Me.lboxExRing.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxExRing.Location = New System.Drawing.Point(11, 22)
        Me.lboxExRing.Name = "lboxExRing"
        Me.lboxExRing.Size = New System.Drawing.Size(360, 91)
        Me.lboxExRing.TabIndex = 4
        Me.ToolTip1.SetToolTip(Me.lboxExRing, "the closed nonintersecting boundary of a void area (or ""hole"" in an interior area" & _
                "). ")
        '
        'btnExAdd
        '
        Me.btnExAdd.Image = Global.MetaDoc.My.Resources.Resources.file_new_16x16
        Me.btnExAdd.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnExAdd.Location = New System.Drawing.Point(134, 119)
        Me.btnExAdd.Name = "btnExAdd"
        Me.btnExAdd.Size = New System.Drawing.Size(75, 23)
        Me.btnExAdd.TabIndex = 5
        Me.btnExAdd.Text = "Add"
        '
        'btnExEdit
        '
        Me.btnExEdit.Enabled = False
        Me.btnExEdit.Image = CType(resources.GetObject("btnExEdit.Image"), System.Drawing.Image)
        Me.btnExEdit.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnExEdit.Location = New System.Drawing.Point(215, 119)
        Me.btnExEdit.Name = "btnExEdit"
        Me.btnExEdit.Size = New System.Drawing.Size(75, 23)
        Me.btnExEdit.TabIndex = 6
        Me.btnExEdit.Text = "Edit"
        '
        'btnExDel
        '
        Me.btnExDel.Enabled = False
        Me.btnExDel.Image = Global.MetaDoc.My.Resources.Resources.file_del_16x16
        Me.btnExDel.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnExDel.Location = New System.Drawing.Point(296, 119)
        Me.btnExDel.Name = "btnExDel"
        Me.btnExDel.Size = New System.Drawing.Size(75, 23)
        Me.btnExDel.TabIndex = 7
        Me.btnExDel.Text = "Delete"
        '
        'btnOK
        '
        Me.btnOK.Enabled = False
        Me.btnOK.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnOK.Image = Global.MetaDoc.My.Resources.Resources.Ok_16x16
        Me.btnOK.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnOK.Location = New System.Drawing.Point(273, 192)
        Me.btnOK.Name = "btnOK"
        Me.btnOK.Size = New System.Drawing.Size(75, 23)
        Me.btnOK.TabIndex = 8
        Me.btnOK.Text = "OK"
        Me.btnOK.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'btnCancel
        '
        Me.btnCancel.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnCancel.Image = Global.MetaDoc.My.Resources.Resources.Cancel_16x16
        Me.btnCancel.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnCancel.Location = New System.Drawing.Point(354, 192)
        Me.btnCancel.Name = "btnCancel"
        Me.btnCancel.Size = New System.Drawing.Size(75, 23)
        Me.btnCancel.TabIndex = 9
        Me.btnCancel.Text = "Cancel"
        Me.btnCancel.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Panel1
        '
        Me.Panel1.Controls.Add(Me.lboxExRing)
        Me.Panel1.Controls.Add(Me.btnExAdd)
        Me.Panel1.Controls.Add(Me.btnExEdit)
        Me.Panel1.Controls.Add(Me.btnExDel)
        Me.Panel1.Controls.Add(Me.Label3)
        Me.Panel1.Location = New System.Drawing.Point(15, 35)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(414, 151)
        Me.Panel1.TabIndex = 3
        Me.Panel1.TabStop = True
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(8, 8)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(160, 23)
        Me.Label3.TabIndex = 3
        Me.Label3.Text = "G-Polygon Exclusion Ring(s)"
        Me.ToolTip1.SetToolTip(Me.Label3, "the closed nonintersecting boundary of a void area (or ""hole"" in an interior area" & _
                "). ")
        '
        'button_example
        '
        Me.button_example.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.button_example.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.button_example.Image = Global.MetaDoc.My.Resources.Resources.app_help_48x48
        Me.button_example.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.button_example.Location = New System.Drawing.Point(439, 12)
        Me.button_example.Name = "button_example"
        Me.button_example.Size = New System.Drawing.Size(110, 48)
        Me.button_example.TabIndex = 21
        Me.button_example.Text = "EXAMPLE"
        Me.button_example.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        Me.button_example.UseVisualStyleBackColor = True
        '
        'ToolTip1
        '
        Me.ToolTip1.IsBalloon = True
        Me.ToolTip1.ShowAlways = True
        Me.ToolTip1.ToolTipIcon = System.Windows.Forms.ToolTipIcon.Info
        '
        'frmGPoly
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.AutoScroll = True
        Me.ClientSize = New System.Drawing.Size(561, 223)
        Me.ControlBox = False
        Me.Controls.Add(Me.button_example)
        Me.Controls.Add(Me.Panel1)
        Me.Controls.Add(Me.btnCancel)
        Me.Controls.Add(Me.btnOK)
        Me.Controls.Add(Me.btnOuterEdit)
        Me.Controls.Add(Me.txtOuter)
        Me.Controls.Add(Me.Label1)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Name = "frmGPoly"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "G-Polygon"
        Me.ToolTip1.SetToolTip(Me, "coordinates defining the outline of an area covered by a data set. ")
        Me.Panel1.ResumeLayout(False)
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Private Sub frmGPoly_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim sList As String = ""

        If (sPolyCol.Count = 0) Then
            Panel1.Enabled = False  'cannot create exclusion rings until boundary polygon established
        Else
            sList = sPolyCol(0) & ": " & Microsoft.VisualBasic.Left(sPolyCol(1), 32)
            sList = sList.Replace(sPdelim, "  ")
            txtOuter.Text = sList 'set boundary polygon if present
        End If

        If (iNpolyEx > 0) Then
            Dim iLoop As Integer
            Dim iCounter As Integer = 2 'index of 1st exclusion ring in collection
            For iLoop = 1 To iNpolyEx
                sList = sPolyCol(iCounter) & ": " & Microsoft.VisualBasic.Left(sPolyCol(iCounter + 1), 32)
                sList = sList.Replace(sPdelim, "  ")
                lboxExRing.Items.Add(sList) 'add the exclusion rings to the list box
                iCounter += 2
            Next
        End If
    End Sub

    Private Sub btnOuterEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOuterEdit.Click
        Dim sList As String = ""
        If (txtOuter.Text = "") Then
            Dim frmGPolyEdit As New frmPolyEdit
            frmGPolyEdit.ShowDialog()
            If (frmGPolyEdit.getUpdated() = True) Then
                bChange = True
                sPolyCol.Add(frmGPolyEdit.getEditType())
                sPolyCol.Add(frmGPolyEdit.getPolyDesc())
                sList = sPolyCol(0) & ": " & Microsoft.VisualBasic.Left(sPolyCol(1), 32)
                sList = sList.Replace(sPdelim, "  ")
                txtOuter.Text = sList 'set boundary polygon if present
                Panel1.Enabled = True
            End If
        Else
            Dim frmGPolyEdit As New frmPolyEdit(sPolyCol(0), sPolyCol(1))
            frmGPolyEdit.ShowDialog()
            If (frmGPolyEdit.getUpdated() = True) Then
                bChange = True
                sPolyCol.Insert(0, frmGPolyEdit.getEditType())
                sPolyCol.Insert(1, frmGPolyEdit.getPolyDesc())
                sPolyCol.RemoveAt(3)
                sPolyCol.RemoveAt(2)
                sList = sPolyCol(0) & ": " & Microsoft.VisualBasic.Left(sPolyCol(1), 32)
                sList = sList.Replace(sPdelim, "  ")
                txtOuter.Text = sList 'set boundary polygon if present
            End If
        End If
    End Sub

    Private Sub btnExAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExAdd.Click
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim sList As String = ""

        Dim frmExPolyEdit As New frmPolyEdit 'prepare to edit the exclusion polygon to be added
        frmExPolyEdit.ShowDialog()           'get the polygon description from the user
        If (frmExPolyEdit.getUpdated() = True) Then
            bChange = True
            s1 = frmExPolyEdit.getEditType()
            s2 = frmExPolyEdit.getPolyDesc()
            sPolyCol.Add(s1)  'add exclusion ring type descriptor to collection
            sPolyCol.Add(s2)  'add exclusion ring to collection
            sList = s1 & ": " & Microsoft.VisualBasic.Left(s2, 32)
            sList = sList.Replace(sPdelim, "  ")
            lboxExRing.Items.Add(sList) 'add exclusion ring to list box
        End If
    End Sub

    Private Sub btnExEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExEdit.Click
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim sList As String = ""
        Dim iCount As Integer = lboxExRing.Items.Count
        Dim iCurInd As Integer = lboxExRing.SelectedIndex 'selected index in list box

        If (iCount = 1) Then iCurInd = 0 'default to edit first exclusion ring if only 1 present
        Dim iPolyInd As Integer = (iCurInd * 2) + 2       'equivalent index in sPolyCol collection
        If (iCurInd = -1) Then 'no index selected
            MessageBox.Show("No exclusion ring selected for editing", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            Dim frmExPolyEdit As New frmPolyEdit(sPolyCol(iPolyInd), sPolyCol(iPolyInd + 1))
            frmExPolyEdit.ShowDialog()
            If (frmExPolyEdit.getUpdated() = True) Then
                bChange = True
                s1 = frmExPolyEdit.getEditType()
                s2 = frmExPolyEdit.getPolyDesc()
                sPolyCol.Insert(iPolyInd, s1) 'insert polygon type descriptor
                sPolyCol.Insert(iPolyInd + 1, s2) 'insert polygon description
                sPolyCol.RemoveAt(iPolyInd + 2) 'remove old polygon type descriptor
                sPolyCol.RemoveAt(iPolyInd + 2) 'remove old polygon description
                sList = s1 & ": " & Microsoft.VisualBasic.Left(s2, 32)
                sList = sList.Replace(sPdelim, "  ")
                lboxExRing.Items.Insert(iCurInd, sList) 'place edited exclusion polygon into list
                lboxExRing.Items.RemoveAt(iCurInd + 1) 'remove old exclusion polygon from list
            End If
        End If
        btnExEdit.Enabled = False : btnExDel.Enabled = False
    End Sub

    Private Sub btnExDel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExDel.Click
        Dim iCurInd As Integer = lboxExRing.SelectedIndex
        If (iCurInd = -1) Then 'no index selected
            MessageBox.Show("No exclusion ring selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            lboxExRing.Items.RemoveAt(iCurInd) 'remove selected exclusion polygon from list
            iCurInd = (2 * iCurInd) + 2 'set the correct index in the collection
            sPolyCol.RemoveAt(iCurInd) 'remove selected exclusion polygon type descriptor from collection
            sPolyCol.RemoveAt(iCurInd) 'remove selected exclusion polygon from collection
            bChange = True
        End If
        btnExEdit.Enabled = False : btnExDel.Enabled = False
    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        Me.Dispose()
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        bChange = False
        Me.Dispose()
    End Sub

    Private Sub txtOuter_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtOuter.TextChanged
        If txtOuter.Text.Trim() = "" Then btnOK.Enabled = False Else btnOK.Enabled = True
    End Sub

    Private Sub lboxExRing_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lboxExRing.SelectedIndexChanged
        If lboxExRing.SelectedItems.Count() > 0 Then btnExEdit.Enabled = True : btnExDel.Enabled = True Else btnExEdit.Enabled = False : btnExDel.Enabled = False
    End Sub

    Public Function getChanged() As Boolean
        Return bChange
    End Function
    Public Function getPolyCol() As StringCollection
        Return sPolyCol
    End Function

    Private Sub button_example_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_example.Click
        Dim helpForm As dialog_help = New dialog_help("GPoly")
        helpForm.ShowDialog()
    End Sub
End Class
