Option Strict On
Option Explicit On 

Imports System
Imports System.Object
Imports System.Collections
Imports System.Collections.Specialized
Imports System.IO
Imports System.Xml
Imports System.Windows.Forms
Imports Microsoft.VisualBasic.ControlChars

Public Class frmMetaMain
    Inherits System.Windows.Forms.Form

#Region "Public Shared Variables"
    Public Shared iSaveType As Integer = 1
    ' iSaveType = 1: save XML to permanent file; 
    ' iSaveType = 2: save XML to temporary file and perform CRLF substitution
    Public Shared strParaMarker As String = "mvcrlf*" 'marks paragraph breaks for HTML conversion feature
    Public Shared strParaHTML As String = "<br/>" 'replaces strParaMarker in final HTML conversion output
    Public Shared strFileToSave As String = "" 'string holding the file name
    Public Shared xmlHeader As XmlDocument
    Public Shared strStylesheet1 As String = "<?xml-stylesheet href="
    Public Shared strStylesheet2 As String = " type='text/xsl'?>"
    Public Shared strCurHref As String = ""
    Public Shared xmlIDsection As XmlNode
    Public Shared xmlDQIsection As XmlNode
    Public Shared xmlSDOsection As XmlNode
    Public Shared xmlSpaRefSection As XmlNode
    Public Shared xmlEAsection As XmlNode
    Public Shared xmlDistSection As XmlDocumentFragment
    Public Shared xmlMetaRefSection As XmlNode
    Private Shared xmlInputDOM As New XmlDocument 'used for opening files

    Public Shared bActiveFile As Boolean = False 'True if New or Open file
    Public Shared bTimeUsed As Boolean = False 'True if the metadata includes a time of day entry (not Geologic); 
    'used to trigger inclusion of Metadata Time Convention in Metadata Reference section

    'Citation information for ID section; the Boolean tells whether there is a larger work citation to process
    Public Shared objCitation As CiteInfo
    Public Shared objCitationLWork As CiteInfo
    Public Shared bCitationLWork As Boolean

    Public Shared IDtimeper As Collection

    'intTimeStyle indicates which time format is used in the documentation; only 1 format is allowed in a given document
    '             default is local time; all formats use a 24-hour clock
    '             value can be changed in Options menu
    'change generates non-modal list of fields to update; if no update at Save, then delete that Time node
    'intTimeStyle = 1: local time
    '               2: local time with GMT differential
    '               3: Universal time
    Public Shared intTimeStyle As Integer

    'Private Shared xmlAttrib As XmlAttribute 'will be used to mark missing mandatory information

    'variables for ID: spatial domain
    Public Shared sDataSetGPoly As StringCollection
    Public Shared sCountGPoly As StringCollection
    Public Shared sPdelim As String = ""

    'variables for ID: keywords
    Public Shared sKeyTheme As StringCollection
    Public Shared sKeyPlace As StringCollection
    Public Shared sKeyStratum As StringCollection
    Public Shared sKeyTemporal As StringCollection
    Public Shared sKdelim As String = CrLf

    'variables for ID: taxonomy
    Public Shared sTaxKeywords As StringCollection
    Public Shared citeTaxSys As Collection 'holds the main citation information for Taxonomic System
    Public Shared boolTaxSys As Collection 'holds Booleans indicating whether LWC is used
    Public Shared citeTaxSysLWC As Collection 'holds larger work citations
    Public Shared sTaxSysMods As StringCollection 'holds the Taxonomic System modifications
    Public Shared citeTaxIDRef As Collection 'holds the main citation information for Identification Reference
    Public Shared boolTaxIDRef As Collection 'holds Booleans indicating whether LWC is used
    Public Shared citeTaxIDRefLWC As Collection 'holds larger work citations
    Public Shared cntTaxID As Collection 'holds contact information for Identifier(s) -- optional
    Public Shared sVSpecimen As StringCollection 'holds the specimen info for vouchers
    Public Shared cntVouchers As Collection 'holds the contact info for voucher repository
    Public Shared TaxaClasses As Collection 'holds the taxonomic classification entries
    Public Shared xmlTaxonClass As XmlDocument 'holds the Taxonomic Classification

    'variables for ID: access
    Public Shared objDataContact As ContactInfo

    'variables for ID: analytical tools
    Public Shared idTools As Collection

    'variables for ID: miscellaneous
    Public Shared sBrowseGraphics As StringCollection
    Public Shared XRefBase As Collection
    Public Shared bXRefLWC As Collection
    Public Shared XRefLarge As Collection


    'variables for Data Quality
    Public Shared sAttribAcc As StringCollection
    Public Shared sHPosAcc As StringCollection
    Public Shared sVPosAcc As StringCollection
    Public Shared cMethods As New Collection
    Public Shared cSources As New Collection
    Public Shared cProcess As New Collection


    'variables for Spatial Data Organization
    Public Shared sSDTS As StringCollection 'holds collection of SDTS or VPF terms descriptions, if used
    Public Shared bSDTS As Boolean 'True if SDTS terms description selected
    Public Shared bVPF As Boolean 'True if VPF terms description selected


    'variables for Spatial Reference Information
    Public Shared cPlanar As New Collection
    Private Shared sPlanProjParams(29) As String


    'variables for Entity and Attribute Information
    Public Shared cEAentity As New Collection 'the detail descriptions
    Public Shared cEAttribs As New Collection    'the attributes associated with detailed descriptions
    Public Shared cEAdomains As New Collection   'the domain values associated with attributes
    Public Shared cEAdomtype As New StringCollection 'the domain types in the domain values collection, effectively 1-based
    Public Shared cEAttrOver As New Collection   'the overview descriptions
    Private Shared iRootIndex As Integer = 0 'index value for root element
    Private Shared iBranchIndex As Integer = 0 'index value for branch element
    Private Shared sRootType As String = "" 'type of root -- entity, attribute, domain
    Private Shared sBranchType As String = "" 'type of branch -- attribute or domain


    'variables for Distribution Information
    Public Shared cDistrib As New Collection 'the distributors of the data set
    Public Shared cStdOrderProc As New Collection 'standard order process descriptions
    Public Shared cDigitalForm As New Collection 'Digital forms for the standard order processes
    Public Shared cDTransOpt As New Collection 'Digital Transfer Options for Digital Forms

    'variables for Metadata Reference section
    Public Shared objMRcontact As ContactInfo
#End Region



#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents tabSection1 As System.Windows.Forms.TabPage
    Friend WithEvents tabSection2 As System.Windows.Forms.TabPage
    Friend WithEvents tabSection3 As System.Windows.Forms.TabPage
    Friend WithEvents tabSection4 As System.Windows.Forms.TabPage
    Friend WithEvents tabSection5 As System.Windows.Forms.TabPage
    Friend WithEvents tabSection6 As System.Windows.Forms.TabPage
    Friend WithEvents tabSection7 As System.Windows.Forms.TabPage
    Friend WithEvents ImageList1 As System.Windows.Forms.ImageList
    Friend WithEvents tabMainSection As System.Windows.Forms.TabControl
    Friend WithEvents tabID As System.Windows.Forms.TabControl
    Friend WithEvents tpIDRef As System.Windows.Forms.TabPage
    Friend WithEvents tpSpDomain As System.Windows.Forms.TabPage
    Friend WithEvents tpKeywords As System.Windows.Forms.TabPage
    Friend WithEvents tbTaxonomy As System.Windows.Forms.TabPage
    Friend WithEvents tpTool As System.Windows.Forms.TabPage
    Friend WithEvents tpAccess As System.Windows.Forms.TabPage
    Friend WithEvents tpIDmisc As System.Windows.Forms.TabPage
    Friend WithEvents tabQuality As System.Windows.Forms.TabControl
    Friend WithEvents tpDQattrib As System.Windows.Forms.TabPage
    Friend WithEvents tpDQlogic As System.Windows.Forms.TabPage
    Friend WithEvents tpDQposit As System.Windows.Forms.TabPage
    Friend WithEvents tpDQlineage As System.Windows.Forms.TabPage
    Friend WithEvents tpDQcloud As System.Windows.Forms.TabPage
    Friend WithEvents tabSDO As System.Windows.Forms.TabControl
    Friend WithEvents tpSDOvector As System.Windows.Forms.TabPage
    Friend WithEvents tpSDOraster As System.Windows.Forms.TabPage
    Friend WithEvents tabSR As System.Windows.Forms.TabControl
    Friend WithEvents tpSRhoriz As System.Windows.Forms.TabPage
    Friend WithEvents tpSRvert As System.Windows.Forms.TabPage
    Friend WithEvents tabEA As System.Windows.Forms.TabControl
    Friend WithEvents tpEAdetail As System.Windows.Forms.TabPage
    Friend WithEvents tabDI As System.Windows.Forms.TabControl
    Friend WithEvents pnlCitation As System.Windows.Forms.Panel
    Friend WithEvents pnlDesc As System.Windows.Forms.Panel
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents txtAbstract As System.Windows.Forms.TextBox
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents txtPurpose As System.Windows.Forms.TextBox
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip
    Friend WithEvents Label5 As System.Windows.Forms.Label
    Friend WithEvents txtSupplInfo As System.Windows.Forms.TextBox
    Friend WithEvents Label6 As System.Windows.Forms.Label
    Friend WithEvents Label7 As System.Windows.Forms.Label
    Friend WithEvents txtIDCiteAuth As System.Windows.Forms.TextBox
    Friend WithEvents Label8 As System.Windows.Forms.Label
    Friend WithEvents Label9 As System.Windows.Forms.Label
    Friend WithEvents txtIDCiteTitle As System.Windows.Forms.TextBox
    Friend WithEvents txtIDCiteDate As System.Windows.Forms.TextBox
    Friend WithEvents btnIDCite As System.Windows.Forms.Button
    Friend WithEvents pnlTime As System.Windows.Forms.Panel
    Friend WithEvents Label10 As System.Windows.Forms.Label
    Friend WithEvents Label11 As System.Windows.Forms.Label
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    Friend WithEvents rdoTLocal As System.Windows.Forms.RadioButton
    Friend WithEvents rdoTGeol As System.Windows.Forms.RadioButton
    Friend WithEvents Label13 As System.Windows.Forms.Label
    Friend WithEvents Panel2 As System.Windows.Forms.Panel
    Friend WithEvents rdoTSingle As System.Windows.Forms.RadioButton
    Friend WithEvents rdoTMult As System.Windows.Forms.RadioButton
    Friend WithEvents rdoTRange As System.Windows.Forms.RadioButton
    Friend WithEvents Label14 As System.Windows.Forms.Label
    Friend WithEvents Label15 As System.Windows.Forms.Label
    Friend WithEvents lboxTime As System.Windows.Forms.ListBox
    Friend WithEvents btnTimeAdd As System.Windows.Forms.Button
    Friend WithEvents btnTimeEdit As System.Windows.Forms.Button
    Friend WithEvents btnTimeDelete As System.Windows.Forms.Button
    Friend WithEvents Label12 As System.Windows.Forms.Label
    Friend WithEvents cboxCurRef As System.Windows.Forms.ComboBox
    Friend WithEvents pnlStatus As System.Windows.Forms.Panel
    Friend WithEvents Label16 As System.Windows.Forms.Label
    Friend WithEvents Label17 As System.Windows.Forms.Label
    Friend WithEvents lboxProg As System.Windows.Forms.ListBox
    Friend WithEvents Label18 As System.Windows.Forms.Label
    Friend WithEvents cboxUpdate As System.Windows.Forms.ComboBox
    Friend WithEvents tabMRef As System.Windows.Forms.TabControl
    Friend WithEvents tpMRinfo As System.Windows.Forms.TabPage
    Friend WithEvents tpMRuse As System.Windows.Forms.TabPage
    Friend WithEvents tpMRext As System.Windows.Forms.TabPage
    Friend WithEvents Label19 As System.Windows.Forms.Label
    Friend WithEvents Label21 As System.Windows.Forms.Label
    Friend WithEvents cboxStdName As System.Windows.Forms.ComboBox
    Friend WithEvents Label22 As System.Windows.Forms.Label
    Friend WithEvents cboxStdVer As System.Windows.Forms.ComboBox
    Friend WithEvents TextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents TextBox2 As System.Windows.Forms.TextBox
    Friend WithEvents dtPick1 As System.Windows.Forms.DateTimePicker
    Friend WithEvents Label20 As System.Windows.Forms.Label
    Friend WithEvents txtMRcontact As System.Windows.Forms.TextBox
    Friend WithEvents btnMRedit As System.Windows.Forms.Button
    Friend WithEvents dtPick2 As System.Windows.Forms.DateTimePicker
    Friend WithEvents Label23 As System.Windows.Forms.Label
    Friend WithEvents Label24 As System.Windows.Forms.Label
    Friend WithEvents Label25 As System.Windows.Forms.Label
    Friend WithEvents Label26 As System.Windows.Forms.Label
    Friend WithEvents TextBox3 As System.Windows.Forms.TextBox
    Friend WithEvents Label27 As System.Windows.Forms.Label
    Friend WithEvents txtMRaccess As System.Windows.Forms.TextBox
    Friend WithEvents txtMRuse As System.Windows.Forms.TextBox
    Friend WithEvents Label28 As System.Windows.Forms.Label
    Friend WithEvents Panel3 As System.Windows.Forms.Panel
    Friend WithEvents TextBox4 As System.Windows.Forms.TextBox
    Friend WithEvents Label29 As System.Windows.Forms.Label
    Friend WithEvents txtMRClassSys As System.Windows.Forms.TextBox
    Friend WithEvents Label30 As System.Windows.Forms.Label
    Friend WithEvents cboxMRClass As System.Windows.Forms.ComboBox
    Friend WithEvents Label31 As System.Windows.Forms.Label
    Friend WithEvents txtMRSecDesc As System.Windows.Forms.TextBox
    Friend WithEvents dtPick3 As System.Windows.Forms.DateTimePicker
    Friend WithEvents chkRevDate As System.Windows.Forms.CheckBox
    Friend WithEvents chkFRevDate As System.Windows.Forms.CheckBox
    Friend WithEvents Label32 As System.Windows.Forms.Label
    Friend WithEvents txtGeoExt As System.Windows.Forms.TextBox
    Friend WithEvents Label33 As System.Windows.Forms.Label
    Friend WithEvents Label34 As System.Windows.Forms.Label
    Friend WithEvents Label35 As System.Windows.Forms.Label
    Friend WithEvents Label36 As System.Windows.Forms.Label
    Friend WithEvents Label37 As System.Windows.Forms.Label
    Friend WithEvents Label38 As System.Windows.Forms.Label
    Friend WithEvents Label39 As System.Windows.Forms.Label
    Friend WithEvents Label40 As System.Windows.Forms.Label
    Friend WithEvents Label41 As System.Windows.Forms.Label
    Friend WithEvents cboxIDaltDistU As System.Windows.Forms.ComboBox
    Friend WithEvents Label42 As System.Windows.Forms.Label
    Friend WithEvents lboxGPoly As System.Windows.Forms.ListBox
    Friend WithEvents btnAddPoly As System.Windows.Forms.Button
    Friend WithEvents btnEditPoly As System.Windows.Forms.Button
    Friend WithEvents btnDelPoly As System.Windows.Forms.Button
    Friend WithEvents Label43 As System.Windows.Forms.Label
    Friend WithEvents lboxKTheme As System.Windows.Forms.ListBox
    Friend WithEvents Label44 As System.Windows.Forms.Label
    Friend WithEvents btnThemeAdd As System.Windows.Forms.Button
    Friend WithEvents btnThemeEdit As System.Windows.Forms.Button
    Friend WithEvents btnThemeDelete As System.Windows.Forms.Button
    Friend WithEvents btnPlaceDelete As System.Windows.Forms.Button
    Friend WithEvents btnPlaceEdit As System.Windows.Forms.Button
    Friend WithEvents btnPlaceAdd As System.Windows.Forms.Button
    Friend WithEvents lboxKPlace As System.Windows.Forms.ListBox
    Friend WithEvents btnStratumDelete As System.Windows.Forms.Button
    Friend WithEvents btnStratumEdit As System.Windows.Forms.Button
    Friend WithEvents btnStratumAdd As System.Windows.Forms.Button
    Friend WithEvents lboxKStratum As System.Windows.Forms.ListBox
    Friend WithEvents Label45 As System.Windows.Forms.Label
    Friend WithEvents Label46 As System.Windows.Forms.Label
    Friend WithEvents btnTemporalDelete As System.Windows.Forms.Button
    Friend WithEvents btnTemporalEdit As System.Windows.Forms.Button
    Friend WithEvents btnTemporalAdd As System.Windows.Forms.Button
    Friend WithEvents lboxKTemporal As System.Windows.Forms.ListBox
    Friend WithEvents Label47 As System.Windows.Forms.Label
    Friend WithEvents txtIDaccess As System.Windows.Forms.TextBox
    Friend WithEvents Label48 As System.Windows.Forms.Label
    Friend WithEvents Label49 As System.Windows.Forms.Label
    Friend WithEvents txtIDuse As System.Windows.Forms.TextBox
    Friend WithEvents Label50 As System.Windows.Forms.Label
    Friend WithEvents Label51 As System.Windows.Forms.Label
    Friend WithEvents txtDataContact As System.Windows.Forms.TextBox
    Friend WithEvents btnDataContact As System.Windows.Forms.Button
    Friend WithEvents Panel4 As System.Windows.Forms.Panel
    Friend WithEvents Label52 As System.Windows.Forms.Label
    Friend WithEvents cboxDataSecClass As System.Windows.Forms.ComboBox
    Friend WithEvents Label53 As System.Windows.Forms.Label
    Friend WithEvents txtDataSecSys As System.Windows.Forms.TextBox
    Friend WithEvents Label54 As System.Windows.Forms.Label
    Friend WithEvents txtDataSecDesc As System.Windows.Forms.TextBox
    Friend WithEvents Label55 As System.Windows.Forms.Label
    Friend WithEvents Label56 As System.Windows.Forms.Label
    Friend WithEvents txtDScredit As System.Windows.Forms.TextBox
    Friend WithEvents Label57 As System.Windows.Forms.Label
    Friend WithEvents lboxBrGraphic As System.Windows.Forms.ListBox
    Friend WithEvents btnGraphicAdd As System.Windows.Forms.Button
    Friend WithEvents btnGraphicEdit As System.Windows.Forms.Button
    Friend WithEvents btnGraphicDelete As System.Windows.Forms.Button
    Friend WithEvents btnXRefDelete As System.Windows.Forms.Button
    Friend WithEvents btnXRefEdit As System.Windows.Forms.Button
    Friend WithEvents btnXRefAdd As System.Windows.Forms.Button
    Friend WithEvents lboxXRef As System.Windows.Forms.ListBox
    Friend WithEvents Label58 As System.Windows.Forms.Label
    Friend WithEvents txtDSenviron As System.Windows.Forms.TextBox
    Friend WithEvents Label59 As System.Windows.Forms.Label
    Friend WithEvents TextBox5 As System.Windows.Forms.TextBox
    Friend WithEvents Label60 As System.Windows.Forms.Label
    Friend WithEvents lboxTool As System.Windows.Forms.ListBox
    Friend WithEvents btnToolAdd As System.Windows.Forms.Button
    Friend WithEvents btnToolEdit As System.Windows.Forms.Button
    Friend WithEvents btnToolDelete As System.Windows.Forms.Button
    Friend WithEvents SaveFileDialog1 As System.Windows.Forms.SaveFileDialog
    Friend WithEvents Panel5 As System.Windows.Forms.Panel
    Friend WithEvents Label61 As System.Windows.Forms.Label
    Friend WithEvents lboxTaxKey As System.Windows.Forms.ListBox
    Friend WithEvents btnAddTaxKey As System.Windows.Forms.Button
    Friend WithEvents btnEditTaxKey As System.Windows.Forms.Button
    Friend WithEvents btnDelTaxKey As System.Windows.Forms.Button
    Friend WithEvents Panel6 As System.Windows.Forms.Panel
    Friend WithEvents Label62 As System.Windows.Forms.Label
    Friend WithEvents Label63 As System.Windows.Forms.Label
    Friend WithEvents lboxTaxSys As System.Windows.Forms.ListBox
    Friend WithEvents btnAddTaxSys As System.Windows.Forms.Button
    Friend WithEvents btnEditTaxSys As System.Windows.Forms.Button
    Friend WithEvents btnDelTaxSys As System.Windows.Forms.Button
    Friend WithEvents btnDelTaxIDRef As System.Windows.Forms.Button
    Friend WithEvents btnEditTaxIDRef As System.Windows.Forms.Button
    Friend WithEvents btnAddTaxIDRef As System.Windows.Forms.Button
    Friend WithEvents lboxTaxIDRef As System.Windows.Forms.ListBox
    Friend WithEvents Label64 As System.Windows.Forms.Label
    Friend WithEvents btnDelTaxID As System.Windows.Forms.Button
    Friend WithEvents btnEditTaxID As System.Windows.Forms.Button
    Friend WithEvents btnAddTaxID As System.Windows.Forms.Button
    Friend WithEvents lboxTaxID As System.Windows.Forms.ListBox
    Friend WithEvents Label65 As System.Windows.Forms.Label
    Friend WithEvents Label66 As System.Windows.Forms.Label
    Friend WithEvents txtTaxProc As System.Windows.Forms.TextBox
    Friend WithEvents Panel7 As System.Windows.Forms.Panel
    Friend WithEvents Label67 As System.Windows.Forms.Label
    Friend WithEvents txtTaxComplete As System.Windows.Forms.TextBox
    Friend WithEvents btnDelVoucher As System.Windows.Forms.Button
    Friend WithEvents btnEditVoucher As System.Windows.Forms.Button
    Friend WithEvents btnAddVoucher As System.Windows.Forms.Button
    Friend WithEvents lboxVouchers As System.Windows.Forms.ListBox
    Friend WithEvents Label68 As System.Windows.Forms.Label
    Friend WithEvents Label69 As System.Windows.Forms.Label
    Friend WithEvents txtTaxCover As System.Windows.Forms.TextBox
    Friend WithEvents Panel8 As System.Windows.Forms.Panel
    Friend WithEvents Panel9 As System.Windows.Forms.Panel
    Friend WithEvents Label70 As System.Windows.Forms.Label
    Friend WithEvents lboxLinneaus As System.Windows.Forms.ListBox
    Friend WithEvents btnAddTaxRank As System.Windows.Forms.Button
    Friend WithEvents btnEditTaxRank As System.Windows.Forms.Button
    Friend WithEvents btnDelTaxRank As System.Windows.Forms.Button
    Friend WithEvents tpSDOref As System.Windows.Forms.TabPage
    Friend WithEvents Label71 As System.Windows.Forms.Label
    Friend WithEvents txtIndirect As System.Windows.Forms.TextBox
    Friend WithEvents Label72 As System.Windows.Forms.Label
    Friend WithEvents lblVector As System.Windows.Forms.Label
    Friend WithEvents lblRaster As System.Windows.Forms.Label
    Friend WithEvents Panel10 As System.Windows.Forms.Panel
    Friend WithEvents Label73 As System.Windows.Forms.Label
    Friend WithEvents Panel11 As System.Windows.Forms.Panel
    Friend WithEvents Label74 As System.Windows.Forms.Label
    Friend WithEvents Label75 As System.Windows.Forms.Label
    Friend WithEvents Label76 As System.Windows.Forms.Label
    Friend WithEvents Label77 As System.Windows.Forms.Label
    Friend WithEvents cboxRasType As System.Windows.Forms.ComboBox
    Friend WithEvents cboxDirect As System.Windows.Forms.ComboBox
    Friend WithEvents numRasVert As System.Windows.Forms.NumericUpDown
    Friend WithEvents numRasRow As System.Windows.Forms.NumericUpDown
    Friend WithEvents numRasCol As System.Windows.Forms.NumericUpDown
    Friend WithEvents TextBox6 As System.Windows.Forms.TextBox
    Friend WithEvents Panel12 As System.Windows.Forms.Panel
    Friend WithEvents Label78 As System.Windows.Forms.Label
    Friend WithEvents Panel13 As System.Windows.Forms.Panel
    Friend WithEvents Label79 As System.Windows.Forms.Label
    Friend WithEvents rdoNoDesc As System.Windows.Forms.RadioButton
    Friend WithEvents rdoSDTS As System.Windows.Forms.RadioButton
    Friend WithEvents rdoVPF As System.Windows.Forms.RadioButton
    Friend WithEvents Panel14 As System.Windows.Forms.Panel
    Friend WithEvents Panel15 As System.Windows.Forms.Panel
    Friend WithEvents Label81 As System.Windows.Forms.Label
    Friend WithEvents btnDelTerm As System.Windows.Forms.Button
    Friend WithEvents btnEditTerm As System.Windows.Forms.Button
    Friend WithEvents btnAddTerm As System.Windows.Forms.Button
    Friend WithEvents lboxTerms As System.Windows.Forms.ListBox
    Friend WithEvents lblSDTS As System.Windows.Forms.Label
    Friend WithEvents Label80 As System.Windows.Forms.Label
    Friend WithEvents numCloud As System.Windows.Forms.NumericUpDown
    Friend WithEvents Panel16 As System.Windows.Forms.Panel
    Friend WithEvents rdoNoCloud As System.Windows.Forms.RadioButton
    Friend WithEvents rdoCloudUnk As System.Windows.Forms.RadioButton
    Friend WithEvents rdoCloud As System.Windows.Forms.RadioButton
    Friend WithEvents pnlCloud As System.Windows.Forms.Panel
    Friend WithEvents TextBox7 As System.Windows.Forms.TextBox
    Friend WithEvents Label82 As System.Windows.Forms.Label
    Friend WithEvents txtLogic As System.Windows.Forms.TextBox
    Friend WithEvents Label83 As System.Windows.Forms.Label
    Friend WithEvents txtComplete As System.Windows.Forms.TextBox
    Friend WithEvents TextBox8 As System.Windows.Forms.TextBox
    Friend WithEvents TextBox9 As System.Windows.Forms.TextBox
    Friend WithEvents TextBox10 As System.Windows.Forms.TextBox
    Friend WithEvents txtAttribAcc As System.Windows.Forms.TextBox
    Friend WithEvents Label84 As System.Windows.Forms.Label
    Friend WithEvents Label85 As System.Windows.Forms.Label
    Friend WithEvents lboxAttribAcc As System.Windows.Forms.ListBox
    Friend WithEvents btnAddAttribAcc As System.Windows.Forms.Button
    Friend WithEvents btnEditAttribAcc As System.Windows.Forms.Button
    Friend WithEvents btnDelAttribAcc As System.Windows.Forms.Button
    Friend WithEvents Panel17 As System.Windows.Forms.Panel
    Friend WithEvents Label86 As System.Windows.Forms.Label
    Friend WithEvents Label87 As System.Windows.Forms.Label
    Friend WithEvents txtHorAccRpt As System.Windows.Forms.TextBox
    Friend WithEvents TextBox11 As System.Windows.Forms.TextBox
    Friend WithEvents Label88 As System.Windows.Forms.Label
    Friend WithEvents lboxHPosAcc As System.Windows.Forms.ListBox
    Friend WithEvents btnAddHPosAcc As System.Windows.Forms.Button
    Friend WithEvents btnEditHPosAcc As System.Windows.Forms.Button
    Friend WithEvents btnDelHPosAcc As System.Windows.Forms.Button
    Friend WithEvents Panel18 As System.Windows.Forms.Panel
    Friend WithEvents lboxVPosAcc As System.Windows.Forms.ListBox
    Friend WithEvents Label89 As System.Windows.Forms.Label
    Friend WithEvents TextBox12 As System.Windows.Forms.TextBox
    Friend WithEvents txtVertAccRpt As System.Windows.Forms.TextBox
    Friend WithEvents Label90 As System.Windows.Forms.Label
    Friend WithEvents Label91 As System.Windows.Forms.Label
    Friend WithEvents btnDelVPosAcc As System.Windows.Forms.Button
    Friend WithEvents btnEditVPosAcc As System.Windows.Forms.Button
    Friend WithEvents btnAddVPosAcc As System.Windows.Forms.Button
    Friend WithEvents Label92 As System.Windows.Forms.Label
    Friend WithEvents lboxMeth As System.Windows.Forms.ListBox
    Friend WithEvents btnAddMeth As System.Windows.Forms.Button
    Friend WithEvents btnEditMeth As System.Windows.Forms.Button
    Friend WithEvents btnDelMeth As System.Windows.Forms.Button
    Friend WithEvents btnDelSource As System.Windows.Forms.Button
    Friend WithEvents btnEditSource As System.Windows.Forms.Button
    Friend WithEvents btnAddSource As System.Windows.Forms.Button
    Friend WithEvents lboxLinSource As System.Windows.Forms.ListBox
    Friend WithEvents Label93 As System.Windows.Forms.Label
    Friend WithEvents btnDelProc As System.Windows.Forms.Button
    Friend WithEvents btnEditProc As System.Windows.Forms.Button
    Friend WithEvents btnAddProc As System.Windows.Forms.Button
    Friend WithEvents lboxProcess As System.Windows.Forms.ListBox
    Friend WithEvents Label94 As System.Windows.Forms.Label
    Friend WithEvents TextBox13 As System.Windows.Forms.TextBox
    Friend WithEvents TextBox14 As System.Windows.Forms.TextBox
    Friend WithEvents TextBox15 As System.Windows.Forms.TextBox
    Friend WithEvents Panel19 As System.Windows.Forms.Panel
    Friend WithEvents btnDelEDetl As System.Windows.Forms.Button
    Friend WithEvents btnEditEDtl As System.Windows.Forms.Button
    Friend WithEvents btnAddEDtl As System.Windows.Forms.Button
    Friend WithEvents Label97 As System.Windows.Forms.Label
    Friend WithEvents tpEAover As System.Windows.Forms.TabPage
    Friend WithEvents btnDelEOver As System.Windows.Forms.Button
    Friend WithEvents btnEditEOver As System.Windows.Forms.Button
    Friend WithEvents btnAddEOver As System.Windows.Forms.Button
    Friend WithEvents lboxOverView As System.Windows.Forms.ListBox
    Friend WithEvents Label96 As System.Windows.Forms.Label
    Friend WithEvents Label95 As System.Windows.Forms.Label
    Friend WithEvents tpEAinfo As System.Windows.Forms.TabPage
    Friend WithEvents TextBox16 As System.Windows.Forms.TextBox
    Friend WithEvents TextBox17 As System.Windows.Forms.TextBox
    Friend WithEvents cboxEntity As System.Windows.Forms.ComboBox
    Friend WithEvents cboxAttrib As System.Windows.Forms.ComboBox
    Friend WithEvents Label98 As System.Windows.Forms.Label
    Friend WithEvents btnEAattribDel As System.Windows.Forms.Button
    Friend WithEvents btnEAattribEdit As System.Windows.Forms.Button
    Friend WithEvents btnEAattribAdd As System.Windows.Forms.Button
    Friend WithEvents btnEAdomainDel As System.Windows.Forms.Button
    Friend WithEvents btnEAdomainEdit As System.Windows.Forms.Button
    Friend WithEvents btnEAdomainAdd As System.Windows.Forms.Button
    Friend WithEvents cboxDomains As System.Windows.Forms.ComboBox
    Friend WithEvents Label99 As System.Windows.Forms.Label
    Friend WithEvents Label100 As System.Windows.Forms.Label
    Friend WithEvents Label101 As System.Windows.Forms.Label
    Friend WithEvents btnSelEntity As System.Windows.Forms.Button
    Friend WithEvents btnSelAttrib As System.Windows.Forms.Button
    Friend WithEvents btnSelDomain As System.Windows.Forms.Button
    Friend WithEvents Label102 As System.Windows.Forms.Label
    Friend WithEvents txtEAbranch As System.Windows.Forms.TextBox
    Friend WithEvents Label103 As System.Windows.Forms.Label
    Friend WithEvents btnViewLinks As System.Windows.Forms.Button
    Friend WithEvents btnCrLink As System.Windows.Forms.Button
    Friend WithEvents btnDelLink As System.Windows.Forms.Button
    Friend WithEvents btnClearElem As System.Windows.Forms.Button
    Friend WithEvents TextBox18 As System.Windows.Forms.TextBox
    Friend WithEvents lblEAroot As System.Windows.Forms.Label
    Friend WithEvents TextBox19 As System.Windows.Forms.TextBox
    Friend WithEvents numWestBC As System.Windows.Forms.NumericUpDown
    Friend WithEvents numEastBC As System.Windows.Forms.NumericUpDown
    Friend WithEvents numNorthBC As System.Windows.Forms.NumericUpDown
    Friend WithEvents numSouthBC As System.Windows.Forms.NumericUpDown
    Friend WithEvents numAltMin As System.Windows.Forms.NumericUpDown
    Friend WithEvents numAltMax As System.Windows.Forms.NumericUpDown
    Friend WithEvents tpDImain As System.Windows.Forms.TabPage
    Friend WithEvents tpDIinfo As System.Windows.Forms.TabPage
    Friend WithEvents TextBox20 As System.Windows.Forms.TextBox
    Friend WithEvents Label104 As System.Windows.Forms.Label
    Friend WithEvents lboxDistrib As System.Windows.Forms.ListBox
    Friend WithEvents btnAddDistrib As System.Windows.Forms.Button
    Friend WithEvents btnEditDistrib As System.Windows.Forms.Button
    Friend WithEvents btnDelDistrib As System.Windows.Forms.Button
    Friend WithEvents pnlAltitude As System.Windows.Forms.Panel
    Friend WithEvents pnlDepth As System.Windows.Forms.Panel
    Friend WithEvents Label105 As System.Windows.Forms.Label
    Friend WithEvents Label106 As System.Windows.Forms.Label
    Friend WithEvents Label107 As System.Windows.Forms.Label
    Friend WithEvents cboxAltDatum As System.Windows.Forms.ComboBox
    Friend WithEvents cboxDepthDatum As System.Windows.Forms.ComboBox
    Friend WithEvents Label108 As System.Windows.Forms.Label
    Friend WithEvents Label109 As System.Windows.Forms.Label
    Friend WithEvents txtAltRes As System.Windows.Forms.TextBox
    Friend WithEvents numAltRes As System.Windows.Forms.NumericUpDown
    Friend WithEvents btnAddAltRes As System.Windows.Forms.Button
    Friend WithEvents btnClearAltRes As System.Windows.Forms.Button
    Friend WithEvents cboxAltUnits As System.Windows.Forms.ComboBox
    Friend WithEvents Label110 As System.Windows.Forms.Label
    Friend WithEvents cboxAltEncode As System.Windows.Forms.ComboBox
    Friend WithEvents Label111 As System.Windows.Forms.Label
    Friend WithEvents cboxDepthEncode As System.Windows.Forms.ComboBox
    Friend WithEvents Label112 As System.Windows.Forms.Label
    Friend WithEvents cboxDepthUnits As System.Windows.Forms.ComboBox
    Friend WithEvents Label113 As System.Windows.Forms.Label
    Friend WithEvents btnClrDepthRes As System.Windows.Forms.Button
    Friend WithEvents btnAddDepth As System.Windows.Forms.Button
    Friend WithEvents numDepthRes As System.Windows.Forms.NumericUpDown
    Friend WithEvents txtDepthRes As System.Windows.Forms.TextBox
    Friend WithEvents Label114 As System.Windows.Forms.Label
    Friend WithEvents Label115 As System.Windows.Forms.Label
    Friend WithEvents pnlHoriz As System.Windows.Forms.Panel
    Friend WithEvents rdoGeographic As System.Windows.Forms.RadioButton
    Friend WithEvents rdoPlanar As System.Windows.Forms.RadioButton
    Friend WithEvents rdoLocal As System.Windows.Forms.RadioButton
    Friend WithEvents rdoNone As System.Windows.Forms.RadioButton
    Friend WithEvents pnlGeographic As System.Windows.Forms.Panel
    Friend WithEvents pnlPlanar As System.Windows.Forms.Panel
    Friend WithEvents pnlLocal As System.Windows.Forms.Panel
    Friend WithEvents Label116 As System.Windows.Forms.Label
    Friend WithEvents numLatRes As System.Windows.Forms.NumericUpDown
    Friend WithEvents numLongRes As System.Windows.Forms.NumericUpDown
    Friend WithEvents Label117 As System.Windows.Forms.Label
    Friend WithEvents Label118 As System.Windows.Forms.Label
    Friend WithEvents cboxGeoCoorUnits As System.Windows.Forms.ComboBox
    Friend WithEvents pnlGeodetic As System.Windows.Forms.Panel
    Friend WithEvents Label119 As System.Windows.Forms.Label
    Friend WithEvents lboxPlanar As System.Windows.Forms.ListBox
    Friend WithEvents btnAddPlanar As System.Windows.Forms.Button
    Friend WithEvents btnEditPlanar As System.Windows.Forms.Button
    Friend WithEvents btnDelPlanar As System.Windows.Forms.Button
    Friend WithEvents Label120 As System.Windows.Forms.Label
    Friend WithEvents Label121 As System.Windows.Forms.Label
    Friend WithEvents Label122 As System.Windows.Forms.Label
    Friend WithEvents txtLocalDesc As System.Windows.Forms.TextBox
    Friend WithEvents Label123 As System.Windows.Forms.Label
    Friend WithEvents Label124 As System.Windows.Forms.Label
    Friend WithEvents Label125 As System.Windows.Forms.Label
    Friend WithEvents cboxHorizName As System.Windows.Forms.ComboBox
    Friend WithEvents cboxEllipsoid As System.Windows.Forms.ComboBox
    Friend WithEvents Label126 As System.Windows.Forms.Label
    Friend WithEvents Label127 As System.Windows.Forms.Label
    Friend WithEvents numSemiMajor As System.Windows.Forms.NumericUpDown
    Friend WithEvents numFlatten As System.Windows.Forms.NumericUpDown
    Friend WithEvents Label128 As System.Windows.Forms.Label
    Friend WithEvents txtLocalGeoInfo As System.Windows.Forms.TextBox
    Friend WithEvents OpenFileDialog1 As System.Windows.Forms.OpenFileDialog
    Friend WithEvents Panel20 As System.Windows.Forms.Panel
    Friend WithEvents rdoTUnknown As System.Windows.Forms.RadioButton
    Friend WithEvents cboxVPF As System.Windows.Forms.ComboBox
    Friend WithEvents SaveHTMLDialog As System.Windows.Forms.SaveFileDialog
    Friend WithEvents btnImpTaxa As System.Windows.Forms.Button
    Friend WithEvents btnExpTaxa As System.Windows.Forms.Button
    Friend WithEvents SaveTaxonDialog As System.Windows.Forms.SaveFileDialog
    Friend WithEvents OpenTaxonFileDialog As System.Windows.Forms.OpenFileDialog
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(frmMetaMain))
        Me.tabMainSection = New System.Windows.Forms.TabControl
        Me.tabSection1 = New System.Windows.Forms.TabPage
        Me.tabID = New System.Windows.Forms.TabControl
        Me.tpIDRef = New System.Windows.Forms.TabPage
        Me.TextBox19 = New System.Windows.Forms.TextBox
        Me.pnlStatus = New System.Windows.Forms.Panel
        Me.cboxUpdate = New System.Windows.Forms.ComboBox
        Me.Label18 = New System.Windows.Forms.Label
        Me.lboxProg = New System.Windows.Forms.ListBox
        Me.Label17 = New System.Windows.Forms.Label
        Me.Label16 = New System.Windows.Forms.Label
        Me.Label14 = New System.Windows.Forms.Label
        Me.pnlTime = New System.Windows.Forms.Panel
        Me.cboxCurRef = New System.Windows.Forms.ComboBox
        Me.Label12 = New System.Windows.Forms.Label
        Me.btnTimeDelete = New System.Windows.Forms.Button
        Me.btnTimeEdit = New System.Windows.Forms.Button
        Me.btnTimeAdd = New System.Windows.Forms.Button
        Me.lboxTime = New System.Windows.Forms.ListBox
        Me.Label15 = New System.Windows.Forms.Label
        Me.Panel2 = New System.Windows.Forms.Panel
        Me.rdoTUnknown = New System.Windows.Forms.RadioButton
        Me.rdoTRange = New System.Windows.Forms.RadioButton
        Me.rdoTMult = New System.Windows.Forms.RadioButton
        Me.rdoTSingle = New System.Windows.Forms.RadioButton
        Me.Label13 = New System.Windows.Forms.Label
        Me.Panel1 = New System.Windows.Forms.Panel
        Me.rdoTGeol = New System.Windows.Forms.RadioButton
        Me.rdoTLocal = New System.Windows.Forms.RadioButton
        Me.Label11 = New System.Windows.Forms.Label
        Me.Label10 = New System.Windows.Forms.Label
        Me.pnlDesc = New System.Windows.Forms.Panel
        Me.Panel20 = New System.Windows.Forms.Panel
        Me.Label6 = New System.Windows.Forms.Label
        Me.txtPurpose = New System.Windows.Forms.TextBox
        Me.txtAbstract = New System.Windows.Forms.TextBox
        Me.Label2 = New System.Windows.Forms.Label
        Me.Label1 = New System.Windows.Forms.Label
        Me.Label3 = New System.Windows.Forms.Label
        Me.Label5 = New System.Windows.Forms.Label
        Me.txtSupplInfo = New System.Windows.Forms.TextBox
        Me.pnlCitation = New System.Windows.Forms.Panel
        Me.btnIDCite = New System.Windows.Forms.Button
        Me.txtIDCiteDate = New System.Windows.Forms.TextBox
        Me.txtIDCiteTitle = New System.Windows.Forms.TextBox
        Me.Label9 = New System.Windows.Forms.Label
        Me.Label8 = New System.Windows.Forms.Label
        Me.txtIDCiteAuth = New System.Windows.Forms.TextBox
        Me.Label7 = New System.Windows.Forms.Label
        Me.Label4 = New System.Windows.Forms.Label
        Me.tpSpDomain = New System.Windows.Forms.TabPage
        Me.numAltMax = New System.Windows.Forms.NumericUpDown
        Me.numAltMin = New System.Windows.Forms.NumericUpDown
        Me.numSouthBC = New System.Windows.Forms.NumericUpDown
        Me.numNorthBC = New System.Windows.Forms.NumericUpDown
        Me.numEastBC = New System.Windows.Forms.NumericUpDown
        Me.numWestBC = New System.Windows.Forms.NumericUpDown
        Me.btnDelPoly = New System.Windows.Forms.Button
        Me.btnEditPoly = New System.Windows.Forms.Button
        Me.btnAddPoly = New System.Windows.Forms.Button
        Me.lboxGPoly = New System.Windows.Forms.ListBox
        Me.Label42 = New System.Windows.Forms.Label
        Me.cboxIDaltDistU = New System.Windows.Forms.ComboBox
        Me.Label41 = New System.Windows.Forms.Label
        Me.Label40 = New System.Windows.Forms.Label
        Me.Label39 = New System.Windows.Forms.Label
        Me.Label38 = New System.Windows.Forms.Label
        Me.Label37 = New System.Windows.Forms.Label
        Me.Label36 = New System.Windows.Forms.Label
        Me.Label35 = New System.Windows.Forms.Label
        Me.Label34 = New System.Windows.Forms.Label
        Me.Label33 = New System.Windows.Forms.Label
        Me.txtGeoExt = New System.Windows.Forms.TextBox
        Me.Label32 = New System.Windows.Forms.Label
        Me.tpKeywords = New System.Windows.Forms.TabPage
        Me.Label46 = New System.Windows.Forms.Label
        Me.btnTemporalDelete = New System.Windows.Forms.Button
        Me.btnTemporalEdit = New System.Windows.Forms.Button
        Me.btnTemporalAdd = New System.Windows.Forms.Button
        Me.lboxKTemporal = New System.Windows.Forms.ListBox
        Me.Label45 = New System.Windows.Forms.Label
        Me.btnStratumDelete = New System.Windows.Forms.Button
        Me.btnStratumEdit = New System.Windows.Forms.Button
        Me.btnStratumAdd = New System.Windows.Forms.Button
        Me.lboxKStratum = New System.Windows.Forms.ListBox
        Me.btnPlaceDelete = New System.Windows.Forms.Button
        Me.btnPlaceEdit = New System.Windows.Forms.Button
        Me.btnPlaceAdd = New System.Windows.Forms.Button
        Me.lboxKPlace = New System.Windows.Forms.ListBox
        Me.btnThemeDelete = New System.Windows.Forms.Button
        Me.btnThemeEdit = New System.Windows.Forms.Button
        Me.btnThemeAdd = New System.Windows.Forms.Button
        Me.Label44 = New System.Windows.Forms.Label
        Me.lboxKTheme = New System.Windows.Forms.ListBox
        Me.Label43 = New System.Windows.Forms.Label
        Me.tbTaxonomy = New System.Windows.Forms.TabPage
        Me.Panel8 = New System.Windows.Forms.Panel
        Me.btnExpTaxa = New System.Windows.Forms.Button
        Me.btnImpTaxa = New System.Windows.Forms.Button
        Me.btnDelTaxRank = New System.Windows.Forms.Button
        Me.btnEditTaxRank = New System.Windows.Forms.Button
        Me.btnAddTaxRank = New System.Windows.Forms.Button
        Me.lboxLinneaus = New System.Windows.Forms.ListBox
        Me.Label70 = New System.Windows.Forms.Label
        Me.Panel9 = New System.Windows.Forms.Panel
        Me.txtTaxCover = New System.Windows.Forms.TextBox
        Me.Label69 = New System.Windows.Forms.Label
        Me.Panel6 = New System.Windows.Forms.Panel
        Me.btnDelVoucher = New System.Windows.Forms.Button
        Me.btnEditVoucher = New System.Windows.Forms.Button
        Me.btnAddVoucher = New System.Windows.Forms.Button
        Me.lboxVouchers = New System.Windows.Forms.ListBox
        Me.Label68 = New System.Windows.Forms.Label
        Me.txtTaxComplete = New System.Windows.Forms.TextBox
        Me.Label67 = New System.Windows.Forms.Label
        Me.Panel7 = New System.Windows.Forms.Panel
        Me.txtTaxProc = New System.Windows.Forms.TextBox
        Me.Label66 = New System.Windows.Forms.Label
        Me.btnDelTaxID = New System.Windows.Forms.Button
        Me.btnEditTaxID = New System.Windows.Forms.Button
        Me.btnAddTaxID = New System.Windows.Forms.Button
        Me.lboxTaxID = New System.Windows.Forms.ListBox
        Me.Label65 = New System.Windows.Forms.Label
        Me.btnDelTaxIDRef = New System.Windows.Forms.Button
        Me.btnEditTaxIDRef = New System.Windows.Forms.Button
        Me.btnAddTaxIDRef = New System.Windows.Forms.Button
        Me.lboxTaxIDRef = New System.Windows.Forms.ListBox
        Me.Label64 = New System.Windows.Forms.Label
        Me.btnDelTaxSys = New System.Windows.Forms.Button
        Me.btnEditTaxSys = New System.Windows.Forms.Button
        Me.btnAddTaxSys = New System.Windows.Forms.Button
        Me.lboxTaxSys = New System.Windows.Forms.ListBox
        Me.Label63 = New System.Windows.Forms.Label
        Me.Label62 = New System.Windows.Forms.Label
        Me.Panel5 = New System.Windows.Forms.Panel
        Me.btnDelTaxKey = New System.Windows.Forms.Button
        Me.btnEditTaxKey = New System.Windows.Forms.Button
        Me.btnAddTaxKey = New System.Windows.Forms.Button
        Me.lboxTaxKey = New System.Windows.Forms.ListBox
        Me.Label61 = New System.Windows.Forms.Label
        Me.tpAccess = New System.Windows.Forms.TabPage
        Me.txtIDaccess = New System.Windows.Forms.TextBox
        Me.txtIDuse = New System.Windows.Forms.TextBox
        Me.Panel4 = New System.Windows.Forms.Panel
        Me.txtDataSecDesc = New System.Windows.Forms.TextBox
        Me.Label55 = New System.Windows.Forms.Label
        Me.cboxDataSecClass = New System.Windows.Forms.ComboBox
        Me.Label53 = New System.Windows.Forms.Label
        Me.txtDataSecSys = New System.Windows.Forms.TextBox
        Me.Label54 = New System.Windows.Forms.Label
        Me.Label52 = New System.Windows.Forms.Label
        Me.btnDataContact = New System.Windows.Forms.Button
        Me.txtDataContact = New System.Windows.Forms.TextBox
        Me.Label51 = New System.Windows.Forms.Label
        Me.Label49 = New System.Windows.Forms.Label
        Me.Label50 = New System.Windows.Forms.Label
        Me.Label48 = New System.Windows.Forms.Label
        Me.Label47 = New System.Windows.Forms.Label
        Me.tpTool = New System.Windows.Forms.TabPage
        Me.btnToolDelete = New System.Windows.Forms.Button
        Me.btnToolEdit = New System.Windows.Forms.Button
        Me.btnToolAdd = New System.Windows.Forms.Button
        Me.lboxTool = New System.Windows.Forms.ListBox
        Me.Label60 = New System.Windows.Forms.Label
        Me.TextBox5 = New System.Windows.Forms.TextBox
        Me.tpIDmisc = New System.Windows.Forms.TabPage
        Me.btnXRefDelete = New System.Windows.Forms.Button
        Me.btnXRefEdit = New System.Windows.Forms.Button
        Me.btnXRefAdd = New System.Windows.Forms.Button
        Me.lboxXRef = New System.Windows.Forms.ListBox
        Me.Label58 = New System.Windows.Forms.Label
        Me.txtDSenviron = New System.Windows.Forms.TextBox
        Me.Label59 = New System.Windows.Forms.Label
        Me.btnGraphicDelete = New System.Windows.Forms.Button
        Me.btnGraphicEdit = New System.Windows.Forms.Button
        Me.btnGraphicAdd = New System.Windows.Forms.Button
        Me.lboxBrGraphic = New System.Windows.Forms.ListBox
        Me.Label57 = New System.Windows.Forms.Label
        Me.txtDScredit = New System.Windows.Forms.TextBox
        Me.Label56 = New System.Windows.Forms.Label
        Me.ImageList1 = New System.Windows.Forms.ImageList(Me.components)
        Me.tabSection2 = New System.Windows.Forms.TabPage
        Me.tabQuality = New System.Windows.Forms.TabControl
        Me.tpDQattrib = New System.Windows.Forms.TabPage
        Me.btnDelAttribAcc = New System.Windows.Forms.Button
        Me.btnEditAttribAcc = New System.Windows.Forms.Button
        Me.btnAddAttribAcc = New System.Windows.Forms.Button
        Me.lboxAttribAcc = New System.Windows.Forms.ListBox
        Me.Label85 = New System.Windows.Forms.Label
        Me.TextBox10 = New System.Windows.Forms.TextBox
        Me.txtAttribAcc = New System.Windows.Forms.TextBox
        Me.Label84 = New System.Windows.Forms.Label
        Me.tpDQlogic = New System.Windows.Forms.TabPage
        Me.TextBox9 = New System.Windows.Forms.TextBox
        Me.TextBox8 = New System.Windows.Forms.TextBox
        Me.txtComplete = New System.Windows.Forms.TextBox
        Me.Label83 = New System.Windows.Forms.Label
        Me.txtLogic = New System.Windows.Forms.TextBox
        Me.Label82 = New System.Windows.Forms.Label
        Me.tpDQposit = New System.Windows.Forms.TabPage
        Me.Panel18 = New System.Windows.Forms.Panel
        Me.btnDelVPosAcc = New System.Windows.Forms.Button
        Me.btnEditVPosAcc = New System.Windows.Forms.Button
        Me.btnAddVPosAcc = New System.Windows.Forms.Button
        Me.lboxVPosAcc = New System.Windows.Forms.ListBox
        Me.Label89 = New System.Windows.Forms.Label
        Me.TextBox12 = New System.Windows.Forms.TextBox
        Me.txtVertAccRpt = New System.Windows.Forms.TextBox
        Me.Label90 = New System.Windows.Forms.Label
        Me.Label91 = New System.Windows.Forms.Label
        Me.Panel17 = New System.Windows.Forms.Panel
        Me.btnDelHPosAcc = New System.Windows.Forms.Button
        Me.btnEditHPosAcc = New System.Windows.Forms.Button
        Me.btnAddHPosAcc = New System.Windows.Forms.Button
        Me.lboxHPosAcc = New System.Windows.Forms.ListBox
        Me.Label88 = New System.Windows.Forms.Label
        Me.TextBox11 = New System.Windows.Forms.TextBox
        Me.txtHorAccRpt = New System.Windows.Forms.TextBox
        Me.Label87 = New System.Windows.Forms.Label
        Me.Label86 = New System.Windows.Forms.Label
        Me.tpDQlineage = New System.Windows.Forms.TabPage
        Me.TextBox15 = New System.Windows.Forms.TextBox
        Me.TextBox14 = New System.Windows.Forms.TextBox
        Me.TextBox13 = New System.Windows.Forms.TextBox
        Me.btnDelProc = New System.Windows.Forms.Button
        Me.btnEditProc = New System.Windows.Forms.Button
        Me.btnAddProc = New System.Windows.Forms.Button
        Me.lboxProcess = New System.Windows.Forms.ListBox
        Me.Label94 = New System.Windows.Forms.Label
        Me.btnDelSource = New System.Windows.Forms.Button
        Me.btnEditSource = New System.Windows.Forms.Button
        Me.btnAddSource = New System.Windows.Forms.Button
        Me.lboxLinSource = New System.Windows.Forms.ListBox
        Me.Label93 = New System.Windows.Forms.Label
        Me.btnDelMeth = New System.Windows.Forms.Button
        Me.btnEditMeth = New System.Windows.Forms.Button
        Me.btnAddMeth = New System.Windows.Forms.Button
        Me.lboxMeth = New System.Windows.Forms.ListBox
        Me.Label92 = New System.Windows.Forms.Label
        Me.tpDQcloud = New System.Windows.Forms.TabPage
        Me.TextBox7 = New System.Windows.Forms.TextBox
        Me.pnlCloud = New System.Windows.Forms.Panel
        Me.numCloud = New System.Windows.Forms.NumericUpDown
        Me.Panel16 = New System.Windows.Forms.Panel
        Me.rdoCloud = New System.Windows.Forms.RadioButton
        Me.rdoCloudUnk = New System.Windows.Forms.RadioButton
        Me.rdoNoCloud = New System.Windows.Forms.RadioButton
        Me.Label80 = New System.Windows.Forms.Label
        Me.tabSection3 = New System.Windows.Forms.TabPage
        Me.tabSDO = New System.Windows.Forms.TabControl
        Me.tpSDOref = New System.Windows.Forms.TabPage
        Me.cboxDirect = New System.Windows.Forms.ComboBox
        Me.Label72 = New System.Windows.Forms.Label
        Me.txtIndirect = New System.Windows.Forms.TextBox
        Me.Label71 = New System.Windows.Forms.Label
        Me.tpSDOvector = New System.Windows.Forms.TabPage
        Me.Panel12 = New System.Windows.Forms.Panel
        Me.Panel15 = New System.Windows.Forms.Panel
        Me.cboxVPF = New System.Windows.Forms.ComboBox
        Me.Label81 = New System.Windows.Forms.Label
        Me.Panel14 = New System.Windows.Forms.Panel
        Me.btnDelTerm = New System.Windows.Forms.Button
        Me.btnEditTerm = New System.Windows.Forms.Button
        Me.btnAddTerm = New System.Windows.Forms.Button
        Me.lboxTerms = New System.Windows.Forms.ListBox
        Me.lblSDTS = New System.Windows.Forms.Label
        Me.Panel13 = New System.Windows.Forms.Panel
        Me.rdoVPF = New System.Windows.Forms.RadioButton
        Me.rdoSDTS = New System.Windows.Forms.RadioButton
        Me.rdoNoDesc = New System.Windows.Forms.RadioButton
        Me.Label79 = New System.Windows.Forms.Label
        Me.Label78 = New System.Windows.Forms.Label
        Me.lblVector = New System.Windows.Forms.Label
        Me.tpSDOraster = New System.Windows.Forms.TabPage
        Me.Panel10 = New System.Windows.Forms.Panel
        Me.cboxRasType = New System.Windows.Forms.ComboBox
        Me.Panel11 = New System.Windows.Forms.Panel
        Me.TextBox6 = New System.Windows.Forms.TextBox
        Me.numRasCol = New System.Windows.Forms.NumericUpDown
        Me.numRasRow = New System.Windows.Forms.NumericUpDown
        Me.numRasVert = New System.Windows.Forms.NumericUpDown
        Me.Label77 = New System.Windows.Forms.Label
        Me.Label76 = New System.Windows.Forms.Label
        Me.Label75 = New System.Windows.Forms.Label
        Me.Label74 = New System.Windows.Forms.Label
        Me.Label73 = New System.Windows.Forms.Label
        Me.lblRaster = New System.Windows.Forms.Label
        Me.tabSection4 = New System.Windows.Forms.TabPage
        Me.tabSR = New System.Windows.Forms.TabControl
        Me.tpSRhoriz = New System.Windows.Forms.TabPage
        Me.pnlGeodetic = New System.Windows.Forms.Panel
        Me.numFlatten = New System.Windows.Forms.NumericUpDown
        Me.Label128 = New System.Windows.Forms.Label
        Me.numSemiMajor = New System.Windows.Forms.NumericUpDown
        Me.Label127 = New System.Windows.Forms.Label
        Me.cboxEllipsoid = New System.Windows.Forms.ComboBox
        Me.Label126 = New System.Windows.Forms.Label
        Me.cboxHorizName = New System.Windows.Forms.ComboBox
        Me.Label125 = New System.Windows.Forms.Label
        Me.Label124 = New System.Windows.Forms.Label
        Me.pnlLocal = New System.Windows.Forms.Panel
        Me.txtLocalGeoInfo = New System.Windows.Forms.TextBox
        Me.Label123 = New System.Windows.Forms.Label
        Me.txtLocalDesc = New System.Windows.Forms.TextBox
        Me.Label122 = New System.Windows.Forms.Label
        Me.Label121 = New System.Windows.Forms.Label
        Me.pnlPlanar = New System.Windows.Forms.Panel
        Me.btnDelPlanar = New System.Windows.Forms.Button
        Me.btnEditPlanar = New System.Windows.Forms.Button
        Me.btnAddPlanar = New System.Windows.Forms.Button
        Me.lboxPlanar = New System.Windows.Forms.ListBox
        Me.Label119 = New System.Windows.Forms.Label
        Me.pnlGeographic = New System.Windows.Forms.Panel
        Me.Label120 = New System.Windows.Forms.Label
        Me.cboxGeoCoorUnits = New System.Windows.Forms.ComboBox
        Me.Label118 = New System.Windows.Forms.Label
        Me.numLongRes = New System.Windows.Forms.NumericUpDown
        Me.Label117 = New System.Windows.Forms.Label
        Me.numLatRes = New System.Windows.Forms.NumericUpDown
        Me.Label116 = New System.Windows.Forms.Label
        Me.pnlHoriz = New System.Windows.Forms.Panel
        Me.rdoNone = New System.Windows.Forms.RadioButton
        Me.rdoLocal = New System.Windows.Forms.RadioButton
        Me.rdoPlanar = New System.Windows.Forms.RadioButton
        Me.rdoGeographic = New System.Windows.Forms.RadioButton
        Me.Label115 = New System.Windows.Forms.Label
        Me.tpSRvert = New System.Windows.Forms.TabPage
        Me.pnlDepth = New System.Windows.Forms.Panel
        Me.cboxDepthEncode = New System.Windows.Forms.ComboBox
        Me.Label112 = New System.Windows.Forms.Label
        Me.cboxDepthUnits = New System.Windows.Forms.ComboBox
        Me.Label113 = New System.Windows.Forms.Label
        Me.btnClrDepthRes = New System.Windows.Forms.Button
        Me.btnAddDepth = New System.Windows.Forms.Button
        Me.numDepthRes = New System.Windows.Forms.NumericUpDown
        Me.txtDepthRes = New System.Windows.Forms.TextBox
        Me.Label114 = New System.Windows.Forms.Label
        Me.cboxDepthDatum = New System.Windows.Forms.ComboBox
        Me.Label108 = New System.Windows.Forms.Label
        Me.Label106 = New System.Windows.Forms.Label
        Me.pnlAltitude = New System.Windows.Forms.Panel
        Me.cboxAltEncode = New System.Windows.Forms.ComboBox
        Me.Label111 = New System.Windows.Forms.Label
        Me.cboxAltUnits = New System.Windows.Forms.ComboBox
        Me.Label110 = New System.Windows.Forms.Label
        Me.btnClearAltRes = New System.Windows.Forms.Button
        Me.btnAddAltRes = New System.Windows.Forms.Button
        Me.numAltRes = New System.Windows.Forms.NumericUpDown
        Me.txtAltRes = New System.Windows.Forms.TextBox
        Me.Label109 = New System.Windows.Forms.Label
        Me.cboxAltDatum = New System.Windows.Forms.ComboBox
        Me.Label107 = New System.Windows.Forms.Label
        Me.Label105 = New System.Windows.Forms.Label
        Me.tabSection5 = New System.Windows.Forms.TabPage
        Me.tabEA = New System.Windows.Forms.TabControl
        Me.tpEAdetail = New System.Windows.Forms.TabPage
        Me.Panel19 = New System.Windows.Forms.Panel
        Me.lblEAroot = New System.Windows.Forms.Label
        Me.TextBox18 = New System.Windows.Forms.TextBox
        Me.btnClearElem = New System.Windows.Forms.Button
        Me.btnDelLink = New System.Windows.Forms.Button
        Me.btnCrLink = New System.Windows.Forms.Button
        Me.btnViewLinks = New System.Windows.Forms.Button
        Me.txtEAbranch = New System.Windows.Forms.TextBox
        Me.Label103 = New System.Windows.Forms.Label
        Me.Label102 = New System.Windows.Forms.Label
        Me.btnSelDomain = New System.Windows.Forms.Button
        Me.btnSelAttrib = New System.Windows.Forms.Button
        Me.btnSelEntity = New System.Windows.Forms.Button
        Me.Label101 = New System.Windows.Forms.Label
        Me.Label100 = New System.Windows.Forms.Label
        Me.btnEAdomainDel = New System.Windows.Forms.Button
        Me.btnEAdomainEdit = New System.Windows.Forms.Button
        Me.btnEAdomainAdd = New System.Windows.Forms.Button
        Me.cboxDomains = New System.Windows.Forms.ComboBox
        Me.Label99 = New System.Windows.Forms.Label
        Me.btnEAattribDel = New System.Windows.Forms.Button
        Me.btnEAattribEdit = New System.Windows.Forms.Button
        Me.btnEAattribAdd = New System.Windows.Forms.Button
        Me.cboxAttrib = New System.Windows.Forms.ComboBox
        Me.Label98 = New System.Windows.Forms.Label
        Me.cboxEntity = New System.Windows.Forms.ComboBox
        Me.Label95 = New System.Windows.Forms.Label
        Me.btnDelEDetl = New System.Windows.Forms.Button
        Me.btnEditEDtl = New System.Windows.Forms.Button
        Me.btnAddEDtl = New System.Windows.Forms.Button
        Me.Label97 = New System.Windows.Forms.Label
        Me.tpEAover = New System.Windows.Forms.TabPage
        Me.btnDelEOver = New System.Windows.Forms.Button
        Me.btnEditEOver = New System.Windows.Forms.Button
        Me.btnAddEOver = New System.Windows.Forms.Button
        Me.lboxOverView = New System.Windows.Forms.ListBox
        Me.Label96 = New System.Windows.Forms.Label
        Me.tpEAinfo = New System.Windows.Forms.TabPage
        Me.TextBox17 = New System.Windows.Forms.TextBox
        Me.TextBox16 = New System.Windows.Forms.TextBox
        Me.tabSection6 = New System.Windows.Forms.TabPage
        Me.tabDI = New System.Windows.Forms.TabControl
        Me.tpDImain = New System.Windows.Forms.TabPage
        Me.btnDelDistrib = New System.Windows.Forms.Button
        Me.btnEditDistrib = New System.Windows.Forms.Button
        Me.btnAddDistrib = New System.Windows.Forms.Button
        Me.lboxDistrib = New System.Windows.Forms.ListBox
        Me.Label104 = New System.Windows.Forms.Label
        Me.tpDIinfo = New System.Windows.Forms.TabPage
        Me.TextBox20 = New System.Windows.Forms.TextBox
        Me.tabSection7 = New System.Windows.Forms.TabPage
        Me.tabMRef = New System.Windows.Forms.TabControl
        Me.tpMRinfo = New System.Windows.Forms.TabPage
        Me.chkFRevDate = New System.Windows.Forms.CheckBox
        Me.chkRevDate = New System.Windows.Forms.CheckBox
        Me.Label26 = New System.Windows.Forms.Label
        Me.Label23 = New System.Windows.Forms.Label
        Me.btnMRedit = New System.Windows.Forms.Button
        Me.txtMRcontact = New System.Windows.Forms.TextBox
        Me.Label20 = New System.Windows.Forms.Label
        Me.TextBox2 = New System.Windows.Forms.TextBox
        Me.TextBox1 = New System.Windows.Forms.TextBox
        Me.cboxStdVer = New System.Windows.Forms.ComboBox
        Me.Label22 = New System.Windows.Forms.Label
        Me.cboxStdName = New System.Windows.Forms.ComboBox
        Me.Label21 = New System.Windows.Forms.Label
        Me.dtPick1 = New System.Windows.Forms.DateTimePicker
        Me.Label19 = New System.Windows.Forms.Label
        Me.dtPick2 = New System.Windows.Forms.DateTimePicker
        Me.Label24 = New System.Windows.Forms.Label
        Me.dtPick3 = New System.Windows.Forms.DateTimePicker
        Me.Label25 = New System.Windows.Forms.Label
        Me.tpMRext = New System.Windows.Forms.TabPage
        Me.TextBox3 = New System.Windows.Forms.TextBox
        Me.tpMRuse = New System.Windows.Forms.TabPage
        Me.Panel3 = New System.Windows.Forms.Panel
        Me.txtMRSecDesc = New System.Windows.Forms.TextBox
        Me.Label31 = New System.Windows.Forms.Label
        Me.cboxMRClass = New System.Windows.Forms.ComboBox
        Me.Label30 = New System.Windows.Forms.Label
        Me.txtMRClassSys = New System.Windows.Forms.TextBox
        Me.Label29 = New System.Windows.Forms.Label
        Me.TextBox4 = New System.Windows.Forms.TextBox
        Me.txtMRuse = New System.Windows.Forms.TextBox
        Me.Label28 = New System.Windows.Forms.Label
        Me.txtMRaccess = New System.Windows.Forms.TextBox
        Me.Label27 = New System.Windows.Forms.Label
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.SaveFileDialog1 = New System.Windows.Forms.SaveFileDialog
        Me.OpenFileDialog1 = New System.Windows.Forms.OpenFileDialog
        Me.SaveHTMLDialog = New System.Windows.Forms.SaveFileDialog
        Me.SaveTaxonDialog = New System.Windows.Forms.SaveFileDialog
        Me.OpenTaxonFileDialog = New System.Windows.Forms.OpenFileDialog
        Me.tabMainSection.SuspendLayout()
        Me.tabSection1.SuspendLayout()
        Me.tabID.SuspendLayout()
        Me.tpIDRef.SuspendLayout()
        Me.pnlStatus.SuspendLayout()
        Me.pnlTime.SuspendLayout()
        Me.Panel2.SuspendLayout()
        Me.Panel1.SuspendLayout()
        Me.pnlDesc.SuspendLayout()
        Me.pnlCitation.SuspendLayout()
        Me.tpSpDomain.SuspendLayout()
        CType(Me.numAltMax, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.numAltMin, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.numSouthBC, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.numNorthBC, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.numEastBC, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.numWestBC, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.tpKeywords.SuspendLayout()
        Me.tbTaxonomy.SuspendLayout()
        Me.Panel8.SuspendLayout()
        Me.Panel6.SuspendLayout()
        Me.Panel5.SuspendLayout()
        Me.tpAccess.SuspendLayout()
        Me.Panel4.SuspendLayout()
        Me.tpTool.SuspendLayout()
        Me.tpIDmisc.SuspendLayout()
        Me.tabSection2.SuspendLayout()
        Me.tabQuality.SuspendLayout()
        Me.tpDQattrib.SuspendLayout()
        Me.tpDQlogic.SuspendLayout()
        Me.tpDQposit.SuspendLayout()
        Me.Panel18.SuspendLayout()
        Me.Panel17.SuspendLayout()
        Me.tpDQlineage.SuspendLayout()
        Me.tpDQcloud.SuspendLayout()
        Me.pnlCloud.SuspendLayout()
        CType(Me.numCloud, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.Panel16.SuspendLayout()
        Me.tabSection3.SuspendLayout()
        Me.tabSDO.SuspendLayout()
        Me.tpSDOref.SuspendLayout()
        Me.tpSDOvector.SuspendLayout()
        Me.Panel12.SuspendLayout()
        Me.Panel15.SuspendLayout()
        Me.Panel14.SuspendLayout()
        Me.Panel13.SuspendLayout()
        Me.tpSDOraster.SuspendLayout()
        Me.Panel10.SuspendLayout()
        Me.Panel11.SuspendLayout()
        CType(Me.numRasCol, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.numRasRow, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.numRasVert, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.tabSection4.SuspendLayout()
        Me.tabSR.SuspendLayout()
        Me.tpSRhoriz.SuspendLayout()
        Me.pnlGeodetic.SuspendLayout()
        CType(Me.numFlatten, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.numSemiMajor, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.pnlLocal.SuspendLayout()
        Me.pnlPlanar.SuspendLayout()
        Me.pnlGeographic.SuspendLayout()
        CType(Me.numLongRes, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.numLatRes, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.pnlHoriz.SuspendLayout()
        Me.tpSRvert.SuspendLayout()
        Me.pnlDepth.SuspendLayout()
        CType(Me.numDepthRes, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.pnlAltitude.SuspendLayout()
        CType(Me.numAltRes, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.tabSection5.SuspendLayout()
        Me.tabEA.SuspendLayout()
        Me.tpEAdetail.SuspendLayout()
        Me.Panel19.SuspendLayout()
        Me.tpEAover.SuspendLayout()
        Me.tpEAinfo.SuspendLayout()
        Me.tabSection6.SuspendLayout()
        Me.tabDI.SuspendLayout()
        Me.tpDImain.SuspendLayout()
        Me.tpDIinfo.SuspendLayout()
        Me.tabSection7.SuspendLayout()
        Me.tabMRef.SuspendLayout()
        Me.tpMRinfo.SuspendLayout()
        Me.tpMRext.SuspendLayout()
        Me.tpMRuse.SuspendLayout()
        Me.Panel3.SuspendLayout()
        Me.SuspendLayout()
        '
        'tabMainSection
        '
        Me.tabMainSection.Controls.Add(Me.tabSection1)
        Me.tabMainSection.Controls.Add(Me.tabSection2)
        Me.tabMainSection.Controls.Add(Me.tabSection3)
        Me.tabMainSection.Controls.Add(Me.tabSection4)
        Me.tabMainSection.Controls.Add(Me.tabSection5)
        Me.tabMainSection.Controls.Add(Me.tabSection6)
        Me.tabMainSection.Controls.Add(Me.tabSection7)
        Me.tabMainSection.Dock = System.Windows.Forms.DockStyle.Fill
        Me.tabMainSection.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.tabMainSection.Location = New System.Drawing.Point(0, 0)
        Me.tabMainSection.Name = "tabMainSection"
        Me.tabMainSection.SelectedIndex = 0
        Me.tabMainSection.Size = New System.Drawing.Size(744, 460)
        Me.tabMainSection.TabIndex = 0
        '
        'tabSection1
        '
        Me.tabSection1.Controls.Add(Me.tabID)
        Me.tabSection1.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.tabSection1.Location = New System.Drawing.Point(4, 24)
        Me.tabSection1.Name = "tabSection1"
        Me.tabSection1.Size = New System.Drawing.Size(736, 432)
        Me.tabSection1.TabIndex = 0
        Me.tabSection1.Text = "Identification"
        '
        'tabID
        '
        Me.tabID.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.tabID.Controls.Add(Me.tpIDRef)
        Me.tabID.Controls.Add(Me.tpSpDomain)
        Me.tabID.Controls.Add(Me.tpKeywords)
        Me.tabID.Controls.Add(Me.tbTaxonomy)
        Me.tabID.Controls.Add(Me.tpAccess)
        Me.tabID.Controls.Add(Me.tpTool)
        Me.tabID.Controls.Add(Me.tpIDmisc)
        Me.tabID.ImageList = Me.ImageList1
        Me.tabID.Location = New System.Drawing.Point(0, 0)
        Me.tabID.Name = "tabID"
        Me.tabID.SelectedIndex = 0
        Me.tabID.Size = New System.Drawing.Size(738, 434)
        Me.tabID.TabIndex = 0
        '
        'tpIDRef
        '
        Me.tpIDRef.AutoScroll = True
        Me.tpIDRef.Controls.Add(Me.TextBox19)
        Me.tpIDRef.Controls.Add(Me.pnlStatus)
        Me.tpIDRef.Controls.Add(Me.Label14)
        Me.tpIDRef.Controls.Add(Me.pnlTime)
        Me.tpIDRef.Controls.Add(Me.pnlDesc)
        Me.tpIDRef.Controls.Add(Me.pnlCitation)
        Me.tpIDRef.ImageIndex = 8
        Me.tpIDRef.Location = New System.Drawing.Point(4, 23)
        Me.tpIDRef.Name = "tpIDRef"
        Me.tpIDRef.Size = New System.Drawing.Size(730, 407)
        Me.tpIDRef.TabIndex = 0
        Me.tpIDRef.Text = "Basic Info"
        '
        'TextBox19
        '
        Me.TextBox19.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.TextBox19.Location = New System.Drawing.Point(440, 432)
        Me.TextBox19.Multiline = True
        Me.TextBox19.Name = "TextBox19"
        Me.TextBox19.ReadOnly = True
        Me.TextBox19.Size = New System.Drawing.Size(256, 224)
        Me.TextBox19.TabIndex = 5
        Me.TextBox19.TabStop = False
        Me.TextBox19.Text = resources.GetString("TextBox19.Text")
        '
        'pnlStatus
        '
        Me.pnlStatus.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.pnlStatus.Controls.Add(Me.cboxUpdate)
        Me.pnlStatus.Controls.Add(Me.Label18)
        Me.pnlStatus.Controls.Add(Me.lboxProg)
        Me.pnlStatus.Controls.Add(Me.Label17)
        Me.pnlStatus.Controls.Add(Me.Label16)
        Me.pnlStatus.Location = New System.Drawing.Point(8, 696)
        Me.pnlStatus.Name = "pnlStatus"
        Me.pnlStatus.Size = New System.Drawing.Size(464, 96)
        Me.pnlStatus.TabIndex = 4
        '
        'cboxUpdate
        '
        Me.cboxUpdate.Items.AddRange(New Object() {"Continually", "Daily", "Weekly", "Monthly", "Annually", "As needed", "None planned", "Unknown", "Irregular"})
        Me.cboxUpdate.Location = New System.Drawing.Point(248, 40)
        Me.cboxUpdate.Name = "cboxUpdate"
        Me.cboxUpdate.Size = New System.Drawing.Size(200, 21)
        Me.cboxUpdate.TabIndex = 4
        Me.ToolTip1.SetToolTip(Me.cboxUpdate, "How often is the data set updated?")
        '
        'Label18
        '
        Me.Label18.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label18.Location = New System.Drawing.Point(184, 40)
        Me.Label18.Name = "Label18"
        Me.Label18.Size = New System.Drawing.Size(64, 23)
        Me.Label18.TabIndex = 3
        Me.Label18.Text = "Updating"
        '
        'lboxProg
        '
        Me.lboxProg.Items.AddRange(New Object() {"Planned", "In work", "Complete"})
        Me.lboxProg.Location = New System.Drawing.Point(72, 40)
        Me.lboxProg.Name = "lboxProg"
        Me.lboxProg.Size = New System.Drawing.Size(88, 43)
        Me.lboxProg.TabIndex = 2
        Me.ToolTip1.SetToolTip(Me.lboxProg, "Select status of data set")
        '
        'Label17
        '
        Me.Label17.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label17.Location = New System.Drawing.Point(8, 40)
        Me.Label17.Name = "Label17"
        Me.Label17.Size = New System.Drawing.Size(64, 23)
        Me.Label17.TabIndex = 1
        Me.Label17.Text = "Progress"
        '
        'Label16
        '
        Me.Label16.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label16.Location = New System.Drawing.Point(158, 0)
        Me.Label16.Name = "Label16"
        Me.Label16.Size = New System.Drawing.Size(64, 23)
        Me.Label16.TabIndex = 0
        Me.Label16.Text = "Status"
        Me.Label16.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label14
        '
        Me.Label14.Location = New System.Drawing.Point(456, 792)
        Me.Label14.Name = "Label14"
        Me.Label14.Size = New System.Drawing.Size(100, 16)
        Me.Label14.TabIndex = 3
        '
        'pnlTime
        '
        Me.pnlTime.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.pnlTime.Controls.Add(Me.cboxCurRef)
        Me.pnlTime.Controls.Add(Me.Label12)
        Me.pnlTime.Controls.Add(Me.btnTimeDelete)
        Me.pnlTime.Controls.Add(Me.btnTimeEdit)
        Me.pnlTime.Controls.Add(Me.btnTimeAdd)
        Me.pnlTime.Controls.Add(Me.lboxTime)
        Me.pnlTime.Controls.Add(Me.Label15)
        Me.pnlTime.Controls.Add(Me.Panel2)
        Me.pnlTime.Controls.Add(Me.Label13)
        Me.pnlTime.Controls.Add(Me.Panel1)
        Me.pnlTime.Controls.Add(Me.Label11)
        Me.pnlTime.Controls.Add(Me.Label10)
        Me.pnlTime.Location = New System.Drawing.Point(8, 416)
        Me.pnlTime.Name = "pnlTime"
        Me.pnlTime.Size = New System.Drawing.Size(416, 264)
        Me.pnlTime.TabIndex = 2
        '
        'cboxCurRef
        '
        Me.cboxCurRef.Items.AddRange(New Object() {"ground condition", "observed", "publication date"})
        Me.cboxCurRef.Location = New System.Drawing.Point(144, 224)
        Me.cboxCurRef.Name = "cboxCurRef"
        Me.cboxCurRef.Size = New System.Drawing.Size(232, 21)
        Me.cboxCurRef.TabIndex = 12
        Me.ToolTip1.SetToolTip(Me.cboxCurRef, "basis for determining time period of content")
        '
        'Label12
        '
        Me.Label12.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label12.Location = New System.Drawing.Point(8, 224)
        Me.Label12.Name = "Label12"
        Me.Label12.Size = New System.Drawing.Size(136, 23)
        Me.Label12.TabIndex = 11
        Me.Label12.Text = "Currentness Reference"
        '
        'btnTimeDelete
        '
        Me.btnTimeDelete.Location = New System.Drawing.Point(304, 176)
        Me.btnTimeDelete.Name = "btnTimeDelete"
        Me.btnTimeDelete.Size = New System.Drawing.Size(64, 23)
        Me.btnTimeDelete.TabIndex = 10
        Me.btnTimeDelete.Text = "Delete"
        '
        'btnTimeEdit
        '
        Me.btnTimeEdit.Location = New System.Drawing.Point(224, 176)
        Me.btnTimeEdit.Name = "btnTimeEdit"
        Me.btnTimeEdit.Size = New System.Drawing.Size(56, 23)
        Me.btnTimeEdit.TabIndex = 9
        Me.btnTimeEdit.Text = "Edit"
        '
        'btnTimeAdd
        '
        Me.btnTimeAdd.Location = New System.Drawing.Point(144, 176)
        Me.btnTimeAdd.Name = "btnTimeAdd"
        Me.btnTimeAdd.Size = New System.Drawing.Size(56, 23)
        Me.btnTimeAdd.TabIndex = 8
        Me.btnTimeAdd.Text = "Add"
        '
        'lboxTime
        '
        Me.lboxTime.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxTime.Location = New System.Drawing.Point(104, 160)
        Me.lboxTime.Name = "lboxTime"
        Me.lboxTime.Size = New System.Drawing.Size(280, 13)
        Me.lboxTime.TabIndex = 7
        '
        'Label15
        '
        Me.Label15.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label15.Location = New System.Drawing.Point(8, 154)
        Me.Label15.Name = "Label15"
        Me.Label15.Size = New System.Drawing.Size(96, 23)
        Me.Label15.TabIndex = 6
        Me.Label15.Text = "Time Period(s):"
        Me.Label15.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Panel2
        '
        Me.Panel2.Controls.Add(Me.rdoTUnknown)
        Me.Panel2.Controls.Add(Me.rdoTRange)
        Me.Panel2.Controls.Add(Me.rdoTMult)
        Me.Panel2.Controls.Add(Me.rdoTSingle)
        Me.Panel2.Location = New System.Drawing.Point(88, 32)
        Me.Panel2.Name = "Panel2"
        Me.Panel2.Size = New System.Drawing.Size(128, 112)
        Me.Panel2.TabIndex = 5
        '
        'rdoTUnknown
        '
        Me.rdoTUnknown.Checked = True
        Me.rdoTUnknown.Location = New System.Drawing.Point(8, 80)
        Me.rdoTUnknown.Name = "rdoTUnknown"
        Me.rdoTUnknown.Size = New System.Drawing.Size(88, 24)
        Me.rdoTUnknown.TabIndex = 3
        Me.rdoTUnknown.TabStop = True
        Me.rdoTUnknown.Text = "Unknown"
        '
        'rdoTRange
        '
        Me.rdoTRange.Location = New System.Drawing.Point(8, 56)
        Me.rdoTRange.Name = "rdoTRange"
        Me.rdoTRange.Size = New System.Drawing.Size(112, 24)
        Me.rdoTRange.TabIndex = 2
        Me.rdoTRange.Text = "A range of dates"
        '
        'rdoTMult
        '
        Me.rdoTMult.Location = New System.Drawing.Point(8, 32)
        Me.rdoTMult.Name = "rdoTMult"
        Me.rdoTMult.Size = New System.Drawing.Size(104, 24)
        Me.rdoTMult.TabIndex = 1
        Me.rdoTMult.Text = "Multiple dates"
        '
        'rdoTSingle
        '
        Me.rdoTSingle.Location = New System.Drawing.Point(8, 8)
        Me.rdoTSingle.Name = "rdoTSingle"
        Me.rdoTSingle.Size = New System.Drawing.Size(96, 24)
        Me.rdoTSingle.TabIndex = 0
        Me.rdoTSingle.Text = "A single date"
        '
        'Label13
        '
        Me.Label13.Location = New System.Drawing.Point(8, 40)
        Me.Label13.Name = "Label13"
        Me.Label13.Size = New System.Drawing.Size(80, 23)
        Me.Label13.TabIndex = 4
        Me.Label13.Text = "Data are from"
        Me.Label13.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Panel1
        '
        Me.Panel1.Controls.Add(Me.rdoTGeol)
        Me.Panel1.Controls.Add(Me.rdoTLocal)
        Me.Panel1.Location = New System.Drawing.Point(312, 32)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(96, 64)
        Me.Panel1.TabIndex = 2
        '
        'rdoTGeol
        '
        Me.rdoTGeol.Location = New System.Drawing.Point(8, 32)
        Me.rdoTGeol.Name = "rdoTGeol"
        Me.rdoTGeol.Size = New System.Drawing.Size(72, 24)
        Me.rdoTGeol.TabIndex = 1
        Me.rdoTGeol.Text = "Geologic"
        '
        'rdoTLocal
        '
        Me.rdoTLocal.Checked = True
        Me.rdoTLocal.Location = New System.Drawing.Point(8, 8)
        Me.rdoTLocal.Name = "rdoTLocal"
        Me.rdoTLocal.Size = New System.Drawing.Size(80, 24)
        Me.rdoTLocal.TabIndex = 0
        Me.rdoTLocal.TabStop = True
        Me.rdoTLocal.Text = "Gregorian"
        '
        'Label11
        '
        Me.Label11.ImageAlign = System.Drawing.ContentAlignment.TopCenter
        Me.Label11.Location = New System.Drawing.Point(224, 40)
        Me.Label11.Name = "Label11"
        Me.Label11.Size = New System.Drawing.Size(96, 23)
        Me.Label11.TabIndex = 1
        Me.Label11.Text = "The calendar is:"
        Me.Label11.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label10
        '
        Me.Label10.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label10.Location = New System.Drawing.Point(134, 8)
        Me.Label10.Name = "Label10"
        Me.Label10.Size = New System.Drawing.Size(144, 23)
        Me.Label10.TabIndex = 0
        Me.Label10.Text = "Time Period of Content"
        '
        'pnlDesc
        '
        Me.pnlDesc.AutoScroll = True
        Me.pnlDesc.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.pnlDesc.Controls.Add(Me.Panel20)
        Me.pnlDesc.Controls.Add(Me.Label6)
        Me.pnlDesc.Controls.Add(Me.txtPurpose)
        Me.pnlDesc.Controls.Add(Me.txtAbstract)
        Me.pnlDesc.Controls.Add(Me.Label2)
        Me.pnlDesc.Controls.Add(Me.Label1)
        Me.pnlDesc.Controls.Add(Me.Label3)
        Me.pnlDesc.Controls.Add(Me.Label5)
        Me.pnlDesc.Controls.Add(Me.txtSupplInfo)
        Me.pnlDesc.Location = New System.Drawing.Point(8, 160)
        Me.pnlDesc.Name = "pnlDesc"
        Me.pnlDesc.Size = New System.Drawing.Size(600, 240)
        Me.pnlDesc.TabIndex = 1
        '
        'Panel20
        '
        Me.Panel20.Location = New System.Drawing.Point(304, 432)
        Me.Panel20.Name = "Panel20"
        Me.Panel20.Size = New System.Drawing.Size(200, 10)
        Me.Panel20.TabIndex = 5
        '
        'Label6
        '
        Me.Label6.Location = New System.Drawing.Point(560, 183)
        Me.Label6.Name = "Label6"
        Me.Label6.Size = New System.Drawing.Size(16, 24)
        Me.Label6.TabIndex = 4
        '
        'txtPurpose
        '
        Me.txtPurpose.Location = New System.Drawing.Point(16, 168)
        Me.txtPurpose.Multiline = True
        Me.txtPurpose.Name = "txtPurpose"
        Me.txtPurpose.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtPurpose.Size = New System.Drawing.Size(544, 112)
        Me.txtPurpose.TabIndex = 3
        Me.ToolTip1.SetToolTip(Me.txtPurpose, "Why were the data collected?")
        '
        'txtAbstract
        '
        Me.txtAbstract.Location = New System.Drawing.Point(16, 24)
        Me.txtAbstract.Multiline = True
        Me.txtAbstract.Name = "txtAbstract"
        Me.txtAbstract.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtAbstract.Size = New System.Drawing.Size(544, 112)
        Me.txtAbstract.TabIndex = 2
        Me.ToolTip1.SetToolTip(Me.txtAbstract, "What's in the data set?")
        '
        'Label2
        '
        Me.Label2.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label2.Location = New System.Drawing.Point(16, 8)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(72, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Abstract"
        '
        'Label1
        '
        Me.Label1.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label1.Location = New System.Drawing.Point(223, -97)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(136, 41)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "Description of data set"
        '
        'Label3
        '
        Me.Label3.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label3.Location = New System.Drawing.Point(16, 152)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(56, 16)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Purpose"
        '
        'Label5
        '
        Me.Label5.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label5.Location = New System.Drawing.Point(16, 296)
        Me.Label5.Name = "Label5"
        Me.Label5.Size = New System.Drawing.Size(192, 16)
        Me.Label5.TabIndex = 2
        Me.Label5.Text = "Supplemental Information (optional)"
        '
        'txtSupplInfo
        '
        Me.txtSupplInfo.Location = New System.Drawing.Point(16, 312)
        Me.txtSupplInfo.Multiline = True
        Me.txtSupplInfo.Name = "txtSupplInfo"
        Me.txtSupplInfo.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtSupplInfo.Size = New System.Drawing.Size(544, 112)
        Me.txtSupplInfo.TabIndex = 3
        Me.ToolTip1.SetToolTip(Me.txtSupplInfo, "Other descriptive info")
        '
        'pnlCitation
        '
        Me.pnlCitation.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.pnlCitation.Controls.Add(Me.btnIDCite)
        Me.pnlCitation.Controls.Add(Me.txtIDCiteDate)
        Me.pnlCitation.Controls.Add(Me.txtIDCiteTitle)
        Me.pnlCitation.Controls.Add(Me.Label9)
        Me.pnlCitation.Controls.Add(Me.Label8)
        Me.pnlCitation.Controls.Add(Me.txtIDCiteAuth)
        Me.pnlCitation.Controls.Add(Me.Label7)
        Me.pnlCitation.Controls.Add(Me.Label4)
        Me.pnlCitation.Location = New System.Drawing.Point(8, 8)
        Me.pnlCitation.Name = "pnlCitation"
        Me.pnlCitation.Size = New System.Drawing.Size(656, 144)
        Me.pnlCitation.TabIndex = 0
        '
        'btnIDCite
        '
        Me.btnIDCite.Location = New System.Drawing.Point(528, 88)
        Me.btnIDCite.Name = "btnIDCite"
        Me.btnIDCite.Size = New System.Drawing.Size(75, 23)
        Me.btnIDCite.TabIndex = 7
        Me.btnIDCite.Text = "Edit Citation"
        '
        'txtIDCiteDate
        '
        Me.txtIDCiteDate.Location = New System.Drawing.Point(480, 48)
        Me.txtIDCiteDate.Name = "txtIDCiteDate"
        Me.txtIDCiteDate.ReadOnly = True
        Me.txtIDCiteDate.Size = New System.Drawing.Size(160, 20)
        Me.txtIDCiteDate.TabIndex = 6
        Me.txtIDCiteDate.TabStop = False
        Me.txtIDCiteDate.WordWrap = False
        '
        'txtIDCiteTitle
        '
        Me.txtIDCiteTitle.Location = New System.Drawing.Point(8, 104)
        Me.txtIDCiteTitle.Multiline = True
        Me.txtIDCiteTitle.Name = "txtIDCiteTitle"
        Me.txtIDCiteTitle.ReadOnly = True
        Me.txtIDCiteTitle.Size = New System.Drawing.Size(440, 20)
        Me.txtIDCiteTitle.TabIndex = 5
        Me.txtIDCiteTitle.TabStop = False
        '
        'Label9
        '
        Me.Label9.Location = New System.Drawing.Point(480, 32)
        Me.Label9.Name = "Label9"
        Me.Label9.Size = New System.Drawing.Size(100, 16)
        Me.Label9.TabIndex = 4
        Me.Label9.Text = "Publication Date"
        '
        'Label8
        '
        Me.Label8.Location = New System.Drawing.Point(8, 88)
        Me.Label8.Name = "Label8"
        Me.Label8.Size = New System.Drawing.Size(48, 16)
        Me.Label8.TabIndex = 3
        Me.Label8.Text = "Title"
        '
        'txtIDCiteAuth
        '
        Me.txtIDCiteAuth.AcceptsReturn = True
        Me.txtIDCiteAuth.Location = New System.Drawing.Point(8, 48)
        Me.txtIDCiteAuth.Multiline = True
        Me.txtIDCiteAuth.Name = "txtIDCiteAuth"
        Me.txtIDCiteAuth.ReadOnly = True
        Me.txtIDCiteAuth.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtIDCiteAuth.Size = New System.Drawing.Size(440, 20)
        Me.txtIDCiteAuth.TabIndex = 2
        Me.txtIDCiteAuth.TabStop = False
        '
        'Label7
        '
        Me.Label7.Location = New System.Drawing.Point(8, 32)
        Me.Label7.Name = "Label7"
        Me.Label7.Size = New System.Drawing.Size(100, 16)
        Me.Label7.TabIndex = 1
        Me.Label7.Text = "Author(s)"
        '
        'Label4
        '
        Me.Label4.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label4.Location = New System.Drawing.Point(259, 8)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(134, 23)
        Me.Label4.TabIndex = 0
        Me.Label4.Text = "Citation for the data set"
        '
        'tpSpDomain
        '
        Me.tpSpDomain.AutoScroll = True
        Me.tpSpDomain.Controls.Add(Me.numAltMax)
        Me.tpSpDomain.Controls.Add(Me.numAltMin)
        Me.tpSpDomain.Controls.Add(Me.numSouthBC)
        Me.tpSpDomain.Controls.Add(Me.numNorthBC)
        Me.tpSpDomain.Controls.Add(Me.numEastBC)
        Me.tpSpDomain.Controls.Add(Me.numWestBC)
        Me.tpSpDomain.Controls.Add(Me.btnDelPoly)
        Me.tpSpDomain.Controls.Add(Me.btnEditPoly)
        Me.tpSpDomain.Controls.Add(Me.btnAddPoly)
        Me.tpSpDomain.Controls.Add(Me.lboxGPoly)
        Me.tpSpDomain.Controls.Add(Me.Label42)
        Me.tpSpDomain.Controls.Add(Me.cboxIDaltDistU)
        Me.tpSpDomain.Controls.Add(Me.Label41)
        Me.tpSpDomain.Controls.Add(Me.Label40)
        Me.tpSpDomain.Controls.Add(Me.Label39)
        Me.tpSpDomain.Controls.Add(Me.Label38)
        Me.tpSpDomain.Controls.Add(Me.Label37)
        Me.tpSpDomain.Controls.Add(Me.Label36)
        Me.tpSpDomain.Controls.Add(Me.Label35)
        Me.tpSpDomain.Controls.Add(Me.Label34)
        Me.tpSpDomain.Controls.Add(Me.Label33)
        Me.tpSpDomain.Controls.Add(Me.txtGeoExt)
        Me.tpSpDomain.Controls.Add(Me.Label32)
        Me.tpSpDomain.ImageIndex = 9
        Me.tpSpDomain.Location = New System.Drawing.Point(4, 23)
        Me.tpSpDomain.Name = "tpSpDomain"
        Me.tpSpDomain.Size = New System.Drawing.Size(730, 407)
        Me.tpSpDomain.TabIndex = 1
        Me.tpSpDomain.Text = "Spatial Domain"
        '
        'numAltMax
        '
        Me.numAltMax.DecimalPlaces = 3
        Me.numAltMax.Location = New System.Drawing.Point(544, 272)
        Me.numAltMax.Maximum = New Decimal(New Integer() {1000000, 0, 0, 0})
        Me.numAltMax.Minimum = New Decimal(New Integer() {1000000, 0, 0, -2147483648})
        Me.numAltMax.Name = "numAltMax"
        Me.numAltMax.Size = New System.Drawing.Size(112, 20)
        Me.numAltMax.TabIndex = 15
        Me.numAltMax.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.ToolTip1.SetToolTip(Me.numAltMax, "real number > Alt min")
        '
        'numAltMin
        '
        Me.numAltMin.DecimalPlaces = 3
        Me.numAltMin.Location = New System.Drawing.Point(544, 232)
        Me.numAltMin.Maximum = New Decimal(New Integer() {1000000, 0, 0, 0})
        Me.numAltMin.Minimum = New Decimal(New Integer() {1000000, 0, 0, -2147483648})
        Me.numAltMin.Name = "numAltMin"
        Me.numAltMin.Size = New System.Drawing.Size(112, 20)
        Me.numAltMin.TabIndex = 13
        Me.numAltMin.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.ToolTip1.SetToolTip(Me.numAltMin, "real number < Alt Max")
        '
        'numSouthBC
        '
        Me.numSouthBC.DecimalPlaces = 5
        Me.numSouthBC.Location = New System.Drawing.Point(544, 160)
        Me.numSouthBC.Maximum = New Decimal(New Integer() {900, 0, 0, 65536})
        Me.numSouthBC.Minimum = New Decimal(New Integer() {900, 0, 0, -2147418112})
        Me.numSouthBC.Name = "numSouthBC"
        Me.numSouthBC.Size = New System.Drawing.Size(96, 20)
        Me.numSouthBC.TabIndex = 10
        Me.numSouthBC.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.ToolTip1.SetToolTip(Me.numSouthBC, "-90 <= x <= 90")
        '
        'numNorthBC
        '
        Me.numNorthBC.DecimalPlaces = 5
        Me.numNorthBC.Location = New System.Drawing.Point(544, 120)
        Me.numNorthBC.Maximum = New Decimal(New Integer() {900, 0, 0, 65536})
        Me.numNorthBC.Minimum = New Decimal(New Integer() {900, 0, 0, -2147418112})
        Me.numNorthBC.Name = "numNorthBC"
        Me.numNorthBC.Size = New System.Drawing.Size(96, 20)
        Me.numNorthBC.TabIndex = 9
        Me.numNorthBC.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.ToolTip1.SetToolTip(Me.numNorthBC, "-90 <= x <= 90")
        '
        'numEastBC
        '
        Me.numEastBC.DecimalPlaces = 5
        Me.numEastBC.Location = New System.Drawing.Point(544, 80)
        Me.numEastBC.Maximum = New Decimal(New Integer() {1800, 0, 0, 65536})
        Me.numEastBC.Minimum = New Decimal(New Integer() {1800, 0, 0, -2147418112})
        Me.numEastBC.Name = "numEastBC"
        Me.numEastBC.Size = New System.Drawing.Size(96, 20)
        Me.numEastBC.TabIndex = 8
        Me.numEastBC.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.ToolTip1.SetToolTip(Me.numEastBC, "-180 <= x <= 180")
        '
        'numWestBC
        '
        Me.numWestBC.DecimalPlaces = 5
        Me.numWestBC.Location = New System.Drawing.Point(544, 40)
        Me.numWestBC.Maximum = New Decimal(New Integer() {179999999, 0, 0, 393216})
        Me.numWestBC.Minimum = New Decimal(New Integer() {1800, 0, 0, -2147418112})
        Me.numWestBC.Name = "numWestBC"
        Me.numWestBC.Size = New System.Drawing.Size(96, 20)
        Me.numWestBC.TabIndex = 7
        Me.numWestBC.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.ToolTip1.SetToolTip(Me.numWestBC, "-180 <= x < 180")
        '
        'btnDelPoly
        '
        Me.btnDelPoly.Location = New System.Drawing.Point(224, 224)
        Me.btnDelPoly.Name = "btnDelPoly"
        Me.btnDelPoly.Size = New System.Drawing.Size(75, 40)
        Me.btnDelPoly.TabIndex = 22
        Me.btnDelPoly.Text = "Delete Polygon"
        '
        'btnEditPoly
        '
        Me.btnEditPoly.Location = New System.Drawing.Point(128, 224)
        Me.btnEditPoly.Name = "btnEditPoly"
        Me.btnEditPoly.Size = New System.Drawing.Size(75, 40)
        Me.btnEditPoly.TabIndex = 21
        Me.btnEditPoly.Text = "Edit Polygon"
        '
        'btnAddPoly
        '
        Me.btnAddPoly.Location = New System.Drawing.Point(32, 224)
        Me.btnAddPoly.Name = "btnAddPoly"
        Me.btnAddPoly.Size = New System.Drawing.Size(75, 40)
        Me.btnAddPoly.TabIndex = 20
        Me.btnAddPoly.Text = "Add Polygon"
        '
        'lboxGPoly
        '
        Me.lboxGPoly.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxGPoly.Location = New System.Drawing.Point(24, 184)
        Me.lboxGPoly.Name = "lboxGPoly"
        Me.lboxGPoly.ScrollAlwaysVisible = True
        Me.lboxGPoly.Size = New System.Drawing.Size(304, 26)
        Me.lboxGPoly.TabIndex = 19
        '
        'Label42
        '
        Me.Label42.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label42.Location = New System.Drawing.Point(24, 168)
        Me.Label42.Name = "Label42"
        Me.Label42.Size = New System.Drawing.Size(192, 24)
        Me.Label42.TabIndex = 18
        Me.Label42.Text = "Data Set G-Polygon(s)  (optional)"
        '
        'cboxIDaltDistU
        '
        Me.cboxIDaltDistU.Items.AddRange(New Object() {"meters", "feet"})
        Me.cboxIDaltDistU.Location = New System.Drawing.Point(576, 312)
        Me.cboxIDaltDistU.Name = "cboxIDaltDistU"
        Me.cboxIDaltDistU.Size = New System.Drawing.Size(96, 21)
        Me.cboxIDaltDistU.TabIndex = 17
        Me.ToolTip1.SetToolTip(Me.cboxIDaltDistU, "type in units if necessary")
        '
        'Label41
        '
        Me.Label41.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label41.Location = New System.Drawing.Point(440, 312)
        Me.Label41.Name = "Label41"
        Me.Label41.Size = New System.Drawing.Size(144, 16)
        Me.Label41.TabIndex = 16
        Me.Label41.Text = "Altitude Distance Units:"
        '
        'Label40
        '
        Me.Label40.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label40.Location = New System.Drawing.Point(440, 272)
        Me.Label40.Name = "Label40"
        Me.Label40.Size = New System.Drawing.Size(104, 16)
        Me.Label40.TabIndex = 14
        Me.Label40.Text = "Altitude Maximum:"
        '
        'Label39
        '
        Me.Label39.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label39.Location = New System.Drawing.Point(440, 232)
        Me.Label39.Name = "Label39"
        Me.Label39.Size = New System.Drawing.Size(104, 16)
        Me.Label39.TabIndex = 12
        Me.Label39.Text = "Altitude Minimum:"
        '
        'Label38
        '
        Me.Label38.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label38.Location = New System.Drawing.Point(440, 208)
        Me.Label38.Name = "Label38"
        Me.Label38.Size = New System.Drawing.Size(160, 23)
        Me.Label38.TabIndex = 11
        Me.Label38.Text = "Bounding Altitudes  (optional)"
        '
        'Label37
        '
        Me.Label37.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label37.Location = New System.Drawing.Point(440, 160)
        Me.Label37.Name = "Label37"
        Me.Label37.Size = New System.Drawing.Size(104, 16)
        Me.Label37.TabIndex = 6
        Me.Label37.Text = "South (latitude):"
        '
        'Label36
        '
        Me.Label36.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label36.Location = New System.Drawing.Point(440, 80)
        Me.Label36.Name = "Label36"
        Me.Label36.Size = New System.Drawing.Size(104, 16)
        Me.Label36.TabIndex = 5
        Me.Label36.Text = "East (longitude):"
        '
        'Label35
        '
        Me.Label35.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label35.Location = New System.Drawing.Point(440, 120)
        Me.Label35.Name = "Label35"
        Me.Label35.Size = New System.Drawing.Size(104, 16)
        Me.Label35.TabIndex = 4
        Me.Label35.Text = "North (latitude):"
        '
        'Label34
        '
        Me.Label34.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label34.Location = New System.Drawing.Point(440, 40)
        Me.Label34.Name = "Label34"
        Me.Label34.Size = New System.Drawing.Size(104, 16)
        Me.Label34.TabIndex = 3
        Me.Label34.Text = "West (longitude):"
        '
        'Label33
        '
        Me.Label33.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label33.Location = New System.Drawing.Point(440, 16)
        Me.Label33.Name = "Label33"
        Me.Label33.Size = New System.Drawing.Size(144, 23)
        Me.Label33.TabIndex = 2
        Me.Label33.Text = "Bounding Coordinates"
        '
        'txtGeoExt
        '
        Me.txtGeoExt.AcceptsReturn = True
        Me.txtGeoExt.Location = New System.Drawing.Point(24, 32)
        Me.txtGeoExt.Multiline = True
        Me.txtGeoExt.Name = "txtGeoExt"
        Me.txtGeoExt.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtGeoExt.Size = New System.Drawing.Size(360, 104)
        Me.txtGeoExt.TabIndex = 1
        Me.ToolTip1.SetToolTip(Me.txtGeoExt, "short description of the geographic areal domain of the data set")
        '
        'Label32
        '
        Me.Label32.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label32.Location = New System.Drawing.Point(24, 16)
        Me.Label32.Name = "Label32"
        Me.Label32.Size = New System.Drawing.Size(200, 23)
        Me.Label32.TabIndex = 0
        Me.Label32.Text = "Description of Geographic Extent"
        '
        'tpKeywords
        '
        Me.tpKeywords.AutoScroll = True
        Me.tpKeywords.Controls.Add(Me.Label46)
        Me.tpKeywords.Controls.Add(Me.btnTemporalDelete)
        Me.tpKeywords.Controls.Add(Me.btnTemporalEdit)
        Me.tpKeywords.Controls.Add(Me.btnTemporalAdd)
        Me.tpKeywords.Controls.Add(Me.lboxKTemporal)
        Me.tpKeywords.Controls.Add(Me.Label45)
        Me.tpKeywords.Controls.Add(Me.btnStratumDelete)
        Me.tpKeywords.Controls.Add(Me.btnStratumEdit)
        Me.tpKeywords.Controls.Add(Me.btnStratumAdd)
        Me.tpKeywords.Controls.Add(Me.lboxKStratum)
        Me.tpKeywords.Controls.Add(Me.btnPlaceDelete)
        Me.tpKeywords.Controls.Add(Me.btnPlaceEdit)
        Me.tpKeywords.Controls.Add(Me.btnPlaceAdd)
        Me.tpKeywords.Controls.Add(Me.lboxKPlace)
        Me.tpKeywords.Controls.Add(Me.btnThemeDelete)
        Me.tpKeywords.Controls.Add(Me.btnThemeEdit)
        Me.tpKeywords.Controls.Add(Me.btnThemeAdd)
        Me.tpKeywords.Controls.Add(Me.Label44)
        Me.tpKeywords.Controls.Add(Me.lboxKTheme)
        Me.tpKeywords.Controls.Add(Me.Label43)
        Me.tpKeywords.ImageIndex = 8
        Me.tpKeywords.Location = New System.Drawing.Point(4, 23)
        Me.tpKeywords.Name = "tpKeywords"
        Me.tpKeywords.Size = New System.Drawing.Size(730, 407)
        Me.tpKeywords.TabIndex = 2
        Me.tpKeywords.Text = "Keywords"
        '
        'Label46
        '
        Me.Label46.Location = New System.Drawing.Point(24, 264)
        Me.Label46.Name = "Label46"
        Me.Label46.Size = New System.Drawing.Size(56, 23)
        Me.Label46.TabIndex = 19
        Me.Label46.Text = "Temporal"
        '
        'btnTemporalDelete
        '
        Me.btnTemporalDelete.Location = New System.Drawing.Point(352, 296)
        Me.btnTemporalDelete.Name = "btnTemporalDelete"
        Me.btnTemporalDelete.Size = New System.Drawing.Size(75, 23)
        Me.btnTemporalDelete.TabIndex = 18
        Me.btnTemporalDelete.Text = "Delete"
        '
        'btnTemporalEdit
        '
        Me.btnTemporalEdit.Location = New System.Drawing.Point(248, 296)
        Me.btnTemporalEdit.Name = "btnTemporalEdit"
        Me.btnTemporalEdit.Size = New System.Drawing.Size(75, 23)
        Me.btnTemporalEdit.TabIndex = 17
        Me.btnTemporalEdit.Text = "Edit"
        '
        'btnTemporalAdd
        '
        Me.btnTemporalAdd.Location = New System.Drawing.Point(144, 296)
        Me.btnTemporalAdd.Name = "btnTemporalAdd"
        Me.btnTemporalAdd.Size = New System.Drawing.Size(75, 23)
        Me.btnTemporalAdd.TabIndex = 16
        Me.btnTemporalAdd.Text = "Add"
        '
        'lboxKTemporal
        '
        Me.lboxKTemporal.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxKTemporal.Location = New System.Drawing.Point(80, 264)
        Me.lboxKTemporal.Name = "lboxKTemporal"
        Me.lboxKTemporal.Size = New System.Drawing.Size(392, 26)
        Me.lboxKTemporal.TabIndex = 15
        Me.ToolTip1.SetToolTip(Me.lboxKTemporal, "name of a time period covered by the data set")
        '
        'Label45
        '
        Me.Label45.Location = New System.Drawing.Point(24, 184)
        Me.Label45.Name = "Label45"
        Me.Label45.Size = New System.Drawing.Size(48, 23)
        Me.Label45.TabIndex = 14
        Me.Label45.Text = "Stratum"
        '
        'btnStratumDelete
        '
        Me.btnStratumDelete.Location = New System.Drawing.Point(352, 216)
        Me.btnStratumDelete.Name = "btnStratumDelete"
        Me.btnStratumDelete.Size = New System.Drawing.Size(75, 23)
        Me.btnStratumDelete.TabIndex = 13
        Me.btnStratumDelete.Text = "Delete"
        '
        'btnStratumEdit
        '
        Me.btnStratumEdit.Location = New System.Drawing.Point(248, 216)
        Me.btnStratumEdit.Name = "btnStratumEdit"
        Me.btnStratumEdit.Size = New System.Drawing.Size(75, 23)
        Me.btnStratumEdit.TabIndex = 12
        Me.btnStratumEdit.Text = "Edit"
        '
        'btnStratumAdd
        '
        Me.btnStratumAdd.Location = New System.Drawing.Point(144, 216)
        Me.btnStratumAdd.Name = "btnStratumAdd"
        Me.btnStratumAdd.Size = New System.Drawing.Size(75, 23)
        Me.btnStratumAdd.TabIndex = 11
        Me.btnStratumAdd.Text = "Add"
        '
        'lboxKStratum
        '
        Me.lboxKStratum.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxKStratum.Location = New System.Drawing.Point(80, 184)
        Me.lboxKStratum.Name = "lboxKStratum"
        Me.lboxKStratum.Size = New System.Drawing.Size(392, 26)
        Me.lboxKStratum.TabIndex = 10
        Me.ToolTip1.SetToolTip(Me.lboxKStratum, "name of a vertical location used to describe the location covered by the data set" & _
                "")
        '
        'btnPlaceDelete
        '
        Me.btnPlaceDelete.Location = New System.Drawing.Point(352, 136)
        Me.btnPlaceDelete.Name = "btnPlaceDelete"
        Me.btnPlaceDelete.Size = New System.Drawing.Size(75, 23)
        Me.btnPlaceDelete.TabIndex = 9
        Me.btnPlaceDelete.Text = "Delete"
        '
        'btnPlaceEdit
        '
        Me.btnPlaceEdit.Location = New System.Drawing.Point(248, 136)
        Me.btnPlaceEdit.Name = "btnPlaceEdit"
        Me.btnPlaceEdit.Size = New System.Drawing.Size(75, 23)
        Me.btnPlaceEdit.TabIndex = 8
        Me.btnPlaceEdit.Text = "Edit"
        '
        'btnPlaceAdd
        '
        Me.btnPlaceAdd.Location = New System.Drawing.Point(144, 136)
        Me.btnPlaceAdd.Name = "btnPlaceAdd"
        Me.btnPlaceAdd.Size = New System.Drawing.Size(75, 23)
        Me.btnPlaceAdd.TabIndex = 7
        Me.btnPlaceAdd.Text = "Add"
        '
        'lboxKPlace
        '
        Me.lboxKPlace.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxKPlace.Location = New System.Drawing.Point(80, 104)
        Me.lboxKPlace.Name = "lboxKPlace"
        Me.lboxKPlace.Size = New System.Drawing.Size(392, 26)
        Me.lboxKPlace.TabIndex = 6
        Me.ToolTip1.SetToolTip(Me.lboxKPlace, "geographic name of a location covered by the data set")
        '
        'btnThemeDelete
        '
        Me.btnThemeDelete.Location = New System.Drawing.Point(352, 56)
        Me.btnThemeDelete.Name = "btnThemeDelete"
        Me.btnThemeDelete.Size = New System.Drawing.Size(75, 23)
        Me.btnThemeDelete.TabIndex = 5
        Me.btnThemeDelete.Text = "Delete"
        '
        'btnThemeEdit
        '
        Me.btnThemeEdit.Location = New System.Drawing.Point(248, 56)
        Me.btnThemeEdit.Name = "btnThemeEdit"
        Me.btnThemeEdit.Size = New System.Drawing.Size(75, 23)
        Me.btnThemeEdit.TabIndex = 4
        Me.btnThemeEdit.Text = "Edit"
        '
        'btnThemeAdd
        '
        Me.btnThemeAdd.Location = New System.Drawing.Point(144, 56)
        Me.btnThemeAdd.Name = "btnThemeAdd"
        Me.btnThemeAdd.Size = New System.Drawing.Size(75, 23)
        Me.btnThemeAdd.TabIndex = 3
        Me.btnThemeAdd.Text = "Add"
        '
        'Label44
        '
        Me.Label44.Location = New System.Drawing.Point(24, 104)
        Me.Label44.Name = "Label44"
        Me.Label44.Size = New System.Drawing.Size(48, 23)
        Me.Label44.TabIndex = 2
        Me.Label44.Text = "Place"
        '
        'lboxKTheme
        '
        Me.lboxKTheme.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxKTheme.Location = New System.Drawing.Point(80, 24)
        Me.lboxKTheme.Name = "lboxKTheme"
        Me.lboxKTheme.Size = New System.Drawing.Size(392, 26)
        Me.lboxKTheme.TabIndex = 1
        Me.ToolTip1.SetToolTip(Me.lboxKTheme, "word or phrase to describe the subject of the data set")
        '
        'Label43
        '
        Me.Label43.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label43.Location = New System.Drawing.Point(24, 26)
        Me.Label43.Name = "Label43"
        Me.Label43.Size = New System.Drawing.Size(56, 24)
        Me.Label43.TabIndex = 0
        Me.Label43.Text = "Theme"
        '
        'tbTaxonomy
        '
        Me.tbTaxonomy.AutoScroll = True
        Me.tbTaxonomy.Controls.Add(Me.Panel8)
        Me.tbTaxonomy.Controls.Add(Me.Panel6)
        Me.tbTaxonomy.Controls.Add(Me.Panel5)
        Me.tbTaxonomy.ImageIndex = 9
        Me.tbTaxonomy.Location = New System.Drawing.Point(4, 23)
        Me.tbTaxonomy.Name = "tbTaxonomy"
        Me.tbTaxonomy.Size = New System.Drawing.Size(730, 407)
        Me.tbTaxonomy.TabIndex = 3
        Me.tbTaxonomy.Text = "Taxonomy"
        '
        'Panel8
        '
        Me.Panel8.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.Panel8.AutoScroll = True
        Me.Panel8.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.Panel8.Controls.Add(Me.btnExpTaxa)
        Me.Panel8.Controls.Add(Me.btnImpTaxa)
        Me.Panel8.Controls.Add(Me.btnDelTaxRank)
        Me.Panel8.Controls.Add(Me.btnEditTaxRank)
        Me.Panel8.Controls.Add(Me.btnAddTaxRank)
        Me.Panel8.Controls.Add(Me.lboxLinneaus)
        Me.Panel8.Controls.Add(Me.Label70)
        Me.Panel8.Controls.Add(Me.Panel9)
        Me.Panel8.Controls.Add(Me.txtTaxCover)
        Me.Panel8.Controls.Add(Me.Label69)
        Me.Panel8.Location = New System.Drawing.Point(16, 104)
        Me.Panel8.Name = "Panel8"
        Me.Panel8.Size = New System.Drawing.Size(320, 288)
        Me.Panel8.TabIndex = 4
        '
        'btnExpTaxa
        '
        Me.btnExpTaxa.Location = New System.Drawing.Point(168, 256)
        Me.btnExpTaxa.Name = "btnExpTaxa"
        Me.btnExpTaxa.Size = New System.Drawing.Size(64, 24)
        Me.btnExpTaxa.TabIndex = 11
        Me.btnExpTaxa.Text = "Export"
        '
        'btnImpTaxa
        '
        Me.btnImpTaxa.Location = New System.Drawing.Point(72, 256)
        Me.btnImpTaxa.Name = "btnImpTaxa"
        Me.btnImpTaxa.Size = New System.Drawing.Size(72, 24)
        Me.btnImpTaxa.TabIndex = 10
        Me.btnImpTaxa.Text = "Import"
        Me.ToolTip1.SetToolTip(Me.btnImpTaxa, "Imports taxa XML from a file")
        '
        'btnDelTaxRank
        '
        Me.btnDelTaxRank.Location = New System.Drawing.Point(200, 224)
        Me.btnDelTaxRank.Name = "btnDelTaxRank"
        Me.btnDelTaxRank.Size = New System.Drawing.Size(64, 23)
        Me.btnDelTaxRank.TabIndex = 9
        Me.btnDelTaxRank.Text = "Delete"
        '
        'btnEditTaxRank
        '
        Me.btnEditTaxRank.Location = New System.Drawing.Point(128, 224)
        Me.btnEditTaxRank.Name = "btnEditTaxRank"
        Me.btnEditTaxRank.Size = New System.Drawing.Size(56, 23)
        Me.btnEditTaxRank.TabIndex = 8
        Me.btnEditTaxRank.Text = "Edit"
        '
        'btnAddTaxRank
        '
        Me.btnAddTaxRank.Location = New System.Drawing.Point(40, 224)
        Me.btnAddTaxRank.Name = "btnAddTaxRank"
        Me.btnAddTaxRank.Size = New System.Drawing.Size(72, 23)
        Me.btnAddTaxRank.TabIndex = 7
        Me.btnAddTaxRank.Text = "Add Child"
        '
        'lboxLinneaus
        '
        Me.lboxLinneaus.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxLinneaus.Location = New System.Drawing.Point(16, 24)
        Me.lboxLinneaus.Name = "lboxLinneaus"
        Me.lboxLinneaus.Size = New System.Drawing.Size(272, 195)
        Me.lboxLinneaus.TabIndex = 6
        Me.ToolTip1.SetToolTip(Me.lboxLinneaus, "Technical description of taxa addressed in the data set.")
        '
        'Label70
        '
        Me.Label70.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label70.Location = New System.Drawing.Point(76, 6)
        Me.Label70.Name = "Label70"
        Me.Label70.Size = New System.Drawing.Size(144, 23)
        Me.Label70.TabIndex = 5
        Me.Label70.Text = "Taxonomic Classification"
        '
        'Panel9
        '
        Me.Panel9.Location = New System.Drawing.Point(72, 432)
        Me.Panel9.Name = "Panel9"
        Me.Panel9.Size = New System.Drawing.Size(120, 16)
        Me.Panel9.TabIndex = 4
        '
        'txtTaxCover
        '
        Me.txtTaxCover.AcceptsReturn = True
        Me.txtTaxCover.Location = New System.Drawing.Point(8, 328)
        Me.txtTaxCover.Multiline = True
        Me.txtTaxCover.Name = "txtTaxCover"
        Me.txtTaxCover.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtTaxCover.Size = New System.Drawing.Size(280, 96)
        Me.txtTaxCover.TabIndex = 3
        Me.ToolTip1.SetToolTip(Me.txtTaxCover, "Written description of the range of taxa in the data set or collection.")
        '
        'Label69
        '
        Me.Label69.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label69.Location = New System.Drawing.Point(8, 312)
        Me.Label69.Name = "Label69"
        Me.Label69.Size = New System.Drawing.Size(224, 16)
        Me.Label69.TabIndex = 2
        Me.Label69.Text = "General Taxonomic Coverage (optional)"
        '
        'Panel6
        '
        Me.Panel6.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.Panel6.AutoScroll = True
        Me.Panel6.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.Panel6.Controls.Add(Me.btnDelVoucher)
        Me.Panel6.Controls.Add(Me.btnEditVoucher)
        Me.Panel6.Controls.Add(Me.btnAddVoucher)
        Me.Panel6.Controls.Add(Me.lboxVouchers)
        Me.Panel6.Controls.Add(Me.Label68)
        Me.Panel6.Controls.Add(Me.txtTaxComplete)
        Me.Panel6.Controls.Add(Me.Label67)
        Me.Panel6.Controls.Add(Me.Panel7)
        Me.Panel6.Controls.Add(Me.txtTaxProc)
        Me.Panel6.Controls.Add(Me.Label66)
        Me.Panel6.Controls.Add(Me.btnDelTaxID)
        Me.Panel6.Controls.Add(Me.btnEditTaxID)
        Me.Panel6.Controls.Add(Me.btnAddTaxID)
        Me.Panel6.Controls.Add(Me.lboxTaxID)
        Me.Panel6.Controls.Add(Me.Label65)
        Me.Panel6.Controls.Add(Me.btnDelTaxIDRef)
        Me.Panel6.Controls.Add(Me.btnEditTaxIDRef)
        Me.Panel6.Controls.Add(Me.btnAddTaxIDRef)
        Me.Panel6.Controls.Add(Me.lboxTaxIDRef)
        Me.Panel6.Controls.Add(Me.Label64)
        Me.Panel6.Controls.Add(Me.btnDelTaxSys)
        Me.Panel6.Controls.Add(Me.btnEditTaxSys)
        Me.Panel6.Controls.Add(Me.btnAddTaxSys)
        Me.Panel6.Controls.Add(Me.lboxTaxSys)
        Me.Panel6.Controls.Add(Me.Label63)
        Me.Panel6.Controls.Add(Me.Label62)
        Me.Panel6.Location = New System.Drawing.Point(360, 8)
        Me.Panel6.Name = "Panel6"
        Me.Panel6.Size = New System.Drawing.Size(368, 384)
        Me.Panel6.TabIndex = 1
        '
        'btnDelVoucher
        '
        Me.btnDelVoucher.Location = New System.Drawing.Point(232, 616)
        Me.btnDelVoucher.Name = "btnDelVoucher"
        Me.btnDelVoucher.Size = New System.Drawing.Size(64, 23)
        Me.btnDelVoucher.TabIndex = 25
        Me.btnDelVoucher.Text = "Delete"
        '
        'btnEditVoucher
        '
        Me.btnEditVoucher.Location = New System.Drawing.Point(144, 616)
        Me.btnEditVoucher.Name = "btnEditVoucher"
        Me.btnEditVoucher.Size = New System.Drawing.Size(64, 23)
        Me.btnEditVoucher.TabIndex = 24
        Me.btnEditVoucher.Text = "Edit"
        '
        'btnAddVoucher
        '
        Me.btnAddVoucher.Location = New System.Drawing.Point(56, 616)
        Me.btnAddVoucher.Name = "btnAddVoucher"
        Me.btnAddVoucher.Size = New System.Drawing.Size(64, 23)
        Me.btnAddVoucher.TabIndex = 23
        Me.btnAddVoucher.Text = "Add"
        '
        'lboxVouchers
        '
        Me.lboxVouchers.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxVouchers.Location = New System.Drawing.Point(8, 584)
        Me.lboxVouchers.Name = "lboxVouchers"
        Me.lboxVouchers.Size = New System.Drawing.Size(296, 26)
        Me.lboxVouchers.TabIndex = 22
        Me.ToolTip1.SetToolTip(Me.lboxVouchers, "Types of specimens, the repository, and the people who identified the vouchers")
        '
        'Label68
        '
        Me.Label68.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label68.Location = New System.Drawing.Point(8, 568)
        Me.Label68.Name = "Label68"
        Me.Label68.Size = New System.Drawing.Size(200, 16)
        Me.Label68.TabIndex = 21
        Me.Label68.Text = "Vouchers"
        '
        'txtTaxComplete
        '
        Me.txtTaxComplete.Location = New System.Drawing.Point(8, 448)
        Me.txtTaxComplete.Multiline = True
        Me.txtTaxComplete.Name = "txtTaxComplete"
        Me.txtTaxComplete.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtTaxComplete.Size = New System.Drawing.Size(320, 104)
        Me.txtTaxComplete.TabIndex = 20
        Me.ToolTip1.SetToolTip(Me.txtTaxComplete, "Proportions and treatment of unidentified materials; importance; taxa not well tr" & _
                "eated; etc.")
        '
        'Label67
        '
        Me.Label67.Location = New System.Drawing.Point(8, 432)
        Me.Label67.Name = "Label67"
        Me.Label67.Size = New System.Drawing.Size(152, 16)
        Me.Label67.TabIndex = 19
        Me.Label67.Text = "Taxonomic Completeness"
        '
        'Panel7
        '
        Me.Panel7.Location = New System.Drawing.Point(80, 648)
        Me.Panel7.Name = "Panel7"
        Me.Panel7.Size = New System.Drawing.Size(184, 8)
        Me.Panel7.TabIndex = 18
        '
        'txtTaxProc
        '
        Me.txtTaxProc.Location = New System.Drawing.Point(8, 312)
        Me.txtTaxProc.Multiline = True
        Me.txtTaxProc.Name = "txtTaxProc"
        Me.txtTaxProc.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtTaxProc.Size = New System.Drawing.Size(320, 104)
        Me.txtTaxProc.TabIndex = 17
        Me.ToolTip1.SetToolTip(Me.txtTaxProc, "Methods used (e.g., specimen processing, comparison with museum materials, keys, " & _
                "genetic analyses, etc.)")
        '
        'Label66
        '
        Me.Label66.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label66.Location = New System.Drawing.Point(8, 296)
        Me.Label66.Name = "Label66"
        Me.Label66.Size = New System.Drawing.Size(160, 16)
        Me.Label66.TabIndex = 16
        Me.Label66.Text = "Taxonomic Procedures"
        '
        'btnDelTaxID
        '
        Me.btnDelTaxID.Location = New System.Drawing.Point(240, 248)
        Me.btnDelTaxID.Name = "btnDelTaxID"
        Me.btnDelTaxID.Size = New System.Drawing.Size(64, 23)
        Me.btnDelTaxID.TabIndex = 15
        Me.btnDelTaxID.Text = "Delete"
        '
        'btnEditTaxID
        '
        Me.btnEditTaxID.Location = New System.Drawing.Point(152, 248)
        Me.btnEditTaxID.Name = "btnEditTaxID"
        Me.btnEditTaxID.Size = New System.Drawing.Size(64, 23)
        Me.btnEditTaxID.TabIndex = 14
        Me.btnEditTaxID.Text = "Edit"
        '
        'btnAddTaxID
        '
        Me.btnAddTaxID.Location = New System.Drawing.Point(64, 248)
        Me.btnAddTaxID.Name = "btnAddTaxID"
        Me.btnAddTaxID.Size = New System.Drawing.Size(64, 23)
        Me.btnAddTaxID.TabIndex = 13
        Me.btnAddTaxID.Text = "Add"
        '
        'lboxTaxID
        '
        Me.lboxTaxID.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxTaxID.Location = New System.Drawing.Point(8, 232)
        Me.lboxTaxID.Name = "lboxTaxID"
        Me.lboxTaxID.Size = New System.Drawing.Size(304, 13)
        Me.lboxTaxID.TabIndex = 12
        Me.ToolTip1.SetToolTip(Me.lboxTaxID, "Who identified specimens, sightings, etc.")
        '
        'Label65
        '
        Me.Label65.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label65.Location = New System.Drawing.Point(8, 216)
        Me.Label65.Name = "Label65"
        Me.Label65.Size = New System.Drawing.Size(200, 16)
        Me.Label65.TabIndex = 11
        Me.Label65.Text = "Identifier (optional)"
        '
        'btnDelTaxIDRef
        '
        Me.btnDelTaxIDRef.Location = New System.Drawing.Point(240, 168)
        Me.btnDelTaxIDRef.Name = "btnDelTaxIDRef"
        Me.btnDelTaxIDRef.Size = New System.Drawing.Size(64, 23)
        Me.btnDelTaxIDRef.TabIndex = 10
        Me.btnDelTaxIDRef.Text = "Delete"
        '
        'btnEditTaxIDRef
        '
        Me.btnEditTaxIDRef.Location = New System.Drawing.Point(152, 168)
        Me.btnEditTaxIDRef.Name = "btnEditTaxIDRef"
        Me.btnEditTaxIDRef.Size = New System.Drawing.Size(64, 23)
        Me.btnEditTaxIDRef.TabIndex = 9
        Me.btnEditTaxIDRef.Text = "Edit"
        '
        'btnAddTaxIDRef
        '
        Me.btnAddTaxIDRef.Location = New System.Drawing.Point(64, 168)
        Me.btnAddTaxIDRef.Name = "btnAddTaxIDRef"
        Me.btnAddTaxIDRef.Size = New System.Drawing.Size(64, 23)
        Me.btnAddTaxIDRef.TabIndex = 8
        Me.btnAddTaxIDRef.Text = "Add"
        '
        'lboxTaxIDRef
        '
        Me.lboxTaxIDRef.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxTaxIDRef.Location = New System.Drawing.Point(8, 152)
        Me.lboxTaxIDRef.Name = "lboxTaxIDRef"
        Me.lboxTaxIDRef.Size = New System.Drawing.Size(304, 13)
        Me.lboxTaxIDRef.TabIndex = 7
        Me.ToolTip1.SetToolTip(Me.lboxTaxIDRef, "Non-authoritative materials (e.g., field guides) useful for reconstructing the id" & _
                "entification process")
        '
        'Label64
        '
        Me.Label64.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label64.Location = New System.Drawing.Point(8, 136)
        Me.Label64.Name = "Label64"
        Me.Label64.Size = New System.Drawing.Size(200, 16)
        Me.Label64.TabIndex = 6
        Me.Label64.Text = "Identification Reference"
        '
        'btnDelTaxSys
        '
        Me.btnDelTaxSys.Location = New System.Drawing.Point(240, 88)
        Me.btnDelTaxSys.Name = "btnDelTaxSys"
        Me.btnDelTaxSys.Size = New System.Drawing.Size(64, 23)
        Me.btnDelTaxSys.TabIndex = 5
        Me.btnDelTaxSys.Text = "Delete"
        '
        'btnEditTaxSys
        '
        Me.btnEditTaxSys.Location = New System.Drawing.Point(152, 88)
        Me.btnEditTaxSys.Name = "btnEditTaxSys"
        Me.btnEditTaxSys.Size = New System.Drawing.Size(64, 23)
        Me.btnEditTaxSys.TabIndex = 4
        Me.btnEditTaxSys.Text = "Edit"
        '
        'btnAddTaxSys
        '
        Me.btnAddTaxSys.Location = New System.Drawing.Point(64, 88)
        Me.btnAddTaxSys.Name = "btnAddTaxSys"
        Me.btnAddTaxSys.Size = New System.Drawing.Size(64, 23)
        Me.btnAddTaxSys.TabIndex = 3
        Me.btnAddTaxSys.Text = "Add"
        '
        'lboxTaxSys
        '
        Me.lboxTaxSys.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxTaxSys.Location = New System.Drawing.Point(16, 56)
        Me.lboxTaxSys.Name = "lboxTaxSys"
        Me.lboxTaxSys.Size = New System.Drawing.Size(296, 26)
        Me.lboxTaxSys.TabIndex = 2
        Me.ToolTip1.SetToolTip(Me.lboxTaxSys, "Information about the classification system or authority used")
        '
        'Label63
        '
        Me.Label63.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label63.Location = New System.Drawing.Point(16, 40)
        Me.Label63.Name = "Label63"
        Me.Label63.Size = New System.Drawing.Size(200, 16)
        Me.Label63.TabIndex = 1
        Me.Label63.Text = "Classification System or Authority"
        '
        'Label62
        '
        Me.Label62.Location = New System.Drawing.Point(138, 8)
        Me.Label62.Name = "Label62"
        Me.Label62.Size = New System.Drawing.Size(100, 16)
        Me.Label62.TabIndex = 0
        Me.Label62.Text = "Taxonomic System"
        '
        'Panel5
        '
        Me.Panel5.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.Panel5.Controls.Add(Me.btnDelTaxKey)
        Me.Panel5.Controls.Add(Me.btnEditTaxKey)
        Me.Panel5.Controls.Add(Me.btnAddTaxKey)
        Me.Panel5.Controls.Add(Me.lboxTaxKey)
        Me.Panel5.Controls.Add(Me.Label61)
        Me.Panel5.Location = New System.Drawing.Point(16, 8)
        Me.Panel5.Name = "Panel5"
        Me.Panel5.Size = New System.Drawing.Size(312, 80)
        Me.Panel5.TabIndex = 0
        '
        'btnDelTaxKey
        '
        Me.btnDelTaxKey.Location = New System.Drawing.Point(208, 40)
        Me.btnDelTaxKey.Name = "btnDelTaxKey"
        Me.btnDelTaxKey.Size = New System.Drawing.Size(64, 23)
        Me.btnDelTaxKey.TabIndex = 4
        Me.btnDelTaxKey.Text = "Delete"
        '
        'btnEditTaxKey
        '
        Me.btnEditTaxKey.Location = New System.Drawing.Point(136, 40)
        Me.btnEditTaxKey.Name = "btnEditTaxKey"
        Me.btnEditTaxKey.Size = New System.Drawing.Size(56, 23)
        Me.btnEditTaxKey.TabIndex = 3
        Me.btnEditTaxKey.Text = "Edit"
        '
        'btnAddTaxKey
        '
        Me.btnAddTaxKey.Location = New System.Drawing.Point(64, 40)
        Me.btnAddTaxKey.Name = "btnAddTaxKey"
        Me.btnAddTaxKey.Size = New System.Drawing.Size(56, 23)
        Me.btnAddTaxKey.TabIndex = 2
        Me.btnAddTaxKey.Text = "Add"
        '
        'lboxTaxKey
        '
        Me.lboxTaxKey.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxTaxKey.Location = New System.Drawing.Point(8, 24)
        Me.lboxTaxKey.Name = "lboxTaxKey"
        Me.lboxTaxKey.Size = New System.Drawing.Size(280, 13)
        Me.lboxTaxKey.TabIndex = 1
        Me.ToolTip1.SetToolTip(Me.lboxTaxKey, "Taxonomic ranks or common groups characterized by the data set. Thesaurus + Keywo" & _
                "rds")
        '
        'Label61
        '
        Me.Label61.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label61.Location = New System.Drawing.Point(105, 8)
        Me.Label61.Name = "Label61"
        Me.Label61.Size = New System.Drawing.Size(100, 16)
        Me.Label61.TabIndex = 0
        Me.Label61.Text = "Keywords/Taxon"
        '
        'tpAccess
        '
        Me.tpAccess.AutoScroll = True
        Me.tpAccess.Controls.Add(Me.txtIDaccess)
        Me.tpAccess.Controls.Add(Me.txtIDuse)
        Me.tpAccess.Controls.Add(Me.Panel4)
        Me.tpAccess.Controls.Add(Me.btnDataContact)
        Me.tpAccess.Controls.Add(Me.txtDataContact)
        Me.tpAccess.Controls.Add(Me.Label51)
        Me.tpAccess.Controls.Add(Me.Label49)
        Me.tpAccess.Controls.Add(Me.Label50)
        Me.tpAccess.Controls.Add(Me.Label48)
        Me.tpAccess.Controls.Add(Me.Label47)
        Me.tpAccess.ImageIndex = 8
        Me.tpAccess.Location = New System.Drawing.Point(4, 23)
        Me.tpAccess.Name = "tpAccess"
        Me.tpAccess.Size = New System.Drawing.Size(730, 407)
        Me.tpAccess.TabIndex = 5
        Me.tpAccess.Text = "Access"
        '
        'txtIDaccess
        '
        Me.txtIDaccess.AcceptsReturn = True
        Me.txtIDaccess.Location = New System.Drawing.Point(24, 42)
        Me.txtIDaccess.Multiline = True
        Me.txtIDaccess.Name = "txtIDaccess"
        Me.txtIDaccess.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtIDaccess.Size = New System.Drawing.Size(304, 88)
        Me.txtIDaccess.TabIndex = 1
        Me.ToolTip1.SetToolTip(Me.txtIDaccess, "restrictions on accessing or obtaining the data set")
        '
        'txtIDuse
        '
        Me.txtIDuse.AcceptsReturn = True
        Me.txtIDuse.Location = New System.Drawing.Point(24, 168)
        Me.txtIDuse.Multiline = True
        Me.txtIDuse.Name = "txtIDuse"
        Me.txtIDuse.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtIDuse.Size = New System.Drawing.Size(304, 88)
        Me.txtIDuse.TabIndex = 4
        Me.ToolTip1.SetToolTip(Me.txtIDuse, "restrictions on using the data set after access is granted")
        '
        'Panel4
        '
        Me.Panel4.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.Panel4.Controls.Add(Me.txtDataSecDesc)
        Me.Panel4.Controls.Add(Me.Label55)
        Me.Panel4.Controls.Add(Me.cboxDataSecClass)
        Me.Panel4.Controls.Add(Me.Label53)
        Me.Panel4.Controls.Add(Me.txtDataSecSys)
        Me.Panel4.Controls.Add(Me.Label54)
        Me.Panel4.Controls.Add(Me.Label52)
        Me.Panel4.Location = New System.Drawing.Point(384, 24)
        Me.Panel4.Name = "Panel4"
        Me.Panel4.Size = New System.Drawing.Size(312, 296)
        Me.Panel4.TabIndex = 9
        '
        'txtDataSecDesc
        '
        Me.txtDataSecDesc.Location = New System.Drawing.Point(16, 208)
        Me.txtDataSecDesc.Multiline = True
        Me.txtDataSecDesc.Name = "txtDataSecDesc"
        Me.txtDataSecDesc.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtDataSecDesc.Size = New System.Drawing.Size(280, 64)
        Me.txtDataSecDesc.TabIndex = 10
        Me.ToolTip1.SetToolTip(Me.txtDataSecDesc, "additional information about the restrictions on handling the data set")
        '
        'Label55
        '
        Me.Label55.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label55.Location = New System.Drawing.Point(16, 192)
        Me.Label55.Name = "Label55"
        Me.Label55.Size = New System.Drawing.Size(200, 16)
        Me.Label55.TabIndex = 9
        Me.Label55.Text = "Security Handling Description"
        '
        'cboxDataSecClass
        '
        Me.cboxDataSecClass.Items.AddRange(New Object() {"Unclassified", "Sensitive", "Restricted", "Confidential", "Secret", "Top secret"})
        Me.cboxDataSecClass.Location = New System.Drawing.Point(16, 144)
        Me.cboxDataSecClass.Name = "cboxDataSecClass"
        Me.cboxDataSecClass.Size = New System.Drawing.Size(136, 21)
        Me.cboxDataSecClass.TabIndex = 8
        Me.ToolTip1.SetToolTip(Me.cboxDataSecClass, "choose a restriction or type appropriate value")
        '
        'Label53
        '
        Me.Label53.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label53.Location = New System.Drawing.Point(16, 128)
        Me.Label53.Name = "Label53"
        Me.Label53.Size = New System.Drawing.Size(160, 16)
        Me.Label53.TabIndex = 7
        Me.Label53.Text = "Security Classification"
        '
        'txtDataSecSys
        '
        Me.txtDataSecSys.Location = New System.Drawing.Point(16, 64)
        Me.txtDataSecSys.Multiline = True
        Me.txtDataSecSys.Name = "txtDataSecSys"
        Me.txtDataSecSys.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtDataSecSys.Size = New System.Drawing.Size(256, 40)
        Me.txtDataSecSys.TabIndex = 6
        Me.ToolTip1.SetToolTip(Me.txtDataSecSys, "name of classification system for the data set")
        '
        'Label54
        '
        Me.Label54.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label54.Location = New System.Drawing.Point(16, 48)
        Me.Label54.Name = "Label54"
        Me.Label54.Size = New System.Drawing.Size(184, 16)
        Me.Label54.TabIndex = 5
        Me.Label54.Text = "Security Classification System"
        Me.ToolTip1.SetToolTip(Me.Label54, "name of the classification system")
        '
        'Label52
        '
        Me.Label52.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label52.Location = New System.Drawing.Point(76, 8)
        Me.Label52.Name = "Label52"
        Me.Label52.Size = New System.Drawing.Size(160, 23)
        Me.Label52.TabIndex = 0
        Me.Label52.Text = "Security Information (optional)"
        Me.Label52.TextAlign = System.Drawing.ContentAlignment.TopCenter
        '
        'btnDataContact
        '
        Me.btnDataContact.Location = New System.Drawing.Point(264, 304)
        Me.btnDataContact.Name = "btnDataContact"
        Me.btnDataContact.Size = New System.Drawing.Size(75, 23)
        Me.btnDataContact.TabIndex = 8
        Me.btnDataContact.Text = "Edit"
        '
        'txtDataContact
        '
        Me.txtDataContact.Location = New System.Drawing.Point(24, 304)
        Me.txtDataContact.Name = "txtDataContact"
        Me.txtDataContact.ReadOnly = True
        Me.txtDataContact.Size = New System.Drawing.Size(232, 20)
        Me.txtDataContact.TabIndex = 7
        Me.txtDataContact.TabStop = False
        Me.ToolTip1.SetToolTip(Me.txtDataContact, "contact that is knowledgeable about the data set")
        '
        'Label51
        '
        Me.Label51.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label51.Location = New System.Drawing.Point(24, 280)
        Me.Label51.Name = "Label51"
        Me.Label51.Size = New System.Drawing.Size(136, 23)
        Me.Label51.TabIndex = 6
        Me.Label51.Text = "Point of Contact (optional)"
        '
        'Label49
        '
        Me.Label49.Location = New System.Drawing.Point(128, 152)
        Me.Label49.Name = "Label49"
        Me.Label49.Size = New System.Drawing.Size(100, 23)
        Me.Label49.TabIndex = 5
        Me.Label49.Text = "(default is ""None"")"
        '
        'Label50
        '
        Me.Label50.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label50.Location = New System.Drawing.Point(24, 152)
        Me.Label50.Name = "Label50"
        Me.Label50.Size = New System.Drawing.Size(104, 23)
        Me.Label50.TabIndex = 3
        Me.Label50.Text = "Use Constraints"
        '
        'Label48
        '
        Me.Label48.Location = New System.Drawing.Point(144, 24)
        Me.Label48.Name = "Label48"
        Me.Label48.Size = New System.Drawing.Size(100, 23)
        Me.Label48.TabIndex = 2
        Me.Label48.Text = "(default is ""None"")"
        '
        'Label47
        '
        Me.Label47.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label47.Location = New System.Drawing.Point(24, 24)
        Me.Label47.Name = "Label47"
        Me.Label47.Size = New System.Drawing.Size(120, 23)
        Me.Label47.TabIndex = 0
        Me.Label47.Text = "Access Constraints"
        '
        'tpTool
        '
        Me.tpTool.AutoScroll = True
        Me.tpTool.Controls.Add(Me.btnToolDelete)
        Me.tpTool.Controls.Add(Me.btnToolEdit)
        Me.tpTool.Controls.Add(Me.btnToolAdd)
        Me.tpTool.Controls.Add(Me.lboxTool)
        Me.tpTool.Controls.Add(Me.Label60)
        Me.tpTool.Controls.Add(Me.TextBox5)
        Me.tpTool.ImageIndex = 9
        Me.tpTool.Location = New System.Drawing.Point(4, 23)
        Me.tpTool.Name = "tpTool"
        Me.tpTool.Size = New System.Drawing.Size(730, 407)
        Me.tpTool.TabIndex = 4
        Me.tpTool.Text = "Analytical Tools"
        '
        'btnToolDelete
        '
        Me.btnToolDelete.Location = New System.Drawing.Point(240, 88)
        Me.btnToolDelete.Name = "btnToolDelete"
        Me.btnToolDelete.Size = New System.Drawing.Size(75, 23)
        Me.btnToolDelete.TabIndex = 5
        Me.btnToolDelete.Text = "Delete"
        '
        'btnToolEdit
        '
        Me.btnToolEdit.Location = New System.Drawing.Point(152, 88)
        Me.btnToolEdit.Name = "btnToolEdit"
        Me.btnToolEdit.Size = New System.Drawing.Size(64, 23)
        Me.btnToolEdit.TabIndex = 4
        Me.btnToolEdit.Text = "Edit"
        '
        'btnToolAdd
        '
        Me.btnToolAdd.Location = New System.Drawing.Point(64, 88)
        Me.btnToolAdd.Name = "btnToolAdd"
        Me.btnToolAdd.Size = New System.Drawing.Size(64, 23)
        Me.btnToolAdd.TabIndex = 3
        Me.btnToolAdd.Text = "Add"
        '
        'lboxTool
        '
        Me.lboxTool.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxTool.Location = New System.Drawing.Point(32, 40)
        Me.lboxTool.Name = "lboxTool"
        Me.lboxTool.Size = New System.Drawing.Size(360, 39)
        Me.lboxTool.TabIndex = 2
        '
        'Label60
        '
        Me.Label60.Location = New System.Drawing.Point(32, 24)
        Me.Label60.Name = "Label60"
        Me.Label60.Size = New System.Drawing.Size(100, 23)
        Me.Label60.TabIndex = 1
        Me.Label60.Text = "Analytical Tool"
        '
        'TextBox5
        '
        Me.TextBox5.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.TextBox5.Location = New System.Drawing.Point(16, 296)
        Me.TextBox5.Multiline = True
        Me.TextBox5.Name = "TextBox5"
        Me.TextBox5.ReadOnly = True
        Me.TextBox5.Size = New System.Drawing.Size(696, 88)
        Me.TextBox5.TabIndex = 0
        Me.TextBox5.Text = resources.GetString("TextBox5.Text")
        '
        'tpIDmisc
        '
        Me.tpIDmisc.AutoScroll = True
        Me.tpIDmisc.Controls.Add(Me.btnXRefDelete)
        Me.tpIDmisc.Controls.Add(Me.btnXRefEdit)
        Me.tpIDmisc.Controls.Add(Me.btnXRefAdd)
        Me.tpIDmisc.Controls.Add(Me.lboxXRef)
        Me.tpIDmisc.Controls.Add(Me.Label58)
        Me.tpIDmisc.Controls.Add(Me.txtDSenviron)
        Me.tpIDmisc.Controls.Add(Me.Label59)
        Me.tpIDmisc.Controls.Add(Me.btnGraphicDelete)
        Me.tpIDmisc.Controls.Add(Me.btnGraphicEdit)
        Me.tpIDmisc.Controls.Add(Me.btnGraphicAdd)
        Me.tpIDmisc.Controls.Add(Me.lboxBrGraphic)
        Me.tpIDmisc.Controls.Add(Me.Label57)
        Me.tpIDmisc.Controls.Add(Me.txtDScredit)
        Me.tpIDmisc.Controls.Add(Me.Label56)
        Me.tpIDmisc.ImageIndex = 7
        Me.tpIDmisc.Location = New System.Drawing.Point(4, 23)
        Me.tpIDmisc.Name = "tpIDmisc"
        Me.tpIDmisc.Size = New System.Drawing.Size(730, 407)
        Me.tpIDmisc.TabIndex = 6
        Me.tpIDmisc.Text = "Miscellaneous"
        '
        'btnXRefDelete
        '
        Me.btnXRefDelete.Location = New System.Drawing.Point(560, 232)
        Me.btnXRefDelete.Name = "btnXRefDelete"
        Me.btnXRefDelete.Size = New System.Drawing.Size(75, 23)
        Me.btnXRefDelete.TabIndex = 13
        Me.btnXRefDelete.Text = "Delete"
        '
        'btnXRefEdit
        '
        Me.btnXRefEdit.Location = New System.Drawing.Point(472, 232)
        Me.btnXRefEdit.Name = "btnXRefEdit"
        Me.btnXRefEdit.Size = New System.Drawing.Size(75, 23)
        Me.btnXRefEdit.TabIndex = 12
        Me.btnXRefEdit.Text = "Edit"
        '
        'btnXRefAdd
        '
        Me.btnXRefAdd.Location = New System.Drawing.Point(384, 232)
        Me.btnXRefAdd.Name = "btnXRefAdd"
        Me.btnXRefAdd.Size = New System.Drawing.Size(75, 23)
        Me.btnXRefAdd.TabIndex = 11
        Me.btnXRefAdd.Text = "Add"
        '
        'lboxXRef
        '
        Me.lboxXRef.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxXRef.Location = New System.Drawing.Point(368, 184)
        Me.lboxXRef.Name = "lboxXRef"
        Me.lboxXRef.Size = New System.Drawing.Size(288, 39)
        Me.lboxXRef.TabIndex = 10
        Me.ToolTip1.SetToolTip(Me.lboxXRef, "information about other, related data sets that are likely to be of interest; or " & _
                "papers using this data set")
        '
        'Label58
        '
        Me.Label58.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label58.Location = New System.Drawing.Point(368, 160)
        Me.Label58.Name = "Label58"
        Me.Label58.Size = New System.Drawing.Size(160, 23)
        Me.Label58.TabIndex = 9
        Me.Label58.Text = "Cross References (optional)"
        '
        'txtDSenviron
        '
        Me.txtDSenviron.AcceptsReturn = True
        Me.txtDSenviron.Location = New System.Drawing.Point(368, 48)
        Me.txtDSenviron.Multiline = True
        Me.txtDSenviron.Name = "txtDSenviron"
        Me.txtDSenviron.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtDSenviron.Size = New System.Drawing.Size(288, 72)
        Me.txtDSenviron.TabIndex = 8
        Me.ToolTip1.SetToolTip(Me.txtDSenviron, "describe data set in the processing environment, e.g., software, OS, file name, s" & _
                "ize")
        '
        'Label59
        '
        Me.Label59.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label59.Location = New System.Drawing.Point(368, 24)
        Me.Label59.Name = "Label59"
        Me.Label59.Size = New System.Drawing.Size(224, 23)
        Me.Label59.TabIndex = 7
        Me.Label59.Text = "Native Data Set Environment (optional)"
        '
        'btnGraphicDelete
        '
        Me.btnGraphicDelete.Location = New System.Drawing.Point(216, 232)
        Me.btnGraphicDelete.Name = "btnGraphicDelete"
        Me.btnGraphicDelete.Size = New System.Drawing.Size(75, 23)
        Me.btnGraphicDelete.TabIndex = 6
        Me.btnGraphicDelete.Text = "Delete"
        '
        'btnGraphicEdit
        '
        Me.btnGraphicEdit.Location = New System.Drawing.Point(128, 232)
        Me.btnGraphicEdit.Name = "btnGraphicEdit"
        Me.btnGraphicEdit.Size = New System.Drawing.Size(72, 23)
        Me.btnGraphicEdit.TabIndex = 5
        Me.btnGraphicEdit.Text = "Edit"
        '
        'btnGraphicAdd
        '
        Me.btnGraphicAdd.Location = New System.Drawing.Point(40, 232)
        Me.btnGraphicAdd.Name = "btnGraphicAdd"
        Me.btnGraphicAdd.Size = New System.Drawing.Size(72, 23)
        Me.btnGraphicAdd.TabIndex = 4
        Me.btnGraphicAdd.Text = "Add"
        '
        'lboxBrGraphic
        '
        Me.lboxBrGraphic.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxBrGraphic.Location = New System.Drawing.Point(24, 184)
        Me.lboxBrGraphic.Name = "lboxBrGraphic"
        Me.lboxBrGraphic.Size = New System.Drawing.Size(288, 39)
        Me.lboxBrGraphic.TabIndex = 3
        Me.ToolTip1.SetToolTip(Me.lboxBrGraphic, "description of graphics that illustrate the data set")
        '
        'Label57
        '
        Me.Label57.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label57.Location = New System.Drawing.Point(24, 160)
        Me.Label57.Name = "Label57"
        Me.Label57.Size = New System.Drawing.Size(160, 23)
        Me.Label57.TabIndex = 2
        Me.Label57.Text = "Browse Graphics (optional)"
        '
        'txtDScredit
        '
        Me.txtDScredit.AcceptsReturn = True
        Me.txtDScredit.Location = New System.Drawing.Point(24, 48)
        Me.txtDScredit.Multiline = True
        Me.txtDScredit.Name = "txtDScredit"
        Me.txtDScredit.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtDScredit.Size = New System.Drawing.Size(288, 72)
        Me.txtDScredit.TabIndex = 1
        Me.ToolTip1.SetToolTip(Me.txtDScredit, "recognition of those who contributed to the data set")
        '
        'Label56
        '
        Me.Label56.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label56.Location = New System.Drawing.Point(24, 24)
        Me.Label56.Name = "Label56"
        Me.Label56.Size = New System.Drawing.Size(144, 23)
        Me.Label56.TabIndex = 0
        Me.Label56.Text = "Data Set Credit (optional)"
        '
        'ImageList1
        '
        Me.ImageList1.ImageStream = CType(resources.GetObject("ImageList1.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ImageList1.TransparentColor = System.Drawing.Color.Transparent
        Me.ImageList1.Images.SetKeyName(0, "")
        Me.ImageList1.Images.SetKeyName(1, "")
        Me.ImageList1.Images.SetKeyName(2, "")
        Me.ImageList1.Images.SetKeyName(3, "")
        Me.ImageList1.Images.SetKeyName(4, "")
        Me.ImageList1.Images.SetKeyName(5, "")
        Me.ImageList1.Images.SetKeyName(6, "")
        Me.ImageList1.Images.SetKeyName(7, "")
        Me.ImageList1.Images.SetKeyName(8, "")
        Me.ImageList1.Images.SetKeyName(9, "")
        '
        'tabSection2
        '
        Me.tabSection2.Controls.Add(Me.tabQuality)
        Me.tabSection2.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.tabSection2.Location = New System.Drawing.Point(4, 24)
        Me.tabSection2.Name = "tabSection2"
        Me.tabSection2.Size = New System.Drawing.Size(736, 432)
        Me.tabSection2.TabIndex = 1
        Me.tabSection2.Text = "Data Quality"
        '
        'tabQuality
        '
        Me.tabQuality.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.tabQuality.Controls.Add(Me.tpDQattrib)
        Me.tabQuality.Controls.Add(Me.tpDQlogic)
        Me.tabQuality.Controls.Add(Me.tpDQposit)
        Me.tabQuality.Controls.Add(Me.tpDQlineage)
        Me.tabQuality.Controls.Add(Me.tpDQcloud)
        Me.tabQuality.ImageList = Me.ImageList1
        Me.tabQuality.Location = New System.Drawing.Point(0, 0)
        Me.tabQuality.Name = "tabQuality"
        Me.tabQuality.SelectedIndex = 0
        Me.tabQuality.Size = New System.Drawing.Size(736, 436)
        Me.tabQuality.TabIndex = 0
        '
        'tpDQattrib
        '
        Me.tpDQattrib.AutoScroll = True
        Me.tpDQattrib.Controls.Add(Me.btnDelAttribAcc)
        Me.tpDQattrib.Controls.Add(Me.btnEditAttribAcc)
        Me.tpDQattrib.Controls.Add(Me.btnAddAttribAcc)
        Me.tpDQattrib.Controls.Add(Me.lboxAttribAcc)
        Me.tpDQattrib.Controls.Add(Me.Label85)
        Me.tpDQattrib.Controls.Add(Me.TextBox10)
        Me.tpDQattrib.Controls.Add(Me.txtAttribAcc)
        Me.tpDQattrib.Controls.Add(Me.Label84)
        Me.tpDQattrib.ImageIndex = 9
        Me.tpDQattrib.Location = New System.Drawing.Point(4, 23)
        Me.tpDQattrib.Name = "tpDQattrib"
        Me.tpDQattrib.Size = New System.Drawing.Size(728, 409)
        Me.tpDQattrib.TabIndex = 0
        Me.tpDQattrib.Text = "Attribute Accuracy"
        '
        'btnDelAttribAcc
        '
        Me.btnDelAttribAcc.Location = New System.Drawing.Point(232, 296)
        Me.btnDelAttribAcc.Name = "btnDelAttribAcc"
        Me.btnDelAttribAcc.Size = New System.Drawing.Size(64, 23)
        Me.btnDelAttribAcc.TabIndex = 12
        Me.btnDelAttribAcc.Text = "Delete"
        '
        'btnEditAttribAcc
        '
        Me.btnEditAttribAcc.Location = New System.Drawing.Point(144, 296)
        Me.btnEditAttribAcc.Name = "btnEditAttribAcc"
        Me.btnEditAttribAcc.Size = New System.Drawing.Size(56, 23)
        Me.btnEditAttribAcc.TabIndex = 11
        Me.btnEditAttribAcc.Text = "Edit"
        '
        'btnAddAttribAcc
        '
        Me.btnAddAttribAcc.Location = New System.Drawing.Point(64, 296)
        Me.btnAddAttribAcc.Name = "btnAddAttribAcc"
        Me.btnAddAttribAcc.Size = New System.Drawing.Size(56, 23)
        Me.btnAddAttribAcc.TabIndex = 10
        Me.btnAddAttribAcc.Text = "Add"
        '
        'lboxAttribAcc
        '
        Me.lboxAttribAcc.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxAttribAcc.Location = New System.Drawing.Point(32, 256)
        Me.lboxAttribAcc.Name = "lboxAttribAcc"
        Me.lboxAttribAcc.Size = New System.Drawing.Size(296, 26)
        Me.lboxAttribAcc.TabIndex = 9
        '
        'Label85
        '
        Me.Label85.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label85.Location = New System.Drawing.Point(24, 232)
        Me.Label85.Name = "Label85"
        Me.Label85.Size = New System.Drawing.Size(288, 16)
        Me.Label85.TabIndex = 8
        Me.Label85.Text = "Quantitative Attribute Accuracy Assessment (optional)"
        '
        'TextBox10
        '
        Me.TextBox10.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.TextBox10.Location = New System.Drawing.Point(464, 72)
        Me.TextBox10.Multiline = True
        Me.TextBox10.Name = "TextBox10"
        Me.TextBox10.ReadOnly = True
        Me.TextBox10.Size = New System.Drawing.Size(224, 88)
        Me.TextBox10.TabIndex = 7
        Me.TextBox10.TabStop = False
        Me.TextBox10.Text = "Explanation of the accuracy of the identification of entities and assignment of a" & _
            "ttribute values in the data set." & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "The report can reference more extensive desc" & _
            "riptions in other documents."
        '
        'txtAttribAcc
        '
        Me.txtAttribAcc.Location = New System.Drawing.Point(24, 48)
        Me.txtAttribAcc.Multiline = True
        Me.txtAttribAcc.Name = "txtAttribAcc"
        Me.txtAttribAcc.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtAttribAcc.Size = New System.Drawing.Size(416, 136)
        Me.txtAttribAcc.TabIndex = 6
        '
        'Label84
        '
        Me.Label84.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label84.Location = New System.Drawing.Point(24, 24)
        Me.Label84.Name = "Label84"
        Me.Label84.Size = New System.Drawing.Size(160, 16)
        Me.Label84.TabIndex = 5
        Me.Label84.Text = "Attribute Accuracy Report"
        '
        'tpDQlogic
        '
        Me.tpDQlogic.AutoScroll = True
        Me.tpDQlogic.Controls.Add(Me.TextBox9)
        Me.tpDQlogic.Controls.Add(Me.TextBox8)
        Me.tpDQlogic.Controls.Add(Me.txtComplete)
        Me.tpDQlogic.Controls.Add(Me.Label83)
        Me.tpDQlogic.Controls.Add(Me.txtLogic)
        Me.tpDQlogic.Controls.Add(Me.Label82)
        Me.tpDQlogic.ImageIndex = 8
        Me.tpDQlogic.Location = New System.Drawing.Point(4, 23)
        Me.tpDQlogic.Name = "tpDQlogic"
        Me.tpDQlogic.Size = New System.Drawing.Size(732, 357)
        Me.tpDQlogic.TabIndex = 1
        Me.tpDQlogic.Text = "Consistency & Completeness"
        '
        'TextBox9
        '
        Me.TextBox9.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.TextBox9.Location = New System.Drawing.Point(464, 256)
        Me.TextBox9.Multiline = True
        Me.TextBox9.Name = "TextBox9"
        Me.TextBox9.ReadOnly = True
        Me.TextBox9.Size = New System.Drawing.Size(224, 88)
        Me.TextBox9.TabIndex = 5
        Me.TextBox9.TabStop = False
        Me.TextBox9.Text = resources.GetString("TextBox9.Text")
        '
        'TextBox8
        '
        Me.TextBox8.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.TextBox8.Location = New System.Drawing.Point(464, 56)
        Me.TextBox8.Multiline = True
        Me.TextBox8.Name = "TextBox8"
        Me.TextBox8.ReadOnly = True
        Me.TextBox8.Size = New System.Drawing.Size(224, 120)
        Me.TextBox8.TabIndex = 4
        Me.TextBox8.TabStop = False
        Me.TextBox8.Text = resources.GetString("TextBox8.Text")
        '
        'txtComplete
        '
        Me.txtComplete.Location = New System.Drawing.Point(24, 232)
        Me.txtComplete.Multiline = True
        Me.txtComplete.Name = "txtComplete"
        Me.txtComplete.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtComplete.Size = New System.Drawing.Size(416, 136)
        Me.txtComplete.TabIndex = 3
        '
        'Label83
        '
        Me.Label83.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label83.Location = New System.Drawing.Point(24, 208)
        Me.Label83.Name = "Label83"
        Me.Label83.Size = New System.Drawing.Size(160, 16)
        Me.Label83.TabIndex = 2
        Me.Label83.Text = "Completeness Report"
        '
        'txtLogic
        '
        Me.txtLogic.Location = New System.Drawing.Point(24, 48)
        Me.txtLogic.Multiline = True
        Me.txtLogic.Name = "txtLogic"
        Me.txtLogic.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtLogic.Size = New System.Drawing.Size(416, 136)
        Me.txtLogic.TabIndex = 1
        Me.txtLogic.Text = "not applicable"
        '
        'Label82
        '
        Me.Label82.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label82.Location = New System.Drawing.Point(24, 24)
        Me.Label82.Name = "Label82"
        Me.Label82.Size = New System.Drawing.Size(160, 16)
        Me.Label82.TabIndex = 0
        Me.Label82.Text = "Logical Consistency Report"
        '
        'tpDQposit
        '
        Me.tpDQposit.AutoScroll = True
        Me.tpDQposit.Controls.Add(Me.Panel18)
        Me.tpDQposit.Controls.Add(Me.Panel17)
        Me.tpDQposit.ImageIndex = 9
        Me.tpDQposit.Location = New System.Drawing.Point(4, 23)
        Me.tpDQposit.Name = "tpDQposit"
        Me.tpDQposit.Size = New System.Drawing.Size(732, 357)
        Me.tpDQposit.TabIndex = 3
        Me.tpDQposit.Text = "Positional Accuracy"
        '
        'Panel18
        '
        Me.Panel18.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.Panel18.Controls.Add(Me.btnDelVPosAcc)
        Me.Panel18.Controls.Add(Me.btnEditVPosAcc)
        Me.Panel18.Controls.Add(Me.btnAddVPosAcc)
        Me.Panel18.Controls.Add(Me.lboxVPosAcc)
        Me.Panel18.Controls.Add(Me.Label89)
        Me.Panel18.Controls.Add(Me.TextBox12)
        Me.Panel18.Controls.Add(Me.txtVertAccRpt)
        Me.Panel18.Controls.Add(Me.Label90)
        Me.Panel18.Controls.Add(Me.Label91)
        Me.Panel18.Location = New System.Drawing.Point(16, 296)
        Me.Panel18.Name = "Panel18"
        Me.Panel18.Size = New System.Drawing.Size(688, 264)
        Me.Panel18.TabIndex = 1
        '
        'btnDelVPosAcc
        '
        Me.btnDelVPosAcc.Location = New System.Drawing.Point(584, 112)
        Me.btnDelVPosAcc.Name = "btnDelVPosAcc"
        Me.btnDelVPosAcc.Size = New System.Drawing.Size(64, 23)
        Me.btnDelVPosAcc.TabIndex = 8
        Me.btnDelVPosAcc.Text = "Delete"
        '
        'btnEditVPosAcc
        '
        Me.btnEditVPosAcc.Location = New System.Drawing.Point(512, 112)
        Me.btnEditVPosAcc.Name = "btnEditVPosAcc"
        Me.btnEditVPosAcc.Size = New System.Drawing.Size(56, 23)
        Me.btnEditVPosAcc.TabIndex = 7
        Me.btnEditVPosAcc.Text = "Edit"
        '
        'btnAddVPosAcc
        '
        Me.btnAddVPosAcc.Location = New System.Drawing.Point(440, 112)
        Me.btnAddVPosAcc.Name = "btnAddVPosAcc"
        Me.btnAddVPosAcc.Size = New System.Drawing.Size(56, 23)
        Me.btnAddVPosAcc.TabIndex = 6
        Me.btnAddVPosAcc.Text = "Add"
        '
        'lboxVPosAcc
        '
        Me.lboxVPosAcc.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxVPosAcc.Location = New System.Drawing.Point(424, 72)
        Me.lboxVPosAcc.Name = "lboxVPosAcc"
        Me.lboxVPosAcc.Size = New System.Drawing.Size(240, 26)
        Me.lboxVPosAcc.TabIndex = 5
        '
        'Label89
        '
        Me.Label89.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label89.Location = New System.Drawing.Point(424, 40)
        Me.Label89.Name = "Label89"
        Me.Label89.Size = New System.Drawing.Size(232, 32)
        Me.Label89.TabIndex = 4
        Me.Label89.Text = "Quantitative Vertical Positional Accuracy Assessment (optional)"
        '
        'TextBox12
        '
        Me.TextBox12.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.TextBox12.Location = New System.Drawing.Point(40, 208)
        Me.TextBox12.Multiline = True
        Me.TextBox12.Name = "TextBox12"
        Me.TextBox12.ReadOnly = True
        Me.TextBox12.Size = New System.Drawing.Size(280, 40)
        Me.TextBox12.TabIndex = 3
        Me.TextBox12.TabStop = False
        Me.TextBox12.Text = "Explanation of the accuracy of the vertical coordinate measurements and a descrip" & _
            "tion of the tests used."
        '
        'txtVertAccRpt
        '
        Me.txtVertAccRpt.Location = New System.Drawing.Point(16, 56)
        Me.txtVertAccRpt.Multiline = True
        Me.txtVertAccRpt.Name = "txtVertAccRpt"
        Me.txtVertAccRpt.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtVertAccRpt.Size = New System.Drawing.Size(368, 136)
        Me.txtVertAccRpt.TabIndex = 2
        '
        'Label90
        '
        Me.Label90.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label90.Location = New System.Drawing.Point(16, 40)
        Me.Label90.Name = "Label90"
        Me.Label90.Size = New System.Drawing.Size(216, 16)
        Me.Label90.TabIndex = 1
        Me.Label90.Text = "Vertical Positional Accuracy Report"
        '
        'Label91
        '
        Me.Label91.Location = New System.Drawing.Point(267, 8)
        Me.Label91.Name = "Label91"
        Me.Label91.Size = New System.Drawing.Size(153, 23)
        Me.Label91.TabIndex = 0
        Me.Label91.Text = "Vertical Positional Accuracy"
        Me.Label91.TextAlign = System.Drawing.ContentAlignment.TopCenter
        '
        'Panel17
        '
        Me.Panel17.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.Panel17.Controls.Add(Me.btnDelHPosAcc)
        Me.Panel17.Controls.Add(Me.btnEditHPosAcc)
        Me.Panel17.Controls.Add(Me.btnAddHPosAcc)
        Me.Panel17.Controls.Add(Me.lboxHPosAcc)
        Me.Panel17.Controls.Add(Me.Label88)
        Me.Panel17.Controls.Add(Me.TextBox11)
        Me.Panel17.Controls.Add(Me.txtHorAccRpt)
        Me.Panel17.Controls.Add(Me.Label87)
        Me.Panel17.Controls.Add(Me.Label86)
        Me.Panel17.Location = New System.Drawing.Point(16, 16)
        Me.Panel17.Name = "Panel17"
        Me.Panel17.Size = New System.Drawing.Size(688, 256)
        Me.Panel17.TabIndex = 0
        '
        'btnDelHPosAcc
        '
        Me.btnDelHPosAcc.Location = New System.Drawing.Point(584, 112)
        Me.btnDelHPosAcc.Name = "btnDelHPosAcc"
        Me.btnDelHPosAcc.Size = New System.Drawing.Size(64, 23)
        Me.btnDelHPosAcc.TabIndex = 8
        Me.btnDelHPosAcc.Text = "Delete"
        '
        'btnEditHPosAcc
        '
        Me.btnEditHPosAcc.Location = New System.Drawing.Point(512, 112)
        Me.btnEditHPosAcc.Name = "btnEditHPosAcc"
        Me.btnEditHPosAcc.Size = New System.Drawing.Size(56, 23)
        Me.btnEditHPosAcc.TabIndex = 7
        Me.btnEditHPosAcc.Text = "Edit"
        '
        'btnAddHPosAcc
        '
        Me.btnAddHPosAcc.Location = New System.Drawing.Point(440, 112)
        Me.btnAddHPosAcc.Name = "btnAddHPosAcc"
        Me.btnAddHPosAcc.Size = New System.Drawing.Size(56, 23)
        Me.btnAddHPosAcc.TabIndex = 6
        Me.btnAddHPosAcc.Text = "Add"
        '
        'lboxHPosAcc
        '
        Me.lboxHPosAcc.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxHPosAcc.Location = New System.Drawing.Point(424, 72)
        Me.lboxHPosAcc.Name = "lboxHPosAcc"
        Me.lboxHPosAcc.Size = New System.Drawing.Size(240, 26)
        Me.lboxHPosAcc.TabIndex = 5
        '
        'Label88
        '
        Me.Label88.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label88.Location = New System.Drawing.Point(424, 40)
        Me.Label88.Name = "Label88"
        Me.Label88.Size = New System.Drawing.Size(232, 32)
        Me.Label88.TabIndex = 4
        Me.Label88.Text = "Quantitative Horizontal Positional Accuracy Assessment (optional)"
        '
        'TextBox11
        '
        Me.TextBox11.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.TextBox11.Location = New System.Drawing.Point(40, 208)
        Me.TextBox11.Multiline = True
        Me.TextBox11.Name = "TextBox11"
        Me.TextBox11.ReadOnly = True
        Me.TextBox11.Size = New System.Drawing.Size(280, 40)
        Me.TextBox11.TabIndex = 3
        Me.TextBox11.TabStop = False
        Me.TextBox11.Text = "Explanation of the accuracy of the horizontal coordinate measurements and a descr" & _
            "iption of the tests used."
        '
        'txtHorAccRpt
        '
        Me.txtHorAccRpt.Location = New System.Drawing.Point(16, 56)
        Me.txtHorAccRpt.Multiline = True
        Me.txtHorAccRpt.Name = "txtHorAccRpt"
        Me.txtHorAccRpt.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtHorAccRpt.Size = New System.Drawing.Size(368, 136)
        Me.txtHorAccRpt.TabIndex = 2
        '
        'Label87
        '
        Me.Label87.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label87.Location = New System.Drawing.Point(16, 40)
        Me.Label87.Name = "Label87"
        Me.Label87.Size = New System.Drawing.Size(216, 16)
        Me.Label87.TabIndex = 1
        Me.Label87.Text = "Horizontal Positional Accuracy Report"
        '
        'Label86
        '
        Me.Label86.Location = New System.Drawing.Point(263, 8)
        Me.Label86.Name = "Label86"
        Me.Label86.Size = New System.Drawing.Size(160, 23)
        Me.Label86.TabIndex = 0
        Me.Label86.Text = "Horizontal Positional Accuracy"
        Me.Label86.TextAlign = System.Drawing.ContentAlignment.TopCenter
        '
        'tpDQlineage
        '
        Me.tpDQlineage.AutoScroll = True
        Me.tpDQlineage.Controls.Add(Me.TextBox15)
        Me.tpDQlineage.Controls.Add(Me.TextBox14)
        Me.tpDQlineage.Controls.Add(Me.TextBox13)
        Me.tpDQlineage.Controls.Add(Me.btnDelProc)
        Me.tpDQlineage.Controls.Add(Me.btnEditProc)
        Me.tpDQlineage.Controls.Add(Me.btnAddProc)
        Me.tpDQlineage.Controls.Add(Me.lboxProcess)
        Me.tpDQlineage.Controls.Add(Me.Label94)
        Me.tpDQlineage.Controls.Add(Me.btnDelSource)
        Me.tpDQlineage.Controls.Add(Me.btnEditSource)
        Me.tpDQlineage.Controls.Add(Me.btnAddSource)
        Me.tpDQlineage.Controls.Add(Me.lboxLinSource)
        Me.tpDQlineage.Controls.Add(Me.Label93)
        Me.tpDQlineage.Controls.Add(Me.btnDelMeth)
        Me.tpDQlineage.Controls.Add(Me.btnEditMeth)
        Me.tpDQlineage.Controls.Add(Me.btnAddMeth)
        Me.tpDQlineage.Controls.Add(Me.lboxMeth)
        Me.tpDQlineage.Controls.Add(Me.Label92)
        Me.tpDQlineage.ImageIndex = 8
        Me.tpDQlineage.Location = New System.Drawing.Point(4, 23)
        Me.tpDQlineage.Name = "tpDQlineage"
        Me.tpDQlineage.Size = New System.Drawing.Size(732, 357)
        Me.tpDQlineage.TabIndex = 4
        Me.tpDQlineage.Text = "Lineage"
        '
        'TextBox15
        '
        Me.TextBox15.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.TextBox15.Location = New System.Drawing.Point(352, 256)
        Me.TextBox15.Multiline = True
        Me.TextBox15.Name = "TextBox15"
        Me.TextBox15.ReadOnly = True
        Me.TextBox15.Size = New System.Drawing.Size(248, 64)
        Me.TextBox15.TabIndex = 17
        Me.TextBox15.TabStop = False
        Me.TextBox15.Text = "Information about a single data processing event." & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "Can describe process applied" & _
            " to an acquired data set or to raw data you collected."
        '
        'TextBox14
        '
        Me.TextBox14.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.TextBox14.Location = New System.Drawing.Point(352, 152)
        Me.TextBox14.Multiline = True
        Me.TextBox14.Name = "TextBox14"
        Me.TextBox14.ReadOnly = True
        Me.TextBox14.Size = New System.Drawing.Size(232, 40)
        Me.TextBox14.TabIndex = 16
        Me.TextBox14.TabStop = False
        Me.TextBox14.Text = "List of sources and a short discussion of the information contributed by each."
        '
        'TextBox13
        '
        Me.TextBox13.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.TextBox13.Location = New System.Drawing.Point(352, 40)
        Me.TextBox13.Multiline = True
        Me.TextBox13.Name = "TextBox13"
        Me.TextBox13.ReadOnly = True
        Me.TextBox13.Size = New System.Drawing.Size(232, 40)
        Me.TextBox13.TabIndex = 15
        Me.TextBox13.TabStop = False
        Me.TextBox13.Text = "Information about a single step of field and/or laboratory work."
        '
        'btnDelProc
        '
        Me.btnDelProc.Location = New System.Drawing.Point(232, 304)
        Me.btnDelProc.Name = "btnDelProc"
        Me.btnDelProc.Size = New System.Drawing.Size(75, 23)
        Me.btnDelProc.TabIndex = 14
        Me.btnDelProc.Text = "Delete"
        '
        'btnEditProc
        '
        Me.btnEditProc.Location = New System.Drawing.Point(136, 304)
        Me.btnEditProc.Name = "btnEditProc"
        Me.btnEditProc.Size = New System.Drawing.Size(75, 23)
        Me.btnEditProc.TabIndex = 13
        Me.btnEditProc.Text = "Edit"
        '
        'btnAddProc
        '
        Me.btnAddProc.Location = New System.Drawing.Point(40, 304)
        Me.btnAddProc.Name = "btnAddProc"
        Me.btnAddProc.Size = New System.Drawing.Size(75, 23)
        Me.btnAddProc.TabIndex = 12
        Me.btnAddProc.Text = "Add"
        '
        'lboxProcess
        '
        Me.lboxProcess.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxProcess.Location = New System.Drawing.Point(24, 264)
        Me.lboxProcess.Name = "lboxProcess"
        Me.lboxProcess.Size = New System.Drawing.Size(304, 26)
        Me.lboxProcess.TabIndex = 11
        '
        'Label94
        '
        Me.Label94.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label94.Location = New System.Drawing.Point(24, 248)
        Me.Label94.Name = "Label94"
        Me.Label94.Size = New System.Drawing.Size(96, 23)
        Me.Label94.TabIndex = 10
        Me.Label94.Text = "Process Step"
        '
        'btnDelSource
        '
        Me.btnDelSource.Location = New System.Drawing.Point(232, 192)
        Me.btnDelSource.Name = "btnDelSource"
        Me.btnDelSource.Size = New System.Drawing.Size(75, 23)
        Me.btnDelSource.TabIndex = 9
        Me.btnDelSource.Text = "Delete"
        '
        'btnEditSource
        '
        Me.btnEditSource.Location = New System.Drawing.Point(136, 192)
        Me.btnEditSource.Name = "btnEditSource"
        Me.btnEditSource.Size = New System.Drawing.Size(75, 23)
        Me.btnEditSource.TabIndex = 8
        Me.btnEditSource.Text = "Edit"
        '
        'btnAddSource
        '
        Me.btnAddSource.Location = New System.Drawing.Point(40, 192)
        Me.btnAddSource.Name = "btnAddSource"
        Me.btnAddSource.Size = New System.Drawing.Size(75, 23)
        Me.btnAddSource.TabIndex = 7
        Me.btnAddSource.Text = "Add"
        '
        'lboxLinSource
        '
        Me.lboxLinSource.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxLinSource.Location = New System.Drawing.Point(24, 152)
        Me.lboxLinSource.Name = "lboxLinSource"
        Me.lboxLinSource.Size = New System.Drawing.Size(304, 26)
        Me.lboxLinSource.TabIndex = 6
        '
        'Label93
        '
        Me.Label93.Location = New System.Drawing.Point(24, 136)
        Me.Label93.Name = "Label93"
        Me.Label93.Size = New System.Drawing.Size(112, 23)
        Me.Label93.TabIndex = 5
        Me.Label93.Text = "Source Information"
        '
        'btnDelMeth
        '
        Me.btnDelMeth.Location = New System.Drawing.Point(232, 80)
        Me.btnDelMeth.Name = "btnDelMeth"
        Me.btnDelMeth.Size = New System.Drawing.Size(75, 23)
        Me.btnDelMeth.TabIndex = 4
        Me.btnDelMeth.Text = "Delete"
        '
        'btnEditMeth
        '
        Me.btnEditMeth.Location = New System.Drawing.Point(136, 80)
        Me.btnEditMeth.Name = "btnEditMeth"
        Me.btnEditMeth.Size = New System.Drawing.Size(75, 23)
        Me.btnEditMeth.TabIndex = 3
        Me.btnEditMeth.Text = "Edit"
        '
        'btnAddMeth
        '
        Me.btnAddMeth.Location = New System.Drawing.Point(40, 80)
        Me.btnAddMeth.Name = "btnAddMeth"
        Me.btnAddMeth.Size = New System.Drawing.Size(75, 23)
        Me.btnAddMeth.TabIndex = 2
        Me.btnAddMeth.Text = "Add"
        '
        'lboxMeth
        '
        Me.lboxMeth.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxMeth.Location = New System.Drawing.Point(24, 40)
        Me.lboxMeth.Name = "lboxMeth"
        Me.lboxMeth.Size = New System.Drawing.Size(304, 26)
        Me.lboxMeth.TabIndex = 1
        '
        'Label92
        '
        Me.Label92.Location = New System.Drawing.Point(24, 24)
        Me.Label92.Name = "Label92"
        Me.Label92.Size = New System.Drawing.Size(88, 23)
        Me.Label92.TabIndex = 0
        Me.Label92.Text = "Methodology"
        '
        'tpDQcloud
        '
        Me.tpDQcloud.Controls.Add(Me.TextBox7)
        Me.tpDQcloud.Controls.Add(Me.pnlCloud)
        Me.tpDQcloud.Controls.Add(Me.Panel16)
        Me.tpDQcloud.Controls.Add(Me.Label80)
        Me.tpDQcloud.ImageIndex = 7
        Me.tpDQcloud.Location = New System.Drawing.Point(4, 23)
        Me.tpDQcloud.Name = "tpDQcloud"
        Me.tpDQcloud.Size = New System.Drawing.Size(732, 357)
        Me.tpDQcloud.TabIndex = 5
        Me.tpDQcloud.Text = "Cloud Cover"
        '
        'TextBox7
        '
        Me.TextBox7.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.TextBox7.Location = New System.Drawing.Point(72, 88)
        Me.TextBox7.Multiline = True
        Me.TextBox7.Name = "TextBox7"
        Me.TextBox7.ReadOnly = True
        Me.TextBox7.Size = New System.Drawing.Size(400, 64)
        Me.TextBox7.TabIndex = 4
        Me.TextBox7.TabStop = False
        Me.TextBox7.Text = resources.GetString("TextBox7.Text")
        '
        'pnlCloud
        '
        Me.pnlCloud.Controls.Add(Me.numCloud)
        Me.pnlCloud.Location = New System.Drawing.Point(416, 24)
        Me.pnlCloud.Name = "pnlCloud"
        Me.pnlCloud.Size = New System.Drawing.Size(88, 45)
        Me.pnlCloud.TabIndex = 3
        '
        'numCloud
        '
        Me.numCloud.Location = New System.Drawing.Point(8, 10)
        Me.numCloud.Name = "numCloud"
        Me.numCloud.Size = New System.Drawing.Size(64, 20)
        Me.numCloud.TabIndex = 1
        Me.numCloud.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'Panel16
        '
        Me.Panel16.Controls.Add(Me.rdoCloud)
        Me.Panel16.Controls.Add(Me.rdoCloudUnk)
        Me.Panel16.Controls.Add(Me.rdoNoCloud)
        Me.Panel16.Location = New System.Drawing.Point(144, 24)
        Me.Panel16.Name = "Panel16"
        Me.Panel16.Size = New System.Drawing.Size(272, 40)
        Me.Panel16.TabIndex = 2
        '
        'rdoCloud
        '
        Me.rdoCloud.Location = New System.Drawing.Point(200, 8)
        Me.rdoCloud.Name = "rdoCloud"
        Me.rdoCloud.Size = New System.Drawing.Size(64, 24)
        Me.rdoCloud.TabIndex = 2
        Me.rdoCloud.Text = "% cover"
        '
        'rdoCloudUnk
        '
        Me.rdoCloudUnk.Location = New System.Drawing.Point(112, 8)
        Me.rdoCloudUnk.Name = "rdoCloudUnk"
        Me.rdoCloudUnk.Size = New System.Drawing.Size(88, 24)
        Me.rdoCloudUnk.TabIndex = 1
        Me.rdoCloudUnk.Text = "Unknown"
        '
        'rdoNoCloud
        '
        Me.rdoNoCloud.Checked = True
        Me.rdoNoCloud.Location = New System.Drawing.Point(8, 8)
        Me.rdoNoCloud.Name = "rdoNoCloud"
        Me.rdoNoCloud.Size = New System.Drawing.Size(104, 24)
        Me.rdoNoCloud.TabIndex = 0
        Me.rdoNoCloud.TabStop = True
        Me.rdoNoCloud.Text = "Not reported"
        '
        'Label80
        '
        Me.Label80.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label80.Location = New System.Drawing.Point(24, 36)
        Me.Label80.Name = "Label80"
        Me.Label80.Size = New System.Drawing.Size(122, 23)
        Me.Label80.TabIndex = 0
        Me.Label80.Text = "Cloud Cover (optional)"
        '
        'tabSection3
        '
        Me.tabSection3.Controls.Add(Me.tabSDO)
        Me.tabSection3.Location = New System.Drawing.Point(4, 24)
        Me.tabSection3.Name = "tabSection3"
        Me.tabSection3.Size = New System.Drawing.Size(736, 432)
        Me.tabSection3.TabIndex = 2
        Me.tabSection3.Text = "Spatial Data Org"
        '
        'tabSDO
        '
        Me.tabSDO.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.tabSDO.Controls.Add(Me.tpSDOref)
        Me.tabSDO.Controls.Add(Me.tpSDOvector)
        Me.tabSDO.Controls.Add(Me.tpSDOraster)
        Me.tabSDO.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.tabSDO.ImageList = Me.ImageList1
        Me.tabSDO.Location = New System.Drawing.Point(0, 0)
        Me.tabSDO.Name = "tabSDO"
        Me.tabSDO.SelectedIndex = 0
        Me.tabSDO.Size = New System.Drawing.Size(740, 436)
        Me.tabSDO.TabIndex = 0
        '
        'tpSDOref
        '
        Me.tpSDOref.Controls.Add(Me.cboxDirect)
        Me.tpSDOref.Controls.Add(Me.Label72)
        Me.tpSDOref.Controls.Add(Me.txtIndirect)
        Me.tpSDOref.Controls.Add(Me.Label71)
        Me.tpSDOref.ImageIndex = 9
        Me.tpSDOref.Location = New System.Drawing.Point(4, 23)
        Me.tpSDOref.Name = "tpSDOref"
        Me.tpSDOref.Size = New System.Drawing.Size(732, 409)
        Me.tpSDOref.TabIndex = 0
        Me.tpSDOref.Text = "Reference methods"
        '
        'cboxDirect
        '
        Me.cboxDirect.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cboxDirect.Items.AddRange(New Object() {"", "Point", "Vector", "Raster"})
        Me.cboxDirect.Location = New System.Drawing.Point(208, 152)
        Me.cboxDirect.Name = "cboxDirect"
        Me.cboxDirect.Size = New System.Drawing.Size(121, 21)
        Me.cboxDirect.TabIndex = 3
        '
        'Label72
        '
        Me.Label72.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label72.Location = New System.Drawing.Point(24, 154)
        Me.Label72.Name = "Label72"
        Me.Label72.Size = New System.Drawing.Size(184, 23)
        Me.Label72.TabIndex = 2
        Me.Label72.Text = "Direct Spatial Reference Method"
        '
        'txtIndirect
        '
        Me.txtIndirect.Location = New System.Drawing.Point(24, 48)
        Me.txtIndirect.Multiline = True
        Me.txtIndirect.Name = "txtIndirect"
        Me.txtIndirect.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtIndirect.Size = New System.Drawing.Size(336, 80)
        Me.txtIndirect.TabIndex = 1
        Me.ToolTip1.SetToolTip(Me.txtIndirect, "types of features, addressing schemes through which locations are referenced")
        '
        'Label71
        '
        Me.Label71.Location = New System.Drawing.Point(24, 24)
        Me.Label71.Name = "Label71"
        Me.Label71.Size = New System.Drawing.Size(144, 23)
        Me.Label71.TabIndex = 0
        Me.Label71.Text = "Indirect Spatial Reference"
        '
        'tpSDOvector
        '
        Me.tpSDOvector.Controls.Add(Me.Panel12)
        Me.tpSDOvector.Controls.Add(Me.lblVector)
        Me.tpSDOvector.ImageIndex = 7
        Me.tpSDOvector.Location = New System.Drawing.Point(4, 23)
        Me.tpSDOvector.Name = "tpSDOvector"
        Me.tpSDOvector.Size = New System.Drawing.Size(736, 357)
        Me.tpSDOvector.TabIndex = 2
        Me.tpSDOvector.Text = "Vector Information"
        '
        'Panel12
        '
        Me.Panel12.Controls.Add(Me.Panel15)
        Me.Panel12.Controls.Add(Me.Panel14)
        Me.Panel12.Controls.Add(Me.Panel13)
        Me.Panel12.Controls.Add(Me.Label78)
        Me.Panel12.Location = New System.Drawing.Point(16, 48)
        Me.Panel12.Name = "Panel12"
        Me.Panel12.Size = New System.Drawing.Size(488, 304)
        Me.Panel12.TabIndex = 1
        '
        'Panel15
        '
        Me.Panel15.Controls.Add(Me.cboxVPF)
        Me.Panel15.Controls.Add(Me.Label81)
        Me.Panel15.Location = New System.Drawing.Point(16, 200)
        Me.Panel15.Name = "Panel15"
        Me.Panel15.Size = New System.Drawing.Size(288, 56)
        Me.Panel15.TabIndex = 8
        '
        'cboxVPF
        '
        Me.cboxVPF.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cboxVPF.Items.AddRange(New Object() {"0", "1", "2", "3"})
        Me.cboxVPF.Location = New System.Drawing.Point(136, 8)
        Me.cboxVPF.Name = "cboxVPF"
        Me.cboxVPF.Size = New System.Drawing.Size(64, 21)
        Me.cboxVPF.TabIndex = 3
        '
        'Label81
        '
        Me.Label81.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label81.Location = New System.Drawing.Point(8, 10)
        Me.Label81.Name = "Label81"
        Me.Label81.Size = New System.Drawing.Size(128, 23)
        Me.Label81.TabIndex = 2
        Me.Label81.Text = "VPF Topology Level"
        '
        'Panel14
        '
        Me.Panel14.Controls.Add(Me.btnDelTerm)
        Me.Panel14.Controls.Add(Me.btnEditTerm)
        Me.Panel14.Controls.Add(Me.btnAddTerm)
        Me.Panel14.Controls.Add(Me.lboxTerms)
        Me.Panel14.Controls.Add(Me.lblSDTS)
        Me.Panel14.Location = New System.Drawing.Point(16, 104)
        Me.Panel14.Name = "Panel14"
        Me.Panel14.Size = New System.Drawing.Size(448, 88)
        Me.Panel14.TabIndex = 7
        '
        'btnDelTerm
        '
        Me.btnDelTerm.Location = New System.Drawing.Point(344, 40)
        Me.btnDelTerm.Name = "btnDelTerm"
        Me.btnDelTerm.Size = New System.Drawing.Size(72, 23)
        Me.btnDelTerm.TabIndex = 11
        Me.btnDelTerm.Text = "Delete"
        '
        'btnEditTerm
        '
        Me.btnEditTerm.Location = New System.Drawing.Point(256, 40)
        Me.btnEditTerm.Name = "btnEditTerm"
        Me.btnEditTerm.Size = New System.Drawing.Size(64, 23)
        Me.btnEditTerm.TabIndex = 10
        Me.btnEditTerm.Text = "Edit"
        '
        'btnAddTerm
        '
        Me.btnAddTerm.Location = New System.Drawing.Point(168, 40)
        Me.btnAddTerm.Name = "btnAddTerm"
        Me.btnAddTerm.Size = New System.Drawing.Size(64, 23)
        Me.btnAddTerm.TabIndex = 9
        Me.btnAddTerm.Text = "Add"
        '
        'lboxTerms
        '
        Me.lboxTerms.Location = New System.Drawing.Point(160, 8)
        Me.lboxTerms.Name = "lboxTerms"
        Me.lboxTerms.Size = New System.Drawing.Size(264, 17)
        Me.lboxTerms.TabIndex = 8
        '
        'lblSDTS
        '
        Me.lblSDTS.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblSDTS.Location = New System.Drawing.Point(8, 8)
        Me.lblSDTS.Name = "lblSDTS"
        Me.lblSDTS.Size = New System.Drawing.Size(152, 23)
        Me.lblSDTS.TabIndex = 7
        Me.lblSDTS.Text = "SDTS Terms Descriptions"
        '
        'Panel13
        '
        Me.Panel13.Controls.Add(Me.rdoVPF)
        Me.Panel13.Controls.Add(Me.rdoSDTS)
        Me.Panel13.Controls.Add(Me.rdoNoDesc)
        Me.Panel13.Controls.Add(Me.Label79)
        Me.Panel13.Location = New System.Drawing.Point(16, 40)
        Me.Panel13.Name = "Panel13"
        Me.Panel13.Size = New System.Drawing.Size(456, 40)
        Me.Panel13.TabIndex = 1
        '
        'rdoVPF
        '
        Me.rdoVPF.Location = New System.Drawing.Point(368, 8)
        Me.rdoVPF.Name = "rdoVPF"
        Me.rdoVPF.Size = New System.Drawing.Size(80, 24)
        Me.rdoVPF.TabIndex = 3
        Me.rdoVPF.Text = "VPF terms"
        '
        'rdoSDTS
        '
        Me.rdoSDTS.Location = New System.Drawing.Point(272, 8)
        Me.rdoSDTS.Name = "rdoSDTS"
        Me.rdoSDTS.Size = New System.Drawing.Size(88, 24)
        Me.rdoSDTS.TabIndex = 2
        Me.rdoSDTS.Text = "SDTS terms"
        '
        'rdoNoDesc
        '
        Me.rdoNoDesc.Checked = True
        Me.rdoNoDesc.Location = New System.Drawing.Point(160, 8)
        Me.rdoNoDesc.Name = "rdoNoDesc"
        Me.rdoNoDesc.Size = New System.Drawing.Size(104, 24)
        Me.rdoNoDesc.TabIndex = 1
        Me.rdoNoDesc.TabStop = True
        Me.rdoNoDesc.Text = "No description"
        '
        'Label79
        '
        Me.Label79.Location = New System.Drawing.Point(8, 12)
        Me.Label79.Name = "Label79"
        Me.Label79.Size = New System.Drawing.Size(152, 20)
        Me.Label79.TabIndex = 0
        Me.Label79.Text = "Objects are described using:"
        '
        'Label78
        '
        Me.Label78.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label78.Location = New System.Drawing.Point(136, 8)
        Me.Label78.Name = "Label78"
        Me.Label78.Size = New System.Drawing.Size(216, 23)
        Me.Label78.TabIndex = 0
        Me.Label78.Text = "Point and Vector Object Information"
        Me.Label78.TextAlign = System.Drawing.ContentAlignment.TopCenter
        '
        'lblVector
        '
        Me.lblVector.Font = New System.Drawing.Font("Microsoft Sans Serif", 10.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblVector.Location = New System.Drawing.Point(224, 8)
        Me.lblVector.Name = "lblVector"
        Me.lblVector.Size = New System.Drawing.Size(296, 40)
        Me.lblVector.TabIndex = 0
        Me.lblVector.Text = "Not Applicable Unless ""Point"" or ""Vector"" Chosen as Direct Spatial Reference Meth" & _
            "od"
        Me.lblVector.TextAlign = System.Drawing.ContentAlignment.TopCenter
        '
        'tpSDOraster
        '
        Me.tpSDOraster.Controls.Add(Me.Panel10)
        Me.tpSDOraster.Controls.Add(Me.lblRaster)
        Me.tpSDOraster.ImageIndex = 7
        Me.tpSDOraster.Location = New System.Drawing.Point(4, 23)
        Me.tpSDOraster.Name = "tpSDOraster"
        Me.tpSDOraster.Size = New System.Drawing.Size(736, 357)
        Me.tpSDOraster.TabIndex = 3
        Me.tpSDOraster.Text = "Raster Information"
        '
        'Panel10
        '
        Me.Panel10.Controls.Add(Me.cboxRasType)
        Me.Panel10.Controls.Add(Me.Panel11)
        Me.Panel10.Controls.Add(Me.Label73)
        Me.Panel10.Location = New System.Drawing.Point(24, 48)
        Me.Panel10.Name = "Panel10"
        Me.Panel10.Size = New System.Drawing.Size(400, 328)
        Me.Panel10.TabIndex = 2
        '
        'cboxRasType
        '
        Me.cboxRasType.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cboxRasType.Items.AddRange(New Object() {"", "Point", "Pixel", "Grid Cell", "Voxel"})
        Me.cboxRasType.Location = New System.Drawing.Point(136, 16)
        Me.cboxRasType.Name = "cboxRasType"
        Me.cboxRasType.Size = New System.Drawing.Size(121, 21)
        Me.cboxRasType.TabIndex = 1
        '
        'Panel11
        '
        Me.Panel11.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.Panel11.Controls.Add(Me.TextBox6)
        Me.Panel11.Controls.Add(Me.numRasCol)
        Me.Panel11.Controls.Add(Me.numRasRow)
        Me.Panel11.Controls.Add(Me.numRasVert)
        Me.Panel11.Controls.Add(Me.Label77)
        Me.Panel11.Controls.Add(Me.Label76)
        Me.Panel11.Controls.Add(Me.Label75)
        Me.Panel11.Controls.Add(Me.Label74)
        Me.Panel11.Location = New System.Drawing.Point(16, 56)
        Me.Panel11.Name = "Panel11"
        Me.Panel11.Size = New System.Drawing.Size(288, 248)
        Me.Panel11.TabIndex = 2
        '
        'TextBox6
        '
        Me.TextBox6.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.TextBox6.Location = New System.Drawing.Point(16, 160)
        Me.TextBox6.Multiline = True
        Me.TextBox6.Name = "TextBox6"
        Me.TextBox6.ReadOnly = True
        Me.TextBox6.Size = New System.Drawing.Size(240, 80)
        Me.TextBox6.TabIndex = 10
        Me.TextBox6.Text = "Only counts > 0 will be included in the metadata document." & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "The counter will fo" & _
            "rmat the input value if you press Enter while the cursor is in the counter."
        '
        'numRasCol
        '
        Me.numRasCol.Location = New System.Drawing.Point(96, 78)
        Me.numRasCol.Maximum = New Decimal(New Integer() {1000000000, 0, 0, 0})
        Me.numRasCol.Name = "numRasCol"
        Me.numRasCol.Size = New System.Drawing.Size(120, 20)
        Me.numRasCol.TabIndex = 3
        Me.numRasCol.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.numRasCol.ThousandsSeparator = True
        Me.ToolTip1.SetToolTip(Me.numRasCol, "max # of objects along x-axis")
        '
        'numRasRow
        '
        Me.numRasRow.Location = New System.Drawing.Point(96, 40)
        Me.numRasRow.Maximum = New Decimal(New Integer() {1000000000, 0, 0, 0})
        Me.numRasRow.Name = "numRasRow"
        Me.numRasRow.Size = New System.Drawing.Size(120, 20)
        Me.numRasRow.TabIndex = 2
        Me.numRasRow.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.numRasRow.ThousandsSeparator = True
        Me.ToolTip1.SetToolTip(Me.numRasRow, "max # of objects along y-axis")
        '
        'numRasVert
        '
        Me.numRasVert.Location = New System.Drawing.Point(96, 118)
        Me.numRasVert.Maximum = New Decimal(New Integer() {1000000000, 0, 0, 0})
        Me.numRasVert.Name = "numRasVert"
        Me.numRasVert.Size = New System.Drawing.Size(120, 20)
        Me.numRasVert.TabIndex = 4
        Me.numRasVert.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.numRasVert.ThousandsSeparator = True
        Me.ToolTip1.SetToolTip(Me.numRasVert, "max # of objects along z-axis")
        '
        'Label77
        '
        Me.Label77.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label77.Location = New System.Drawing.Point(8, 120)
        Me.Label77.Name = "Label77"
        Me.Label77.Size = New System.Drawing.Size(80, 23)
        Me.Label77.TabIndex = 9
        Me.Label77.Text = "Vertical Count"
        '
        'Label76
        '
        Me.Label76.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label76.Location = New System.Drawing.Point(8, 80)
        Me.Label76.Name = "Label76"
        Me.Label76.Size = New System.Drawing.Size(88, 23)
        Me.Label76.TabIndex = 8
        Me.Label76.Text = "Column Count"
        '
        'Label75
        '
        Me.Label75.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label75.Location = New System.Drawing.Point(8, 40)
        Me.Label75.Name = "Label75"
        Me.Label75.Size = New System.Drawing.Size(72, 23)
        Me.Label75.TabIndex = 7
        Me.Label75.Text = "Row Count"
        '
        'Label74
        '
        Me.Label74.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label74.Location = New System.Drawing.Point(93, 8)
        Me.Label74.Name = "Label74"
        Me.Label74.Size = New System.Drawing.Size(100, 23)
        Me.Label74.TabIndex = 0
        Me.Label74.Text = "Counts (optional)"
        '
        'Label73
        '
        Me.Label73.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label73.Location = New System.Drawing.Point(16, 16)
        Me.Label73.Name = "Label73"
        Me.Label73.Size = New System.Drawing.Size(120, 23)
        Me.Label73.TabIndex = 0
        Me.Label73.Text = "Raster Object Type"
        '
        'lblRaster
        '
        Me.lblRaster.Font = New System.Drawing.Font("Microsoft Sans Serif", 10.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRaster.Location = New System.Drawing.Point(224, 8)
        Me.lblRaster.Name = "lblRaster"
        Me.lblRaster.Size = New System.Drawing.Size(296, 40)
        Me.lblRaster.TabIndex = 1
        Me.lblRaster.Text = "Not Applicable Unless ""Raster"" Chosen as Direct Spatial Reference Method"
        Me.lblRaster.TextAlign = System.Drawing.ContentAlignment.TopCenter
        '
        'tabSection4
        '
        Me.tabSection4.Controls.Add(Me.tabSR)
        Me.tabSection4.Location = New System.Drawing.Point(4, 24)
        Me.tabSection4.Name = "tabSection4"
        Me.tabSection4.Size = New System.Drawing.Size(736, 432)
        Me.tabSection4.TabIndex = 3
        Me.tabSection4.Text = "Spatial Reference"
        '
        'tabSR
        '
        Me.tabSR.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.tabSR.Controls.Add(Me.tpSRhoriz)
        Me.tabSR.Controls.Add(Me.tpSRvert)
        Me.tabSR.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.tabSR.ImageList = Me.ImageList1
        Me.tabSR.Location = New System.Drawing.Point(0, 0)
        Me.tabSR.Name = "tabSR"
        Me.tabSR.SelectedIndex = 0
        Me.tabSR.Size = New System.Drawing.Size(744, 436)
        Me.tabSR.TabIndex = 0
        '
        'tpSRhoriz
        '
        Me.tpSRhoriz.AutoScroll = True
        Me.tpSRhoriz.Controls.Add(Me.pnlGeodetic)
        Me.tpSRhoriz.Controls.Add(Me.pnlLocal)
        Me.tpSRhoriz.Controls.Add(Me.pnlPlanar)
        Me.tpSRhoriz.Controls.Add(Me.pnlGeographic)
        Me.tpSRhoriz.Controls.Add(Me.pnlHoriz)
        Me.tpSRhoriz.Controls.Add(Me.Label115)
        Me.tpSRhoriz.ImageIndex = 9
        Me.tpSRhoriz.Location = New System.Drawing.Point(4, 23)
        Me.tpSRhoriz.Name = "tpSRhoriz"
        Me.tpSRhoriz.Size = New System.Drawing.Size(736, 409)
        Me.tpSRhoriz.TabIndex = 0
        Me.tpSRhoriz.Text = "Horizontal Coordinate System Definition"
        '
        'pnlGeodetic
        '
        Me.pnlGeodetic.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.pnlGeodetic.Controls.Add(Me.numFlatten)
        Me.pnlGeodetic.Controls.Add(Me.Label128)
        Me.pnlGeodetic.Controls.Add(Me.numSemiMajor)
        Me.pnlGeodetic.Controls.Add(Me.Label127)
        Me.pnlGeodetic.Controls.Add(Me.cboxEllipsoid)
        Me.pnlGeodetic.Controls.Add(Me.Label126)
        Me.pnlGeodetic.Controls.Add(Me.cboxHorizName)
        Me.pnlGeodetic.Controls.Add(Me.Label125)
        Me.pnlGeodetic.Controls.Add(Me.Label124)
        Me.pnlGeodetic.Location = New System.Drawing.Point(16, 240)
        Me.pnlGeodetic.Name = "pnlGeodetic"
        Me.pnlGeodetic.Size = New System.Drawing.Size(432, 144)
        Me.pnlGeodetic.TabIndex = 5
        '
        'numFlatten
        '
        Me.numFlatten.DecimalPlaces = 8
        Me.numFlatten.Location = New System.Drawing.Point(248, 104)
        Me.numFlatten.Maximum = New Decimal(New Integer() {400, 0, 0, 0})
        Me.numFlatten.Name = "numFlatten"
        Me.numFlatten.Size = New System.Drawing.Size(120, 20)
        Me.numFlatten.TabIndex = 8
        Me.numFlatten.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.ToolTip1.SetToolTip(Me.numFlatten, "Semi-major/(Semi-major - Semi-minor)")
        Me.numFlatten.Value = New Decimal(New Integer() {1469306664, 6944, 0, 720896})
        '
        'Label128
        '
        Me.Label128.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label128.Location = New System.Drawing.Point(240, 88)
        Me.Label128.Name = "Label128"
        Me.Label128.Size = New System.Drawing.Size(184, 24)
        Me.Label128.TabIndex = 7
        Me.Label128.Text = "Denominator of Flattening Ratio"
        Me.ToolTip1.SetToolTip(Me.Label128, "Semi-major/(Semi-major - Semi-minor)")
        '
        'numSemiMajor
        '
        Me.numSemiMajor.DecimalPlaces = 4
        Me.numSemiMajor.Location = New System.Drawing.Point(248, 48)
        Me.numSemiMajor.Maximum = New Decimal(New Integer() {6500000, 0, 0, 0})
        Me.numSemiMajor.Name = "numSemiMajor"
        Me.numSemiMajor.Size = New System.Drawing.Size(120, 20)
        Me.numSemiMajor.TabIndex = 6
        Me.numSemiMajor.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.numSemiMajor.ThousandsSeparator = True
        Me.ToolTip1.SetToolTip(Me.numSemiMajor, "radius of the equatorial axis of the ellipsoid")
        Me.numSemiMajor.Value = New Decimal(New Integer() {6378137, 0, 0, 0})
        '
        'Label127
        '
        Me.Label127.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label127.Location = New System.Drawing.Point(240, 32)
        Me.Label127.Name = "Label127"
        Me.Label127.Size = New System.Drawing.Size(104, 24)
        Me.Label127.TabIndex = 5
        Me.Label127.Text = "Semi-major Axis"
        Me.ToolTip1.SetToolTip(Me.Label127, "radius of the equatorial axis of the ellipsoid")
        '
        'cboxEllipsoid
        '
        Me.cboxEllipsoid.Items.AddRange(New Object() {"Clarke 1866", "Geodetic Reference System 80", "World Geodetic System of 1984"})
        Me.cboxEllipsoid.Location = New System.Drawing.Point(8, 104)
        Me.cboxEllipsoid.Name = "cboxEllipsoid"
        Me.cboxEllipsoid.Size = New System.Drawing.Size(200, 21)
        Me.cboxEllipsoid.TabIndex = 4
        Me.ToolTip1.SetToolTip(Me.cboxEllipsoid, "representation of Earth's shape")
        '
        'Label126
        '
        Me.Label126.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label126.Location = New System.Drawing.Point(8, 88)
        Me.Label126.Name = "Label126"
        Me.Label126.Size = New System.Drawing.Size(136, 24)
        Me.Label126.TabIndex = 3
        Me.Label126.Text = "Ellipsoid Name"
        '
        'cboxHorizName
        '
        Me.cboxHorizName.Items.AddRange(New Object() {"North American Datum of 1927", "North American Datum of 1983", "World Geodetic System of 1984"})
        Me.cboxHorizName.Location = New System.Drawing.Point(8, 48)
        Me.cboxHorizName.Name = "cboxHorizName"
        Me.cboxHorizName.Size = New System.Drawing.Size(200, 21)
        Me.cboxHorizName.TabIndex = 2
        Me.ToolTip1.SetToolTip(Me.cboxHorizName, "reference system for coordinates")
        '
        'Label125
        '
        Me.Label125.Location = New System.Drawing.Point(8, 32)
        Me.Label125.Name = "Label125"
        Me.Label125.Size = New System.Drawing.Size(136, 16)
        Me.Label125.TabIndex = 1
        Me.Label125.Text = "Horizontal Datum Name"
        '
        'Label124
        '
        Me.Label124.Location = New System.Drawing.Point(164, 8)
        Me.Label124.Name = "Label124"
        Me.Label124.Size = New System.Drawing.Size(100, 23)
        Me.Label124.TabIndex = 0
        Me.Label124.Text = "Geodetic Model"
        Me.Label124.TextAlign = System.Drawing.ContentAlignment.TopCenter
        '
        'pnlLocal
        '
        Me.pnlLocal.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.pnlLocal.Controls.Add(Me.txtLocalGeoInfo)
        Me.pnlLocal.Controls.Add(Me.Label123)
        Me.pnlLocal.Controls.Add(Me.txtLocalDesc)
        Me.pnlLocal.Controls.Add(Me.Label122)
        Me.pnlLocal.Controls.Add(Me.Label121)
        Me.pnlLocal.Location = New System.Drawing.Point(488, 56)
        Me.pnlLocal.Name = "pnlLocal"
        Me.pnlLocal.Size = New System.Drawing.Size(224, 216)
        Me.pnlLocal.TabIndex = 4
        '
        'txtLocalGeoInfo
        '
        Me.txtLocalGeoInfo.Location = New System.Drawing.Point(8, 144)
        Me.txtLocalGeoInfo.Multiline = True
        Me.txtLocalGeoInfo.Name = "txtLocalGeoInfo"
        Me.txtLocalGeoInfo.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtLocalGeoInfo.Size = New System.Drawing.Size(200, 56)
        Me.txtLocalGeoInfo.TabIndex = 4
        Me.ToolTip1.SetToolTip(Me.txtLocalGeoInfo, "description of info provided to register the local system to the Earth")
        '
        'Label123
        '
        Me.Label123.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label123.Location = New System.Drawing.Point(8, 128)
        Me.Label123.Name = "Label123"
        Me.Label123.Size = New System.Drawing.Size(184, 23)
        Me.Label123.TabIndex = 3
        Me.Label123.Text = "Local Georeference Information"
        '
        'txtLocalDesc
        '
        Me.txtLocalDesc.Location = New System.Drawing.Point(8, 56)
        Me.txtLocalDesc.Multiline = True
        Me.txtLocalDesc.Name = "txtLocalDesc"
        Me.txtLocalDesc.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtLocalDesc.Size = New System.Drawing.Size(200, 56)
        Me.txtLocalDesc.TabIndex = 2
        Me.ToolTip1.SetToolTip(Me.txtLocalDesc, "description of coordinate system and its orientation to Earth's surface")
        '
        'Label122
        '
        Me.Label122.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label122.Location = New System.Drawing.Point(8, 40)
        Me.Label122.Name = "Label122"
        Me.Label122.Size = New System.Drawing.Size(112, 23)
        Me.Label122.TabIndex = 1
        Me.Label122.Text = "Local Description"
        '
        'Label121
        '
        Me.Label121.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label121.Location = New System.Drawing.Point(75, 8)
        Me.Label121.Name = "Label121"
        Me.Label121.Size = New System.Drawing.Size(72, 23)
        Me.Label121.TabIndex = 0
        Me.Label121.Text = "Local"
        Me.Label121.TextAlign = System.Drawing.ContentAlignment.TopCenter
        '
        'pnlPlanar
        '
        Me.pnlPlanar.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.pnlPlanar.Controls.Add(Me.btnDelPlanar)
        Me.pnlPlanar.Controls.Add(Me.btnEditPlanar)
        Me.pnlPlanar.Controls.Add(Me.btnAddPlanar)
        Me.pnlPlanar.Controls.Add(Me.lboxPlanar)
        Me.pnlPlanar.Controls.Add(Me.Label119)
        Me.pnlPlanar.Location = New System.Drawing.Point(264, 56)
        Me.pnlPlanar.Name = "pnlPlanar"
        Me.pnlPlanar.Size = New System.Drawing.Size(208, 112)
        Me.pnlPlanar.TabIndex = 3
        '
        'btnDelPlanar
        '
        Me.btnDelPlanar.Location = New System.Drawing.Point(128, 72)
        Me.btnDelPlanar.Name = "btnDelPlanar"
        Me.btnDelPlanar.Size = New System.Drawing.Size(56, 23)
        Me.btnDelPlanar.TabIndex = 4
        Me.btnDelPlanar.Text = "Delete"
        '
        'btnEditPlanar
        '
        Me.btnEditPlanar.Location = New System.Drawing.Point(72, 72)
        Me.btnEditPlanar.Name = "btnEditPlanar"
        Me.btnEditPlanar.Size = New System.Drawing.Size(48, 23)
        Me.btnEditPlanar.TabIndex = 3
        Me.btnEditPlanar.Text = "Edit"
        '
        'btnAddPlanar
        '
        Me.btnAddPlanar.Location = New System.Drawing.Point(16, 72)
        Me.btnAddPlanar.Name = "btnAddPlanar"
        Me.btnAddPlanar.Size = New System.Drawing.Size(48, 23)
        Me.btnAddPlanar.TabIndex = 2
        Me.btnAddPlanar.Text = "Add"
        '
        'lboxPlanar
        '
        Me.lboxPlanar.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxPlanar.Location = New System.Drawing.Point(8, 40)
        Me.lboxPlanar.Name = "lboxPlanar"
        Me.lboxPlanar.Size = New System.Drawing.Size(184, 26)
        Me.lboxPlanar.TabIndex = 1
        Me.lboxPlanar.TabStop = False
        '
        'Label119
        '
        Me.Label119.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label119.Location = New System.Drawing.Point(53, 8)
        Me.Label119.Name = "Label119"
        Me.Label119.Size = New System.Drawing.Size(100, 23)
        Me.Label119.TabIndex = 0
        Me.Label119.Text = "Planar"
        Me.Label119.TextAlign = System.Drawing.ContentAlignment.TopCenter
        '
        'pnlGeographic
        '
        Me.pnlGeographic.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.pnlGeographic.Controls.Add(Me.Label120)
        Me.pnlGeographic.Controls.Add(Me.cboxGeoCoorUnits)
        Me.pnlGeographic.Controls.Add(Me.Label118)
        Me.pnlGeographic.Controls.Add(Me.numLongRes)
        Me.pnlGeographic.Controls.Add(Me.Label117)
        Me.pnlGeographic.Controls.Add(Me.numLatRes)
        Me.pnlGeographic.Controls.Add(Me.Label116)
        Me.pnlGeographic.Location = New System.Drawing.Point(16, 56)
        Me.pnlGeographic.Name = "pnlGeographic"
        Me.pnlGeographic.Size = New System.Drawing.Size(232, 160)
        Me.pnlGeographic.TabIndex = 2
        '
        'Label120
        '
        Me.Label120.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label120.Location = New System.Drawing.Point(72, 8)
        Me.Label120.Name = "Label120"
        Me.Label120.Size = New System.Drawing.Size(100, 23)
        Me.Label120.TabIndex = 6
        Me.Label120.Text = "Geographic"
        Me.Label120.TextAlign = System.Drawing.ContentAlignment.TopCenter
        '
        'cboxGeoCoorUnits
        '
        Me.cboxGeoCoorUnits.Items.AddRange(New Object() {"Decimal degrees", "Decimal minutes", "Decimal seconds", "Degrees and decimal minutes", "Degrees, minutes, and decimal seconds", "Radians", "Grads"})
        Me.cboxGeoCoorUnits.Location = New System.Drawing.Point(8, 120)
        Me.cboxGeoCoorUnits.Name = "cboxGeoCoorUnits"
        Me.cboxGeoCoorUnits.Size = New System.Drawing.Size(216, 21)
        Me.cboxGeoCoorUnits.TabIndex = 5
        Me.ToolTip1.SetToolTip(Me.cboxGeoCoorUnits, "units of measure for lat and long values")
        '
        'Label118
        '
        Me.Label118.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label118.Location = New System.Drawing.Point(8, 104)
        Me.Label118.Name = "Label118"
        Me.Label118.Size = New System.Drawing.Size(176, 16)
        Me.Label118.TabIndex = 4
        Me.Label118.Text = "Geographic Coordinate Units"
        '
        'numLongRes
        '
        Me.numLongRes.DecimalPlaces = 8
        Me.numLongRes.Location = New System.Drawing.Point(128, 72)
        Me.numLongRes.Maximum = New Decimal(New Integer() {90, 0, 0, 0})
        Me.numLongRes.Name = "numLongRes"
        Me.numLongRes.Size = New System.Drawing.Size(88, 20)
        Me.numLongRes.TabIndex = 3
        Me.numLongRes.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.ToolTip1.SetToolTip(Me.numLongRes, "min diff adjacent long values, Geo Coor Units")
        '
        'Label117
        '
        Me.Label117.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label117.Location = New System.Drawing.Point(8, 72)
        Me.Label117.Name = "Label117"
        Me.Label117.Size = New System.Drawing.Size(120, 24)
        Me.Label117.TabIndex = 2
        Me.Label117.Text = "Longitude Resolution"
        Me.ToolTip1.SetToolTip(Me.Label117, "min diff adjacent long values, Geo Coor Units")
        '
        'numLatRes
        '
        Me.numLatRes.DecimalPlaces = 8
        Me.numLatRes.Location = New System.Drawing.Point(128, 40)
        Me.numLatRes.Maximum = New Decimal(New Integer() {90, 0, 0, 0})
        Me.numLatRes.Name = "numLatRes"
        Me.numLatRes.Size = New System.Drawing.Size(88, 20)
        Me.numLatRes.TabIndex = 1
        Me.numLatRes.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.ToolTip1.SetToolTip(Me.numLatRes, "min diff between adjacent lat values, in Geo Coor Units")
        '
        'Label116
        '
        Me.Label116.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label116.Location = New System.Drawing.Point(8, 40)
        Me.Label116.Name = "Label116"
        Me.Label116.Size = New System.Drawing.Size(112, 24)
        Me.Label116.TabIndex = 0
        Me.Label116.Text = "Latitude Resolution"
        Me.ToolTip1.SetToolTip(Me.Label116, "min diff between adjacent lat values, in Geo Coor Units")
        '
        'pnlHoriz
        '
        Me.pnlHoriz.Controls.Add(Me.rdoNone)
        Me.pnlHoriz.Controls.Add(Me.rdoLocal)
        Me.pnlHoriz.Controls.Add(Me.rdoPlanar)
        Me.pnlHoriz.Controls.Add(Me.rdoGeographic)
        Me.pnlHoriz.Location = New System.Drawing.Point(136, 8)
        Me.pnlHoriz.Name = "pnlHoriz"
        Me.pnlHoriz.Size = New System.Drawing.Size(328, 40)
        Me.pnlHoriz.TabIndex = 1
        '
        'rdoNone
        '
        Me.rdoNone.Checked = True
        Me.rdoNone.Location = New System.Drawing.Point(232, 8)
        Me.rdoNone.Name = "rdoNone"
        Me.rdoNone.Size = New System.Drawing.Size(88, 24)
        Me.rdoNone.TabIndex = 3
        Me.rdoNone.TabStop = True
        Me.rdoNone.Text = "No definition"
        '
        'rdoLocal
        '
        Me.rdoLocal.Location = New System.Drawing.Point(168, 8)
        Me.rdoLocal.Name = "rdoLocal"
        Me.rdoLocal.Size = New System.Drawing.Size(64, 24)
        Me.rdoLocal.TabIndex = 2
        Me.rdoLocal.Text = "Local"
        '
        'rdoPlanar
        '
        Me.rdoPlanar.Location = New System.Drawing.Point(96, 8)
        Me.rdoPlanar.Name = "rdoPlanar"
        Me.rdoPlanar.Size = New System.Drawing.Size(72, 24)
        Me.rdoPlanar.TabIndex = 1
        Me.rdoPlanar.Text = "Planar"
        '
        'rdoGeographic
        '
        Me.rdoGeographic.Location = New System.Drawing.Point(8, 8)
        Me.rdoGeographic.Name = "rdoGeographic"
        Me.rdoGeographic.Size = New System.Drawing.Size(88, 24)
        Me.rdoGeographic.TabIndex = 0
        Me.rdoGeographic.Text = "Geographic"
        '
        'Label115
        '
        Me.Label115.Location = New System.Drawing.Point(16, 16)
        Me.Label115.Name = "Label115"
        Me.Label115.Size = New System.Drawing.Size(120, 32)
        Me.Label115.TabIndex = 0
        Me.Label115.Text = "Horizontal Coordinate System Definition:"
        '
        'tpSRvert
        '
        Me.tpSRvert.AutoScroll = True
        Me.tpSRvert.Controls.Add(Me.pnlDepth)
        Me.tpSRvert.Controls.Add(Me.pnlAltitude)
        Me.tpSRvert.ImageIndex = 9
        Me.tpSRvert.Location = New System.Drawing.Point(4, 23)
        Me.tpSRvert.Name = "tpSRvert"
        Me.tpSRvert.Size = New System.Drawing.Size(740, 357)
        Me.tpSRvert.TabIndex = 1
        Me.tpSRvert.Text = "Vertical Coordinate System Definition"
        '
        'pnlDepth
        '
        Me.pnlDepth.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.pnlDepth.Controls.Add(Me.cboxDepthEncode)
        Me.pnlDepth.Controls.Add(Me.Label112)
        Me.pnlDepth.Controls.Add(Me.cboxDepthUnits)
        Me.pnlDepth.Controls.Add(Me.Label113)
        Me.pnlDepth.Controls.Add(Me.btnClrDepthRes)
        Me.pnlDepth.Controls.Add(Me.btnAddDepth)
        Me.pnlDepth.Controls.Add(Me.numDepthRes)
        Me.pnlDepth.Controls.Add(Me.txtDepthRes)
        Me.pnlDepth.Controls.Add(Me.Label114)
        Me.pnlDepth.Controls.Add(Me.cboxDepthDatum)
        Me.pnlDepth.Controls.Add(Me.Label108)
        Me.pnlDepth.Controls.Add(Me.Label106)
        Me.pnlDepth.Location = New System.Drawing.Point(376, 8)
        Me.pnlDepth.Name = "pnlDepth"
        Me.pnlDepth.Size = New System.Drawing.Size(344, 344)
        Me.pnlDepth.TabIndex = 1
        '
        'cboxDepthEncode
        '
        Me.cboxDepthEncode.Items.AddRange(New Object() {"Explicit depth coordinate included with horizontal coordinates", "Implicit coordinate", "Attribute values"})
        Me.cboxDepthEncode.Location = New System.Drawing.Point(8, 296)
        Me.cboxDepthEncode.Name = "cboxDepthEncode"
        Me.cboxDepthEncode.Size = New System.Drawing.Size(320, 21)
        Me.cboxDepthEncode.TabIndex = 20
        Me.ToolTip1.SetToolTip(Me.cboxDepthEncode, "means used to encode the depths")
        '
        'Label112
        '
        Me.Label112.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label112.Location = New System.Drawing.Point(8, 280)
        Me.Label112.Name = "Label112"
        Me.Label112.Size = New System.Drawing.Size(152, 24)
        Me.Label112.TabIndex = 19
        Me.Label112.Text = "Depth Encoding Method"
        '
        'cboxDepthUnits
        '
        Me.cboxDepthUnits.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cboxDepthUnits.Items.AddRange(New Object() {"meters", "feet"})
        Me.cboxDepthUnits.Location = New System.Drawing.Point(136, 240)
        Me.cboxDepthUnits.Name = "cboxDepthUnits"
        Me.cboxDepthUnits.Size = New System.Drawing.Size(136, 21)
        Me.cboxDepthUnits.TabIndex = 18
        Me.ToolTip1.SetToolTip(Me.cboxDepthUnits, "units in which depths are recorded")
        '
        'Label113
        '
        Me.Label113.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label113.Location = New System.Drawing.Point(8, 240)
        Me.Label113.Name = "Label113"
        Me.Label113.Size = New System.Drawing.Size(128, 24)
        Me.Label113.TabIndex = 17
        Me.Label113.Text = "Depth Distance Units"
        '
        'btnClrDepthRes
        '
        Me.btnClrDepthRes.Location = New System.Drawing.Point(216, 184)
        Me.btnClrDepthRes.Name = "btnClrDepthRes"
        Me.btnClrDepthRes.Size = New System.Drawing.Size(75, 23)
        Me.btnClrDepthRes.TabIndex = 16
        Me.btnClrDepthRes.Text = "Clear the list"
        '
        'btnAddDepth
        '
        Me.btnAddDepth.Location = New System.Drawing.Point(216, 128)
        Me.btnAddDepth.Name = "btnAddDepth"
        Me.btnAddDepth.Size = New System.Drawing.Size(72, 32)
        Me.btnAddDepth.TabIndex = 15
        Me.btnAddDepth.Text = "Add value to list"
        '
        'numDepthRes
        '
        Me.numDepthRes.DecimalPlaces = 2
        Me.numDepthRes.Location = New System.Drawing.Point(208, 104)
        Me.numDepthRes.Maximum = New Decimal(New Integer() {100000, 0, 0, 0})
        Me.numDepthRes.Name = "numDepthRes"
        Me.numDepthRes.Size = New System.Drawing.Size(96, 20)
        Me.numDepthRes.TabIndex = 14
        Me.numDepthRes.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'txtDepthRes
        '
        Me.txtDepthRes.AcceptsReturn = True
        Me.txtDepthRes.Location = New System.Drawing.Point(88, 96)
        Me.txtDepthRes.Multiline = True
        Me.txtDepthRes.Name = "txtDepthRes"
        Me.txtDepthRes.ReadOnly = True
        Me.txtDepthRes.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtDepthRes.Size = New System.Drawing.Size(96, 120)
        Me.txtDepthRes.TabIndex = 13
        Me.txtDepthRes.TabStop = False
        Me.ToolTip1.SetToolTip(Me.txtDepthRes, "min distance possible between 2 adjacent depth values, in Depth Dist Units of mea" & _
                "sure")
        '
        'Label114
        '
        Me.Label114.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label114.Location = New System.Drawing.Point(8, 96)
        Me.Label114.Name = "Label114"
        Me.Label114.Size = New System.Drawing.Size(80, 32)
        Me.Label114.TabIndex = 12
        Me.Label114.Text = "Depth Resolution"
        '
        'cboxDepthDatum
        '
        Me.cboxDepthDatum.Items.AddRange(New Object() {"Local surface", "Chart datum; datum for sounding reduction", "Lowest astronomical tide", "Highest astronomical tide", "Mean low water", "Mean high water", "Mean sea level", "Land survey datum", "Mean low water springs", "Mean high water springs", "Mean low water neap", "Mean high water neap", "Mean lower low water", "Mean lower low water springs", "Mean higher high water", "Mean higher low water", "Mean lower high water", "Spring tide", "Tropic lower low water", "Neap tide", "High water", "Higher high water", "Low water", "Low-water datum", "Lowest low water", "Lower low water", "Lowest normal low water", "Mean tide level", "Indian spring low water", "High-water full and charge", "Low-water full and charge", "Columbia River datum", "Gulf Coast low water datum", "Equatorial springs low water", "Approximate lowest astronomical tide", "No correction"})
        Me.cboxDepthDatum.Location = New System.Drawing.Point(96, 40)
        Me.cboxDepthDatum.Name = "cboxDepthDatum"
        Me.cboxDepthDatum.Size = New System.Drawing.Size(232, 21)
        Me.cboxDepthDatum.TabIndex = 4
        '
        'Label108
        '
        Me.Label108.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label108.Location = New System.Drawing.Point(8, 40)
        Me.Label108.Name = "Label108"
        Me.Label108.Size = New System.Drawing.Size(80, 32)
        Me.Label108.TabIndex = 3
        Me.Label108.Text = "Depth Datum Name"
        '
        'Label106
        '
        Me.Label106.Location = New System.Drawing.Point(99, 8)
        Me.Label106.Name = "Label106"
        Me.Label106.Size = New System.Drawing.Size(144, 23)
        Me.Label106.TabIndex = 1
        Me.Label106.Text = "Depth System Definition"
        Me.Label106.TextAlign = System.Drawing.ContentAlignment.TopCenter
        '
        'pnlAltitude
        '
        Me.pnlAltitude.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.pnlAltitude.Controls.Add(Me.cboxAltEncode)
        Me.pnlAltitude.Controls.Add(Me.Label111)
        Me.pnlAltitude.Controls.Add(Me.cboxAltUnits)
        Me.pnlAltitude.Controls.Add(Me.Label110)
        Me.pnlAltitude.Controls.Add(Me.btnClearAltRes)
        Me.pnlAltitude.Controls.Add(Me.btnAddAltRes)
        Me.pnlAltitude.Controls.Add(Me.numAltRes)
        Me.pnlAltitude.Controls.Add(Me.txtAltRes)
        Me.pnlAltitude.Controls.Add(Me.Label109)
        Me.pnlAltitude.Controls.Add(Me.cboxAltDatum)
        Me.pnlAltitude.Controls.Add(Me.Label107)
        Me.pnlAltitude.Controls.Add(Me.Label105)
        Me.pnlAltitude.Location = New System.Drawing.Point(8, 8)
        Me.pnlAltitude.Name = "pnlAltitude"
        Me.pnlAltitude.Size = New System.Drawing.Size(352, 344)
        Me.pnlAltitude.TabIndex = 0
        '
        'cboxAltEncode
        '
        Me.cboxAltEncode.Items.AddRange(New Object() {"Explicit elevation coordinate included with horizontal coordinates", "Implicit coordinate", "Attribute values"})
        Me.cboxAltEncode.Location = New System.Drawing.Point(8, 296)
        Me.cboxAltEncode.Name = "cboxAltEncode"
        Me.cboxAltEncode.Size = New System.Drawing.Size(328, 21)
        Me.cboxAltEncode.TabIndex = 11
        Me.ToolTip1.SetToolTip(Me.cboxAltEncode, "means used to encode the altitudes")
        '
        'Label111
        '
        Me.Label111.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label111.Location = New System.Drawing.Point(8, 280)
        Me.Label111.Name = "Label111"
        Me.Label111.Size = New System.Drawing.Size(160, 16)
        Me.Label111.TabIndex = 10
        Me.Label111.Text = "Altitude Encoding Method"
        '
        'cboxAltUnits
        '
        Me.cboxAltUnits.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cboxAltUnits.Items.AddRange(New Object() {"meters", "feet"})
        Me.cboxAltUnits.Location = New System.Drawing.Point(144, 240)
        Me.cboxAltUnits.Name = "cboxAltUnits"
        Me.cboxAltUnits.Size = New System.Drawing.Size(136, 21)
        Me.cboxAltUnits.TabIndex = 9
        Me.ToolTip1.SetToolTip(Me.cboxAltUnits, "units in which altitudes are recorded")
        '
        'Label110
        '
        Me.Label110.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label110.Location = New System.Drawing.Point(8, 240)
        Me.Label110.Name = "Label110"
        Me.Label110.Size = New System.Drawing.Size(136, 24)
        Me.Label110.TabIndex = 8
        Me.Label110.Text = "Altitude Distance Units"
        '
        'btnClearAltRes
        '
        Me.btnClearAltRes.Location = New System.Drawing.Point(216, 184)
        Me.btnClearAltRes.Name = "btnClearAltRes"
        Me.btnClearAltRes.Size = New System.Drawing.Size(75, 23)
        Me.btnClearAltRes.TabIndex = 7
        Me.btnClearAltRes.Text = "Clear the list"
        '
        'btnAddAltRes
        '
        Me.btnAddAltRes.Location = New System.Drawing.Point(216, 128)
        Me.btnAddAltRes.Name = "btnAddAltRes"
        Me.btnAddAltRes.Size = New System.Drawing.Size(72, 32)
        Me.btnAddAltRes.TabIndex = 6
        Me.btnAddAltRes.Text = "Add value to list"
        '
        'numAltRes
        '
        Me.numAltRes.DecimalPlaces = 2
        Me.numAltRes.Location = New System.Drawing.Point(208, 104)
        Me.numAltRes.Maximum = New Decimal(New Integer() {100000, 0, 0, 0})
        Me.numAltRes.Name = "numAltRes"
        Me.numAltRes.Size = New System.Drawing.Size(96, 20)
        Me.numAltRes.TabIndex = 5
        Me.numAltRes.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'txtAltRes
        '
        Me.txtAltRes.AcceptsReturn = True
        Me.txtAltRes.Location = New System.Drawing.Point(88, 96)
        Me.txtAltRes.Multiline = True
        Me.txtAltRes.Name = "txtAltRes"
        Me.txtAltRes.ReadOnly = True
        Me.txtAltRes.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtAltRes.Size = New System.Drawing.Size(96, 120)
        Me.txtAltRes.TabIndex = 4
        Me.txtAltRes.TabStop = False
        Me.ToolTip1.SetToolTip(Me.txtAltRes, "min distance possible between 2 adjacent altitude values, in Alt Dist Units of me" & _
                "asure")
        '
        'Label109
        '
        Me.Label109.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label109.Location = New System.Drawing.Point(8, 96)
        Me.Label109.Name = "Label109"
        Me.Label109.Size = New System.Drawing.Size(80, 32)
        Me.Label109.TabIndex = 3
        Me.Label109.Text = "Altitude Resolution"
        '
        'cboxAltDatum
        '
        Me.cboxAltDatum.Items.AddRange(New Object() {"National Geodetic Vertical Datum of 1929", "North American Vertical Datum of 1988"})
        Me.cboxAltDatum.Location = New System.Drawing.Point(96, 40)
        Me.cboxAltDatum.Name = "cboxAltDatum"
        Me.cboxAltDatum.Size = New System.Drawing.Size(232, 21)
        Me.cboxAltDatum.TabIndex = 2
        '
        'Label107
        '
        Me.Label107.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label107.Location = New System.Drawing.Point(8, 40)
        Me.Label107.Name = "Label107"
        Me.Label107.Size = New System.Drawing.Size(80, 32)
        Me.Label107.TabIndex = 1
        Me.Label107.Text = "Altitude Datum Name"
        '
        'Label105
        '
        Me.Label105.Location = New System.Drawing.Point(103, 8)
        Me.Label105.Name = "Label105"
        Me.Label105.Size = New System.Drawing.Size(144, 23)
        Me.Label105.TabIndex = 0
        Me.Label105.Text = "Altitude System Definition"
        Me.Label105.TextAlign = System.Drawing.ContentAlignment.TopCenter
        '
        'tabSection5
        '
        Me.tabSection5.Controls.Add(Me.tabEA)
        Me.tabSection5.Location = New System.Drawing.Point(4, 24)
        Me.tabSection5.Name = "tabSection5"
        Me.tabSection5.Size = New System.Drawing.Size(736, 432)
        Me.tabSection5.TabIndex = 4
        Me.tabSection5.Text = "Entity & Attribute"
        '
        'tabEA
        '
        Me.tabEA.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.tabEA.Controls.Add(Me.tpEAdetail)
        Me.tabEA.Controls.Add(Me.tpEAover)
        Me.tabEA.Controls.Add(Me.tpEAinfo)
        Me.tabEA.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.tabEA.ImageList = Me.ImageList1
        Me.tabEA.Location = New System.Drawing.Point(0, 0)
        Me.tabEA.Name = "tabEA"
        Me.tabEA.SelectedIndex = 0
        Me.tabEA.Size = New System.Drawing.Size(752, 436)
        Me.tabEA.TabIndex = 0
        '
        'tpEAdetail
        '
        Me.tpEAdetail.AutoScroll = True
        Me.tpEAdetail.Controls.Add(Me.Panel19)
        Me.tpEAdetail.ImageIndex = 8
        Me.tpEAdetail.Location = New System.Drawing.Point(4, 23)
        Me.tpEAdetail.Name = "tpEAdetail"
        Me.tpEAdetail.Size = New System.Drawing.Size(744, 409)
        Me.tpEAdetail.TabIndex = 0
        Me.tpEAdetail.Text = "Detailed Descriptions"
        '
        'Panel19
        '
        Me.Panel19.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.Panel19.AutoScroll = True
        Me.Panel19.Controls.Add(Me.lblEAroot)
        Me.Panel19.Controls.Add(Me.TextBox18)
        Me.Panel19.Controls.Add(Me.btnClearElem)
        Me.Panel19.Controls.Add(Me.btnDelLink)
        Me.Panel19.Controls.Add(Me.btnCrLink)
        Me.Panel19.Controls.Add(Me.btnViewLinks)
        Me.Panel19.Controls.Add(Me.txtEAbranch)
        Me.Panel19.Controls.Add(Me.Label103)
        Me.Panel19.Controls.Add(Me.Label102)
        Me.Panel19.Controls.Add(Me.btnSelDomain)
        Me.Panel19.Controls.Add(Me.btnSelAttrib)
        Me.Panel19.Controls.Add(Me.btnSelEntity)
        Me.Panel19.Controls.Add(Me.Label101)
        Me.Panel19.Controls.Add(Me.Label100)
        Me.Panel19.Controls.Add(Me.btnEAdomainDel)
        Me.Panel19.Controls.Add(Me.btnEAdomainEdit)
        Me.Panel19.Controls.Add(Me.btnEAdomainAdd)
        Me.Panel19.Controls.Add(Me.cboxDomains)
        Me.Panel19.Controls.Add(Me.Label99)
        Me.Panel19.Controls.Add(Me.btnEAattribDel)
        Me.Panel19.Controls.Add(Me.btnEAattribEdit)
        Me.Panel19.Controls.Add(Me.btnEAattribAdd)
        Me.Panel19.Controls.Add(Me.cboxAttrib)
        Me.Panel19.Controls.Add(Me.Label98)
        Me.Panel19.Controls.Add(Me.cboxEntity)
        Me.Panel19.Controls.Add(Me.Label95)
        Me.Panel19.Controls.Add(Me.btnDelEDetl)
        Me.Panel19.Controls.Add(Me.btnEditEDtl)
        Me.Panel19.Controls.Add(Me.btnAddEDtl)
        Me.Panel19.Controls.Add(Me.Label97)
        Me.Panel19.Location = New System.Drawing.Point(0, 0)
        Me.Panel19.Name = "Panel19"
        Me.Panel19.Size = New System.Drawing.Size(732, 404)
        Me.Panel19.TabIndex = 0
        '
        'lblEAroot
        '
        Me.lblEAroot.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.lblEAroot.Location = New System.Drawing.Point(400, 64)
        Me.lblEAroot.Name = "lblEAroot"
        Me.lblEAroot.Size = New System.Drawing.Size(184, 24)
        Me.lblEAroot.TabIndex = 49
        '
        'TextBox18
        '
        Me.TextBox18.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.TextBox18.Location = New System.Drawing.Point(408, 264)
        Me.TextBox18.Multiline = True
        Me.TextBox18.Name = "TextBox18"
        Me.TextBox18.ReadOnly = True
        Me.TextBox18.Size = New System.Drawing.Size(176, 80)
        Me.TextBox18.TabIndex = 48
        Me.TextBox18.TabStop = False
        Me.TextBox18.Text = "Valid linkages, root + branch:" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "Entity type + Attribute" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "Attribute + Domain Value" & _
            "" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "Enumerated Domain + Attribute" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "Range Domain + Attribute"
        '
        'btnClearElem
        '
        Me.btnClearElem.Location = New System.Drawing.Point(456, 208)
        Me.btnClearElem.Name = "btnClearElem"
        Me.btnClearElem.Size = New System.Drawing.Size(75, 23)
        Me.btnClearElem.TabIndex = 47
        Me.btnClearElem.Text = "Clear fields"
        Me.ToolTip1.SetToolTip(Me.btnClearElem, "Clear root and branch fields")
        '
        'btnDelLink
        '
        Me.btnDelLink.Location = New System.Drawing.Point(504, 160)
        Me.btnDelLink.Name = "btnDelLink"
        Me.btnDelLink.Size = New System.Drawing.Size(64, 23)
        Me.btnDelLink.TabIndex = 46
        Me.btnDelLink.Text = "Detach"
        '
        'btnCrLink
        '
        Me.btnCrLink.Location = New System.Drawing.Point(416, 160)
        Me.btnCrLink.Name = "btnCrLink"
        Me.btnCrLink.Size = New System.Drawing.Size(64, 23)
        Me.btnCrLink.TabIndex = 45
        Me.btnCrLink.Text = "Attach"
        '
        'btnViewLinks
        '
        Me.btnViewLinks.Location = New System.Drawing.Point(600, 56)
        Me.btnViewLinks.Name = "btnViewLinks"
        Me.btnViewLinks.Size = New System.Drawing.Size(88, 40)
        Me.btnViewLinks.TabIndex = 44
        Me.btnViewLinks.Text = "View Existing Branches"
        Me.ToolTip1.SetToolTip(Me.btnViewLinks, "Links for selected Root")
        '
        'txtEAbranch
        '
        Me.txtEAbranch.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.txtEAbranch.Location = New System.Drawing.Point(400, 128)
        Me.txtEAbranch.Name = "txtEAbranch"
        Me.txtEAbranch.ReadOnly = True
        Me.txtEAbranch.Size = New System.Drawing.Size(184, 20)
        Me.txtEAbranch.TabIndex = 43
        Me.txtEAbranch.TabStop = False
        '
        'Label103
        '
        Me.Label103.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label103.Location = New System.Drawing.Point(400, 112)
        Me.Label103.Name = "Label103"
        Me.Label103.Size = New System.Drawing.Size(48, 23)
        Me.Label103.TabIndex = 42
        Me.Label103.Text = "Branch"
        '
        'Label102
        '
        Me.Label102.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label102.Location = New System.Drawing.Point(400, 48)
        Me.Label102.Name = "Label102"
        Me.Label102.Size = New System.Drawing.Size(48, 23)
        Me.Label102.TabIndex = 40
        Me.Label102.Text = "Root"
        '
        'btnSelDomain
        '
        Me.btnSelDomain.Font = New System.Drawing.Font("Symbol", 16.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(2, Byte))
        Me.btnSelDomain.ImageIndex = 6
        Me.btnSelDomain.ImageList = Me.ImageList1
        Me.btnSelDomain.Location = New System.Drawing.Point(304, 256)
        Me.btnSelDomain.Name = "btnSelDomain"
        Me.btnSelDomain.Size = New System.Drawing.Size(64, 24)
        Me.btnSelDomain.TabIndex = 39
        '
        'btnSelAttrib
        '
        Me.btnSelAttrib.Font = New System.Drawing.Font("Symbol", 16.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(2, Byte))
        Me.btnSelAttrib.ImageIndex = 6
        Me.btnSelAttrib.ImageList = Me.ImageList1
        Me.btnSelAttrib.Location = New System.Drawing.Point(304, 160)
        Me.btnSelAttrib.Name = "btnSelAttrib"
        Me.btnSelAttrib.Size = New System.Drawing.Size(64, 24)
        Me.btnSelAttrib.TabIndex = 38
        '
        'btnSelEntity
        '
        Me.btnSelEntity.Font = New System.Drawing.Font("Symbol", 16.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(2, Byte))
        Me.btnSelEntity.ImageIndex = 6
        Me.btnSelEntity.ImageList = Me.ImageList1
        Me.btnSelEntity.Location = New System.Drawing.Point(304, 64)
        Me.btnSelEntity.Name = "btnSelEntity"
        Me.btnSelEntity.Size = New System.Drawing.Size(64, 24)
        Me.btnSelEntity.TabIndex = 37
        '
        'Label101
        '
        Me.Label101.Location = New System.Drawing.Point(400, 16)
        Me.Label101.Name = "Label101"
        Me.Label101.Size = New System.Drawing.Size(152, 23)
        Me.Label101.TabIndex = 36
        Me.Label101.Text = "Manipulate attachments"
        '
        'Label100
        '
        Me.Label100.Location = New System.Drawing.Point(312, 16)
        Me.Label100.Name = "Label100"
        Me.Label100.Size = New System.Drawing.Size(64, 32)
        Me.Label100.TabIndex = 35
        Me.Label100.Text = "Select elements"
        '
        'btnEAdomainDel
        '
        Me.btnEAdomainDel.Location = New System.Drawing.Point(184, 288)
        Me.btnEAdomainDel.Name = "btnEAdomainDel"
        Me.btnEAdomainDel.Size = New System.Drawing.Size(72, 23)
        Me.btnEAdomainDel.TabIndex = 34
        Me.btnEAdomainDel.Text = "Delete"
        '
        'btnEAdomainEdit
        '
        Me.btnEAdomainEdit.Location = New System.Drawing.Point(104, 288)
        Me.btnEAdomainEdit.Name = "btnEAdomainEdit"
        Me.btnEAdomainEdit.Size = New System.Drawing.Size(64, 23)
        Me.btnEAdomainEdit.TabIndex = 33
        Me.btnEAdomainEdit.Text = "Edit"
        '
        'btnEAdomainAdd
        '
        Me.btnEAdomainAdd.Location = New System.Drawing.Point(24, 288)
        Me.btnEAdomainAdd.Name = "btnEAdomainAdd"
        Me.btnEAdomainAdd.Size = New System.Drawing.Size(64, 23)
        Me.btnEAdomainAdd.TabIndex = 32
        Me.btnEAdomainAdd.Text = "Add"
        '
        'cboxDomains
        '
        Me.cboxDomains.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cboxDomains.Location = New System.Drawing.Point(16, 256)
        Me.cboxDomains.Name = "cboxDomains"
        Me.cboxDomains.Size = New System.Drawing.Size(264, 21)
        Me.cboxDomains.TabIndex = 31
        '
        'Label99
        '
        Me.Label99.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label99.Location = New System.Drawing.Point(16, 240)
        Me.Label99.Name = "Label99"
        Me.Label99.Size = New System.Drawing.Size(96, 16)
        Me.Label99.TabIndex = 30
        Me.Label99.Text = "Domain Values"
        '
        'btnEAattribDel
        '
        Me.btnEAattribDel.Location = New System.Drawing.Point(184, 192)
        Me.btnEAattribDel.Name = "btnEAattribDel"
        Me.btnEAattribDel.Size = New System.Drawing.Size(72, 23)
        Me.btnEAattribDel.TabIndex = 29
        Me.btnEAattribDel.Text = "Delete"
        '
        'btnEAattribEdit
        '
        Me.btnEAattribEdit.Location = New System.Drawing.Point(104, 192)
        Me.btnEAattribEdit.Name = "btnEAattribEdit"
        Me.btnEAattribEdit.Size = New System.Drawing.Size(64, 23)
        Me.btnEAattribEdit.TabIndex = 28
        Me.btnEAattribEdit.Text = "Edit"
        '
        'btnEAattribAdd
        '
        Me.btnEAattribAdd.Location = New System.Drawing.Point(24, 192)
        Me.btnEAattribAdd.Name = "btnEAattribAdd"
        Me.btnEAattribAdd.Size = New System.Drawing.Size(64, 23)
        Me.btnEAattribAdd.TabIndex = 27
        Me.btnEAattribAdd.Text = "Add"
        '
        'cboxAttrib
        '
        Me.cboxAttrib.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cboxAttrib.Location = New System.Drawing.Point(16, 160)
        Me.cboxAttrib.Name = "cboxAttrib"
        Me.cboxAttrib.Size = New System.Drawing.Size(264, 21)
        Me.cboxAttrib.TabIndex = 26
        '
        'Label98
        '
        Me.Label98.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label98.Location = New System.Drawing.Point(16, 144)
        Me.Label98.Name = "Label98"
        Me.Label98.Size = New System.Drawing.Size(96, 16)
        Me.Label98.TabIndex = 25
        Me.Label98.Text = "Attributes"
        '
        'cboxEntity
        '
        Me.cboxEntity.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cboxEntity.Location = New System.Drawing.Point(16, 64)
        Me.cboxEntity.Name = "cboxEntity"
        Me.cboxEntity.Size = New System.Drawing.Size(264, 21)
        Me.cboxEntity.TabIndex = 20
        '
        'Label95
        '
        Me.Label95.Location = New System.Drawing.Point(16, 16)
        Me.Label95.Name = "Label95"
        Me.Label95.Size = New System.Drawing.Size(104, 23)
        Me.Label95.TabIndex = 24
        Me.Label95.Text = "Edit elements"
        '
        'btnDelEDetl
        '
        Me.btnDelEDetl.Location = New System.Drawing.Point(184, 96)
        Me.btnDelEDetl.Name = "btnDelEDetl"
        Me.btnDelEDetl.Size = New System.Drawing.Size(72, 23)
        Me.btnDelEDetl.TabIndex = 23
        Me.btnDelEDetl.Text = "Delete"
        '
        'btnEditEDtl
        '
        Me.btnEditEDtl.Location = New System.Drawing.Point(104, 96)
        Me.btnEditEDtl.Name = "btnEditEDtl"
        Me.btnEditEDtl.Size = New System.Drawing.Size(64, 23)
        Me.btnEditEDtl.TabIndex = 22
        Me.btnEditEDtl.Text = "Edit"
        '
        'btnAddEDtl
        '
        Me.btnAddEDtl.Location = New System.Drawing.Point(24, 96)
        Me.btnAddEDtl.Name = "btnAddEDtl"
        Me.btnAddEDtl.Size = New System.Drawing.Size(64, 23)
        Me.btnAddEDtl.TabIndex = 21
        Me.btnAddEDtl.Text = "Add"
        '
        'Label97
        '
        Me.Label97.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label97.Location = New System.Drawing.Point(16, 48)
        Me.Label97.Name = "Label97"
        Me.Label97.Size = New System.Drawing.Size(96, 23)
        Me.Label97.TabIndex = 19
        Me.Label97.Text = "Entity Types"
        '
        'tpEAover
        '
        Me.tpEAover.AutoScroll = True
        Me.tpEAover.Controls.Add(Me.btnDelEOver)
        Me.tpEAover.Controls.Add(Me.btnEditEOver)
        Me.tpEAover.Controls.Add(Me.btnAddEOver)
        Me.tpEAover.Controls.Add(Me.lboxOverView)
        Me.tpEAover.Controls.Add(Me.Label96)
        Me.tpEAover.ImageIndex = 8
        Me.tpEAover.Location = New System.Drawing.Point(4, 23)
        Me.tpEAover.Name = "tpEAover"
        Me.tpEAover.Size = New System.Drawing.Size(748, 357)
        Me.tpEAover.TabIndex = 1
        Me.tpEAover.Text = "Overview Descriptions"
        '
        'btnDelEOver
        '
        Me.btnDelEOver.Location = New System.Drawing.Point(240, 96)
        Me.btnDelEOver.Name = "btnDelEOver"
        Me.btnDelEOver.Size = New System.Drawing.Size(75, 23)
        Me.btnDelEOver.TabIndex = 23
        Me.btnDelEOver.Text = "Delete"
        '
        'btnEditEOver
        '
        Me.btnEditEOver.Location = New System.Drawing.Point(144, 96)
        Me.btnEditEOver.Name = "btnEditEOver"
        Me.btnEditEOver.Size = New System.Drawing.Size(75, 23)
        Me.btnEditEOver.TabIndex = 22
        Me.btnEditEOver.Text = "Edit"
        '
        'btnAddEOver
        '
        Me.btnAddEOver.Location = New System.Drawing.Point(48, 96)
        Me.btnAddEOver.Name = "btnAddEOver"
        Me.btnAddEOver.Size = New System.Drawing.Size(75, 23)
        Me.btnAddEOver.TabIndex = 21
        Me.btnAddEOver.Text = "Add"
        '
        'lboxOverView
        '
        Me.lboxOverView.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxOverView.Location = New System.Drawing.Point(32, 56)
        Me.lboxOverView.Name = "lboxOverView"
        Me.lboxOverView.Size = New System.Drawing.Size(336, 26)
        Me.lboxOverView.TabIndex = 20
        '
        'Label96
        '
        Me.Label96.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label96.Location = New System.Drawing.Point(32, 32)
        Me.Label96.Name = "Label96"
        Me.Label96.Size = New System.Drawing.Size(160, 23)
        Me.Label96.TabIndex = 19
        Me.Label96.Text = "Overview Description(s)"
        '
        'tpEAinfo
        '
        Me.tpEAinfo.Controls.Add(Me.TextBox17)
        Me.tpEAinfo.Controls.Add(Me.TextBox16)
        Me.tpEAinfo.ImageIndex = 5
        Me.tpEAinfo.Location = New System.Drawing.Point(4, 23)
        Me.tpEAinfo.Name = "tpEAinfo"
        Me.tpEAinfo.Size = New System.Drawing.Size(748, 357)
        Me.tpEAinfo.TabIndex = 2
        Me.tpEAinfo.Text = "Information"
        '
        'TextBox17
        '
        Me.TextBox17.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.TextBox17.Location = New System.Drawing.Point(170, 288)
        Me.TextBox17.Multiline = True
        Me.TextBox17.Name = "TextBox17"
        Me.TextBox17.ReadOnly = True
        Me.TextBox17.Size = New System.Drawing.Size(408, 112)
        Me.TextBox17.TabIndex = 25
        Me.TextBox17.TabStop = False
        Me.TextBox17.Text = resources.GetString("TextBox17.Text")
        '
        'TextBox16
        '
        Me.TextBox16.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.TextBox16.Location = New System.Drawing.Point(104, 16)
        Me.TextBox16.Multiline = True
        Me.TextBox16.Name = "TextBox16"
        Me.TextBox16.ReadOnly = True
        Me.TextBox16.Size = New System.Drawing.Size(544, 224)
        Me.TextBox16.TabIndex = 13
        Me.TextBox16.TabStop = False
        Me.TextBox16.Text = resources.GetString("TextBox16.Text")
        '
        'tabSection6
        '
        Me.tabSection6.Controls.Add(Me.tabDI)
        Me.tabSection6.Location = New System.Drawing.Point(4, 24)
        Me.tabSection6.Name = "tabSection6"
        Me.tabSection6.Size = New System.Drawing.Size(736, 432)
        Me.tabSection6.TabIndex = 5
        Me.tabSection6.Text = "Distribution"
        '
        'tabDI
        '
        Me.tabDI.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.tabDI.Controls.Add(Me.tpDImain)
        Me.tabDI.Controls.Add(Me.tpDIinfo)
        Me.tabDI.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.tabDI.ImageList = Me.ImageList1
        Me.tabDI.Location = New System.Drawing.Point(0, 0)
        Me.tabDI.Name = "tabDI"
        Me.tabDI.SelectedIndex = 0
        Me.tabDI.Size = New System.Drawing.Size(744, 436)
        Me.tabDI.TabIndex = 0
        '
        'tpDImain
        '
        Me.tpDImain.Controls.Add(Me.btnDelDistrib)
        Me.tpDImain.Controls.Add(Me.btnEditDistrib)
        Me.tpDImain.Controls.Add(Me.btnAddDistrib)
        Me.tpDImain.Controls.Add(Me.lboxDistrib)
        Me.tpDImain.Controls.Add(Me.Label104)
        Me.tpDImain.ImageIndex = 9
        Me.tpDImain.Location = New System.Drawing.Point(4, 23)
        Me.tpDImain.Name = "tpDImain"
        Me.tpDImain.Size = New System.Drawing.Size(736, 409)
        Me.tpDImain.TabIndex = 3
        Me.tpDImain.Text = "Distributors"
        '
        'btnDelDistrib
        '
        Me.btnDelDistrib.Location = New System.Drawing.Point(216, 88)
        Me.btnDelDistrib.Name = "btnDelDistrib"
        Me.btnDelDistrib.Size = New System.Drawing.Size(75, 23)
        Me.btnDelDistrib.TabIndex = 4
        Me.btnDelDistrib.Text = "Delete"
        '
        'btnEditDistrib
        '
        Me.btnEditDistrib.Location = New System.Drawing.Point(128, 88)
        Me.btnEditDistrib.Name = "btnEditDistrib"
        Me.btnEditDistrib.Size = New System.Drawing.Size(64, 23)
        Me.btnEditDistrib.TabIndex = 3
        Me.btnEditDistrib.Text = "Edit"
        '
        'btnAddDistrib
        '
        Me.btnAddDistrib.Location = New System.Drawing.Point(40, 88)
        Me.btnAddDistrib.Name = "btnAddDistrib"
        Me.btnAddDistrib.Size = New System.Drawing.Size(64, 23)
        Me.btnAddDistrib.TabIndex = 2
        Me.btnAddDistrib.Text = "Add"
        '
        'lboxDistrib
        '
        Me.lboxDistrib.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.lboxDistrib.Location = New System.Drawing.Point(24, 40)
        Me.lboxDistrib.Name = "lboxDistrib"
        Me.lboxDistrib.Size = New System.Drawing.Size(280, 39)
        Me.lboxDistrib.TabIndex = 1
        '
        'Label104
        '
        Me.Label104.Location = New System.Drawing.Point(24, 24)
        Me.Label104.Name = "Label104"
        Me.Label104.Size = New System.Drawing.Size(100, 23)
        Me.Label104.TabIndex = 0
        Me.Label104.Text = "Distributors"
        '
        'tpDIinfo
        '
        Me.tpDIinfo.AutoScroll = True
        Me.tpDIinfo.Controls.Add(Me.TextBox20)
        Me.tpDIinfo.ImageIndex = 5
        Me.tpDIinfo.Location = New System.Drawing.Point(4, 23)
        Me.tpDIinfo.Name = "tpDIinfo"
        Me.tpDIinfo.Size = New System.Drawing.Size(740, 357)
        Me.tpDIinfo.TabIndex = 4
        Me.tpDIinfo.Text = "Information"
        '
        'TextBox20
        '
        Me.TextBox20.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.TextBox20.Location = New System.Drawing.Point(24, 24)
        Me.TextBox20.Multiline = True
        Me.TextBox20.Name = "TextBox20"
        Me.TextBox20.ReadOnly = True
        Me.TextBox20.Size = New System.Drawing.Size(424, 80)
        Me.TextBox20.TabIndex = 0
        Me.TextBox20.TabStop = False
        Me.TextBox20.Text = resources.GetString("TextBox20.Text")
        '
        'tabSection7
        '
        Me.tabSection7.Controls.Add(Me.tabMRef)
        Me.tabSection7.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.tabSection7.Location = New System.Drawing.Point(4, 24)
        Me.tabSection7.Name = "tabSection7"
        Me.tabSection7.Size = New System.Drawing.Size(736, 432)
        Me.tabSection7.TabIndex = 6
        Me.tabSection7.Text = "Metadata Ref"
        '
        'tabMRef
        '
        Me.tabMRef.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.tabMRef.Controls.Add(Me.tpMRinfo)
        Me.tabMRef.Controls.Add(Me.tpMRext)
        Me.tabMRef.Controls.Add(Me.tpMRuse)
        Me.tabMRef.ImageList = Me.ImageList1
        Me.tabMRef.Location = New System.Drawing.Point(0, 0)
        Me.tabMRef.Name = "tabMRef"
        Me.tabMRef.SelectedIndex = 0
        Me.tabMRef.Size = New System.Drawing.Size(736, 436)
        Me.tabMRef.TabIndex = 0
        '
        'tpMRinfo
        '
        Me.tpMRinfo.AutoScroll = True
        Me.tpMRinfo.Controls.Add(Me.chkFRevDate)
        Me.tpMRinfo.Controls.Add(Me.chkRevDate)
        Me.tpMRinfo.Controls.Add(Me.Label26)
        Me.tpMRinfo.Controls.Add(Me.Label23)
        Me.tpMRinfo.Controls.Add(Me.btnMRedit)
        Me.tpMRinfo.Controls.Add(Me.txtMRcontact)
        Me.tpMRinfo.Controls.Add(Me.Label20)
        Me.tpMRinfo.Controls.Add(Me.TextBox2)
        Me.tpMRinfo.Controls.Add(Me.TextBox1)
        Me.tpMRinfo.Controls.Add(Me.cboxStdVer)
        Me.tpMRinfo.Controls.Add(Me.Label22)
        Me.tpMRinfo.Controls.Add(Me.cboxStdName)
        Me.tpMRinfo.Controls.Add(Me.Label21)
        Me.tpMRinfo.Controls.Add(Me.dtPick1)
        Me.tpMRinfo.Controls.Add(Me.Label19)
        Me.tpMRinfo.Controls.Add(Me.dtPick2)
        Me.tpMRinfo.Controls.Add(Me.Label24)
        Me.tpMRinfo.Controls.Add(Me.dtPick3)
        Me.tpMRinfo.Controls.Add(Me.Label25)
        Me.tpMRinfo.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.tpMRinfo.ImageIndex = 8
        Me.tpMRinfo.Location = New System.Drawing.Point(4, 23)
        Me.tpMRinfo.Name = "tpMRinfo"
        Me.tpMRinfo.Size = New System.Drawing.Size(728, 409)
        Me.tpMRinfo.TabIndex = 0
        Me.tpMRinfo.Text = "Metadata information"
        '
        'chkFRevDate
        '
        Me.chkFRevDate.Location = New System.Drawing.Point(222, 310)
        Me.chkFRevDate.Name = "chkFRevDate"
        Me.chkFRevDate.Size = New System.Drawing.Size(24, 24)
        Me.chkFRevDate.TabIndex = 19
        '
        'chkRevDate
        '
        Me.chkRevDate.Location = New System.Drawing.Point(184, 236)
        Me.chkRevDate.Name = "chkRevDate"
        Me.chkRevDate.Size = New System.Drawing.Size(24, 24)
        Me.chkRevDate.TabIndex = 18
        '
        'Label26
        '
        Me.Label26.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label26.Location = New System.Drawing.Point(16, 312)
        Me.Label26.Name = "Label26"
        Me.Label26.Size = New System.Drawing.Size(214, 16)
        Me.Label26.TabIndex = 15
        Me.Label26.Text = "Metadata Future Review Date (optional):"
        Me.Label26.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'Label23
        '
        Me.Label23.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label23.Location = New System.Drawing.Point(16, 240)
        Me.Label23.Name = "Label23"
        Me.Label23.Size = New System.Drawing.Size(174, 16)
        Me.Label23.TabIndex = 12
        Me.Label23.Text = "Metadata Review Date (optional):"
        Me.Label23.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'btnMRedit
        '
        Me.btnMRedit.Location = New System.Drawing.Point(400, 192)
        Me.btnMRedit.Name = "btnMRedit"
        Me.btnMRedit.Size = New System.Drawing.Size(75, 23)
        Me.btnMRedit.TabIndex = 11
        Me.btnMRedit.Text = "Edit contact"
        '
        'txtMRcontact
        '
        Me.txtMRcontact.Location = New System.Drawing.Point(128, 192)
        Me.txtMRcontact.Name = "txtMRcontact"
        Me.txtMRcontact.ReadOnly = True
        Me.txtMRcontact.Size = New System.Drawing.Size(256, 20)
        Me.txtMRcontact.TabIndex = 10
        Me.txtMRcontact.TabStop = False
        Me.ToolTip1.SetToolTip(Me.txtMRcontact, "party responsible for the metadata information")
        '
        'Label20
        '
        Me.Label20.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label20.Location = New System.Drawing.Point(16, 192)
        Me.Label20.Name = "Label20"
        Me.Label20.Size = New System.Drawing.Size(112, 23)
        Me.Label20.TabIndex = 9
        Me.Label20.Text = "Metadata Contact:"
        '
        'TextBox2
        '
        Me.TextBox2.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.TextBox2.Font = New System.Drawing.Font("Microsoft Sans Serif", 7.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.TextBox2.Location = New System.Drawing.Point(544, 56)
        Me.TextBox2.Multiline = True
        Me.TextBox2.Name = "TextBox2"
        Me.TextBox2.ReadOnly = True
        Me.TextBox2.Size = New System.Drawing.Size(168, 48)
        Me.TextBox2.TabIndex = 8
        Me.TextBox2.Text = """FGDC Biological"" is default" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & """National Biological"" is alternate" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & """FGDC Content"" " & _
            "is for plain spatial data"
        '
        'TextBox1
        '
        Me.TextBox1.AcceptsReturn = True
        Me.TextBox1.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.TextBox1.Font = New System.Drawing.Font("Microsoft Sans Serif", 7.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.TextBox1.Location = New System.Drawing.Point(336, 80)
        Me.TextBox1.MaxLength = 327
        Me.TextBox1.Multiline = True
        Me.TextBox1.Name = "TextBox1"
        Me.TextBox1.ReadOnly = True
        Me.TextBox1.Size = New System.Drawing.Size(144, 48)
        Me.TextBox1.TabIndex = 7
        Me.TextBox1.Text = "1999 = Biological" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "1998 = Plain spatial data" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "(type in your own if needed)"
        '
        'cboxStdVer
        '
        Me.cboxStdVer.Items.AddRange(New Object() {"FGDC-STD-001.1-1999", "FGDC-STD-001-1998"})
        Me.cboxStdVer.Location = New System.Drawing.Point(152, 80)
        Me.cboxStdVer.Name = "cboxStdVer"
        Me.cboxStdVer.Size = New System.Drawing.Size(168, 21)
        Me.cboxStdVer.TabIndex = 6
        Me.cboxStdVer.Text = "FGDC-STD-001.1-1999"
        '
        'Label22
        '
        Me.Label22.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label22.Location = New System.Drawing.Point(16, 80)
        Me.Label22.Name = "Label22"
        Me.Label22.Size = New System.Drawing.Size(128, 23)
        Me.Label22.TabIndex = 5
        Me.Label22.Text = "Version of Standard:"
        '
        'cboxStdName
        '
        Me.cboxStdName.Items.AddRange(New Object() {"FGDC Biological Data Profile of the Content Standard for Digital Geospatial Metad" & _
                        "ata", "Content Standard for National Biological Information Infrastructure Metadata", "FGDC Content Standard for Digital Geospatial Metadata"})
        Me.cboxStdName.Location = New System.Drawing.Point(184, 24)
        Me.cboxStdName.Name = "cboxStdName"
        Me.cboxStdName.Size = New System.Drawing.Size(440, 21)
        Me.cboxStdName.TabIndex = 4
        Me.cboxStdName.Text = "FGDC Biological Data Profile of the Content Standard for Digital Geospatial Metad" & _
            "ata"
        '
        'Label21
        '
        Me.Label21.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label21.Location = New System.Drawing.Point(18, 26)
        Me.Label21.Name = "Label21"
        Me.Label21.Size = New System.Drawing.Size(160, 23)
        Me.Label21.TabIndex = 3
        Me.Label21.Text = "Metadata Standards Name:"
        '
        'dtPick1
        '
        Me.dtPick1.Location = New System.Drawing.Point(208, 144)
        Me.dtPick1.MinDate = New Date(1990, 1, 1, 0, 0, 0, 0)
        Me.dtPick1.Name = "dtPick1"
        Me.dtPick1.Size = New System.Drawing.Size(200, 20)
        Me.dtPick1.TabIndex = 1
        Me.dtPick1.Value = New Date(2003, 11, 6, 0, 0, 0, 0)
        '
        'Label19
        '
        Me.Label19.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label19.Location = New System.Drawing.Point(18, 144)
        Me.Label19.Name = "Label19"
        Me.Label19.Size = New System.Drawing.Size(182, 16)
        Me.Label19.TabIndex = 0
        Me.Label19.Text = "Metadata Creation/Update Date:"
        Me.Label19.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'dtPick2
        '
        Me.dtPick2.Enabled = False
        Me.dtPick2.Location = New System.Drawing.Point(96, 264)
        Me.dtPick2.MinDate = New Date(1990, 1, 1, 0, 0, 0, 0)
        Me.dtPick2.Name = "dtPick2"
        Me.dtPick2.Size = New System.Drawing.Size(200, 20)
        Me.dtPick2.TabIndex = 13
        Me.dtPick2.Value = New Date(2003, 11, 14, 0, 0, 0, 0)
        '
        'Label24
        '
        Me.Label24.Font = New System.Drawing.Font("Microsoft Sans Serif", 7.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label24.Location = New System.Drawing.Point(296, 264)
        Me.Label24.Name = "Label24"
        Me.Label24.Size = New System.Drawing.Size(152, 23)
        Me.Label24.TabIndex = 14
        Me.Label24.Text = "(date later than Creation/Update)"
        Me.Label24.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'dtPick3
        '
        Me.dtPick3.Enabled = False
        Me.dtPick3.Location = New System.Drawing.Point(96, 336)
        Me.dtPick3.MinDate = New Date(1990, 1, 1, 0, 0, 0, 0)
        Me.dtPick3.Name = "dtPick3"
        Me.dtPick3.Size = New System.Drawing.Size(200, 20)
        Me.dtPick3.TabIndex = 16
        Me.dtPick3.Value = New Date(2003, 11, 6, 0, 0, 0, 0)
        '
        'Label25
        '
        Me.Label25.Font = New System.Drawing.Font("Microsoft Sans Serif", 7.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label25.Location = New System.Drawing.Point(296, 336)
        Me.Label25.Name = "Label25"
        Me.Label25.Size = New System.Drawing.Size(152, 23)
        Me.Label25.TabIndex = 17
        Me.Label25.Text = "(date later than Metadata Review)"
        '
        'tpMRext
        '
        Me.tpMRext.Controls.Add(Me.TextBox3)
        Me.tpMRext.ImageIndex = 9
        Me.tpMRext.Location = New System.Drawing.Point(4, 23)
        Me.tpMRext.Name = "tpMRext"
        Me.tpMRext.Size = New System.Drawing.Size(732, 357)
        Me.tpMRext.TabIndex = 7
        Me.tpMRext.Text = "Extensions"
        '
        'TextBox3
        '
        Me.TextBox3.Location = New System.Drawing.Point(32, 32)
        Me.TextBox3.Multiline = True
        Me.TextBox3.Name = "TextBox3"
        Me.TextBox3.ReadOnly = True
        Me.TextBox3.Size = New System.Drawing.Size(480, 120)
        Me.TextBox3.TabIndex = 0
        Me.TextBox3.TabStop = False
        Me.TextBox3.Text = resources.GetString("TextBox3.Text")
        '
        'tpMRuse
        '
        Me.tpMRuse.AutoScroll = True
        Me.tpMRuse.Controls.Add(Me.Panel3)
        Me.tpMRuse.Controls.Add(Me.txtMRuse)
        Me.tpMRuse.Controls.Add(Me.Label28)
        Me.tpMRuse.Controls.Add(Me.txtMRaccess)
        Me.tpMRuse.Controls.Add(Me.Label27)
        Me.tpMRuse.ImageIndex = 7
        Me.tpMRuse.Location = New System.Drawing.Point(4, 23)
        Me.tpMRuse.Name = "tpMRuse"
        Me.tpMRuse.Size = New System.Drawing.Size(732, 357)
        Me.tpMRuse.TabIndex = 5
        Me.tpMRuse.Text = "Constraints & Security"
        '
        'Panel3
        '
        Me.Panel3.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Panel3.Controls.Add(Me.txtMRSecDesc)
        Me.Panel3.Controls.Add(Me.Label31)
        Me.Panel3.Controls.Add(Me.cboxMRClass)
        Me.Panel3.Controls.Add(Me.Label30)
        Me.Panel3.Controls.Add(Me.txtMRClassSys)
        Me.Panel3.Controls.Add(Me.Label29)
        Me.Panel3.Controls.Add(Me.TextBox4)
        Me.Panel3.Location = New System.Drawing.Point(24, 152)
        Me.Panel3.Name = "Panel3"
        Me.Panel3.Size = New System.Drawing.Size(672, 192)
        Me.Panel3.TabIndex = 4
        '
        'txtMRSecDesc
        '
        Me.txtMRSecDesc.Location = New System.Drawing.Point(328, 72)
        Me.txtMRSecDesc.Multiline = True
        Me.txtMRSecDesc.Name = "txtMRSecDesc"
        Me.txtMRSecDesc.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtMRSecDesc.Size = New System.Drawing.Size(320, 64)
        Me.txtMRSecDesc.TabIndex = 6
        Me.ToolTip1.SetToolTip(Me.txtMRSecDesc, "additional information about the restrictions on handling the metadata")
        '
        'Label31
        '
        Me.Label31.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label31.Location = New System.Drawing.Point(328, 56)
        Me.Label31.Name = "Label31"
        Me.Label31.Size = New System.Drawing.Size(232, 16)
        Me.Label31.TabIndex = 5
        Me.Label31.Text = "Metadata Security Handling Description"
        '
        'cboxMRClass
        '
        Me.cboxMRClass.Items.AddRange(New Object() {"Unclassified", "Sensitive", "Restricted", "Confidential", "Secret", "Top secret"})
        Me.cboxMRClass.Location = New System.Drawing.Point(16, 152)
        Me.cboxMRClass.Name = "cboxMRClass"
        Me.cboxMRClass.Size = New System.Drawing.Size(136, 21)
        Me.cboxMRClass.TabIndex = 4
        Me.ToolTip1.SetToolTip(Me.cboxMRClass, "choose a restriction or type appropriate value")
        '
        'Label30
        '
        Me.Label30.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label30.Location = New System.Drawing.Point(16, 136)
        Me.Label30.Name = "Label30"
        Me.Label30.Size = New System.Drawing.Size(192, 16)
        Me.Label30.TabIndex = 3
        Me.Label30.Text = "Metadata Security Classification"
        '
        'txtMRClassSys
        '
        Me.txtMRClassSys.Location = New System.Drawing.Point(16, 72)
        Me.txtMRClassSys.Multiline = True
        Me.txtMRClassSys.Name = "txtMRClassSys"
        Me.txtMRClassSys.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtMRClassSys.Size = New System.Drawing.Size(256, 40)
        Me.txtMRClassSys.TabIndex = 2
        Me.ToolTip1.SetToolTip(Me.txtMRClassSys, "name of classification system for the metadata")
        '
        'Label29
        '
        Me.Label29.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label29.Location = New System.Drawing.Point(16, 56)
        Me.Label29.Name = "Label29"
        Me.Label29.Size = New System.Drawing.Size(232, 16)
        Me.Label29.TabIndex = 1
        Me.Label29.Text = "Metadata Security Classification System"
        '
        'TextBox4
        '
        Me.TextBox4.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.TextBox4.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.TextBox4.Location = New System.Drawing.Point(248, 8)
        Me.TextBox4.Multiline = True
        Me.TextBox4.Name = "TextBox4"
        Me.TextBox4.ReadOnly = True
        Me.TextBox4.Size = New System.Drawing.Size(168, 32)
        Me.TextBox4.TabIndex = 0
        Me.TextBox4.Text = "Metadata Security Information" & Global.Microsoft.VisualBasic.ChrW(13) & Global.Microsoft.VisualBasic.ChrW(10) & "(optional)"
        Me.TextBox4.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        '
        'txtMRuse
        '
        Me.txtMRuse.AcceptsReturn = True
        Me.txtMRuse.Location = New System.Drawing.Point(376, 40)
        Me.txtMRuse.Multiline = True
        Me.txtMRuse.Name = "txtMRuse"
        Me.txtMRuse.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtMRuse.Size = New System.Drawing.Size(312, 88)
        Me.txtMRuse.TabIndex = 3
        Me.ToolTip1.SetToolTip(Me.txtMRuse, "restrictions on using the metadata after access granted")
        '
        'Label28
        '
        Me.Label28.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.5!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label28.Location = New System.Drawing.Point(376, 24)
        Me.Label28.Name = "Label28"
        Me.Label28.Size = New System.Drawing.Size(232, 16)
        Me.Label28.TabIndex = 2
        Me.Label28.Text = "Metadata Use Constraints (optional)"
        '
        'txtMRaccess
        '
        Me.txtMRaccess.AcceptsReturn = True
        Me.txtMRaccess.Location = New System.Drawing.Point(24, 40)
        Me.txtMRaccess.Multiline = True
        Me.txtMRaccess.Name = "txtMRaccess"
        Me.txtMRaccess.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtMRaccess.Size = New System.Drawing.Size(328, 88)
        Me.txtMRaccess.TabIndex = 1
        Me.ToolTip1.SetToolTip(Me.txtMRaccess, "restrictions on accessing the metadata")
        '
        'Label27
        '
        Me.Label27.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.5!, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label27.Location = New System.Drawing.Point(24, 24)
        Me.Label27.Name = "Label27"
        Me.Label27.Size = New System.Drawing.Size(232, 16)
        Me.Label27.TabIndex = 0
        Me.Label27.Text = "Metadata Access Constraints (optional)"
        '
        'ToolTip1
        '
        Me.ToolTip1.ShowAlways = True
        Me.ToolTip1.ToolTipIcon = System.Windows.Forms.ToolTipIcon.Info
        '
        'SaveFileDialog1
        '
        Me.SaveFileDialog1.DefaultExt = "xml"
        Me.SaveFileDialog1.Filter = "Metadata files (*.xml)|*.xml|All files|*.*"
        Me.SaveFileDialog1.Title = "Save Metadata File As"
        '
        'OpenFileDialog1
        '
        Me.OpenFileDialog1.DefaultExt = "xml"
        Me.OpenFileDialog1.Filter = "Metadata files (*.xml)|*.xml"
        '
        'SaveHTMLDialog
        '
        Me.SaveHTMLDialog.DefaultExt = "html"
        Me.SaveHTMLDialog.Filter = "HTML files|*.html"
        '
        'SaveTaxonDialog
        '
        Me.SaveTaxonDialog.DefaultExt = "xml"
        Me.SaveTaxonDialog.Filter = "Metadata files (*.xml)|*.xml|All files|*.*"
        Me.SaveTaxonDialog.Title = "Save taxonomic classification"
        '
        'OpenTaxonFileDialog
        '
        Me.OpenTaxonFileDialog.DefaultExt = "xml"
        Me.OpenTaxonFileDialog.Filter = "Taxonomic files (*.xml)|*.xml"
        '
        'frmMetaMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.AutoScroll = True
        Me.ClientSize = New System.Drawing.Size(744, 460)
        Me.Controls.Add(Me.tabMainSection)
        Me.Name = "frmMetaMain"
        Me.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Metavist"
        Me.tabMainSection.ResumeLayout(False)
        Me.tabSection1.ResumeLayout(False)
        Me.tabID.ResumeLayout(False)
        Me.tpIDRef.ResumeLayout(False)
        Me.tpIDRef.PerformLayout()
        Me.pnlStatus.ResumeLayout(False)
        Me.pnlTime.ResumeLayout(False)
        Me.Panel2.ResumeLayout(False)
        Me.Panel1.ResumeLayout(False)
        Me.pnlDesc.ResumeLayout(False)
        Me.pnlDesc.PerformLayout()
        Me.pnlCitation.ResumeLayout(False)
        Me.pnlCitation.PerformLayout()
        Me.tpSpDomain.ResumeLayout(False)
        Me.tpSpDomain.PerformLayout()
        CType(Me.numAltMax, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.numAltMin, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.numSouthBC, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.numNorthBC, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.numEastBC, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.numWestBC, System.ComponentModel.ISupportInitialize).EndInit()
        Me.tpKeywords.ResumeLayout(False)
        Me.tbTaxonomy.ResumeLayout(False)
        Me.Panel8.ResumeLayout(False)
        Me.Panel8.PerformLayout()
        Me.Panel6.ResumeLayout(False)
        Me.Panel6.PerformLayout()
        Me.Panel5.ResumeLayout(False)
        Me.tpAccess.ResumeLayout(False)
        Me.tpAccess.PerformLayout()
        Me.Panel4.ResumeLayout(False)
        Me.Panel4.PerformLayout()
        Me.tpTool.ResumeLayout(False)
        Me.tpTool.PerformLayout()
        Me.tpIDmisc.ResumeLayout(False)
        Me.tpIDmisc.PerformLayout()
        Me.tabSection2.ResumeLayout(False)
        Me.tabQuality.ResumeLayout(False)
        Me.tpDQattrib.ResumeLayout(False)
        Me.tpDQattrib.PerformLayout()
        Me.tpDQlogic.ResumeLayout(False)
        Me.tpDQlogic.PerformLayout()
        Me.tpDQposit.ResumeLayout(False)
        Me.Panel18.ResumeLayout(False)
        Me.Panel18.PerformLayout()
        Me.Panel17.ResumeLayout(False)
        Me.Panel17.PerformLayout()
        Me.tpDQlineage.ResumeLayout(False)
        Me.tpDQlineage.PerformLayout()
        Me.tpDQcloud.ResumeLayout(False)
        Me.tpDQcloud.PerformLayout()
        Me.pnlCloud.ResumeLayout(False)
        CType(Me.numCloud, System.ComponentModel.ISupportInitialize).EndInit()
        Me.Panel16.ResumeLayout(False)
        Me.tabSection3.ResumeLayout(False)
        Me.tabSDO.ResumeLayout(False)
        Me.tpSDOref.ResumeLayout(False)
        Me.tpSDOref.PerformLayout()
        Me.tpSDOvector.ResumeLayout(False)
        Me.Panel12.ResumeLayout(False)
        Me.Panel15.ResumeLayout(False)
        Me.Panel14.ResumeLayout(False)
        Me.Panel13.ResumeLayout(False)
        Me.tpSDOraster.ResumeLayout(False)
        Me.Panel10.ResumeLayout(False)
        Me.Panel11.ResumeLayout(False)
        Me.Panel11.PerformLayout()
        CType(Me.numRasCol, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.numRasRow, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.numRasVert, System.ComponentModel.ISupportInitialize).EndInit()
        Me.tabSection4.ResumeLayout(False)
        Me.tabSR.ResumeLayout(False)
        Me.tpSRhoriz.ResumeLayout(False)
        Me.pnlGeodetic.ResumeLayout(False)
        CType(Me.numFlatten, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.numSemiMajor, System.ComponentModel.ISupportInitialize).EndInit()
        Me.pnlLocal.ResumeLayout(False)
        Me.pnlLocal.PerformLayout()
        Me.pnlPlanar.ResumeLayout(False)
        Me.pnlGeographic.ResumeLayout(False)
        CType(Me.numLongRes, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.numLatRes, System.ComponentModel.ISupportInitialize).EndInit()
        Me.pnlHoriz.ResumeLayout(False)
        Me.tpSRvert.ResumeLayout(False)
        Me.pnlDepth.ResumeLayout(False)
        Me.pnlDepth.PerformLayout()
        CType(Me.numDepthRes, System.ComponentModel.ISupportInitialize).EndInit()
        Me.pnlAltitude.ResumeLayout(False)
        Me.pnlAltitude.PerformLayout()
        CType(Me.numAltRes, System.ComponentModel.ISupportInitialize).EndInit()
        Me.tabSection5.ResumeLayout(False)
        Me.tabEA.ResumeLayout(False)
        Me.tpEAdetail.ResumeLayout(False)
        Me.Panel19.ResumeLayout(False)
        Me.Panel19.PerformLayout()
        Me.tpEAover.ResumeLayout(False)
        Me.tpEAinfo.ResumeLayout(False)
        Me.tpEAinfo.PerformLayout()
        Me.tabSection6.ResumeLayout(False)
        Me.tabDI.ResumeLayout(False)
        Me.tpDImain.ResumeLayout(False)
        Me.tpDIinfo.ResumeLayout(False)
        Me.tpDIinfo.PerformLayout()
        Me.tabSection7.ResumeLayout(False)
        Me.tabMRef.ResumeLayout(False)
        Me.tpMRinfo.ResumeLayout(False)
        Me.tpMRinfo.PerformLayout()
        Me.tpMRext.ResumeLayout(False)
        Me.tpMRext.PerformLayout()
        Me.tpMRuse.ResumeLayout(False)
        Me.tpMRuse.PerformLayout()
        Me.Panel3.ResumeLayout(False)
        Me.Panel3.PerformLayout()
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region " Menus and toolbar buttons "

    '    Private Sub miFileNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '        Call runFileNew()
    '    End Sub

    '    Private Sub miFileClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '        Call runFileClose()
    '    End Sub

    '    Private Sub miFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '        runFileOpen()
    '    End Sub

    '    Private Sub miFileSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '        iSaveType = 1 'added April 2006 for version 1.2; tells Sub Save that this saves the metadata file
    '        If (strFileToSave = "") Then
    '            SaveFileDialog1.ShowDialog()
    '            strFileToSave = SaveFileDialog1.FileName
    '            If (strFileToSave <> "") Then
    '                runFileSave("dummy")
    '            End If
    '        Else
    '            runFileSave("dummy")
    '        End If
    '    End Sub

    '    Private Sub miFileSaveAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '        iSaveType = 1 'added April 2006 for version 1.2; tells Sub Save that this saves the metadata file
    '        SaveFileDialog1.ShowDialog()
    '        strFileToSave = SaveFileDialog1.FileName
    '        If (strFileToSave <> "") Then
    '            runFileSave("dummy")
    '        End If
    '    End Sub

    '    Private Sub miFileHTML_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '        'added 4/19/2006 as sole new feature for version 1.2
    '        '1. get the URL for the desired XSLT style sheet
    '        '2. write the current metadata as XML to a temporary file
    '        '   use XPath calls in FileSave routine to navigate the DOM object and replace CRLF characters in 
    '        '   selected nodes with the special character "mvcrlf*" -- which should not ever appear in metadata content
    '        '3. apply the style sheet to generate intermediate HTML (save to temporary file)
    '        '4. open the intermediate HTML file and read it line by line, exchanging "<br/>" for "mvcrlf*"
    '        '   this will preserve the paragraph structure of the original metadata
    '        '5. write final HTML to final file destination
    '        '6. clean up temporary files

    '        Dim sError As String = ""

    '        '1. get the URL for the desired XSLT style sheet
    '        Dim strXSLurl As String = ""  'will hold the URL for the style sheet
    '        Dim iLength As Integer = 0
    '        Dim frmGetStyle As New frmXMLchangeStyle(strCurHref)  'standard dialog window for style sheet; defined in version 1.0
    '        frmGetStyle.ShowDialog()
    '        strXSLurl = frmGetStyle.strNewHref 'the stylesheet for the HTML export
    '        strXSLurl = strXSLurl.Trim  'make sure no extraneous leading or trailing characters

    '        If (Len(strXSLurl) = 0) Then  'null stylesheet
    '            MessageBox.Show("No XSL stylesheet specified. Export to HTML failed", "Save Failed", MessageBoxButtons.OK)
    '            Return
    '        End If

    '        iLength = strXSLurl.Length
    '        strXSLurl = strXSLurl.Substring(1, iLength - 2)
    '        strXSLurl = strXSLurl.Trim  'make sure no extraneous leading or trailing characters

    '        If (Len(strXSLurl) = 0) Then  'null stylesheet
    '            MessageBox.Show("No XSL stylesheet specified. Export to HTML failed", "Save Failed", MessageBoxButtons.OK)
    '            Return
    '        End If

    '        'need to make sure the style sheet file exists
    '        Dim testURL As System.IO.File
    '        Dim boolURL As Boolean = testURL.Exists(strXSLurl)
    '        If (boolURL) Then
    '            'everything is okay
    '        Else
    '            sError = "Style sheet file not found! HTML export aborted." & CrLf & "Tip: the style sheet browse feature is more reliable"
    '            MessageBox.Show(sError, "HTML export error", MessageBoxButtons.OK, MessageBoxIcon.Error)
    '            Return
    '        End If

    '        '2. write the current metadata as XML to a temporary file
    '        '   use XPath calls in FileSave routine to navigate the DOM object and replace CRLF characters in 
    '        '   selected nodes with the special character "mvcrlf*" -- which should not ever appear in metadata content
    '        Dim strXMLtempfile As String = Application.StartupPath & "\mvtemp.xml"
    '        iSaveType = 2 'type 2 = save associated with HTML export
    '        Call runFileSave(strXMLtempfile)

    '        '3. apply the style sheet to generate intermediate HTML (save to temporary file)
    '        Dim xslTran As New System.Xml.Xsl.XslTransform
    '        Dim strHTMLtempfile As String = Application.StartupPath & "\mvtemp.html"
    '        Dim htmlMetafile As System.IO.FileStream
    '        Dim resolver As XmlUrlResolver = New XmlUrlResolver ' Create a resolver with default credentials.
    '        resolver.Credentials = System.Net.CredentialCache.DefaultCredentials

    '        htmlMetafile = System.IO.File.Create(strHTMLtempfile)
    '        htmlMetafile.Close()

    '        xslTran.Load(strXSLurl) 'load stylesheet
    '        xslTran.Transform(strXMLtempfile, strHTMLtempfile, resolver) 'apply stylesheet

    '        '4. open the intermediate HTML file and read it line by line, exchanging "<br/>" for "mvcrlf*"
    '        '   this will preserve the paragraph structure of the original metadata
    '        Dim iLoop As Integer = 0
    '        Dim sGenArray As New StringCollection
    '        Dim sParagraphs As New StringCollection
    '        Dim srMeta As StreamReader
    '        htmlMetafile = System.IO.File.OpenRead(strHTMLtempfile)
    '        srMeta = New StreamReader(htmlMetafile)
    '        sGenArray.Add("<?xml version='1.0' encoding='UTF-8'?>")
    '        Do Until srMeta.Peek = -1
    '            sGenArray.Add(srMeta.ReadLine)
    '        Loop
    '        srMeta.Close()
    '        iLength = sGenArray.Count
    '        For iLoop = 0 To iLength - 1
    '            sParagraphs.Add(sGenArray(iLoop).Replace(strParaMarker, strParaHTML))
    '        Next
    '        sGenArray.Clear()

    '        '5. write final HTML to final file destination
    '        Dim strSaveHTML As String = "" 'holds pathname to HTML output file

    '        SaveHTMLDialog.ShowDialog()
    '        strSaveHTML = SaveHTMLDialog.FileName
    '        MessageBox.Show(strSaveHTML, "HTML final file name", MessageBoxButtons.OK)
    '        If (strSaveHTML <> "") Then
    '            Dim swHTML As StreamWriter = File.CreateText(strSaveHTML)
    '            For iLoop = 0 To iLength - 1
    '                swHTML.WriteLine(sParagraphs(iLoop))
    '            Next
    '            swHTML.Flush()
    '            swHTML.Close()
    '            sParagraphs.Clear()
    '        Else
    '            sError = "No file specified for HTML output" & CrLf & "Conversion not performed"
    '            MessageBox.Show(sError, "HTML conversion process", MessageBoxButtons.OK, MessageBoxIcon.Error)
    '        End If

    '        System.IO.File.Delete(strXMLtempfile)
    '        System.IO.File.Delete(strHTMLtempfile)
    '    End Sub

    '    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '        Me.Dispose()
    '    End Sub

    '    Private Sub miXMLstyle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '        Dim strMetaHeader As String = ""
    '        Dim strFileDesignator As String = "'file:///"
    '        Dim strTempPath As String = ""

    '        Dim frmUpdateStyle As New frmXMLchangeStyle(strCurHref)
    '        frmUpdateStyle.ShowDialog()

    '        strCurHref = frmUpdateStyle.strNewHref
    '        If (Len(strCurHref) > 0) Then
    '            If (strCurHref.StartsWith("'http://") Or strCurHref.StartsWith("'file:///")) Then
    '                strTempPath = strCurHref
    '            Else
    '                MessageBox.Show("modifying stylesheet path", "output", MessageBoxButtons.OK)
    '                strTempPath = strCurHref.Remove(0, 1)
    '                strTempPath = strFileDesignator & strTempPath
    '            End If
    '            strMetaHeader = "<?xml version='1.0'?>" & CrLf & _
    '            strStylesheet1 & strTempPath & strStylesheet2 & CrLf & _
    '            "<metadata>" & CrLf & "</metadata>"
    '        Else
    '            strMetaHeader = "<?xml version='1.0'?>" & CrLf & "<metadata>" & CrLf & "</metadata>"
    '        End If
    '        xmlHeader.LoadXml(strMetaHeader)
    '    End Sub

    '    Private Sub mnuTime1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '        localTime()
    '    End Sub
    '    Private Sub localTime()
    '        intTimeStyle = 1 'local time
    '        'commented
    '        'miTime1.Checked = True
    '        'miTime2.Checked = False
    '        'miTime3.Checked = False
    '    End Sub

    '    Private Sub mnuTime2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '        differTime()
    '    End Sub
    '    Private Sub differTime()
    '        intTimeStyle = 2 'local time with time differential factor
    '        'commented
    '        'miTime1.Checked = False
    '        'miTime2.Checked = True
    '        'miTime3.Checked = False
    '    End Sub

    '    Private Sub mnuTime3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '        univTime()
    '    End Sub
    '    Private Sub univTime()
    '        intTimeStyle = 3 'universal
    '        'commented
    '        'miTime1.Checked = False
    '        'miTime2.Checked = False
    '        'miTime3.Checked = True
    '    End Sub

    '    Private Sub mnuHelpHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '        Dim s1 As String = ""
    '        s1 = "All available help is provided in the program manual," & CrLf & "the Standard manuals, and the worked examples."
    '        s1 += CrLf & CrLf & "If you have a question not addressed in the other resources, " & CrLf
    '        s1 += "or you would like to make a suggestion about the software " & CrLf
    '        s1 += "or its manual, please send an e-mail to the author, Dave Rugg, " & CrLf
    '        s1 += "at drugg@fs.fed.us."
    '        MessageBox.Show(s1, "Metavist Help", MessageBoxButtons.OK, MessageBoxIcon.Information)
    '    End Sub

    '    Private Sub miITIS_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '        Dim s1 As String = Application.StartupPath & "\ITIShelp.html"
    '        Try
    '            System.Diagnostics.Process.Start(s1)
    '        Catch ex As Exception
    '            s1 = "Couldn't find ITIS help file." & vbCrLf & "Contact program author: see Help-About"
    '            MessageBox.Show(s1, "Missing help file", MessageBoxButtons.OK)
    '        End Try
    '    End Sub

    '    Private Sub mnuHelpAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '        Dim sDisplayString As String
    '        sDisplayString = "Metavist 2005" & CrLf & "Data entry for FGDC or NBII metadata with XML output" & CrLf
    '        sDisplayString += CrLf & "version 1.6 (November 2007)" & CrLf
    '        sDisplayString += "for .Net Framework version 2.0" & CrLf & CrLf
    '        sDisplayString += CrLf & "Written by Dave Rugg" & CrLf
    '        sDisplayString += "USDA Forest Service" & CrLf
    '        sDisplayString += "Northern Research Station" & CrLf & "1992 Folwell Avenue, St. Paul, MN 55108" & CrLf
    '        sDisplayString += "http://www.nrs.fs.fed.us" & CrLf
    '        MessageBox.Show(sDisplayString, "About Metavist", MessageBoxButtons.OK, MessageBoxIcon.Information)
    '    End Sub

    '    'Private Sub ToolBar1_ButtonClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ToolBarButtonClickEventArgs)
    '    '    ' Evaluate the Button property to determine which button was clicked.
    '    '    Select Case ToolBar1.Buttons.IndexOf(e.Button)
    '    '        Case 0
    '    '            Call runFileNew()
    '    '        Case 1
    '    '            Call runFileOpen()
    '    '        Case 2
    '    '            iSaveType = 1 'added April 2006 for version 1.2; tells runFileSave how to save the metadata file
    '    '            If (strFileToSave = "") Then
    '    '                SaveFileDialog1.ShowDialog()
    '    '                strFileToSave = SaveFileDialog1.FileName
    '    '                If (strFileToSave <> "") Then
    '    '                    runFileSave("dummy")
    '    '                End If
    '    '            Else
    '    '                runFileSave("dummy")
    '    '            End If
    '    '    End Select
    '    'End Sub

    '    Private Sub runFileNew()
    '        miFileClose.Enabled = True
    '        miFileSave.Enabled = True
    '        btnFileSave.Enabled = True
    '        miFileSaveAs.Enabled = True
    '        miFileHTML.Enabled = True
    '        miFileNew.Enabled = False
    '        mnuOptions.Enabled = True
    '        Me.btnFileNew.Enabled = False
    '        tabMainSection.Visible = True

    '        bActiveFile = True
    '        bTimeUsed = False
    '        strFileToSave = "" 'reset name of metadata file

    '        'clear the header DOM, the section XML nodes, and all metadata elements
    '        InitialDOM()

    '        'set up new standard header DOM
    '        strCurHref = "'file:///" & Application.StartupPath & "\NBII_classic.xsl'"
    '        Dim strMetaHeader As String = "<?xml version='1.0'?>" & CrLf & _
    '               strStylesheet1 & strCurHref & strStylesheet2 & CrLf & _
    '               "<metadata>" & CrLf & "</metadata>"
    '        xmlHeader.LoadXml(strMetaHeader)

    '        'create and append standard XML declaration: version 1.0, stand-alone, UTF-8 encoding
    '        'Dim xmlNode As XmlNode = xmlHeader.CreateXmlDeclaration("1.0", "", "")
    '        'xmlHeader.AppendChild(xmlNode)
    '        'create and append XSLT processing instruction for display of NBII metadata in browser
    '        'Dim xmlPI As XmlProcessingInstruction
    '        'Dim PItext As String = "type='text/xsl' href='nc_NBII.xsl'"
    '        'xmlPI = xmlHeader.CreateProcessingInstruction("xml-stylesheet", PItext)
    '        'xmlHeader.AppendChild(xmlPI)
    '    End Sub

    '    Private Sub runFileClose()
    '        miFileNew.Enabled = True
    '        btnFileNew.Enabled = True
    '        tabMainSection.Visible = False
    '        miFileClose.Enabled = False
    '        miFileSave.Enabled = False
    '        btnFileSave.Enabled = False
    '        miFileSaveAs.Enabled = False
    '        miFileHTML.Enabled = False
    '        mnuOptions.Enabled = False
    '        bActiveFile = False
    '        Me.Text = "Metavist"
    '    End Sub

    '    Private Sub runFileOpen()
    '        xmlInputDOM = New XmlDocument 'initialize the DOM

    '        If OpenFileDialog1.ShowDialog() = DialogResult.OK Then
    '            Try
    '                'load XML into Document Object Model (DOM)
    '                xmlInputDOM.Load(OpenFileDialog1.FileName)
    '            Catch ex As Exception
    '                MessageBox.Show(ex.Message, "Error loading XML from specified file", MessageBoxButtons.OK, MessageBoxIcon.Error)
    '                Return
    '            End Try
    '        Else
    '            Return
    '        End If

    '        'file succesfully opened and XML loaded into xmlInputDOM
    '        'prepare to transfer metadata from xmlInputDOM to Metavist
    '        runFileClose() 'close any existing file
    '        runFileNew() 'reinitialize the interface and variables

    '        'add the file name to the window title
    '        strFileToSave = OpenFileDialog1.FileName 'full file name for use in Save operations
    '        Dim sFileTemp As String = ""
    '        Dim sGenArray() As String
    '        Dim iBound As Integer = 0
    '        sGenArray = Split(strFileToSave, "\") 'break full file name into components
    '        iBound = sGenArray.GetUpperBound(0)   'get upper bound of array
    '        sFileTemp = sGenArray(iBound) 'get the last component -- should be the file name, no path info
    '        Me.Text = "Metavist  " & sFileTemp

    '        'retrieve the style sheet info in the file, if any, and update
    '        Dim iCount As Integer = 0
    '        Dim iPosHRef As Integer = 0
    '        Dim iPosEq As Integer = 0
    '        Dim iPosEnd As Integer = 0
    '        Dim xmlNList As XmlNodeList
    '        Dim xmlProcNode As XmlNode
    '        Dim sProcInsVal As String = ""
    '        Dim sProcDelim As String = ""
    '        xmlNList = xmlInputDOM.SelectNodes("/processing-instruction('xml-stylesheet')")
    '        iCount = xmlNList.Count
    '        If (iCount > 0) Then
    '            'retrieve last stylesheet in tree
    '            'last stylesheet is the one used for presentation in browser, so is assumed active
    '            xmlProcNode = xmlNList.Item(iCount - 1) 'zero-based list of nodes
    '            sProcInsVal = xmlProcNode.Value
    '            iPosHRef = sProcInsVal.IndexOf("href")
    '            iPosEq = sProcInsVal.IndexOf("=", iPosHRef)
    '            sProcInsVal = sProcInsVal.Substring(iPosEq + 1) 'eliminates href and equal sign, preserves rest of substring
    '            sProcInsVal = sProcInsVal.TrimStart
    '            sProcDelim = sProcInsVal.Substring(0, 1) 'gets the delimiter character
    '            iPosEnd = sProcInsVal.IndexOf(sProcDelim, 1) 'gets position of ending delimiter
    '            If (iPosEnd <= 0) Then
    '                'no change to std stylesheet -- malformed processing instruction
    '            Else
    '                iPosEnd = iPosEnd + 1 'length of href identifier
    '                strCurHref = sProcInsVal.Substring(0, iPosEnd)
    '                InitialDOM() 'reset the XML
    '                'load new stylesheet processing instruction
    '                Dim strMetaHeader As String = "<?xml version='1.0'?>" & CrLf & _
    '                       strStylesheet1 & strCurHref & strStylesheet2 & CrLf & _
    '                       "<metadata>" & CrLf & "</metadata>"
    '                xmlHeader.LoadXml(strMetaHeader)
    '            End If
    '        Else
    '            'use standard stylesheet processing instruction
    '            strCurHref = "'NBII_classic.xsl'"
    '            Dim strMetaHeader As String = "<?xml version='1.0'?>" & CrLf & _
    '                   strStylesheet1 & strCurHref & strStylesheet2 & CrLf & _
    '                   "<metadata>" & CrLf & "</metadata>"
    '            xmlHeader.LoadXml(strMetaHeader)
    '        End If

    '        'update the time format used, if present
    '        Dim sError As String = ""
    '        xmlNList = xmlInputDOM.SelectNodes("/metadata/metainfo/mettc")
    '        iCount = xmlNList.Count
    '        If (iCount = 0) Then
    '            'no element, so no change to default of local time
    '        Else
    '            xmlProcNode = xmlNList.Item(0) 'get the time format node from list
    '            sProcInsVal = xmlProcNode.InnerText
    '            Select Case sProcInsVal
    '                Case "local time"
    '                    localTime()
    '                Case "local time with time differential factor"
    '                    differTime()
    '                Case "universal time"
    '                    univTime()
    '                Case Else
    '                    sError = "File's value of " & sProcInsVal & "not valid member of domain." & CrLf
    '                    sError += "local time will be the format until you change the setting under Options"
    '                    MessageBox.Show(sError, "Time Convention Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
    '            End Select
    '        End If

    '        'process the metadata sections
    '        openNBII()

    '    End Sub

    '    Private Sub runFileSave(ByVal strFileRef As String)
    '        'code to save the metadata file being worked on
    '        'modified April 2006 for version 1.2 to use iSaveType and strFileRef as part of HTML conversion

    '        'create XML DOM structure

    '        Dim xmlMetafile As System.IO.FileStream
    '        Dim strError As String = ""
    '        'xmlMetafile = System.IO.File.Create("c:\djr files\data management\metadata xslt\test.xml")
    '        If (iSaveType = 1) Then
    '            'write permanent copy of metadata
    '            xmlMetafile = System.IO.File.Create(strFileToSave)
    '        ElseIf (iSaveType = 2) Then
    '            'write temporary copy of metadata
    '            xmlMetafile = System.IO.File.Create(strFileRef)
    '        Else
    '            strError = "Save Type is " & iSaveType.ToString & "  not a legal value." & CrLf & "Contact the author."
    '            MessageBox.Show("Save Type is ", "File Save Error", MessageBoxButtons.OK)
    '        End If

    '        'with valid filestream created, set the time use marker to False
    '        bTimeUsed = False

    '        'update the main section nodes
    '        updateIDsection()   'section 1
    '        updateDQsection()   'section 2
    '        updateSPDOsection() 'section 3
    '        updateSpRef()       'section 4
    '        updateEAsection()   'section 5
    '        updateDIsection()   'section 6
    '        updateMRsection()   'section 7

    '        'add the updated section nodes to the XML document to be saved
    '        xmlHeader.DocumentElement.AppendChild(xmlIDsection)
    '        If (xmlDQIsection.HasChildNodes = True) Then xmlHeader.DocumentElement.AppendChild(xmlDQIsection)
    '        If (xmlSDOsection.HasChildNodes = True) Then xmlHeader.DocumentElement.AppendChild(xmlSDOsection)
    '        If (xmlSpaRefSection.HasChildNodes = True) Then xmlHeader.DocumentElement.AppendChild(xmlSpaRefSection)
    '        If (xmlEAsection.HasChildNodes = True) Then xmlHeader.DocumentElement.AppendChild(xmlEAsection)
    '        If (cDistrib.Count > 0) Then xmlHeader.DocumentElement.AppendChild(xmlDistSection)
    '        xmlHeader.DocumentElement.AppendChild(xmlMetaRefSection)

    '        'write the XML document to the specified file, close the file, clear the document
    '        xmlHeader.Save(xmlMetafile)
    '        xmlMetafile.Close()
    '        xmlHeader.DocumentElement.RemoveAll()
    '        xmlIDsection = xmlHeader.CreateElement("idinfo")
    '        xmlDQIsection = xmlHeader.CreateElement("dataqual")
    '        xmlSDOsection = xmlHeader.CreateElement("spdoinfo")
    '        xmlSpaRefSection = xmlHeader.CreateElement("spref")
    '        xmlEAsection = xmlHeader.CreateElement("eainfo")
    '        xmlDistSection = xmlHeader.CreateDocumentFragment
    '        xmlMetaRefSection = xmlHeader.CreateElement("metainfo")

    '        'having successfully saved a file, add the file name to the window title if it was a permanent save
    '        If (iSaveType = 1) Then
    '            Dim sFileTemp As String = ""
    '            Dim sGenArray() As String
    '            Dim iBound As Integer = 0
    '            sGenArray = Split(strFileToSave, "\") 'break full file name into components
    '            iBound = sGenArray.GetUpperBound(0)   'get upper bound of array
    '            sFileTemp = sGenArray(iBound) 'get the last component -- should be the file name, no path info
    '            Me.Text = "Metavist  " & sFileTemp
    '        End If

    '    End Sub

#End Region


#Region " Initialization routines for new metadata document "

    Private Sub InitialDOM()
        'sets up a fresh set of document and node templates
        xmlHeader = New XmlDocument
        xmlIDsection = xmlHeader.CreateElement("idinfo")
        xmlDQIsection = xmlHeader.CreateElement("dataqual")
        xmlSDOsection = xmlHeader.CreateElement("spdoinfo")
        xmlSpaRefSection = xmlHeader.CreateElement("spref")
        xmlEAsection = xmlHeader.CreateElement("eainfo")
        xmlDistSection = xmlHeader.CreateDocumentFragment
        xmlMetaRefSection = xmlHeader.CreateElement("metainfo")

        'initialize general variables
        'localTime() 'set local time as default
        'xmlAttrib = xmlHeader.CreateAttribute("missing")
        'xmlAttrib.Value = "True"

        'clear input from all metadata elements
        initID()
        initDQ()
        initSPDO()
        initSpRef()
        initEA()
        initDI()
        initMR()

        'set display tab page to Basic Info of Identification section
        tabMainSection.SelectedIndex = 0
        tabID.SelectedIndex = 0
    End Sub

    Private Sub initID()
        'Basic information
        objCitation = New CiteInfo
        objCitationLWork = New CiteInfo
        bCitationLWork = False
        IDtimeper = New Collection
        'Spatial Domain
        sDataSetGPoly = New StringCollection
        sCountGPoly = New StringCollection
        'Keywords
        sKeyTheme = New StringCollection
        sKeyPlace = New StringCollection
        sKeyStratum = New StringCollection
        sKeyTemporal = New StringCollection
        'Taxonomy
        sTaxKeywords = New StringCollection
        citeTaxSys = New Collection 'holds the main citation information for Taxonomic System
        boolTaxSys = New Collection 'holds Booleans indicating whether LWC is used
        citeTaxSysLWC = New Collection 'holds larger work citations
        sTaxSysMods = New StringCollection 'holds the Taxonomic System modifications
        citeTaxIDRef = New Collection 'holds the main citation information for Identification Reference
        boolTaxIDRef = New Collection 'holds Booleans indicating whether LWC is used
        citeTaxIDRefLWC = New Collection 'holds larger work citations
        cntTaxID = New Collection 'holds contact information for Identifier(s) -- optional
        sVSpecimen = New StringCollection 'holds the specimen info for vouchers
        cntVouchers = New Collection 'holds the contact info for voucher repository
        TaxaClasses = New Collection 'holds the taxonomic classification nodes
        xmlTaxonClass = New XmlDocument 'holds the taxonomic classification XML tree
        'Access
        objDataContact = New ContactInfo 'only 1 point of contact
        'Analytical Tools
        idTools = New Collection
        'Miscellaneous
        sBrowseGraphics = New StringCollection
        XRefBase = New Collection
        bXRefLWC = New Collection
        XRefLarge = New Collection

        clrIDinfo()
    End Sub

    Private Sub clrIDinfo()
        'Basic information
        txtIDCiteAuth.Clear()
        txtIDCiteDate.Clear()
        txtIDCiteTitle.Clear()
        txtAbstract.Clear()
        txtPurpose.Clear()
        txtSupplInfo.Clear()
        rdoTUnknown.Checked = True
        rdoTLocal.Checked = True
        lboxTime.Items.Clear()
        cboxCurRef.Text = ""
        cboxCurRef.SelectedIndex = -1
        lboxProg.SelectedIndex = -1
        cboxUpdate.Text = ""
        cboxUpdate.SelectedIndex = -1
        'Spatial Domain
        txtGeoExt.Text = ""
        numWestBC.Value = 0
        numEastBC.Value = 0
        numNorthBC.Value = 0
        numSouthBC.Value = 0
        numAltMin.Value = 0
        numAltMax.Value = 0
        cboxIDaltDistU.Text = ""
        cboxIDaltDistU.SelectedIndex = -1
        lboxGPoly.Items.Clear()
        'Keywords
        lboxKTheme.Items.Clear()
        lboxKPlace.Items.Clear()
        lboxKStratum.Items.Clear()
        lboxKTemporal.Items.Clear()
        'Taxonomy
        txtTaxCover.Text = ""
        txtTaxProc.Text = ""
        txtTaxCover.Text = ""
        lboxTaxKey.Items.Clear()
        lboxTaxSys.Items.Clear()
        lboxTaxIDRef.Items.Clear()
        lboxVouchers.Items.Clear()
        lboxLinneaus.Items.Clear()
        'Access
        txtIDaccess.Text = ""
        txtIDuse.Text = ""
        txtDataContact.Text = ""
        txtDataSecSys.Text = ""
        cboxDataSecClass.Text = ""
        cboxDataSecClass.SelectedIndex = -1
        txtDataSecDesc.Text = ""
        'Analytical Tools
        lboxTool.Items.Clear()
        'Miscellaneous
        txtDScredit.Text = ""
        txtDSenviron.Text = ""
        lboxBrGraphic.Items.Clear()
        lboxXRef.Items.Clear()

    End Sub

    Private Sub initDQ()
        'Attribute Accuracy
        sAttribAcc = New StringCollection
        txtAttribAcc.Text = ""
        lboxAttribAcc.Items.Clear()
        'Consistency & Completeness
        txtLogic.Text = ""
        txtComplete.Text = ""
        'Positional Accuracy
        txtHorAccRpt.Text = ""
        sHPosAcc = New StringCollection
        lboxHPosAcc.Items.Clear()
        txtVertAccRpt.Text = ""
        sVPosAcc = New StringCollection
        lboxVPosAcc.Items.Clear()
        'Lineage
        cMethods = New Collection
        cSources = New Collection
        cProcess = New Collection
        lboxMeth.Items.Clear()
        lboxLinSource.Items.Clear()
        lboxProcess.Items.Clear()
        'Cloud Cover
        rdoNoCloud.Checked = True
        pnlCloud.Visible = False
        numCloud.Value = 0
    End Sub

    Private Sub initSPDO()
        sSDTS = New StringCollection 'holds collection of SDTS or VPF terms descriptions, if used
        bSDTS = False
        bVPF = False
        txtIndirect.Text = ""
        cboxDirect.SelectedIndex = -1

        lblVector.Visible = True
        Panel12.Visible = False
        rdoNoDesc.Checked = True
        lboxTerms.Items.Clear()
        cboxVPF.SelectedIndex = -1

        lblRaster.Visible = True
        Panel10.Visible = False
        cboxRasType.SelectedIndex = -1
        numRasRow.Value = 0
        numRasCol.Value = 0
        numRasVert.Value = 0
    End Sub

    Private Sub initSpRef()
        'Horizontal Coordinate System Definition
        'set up projection systems
        rdoNone.Checked = True 'default is no definition
        pnlGeographic.Enabled = False
        numLatRes.Value = 0
        numLongRes.Value = 0
        cboxGeoCoorUnits.SelectedIndex = -1
        pnlPlanar.Enabled = False
        lboxPlanar.Items.Clear()
        cPlanar = New Collection
        pnlLocal.Enabled = False
        txtLocalDesc.Text = ""
        txtLocalGeoInfo.Text = ""
        'set up geodetic model
        cboxHorizName.Text = ""
        cboxHorizName.SelectedIndex = -1
        cboxEllipsoid.Text = ""
        cboxEllipsoid.SelectedIndex = -1
        numSemiMajor.Value = 6378137D
        numFlatten.Value = 298.25722210088D

        'Vertical Coordinate System Definition
        'Altitude sub-section
        cboxAltDatum.Text = ""
        cboxAltDatum.SelectedIndex = -1
        numAltRes.Value = 0
        txtAltRes.Text = ""
        cboxAltUnits.Text = ""
        cboxAltUnits.SelectedIndex = -1
        cboxAltEncode.SelectedIndex = -1
        'Depth sub-section
        cboxDepthDatum.Text = ""
        cboxDepthDatum.SelectedIndex = -1
        numDepthRes.Value = 0
        txtDepthRes.Text = ""
        cboxDepthUnits.Text = ""
        cboxDepthUnits.SelectedIndex = -1
        cboxDepthEncode.SelectedIndex = -1
    End Sub

    Private Sub initEA()
        cEAentity = New Collection
        cEAttribs = New Collection
        cEAdomains = New Collection
        cEAdomtype = New StringCollection
        cEAdomtype.Add("unused") 'initialize 0th element so collection is 1-based
        cEAttrOver = New Collection
        lboxOverView.Items.Clear()
        cboxEntity.Items.Clear()
        cboxAttrib.Items.Clear()
        cboxDomains.Items.Clear()
        ClearElem()
    End Sub

    Private Sub initDI()
        cDistrib = New Collection 'the distributors of the data set
        cStdOrderProc = New Collection 'standard order process descriptions
        cDigitalForm = New Collection 'Digital forms for the standard order processes
        cDTransOpt = New Collection 'Digital Transfer Options for Digital Forms
        lboxDistrib.Items.Clear()
    End Sub

    Private Sub initMR()
        objMRcontact = New ContactInfo 'only 1 possible contact
        cboxStdName.SelectedIndex = 0
        cboxStdVer.SelectedIndex = 0
        txtMRcontact.Text = ""
        txtMRaccess.Text = ""
        txtMRuse.Text = ""
        txtMRClassSys.Text = ""
        txtMRSecDesc.Text = ""
        cboxMRClass.SelectedIndex = -1
        cboxMRClass.Text = ""
        chkRevDate.Checked = False
        chkFRevDate.Checked = False
        dtPick1.Value = Today
        dtPick2.Value = Today
        dtPick3.Value = Today
    End Sub

#End Region


#Region " Retrieving Section element values from DOM "

    Private Sub openNBII()
        Dim xmlOpenSect As New XmlDocument
        Dim xmlNList As XmlNodeList
        Dim sNBIIinfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0

        'get the idinfo section from the main XML document, if present
        xmlNList = xmlInputDOM.SelectNodes("/metadata/idinfo")
        If (xmlNList.Count > 0) Then
            'max of 1 ID Info section
            sNBIIinfo = xmlNList(0).OuterXml
            xmlOpenSect.LoadXml(sNBIIinfo)
            openID(xmlOpenSect)
        End If

        'get the dataqual section from the main XML document, if present
        xmlNList = xmlInputDOM.SelectNodes("/metadata/dataqual")
        If (xmlNList.Count > 0) Then
            'max of 1 Data Quality Info section
            sNBIIinfo = xmlNList(0).OuterXml
            xmlOpenSect.LoadXml(sNBIIinfo)
            openDQ(xmlOpenSect)
        End If

        'get the spdoinfo section from the main XML document, if present
        xmlNList = xmlInputDOM.SelectNodes("/metadata/spdoinfo")
        If (xmlNList.Count > 0) Then
            'max of 1 Spatial Data Organization Info section
            sNBIIinfo = xmlNList(0).OuterXml
            xmlOpenSect.LoadXml(sNBIIinfo)
            openSpDO(xmlOpenSect)
        End If

        'get the spref section from the main XML document, if present
        xmlNList = xmlInputDOM.SelectNodes("/metadata/spref")
        If (xmlNList.Count > 0) Then
            'max of 1 Spatial Reference Info section
            sNBIIinfo = xmlNList(0).OuterXml
            xmlOpenSect.LoadXml(sNBIIinfo)
            openSpRef(xmlOpenSect)
        End If

        'get the eainfo section from the main XML document, if present
        xmlNList = xmlInputDOM.SelectNodes("/metadata/eainfo")
        If (xmlNList.Count > 0) Then
            'max of 1 Entity & Attribute Info section
            sNBIIinfo = xmlNList(0).OuterXml
            xmlOpenSect.LoadXml(sNBIIinfo)
            openEA(xmlOpenSect)
        End If

        'get the distinfo section from the main XML document, if present
        'note that there can be more than 1 distinfo section!
        xmlNList = xmlInputDOM.SelectNodes("/metadata/distinfo")
        iCount = xmlNList.Count - 1
        For iLoop = 0 To iCount
            sNBIIinfo = xmlNList(iLoop).OuterXml
            xmlOpenSect.LoadXml(sNBIIinfo)
            openDistrib(xmlOpenSect)
        Next

        'get the metainfo section from the main XML document, if present
        xmlNList = xmlInputDOM.SelectNodes("/metadata/metainfo")
        If (xmlNList.Count > 0) Then
            'max of 1 Metadata Reference Information section
            sNBIIinfo = xmlNList(0).OuterXml
            xmlOpenSect.LoadXml(sNBIIinfo)
            openMR(xmlOpenSect)
        End If
    End Sub

    Private Sub evalDate(ByRef sCandidate As String, ByRef bTrans As Boolean)
        Dim iCheck As Integer = -10
        Dim iLength As Integer = 0
        Dim sTimeScale As String = ""
        Dim sCanDate As String = ""
        Dim sTest As String = ""

        bTrans = True 'initialize as a proper date
        sCanDate = sCandidate
        iLength = sCandidate.Length 'get the length of the proposed date string

        'evaluate whether date is Before Common Era (bc) or pre-Before Common Era (cc)
        If (iLength > 4) Then
            sTimeScale = sCandidate.Substring(0, 2)
            If (sTimeScale = "bc" Or sTimeScale = "cc") Then
                'adjust the string and its length to test just the date
                sCanDate = sCandidate.Substring(2)
                iLength = iLength - 2
            End If
        End If

        'make sure the candidate date is an integer and of the correct length
        If (sTimeScale = "cc") Then
            'minimum length is 5; maximum is arbitrarily set at 10 (1 billion) in the program -- earlier uses Geologic Age
            If (iLength > 4 And iLength < 11) Then
                'check to ensure positive integer
                Try
                    iCheck = Convert.ToInt32(sCanDate)
                    MessageBox.Show(iCheck.ToString, "converted integer", MessageBoxButtons.OK)
                Catch ex As Exception
                    bTrans = False
                    iCheck = -10
                End Try
                'check the value of the integer to fit in the bounds
                If (iCheck > 1000000000) Then
                    iCheck = 1000000000
                    sTest = "Input date of " & sCandidate & CrLf & "converted to " & sTimeScale & iCheck.ToString
                    sCandidate = sTimeScale & iCheck.ToString
                    MessageBox.Show(sTest, "Conversion of date  exceeded maximum value", MessageBoxButtons.OK)
                End If
                If (iCheck < 10000) Then
                    iCheck = 10000
                    sTest = "Input date of " & sCandidate & CrLf & "converted to " & sTimeScale & iCheck.ToString
                    sCandidate = sTimeScale & iCheck.ToString
                    MessageBox.Show(sTest, "Conversion of date  exceeded minimum value", MessageBoxButtons.OK)
                End If
            Else
                'not a proper cc date
                bTrans = False
            End If
        Else
            'bc and Common Era dates
            Select Case iLength
                Case 4, 6, 8
                    Try
                        iCheck = Convert.ToInt32(sCanDate)
                    Catch ex As Exception
                        bTrans = False
                    End Try
                    If (bTrans = True) Then
                        'check the value of the integer to fit in the bounds
                        If (iCheck < 1) Then
                            bTrans = False
                        End If
                    End If
                Case Else
                    bTrans = False
            End Select
        End If
    End Sub

#End Region


#Region " DOM processing routines for ID Info section "

    Private Sub openID(ByVal xmlOpenID As XmlDocument)
        Dim xmlTempDoc As New XmlDocument
        Dim xmlTempSubDoc As New XmlDocument 'handles subsections of xmlTempDoc
        Dim xmlTimeDoc As New XmlDocument 'will handle Time Info sub-section
        Dim xmlNList As XmlNodeList
        Dim oCite As New CiteInfo 'for Citation
        Dim oNewContact As New ContactInfo
        Dim oSource As New SourceClass 'for Time Info
        Dim cIDTimeColl As New Collection 'for Time Info
        Dim s1 As String = ""
        Dim sIDinfo As String = ""
        Dim iSelInd As Integer = 0
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim bCheck As Boolean 'generic boolean
        Dim bCheck2 As Boolean 'another generic boolean

        'open Citation
        xmlNList = xmlOpenID.SelectNodes("/idinfo/citation/citeinfo")
        If (xmlNList.Count > 0) Then
            'get Citation Information node
            sIDinfo = xmlOpenID.SelectSingleNode("/idinfo/citation/citeinfo").OuterXml
            'the OuterXml will get a citeinfo, including any larger work citation nodes
        Else
            sIDinfo = ""
        End If

        'process XML if present
        If (sIDinfo <> "") Then
            'load the Citation Information
            xmlTempDoc.LoadXml(sIDinfo)
            bCitationLWork = False 'larger work citation indicator
            bCheck = False 'local larger work citation indicator
            'need to call the citeinfo processing routine, then place results into public objects
            openCite(xmlTempDoc, oCite, bCheck)
            If (bCheck = True) Then
                objCitation = oCite 'place citation information into public object
                'check for presence of a larger work citation
                xmlNList = xmlTempDoc.SelectNodes("/citeinfo/lworkcit")
                If (xmlNList.Count > 0) Then
                    'process the larger work citation
                    sIDinfo = xmlTempDoc.SelectSingleNode("/citeinfo/lworkcit").InnerXml
                    xmlTempSubDoc.LoadXml(sIDinfo) 'holds the larger work citation
                    'the InnerXml will get the citeinfo under lworkcit
                    'need to call the citeinfo processing routine, then place results into oGeol
                    openCite(xmlTempSubDoc, oCite, bCheck2)
                    If (bCheck2 = True) Then
                        bCitationLWork = True
                        objCitationLWork = oCite 'update public larger work citation object with current LWC info
                    End If
                End If 'end processing of larger work citation
                'fill the form controls
                txtIDCiteAuth.Text = objCitation.Author
                txtIDCiteDate.Text = objCitation.PubDate
                txtIDCiteTitle.Text = objCitation.Title
            End If 'end processing of citation
        End If


        'open Description
        xmlNList = xmlOpenID.SelectNodes("/idinfo/descript")
        If (xmlNList.Count > 0) Then
            'get Description node
            sIDinfo = xmlOpenID.SelectSingleNode("/idinfo/descript").OuterXml
        Else
            sIDinfo = ""
        End If

        If (sIDinfo <> "") Then
            xmlTempDoc.LoadXml(sIDinfo) 'load the Description node
            'retrieve Abstract
            xmlNList = xmlTempDoc.SelectNodes("/descript/abstract")
            If (xmlNList.Count > 0) Then
                sIDinfo = xmlTempDoc.SelectSingleNode("/descript/abstract").InnerText
                If (sIDinfo <> "") Then txtAbstract.Text = sIDinfo
            End If
            'retrieve Purpose
            xmlNList = xmlTempDoc.SelectNodes("/descript/purpose")
            If (xmlNList.Count > 0) Then
                sIDinfo = xmlTempDoc.SelectSingleNode("/descript/purpose").InnerText
                If (sIDinfo <> "") Then txtPurpose.Text = sIDinfo
            End If
            'retrieve Supplemental Info
            xmlNList = xmlTempDoc.SelectNodes("/descript/supplinf")
            If (xmlNList.Count > 0) Then
                sIDinfo = xmlTempDoc.SelectSingleNode("/descript/supplinf").InnerText
                If (sIDinfo <> "") Then txtSupplInfo.Text = sIDinfo
            End If
        End If


        'open Time Period of Content
        xmlNList = xmlOpenID.SelectNodes("/idinfo/timeperd")
        If (xmlNList.Count > 0) Then
            'get Time Period of Content node
            sIDinfo = xmlOpenID.SelectSingleNode("/idinfo/timeperd").OuterXml
            openIDtime(sIDinfo)
        End If

        'open Status
        xmlNList = xmlOpenID.SelectNodes("/idinfo/status")
        If (xmlNList.Count > 0) Then
            'get Status node
            sIDinfo = xmlOpenID.SelectSingleNode("/idinfo/status").OuterXml
        Else
            sIDinfo = ""
        End If

        If (sIDinfo <> "") Then
            xmlTempDoc.LoadXml(sIDinfo)
            'retrieve Progress
            xmlNList = xmlTempDoc.SelectNodes("/status/progress")
            If (xmlNList.Count > 0) Then
                sIDinfo = xmlTempDoc.SelectSingleNode("/status/progress").InnerText
                If (sIDinfo <> "") Then
                    iSelInd = lboxProg.FindString(sIDinfo)
                    lboxProg.SelectedIndex = iSelInd
                End If
            End If
            'retrieve Update Frequency, set the combo box
            xmlNList = xmlTempDoc.SelectNodes("/status/update")
            If (xmlNList.Count > 0) Then
                sIDinfo = xmlTempDoc.SelectSingleNode("/status/update").InnerText
                If (sIDinfo <> "") Then
                    iSelInd = cboxUpdate.FindStringExact(sIDinfo)
                    If (iSelInd = -1) Then
                        'a free text element
                        cboxUpdate.Items.Add(sIDinfo)
                        cboxUpdate.SelectedIndex = cboxUpdate.Items.Count - 1
                    Else
                        cboxUpdate.SelectedIndex = iSelInd
                    End If
                End If
            End If
        End If


        'open Spatial Domain
        xmlNList = xmlOpenID.SelectNodes("/idinfo/spdom")
        If (xmlNList.Count > 0) Then
            'get Spatial Domain node
            sIDinfo = xmlOpenID.SelectSingleNode("/idinfo/spdom").OuterXml
            openIDspdom(sIDinfo)
        End If

        'open Keywords
        xmlNList = xmlOpenID.SelectNodes("/idinfo/keywords")
        If (xmlNList.Count > 0) Then
            'get Keywords node
            sIDinfo = xmlOpenID.SelectSingleNode("/idinfo/keywords").OuterXml
            openIDkeywords(sIDinfo)
        End If

        'open Taxonomy
        xmlNList = xmlOpenID.SelectNodes("/idinfo/taxonomy")
        If (xmlNList.Count > 0) Then
            'get Taxonomy node
            sIDinfo = xmlOpenID.SelectSingleNode("/idinfo/taxonomy").OuterXml
            openIDtaxonomy(sIDinfo)
        End If

        'open Access Constraints
        xmlNList = xmlOpenID.SelectNodes("/idinfo/accconst")
        If (xmlNList.Count > 0) Then
            sIDinfo = xmlNList(0).InnerText.Trim
            txtIDaccess.Text = sIDinfo
        End If

        'open Use Constraints
        xmlNList = xmlOpenID.SelectNodes("/idinfo/useconst")
        If (xmlNList.Count > 0) Then
            sIDinfo = xmlNList(0).InnerText.Trim
            txtIDuse.Text = sIDinfo
        End If

        'open Point of Contact
        xmlNList = xmlOpenID.SelectNodes("/idinfo/ptcontac")
        If (xmlNList.Count > 0) Then
            sIDinfo = xmlNList(0).InnerXml
            openContact(sIDinfo, oNewContact)
            objDataContact = oNewContact 'update the contact object
            If (objDataContact.PrimaryPerson = True) Then 'update the form display
                txtDataContact.Text = objDataContact.Person
            Else
                txtDataContact.Text = objDataContact.Organization
            End If
        End If

        'open Browse Graphic(s), if present
        xmlNList = xmlOpenID.SelectNodes("/idinfo/browse")
        iCount = xmlNList.Count
        For iLoop = 0 To iCount - 1
            sIDinfo = xmlNList(iLoop).OuterXml
            openIDgraphic(sIDinfo)
        Next

        'open Data Set Credit, if present
        xmlNList = xmlOpenID.SelectNodes("/idinfo/datacred")
        If (xmlNList.Count > 0) Then
            txtDScredit.Text = xmlNList(0).InnerText.Trim
        End If

        'open Security Information, if present
        xmlNList = xmlOpenID.SelectNodes("/idinfo/secinfo")
        If (xmlNList.Count > 0) Then
            sIDinfo = xmlNList(0).OuterXml
            openIDsecurity(sIDinfo)
        End If

        'open Native Data Set Environment, if present
        xmlNList = xmlOpenID.SelectNodes("/idinfo/native")
        If (xmlNList.Count > 0) Then
            txtDSenviron.Text = xmlNList(0).InnerText.Trim
        End If

        'open Cross Reference(s), if present
        xmlNList = xmlOpenID.SelectNodes("/idinfo/crossref")
        iCount = xmlNList.Count
        For iLoop = 0 To iCount - 1
            sIDinfo = xmlNList(iLoop).OuterXml
            openIDxref(sIDinfo)
        Next

        'open Analytical Tool(s), if present
        xmlNList = xmlOpenID.SelectNodes("/idinfo/tool")
        iCount = xmlNList.Count
        For iLoop = 0 To iCount - 1
            sIDinfo = xmlNList(iLoop).OuterXml
            openIDtool(sIDinfo)
        Next

    End Sub

    Private Sub openIDtime(ByVal sTimeInfo As String)
        Dim xmlTempDoc As New XmlDocument
        Dim xmlTimeDoc As New XmlDocument 'will handle Time Info sub-section
        Dim xmlNList As XmlNodeList
        Dim oCite As New CiteInfo 'for Citation
        Dim oSource As New SourceClass 'for Time Info
        Dim cIDTimeColl As New Collection 'for Time Info
        Dim s1 As String = ""
        Dim sIDinfo As String = ""
        Dim iSelInd As Integer = 0
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0

        xmlTempDoc.LoadXml(sTimeInfo) 'node exists, fill local DOM

        'retrieve Time Period Information
        xmlNList = xmlTempDoc.SelectNodes("/timeperd/timeinfo")
        If (xmlNList.Count > 0) Then
            sIDinfo = xmlTempDoc.SelectSingleNode("/timeperd/timeinfo").OuterXml
            xmlTimeDoc.LoadXml(sIDinfo)
            openTimeInfo(xmlTimeDoc, oSource, cIDTimeColl) 'process the time info nodes

            'load returned information into collection and form
            If (oSource.Gregorian = True) Then
                rdoTLocal.Checked = True
            Else
                rdoTGeol.Checked = True
            End If
            If (oSource.boolSingle = True And oSource.boolRange = True) Then
                rdoTUnknown.Checked = True
            ElseIf (oSource.boolSingle = True And oSource.boolRange = False) Then
                rdoTSingle.Checked = True
            ElseIf (oSource.boolSingle = False And oSource.boolRange = True) Then
                rdoTRange.Checked = True
            Else
                rdoTMult.Checked = True
            End If
            IDtimeper = cIDTimeColl 'copy date/time collection to public collection

            'fill the list box with date/time identifiers
            iCount = IDtimeper.Count

            Dim strNewDate As String = ""
            If (rdoTLocal.Checked = True) Then  'process Gregorian dates
                Dim dBegin As New SngDateTime
                Dim dEnding As New SngDateTime
                If (rdoTUnknown.Checked = True) Then
                    IDtimeper = New Collection
                End If
                If (rdoTRange.Checked = False) Then  'add the date/time(s) to list box
                    For iLoop = 1 To iCount
                        dBegin = CType(IDtimeper(iLoop), SngDateTime)
                        strNewDate = dBegin.SngDate & "  " & dBegin.TimeOfDay
                        lboxTime.Items.Add(strNewDate)
                    Next
                Else     'add date/time range to list box
                    dBegin = CType(IDtimeper(1), SngDateTime)
                    dEnding = CType(IDtimeper(2), SngDateTime)
                    strNewDate = "begin: " & dBegin.SngDate & "  " & "end: " & dEnding.SngDate
                    lboxTime.Items.Add(strNewDate)
                End If
            Else                              'process Geologic Age dates
                Dim dBegin As New GeolAge
                Dim dEnding As New GeolAge
                If (rdoTUnknown.Checked = True) Then
                    IDtimeper = New Collection
                End If
                If (rdoTRange.Checked = False) Then  'add Geologic Age(s) to list box
                    For iLoop = 1 To iCount
                        dBegin = CType(IDtimeper(iLoop), GeolAge)
                        strNewDate = dBegin.TimeScale & "  " & dBegin.Estim
                        lboxTime.Items.Add(strNewDate)
                    Next
                Else     'add and update Geologic Age range
                    dBegin = CType(IDtimeper(1), GeolAge)
                    dEnding = CType(IDtimeper(2), GeolAge)
                    strNewDate = "begin: " & dBegin.Estim & "  " & "end: " & dEnding.Estim
                    lboxTime.Items.Add(strNewDate)
                End If
            End If
        End If

        'retrieve Currentness Reference, set the combo box
        xmlNList = xmlTempDoc.SelectNodes("/timeperd/current")
        If (xmlNList.Count > 0) Then
            sIDinfo = xmlTempDoc.SelectSingleNode("/timeperd/current").InnerText
            If (sIDinfo <> "") Then
                iSelInd = cboxCurRef.FindStringExact(sIDinfo)
                If (iSelInd = -1) Then
                    'a free text element
                    cboxCurRef.Items.Add(sIDinfo)
                    cboxCurRef.SelectedIndex = cboxCurRef.Items.Count - 1
                Else
                    cboxCurRef.SelectedIndex = iSelInd
                End If
            End If
        End If


    End Sub

    Private Sub openIDspdom(ByVal sSpaDom As String)
        Dim xmlTempDoc As New XmlDocument
        Dim xmlNList As XmlNodeList
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sIDinfo As String = ""
        Dim iSelInd As Integer = 0
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim dValue As Decimal = 0

        xmlTempDoc.LoadXml(sSpaDom) 'node exists, fill local DOM

        'retrieve Geographic Extent
        xmlNList = xmlTempDoc.SelectNodes("/spdom/descgeog")
        If (xmlNList.Count > 0) Then txtGeoExt.Text = xmlNList(0).InnerText

        'retrieve Bounding Coordinates
        xmlNList = xmlTempDoc.SelectNodes("/spdom/bounding")
        iCount = xmlNList.Count
        If (iCount > 0) Then
            xmlNList = xmlTempDoc.SelectNodes("spdom/bounding/westbc") 'the West Bounding Coordinate
            If (xmlNList.Count > 0) Then
                s1 = xmlNList(0).InnerText
                Try
                    dValue = Convert.ToDecimal(s1)
                Catch ex As Exception
                    sError = "West Bounding Coordinate of " & s1 & " is not a number"
                    MessageBox.Show(sError, "Bounding Coordinate input error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    dValue = 0
                End Try
                adjLongitude(dValue, "W")
                numWestBC.Value = dValue
            End If
            xmlNList = xmlTempDoc.SelectNodes("spdom/bounding/eastbc") 'the East Bounding Coordinate
            If (xmlNList.Count > 0) Then
                s1 = xmlNList(0).InnerText
                Try
                    dValue = Convert.ToDecimal(s1)
                Catch ex As Exception
                    sError = "East Bounding Coordinate of " & s1 & " is not a number"
                    MessageBox.Show(sError, "Bounding Coordinate input error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    dValue = 0
                End Try
                adjLongitude(dValue, "E")
                numEastBC.Value = dValue
            End If
            xmlNList = xmlTempDoc.SelectNodes("spdom/bounding/northbc") 'the North Bounding Coordinate
            If (xmlNList.Count > 0) Then
                s1 = xmlNList(0).InnerText
                Try
                    dValue = Convert.ToDecimal(s1)
                Catch ex As Exception
                    sError = "North Bounding Coordinate of " & s1 & " is not a number"
                    MessageBox.Show(sError, "Bounding Coordinate input error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    dValue = 0
                End Try
                adjLatitude(dValue)
                numNorthBC.Value = dValue
            End If
            xmlNList = xmlTempDoc.SelectNodes("spdom/bounding/southbc") 'the South Bounding Coordinate
            If (xmlNList.Count > 0) Then
                s1 = xmlNList(0).InnerText
                Try
                    dValue = Convert.ToDecimal(s1)
                Catch ex As Exception
                    sError = "South Bounding Coordinate of " & s1 & " is not a number"
                    MessageBox.Show(sError, "Bounding Coordinate input error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    dValue = 0
                End Try
                adjLatitude(dValue)
                numSouthBC.Value = dValue
            End If
        End If

        'Bounding Altitudes, if present
        xmlNList = xmlTempDoc.SelectNodes("/spdom/bounding/boundalt")
        iCount = xmlNList.Count
        If (iCount > 0) Then
            xmlNList = xmlTempDoc.SelectNodes("/spdom/bounding/boundalt/altmin") 'Altitude Minimum
            If (xmlNList.Count > 0) Then
                s1 = xmlNList(0).InnerText
                Try
                    dValue = Convert.ToDecimal(s1)
                Catch ex As Exception
                    sError = "Altitude Minimum of " & s1 & " is not a number"
                    MessageBox.Show(sError, "Bounding Altitude input error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    dValue = 0
                End Try
                'check against bounds of numeric control
                If (dValue > 1000000) Then
                    dValue = 1000000
                ElseIf (dValue < -1000000) Then
                    dValue = -1000000
                End If
                numAltMin.Value = dValue
            End If

            xmlNList = xmlTempDoc.SelectNodes("/spdom/bounding/boundalt/altmax") 'Altitude Maximum
            If (xmlNList.Count > 0) Then
                s1 = xmlNList(0).InnerText
                Try
                    dValue = Convert.ToDecimal(s1)
                Catch ex As Exception
                    sError = "Altitude Maximum of " & s1 & " is not a number"
                    MessageBox.Show(sError, "Bounding Altitude input error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    dValue = 0
                End Try
                'check against bounds of numeric control
                If (dValue > 1000000) Then
                    dValue = 1000000
                ElseIf (dValue < -1000000) Then
                    dValue = -1000000
                End If
                numAltMax.Value = dValue
            End If

            xmlNList = xmlTempDoc.SelectNodes("/spdom/bounding/boundalt/altunits") 'Altitude Distance Units
            If (xmlNList.Count > 0) Then
                s1 = xmlNList(0).InnerText
                iSelInd = cboxIDaltDistU.FindStringExact(s1)
                If (iSelInd = -1 And s1 <> "") Then
                    'add the distance units entry
                    cboxIDaltDistU.Items.Add(s1)
                    cboxIDaltDistU.SelectedIndex = cboxIDaltDistU.Items.Count - 1
                ElseIf (iSelInd > -1) Then
                    cboxIDaltDistU.SelectedIndex = iSelInd
                End If
            End If
        End If


        'Data Set G-Polygons, if present
        Dim s2 As String = ""
        Dim xmlPlist As XmlNodeList
        Dim iGRing As Integer = 0
        Dim iExCount As Integer = 0
        Dim iLoopEx As Integer = 0
        xmlNList = xmlTempDoc.SelectNodes("/spdom/dsgpoly") 'node list of G-Polygons
        iCount = xmlNList.Count - 1 'working with 0-based string collections
        For iLoop = 0 To iCount
            xmlPlist = xmlNList(iLoop).SelectNodes("dsgpolyo")
            s2 = ""
            iGRing = 0
            If (xmlPlist.Count > 0) Then
                iGRing = 1
                sIDinfo = xmlNList(iLoop).SelectSingleNode("dsgpolyo").OuterXml
                procGRing(s2, sIDinfo, "outer")
                If (s2 = "") Then iGRing = 0
            End If

            If (iGRing > 0) Then
                'process Exclusion G-Rings
                xmlPlist = xmlNList(iLoop).SelectNodes("dsgpolyx") 'node list of Exclusion G-Rings
                iExCount = xmlPlist.Count
                For iLoopEx = 0 To iExCount - 1 'adjust for 0-based index in processing
                    sIDinfo = xmlPlist(iLoopEx).OuterXml
                    s2 = ""
                    procGRing(s2, sIDinfo, "exclude")
                    If (s2 = "") Then iExCount -= 1
                Next
                sCountGPoly.Add(iExCount.ToString) 'number of exclusion polygons associated with the G-Polygon
            End If
        Next

    End Sub

    Private Sub adjLongitude(ByRef dValue As Decimal, ByVal sDirect As String)
        'routine checks longitude bounds on dValue, adjusts as needed
        'normally, sDirect will be "W"
        Dim sError As String = ""
        If (dValue > 180.0) Then
            sError = "Longitude of " & dValue.ToString & " is being set to 179.99999"
            MessageBox.Show(sError, "Longitude out of bounds", MessageBoxButtons.OK, MessageBoxIcon.Error)
            dValue = 179.99999D
        End If
        If (dValue = 180.0 And sDirect = "W") Then 'west bounding coordinate fix
            sError = "Longitude of " & dValue.ToString & " is being set to 179.99999"
            MessageBox.Show(sError, "Longitude out of bounds", MessageBoxButtons.OK, MessageBoxIcon.Error)
            dValue = 179.99999D
        End If
        If (dValue < -180.0) Then
            sError = "Longitude of " & dValue.ToString & " is being set to -180.0"
            MessageBox.Show(sError, "Longitude out of bounds", MessageBoxButtons.OK, MessageBoxIcon.Error)
            dValue = -180D
        End If
    End Sub

    Private Sub adjLatitude(ByRef dValue As Decimal)
        'routine checks latitude bounds on dValue, adjusts as needed
        Dim sError As String = ""
        If (dValue > 90.0) Then
            sError = "Latitude of " & dValue.ToString & " is being set to 179.99999"
            MessageBox.Show(sError, "Latitude out of bounds", MessageBoxButtons.OK, MessageBoxIcon.Error)
            dValue = 180D
        End If
        If (dValue < -90.0) Then
            sError = "Latitude of " & dValue.ToString & " is being set to -180.0"
            MessageBox.Show(sError, "Latitude out of bounds", MessageBoxButtons.OK, MessageBoxIcon.Error)
            dValue = -180D
        End If
    End Sub

    Private Sub procGRing(ByRef s2 As String, ByVal sNode As String, ByVal sType As String)
        'process Data Set G-Polygon information
        'sType is either "outer" or "exclude"
        Dim xmlRingDoc As New XmlDocument
        Dim xmlPlist As XmlNodeList
        Dim xmlRlist As XmlNodeList
        Dim s1 As String = ""
        Dim sLat As String = ""
        Dim sLong As String = ""
        Dim dLat As Decimal = 0
        Dim dLong As Decimal = 0
        Dim sList As String = ""
        Dim iGPoint As Integer = 0
        Dim iGRing As Integer = 0
        Dim iLoop As Integer = 0

        s1 = ""
        s2 = ""
        xmlRingDoc.LoadXml(sNode)

        'look for and process G-Rings
        If (sType = "outer") Then
            xmlPlist = xmlRingDoc.SelectNodes("dsgpolyo/gring")
        Else
            xmlPlist = xmlRingDoc.SelectNodes("dsgpolyx/gring")
        End If
        iGRing = xmlPlist.Count
        If (iGRing > 0) Then
            'process the outer G-Ring string
            'if have G-Ring string, then do not process G-Ring points even if present
            s1 = "string"
            s2 = xmlPlist(0).InnerText
            s2 = s2.Trim
            If (s2 = "") Then
                'blank G-Ring strings are ignored
                iGRing = 0
            Else
                sDataSetGPoly.Add(s1)
                sDataSetGPoly.Add(s2)
                If (sType = "outer") Then
                    sList = s1 & ": " & Microsoft.VisualBasic.Left(s2, 32)
                    sList = sList.Replace(sPdelim, "  ")
                    lboxGPoly.Items.Add(sList) 'add data set polygon to list box (outer g-ring)
                End If
                Return 'nontrivial G-Ring found and processed
            End If
        End If


        'look for and process G-Ring Points
        If (sType = "outer") Then
            xmlPlist = xmlRingDoc.SelectNodes("dsgpolyo/grngpoin")
        Else
            xmlPlist = xmlRingDoc.SelectNodes("dsgpolyx/grngpoin")
        End If

        iGPoint = xmlPlist.Count
        s2 = ""

        If (iGPoint > 0) Then
            'process the G-Ring points
            s1 = "points"
            For iLoop = 0 To iGPoint - 1
                sLat = ""
                sLong = ""
                xmlRlist = xmlPlist(iLoop).SelectNodes("gringlat")
                If (xmlRlist.Count > 0) Then
                    sLat = xmlRlist(0).InnerText
                    Try
                        dLat = Convert.ToDecimal(sLat)
                        'make sure the value is a number
                    Catch ex As Exception
                        sLat = ""
                    End Try
                    If (sLat <> "") Then
                        'check bounds
                        adjLatitude(dLat)
                        sLat = dLat.ToString
                    End If
                End If

                xmlRlist = xmlPlist(iLoop).SelectNodes("gringlon")
                If (xmlRlist.Count > 0) Then
                    sLong = xmlRlist(0).InnerText
                    Try
                        dLong = Convert.ToDecimal(sLong)
                        'make sure the value is a number
                    Catch ex As Exception
                        sLong = ""
                    End Try
                    If (sLong <> "") Then
                        'check bounds
                        adjLongitude(dLong, "W")
                        sLong = dLong.ToString
                    End If
                End If
                If (sLat <> "" And sLong <> "") Then
                    s2 += sLat & " " & sLong & sPdelim
                End If
            Next
            If (s2 <> "") Then s2 = s2.Substring(0, s2.Length - 1)
        End If

        If (s2 = "") Then
            'blank G-Ring points are ignored
        Else
            sDataSetGPoly.Add(s1)
            sDataSetGPoly.Add(s2)
            If (sType = "outer") Then
                sList = s1 & ": " & Microsoft.VisualBasic.Left(s2, 32)
                sList = sList.Replace(sPdelim, "  ")
                lboxGPoly.Items.Add(sList) 'add data set polygon to list box (outer g-ring)
            End If
        End If
    End Sub

    Private Sub openIDkeywords(ByVal sKeywords As String)
        Dim xmlKeyDoc As New XmlDocument
        Dim xmlNList As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim sThesaurus As String = ""
        Dim sKey As String = ""
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sIDinfo As String = ""
        Dim iSelInd As Integer = 0
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim kCount As Integer = 0
        Dim kLoop As Integer = 0
        Dim sKeyArray() As String
        Dim sList As String

        xmlKeyDoc.LoadXml(sKeywords) 'node exists, fill local DOM

        'retrieve Themes
        xmlNList = xmlKeyDoc.SelectNodes("/keywords/theme")
        iCount = xmlNList.Count
        If (iCount > 0) Then
            'process Themes
            For iLoop = 0 To iCount - 1
                sThesaurus = ""
                xmlPlist = xmlNList(iLoop).SelectNodes("themekt")
                If (xmlPlist.Count > 0) Then
                    sThesaurus = xmlPlist(0).InnerText
                End If
                xmlPlist = xmlNList(iLoop).SelectNodes("themekey")
                If (xmlPlist.Count > 0) Then
                    'process keywords
                    kCount = xmlPlist.Count
                    sKey = ""
                    For kLoop = 0 To kCount - 1
                        s1 = xmlPlist(kLoop).InnerText
                        s1 = s1.Trim
                        If (s1 <> "") Then
                            sKey += s1 & sKdelim
                        End If
                    Next
                End If
                If (sKey <> "" And sThesaurus = "") Then sThesaurus = "None"
                If (sKey = "" Or sThesaurus = "") Then
                    'do nothing, incomplete information considered error condition
                Else
                    sList = "thesaurus: " & sThesaurus & "   keywords: " & sKey
                    sList = sList.Replace(sKdelim, "; ")
                    lboxKTheme.Items.Add(sList) 'add formatted info to listbox
                    sThesaurus += sPdelim & sKey
                    sKeyTheme.Add(sThesaurus) 'add theme keyword info to collection
                End If
            Next
        End If

        'retrieve Places
        xmlNList = xmlKeyDoc.SelectNodes("/keywords/place")
        iCount = xmlNList.Count
        If (iCount > 0) Then
            'process Places
            For iLoop = 0 To iCount - 1
                sThesaurus = ""
                xmlPlist = xmlNList(iLoop).SelectNodes("placekt")
                If (xmlPlist.Count > 0) Then
                    sThesaurus = xmlPlist(0).InnerText
                End If
                xmlPlist = xmlNList(iLoop).SelectNodes("placekey")
                If (xmlPlist.Count > 0) Then
                    'process keywords
                    kCount = xmlPlist.Count
                    sKey = ""
                    For kLoop = 0 To kCount - 1
                        s1 = xmlPlist(kLoop).InnerText
                        s1 = s1.Trim
                        If (s1 <> "") Then
                            sKey += s1 & sKdelim
                        End If
                    Next
                End If
                If (sKey <> "" And sThesaurus = "") Then sThesaurus = "None"
                If (sKey = "" Or sThesaurus = "") Then
                    'do nothing, incomplete information considered error condition
                Else
                    sList = "thesaurus: " & sThesaurus & "   keywords: " & sKey
                    sList = sList.Replace(sKdelim, "; ")
                    lboxKPlace.Items.Add(sList) 'add formatted info to listbox
                    sThesaurus += sPdelim & sKey
                    sKeyPlace.Add(sThesaurus) 'add place keyword info to collection
                End If
            Next
        End If

        'retrieve Strata
        xmlNList = xmlKeyDoc.SelectNodes("/keywords/stratum")
        iCount = xmlNList.Count
        If (iCount > 0) Then
            'process Strata
            For iLoop = 0 To iCount - 1
                sThesaurus = ""
                xmlPlist = xmlNList(iLoop).SelectNodes("stratkt")
                If (xmlPlist.Count > 0) Then
                    sThesaurus = xmlPlist(0).InnerText
                End If
                xmlPlist = xmlNList(iLoop).SelectNodes("stratkey")
                If (xmlPlist.Count > 0) Then
                    'process keywords
                    kCount = xmlPlist.Count
                    sKey = ""
                    For kLoop = 0 To kCount - 1
                        s1 = xmlPlist(kLoop).InnerText
                        s1 = s1.Trim
                        If (s1 <> "") Then
                            sKey += s1 & sKdelim
                        End If
                    Next
                End If
                If (sKey <> "" And sThesaurus = "") Then sThesaurus = "None"
                If (sKey = "" Or sThesaurus = "") Then
                    'do nothing, incomplete information considered error condition
                Else
                    sList = "thesaurus: " & sThesaurus & "   keywords: " & sKey
                    sList = sList.Replace(sKdelim, "; ")
                    lboxKStratum.Items.Add(sList) 'add formatted info to listbox
                    sThesaurus += sPdelim & sKey
                    sKeyStratum.Add(sThesaurus) 'add stratum keyword info to collection
                End If
            Next
        End If

        'retrieve Temporal
        xmlNList = xmlKeyDoc.SelectNodes("/keywords/temporal")
        iCount = xmlNList.Count
        If (iCount > 0) Then
            'process Themes
            For iLoop = 0 To iCount - 1
                sThesaurus = ""
                xmlPlist = xmlNList(iLoop).SelectNodes("tempkt")
                If (xmlPlist.Count > 0) Then
                    sThesaurus = xmlPlist(0).InnerText
                End If
                xmlPlist = xmlNList(iLoop).SelectNodes("tempkey")
                If (xmlPlist.Count > 0) Then
                    'process keywords
                    kCount = xmlPlist.Count
                    sKey = ""
                    For kLoop = 0 To kCount - 1
                        s1 = xmlPlist(kLoop).InnerText
                        s1 = s1.Trim
                        If (s1 <> "") Then
                            sKey += s1 & sKdelim
                        End If
                    Next
                End If
                If (sKey <> "" And sThesaurus = "") Then sThesaurus = "None"
                If (sKey = "" Or sThesaurus = "") Then
                    'do nothing, incomplete information considered error condition
                Else
                    sList = "thesaurus: " & sThesaurus & "   keywords: " & sKey
                    sList = sList.Replace(sKdelim, "; ")
                    lboxKTemporal.Items.Add(sList) 'add formatted info to listbox
                    sThesaurus += sPdelim & sKey
                    sKeyTemporal.Add(sThesaurus) 'add temporal keyword info to collection
                End If
            Next
        End If
    End Sub

    Private Sub openIDtaxonomy(ByVal sTaxa As String)
        Dim xmlTaxaDoc As New XmlDocument
        Dim xmlNList As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim sThesaurus As String = ""
        Dim sKey As String = ""
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sIDinfo As String = ""
        Dim iSelInd As Integer = 0
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim kCount As Integer = 0
        Dim kLoop As Integer = 0
        Dim sKeyArray() As String
        Dim sList As String

        xmlTaxaDoc.LoadXml(sTaxa) 'node exists, fill local DOM

        'retrieve Keywords/Taxon
        xmlNList = xmlTaxaDoc.SelectNodes("/taxonomy/keywtax")
        iCount = xmlNList.Count
        If (iCount > 0) Then
            'process Keywords/Taxon
            For iLoop = 0 To iCount - 1
                sThesaurus = ""
                xmlPlist = xmlNList(iLoop).SelectNodes("taxonkt")
                If (xmlPlist.Count > 0) Then
                    sThesaurus = xmlPlist(0).InnerText
                End If
                xmlPlist = xmlNList(iLoop).SelectNodes("taxonkey")
                If (xmlPlist.Count > 0) Then
                    'process keywords
                    kCount = xmlPlist.Count
                    sKey = ""
                    For kLoop = 0 To kCount - 1
                        s1 = xmlPlist(kLoop).InnerText
                        s1 = s1.Trim
                        If (s1 <> "") Then
                            sKey += s1 & sKdelim
                        End If
                    Next
                End If
                If (sKey <> "" And sThesaurus = "") Then sThesaurus = "None"
                If (sKey = "" Or sThesaurus = "") Then
                    'do nothing, incomplete information considered error condition
                Else
                    sList = sThesaurus & ":  " & sKey
                    sList = sList.Replace(sKdelim, "; ")
                    lboxTaxKey.Items.Add(sList) 'add formatted info to listbox
                    sThesaurus += sPdelim & sKey
                    sTaxKeywords.Add(sThesaurus) 'add taxon keyword info to collection
                End If
            Next
        End If

        'open Taxonomic System
        xmlNList = xmlTaxaDoc.SelectNodes("/taxonomy/taxonsys")
        If (xmlNList.Count > 0) Then
            sIDinfo = xmlNList(0).OuterXml
            openIDtaxsys(sIDinfo)
        End If

        'retrieve Taxonomic Coverage, if present
        xmlNList = xmlTaxaDoc.SelectNodes("/taxonomy/taxongen")
        If (xmlNList.Count > 0) Then
            s1 = xmlNList(0).InnerText
            s1 = s1.Trim
            txtTaxCover.Text = s1
        End If

        'retrieve Taxonomic Classification
        ' 1. build the TaxaClasses collection
        xmlNList = xmlTaxaDoc.SelectNodes("/taxonomy/taxoncl")
        If (xmlNList.Count > 0) Then
            sIDinfo = xmlNList(0).OuterXml
            xmlTaxonClass.LoadXml(sIDinfo)
            openIDtaxclass(sIDinfo)
        End If

        ' 2. create the display
        lboxLinneausBuild()
    End Sub

    Private Sub openIDtaxsys(ByVal sTaxSys As String)
        Dim xmlTaxSysDoc As New XmlDocument
        Dim xmlNList As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim sClassMod As String = ""
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sIDinfo As String = ""
        Dim iSelInd As Integer = 0
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim kCount As Integer = 0
        Dim kLoop As Integer = 0
        Dim sList As String
        Dim xmlCiteDoc As New XmlDocument
        Dim bCheck As Boolean = False
        Dim oCite As New CiteInfo
        Dim bLWC As Boolean = False
        Dim oCiteLWC As New CiteInfo
        Dim oContact As New ContactInfo

        xmlTaxSysDoc.LoadXml(sTaxSys) 'node exists, fill local DOM

        'retrieve Classification System or Authority
        xmlNList = xmlTaxSysDoc.SelectNodes("/taxonsys/classsys")
        iCount = xmlNList.Count
        For iLoop = 0 To iCount - 1
            oCite = New CiteInfo
            bLWC = False
            oCiteLWC = New CiteInfo

            'retrieve Citation
            xmlPlist = xmlNList(iLoop).SelectNodes("classcit/citeinfo")
            kCount = xmlPlist.Count
            If (kCount > 0) Then
                'process Citation
                sIDinfo = xmlPlist(0).OuterXml
                xmlCiteDoc.LoadXml(sIDinfo)
                openCite(xmlCiteDoc, oCite, bCheck) 'main citation
                If (bCheck = False) Then
                    'no required citation elements found
                Else
                    sList = "cite: " & oCite.Author & "  " & oCite.Title
                    lboxTaxSys.Items.Add(sList) 'put citation ID into list box
                    'look for Larger Work Citation
                    xmlPlist = xmlCiteDoc.SelectNodes("/citeinfo/lworkcit/citeinfo")
                    bCheck = False
                    If (xmlPlist.Count > 0) Then
                        sIDinfo = xmlPlist(0).OuterXml
                        xmlCiteDoc.LoadXml(sIDinfo)
                        openCite(xmlCiteDoc, oCiteLWC, bCheck) 'larger work citation
                    End If
                    If (bCheck = True) Then bLWC = True 'a Larger Work Citation was processed

                    'process Classification System Modifications, if present
                    sClassMod = ""
                    xmlPlist = xmlNList(iLoop).SelectNodes("classmod")
                    If (xmlPlist.Count > 0) Then
                        sClassMod = xmlPlist(0).InnerText
                    End If
                    sList = "  modifications: " & Microsoft.VisualBasic.Left(sClassMod, 50)
                    lboxTaxSys.Items.Add(sList) 'put mods into list box

                    'update the main collections
                    citeTaxSys.Add(oCite)
                    boolTaxSys.Add(bLWC)
                    citeTaxSysLWC.Add(oCiteLWC)
                    sTaxSysMods.Add(sClassMod) 'might be blank string
                End If
            End If
        Next


        'retrieve Identification Reference(s)
        xmlNList = xmlTaxSysDoc.SelectNodes("/taxonsys/idref")
        iCount = xmlNList.Count
        For iLoop = 0 To iCount - 1
            oCite = New CiteInfo
            bLWC = False
            oCiteLWC = New CiteInfo

            'retrieve IDref Citation
            xmlPlist = xmlNList(iLoop).SelectNodes("citeinfo")
            kCount = xmlPlist.Count
            If (kCount > 0) Then
                'process Citation
                sIDinfo = xmlPlist(0).OuterXml
                xmlCiteDoc.LoadXml(sIDinfo)
                openCite(xmlCiteDoc, oCite, bCheck) 'main citation
                If (bCheck = False) Then
                    'no required citation elements found
                Else
                    sList = "cite: " & oCite.Author & "  " & oCite.Title
                    lboxTaxIDRef.Items.Add(sList) 'put citation ID into list box
                    'look for Larger Work Citation
                    xmlPlist = xmlCiteDoc.SelectNodes("/citeinfo/lworkcit/citeinfo")
                    bCheck = False
                    If (xmlPlist.Count > 0) Then
                        sIDinfo = xmlPlist(0).OuterXml
                        xmlCiteDoc.LoadXml(sIDinfo)
                        openCite(xmlCiteDoc, oCiteLWC, bCheck) 'main citation
                    End If
                    If (bCheck = True) Then bLWC = True 'a Larger Work Citation was processed

                    'update the main collections
                    citeTaxIDRef.Add(oCite)
                    boolTaxIDRef.Add(bLWC)
                    citeTaxIDRefLWC.Add(oCiteLWC)
                End If
            End If
        Next


        'retrieve Identifier(s)
        xmlNList = xmlTaxSysDoc.SelectNodes("/taxonsys/ider")
        iCount = xmlNList.Count - 1
        For iLoop = 0 To iCount
            xmlPlist = xmlNList(iLoop).SelectNodes("cntinfo")
            If (xmlPlist.Count > 0) Then
                'get the Contact Information XML
                sIDinfo = xmlPlist(0).OuterXml
                openContact(sIDinfo, oContact)
                'put into main collection and display
                cntTaxID.Add(oContact)
                If (oContact.PrimaryPerson = True) Then
                    lboxTaxID.Items.Add(oContact.Person)
                Else
                    lboxTaxID.Items.Add(oContact.Organization)
                End If
            End If
        Next


        'retrieve Taxonomic Procedures
        xmlNList = xmlTaxSysDoc.SelectNodes("/taxonsys/taxonpro")
        If (xmlNList.Count > 0) Then
            sClassMod = xmlNList(0).InnerText
            sClassMod = sClassMod.Trim
            txtTaxProc.Text = sClassMod
        End If


        'retrieve Taxonomic Completeness
        xmlNList = xmlTaxSysDoc.SelectNodes("/taxonsys/taxoncom")
        If (xmlNList.Count > 0) Then
            sClassMod = xmlNList(0).InnerText
            sClassMod = sClassMod.Trim
            txtTaxComplete.Text = sClassMod
        End If


        'retrieve Vouchers
        xmlNList = xmlTaxSysDoc.SelectNodes("/taxonsys/vouchers")
        iCount = xmlNList.Count - 1
        For iLoop = 0 To iCount
            xmlPlist = xmlNList(iLoop).SelectNodes("specimen") 'retrieve specimen
            If (xmlPlist.Count > 0) Then
                s1 = xmlPlist(0).InnerText.Trim
                sVSpecimen.Add(s1)
                sList = "specimen: " & Microsoft.VisualBasic.Left(s1, 50)
                lboxVouchers.Items.Add(sList)
            End If
            xmlPlist = xmlNList(iLoop).SelectNodes("reposit/cntinfo") 'retrieve repository
            If (xmlPlist.Count > 0) Then
                'get the Contact Information XML
                sIDinfo = xmlPlist(0).OuterXml
                openContact(sIDinfo, oContact)
                'put into main collection and display
                cntVouchers.Add(oContact)
                If (oContact.PrimaryPerson = True) Then
                    sList = "  repository: " & oContact.Person
                Else
                    sList = "  repository: " & oContact.Organization
                End If
                lboxVouchers.Items.Add(sList)
            End If
        Next
    End Sub

    Private Sub openIDtaxclass(ByVal sTaxClass As String)
        Dim xmlTaxClassDoc As New XmlDocument
        Dim xmlNList As XmlNodeList
        Dim s1 As String = ""
        Dim sIDinfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim iLevel As Integer = 0
        Dim oNewTaxa As New TaxonClass

        xmlTaxClassDoc.LoadXml(sTaxClass) 'node exists, fill local DOM
        oNewTaxa = New TaxonClass

        xmlNList = xmlTaxClassDoc.SelectNodes("/taxoncl/taxonrn")
        If (xmlNList.Count > 0) Then 'get rank name
            oNewTaxa.RankName = xmlNList(0).InnerText.Trim
        End If
        xmlNList = xmlTaxClassDoc.SelectNodes("/taxoncl/taxonrv")
        If (xmlNList.Count > 0) Then 'get rank value
            oNewTaxa.RankValue = xmlNList(0).InnerText.Trim
        End If
        xmlNList = xmlTaxClassDoc.SelectNodes("/taxoncl/common")
        iCount = xmlNList.Count - 1
        s1 = ""
        For iLoop = 0 To iCount
            'process common names
            s1 = xmlNList(iLoop).InnerText.Trim & sKdelim
        Next
        oNewTaxa.CommonName = s1

        'set base level to zero
        iLevel = 0
        oNewTaxa.Level = iLevel

        'process additional taxonomic classification nodes
        xmlNList = xmlTaxClassDoc.SelectNodes("/taxoncl/taxoncl")
        iCount = xmlNList.Count
        oNewTaxa.Nchildren = iCount
        TaxaClasses.Add(oNewTaxa) 'add node to main collection
        iLevel += 1
        For iLoop = 0 To iCount - 1
            sIDinfo = xmlNList(iLoop).OuterXml
            openIDtaxon(sIDinfo, iLevel)
        Next

    End Sub

    Private Sub openIDtaxon(ByVal sTaxon As String, ByVal iLevel As Integer)
        'sTaxon contains an XML string, iLevel is the current level
        Dim xmlTaxClassDoc As New XmlDocument
        Dim xmlNList As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim s1 As String = ""
        Dim sIDinfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim oNewTaxa As New TaxonClass

        xmlTaxClassDoc.LoadXml(sTaxon) 'node exists, fill local DOM
        oNewTaxa = New TaxonClass

        xmlNList = xmlTaxClassDoc.SelectNodes("/taxoncl/taxonrn")
        If (xmlNList.Count > 0) Then 'get rank name
            oNewTaxa.RankName = xmlNList(0).InnerText.Trim
        End If
        xmlNList = xmlTaxClassDoc.SelectNodes("/taxoncl/taxonrv")
        If (xmlNList.Count > 0) Then 'get rank value
            oNewTaxa.RankValue = xmlNList(0).InnerText.Trim
        End If
        xmlNList = xmlTaxClassDoc.SelectNodes("/taxoncl/common")
        iCount = xmlNList.Count - 1
        s1 = ""
        For iLoop = 0 To iCount
            'process common names
            s1 = s1 & xmlNList(iLoop).InnerText.Trim & sKdelim
        Next
        oNewTaxa.CommonName = s1

        'set current node's level
        oNewTaxa.Level = iLevel

        'process additional taxonomic classification nodes
        xmlNList = xmlTaxClassDoc.SelectNodes("/taxoncl/taxoncl")
        iCount = xmlNList.Count
        oNewTaxa.Nchildren = iCount
        TaxaClasses.Add(oNewTaxa) 'add node to main collection
        iLevel += 1
        For iLoop = 0 To iCount - 1
            sIDinfo = xmlNList(iLoop).OuterXml
            openIDtaxon(sIDinfo, iLevel)
        Next
    End Sub

    Private Sub openIDgraphic(ByVal sGraphic As String)
        Dim xmlGraphicDoc As New XmlDocument
        Dim xmlNList As XmlNodeList
        Dim sName As String = ""
        Dim sDesc As String = ""
        Dim sType As String = ""
        Dim bEmpty As Boolean = True 'the graphic lacks all 3 required elements
        Dim sList As String

        xmlGraphicDoc.LoadXml(sGraphic) 'node exists, fill local DOM
        sName = ""
        sDesc = ""
        sType = ""
        bEmpty = True

        'retrieve File Name
        xmlNList = xmlGraphicDoc.SelectNodes("/browse/browsen")
        If (xmlNList.Count > 0) Then
            sName = xmlNList(0).InnerText.Trim
            If (sName <> "") Then bEmpty = False
        End If

        'retrieve File Description
        xmlNList = xmlGraphicDoc.SelectNodes("/browse/browsed")
        If (xmlNList.Count > 0) Then
            sDesc = xmlNList(0).InnerText.Trim
            If (sDesc <> "") Then bEmpty = False
        End If

        'retrieve File Type
        xmlNList = xmlGraphicDoc.SelectNodes("/browse/browset")
        If (xmlNList.Count > 0) Then
            sType = xmlNList(0).InnerText.Trim
            If (sType <> "") Then bEmpty = False
        End If

        If (bEmpty = False) Then
            'update list box display
            sList = sName & "    " & sDesc
            lboxBrGraphic.Items.Add(sList)
            'update main string collection
            sList = sName & sPdelim & sDesc & sPdelim & sType
            sBrowseGraphics.Add(sList)
        End If
        Return
    End Sub

    Private Sub openIDsecurity(ByVal sSecurity As String)
        Dim xmlSecurityDoc As New XmlDocument
        Dim xmlNList As XmlNodeList
        Dim sSystem As String = ""
        Dim sClass As String = ""
        Dim sDesc As String = ""
        Dim iSelInd As Integer = 0
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0

        xmlSecurityDoc.LoadXml(sSecurity) 'node exists, fill local DOM
        sSystem = ""
        sClass = ""
        sDesc = ""

        'retrieve Security Classification System
        xmlNList = xmlSecurityDoc.SelectNodes("/secinfo/secsys")
        If (xmlNList.Count > 0) Then
            sSystem = xmlNList(0).InnerText.Trim
            txtDataSecSys.Text = sSystem
        End If

        'retrieve Security Classification
        xmlNList = xmlSecurityDoc.SelectNodes("/secinfo/secclass")
        If (xmlNList.Count > 0) Then
            sClass = xmlNList(0).InnerText.Trim
            If (sClass = "") Then
                cboxDataSecClass.SelectedIndex = -1
            Else
                'set the selection
                iSelInd = cboxDataSecClass.FindStringExact(sClass)
                If (iSelInd = -1) Then
                    'add classification to combo box
                    cboxDataSecClass.Items.Add(sClass)
                    cboxDataSecClass.SelectedIndex = cboxDataSecClass.Items.Count - 1
                Else
                    cboxDataSecClass.SelectedIndex = iSelInd
                End If
            End If
        End If

        'retrieve Security Handling Description
        xmlNList = xmlSecurityDoc.SelectNodes("/secinfo/sechandl")
        If (xmlNList.Count > 0) Then
            sDesc = xmlNList(0).InnerText.Trim
            txtDataSecDesc.Text = sDesc
        End If
        Return
    End Sub

    Private Sub openIDxref(ByVal sXRef As String)
        Dim xmlXRefDoc As New XmlDocument
        Dim xmlNList As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim sIDinfo As String = ""
        Dim sList As String
        Dim xmlCiteDoc As New XmlDocument
        Dim bCheck As Boolean = False
        Dim oCite As New CiteInfo
        Dim bLWC As Boolean = False
        Dim oCiteLWC As New CiteInfo

        xmlXRefDoc.LoadXml(sXRef) 'node exists, fill local DOM
        oCite = New CiteInfo
        bLWC = False
        oCiteLWC = New CiteInfo

        'retrieve Citation Information
        xmlNList = xmlXRefDoc.SelectNodes("/crossref/citeinfo")
        If (xmlNList.Count > 0) Then
            'process Citation
            sIDinfo = xmlNList(0).OuterXml
            xmlCiteDoc.LoadXml(sIDinfo)
            openCite(xmlCiteDoc, oCite, bCheck) 'main citation
            If (bCheck = False) Then
                'no required citation elements found
            Else
                sList = Microsoft.VisualBasic.Left(oCite.Author, 25) & "   " & Microsoft.VisualBasic.Left(oCite.Title, 25)
                lboxXRef.Items.Add(sList) 'put citation ID into list box
                'look for Larger Work Citation
                xmlPlist = xmlCiteDoc.SelectNodes("/citeinfo/lworkcit/citeinfo")
                bCheck = False
                If (xmlPlist.Count > 0) Then
                    sIDinfo = xmlPlist(0).OuterXml
                    xmlCiteDoc.LoadXml(sIDinfo)
                    openCite(xmlCiteDoc, oCiteLWC, bCheck) 'larger work citation
                End If
                If (bCheck = True) Then bLWC = True 'a Larger Work Citation was processed

                'update the main collections
                XRefBase.Add(oCite) 'add new citation to the collection
                bXRefLWC.Add(bLWC) 'add new larger work Boolean to its collection
                XRefLarge.Add(oCiteLWC) 'add new larger work citation to its collection
            End If
        End If
    End Sub

    Private Sub openIDtool(ByVal sTool As String)
        Dim xmlToolDoc As New XmlDocument
        Dim xmlNList As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim sIDinfo As String = ""
        Dim sList As String
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim oCurTool As New ToolClass
        Dim xmlCiteDoc As New XmlDocument
        Dim bCheck As Boolean = False
        Dim oCite As New CiteInfo
        Dim bLWC As Boolean = False
        Dim oCiteLWC As New CiteInfo
        Dim oNewContact As New ContactInfo

        xmlToolDoc.LoadXml(sTool) 'node exists, fill local DOM
        oCurTool = New ToolClass

        'retrieve Tool Description
        xmlNList = xmlToolDoc.SelectNodes("/tool/tooldesc")
        If (xmlNList.Count > 0) Then
            oCurTool.ToolDesc = xmlNList(0).InnerText.Trim
            lboxTool.Items.Add(oCurTool.ToolDesc) 'add to list box display
        End If

        'retrieve Tool Access Information
        '  1. retrieve Online Linkage(s)
        xmlNList = xmlToolDoc.SelectNodes("/tool/toolacc/onlink")
        iCount = xmlNList.Count - 1
        sList = ""
        For iLoop = 0 To iCount
            sList += xmlNList(iLoop).InnerText.Trim & sKdelim
        Next
        oCurTool.ToolLink = sList

        '  2. retrieve Access Instructions
        xmlNList = xmlToolDoc.SelectNodes("/tool/toolacc/toolinst")
        If (xmlNList.Count > 0) Then
            oCurTool.ToolAccess = xmlNList(0).InnerText.Trim
        End If

        '  3. retrieve Computer and Operating System
        xmlNList = xmlToolDoc.SelectNodes("/tool/toolacc/toolcomp")
        If (xmlNList.Count > 0) Then
            oCurTool.ToolOS = xmlNList(0).InnerText.Trim
        End If

        'retrieve Tool Contact
        oNewContact = New ContactInfo
        xmlNList = xmlToolDoc.SelectNodes("/tool/toolcont/cntinfo")
        If (xmlNList.Count > 0) Then
            'get the Contact Information XML
            sIDinfo = xmlNList(0).OuterXml
            openContact(sIDinfo, oNewContact)
            oCurTool.boolContact = True
            oCurTool.ToolContact = oNewContact
        End If

        'retrieve Tool Citation Information
        xmlNList = xmlToolDoc.SelectNodes("/tool/toolcite/citeinfo")
        If (xmlNList.Count > 0) Then
            'process Citation
            oCite = New CiteInfo
            bLWC = False
            oCiteLWC = New CiteInfo
            sIDinfo = xmlNList(0).OuterXml
            xmlCiteDoc.LoadXml(sIDinfo)
            openCite(xmlCiteDoc, oCite, bCheck) 'main citation
            If (bCheck = False) Then
                'no required citation elements found
            Else
                'look for Larger Work Citation
                xmlPlist = xmlCiteDoc.SelectNodes("/citeinfo/lworkcit/citeinfo")
                bCheck = False
                If (xmlPlist.Count > 0) Then
                    sIDinfo = xmlPlist(0).OuterXml
                    xmlCiteDoc.LoadXml(sIDinfo)
                    openCite(xmlCiteDoc, oCiteLWC, bCheck) 'larger work citation
                End If
                If (bCheck = True) Then bLWC = True 'a Larger Work Citation was processed

                'update the tool object
                oCurTool.boolCitation = True
                oCurTool.ToolCite = oCite 'add citation to the tool object
                oCurTool.boolCiteLWC = bLWC 'add larger work Boolean to the object
                oCurTool.ToolCiteLWC = oCiteLWC 'add larger work citation to the object
            End If
        End If

        'add tool object to main collection and return
        idTools.Add(oCurTool)
        Return
    End Sub

#End Region


#Region " DOM processing for Data Quality Information section "

    Private Sub openDQ(ByVal xmlOpenDQ As XmlDocument)
        Dim xmlNList As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim xmlRlist As XmlNodeList
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim sError As String = ""
        Dim sDQinfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim sList As String
        Dim bCloud As Boolean = False

        'retrieve Attribute Accuracy
        xmlNList = xmlOpenDQ.SelectNodes("/dataqual/attracc")
        If (xmlNList.Count > 0) Then
            '  1. retrieve Attribute Accuracy Report
            xmlPlist = xmlNList(0).SelectNodes("attraccr")
            If (xmlPlist.Count > 0) Then
                txtAttribAcc.Text = xmlPlist(0).InnerText.Trim
            End If
            '  2. retrieve Attribute Accuracy Assessment(s)
            xmlPlist = xmlNList(0).SelectNodes("qattracc")
            iCount = xmlPlist.Count
            For iLoop = 0 To iCount - 1
                s1 = ""
                s2 = ""
                ' 2a. retrieve Attribute Accuracy Value
                xmlRlist = xmlPlist(iLoop).SelectNodes("attraccv")
                If (xmlRlist.Count > 0) Then
                    s1 = xmlRlist(0).InnerText.Trim
                End If
                ' 2b. retrieve Attribute Accuracy Explanation
                xmlRlist = xmlPlist(iLoop).SelectNodes("attracce")
                If (xmlRlist.Count > 0) Then
                    s2 = xmlRlist(0).InnerText.Trim
                End If
                If (s1 <> "" Or s2 <> "") Then
                    sList = s1 & ":  " & s2
                    lboxAttribAcc.Items.Add(sList) 'update list box display
                    sList = s1 & sPdelim & s2
                    sAttribAcc.Add(sList) 'update the main collection
                End If
            Next
        End If

        'retrieve Logical Consistency Report
        xmlNList = xmlOpenDQ.SelectNodes("/dataqual/logic")
        If (xmlNList.Count > 0) Then
            txtLogic.Text = xmlNList(0).InnerText.Trim
        End If

        'retrieve Completeness Report
        xmlNList = xmlOpenDQ.SelectNodes("/dataqual/complete")
        If (xmlNList.Count > 0) Then
            txtComplete.Text = xmlNList(0).InnerText.Trim
        End If

        'retrieve Positional Accuracy
        xmlNList = xmlOpenDQ.SelectNodes("/dataqual/posacc")
        If (xmlNList.Count > 0) Then
            sDQinfo = xmlNList(0).OuterXml
            openDQpos(sDQinfo)
        End If

        'retrieve Lineage
        xmlNList = xmlOpenDQ.SelectNodes("/dataqual/lineage")
        If (xmlNList.Count > 0) Then
            sDQinfo = xmlNList(0).OuterXml
            openDQlineage(sDQinfo)
        End If

        'retrieve Cloud Cover
        rdoNoCloud.Checked = True
        xmlNList = xmlOpenDQ.SelectNodes("/dataqual/cloud")
        If (xmlNList.Count > 0) Then
            s1 = xmlNList(0).InnerText.Trim
            If (s1 = "Unknown") Then
                rdoCloudUnk.Checked = True
            Else
                Try
                    bCloud = True
                    iCount = Convert.ToInt32(s1)
                Catch ex As Exception
                    bCloud = False
                    sError = "Cloud cover not an integer." & CrLf & "Set to 'Not reported'"
                    MessageBox.Show(sError, "Cloud cover error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End Try
                If (bCloud = True) Then
                    If (iCount > -1 And iCount < 101) Then
                        rdoCloud.Checked = True
                        numCloud.Value = Convert.ToDecimal(iCount)
                    Else
                        sError = "Cloud cover, " & iCount.ToString & ", outside of range." & CrLf & "Set to 'Not reported'"
                        MessageBox.Show(sError, "Cloud cover error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    End If
                End If
            End If
        End If

    End Sub

    Private Sub openDQpos(ByVal sPosAcc As String)
        Dim xmlDataQDoc As New XmlDocument
        Dim xmlNList As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim xmlRlist As XmlNodeList
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim sError As String = ""
        Dim sDQinfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim sList As String
        Dim bReal As Boolean = False
        Dim rAccVal As Double = 0.0

        xmlDataQDoc.LoadXml(sPosAcc)

        'retrieve Horizontal Positional Accuracy
        xmlNList = xmlDataQDoc.SelectNodes("/posacc/horizpa")
        If (xmlNList.Count > 0) Then
            '  1. retrieve horizontal positional accuracy report
            xmlPlist = xmlNList(0).SelectNodes("horizpar")
            If (xmlPlist.Count > 0) Then
                txtHorAccRpt.Text = xmlPlist(0).InnerText.Trim
            End If
            '  2. retrieve quantitative horizontal positional accuracy assessment
            xmlPlist = xmlNList(0).SelectNodes("qhorizpa")
            iCount = xmlPlist.Count
            For iLoop = 0 To iCount - 1
                s1 = ""
                s2 = ""
                ' 2a. retrieve the accuracy explanation (simple string)
                xmlRlist = xmlPlist(iLoop).SelectNodes("horizpae")
                If (xmlRlist.Count > 0) Then
                    s2 = xmlRlist(0).InnerText.Trim
                End If
                ' 2b. retrieve the accuracy value and test for conformance (real value >= 0)
                xmlRlist = xmlPlist(iLoop).SelectNodes("horizpav")
                If (xmlRlist.Count > 0) Then
                    s1 = xmlRlist(0).InnerText.Trim
                    Try
                        bReal = True
                        rAccVal = Convert.ToDouble(s1)
                    Catch ex As Exception
                        bReal = False
                        sError = "Horizontal Accuracy Value, " & s1 & ", is not a real number"
                        sError += CrLf & "Reset to 0.00"
                        MessageBox.Show(sError, "Accuracy Value error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    End Try
                    If (bReal = True) Then
                        If (rAccVal >= 0.0) Then
                            'do nothing
                        Else
                            s1 = "0.00"
                            sError = "Horizontal Positional Accuracy Value < 0.00" & CrLf & "Set to 0.00"
                            MessageBox.Show(sError, "Quantitative Accuracy Assessment error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                        End If
                    Else
                        s1 = "0.00"
                    End If
                End If
                sList = s1 & " m:  " & s2
                lboxHPosAcc.Items.Add(sList) 'update the list box display
                sList = s1 & sPdelim & s2
                sHPosAcc.Add(sList) 'update main collection
            Next
        End If

        'retrieve Vertical Positional Accuracy
        xmlNList = xmlDataQDoc.SelectNodes("/posacc/vertacc")
        If (xmlNList.Count > 0) Then
            '  1. retrieve vertical positional accuracy report
            xmlPlist = xmlNList(0).SelectNodes("vertaccrr")
            If (xmlPlist.Count > 0) Then
                txtVertAccRpt.Text = xmlPlist(0).InnerText.Trim
            End If
            '  2. retrieve quantitative vertical positional accuracy assessment
            xmlPlist = xmlNList(0).SelectNodes("qvertpa")
            iCount = xmlPlist.Count
            For iLoop = 0 To iCount - 1
                s1 = ""
                s2 = ""
                ' 2a. retrieve the accuracy explanation (simple string)
                xmlRlist = xmlPlist(iLoop).SelectNodes("vertacce")
                If (xmlRlist.Count > 0) Then
                    s2 = xmlRlist(0).InnerText.Trim
                End If
                ' 2b. retrieve the accuracy value and test for conformance (real value >= 0)
                xmlRlist = xmlPlist(iLoop).SelectNodes("vertaccv")
                If (xmlRlist.Count > 0) Then
                    s1 = xmlRlist(0).InnerText.Trim
                    Try
                        bReal = True
                        rAccVal = Convert.ToDouble(s1)
                    Catch ex As Exception
                        bReal = False
                        sError = "Vertical Accuracy Value, " & s1 & ", is not a real number"
                        sError += CrLf & "Reset to 0.00"
                        MessageBox.Show(sError, "Accuracy Value error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    End Try
                    If (bReal = True) Then
                        If (rAccVal >= 0.0) Then
                            'do nothing
                        Else
                            s1 = "0.00"
                            sError = "Vertical Positional Accuracy Value < 0.00" & CrLf & "Set to 0.00"
                            MessageBox.Show(sError, "Quantitative Accuracy Assessment error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                        End If
                    Else
                        s1 = "0.00"
                    End If
                End If
                sList = s1 & " m:  " & s2
                lboxVPosAcc.Items.Add(sList) 'update the list box display
                sList = s1 & sPdelim & s2
                sVPosAcc.Add(sList) 'update main collection
            Next
        End If
    End Sub

    Private Sub openDQlineage(ByVal sLineage As String)
        Dim xmlDataQDoc As New XmlDocument
        Dim xmlNList As XmlNodeList
        Dim sDQinfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0

        xmlDataQDoc.LoadXml(sLineage) 'node exists, fill local DOM

        'retrieve Methodology
        xmlNList = xmlDataQDoc.SelectNodes("/lineage/method")
        iCount = xmlNList.Count
        For iLoop = 0 To iCount - 1
            sDQinfo = xmlNList(iLoop).OuterXml
            openDQmethod(sDQinfo)
        Next

        'retrieve Source Information
        xmlNList = xmlDataQDoc.SelectNodes("/lineage/srcinfo")
        iCount = xmlNList.Count
        For iLoop = 0 To iCount - 1
            sDQinfo = xmlNList(iLoop).OuterXml
            openDQsource(sDQinfo)
        Next

        'retrieve Process Step
        xmlNList = xmlDataQDoc.SelectNodes("/lineage/procstep")
        iCount = xmlNList.Count
        For iLoop = 0 To iCount - 1
            sDQinfo = xmlNList(iLoop).OuterXml
            openDQprocess(sDQinfo)
        Next
    End Sub

    Private Sub openDQmethod(ByVal sMethod As String)
        Dim xmlDataQDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim sThesaurus As String = ""
        Dim sKey As String = ""
        Dim s1 As String = ""
        Dim sDQinfo As String = ""
        Dim iSelInd As Integer = 0
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim kCount As Integer = 0
        Dim kLoop As Integer = 0
        Dim sList As String
        Dim oNewMethod As New MethodClass
        Dim sMethIDs As New StringCollection
        Dim xmlCiteDoc As New XmlDocument
        Dim bCheck As Boolean = False
        Dim oCite As New CiteInfo
        Dim bLWC As Boolean = False
        Dim oCiteLWC As New CiteInfo

        xmlDataQDoc.LoadXml(sMethod) 'node exists, fill local DOM
        oNewMethod = New MethodClass

        'retrieve Methodology Type
        xmlNlist = xmlDataQDoc.SelectNodes("/method/methtype")
        If (xmlNlist.Count > 0) Then
            oNewMethod.MethodType = xmlNlist(0).InnerText.Trim
        End If

        'retrieve Methodology Identifier(s)
        xmlNlist = xmlDataQDoc.SelectNodes("/method/methodid")
        iCount = xmlNlist.Count
        For iLoop = 0 To iCount - 1
            ' 1. retrieve methodology keyword thesaurus
            sThesaurus = ""
            xmlPlist = xmlNlist(iLoop).SelectNodes("methkt")
            If (xmlPlist.Count > 0) Then
                sThesaurus = xmlPlist(0).InnerText.Trim
            End If
            ' 2. retrieve methodology keywords
            sKey = ""
            xmlPlist = xmlNlist(iLoop).SelectNodes("methkey")
            kCount = xmlPlist.Count
            For kLoop = 0 To kCount - 1
                s1 = xmlPlist(kLoop).InnerText.Trim
                If (s1 <> "") Then
                    sKey += s1 & sKdelim
                End If
            Next
            If (sKey <> "" And sThesaurus = "") Then sThesaurus = "None"
            If (sKey = "" And sThesaurus = "") Then
                'do nothing, incomplete information considered error condition
            Else
                sThesaurus += sPdelim & sKey
                sMethIDs.Add(sThesaurus) 'add methodology identifier to collection
            End If
        Next
        oNewMethod.MethodID = sMethIDs 'place identifier collection into object

        'retrieve Methodology Description
        xmlNlist = xmlDataQDoc.SelectNodes("/method/methdesc")
        If (xmlNlist.Count > 0) Then
            oNewMethod.MethodDesc = xmlNlist(0).InnerText.Trim
        End If

        'retrieve Methodology Citations
        xmlNlist = xmlDataQDoc.SelectNodes("/method/methcite")
        iCount = xmlNlist.Count
        For iLoop = 0 To iCount - 1
            oCite = New CiteInfo
            bLWC = False
            oCiteLWC = New CiteInfo

            'retrieve Citation
            xmlPlist = xmlNlist(iLoop).SelectNodes("citeinfo")
            kCount = xmlPlist.Count
            If (kCount > 0) Then
                'process Citation
                sDQinfo = xmlPlist(0).OuterXml
                xmlCiteDoc.LoadXml(sDQinfo)
                openCite(xmlCiteDoc, oCite, bCheck) 'main citation
                If (bCheck = False) Then
                    'no required citation elements found
                Else
                    'look for Larger Work Citation
                    xmlPlist = xmlCiteDoc.SelectNodes("/citeinfo/lworkcit/citeinfo")
                    bCheck = False
                    If (xmlPlist.Count > 0) Then
                        sDQinfo = xmlPlist(0).OuterXml
                        xmlCiteDoc.LoadXml(sDQinfo)
                        openCite(xmlCiteDoc, oCiteLWC, bCheck) 'larger work citation
                    End If
                    If (bCheck = True) Then bLWC = True 'a Larger Work Citation was processed
                    'update the object
                    oNewMethod.CiteAdd()
                    iSelInd = oNewMethod.CiteCount '1-based collection
                    oNewMethod.CiteUpdate(oCite, iSelInd)
                    oNewMethod.LWCUpdate(bLWC, oCiteLWC, iSelInd)
                End If
            End If
        Next

        cMethods.Add(oNewMethod) 'place completed object into main collection
        sList = oNewMethod.MethodType & ":  " & Microsoft.VisualBasic.Left(oNewMethod.MethodDesc, 60)
        lboxMeth.Items.Add(sList) 'place identifier into list box display
        Return
    End Sub

    Private Sub openDQsource(ByVal sSource As String)
        Dim xmlDataQDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim oNewSource As New SourceClass
        Dim sThesaurus As String = ""
        Dim sKey As String = ""
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sDQinfo As String = ""
        Dim iSelInd As Integer = 0
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim sList As String
        Dim xmlCiteDoc As New XmlDocument
        Dim bCheck As Boolean = False
        Dim oCite As New CiteInfo
        Dim bLWC As Boolean = False
        Dim oCiteLWC As New CiteInfo
        Dim oTSource As New SourceClass
        Dim oTColl As New Collection
        Dim oTimeDoc As New XmlDocument

        xmlDataQDoc.LoadXml(sSource) 'node exists, fill local DOM
        oNewSource = New SourceClass

        'retrieve Source Citation
        xmlNlist = xmlDataQDoc.SelectNodes("/srcinfo/srccite/citeinfo")
        If (xmlNlist.Count > 0) Then
            oCite = New CiteInfo
            bLWC = False
            oCiteLWC = New CiteInfo

            'process Citation
            sDQinfo = xmlNlist(0).OuterXml
            xmlCiteDoc.LoadXml(sDQinfo)
            openCite(xmlCiteDoc, oCite, bCheck) 'main citation
            If (bCheck = False) Then
                'no required citation elements found
            Else
                'look for Larger Work Citation
                xmlPlist = xmlCiteDoc.SelectNodes("/citeinfo/lworkcit/citeinfo")
                bCheck = False
                If (xmlPlist.Count > 0) Then
                    sDQinfo = xmlPlist(0).OuterXml
                    xmlCiteDoc.LoadXml(sDQinfo)
                    openCite(xmlCiteDoc, oCiteLWC, bCheck) 'larger work citation
                End If
                If (bCheck = True) Then bLWC = True 'a Larger Work Citation was processed

                'update the source object
                oNewSource.SourceCite = oCite
                oNewSource.boolLWC = bLWC
                oNewSource.SourceLWC = oCiteLWC
            End If
        End If

        'retrieve Source Scale Denominator
        xmlNlist = xmlDataQDoc.SelectNodes("/srcinfo/srcscale")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            Try
                iCount = Convert.ToInt32(s1)
            Catch ex As Exception
                sError = "Source Scale Denominator, " & s1 & ", cannot be converted to an integer."
                sError += CrLf & "Denominator not set"
                MessageBox.Show(sError, "Source Scale Denominator error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                s1 = ""
                iCount = 5 'value not actually used
            End Try
            If (iCount < 2) Then
                sError = "Source Scale Denominator, " & s1 & ", is not > 1."
                sError += CrLf & "Denominator not set"
                MessageBox.Show(sError, "Source Scale Denominator error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                s1 = ""
            End If
            oNewSource.ScaleDenom = s1 'either blank or valid integer as string
        End If

        'retrieve Type of Source Media
        xmlNlist = xmlDataQDoc.SelectNodes("/srcinfo/typesrc")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            oNewSource.Media = s1
        End If

        'retrieve Time Period of Content
        xmlNlist = xmlDataQDoc.SelectNodes("/srcinfo/srctime")
        If (xmlNlist.Count > 0) Then
            '  1. retrieve Time Period Information
            xmlPlist = xmlNlist(0).SelectNodes("timeinfo")
            If (xmlPlist.Count > 0) Then
                sDQinfo = xmlPlist(0).OuterXml
                oTimeDoc.LoadXml(sDQinfo)
                openTimeInfo(oTimeDoc, oTSource, oTColl)
                oNewSource.boolRange = oTSource.boolRange
                oNewSource.boolSingle = oTSource.boolSingle
                oNewSource.Gregorian = oTSource.Gregorian
                oNewSource.TimePeriod = oTColl
            End If
            '  2. retrieve Source Currentness Reference
            xmlPlist = xmlNlist(0).SelectNodes("srccurr")
            If (xmlPlist.Count > 0) Then
                s1 = xmlPlist(0).InnerText.Trim
                oNewSource.Currentness = s1
            End If
        End If

        'retrieve Source Citation Abbreviation
        xmlNlist = xmlDataQDoc.SelectNodes("/srcinfo/srccitea")
        If (xmlNlist.Count > 0) Then
            oNewSource.CiteAbbrv = xmlNlist(0).InnerText.Trim
        End If

        'retrieve Source Contribution
        xmlNlist = xmlDataQDoc.SelectNodes("/srcinfo/srccontr")
        If (xmlNlist.Count > 0) Then
            oNewSource.Contrib = xmlNlist(0).InnerText.Trim
        End If

        'update main collection and list box display
        cSources.Add(oNewSource)
        s1 = oNewSource.CiteAbbrv & ":  " & Microsoft.VisualBasic.Left(oNewSource.Contrib, 40)
        lboxLinSource.Items.Add(s1)
        Return
    End Sub

    Private Sub openDQprocess(ByVal sProcess As String)
        Dim xmlDataQDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim oNewProc As New ProcessClass
        Dim sThesaurus As String = ""
        Dim sKey As String = ""
        Dim s1 As String = ""
        Dim sTitle As String = ""
        Dim sError As String = ""
        Dim sDQinfo As String = ""
        Dim iSelInd As Integer = 0
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim kCount As Integer = 0
        Dim kLoop As Integer = 0
        Dim sKeyArray() As String
        Dim sList As String
        Dim xmlCiteDoc As New XmlDocument
        Dim oContact As New ContactInfo
        Dim bDate As Boolean = False

        xmlDataQDoc.LoadXml(sProcess) 'node exists, fill local DOM
        oNewProc = New ProcessClass
        oContact = New ContactInfo

        'retrieve Process Description
        xmlNlist = xmlDataQDoc.SelectNodes("/procstep/procdesc")
        If (xmlNlist.Count > 0) Then
            oNewProc.Description = xmlNlist(0).InnerText.Trim
        End If

        'retrieve Source Used Abbreviation(s)
        xmlNlist = xmlDataQDoc.SelectNodes("/procstep/srcused")
        iCount = xmlNlist.Count
        sKey = ""
        For iLoop = 0 To iCount - 1
            s1 = xmlNlist(iLoop).InnerText.Trim
            If (s1 <> "") Then
                sKey += s1 & sKdelim
            End If
        Next
        oNewProc.UsedAbbrv = sKey

        'retrieve Process Date
        xmlNlist = xmlDataQDoc.SelectNodes("/procstep/procdate")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            Select Case s1
                Case "Unknown", "Not complete"
                    'valid entries
                Case Else
                    evalDate(s1, bDate)
                    If (bDate = True) Then
                        'have valid date
                    Else
                        sTitle = "Data Quality Info  Lineage error"
                        sError = "Process Date  " & s1 & "  is not in correct date format."
                        sError += "Date set to Unknown."
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        s1 = "Unknown"
                    End If
            End Select
            oNewProc.ProcessDate = s1
        End If

        'retrieve Process Time
        xmlNlist = xmlDataQDoc.SelectNodes("/procstep/proctime")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            chkTime(s1)
            oNewProc.ProcessTime = s1
        End If

        'retrieve Source Produced Abbreviation(s)
        xmlNlist = xmlDataQDoc.SelectNodes("/procstep/srcprod")
        iCount = xmlNlist.Count
        sKey = ""
        For iLoop = 0 To iCount - 1
            s1 = xmlNlist(iLoop).InnerText.Trim
            If (s1 <> "") Then
                sKey += s1 & sKdelim
            End If
        Next
        oNewProc.ProducedAbbrv = sKey

        'retrieve Process Contact
        xmlNlist = xmlDataQDoc.SelectNodes("/procstep/proccont/cntinfo")
        If (xmlNlist.Count > 0) Then
            'get the Contact Information XML
            sDQinfo = xmlNlist(0).OuterXml
            openContact(sDQinfo, oContact)
            oNewProc.ProcessContact = oContact
        End If

        'add object to main collection and place entry in list box display
        cProcess.Add(oNewProc)
        s1 = Microsoft.VisualBasic.Left(oNewProc.Description, 60)
        lboxProcess.Items.Add(s1)
        Return
    End Sub

#End Region


#Region " DOM processing for Spatial Data Organization Information section "

    Private Sub openSpDO(ByVal xmlOpenSpDO As XmlDocument)
        Dim xmlNlist As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim sSpDOinfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim kCount As Integer = 0

        'retrieve Indirect Spatial Reference
        xmlNlist = xmlOpenSpDO.SelectNodes("/spdoinfo/indspref")
        If (xmlNlist.Count > 0) Then
            txtIndirect.Text = xmlNlist(0).InnerText.Trim
        End If

        'retrieve Direct Spatial Reference Method
        xmlNlist = xmlOpenSpDO.SelectNodes("/spdoinfo/direct")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            iCount = cboxDirect.FindStringExact(s1)
            cboxDirect.SelectedIndex = iCount
        End If

        'retrieve appropriate Object Information, if available
        Select Case s1
            Case "Point", "Vector"
                'retrieve point and vector object information
                xmlNlist = xmlOpenSpDO.SelectNodes("/spdoinfo/ptvctinf/sdtsterm")
                iCount = xmlNlist.Count
                If (iCount > 0) Then
                    'process SDTS terms
                    rdoSDTS.Checked = True
                    For iLoop = 0 To iCount - 1
                        sSpDOinfo = xmlNlist(iLoop).OuterXml
                        openSPDOvector(sSpDOinfo, "sdts")
                    Next
                Else
                    'look for VPF terms
                    xmlNlist = xmlOpenSpDO.SelectNodes("/spdoinfo/ptvctinf/vpfterm")
                    If (xmlNlist.Count > 0) Then
                        'process VPF Terms Description
                        rdoVPF.Checked = True
                        ' 1. retrieve VPF topology level
                        xmlPlist = xmlNlist(0).SelectNodes("vpflevel")
                        If (xmlPlist.Count > 0) Then
                            s1 = xmlPlist(0).InnerText.Trim
                            kCount = cboxVPF.FindStringExact(s1)
                            cboxVPF.SelectedIndex = kCount
                            If (kCount = -1) Then
                                'provide error msg, incorrect VPF topology level
                                sError = "VPF Topology Level, " & s1 & ", is not valid." & sKdelim
                                sError += "It will be ignored."
                                sTitle = "Spatial Data Organization error"
                                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                            End If
                        End If
                        ' 2. retrieve VPF object information
                        xmlPlist = xmlNlist(0).SelectNodes("vpfinfo")
                        kCount = xmlPlist.Count - 1
                        For iLoop = 0 To kCount
                            sSpDOinfo = xmlPlist(iLoop).OuterXml
                            openSPDOvector(sSpDOinfo, "vpf")
                        Next
                    End If
                End If
            Case "Raster"
                'retrieve raster object information
                xmlNlist = xmlOpenSpDO.SelectNodes("/spdoinfo/rastinfo")
                If (xmlNlist.Count > 0) Then
                    sSpDOinfo = xmlNlist(0).OuterXml
                    openSPDOraster(sSpDOinfo)
                End If
            Case ""
                'do nothing, blank value
            Case Else
                'provide error msg, incorrect Direct Spatial Reference Method
                sError = "Direct Spatial Reference Method, " & s1 & ", is not a valid method!" & sKdelim
                sError += "Reference Method and Object Information ignored."
                sTitle = "Spatial Data Organization error"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Select
    End Sub

    Private Sub openSPDOvector(ByVal sTerms As String, ByVal sType As String)
        'sType is either "sdts" or "vpf"
        Dim xmlSpDODoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim sList As String
        Dim bInteger As Boolean = False

        xmlSpDODoc.LoadXml(sTerms)

        'retrieve Object Type
        s1 = ""
        If (sType = "sdts") Then
            xmlNlist = xmlSpDODoc.SelectNodes("/sdtsterm/sdtstype")
            If (xmlNlist.Count > 0) Then
                s1 = xmlNlist(0).InnerText.Trim
            End If
        Else
            xmlNlist = xmlSpDODoc.SelectNodes("/vpfinfo/vpftype")
            If (xmlNlist.Count > 0) Then
                s1 = xmlNlist(0).InnerText.Trim
            End If
        End If

        'retrieve Object Count
        s2 = "0"
        If (sType = "sdts") Then
            xmlNlist = xmlSpDODoc.SelectNodes("/sdtsterm/ptvctcnt")
            If (xmlNlist.Count > 0) Then
                s2 = xmlNlist(0).InnerText.Trim
            End If
        Else
            xmlNlist = xmlSpDODoc.SelectNodes("/vpfinfo/ptvctcnt")
            If (xmlNlist.Count > 0) Then
                s2 = xmlNlist(0).InnerText.Trim
            End If
        End If
        chkInteger(s2, iCount, bInteger)
        If (bInteger = False) Then
            s2 = "0"
        Else
            Select Case iCount
                Case Is < 0
                    sError = "Vector Object Information" & CrLf
                    sError += "Object Count, " & s1 & ", less than 0. Value reset to 0."
                    sTitle = "Spatial Data Organization error"
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    iCount = 0
                Case Is > 1000000 'one million is current upper bound set for numeric control
                    sError = "Vector Object Information" & CrLf
                    sError += "Object Count, " & s1 & ", > 1 million. Value reset to 1 million."
                    sTitle = "Spatial Data Organization error"
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    iCount = 1000000
            End Select
            s2 = iCount.ToString
        End If

        'update main string collection and list box display
        If (s1 <> "") Then
            sList = s1 & sPdelim & s2
            sSDTS.Add(sList)
            sList = Replace(sList, sPdelim, "  :  ")
            lboxTerms.Items.Add(sList)
        End If
        Return
    End Sub

    Private Sub openSPDOraster(ByVal sRaster As String)
        Dim xmlSpDODoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim bInteger As Boolean = False

        xmlSpDODoc.LoadXml(sRaster)

        'retrieve Raster Object Type
        xmlNlist = xmlSpDODoc.SelectNodes("/rastinfo/rasttype")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            iCount = cboxRasType.FindStringExact(s1)
            cboxRasType.SelectedIndex = iCount
        End If

        'retrieve Row Count
        xmlNlist = xmlSpDODoc.SelectNodes("/rastinfo/rowcount")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            chkInteger(s1, iCount, bInteger)
            If (bInteger = True) Then
                Select Case iCount
                    Case Is < 0
                        sError = "Raster Object Information" & CrLf
                        sError += "Row Count, " & s1 & ", less than 0. Value reset to 0."
                        sTitle = "Spatial Data Organization error"
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        iCount = 0
                    Case Is > 1000000000 'one billion is current upper bound set for numeric control
                        sError = "Raster Object Information" & CrLf
                        sError += "Row Count, " & s1 & ", > 1 million. Value reset to 1 billion."
                        sTitle = "Spatial Data Organization error"
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        iCount = 1000000000
                End Select
                numRasRow.Value = Convert.ToDecimal(iCount) 'place checked integer into numeric control
            Else
                sError = "Raster Object Information" & CrLf
                sError += "Row Count, " & s1 & ", could not be converted to an integer."
                MessageBox.Show(sError, "Spatial Data Organization error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If

        'retrieve Column Count
        xmlNlist = xmlSpDODoc.SelectNodes("/rastinfo/colcount")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            chkInteger(s1, iCount, bInteger)
            If (bInteger = True) Then
                Select Case iCount
                    Case Is < 0
                        sError = "Raster Object Information" & CrLf
                        sError += "Column Count, " & s1 & ", less than 0. Value reset to 0."
                        sTitle = "Spatial Data Organization error"
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        iCount = 0
                    Case Is > 1000000000 'one billion is current upper bound set for numeric control
                        sError = "Raster Object Information" & CrLf
                        sError += "Column Count, " & s1 & ", > 1 million. Value reset to 1 billion."
                        sTitle = "Spatial Data Organization error"
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        iCount = 1000000000
                End Select
                numRasCol.Value = Convert.ToDecimal(iCount) 'place checked integer into numeric control
            Else
                sError = "Raster Object Information" & CrLf
                sError += "Column Count, " & s1 & ", could not be converted to an integer."
                MessageBox.Show(sError, "Spatial Data Organization error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If

        'retrieve Vertical Count
        xmlNlist = xmlSpDODoc.SelectNodes("/rastinfo/vrtcount")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            chkInteger(s1, iCount, bInteger)
            If (bInteger = True) Then
                Select Case iCount
                    Case Is < 0
                        sError = "Raster Object Information" & CrLf
                        sError += "Vertical Count, " & s1 & ", less than 0. Value reset to 0."
                        sTitle = "Spatial Data Organization error"
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        iCount = 0
                    Case Is > 1000000000 'one billion is current upper bound set for numeric control
                        sError = "Raster Object Information" & CrLf
                        sError += "Vertical Count, " & s1 & ", > 1 million. Value reset to 1 billion."
                        sTitle = "Spatial Data Organization error"
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        iCount = 1000000000
                End Select
                numRasVert.Value = Convert.ToDecimal(iCount) 'place checked integer into numeric control
            Else
                sError = "Raster Object Information" & CrLf
                sError += "Vertical Count, " & s1 & ", could not be converted to an integer."
                MessageBox.Show(sError, "Spatial Data Organization error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If
        Return
    End Sub

    Private Sub chkInteger(ByVal s1 As String, ByRef iValue As Integer, ByRef bTrans As Boolean)
        Try
            bTrans = True
            iValue = Convert.ToInt32(s1)
        Catch ex As Exception
            bTrans = False
            iValue = 0
        End Try
    End Sub

#End Region


#Region " DOM processing for Spatial Reference Information section "

    Private Sub openSpRef(ByVal xmlOpenSpRef As XmlDocument)
        Dim xmlNlist As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim sSpRefinfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim kCount As Integer = 0
        Dim jCount As Integer = 0

        'retrieve Horizontal Coordinate System Definition
        xmlNlist = xmlOpenSpRef.SelectNodes("/spref/horizsys")
        If (xmlNlist.Count > 0) Then
            ' 1. retrieve Geographic definition
            xmlPlist = xmlNlist(0).SelectNodes("geograph")
            kCount = xmlPlist.Count
            If (kCount > 0) Then
                rdoGeographic.Checked = True
                sSpRefinfo = xmlPlist(0).OuterXml
                openSRgeog(sSpRefinfo)
            Else
                ' 2. OR retrieve Local definition
                xmlPlist = xmlNlist(0).SelectNodes("local")
                jCount = xmlPlist.Count
                If (jCount > 0) Then
                    rdoLocal.Checked = True
                    sSpRefinfo = xmlPlist(0).OuterXml
                    openSRlocal(sSpRefinfo)
                Else
                    ' 3. OR retrieve Planar definition(s)
                    xmlPlist = xmlNlist(0).SelectNodes("planar")
                    iCount = xmlPlist.Count - 1
                    If (xmlPlist.Count > 0) Then rdoPlanar.Checked = True
                    For iLoop = 0 To iCount
                        sSpRefinfo = xmlPlist(iLoop).OuterXml
                        openSRplanar(sSpRefinfo)
                    Next
                End If
            End If
            ' 4. retrieve Geodetic Model
            xmlPlist = xmlNlist(0).SelectNodes("geodetic")
            If (xmlPlist.Count > 0) Then
                sSpRefinfo = xmlPlist(0).OuterXml
                openSRgeodetic(sSpRefinfo)
            End If
        End If

        'retrieve Vertical Coordinate System Definition
        xmlNlist = xmlOpenSpRef.SelectNodes("/spref/vertdef")
        If (xmlNlist.Count > 0) Then
            ' 1. retrieve Altitude System Definition
            xmlPlist = xmlNlist(0).SelectNodes("altsys")
            If (xmlPlist.Count > 0) Then
                sSpRefinfo = xmlPlist(0).OuterXml
                openSRaltitude(sSpRefinfo)
            End If
            ' 2. retrieve Depth System Definition
            xmlPlist = xmlNlist(0).SelectNodes("depthsys")
            If (xmlPlist.Count > 0) Then
                sSpRefinfo = xmlPlist(0).OuterXml
                openSRdepth(sSpRefinfo)
            End If
        End If
    End Sub

    Private Sub openSRgeog(ByVal sGeog As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim sList As String
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        xmlSpRefDoc.LoadXml(sGeog)
        sTitle = "Spatial Reference error"

        'retrieve Latitude Resolution
        xmlNlist = xmlSpRefDoc.SelectNodes("/geograph/latres")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            realCheck(s1, rVal, bReal)
            If (bReal = True) Then
                If (rVal > 90.0) Then rVal = 90.0 'truncate to maximum value of numeric control
                If (rVal >= 0.0) Then
                    numLatRes.Value = Convert.ToDecimal(rVal) 'put resolution into control
                Else
                    sError = "Geographic Definition" & CrLf
                    sError += "Latitude Resolution, " & s1 & ", less than 0. Value ignored."
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            Else
                sError = "Geographic Definition" & CrLf
                sError += "Latitude Resolution, " & s1 & ", could not be converted to a real number." & CrLf
                sError += "Value ignored."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If

        'retrieve Longitude Resolution
        xmlNlist = xmlSpRefDoc.SelectNodes("/geograph/longres")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            realCheck(s1, rVal, bReal)
            If (bReal = True) Then
                If (rVal > 180.0) Then rVal = 180.0 'truncate to maximum value of numeric control
                If (rVal >= 0.0) Then
                    numLongRes.Value = Convert.ToDecimal(rVal) 'put resolution into control
                Else
                    sError = "Geographic Definition" & CrLf
                    sError += "Longitude Resolution, " & s1 & ", less than 0. Value ignored."
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            Else
                sError = "Geographic Definition" & CrLf
                sError += "Longitude Resolution, " & s1 & ", could not be converted to a real number." & CrLf
                sError += "Value ignored."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If

        'retrieve Geographic Coordinate Units
        xmlNlist = xmlSpRefDoc.SelectNodes("/geograph/geogunit")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            'select coordinate units for combo box display
            iCount = cboxGeoCoorUnits.FindStringExact(s1)
            cboxGeoCoorUnits.SelectedIndex = iCount
        End If
    End Sub

    Private Sub openSRlocal(ByVal sLocal As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList

        xmlSpRefDoc.LoadXml(sLocal)

        'retrieve Local Description
        xmlNlist = xmlSpRefDoc.SelectNodes("/local/localdes")
        If (xmlNlist.Count > 0) Then
            txtLocalDesc.Text = xmlNlist(0).InnerText.Trim
        End If

        'retrieve Local Georeference Information
        xmlNlist = xmlSpRefDoc.SelectNodes("/local/localgeo")
        If (xmlNlist.Count > 0) Then
            txtLocalGeoInfo.Text = xmlNlist(0).InnerText.Trim
        End If
    End Sub

    Private Sub openSRplanar(ByVal sPlanar As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim sSpRefInfo As String = ""
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim sList As String
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False
        Dim oPlanar As New PlanarClass

        xmlSpRefDoc.LoadXml(sPlanar)
        oPlanar = New PlanarClass

        'retrieve Planar Coordinate Information
        xmlNlist = xmlSpRefDoc.SelectNodes("/planar/planci")
        If (xmlNlist.Count > 0) Then
            sSpRefInfo = xmlNlist(0).OuterXml
            openSRplanarCoord(sSpRefInfo, oPlanar)
        End If

        'retrieve Map Projection
        xmlNlist = xmlSpRefDoc.SelectNodes("/planar/mapproj")
        If (xmlNlist.Count > 0) Then
            sSpRefInfo = xmlNlist(0).OuterXml
            openSRplanarMap(sSpRefInfo, oPlanar)
            openSRplanarUpdate(oPlanar)
            Return
        End If

        'OR retrieve Grid Coordinate System
        xmlNlist = xmlSpRefDoc.SelectNodes("/planar/gridsys")
        If (xmlNlist.Count > 0) Then
            sSpRefInfo = xmlNlist(0).OuterXml
            openSRplanarGrid(sSpRefInfo, oPlanar)
            openSRplanarUpdate(oPlanar)
            Return
        End If

        'OR retrieve Local Planar
        xmlNlist = xmlSpRefDoc.SelectNodes("/planar/localp")
        If (xmlNlist.Count > 0) Then
            oPlanar.LocalPlanar = True
            ' 1. retrieve Local Planar Description
            xmlPlist = xmlNlist(0).SelectNodes("localpd")
            If (xmlPlist.Count > 0) Then
                oPlanar.LocalDesc = xmlPlist(0).InnerText.Trim
            End If
            ' 2. retrieve Local Planar Georeference Information
            xmlPlist = xmlNlist(0).SelectNodes("localpgi")
            If (xmlPlist.Count > 0) Then
                oPlanar.LocalGeoRef = xmlPlist(0).InnerText.Trim
            End If
            openSRplanarUpdate(oPlanar)
            Return
        End If
    End Sub

    Private Sub openSRplanarCoord(ByVal sPlanar As String, ByRef oPlanar As PlanarClass)
        'retrieve Planar Coordinate Information
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        xmlSpRefDoc.LoadXml(sPlanar)
        sTitle = "Spatial Reference error"

        'retrieve Planar Coordinate Encoding Method
        xmlNlist = xmlSpRefDoc.SelectNodes("/planci/plance")
        If (xmlNlist.Count > 0) Then
            oPlanar.Encoding = xmlNlist(0).InnerText.Trim
        End If

        'retrieve Planar Distance Units
        xmlNlist = xmlSpRefDoc.SelectNodes("/planci/plandu")
        If (xmlNlist.Count > 0) Then
            oPlanar.PlanarUnits = xmlNlist(0).InnerText.Trim
        End If

        'retrieve Coordinate Representation
        xmlNlist = xmlSpRefDoc.SelectNodes("/planci/coordrep")
        iCount = xmlNlist.Count
        If (iCount > 0) Then
            oPlanar.CoorRep = True
            ' 1. retrieve Abcissa Resolution
            xmlPlist = xmlNlist(0).SelectNodes("absres")
            If (xmlPlist.Count > 0) Then
                s1 = xmlPlist(0).InnerText.Trim
                realCheck(s1, rVal, bReal)
                If (bReal = True) Then
                    If (rVal > 100000.0) Then
                        sError = "Planar Coordinate Representation" & CrLf
                        sError += "Abscissa Resolution, " & s1 & ", > 100,000 -- max value for control."
                        sError += "Value reduced to 100,000."
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        rVal = 100000.0
                    End If
                    If (rVal >= 0.0) Then
                        oPlanar.Abscissa = Convert.ToDecimal(rVal)
                    Else
                        sError = "Planar Coordinate Representation" & CrLf
                        sError += "Abscissa Resolution, " & s1 & ", less than 0. Value ignored."
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    End If
                Else
                    sError = "Planar Coordinate Representation" & CrLf
                    sError += "Abscissa Resolution, " & s1 & ", could not be converted to a real number." & CrLf
                    sError += "Value ignored."
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            End If
            ' 2. retrieve Ordinate Resolution
            xmlPlist = xmlNlist(0).SelectNodes("ordres")
            If (xmlPlist.Count > 0) Then
                s1 = xmlPlist(0).InnerText.Trim
                realCheck(s1, rVal, bReal)
                If (bReal = True) Then
                    If (rVal > 100000.0) Then
                        sError = "Planar Coordinate Representation" & CrLf
                        sError += "Ordinate Resolution, " & s1 & ", > 100,000 -- max value for control."
                        sError += "Value reduced to 100,000."
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        rVal = 100000.0
                    End If
                    If (rVal >= 0.0) Then
                        oPlanar.Ordinate = Convert.ToDecimal(rVal)
                    Else
                        sError = "Planar Coordinate Representation" & CrLf
                        sError += "Ordinate Resolution, " & s1 & ", less than 0. Value ignored."
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    End If
                Else
                    sError = "Planar Coordinate Representation" & CrLf
                    sError += "Ordinate Resolution, " & s1 & ", could not be converted to a real number." & CrLf
                    sError += "Value ignored."
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            End If
            Return 'if Coordinate Representation present, do not look for Distance & Bearing Representation
        End If

        ' OR retrieve Distance and Bearing Representation
        xmlNlist = xmlSpRefDoc.SelectNodes("/planci/distbrep")
        If (xmlNlist.Count > 0) Then
            oPlanar.BearingRep = True
            ' 1. retrieve Distance Resolution
            xmlPlist = xmlNlist(0).SelectNodes("distres")
            If (xmlPlist.Count > 0) Then
                s1 = xmlPlist(0).InnerText.Trim
                realCheck(s1, rVal, bReal)
                If (bReal = True) Then
                    If (rVal > 100000.0) Then
                        sError = "Planar Coordinate Representation" & CrLf
                        sError += "Distance Resolution, " & s1 & ", > 100,000 -- max value for control."
                        sError += "Value reduced to 100,000."
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        rVal = 100000.0
                    End If
                    If (rVal >= 0.0) Then
                        oPlanar.DistanceRes = Convert.ToDecimal(rVal)
                    Else
                        sError = "Planar Coordinate Representation" & CrLf
                        sError += "Distance Resolution, " & s1 & ", less than 0. Value ignored."
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    End If
                Else
                    sError = "Planar Coordinate Representation" & CrLf
                    sError += "Distance Resolution, " & s1 & ", could not be converted to a real number." & CrLf
                    sError += "Value ignored."
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            End If
            ' 2. retrieve Bearing Resolution
            xmlPlist = xmlNlist(0).SelectNodes("bearres")
            If (xmlPlist.Count > 0) Then
                s1 = xmlPlist(0).InnerText.Trim
                realCheck(s1, rVal, bReal)
                If (bReal = True) Then
                    If (rVal > 100000.0) Then
                        sError = "Planar Coordinate Representation" & CrLf
                        sError += "Bearing Resolution, " & s1 & ", > 100,000 -- max value for control."
                        sError += "Value reduced to 100,000."
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        rVal = 100000.0
                    End If
                    If (rVal >= 0.0) Then
                        oPlanar.BearingRes = Convert.ToDecimal(rVal)
                    Else
                        sError = "Planar Coordinate Representation" & CrLf
                        sError += "Bearing Resolution, " & s1 & ", less than 0. Value ignored."
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    End If
                Else
                    sError = "Planar Coordinate Representation" & CrLf
                    sError += "Bearing Resolution, " & s1 & ", could not be converted to a real number." & CrLf
                    sError += "Value ignored."
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            End If
            ' 3. retrieve Bearing Units
            xmlPlist = xmlNlist(0).SelectNodes("bearunit")
            If (xmlPlist.Count > 0) Then
                oPlanar.BearingUnits = xmlPlist(0).InnerText.Trim
            End If
            ' 4. retrieve Bearing Reference Direction
            xmlPlist = xmlNlist(0).SelectNodes("bearrefd")
            If (xmlPlist.Count > 0) Then
                oPlanar.BearingDir = xmlPlist(0).InnerText.Trim
            End If
            ' 5. retrieve Bearing Reference Meridian
            xmlPlist = xmlNlist(0).SelectNodes("bearrefm")
            If (xmlPlist.Count > 0) Then
                oPlanar.BearingMerid = xmlPlist(0).InnerText.Trim
            End If
        End If
        Return
    End Sub

    Private Sub openSRplanarMap(ByVal sPlanar As String, ByRef oPlanar As PlanarClass)
        'retrieve Map Projection
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim sParArray(29) As String 'map projection parameter array
        Dim s1 As String = ""
        Dim sProjInfo As String = ""
        Dim iSelIndex As Integer = 0
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        xmlSpRefDoc.LoadXml(sPlanar)
        sTitle = "Spatial Reference error"

        'retrieve Map Projection Name
        xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/mapprojn")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            oPlanar.MapProj = True
            oPlanar.MapProjName = s1
            sParArray(0) = s1
        Else
            Return
        End If

        'retrieve Map Projection parameter info using type in s1
        Select Case s1
            Case "Albers Conical Equal Area"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/albers")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openAlbers(sProjInfo, sParArray, "albers")
                End If
            Case "Azimuthal Equidistant"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/azimequi")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openAziEqui(sProjInfo, sParArray, "azimequi")
                End If
            Case "Equidistant Conic"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/equicon")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openAlbers(sProjInfo, sParArray, "equicon")
                End If
            Case "Equirectangular"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/equirect")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openEquiRect(sProjInfo, sParArray)
                End If
            Case "General Vertical Near-sided Projection"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/gvnsp")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openGenVertPersp(sProjInfo, sParArray)
                End If
            Case "Gnomonic"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/gnomonic")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openGnomonic(sProjInfo, sParArray, "gnomonic")
                End If
            Case "Lambert Azimuthal Equal Area"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/lamberta")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openGnomonic(sProjInfo, sParArray, "lamberta")
                End If
            Case "Lambert Conformal Conic"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/lambertc")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openAlbers(sProjInfo, sParArray, "lambertc")
                End If
            Case "Mercator"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/mercator")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openMercator(sProjInfo, sParArray)
                End If
            Case "Modified Stereographic for Alaska"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/modsak")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openModAlaska(sProjInfo, sParArray)
                End If
            Case "Miller Cylindrical"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/miller")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openMiller(sProjInfo, sParArray)
                End If
            Case "Oblique Mercator"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/obqmerc")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openObqMercator(sProjInfo, sParArray)
                End If
            Case "Orthographic"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/orthogr")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openGnomonic(sProjInfo, sParArray, "orthogr")
                End If
            Case "Polar Stereographic"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/polarst")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openPolarStereo(sProjInfo, sParArray)
                End If
            Case "Polyconic"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/polycon")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openAziEqui(sProjInfo, sParArray, "polycon")
                End If
            Case "Robinson"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/robinson")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openGnomonic(sProjInfo, sParArray, "robinson")
                End If
            Case "Sinusoidal"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/sinusoid")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openAziEqui(sProjInfo, sParArray, "sinusoid")
                End If
            Case "Space Oblique Mercator"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/spaceobq")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openSpaceMercator(sProjInfo, sParArray)
                End If
            Case "Stereographic"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/stereo")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openGnomonic(sProjInfo, sParArray, "stereo")
                End If
            Case "Transverse Mercator"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/transmer")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openAziEqui(sProjInfo, sParArray, "transmer")
                End If
            Case "van der Grinten"
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/vdgrin")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).OuterXml
                    openAziEqui(sProjInfo, sParArray, "vdgrin")
                End If
            Case Else
                'other map projection system
                xmlNlist = xmlSpRefDoc.SelectNodes("/mapproj/otherprj")
                If (xmlNlist.Count > 0) Then
                    sProjInfo = xmlNlist(0).InnerText.Trim
                    sParArray(28) = sProjInfo
                End If
        End Select

        'update the parameter values
        iCount = 28
        For iLoop = 0 To iCount
            oPlanar.setParam(iLoop, sParArray(iLoop))
        Next
    End Sub

    Private Sub openAlbers(ByVal sAlbers As String, ByRef sParValues() As String, ByVal sType As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim sProjInfo As String = ""
        Dim sNode As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0

        xmlSpRefDoc.LoadXml(sAlbers)

        'retrieve up to 2 standard parallels
        sNode = "/" & sType & "/stdparll"
        xmlNlist = xmlSpRefDoc.SelectNodes(sNode)
        iCount = xmlNlist.Count - 1
        If (iCount > 1) Then iCount = 1 'only 2 std parallels
        For iLoop = 0 To iCount
            sProjInfo = xmlNlist(iLoop).OuterXml
            openStdParallel(sProjInfo)
            sParValues(iLoop + 2) = sProjInfo
        Next
        'Longitude of Central Meridian
        sNode = "/" & sType & "/longcm"
        xmlNlist = xmlSpRefDoc.SelectNodes(sNode)
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openLongCentMerid(sProjInfo)
            sParValues(4) = sProjInfo
        End If
        'Latitude of Projection Origin
        sNode = "/" & sType & "/latprjo"
        xmlNlist = xmlSpRefDoc.SelectNodes(sNode)
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openLatProjOrig(sProjInfo)
            sParValues(5) = sProjInfo
        End If
        'False Easting
        sNode = "/" & sType & "/feast"
        xmlNlist = xmlSpRefDoc.SelectNodes(sNode)
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Easting")
            sParValues(6) = sProjInfo
        End If
        'False Northing
        sNode = "/" & sType & "/fnorth"
        xmlNlist = xmlSpRefDoc.SelectNodes(sNode)
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Northing")
            sParValues(7) = sProjInfo
        End If
    End Sub

    Private Sub openAziEqui(ByVal sAziEqui As String, ByRef sParValues() As String, ByVal sType As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim sProjInfo As String = ""
        Dim sNode As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0

        xmlSpRefDoc.LoadXml(sAziEqui)

        'Longitude of Central Meridian
        sNode = "/" & sType & "/longcm"
        xmlNlist = xmlSpRefDoc.SelectNodes(sNode)
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openLongCentMerid(sProjInfo)
            sParValues(4) = sProjInfo
        End If
        'Latitude of Projection Origin
        sNode = "/" & sType & "/latprjo"
        xmlNlist = xmlSpRefDoc.SelectNodes(sNode)
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openLatProjOrig(sProjInfo)
            sParValues(5) = sProjInfo
        End If
        'False Easting
        sNode = "/" & sType & "/feast"
        xmlNlist = xmlSpRefDoc.SelectNodes(sNode)
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Easting")
            sParValues(6) = sProjInfo
        End If
        'False Northing
        sNode = "/" & sType & "/fnorth"
        xmlNlist = xmlSpRefDoc.SelectNodes(sNode)
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Northing")
            sParValues(7) = sProjInfo
        End If

        If (sType = "transmer") Then
            'Scale Factor at Central Meridian
            sNode = "/" & sType & "/sfctrmer"
            xmlNlist = xmlSpRefDoc.SelectNodes(sNode)
            If (xmlNlist.Count > 0) Then
                sProjInfo = xmlNlist(0).OuterXml
                openScaleCentMerid(sProjInfo)
                sParValues(23) = sProjInfo
            End If
        End If
    End Sub

    Private Sub openEquiConic(ByVal sEquiConic As String, ByRef sParValues() As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim sProjInfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0

        xmlSpRefDoc.LoadXml(sEquiConic)

        'retrieve up to 2 standard parallels
        xmlNlist = xmlSpRefDoc.SelectNodes("/equicon/stdparll")
        iCount = xmlNlist.Count - 1
        If (iCount > 1) Then iCount = 1 'only 2 std parallels
        For iLoop = 0 To iCount
            sProjInfo = xmlNlist(iLoop).OuterXml
            openStdParallel(sProjInfo)
            sParValues(iLoop + 2) = sProjInfo
        Next
        'Longitude of Central Meridian
        xmlNlist = xmlSpRefDoc.SelectNodes("/equicon/longcm")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openLongCentMerid(sProjInfo)
            sParValues(4) = sProjInfo
        End If
        'Latitude of Projection Origin
        xmlNlist = xmlSpRefDoc.SelectNodes("/equicon/latprjo")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openLatProjOrig(sProjInfo)
            sParValues(5) = sProjInfo
        End If
        'False Easting
        xmlNlist = xmlSpRefDoc.SelectNodes("/equicon/feast")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Easting")
            sParValues(6) = sProjInfo
        End If
        'False Northing
        xmlNlist = xmlSpRefDoc.SelectNodes("/equicon/fnorth")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Northing")
            sParValues(7) = sProjInfo
        End If
    End Sub

    Private Sub openEquiRect(ByVal sEquiRect As String, ByRef sParValues() As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim sProjInfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0

        xmlSpRefDoc.LoadXml(sEquiRect)

        'retrieve up to 1 standard parallel
        xmlNlist = xmlSpRefDoc.SelectNodes("/equirect/stdparll")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openStdParallel(sProjInfo)
            sParValues(2) = sProjInfo
        End If
        'Longitude of Central Meridian
        xmlNlist = xmlSpRefDoc.SelectNodes("/equirect/longcm")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openLongCentMerid(sProjInfo)
            sParValues(4) = sProjInfo
        End If
        'False Easting
        xmlNlist = xmlSpRefDoc.SelectNodes("/equirect/feast")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Easting")
            sParValues(6) = sProjInfo
        End If
        'False Northing
        xmlNlist = xmlSpRefDoc.SelectNodes("/equirect/fnorth")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Northing")
            sParValues(7) = sProjInfo
        End If
    End Sub

    Private Sub openGenVertPersp(ByVal sGVNP As String, ByRef sParValues() As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim sProjInfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0

        xmlSpRefDoc.LoadXml(sGVNP)

        'retrieve Height Above Perspective Point
        xmlNlist = xmlSpRefDoc.SelectNodes("/gvnsp/heightpt")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openHtPersPoint(sProjInfo)
            sParValues(9) = sProjInfo
        End If
        'Longitude of Projection Center
        xmlNlist = xmlSpRefDoc.SelectNodes("/gvnsp/longpc")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openLongProjCent(sProjInfo)
            sParValues(10) = sProjInfo
        End If
        'Latitude of Projection Center
        xmlNlist = xmlSpRefDoc.SelectNodes("/gvnsp/latprjc")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openLatProjCent(sProjInfo)
            sParValues(11) = sProjInfo
        End If
        'False Easting
        xmlNlist = xmlSpRefDoc.SelectNodes("/gvnsp/feast")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Easting")
            sParValues(6) = sProjInfo
        End If
        'False Northing
        xmlNlist = xmlSpRefDoc.SelectNodes("/gvnsp/fnorth")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Northing")
            sParValues(7) = sProjInfo
        End If
    End Sub

    Private Sub openGnomonic(ByVal sGnomonic As String, ByRef sParValues() As String, ByVal sType As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim sProjInfo As String = ""
        Dim sNode As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0

        xmlSpRefDoc.LoadXml(sGnomonic)

        'Longitude of Projection Center
        sNode = "/" & sType & "/longpc"
        xmlNlist = xmlSpRefDoc.SelectNodes(sNode)
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openLongProjCent(sProjInfo)
            sParValues(10) = sProjInfo
        End If
        'Latitude of Projection Center
        sNode = "/" & sType & "/latprjc"
        xmlNlist = xmlSpRefDoc.SelectNodes(sNode)
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openLatProjCent(sProjInfo)
            sParValues(11) = sProjInfo
        End If
        'False Easting
        sNode = "/" & sType & "/feast"
        xmlNlist = xmlSpRefDoc.SelectNodes(sNode)
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Easting")
            sParValues(6) = sProjInfo
        End If
        'False Northing
        sNode = "/" & sType & "/fnorth"
        xmlNlist = xmlSpRefDoc.SelectNodes(sNode)
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Northing")
            sParValues(7) = sProjInfo
        End If
    End Sub

    Private Sub openMercator(ByVal sMercator As String, ByRef sParValues() As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim sProjInfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0

        xmlSpRefDoc.LoadXml(sMercator)

        'Longitude of Central Meridian
        xmlNlist = xmlSpRefDoc.SelectNodes("/mercator/longcm")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openLongCentMerid(sProjInfo)
            sParValues(4) = sProjInfo
        End If
        'False Easting
        xmlNlist = xmlSpRefDoc.SelectNodes("/mercator/feast")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Easting")
            sParValues(6) = sProjInfo
        End If
        'False Northing
        xmlNlist = xmlSpRefDoc.SelectNodes("/mercator/fnorth")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Northing")
            sParValues(7) = sProjInfo
        End If

        'retrieve Standard Parallel
        xmlNlist = xmlSpRefDoc.SelectNodes("/mercator/stdparll")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(iLoop).OuterXml
            openStdParallel(sProjInfo)
            sParValues(2) = sProjInfo
            Return
        End If
        ' OR retrieve Scale Factor at Equator
        xmlNlist = xmlSpRefDoc.SelectNodes("/mercator/sfequat")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openScaleEquator(sProjInfo)
            sParValues(8) = sProjInfo
        End If
    End Sub

    Private Sub openModAlaska(ByVal sModAlaska As String, ByRef sParValues() As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim sProjInfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0

        xmlSpRefDoc.LoadXml(sModAlaska)

        'False Easting
        xmlNlist = xmlSpRefDoc.SelectNodes("/modsak/feast")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Easting")
            sParValues(6) = sProjInfo
        End If
        'False Northing
        xmlNlist = xmlSpRefDoc.SelectNodes("/modsak/fnorth")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Northing")
            sParValues(7) = sProjInfo
        End If
    End Sub

    Private Sub openMiller(ByVal sMiller As String, ByRef sParValues() As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim sProjInfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0

        xmlSpRefDoc.LoadXml(sMiller)

        'Longitude of Central Meridian
        xmlNlist = xmlSpRefDoc.SelectNodes("/miller/longcm")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openLongCentMerid(sProjInfo)
            sParValues(4) = sProjInfo
        End If
        'False Easting
        xmlNlist = xmlSpRefDoc.SelectNodes("/miller/feast")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Easting")
            sParValues(6) = sProjInfo
        End If
        'False Northing
        xmlNlist = xmlSpRefDoc.SelectNodes("/miller/fnorth")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Northing")
            sParValues(7) = sProjInfo
        End If
    End Sub

    Private Sub openObqMercator(ByVal sMercator As String, ByRef sParValues() As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim sProjInfo As String = ""
        Dim sVal1(2) As String
        Dim sVal2(2) As String
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0

        xmlSpRefDoc.LoadXml(sMercator)

        'Scale Factor at Center Line
        xmlNlist = xmlSpRefDoc.SelectNodes("/obqmerc/sfctrlin")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openScaleCentLine(sProjInfo)
            sParValues(12) = sProjInfo
        End If
        'Latitude of Projection Origin
        xmlNlist = xmlSpRefDoc.SelectNodes("obqmerc/latprjo")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openLatProjOrig(sProjInfo)
            sParValues(5) = sProjInfo
        End If
        'False Easting
        xmlNlist = xmlSpRefDoc.SelectNodes("/obqmerc/feast")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Easting")
            sParValues(6) = sProjInfo
        End If
        'False Northing
        xmlNlist = xmlSpRefDoc.SelectNodes("/obqmerc/fnorth")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Northing")
            sParValues(7) = sProjInfo
        End If

        'Oblique Line Azimuth
        xmlNlist = xmlSpRefDoc.SelectNodes("/obqmerc/obqlazim")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(iLoop).OuterXml
            openObqAzimuth(sProjInfo, sVal1(0), sVal1(1))
            sParValues(13) = sVal1(0)
            sParValues(14) = sVal1(1)
            Return
        End If
        'OR Oblique Line Point
        xmlNlist = xmlSpRefDoc.SelectNodes("/obqmerc/obqlpt")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openObqLinePt(sProjInfo, sVal1, sVal2)
            sParValues(15) = sVal1(0) 'Oblique Line Latitude 1
            sParValues(16) = sVal2(0) 'Oblique Line Longitude 1
            sParValues(17) = sVal1(1) 'Oblique Line Latitude 2
            sParValues(18) = sVal2(1) 'Oblique Line Longitude 2
        End If
    End Sub

    Private Sub openPolarStereo(ByVal sPolar As String, ByRef sParValues() As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim sProjInfo As String = ""
        Dim iCount As Integer = 0

        xmlSpRefDoc.LoadXml(sPolar)

        'Straight Vertical Longitude
        xmlNlist = xmlSpRefDoc.SelectNodes("/polarst/svlong")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openStraightLongPole(sProjInfo)
            sParValues(19) = sProjInfo
        End If
        'False Easting
        xmlNlist = xmlSpRefDoc.SelectNodes("/polarst/feast")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Easting")
            sParValues(6) = sProjInfo
        End If
        'False Northing
        xmlNlist = xmlSpRefDoc.SelectNodes("/polarst/fnorth")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Northing")
            sParValues(7) = sProjInfo
        End If

        'Standard Parallel
        xmlNlist = xmlSpRefDoc.SelectNodes("polarst/stdparll")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openStdParallel(sProjInfo)
            sParValues(2) = sProjInfo
            Return
        End If
        'OR Scale Factor at Projection Origin
        xmlNlist = xmlSpRefDoc.SelectNodes("/polarst/sfprjorg")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openScaleProjOrig(sProjInfo)
            sParValues(20) = sProjInfo
        End If
    End Sub

    Private Sub openSpaceMercator(ByVal sMercator As String, ByRef sParValues() As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim sProjInfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0

        xmlSpRefDoc.LoadXml(sMercator)

        'Landsat Number
        xmlNlist = xmlSpRefDoc.SelectNodes("/spaceobq/landsat")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openLandsat(sProjInfo)
            sParValues(21) = sProjInfo
        End If
        'Path Number
        xmlNlist = xmlSpRefDoc.SelectNodes("/spaceobq/pathnum")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openPathNumber(sProjInfo)
            sParValues(22) = sProjInfo
        End If
        'False Easting
        xmlNlist = xmlSpRefDoc.SelectNodes("/spaceobq/feast")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Easting")
            sParValues(6) = sProjInfo
        End If
        'False Northing
        xmlNlist = xmlSpRefDoc.SelectNodes("/spaceobq/fnorth")
        If (xmlNlist.Count > 0) Then
            sProjInfo = xmlNlist(0).OuterXml
            openEastNorth(sProjInfo, "Northing")
            sParValues(7) = sProjInfo
        End If
    End Sub

    Private Sub openStdParallel(ByRef sParallel As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        sTitle = "Retrieval of Map Projection parameters"
        xmlSpRefDoc.LoadXml(sParallel)
        s1 = xmlSpRefDoc.SelectSingleNode("stdparll").InnerText.Trim

        'check to make sure value is real number between -90 and 90
        realCheck(s1, rVal, bReal)
        If (bReal = True) Then
            If (rVal > 90.0) Then
                sError = "Standard parallel of " & s1 & " exceeds maximum of 90.0." & CrLf
                sError += "Value truncated to 90.0"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sParallel = "90.0"
            ElseIf (rVal < -90.0) Then
                sError = "Standard parallel of " & s1 & " exceeds minimum of -90.0." & CrLf
                sError += "Value truncated to -90.0"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sParallel = "-90.0"
            Else
                'satisfactory value
                sParallel = s1
            End If
        Else
            sError = "Standard parallel of " & s1 & " could not be converted to a number."
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            sParallel = ""
        End If
    End Sub

    Private Sub openLongCentMerid(ByRef sMerid As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        sTitle = "Retrieval of Map Projection parameters"
        xmlSpRefDoc.LoadXml(sMerid)
        s1 = xmlSpRefDoc.SelectSingleNode("longcm").InnerText.Trim

        'check to make sure value is real number between -180 and 180
        realCheck(s1, rVal, bReal)
        If (bReal = True) Then
            If (rVal >= 180.0) Then
                sError = "Longitude of Central Meridian of " & s1 & " exceeds maximum of 180.0." & CrLf
                sError += "Value truncated to 179.99999"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sMerid = "179.99999"
            ElseIf (rVal < -180.0) Then
                sError = "Longitude of Central Meridian of " & s1 & " exceeds minimum of -180.0." & CrLf
                sError += "Value truncated to -180.0"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sMerid = "-180.0"
            Else
                'satisfactory value
                sMerid = s1
            End If
        Else
            sError = "Longitude of Central Meridian of " & s1 & " could not be converted to a number."
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            sMerid = ""
        End If
    End Sub

    Private Sub openLatProjOrig(ByRef sParallel As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        sTitle = "Retrieval of Map Projection parameters"
        xmlSpRefDoc.LoadXml(sParallel)
        s1 = xmlSpRefDoc.SelectSingleNode("latprjo").InnerText.Trim

        'check to make sure value is real number between -90 and 90
        realCheck(s1, rVal, bReal)
        If (bReal = True) Then
            If (rVal > 90.0) Then
                sError = "Latitude of Projection Origin of " & s1 & " exceeds maximum of 90.0." & CrLf
                sError += "Value truncated to 90.0"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sParallel = "90.0"
            ElseIf (rVal < -90.0) Then
                sError = "Latitude of Projection Origin of " & s1 & " exceeds minimum of -90.0." & CrLf
                sError += "Value truncated to -90.0"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sParallel = "-90.0"
            Else
                'satisfactory value
                sParallel = s1
            End If
        Else
            sError = "Latitude of Projection Origin of " & s1 & " could not be converted to a number."
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            sParallel = ""
        End If
    End Sub

    Private Sub openEastNorth(ByRef sRealVal As String, ByVal sDir As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        s1 = ""
        sTitle = "Retrieval of Map Projection parameters"
        xmlSpRefDoc.LoadXml(sRealVal)
        Select Case sDir
            Case "Easting"
                s1 = xmlSpRefDoc.SelectSingleNode("feast").InnerText.Trim
            Case "Northing"
                s1 = xmlSpRefDoc.SelectSingleNode("fnorth").InnerText.Trim
        End Select

        'check to make sure value is real number between -500,000,000 and 500,000,000
        realCheck(s1, rVal, bReal)
        If (bReal = True) Then
            If (rVal > 500000000.0) Then
                sError = "False " & sDir & " of " & s1 & " exceeds maximum of 500,000,000.0." & CrLf
                sError += "Value truncated to 500,000,000.0"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sRealVal = "500000000.0"
            ElseIf (rVal < -500000000.0) Then
                sError = "False " & sDir & " of " & s1 & " exceeds minimum of -500,000,000.0." & CrLf
                sError += "Value truncated to -500,000,000.0"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sRealVal = "-5000000000.0"
            Else
                'satisfactory value
                sRealVal = s1
            End If
        Else
            sError = "False " & sDir & " of " & s1 & " could not be converted to a number."
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            sRealVal = ""
        End If
    End Sub

    Private Sub openHtPersPoint(ByRef sRealVal As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        s1 = ""
        sTitle = "Retrieval of Map Projection parameters"
        xmlSpRefDoc.LoadXml(sRealVal)
        s1 = xmlSpRefDoc.SelectSingleNode("heightpt").InnerText.Trim

        'check to make sure value is real number between -500,000,000 and 500,000,000
        realCheck(s1, rVal, bReal)
        If (bReal = True) Then
            If (rVal > 500000000.0) Then
                sError = "Height Above Perspective Point of " & s1 & " exceeds maximum of 500,000,000.0." & CrLf
                sError += "Value truncated to 500,000,000.0"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sRealVal = "500000000.0"
            ElseIf (rVal < -500000000.0) Then
                sError = "Height Above Perspective Point of " & s1 & " exceeds minimum of -500,000,000.0." & CrLf
                sError += "Value truncated to -500,000,000.0"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sRealVal = "-5000000000.0"
            Else
                'satisfactory value
                sRealVal = s1
            End If
        Else
            sError = "Height Above Perspective Point of " & s1 & " could not be converted to a number."
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            sRealVal = ""
        End If
    End Sub

    Private Sub openLongProjCent(ByRef sLongProjCent As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        sTitle = "Retrieval of Map Projection parameters"
        xmlSpRefDoc.LoadXml(sLongProjCent)
        s1 = xmlSpRefDoc.SelectSingleNode("longpc").InnerText.Trim

        'check to make sure value is real number between -180 and 180
        realCheck(s1, rVal, bReal)
        If (bReal = True) Then
            If (rVal >= 180.0) Then
                sError = "Longitude of Projection Center of " & s1 & " exceeds maximum of 180.0." & CrLf
                sError += "Value truncated to 179.99999"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sLongProjCent = "179.99999"
            ElseIf (rVal < -180.0) Then
                sError = "Longitude of Projection Center of " & s1 & " exceeds minimum of -180.0." & CrLf
                sError += "Value truncated to -180.0"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sLongProjCent = "-180.0"
            Else
                'satisfactory value
                sLongProjCent = s1
            End If
        Else
            sError = "Longitude of Projection Center of " & s1 & " could not be converted to a number."
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            sLongProjCent = ""
        End If
    End Sub

    Private Sub openLatProjCent(ByRef sParallel As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        sTitle = "Retrieval of Map Projection parameters"
        xmlSpRefDoc.LoadXml(sParallel)
        s1 = xmlSpRefDoc.SelectSingleNode("latprjc").InnerText.Trim

        'check to make sure value is real number between -90 and 90
        realCheck(s1, rVal, bReal)
        If (bReal = True) Then
            If (rVal > 90.0) Then
                sError = "Latitude of Projection Center of " & s1 & " exceeds maximum of 90.0." & CrLf
                sError += "Value truncated to 90.0"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sParallel = "90.0"
            ElseIf (rVal < -90.0) Then
                sError = "Latitude of Projection Center of " & s1 & " exceeds minimum of -90.0." & CrLf
                sError += "Value truncated to -90.0"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sParallel = "-90.0"
            Else
                'satisfactory value
                sParallel = s1
            End If
        Else
            sError = "Latitude of Projection Center of " & s1 & " could not be converted to a number."
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            sParallel = ""
        End If
    End Sub

    Private Sub openScaleEquator(ByRef sRealVal As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        s1 = ""
        sTitle = "Retrieval of Map Projection parameters"
        xmlSpRefDoc.LoadXml(sRealVal)
        s1 = xmlSpRefDoc.SelectSingleNode("sfequat").InnerText.Trim

        'check to make sure value is real number between 0 and 500
        realCheck(s1, rVal, bReal)
        If (bReal = True) Then
            If (rVal > 500.0) Then
                sError = "Scale Factor at Equator of " & s1 & " exceeds maximum of 500.0." & CrLf
                sError += "Value truncated to 500.0"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sRealVal = "500.0"
            ElseIf (rVal < 0.0) Then
                sError = "Scale Factor at Equator of " & s1 & " < 0.0." & CrLf
                sError += "Value ignored."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sRealVal = ""
            Else
                'satisfactory value
                sRealVal = s1
            End If
        Else
            sError = "Scale Factor at Equator of " & s1 & " could not be converted to a number."
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            sRealVal = ""
        End If
    End Sub

    Private Sub openScaleCentLine(ByRef sRealVal As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        s1 = ""
        sTitle = "Retrieval of Map Projection parameters"
        xmlSpRefDoc.LoadXml(sRealVal)
        s1 = xmlSpRefDoc.SelectSingleNode("sfctrlin").InnerText.Trim

        'check to make sure value is real number between 0 and 500
        realCheck(s1, rVal, bReal)
        If (bReal = True) Then
            If (rVal > 500.0) Then
                sError = "Scale Factor at Center Line of " & s1 & " exceeds maximum of 500.0." & CrLf
                sError += "Value truncated to 500.0"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sRealVal = "500.0"
            ElseIf (rVal < 0.0) Then
                sError = "Scale Factor at Center Line of " & s1 & " < 0.0." & CrLf
                sError += "Value ignored."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sRealVal = ""
            Else
                'satisfactory value
                sRealVal = s1
            End If
        Else
            sError = "Scale Factor at Center Line of " & s1 & " could not be converted to a number."
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            sRealVal = ""
        End If
    End Sub

    Private Sub openObqAzimuth(ByVal sAzimuth As String, ByRef sAngle As String, ByRef sLong As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        sTitle = "Retrieval of Map Projection parameters"
        xmlSpRefDoc.LoadXml(sAzimuth)
        sAngle = ""
        sLong = ""

        'Azimuthal Angle
        xmlNlist = xmlSpRefDoc.SelectNodes("/obqlazim/azimangl")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            'check to make sure value is real number between 0 and 360
            realCheck(s1, rVal, bReal)
            If (bReal = True) Then
                If (rVal >= 360.0) Then
                    sError = "Azimuthal Angle of " & s1 & " exceeds maximum of 360.0." & CrLf
                    sError += "Value truncated to 359.99999"
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    sAngle = "359.99999"
                ElseIf (rVal < 0.0) Then
                    sError = "Azimuthal Angle of " & s1 & " < 0.0." & CrLf
                    sError += "Value ignored."
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    sAngle = ""
                Else
                    'satisfactory value
                    sAngle = s1
                End If
            Else
                sError = "Azimuthal Angle of " & s1 & " could not be converted to a number."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sAngle = ""
            End If
        End If
        'Azimuth Measure Point Longitude
        xmlNlist = xmlSpRefDoc.SelectNodes("/obqlazim/azimptl")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            'check to make sure value is real number between -180 and 180
            realCheck(s1, rVal, bReal)
            If (bReal = True) Then
                If (rVal >= 180.0) Then
                    sError = "Azimuth Measure Point Longitude of " & s1 & " exceeds maximum of 180.0." & CrLf
                    sError += "Value truncated to 179.99999"
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    sLong = "179.99999"
                ElseIf (rVal < -180.0) Then
                    sError = "Azimuth Measure Point Longitude of " & s1 & " exceeds minimum of -180.0." & CrLf
                    sError += "Value truncated to -180.0"
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    sLong = "-180.0"
                Else
                    'satisfactory value
                    sLong = s1
                End If
            Else
                sError = "Azimuth Measure Point Longitude of " & s1 & " could not be converted to a number."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sLong = ""
            End If
        End If
    End Sub

    Private Sub openObqLinePt(ByVal sLinePt As String, ByRef sLat() As String, ByRef sLong() As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        sTitle = "Retrieval of Map Projection parameters"
        xmlSpRefDoc.LoadXml(sLinePt)
        'initialize return variables
        sLat(0) = "" : sLat(1) = ""
        sLong(0) = "" : sLong(1) = ""

        'Oblique Line Latitudes
        xmlNlist = xmlSpRefDoc.SelectNodes("/obqlpt/obqllat")
        iCount = xmlNlist.Count - 1
        If (iCount > 1) Then iCount = 1 'only 2 latitudes maximum
        For iLoop = 0 To iCount
            s1 = xmlNlist(iLoop).InnerText.Trim
            'check to make sure value is real number between -90 and 90
            realCheck(s1, rVal, bReal)
            If (bReal = True) Then
                If (rVal > 90.0) Then
                    sError = "Oblique Line Latitude of " & s1 & " exceeds maximum of 90.0." & CrLf
                    sError += "Value truncated to 90.0"
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    sLat(iLoop) = "90.0"
                ElseIf (rVal < -90.0) Then
                    sError = "Oblique Line Latitude of " & s1 & " exceeds minimum of -90.0." & CrLf
                    sError += "Value truncated to -90.0"
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    sLat(iLoop) = "-90.0"
                Else
                    'satisfactory value
                    sLat(iLoop) = s1
                End If
            Else
                sError = "Oblique Line Latitude of " & s1 & " could not be converted to a number."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sLat(iLoop) = ""
            End If
        Next
        'Oblique Line Longitude
        xmlNlist = xmlSpRefDoc.SelectNodes("/obqlpt/obqllong")
        iCount = xmlNlist.Count - 1
        If (iCount > 1) Then iCount = 1 'only 2 longitudes maximum
        For iLoop = 0 To iCount
            s1 = xmlNlist(iLoop).InnerText.Trim
            'check to make sure value is real number between -180 and 180
            realCheck(s1, rVal, bReal)
            If (bReal = True) Then
                If (rVal >= 180.0) Then
                    sError = "Oblique Line Longitude of " & s1 & " exceeds maximum of 180.0." & CrLf
                    sError += "Value truncated to 179.99999"
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    sLong(iLoop) = "179.99999"
                ElseIf (rVal < -180.0) Then
                    sError = "Oblique Line Longitude of " & s1 & " exceeds minimum of -180.0." & CrLf
                    sError += "Value truncated to -180.0"
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    sLong(iLoop) = "-180.0"
                Else
                    'satisfactory value
                    sLong(iLoop) = s1
                End If
            Else
                sError = "Oblique Line Longitude of " & s1 & " could not be converted to a number."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sLong(iLoop) = ""
            End If
        Next
    End Sub

    Private Sub openStraightLongPole(ByRef sPole As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        sTitle = "Retrieval of Map Projection parameters"
        xmlSpRefDoc.LoadXml(sPole)
        s1 = xmlSpRefDoc.SelectSingleNode("svlong").InnerText.Trim

        'check to make sure value is real number between -180 and 180
        realCheck(s1, rVal, bReal)
        If (bReal = True) Then
            If (rVal >= 180.0) Then
                sError = "Straight Vertical Longitude from Pole of " & s1 & " exceeds maximum of 180.0." & CrLf
                sError += "Value truncated to 179.99999"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sPole = "179.99999"
            ElseIf (rVal < -180.0) Then
                sError = "Straight Vertical Longitude from Pole of " & s1 & " exceeds minimum of -180.0." & CrLf
                sError += "Value truncated to -180.0"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sPole = "-180.0"
            Else
                'satisfactory value
                sPole = s1
            End If
        Else
            sError = "Straight Vertical Longitude from Pole of " & s1 & " could not be converted to a number."
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            sPole = ""
        End If
    End Sub

    Private Sub openScaleProjOrig(ByRef sRealVal As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        s1 = ""
        sTitle = "Retrieval of Map Projection parameters"
        xmlSpRefDoc.LoadXml(sRealVal)
        s1 = xmlSpRefDoc.SelectSingleNode("sfprjorg").InnerText.Trim

        'check to make sure value is real number between 0 and 500
        realCheck(s1, rVal, bReal)
        If (bReal = True) Then
            If (rVal > 500.0) Then
                sError = "Scale Factor at Projection Origin of " & s1 & " exceeds maximum of 500.0." & CrLf
                sError += "Value truncated to 500.0"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sRealVal = "500.0"
            ElseIf (rVal < 0.0) Then
                sError = "Scale Factor at Projection Origin of " & s1 & " < 0.0." & CrLf
                sError += "Value ignored."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sRealVal = ""
            Else
                'satisfactory value
                sRealVal = s1
            End If
        Else
            sError = "Scale Factor at Projection Origin of " & s1 & " could not be converted to a number."
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            sRealVal = ""
        End If
    End Sub

    Private Sub openLandsat(ByRef sIntegerVal As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim iVal As Integer = 0
        Dim bCheck As Boolean = False

        s1 = ""
        sTitle = "Retrieval of Map Projection parameters"
        xmlSpRefDoc.LoadXml(sIntegerVal)
        s1 = xmlSpRefDoc.SelectSingleNode("landsat").InnerText.Trim

        'check to make sure value is integer number between 0 and 50
        chkInteger(s1, iVal, bCheck)
        If (bCheck = True) Then
            If (iVal > 50) Then
                sError = "Landsat of " & s1 & " exceeds maximum of 50." & CrLf
                sError += "Value truncated to 50."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sIntegerVal = "50"
            ElseIf (iVal < 0) Then
                sError = "Landsat of " & s1 & " is < 0." & CrLf
                sError += "Value truncated to 0."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sIntegerVal = "0"
            Else
                'satisfactory value
                sIntegerVal = s1
            End If
        Else
            sError = "Landsat of " & s1 & " could not be converted to a number."
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            sIntegerVal = ""
        End If
    End Sub

    Private Sub openPathNumber(ByRef sIntegerVal As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim iVal As Integer = 0
        Dim bCheck As Boolean = False

        s1 = ""
        sTitle = "Retrieval of Map Projection parameters"
        xmlSpRefDoc.LoadXml(sIntegerVal)
        s1 = xmlSpRefDoc.SelectSingleNode("pathnum").InnerText.Trim

        'check to make sure value is integer number between 0 and 500
        chkInteger(s1, iVal, bCheck)
        If (bCheck = True) Then
            If (iVal > 50) Then
                sError = "Path Number of " & s1 & " exceeds maximum of 500." & CrLf
                sError += "Value truncated to 500."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sIntegerVal = "500"
            ElseIf (iVal < 0) Then
                sError = "Path Number of " & s1 & " is < 0." & CrLf
                sError += "Value truncated to 0."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sIntegerVal = "0"
            Else
                'satisfactory value
                sIntegerVal = s1
            End If
        Else
            sError = "Path Number of " & s1 & " could not be converted to a number."
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            sIntegerVal = ""
        End If
    End Sub

    Private Sub openScaleCentMerid(ByRef sRealVal As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        s1 = ""
        sTitle = "Retrieval of Map Projection parameters"
        xmlSpRefDoc.LoadXml(sRealVal)
        s1 = xmlSpRefDoc.SelectSingleNode("sfctrmer").InnerText.Trim

        'check to make sure value is real number between 0 and 500
        realCheck(s1, rVal, bReal)
        If (bReal = True) Then
            If (rVal > 500.0) Then
                sError = "Scale Factor at Center Meridian of " & s1 & " exceeds maximum of 500.0." & CrLf
                sError += "Value truncated to 500.0"
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sRealVal = "500.0"
            ElseIf (rVal < 0.0) Then
                sError = "Scale Factor at Center Meridian of " & s1 & " < 0.0." & CrLf
                sError += "Value ignored."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sRealVal = ""
            Else
                'satisfactory value
                sRealVal = s1
            End If
        Else
            sError = "Scale Factor at Center Meridian of " & s1 & " could not be converted to a number."
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            sRealVal = ""
        End If
    End Sub

    Private Sub openSRplanarGrid(ByVal sPlanar As String, ByRef oPlanar As PlanarClass)
        'retrieve Grid Coordinate System
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim sParArray(29) As String 'map projection parameter array
        Dim sProjInfo As String = ""
        Dim s1 As String = ""
        Dim iSelIndex As Integer = 0
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim i1 As Integer = 0
        Dim i2 As Integer = 0
        Dim i3 As Integer = 0
        Dim i4 As Integer = 0
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        xmlSpRefDoc.LoadXml(sPlanar)
        sTitle = "Spatial Reference error"

        'retrieve Grid System Name
        xmlNlist = xmlSpRefDoc.SelectNodes("/gridsys/gridsysn")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            oPlanar.GridSys = True
            oPlanar.GridName = s1
            sParArray(0) = s1
        Else
            Return
        End If

        'retrieve Map Projection parameter info using type in s1
        'begin grid systems
        Select Case s1
            Case "Universal Transverse Mercator"
                xmlNlist = xmlSpRefDoc.SelectNodes("/gridsys/utm")
                If (xmlNlist.Count > 0) Then
                    'UTM Zone Number
                    xmlPlist = xmlNlist(0).SelectNodes("utmzone")
                    If (xmlPlist.Count > 0) Then
                        sProjInfo = xmlPlist(0).OuterXml
                        openUTMzone(sProjInfo)
                        sParArray(24) = sProjInfo
                    End If
                    'Transverse Mercator
                    xmlPlist = xmlNlist(0).SelectNodes("transmer")
                    If (xmlPlist.Count > 0) Then
                        sProjInfo = xmlPlist(0).OuterXml
                        openAziEqui(sProjInfo, sParArray, "transmer")
                    End If
                End If
            Case "Universal Polar Stereographic"
                xmlNlist = xmlSpRefDoc.SelectNodes("/gridsys/ups")
                If (xmlNlist.Count > 0) Then
                    'UPS Zone Identifier
                    xmlPlist = xmlNlist(0).SelectNodes("upszone")
                    If (xmlPlist.Count > 0) Then
                        s1 = xmlPlist(0).InnerText.Trim
                        If (s1 = "A" Or s1 = "B" Or s1 = "Y" Or s1 = "Z") Then
                            sParArray(25) = s1
                        Else
                            sParArray(25) = ""
                        End If
                    End If
                    'Polar Stereographic
                    xmlPlist = xmlNlist(0).SelectNodes("polarst")
                    If (xmlPlist.Count > 0) Then
                        sProjInfo = xmlPlist(0).OuterXml
                        openPolarStereo(sProjInfo, sParArray)
                    End If
                End If
            Case "State Plane Coordinate System 1927", "State Plane Coordinate System 1983"
                xmlNlist = xmlSpRefDoc.SelectNodes("/gridsys/spcs")
                If (xmlNlist.Count > 0) Then
                    'SPCS Zone Identifier
                    xmlPlist = xmlNlist(0).SelectNodes("spcszone")
                    If (xmlPlist.Count > 0) Then
                        sProjInfo = xmlPlist(0).OuterXml
                        openSPCSzone(sProjInfo)
                        sParArray(26) = sProjInfo
                    End If
                    'select 1 of 4 possible projections
                    xmlPlist = xmlNlist(0).SelectNodes("lambertc")
                    i1 = xmlPlist.Count
                    If (i1 > 0) Then
                        sProjInfo = xmlPlist(0).OuterXml
                        openAlbers(sProjInfo, sParArray, "lambertc")
                        sParArray(1) = "Lambert Conformal Conic"
                    Else
                        xmlPlist = xmlNlist(0).SelectNodes("transmer")
                        i2 = xmlPlist.Count
                        If (i2 > 0) Then
                            sProjInfo = xmlPlist(0).OuterXml
                            openAziEqui(sProjInfo, sParArray, "transmer")
                            sParArray(1) = "Transverse Mercator"
                        Else
                            xmlPlist = xmlNlist(0).SelectNodes("obqmerc")
                            i3 = xmlPlist.Count
                            If (i3 > 0) Then
                                sProjInfo = xmlPlist(0).OuterXml
                                openObqMercator(sProjInfo, sParArray)
                                sParArray(1) = "Oblique Mercator"
                            Else
                                xmlPlist = xmlNlist(0).SelectNodes("polycon")
                                i4 = xmlPlist.Count
                                If (i4 > 0) Then
                                    sProjInfo = xmlPlist(0).OuterXml
                                    openAziEqui(sProjInfo, sParArray, "polycon")
                                    sParArray(1) = "Polyconic"
                                End If
                            End If
                        End If
                    End If
                End If
            Case "ARC Coordinate System"
                xmlNlist = xmlSpRefDoc.SelectNodes("/gridsys/arcsys")
                If (xmlNlist.Count > 0) Then
                    'ARC System Zone Identifier
                    xmlPlist = xmlNlist(0).SelectNodes("arczone")
                    If (xmlPlist.Count > 0) Then
                        sProjInfo = xmlPlist(0).OuterXml
                        openARCzone(sProjInfo)
                        sParArray(27) = sProjInfo
                    End If
                    'select 1 of 2 possible projections
                    xmlPlist = xmlNlist(0).SelectNodes("equirect")
                    i1 = xmlPlist.Count
                    If (i1 > 0) Then
                        sProjInfo = xmlPlist(0).OuterXml
                        openEquiRect(sProjInfo, sParArray)
                        sParArray(1) = "Equirectangular"
                    Else
                        xmlPlist = xmlNlist(0).SelectNodes("azimequi")
                        i2 = xmlPlist.Count
                        If (i2 > 0) Then
                            sProjInfo = xmlPlist(0).OuterXml
                            openAziEqui(sProjInfo, sParArray, "azimequi")
                            sParArray(1) = "Azimuthal Equidistant"
                        End If
                    End If
                End If
            Case "other grid system"
                xmlNlist = xmlSpRefDoc.SelectNodes("/gridsys/othergrd")
                If (xmlNlist.Count > 0) Then
                    'Other Grid System Definition
                    sParArray(28) = xmlNlist(0).InnerText.Trim
                End If
        End Select

        'update the parameter values
        iCount = 28
        For iLoop = 0 To iCount
            oPlanar.setParam(iLoop, sParArray(iLoop))
        Next
    End Sub

    Private Sub openUTMzone(ByRef sIntegerVal As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim iVal As Integer = 0
        Dim bCheck As Boolean = False

        s1 = ""
        sTitle = "Retrieval of Map Projection parameters"
        xmlSpRefDoc.LoadXml(sIntegerVal)
        s1 = xmlSpRefDoc.SelectSingleNode("utmzone").InnerText.Trim

        'check to make sure value is integer number between -60 and 60
        chkInteger(s1, iVal, bCheck)
        If (bCheck = True) Then
            If (iVal > 60) Then
                sError = "UTM Zone Number of " & s1 & " exceeds maximum of 60." & CrLf
                sError += "Value truncated to 60."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sIntegerVal = "60"
            ElseIf (iVal < -60) Then
                sError = "UTM Zone Number of " & s1 & " below minimum of -60." & CrLf
                sError += "Value truncated to -60."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sIntegerVal = "0"
            Else
                'satisfactory value
                sIntegerVal = s1
            End If
        Else
            sError = "UTM Zone Number of " & s1 & " could not be converted to a number."
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            sIntegerVal = ""
        End If
    End Sub

    Private Sub openSPCSzone(ByRef sIntegerVal As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim iVal As Integer = 0
        Dim bCheck As Boolean = False

        s1 = ""
        sTitle = "Retrieval of Map Projection parameters"
        xmlSpRefDoc.LoadXml(sIntegerVal)
        s1 = xmlSpRefDoc.SelectSingleNode("spcszone").InnerText.Trim

        'check to make sure the string length is 4
        If (s1.Length = 4) Then
            'continue processing
        ElseIf (s1.Length < 4) Then
            sError = "SPCS Zone Identifier " & s1 & " is too short; it needs a 4 digit identifier." & CrLf
            sError += "Value left blank."
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            sIntegerVal = ""
            Return
        Else
            sError = "SPCS Zone Identifier " & s1 & " contains characters besides the expected 4 digit identifier." & CrLf
            sError += "Value left blank."
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            sIntegerVal = ""
            Return
        End If

        'check to make sure value is integer number between 0 and 9999
        chkInteger(s1, iVal, bCheck)
        If (bCheck = True) Then
            If (iVal > 9999) Then ' this should not ever happen because of 4-character limit
                sError = "SPCS Zone Identifier " & s1 & " exceeds maximum of 9999." & CrLf
                sError += "Value truncated to 9999."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sIntegerVal = "9999"
            ElseIf (iVal < 0) Then
                sError = "SPCS Zone Identifier " & s1 & " below minimum of 0." & CrLf
                sError += "Value left blank."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sIntegerVal = ""
            Else
                'satisfactory value
                sIntegerVal = s1
            End If
        Else
            sError = "SPCS Zone Identifier " & s1 & " could not be converted to a number." & CrLf
            sError += "Value left blank."
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            sIntegerVal = ""
        End If
    End Sub

    Private Sub openARCzone(ByRef sIntegerVal As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim iVal As Integer = 0
        Dim bCheck As Boolean = False

        s1 = ""
        sTitle = "Retrieval of Map Projection parameters"
        xmlSpRefDoc.LoadXml(sIntegerVal)
        s1 = xmlSpRefDoc.SelectSingleNode("arczone").InnerText.Trim

        'check to make sure value is integer number between 1 and 18
        chkInteger(s1, iVal, bCheck)
        If (bCheck = True) Then
            If (iVal > 18) Then
                sError = "ARC System Zone Idenfier " & s1 & " exceeds maximum of 18." & CrLf
                sError += "Value set to 18."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sIntegerVal = "18"
            ElseIf (iVal < 1) Then
                sError = "ARC System Zone Idenfier " & s1 & " below minimum of 1." & CrLf
                sError += "Value set to 1."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                sIntegerVal = "1"
            Else
                'satisfactory value
                sIntegerVal = s1
            End If
        Else
            sError = "ARC System Zone Idenfier " & s1 & " could not be converted to a number."
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            sIntegerVal = ""
        End If
    End Sub

    Private Sub openSRplanarUpdate(ByVal oplanar As PlanarClass)
        Dim s1 As String = ""

        'update display list box
        If (oplanar.MapProj = True) Then
            s1 = "Map: " & oplanar.MapProjName
        ElseIf (oplanar.GridSys = True) Then
            s1 = "Grid: " & oplanar.GridName
            If (oplanar.GridName <> "other grid system") Then
                s1 += ", Projection: " & oplanar.GridProjName
            End If
        Else
            s1 = "Local Planar: " & Microsoft.VisualBasic.Left(oplanar.LocalDesc, 40)
        End If
        lboxPlanar.Items.Add(s1)

        'update the main collection
        cPlanar.Add(oplanar)
    End Sub

    Private Sub openSRgeodetic(ByVal sGeodetic As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim sList As String
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        xmlSpRefDoc.LoadXml(sGeodetic)
        sTitle = "Spatial Reference error"

        'retrieve Horizontal Datum Name
        xmlNlist = xmlSpRefDoc.SelectNodes("/geodetic/horizdn")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            If (s1 = "") Then
                'do nothing
            Else
                'put datum name into combo box display
                iCount = cboxHorizName.FindStringExact(s1)
                If (iCount = -1) Then
                    cboxHorizName.Items.Add(s1)
                    cboxHorizName.SelectedIndex = cboxHorizName.Items.Count - 1
                Else
                    cboxHorizName.SelectedIndex = iCount
                End If
            End If
        End If

        'retrieve Ellipsoid Name
        xmlNlist = xmlSpRefDoc.SelectNodes("/geodetic/ellips")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            If (s1 = "") Then
                'do nothing
            Else
                'put ellipsoid name into combo box display
                iCount = cboxEllipsoid.FindStringExact(s1)
                If (iCount = -1) Then
                    cboxEllipsoid.Items.Add(s1)
                    cboxEllipsoid.SelectedIndex = cboxEllipsoid.Items.Count - 1
                Else
                    cboxEllipsoid.SelectedIndex = iCount
                End If
            End If
        End If

        'retrieve Semi-major Axis
        xmlNlist = xmlSpRefDoc.SelectNodes("/geodetic/semiaxis")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(iLoop).InnerText.Trim
            realCheck(s1, rVal, bReal)
            If (bReal = True) Then
                If (rVal > 6500000.0) Then
                    sError = "Geodetic Model" & CrLf
                    sError += "Semi-major Axis, " & s1 & ", is too large for the control."
                    sError += "Value reduced to 6,500,000."
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    rVal = 6500000.0
                End If
                If (rVal >= 0.0) Then
                    numSemiMajor.Value = Convert.ToDecimal(rVal) 'place value into control
                Else
                    sError = "Geodetic Model" & CrLf
                    sError += "Semi-major Axis, " & s1 & ", less than 0. Value ignored."
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            Else
                sError = "Geodetic Model" & CrLf
                sError += "Semi-major Axis, " & s1 & ", could not be converted to a real number." & CrLf
                sError += "Value ignored."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If

        'retrieve Denominator of Flattening Ratio
        xmlNlist = xmlSpRefDoc.SelectNodes("/geodetic/denflat")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(iLoop).InnerText.Trim
            realCheck(s1, rVal, bReal)
            If (bReal = True) Then
                If (rVal > 400.0) Then
                    sError = "Geodetic Model" & CrLf
                    sError += "Denominator of Flattening Ratio, " & s1 & ", is too large for the control."
                    sError += "Value reduced to 400."
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    rVal = 400.0
                End If
                If (rVal >= 0.0) Then
                    numFlatten.Value = Convert.ToDecimal(rVal) 'place value into control
                Else
                    sError = "Geodetic Model" & CrLf
                    sError += "Denominator of Flattening Ratio, " & s1 & ", less than 0. Value ignored."
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            Else
                sError = "Geodetic Model" & CrLf
                sError += "Denominator of Flattening Ratio, " & s1 & ", could not be converted to a real number." & CrLf
                sError += "Value ignored."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If
    End Sub

    Private Sub openSRaltitude(ByVal sAltitude As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim sList As String
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        xmlSpRefDoc.LoadXml(sAltitude)
        sTitle = "Spatial Reference error"

        'retrieve Altitude Datum Name
        xmlNlist = xmlSpRefDoc.SelectNodes("/altsys/altdatum")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            If (s1 = "") Then
                'do nothing
            Else
                'put datum name into combo box display
                iCount = cboxAltDatum.FindStringExact(s1)
                If (iCount = -1) Then
                    cboxAltDatum.Items.Add(s1)
                    cboxAltDatum.SelectedIndex = cboxAltDatum.Items.Count - 1
                Else
                    cboxAltDatum.SelectedIndex = iCount
                End If
            End If
        End If

        'retrieve Altitude Resolution
        xmlNlist = xmlSpRefDoc.SelectNodes("/altsys/altres")
        iCount = xmlNlist.Count
        sList = ""
        For iLoop = 0 To iCount - 1
            s1 = xmlNlist(iLoop).InnerText.Trim
            realCheck(s1, rVal, bReal)
            If (bReal = True) Then
                If (rVal >= 0.0) Then
                    sList += s1 & sKdelim 'append new resolution to string
                Else
                    sError = "Altitude System Definition" & CrLf
                    sError += "Altitude Resolution, " & s1 & ", less than 0. Value ignored."
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            Else
                sError = "Altitude System Definition" & CrLf
                sError += "Altitude Resolution, " & s1 & ", could not be converted to a real number." & CrLf
                sError += "Value ignored."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        Next
        txtAltRes.Text = sList 'put collection of resolutions into text box

        'retrieve Altitude Distance Units
        xmlNlist = xmlSpRefDoc.SelectNodes("/altsys/altunits")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            If (s1 = "") Then
                'do nothing
            Else
                'put distance units into combo box display
                iCount = cboxAltUnits.FindStringExact(s1)
                If (iCount = -1) Then
                    cboxAltUnits.Items.Add(s1)
                    cboxAltUnits.SelectedIndex = cboxAltUnits.Items.Count - 1
                Else
                    cboxAltUnits.SelectedIndex = iCount
                End If
            End If
        End If

        'retrieve Altitude Encoding Method
        xmlNlist = xmlSpRefDoc.SelectNodes("/altsys/altenc")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            'select encoding method for combo box display
            iCount = cboxAltEncode.FindStringExact(s1)
            cboxAltEncode.SelectedIndex = iCount
        End If
    End Sub

    Private Sub openSRdepth(ByVal sDepth As String)
        Dim xmlSpRefDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim sList As String
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False

        xmlSpRefDoc.LoadXml(sDepth)
        sTitle = "Spatial Reference error"

        'retrieve Depth Datum Name
        xmlNlist = xmlSpRefDoc.SelectNodes("/depthsys/depthdn")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            If (s1 = "") Then
                'do nothing
            Else
                'put datum name into combo box display
                iCount = cboxDepthDatum.FindStringExact(s1)
                If (iCount = -1) Then
                    cboxDepthDatum.Items.Add(s1)
                    cboxDepthDatum.SelectedIndex = cboxDepthDatum.Items.Count - 1
                Else
                    cboxDepthDatum.SelectedIndex = iCount
                End If
            End If
        End If

        'retrieve Depth Resolution
        xmlNlist = xmlSpRefDoc.SelectNodes("/depthsys/depthres")
        iCount = xmlNlist.Count
        sList = ""
        For iLoop = 0 To iCount - 1
            s1 = xmlNlist(iLoop).InnerText.Trim
            realCheck(s1, rVal, bReal)
            If (bReal = True) Then
                If (rVal >= 0.0) Then
                    sList += s1 & sKdelim 'append new resolution to string
                Else
                    sError = "Depth System Definition" & CrLf
                    sError += "Depth Resolution, " & s1 & ", less than 0. Value ignored."
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            Else
                sError = "Depth System Definition" & CrLf
                sError += "Depth Resolution, " & s1 & ", could not be converted to a real number." & CrLf
                sError += "Value ignored."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        Next
        txtDepthRes.Text = sList 'put collection of resolutions into text box

        'retrieve Depth Distance Units
        xmlNlist = xmlSpRefDoc.SelectNodes("/depthsys/depthdu")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            If (s1 = "") Then
                'do nothing
            Else
                'put distance units into combo box display
                iCount = cboxDepthUnits.FindStringExact(s1)
                If (iCount = -1) Then
                    cboxDepthUnits.Items.Add(s1)
                    cboxDepthUnits.SelectedIndex = cboxDepthUnits.Items.Count - 1
                Else
                    cboxDepthUnits.SelectedIndex = iCount
                End If
            End If
        End If

        'retrieve Depth Encoding Method
        xmlNlist = xmlSpRefDoc.SelectNodes("/depthsys/depthem")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            'select encoding method for combo box display
            iCount = cboxDepthEncode.FindStringExact(s1)
            cboxDepthEncode.SelectedIndex = iCount
        End If
    End Sub

    Private Sub realCheck(ByVal s1 As String, ByRef rValue As Double, ByRef bTrans As Boolean)
        Try
            bTrans = True
            rValue = Convert.ToDouble(s1)
        Catch ex As Exception
            bTrans = False
            rValue = 0.0
        End Try
    End Sub


#End Region


#Region " DOM processing for Entity & Attribute Information section "

    Private Sub openEA(ByVal xmlOpenEA As XmlDocument)
        Dim xmlNlist As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim sEAinfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim kCount As Integer = 0
        Dim jCount As Integer = 0

        'retrieve Overview Description(s)
        xmlNlist = xmlOpenEA.SelectNodes("/eainfo/overview")
        iCount = xmlNlist.Count - 1
        For iLoop = 0 To iCount
            sEAinfo = xmlNlist(iLoop).OuterXml
            openEAover(sEAinfo)
        Next

        'retrieve Detailed Description(s)
        xmlNlist = xmlOpenEA.SelectNodes("/eainfo/detailed")
        iCount = xmlNlist.Count - 1
        For iLoop = 0 To iCount
            sEAinfo = xmlNlist(iLoop).OuterXml
            openEAdetail(sEAinfo)
        Next
        'set selected index for entities, attributes, and domains to 0
        If (cboxEntity.Items.Count > 0) Then cboxEntity.SelectedIndex = 0
        If (cboxAttrib.Items.Count > 0) Then cboxAttrib.SelectedIndex = 0
        If (cboxDomains.Items.Count > 0) Then cboxDomains.SelectedIndex = 0
    End Sub

    Private Sub openEAover(ByVal sOverview As String)
        Dim xmlEADoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim s1 As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim sList As String
        Dim oNewOver As New EAoverClass
        Dim sOverCite As New StringCollection

        xmlEADoc.LoadXml(sOverview)
        oNewOver = New EAoverClass
        sOverCite = New StringCollection

        'retrieve Entity & Attribute Overview
        xmlNlist = xmlEADoc.SelectNodes("/overview/eaover")
        If (xmlNlist.Count > 0) Then
            oNewOver.Overview = xmlNlist(0).InnerText.Trim
        End If

        'retrieve Entity & Attribute Detail Citation(s)
        xmlNlist = xmlEADoc.SelectNodes("/overview/eadetcit")
        iCount = xmlNlist.Count - 1
        For iLoop = 0 To iCount
            s1 = xmlNlist(iLoop).InnerText.Trim
            sOverCite.Add(s1)
        Next
        oNewOver.DetailCite = sOverCite 'put collection into object

        'update main overview collection and list box display
        cEAttrOver.Add(oNewOver)
        s1 = oNewOver.Overview
        s1 = Replace(s1, sKdelim, "  ")
        sList = Microsoft.VisualBasic.Left(s1, 80)
        lboxOverView.Items.Add(sList)
        Return
    End Sub

    Private Sub openEAdetail(ByVal sDetail As String)
        Dim xmlEADoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim sEAinfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim sList As String
        Dim oNewDetail As New EAdetailClass
        Dim cAttIndex As New Collection 'collection of index integers

        xmlEADoc.LoadXml(sDetail)
        oNewDetail = New EAdetailClass
        cAttIndex = New Collection

        'retrieve Entity Type
        xmlNlist = xmlEADoc.SelectNodes("/detailed/enttyp")
        If (xmlNlist.Count > 0) Then
            ' 1. retrieve Entity Type Label
            xmlPlist = xmlNlist(0).SelectNodes("enttypl")
            If (xmlPlist.Count > 0) Then
                oNewDetail.EntityLabel = xmlPlist(0).InnerText.Trim
            End If
            ' 2. retrieve Entity Type Definition
            xmlPlist = xmlNlist(0).SelectNodes("enttypd")
            If (xmlPlist.Count > 0) Then
                oNewDetail.EntityDef = xmlPlist(0).InnerText.Trim
            End If
            ' 3. retrieve Entity Type Definition Source
            xmlPlist = xmlNlist(0).SelectNodes("enttypds")
            If (xmlPlist.Count > 0) Then
                oNewDetail.DefSource = xmlPlist(0).InnerText.Trim
            End If
        End If

        'retrieve Attribute(s)
        xmlNlist = xmlEADoc.SelectNodes("/detailed/attr")
        iCount = xmlNlist.Count - 1
        For iLoop = 0 To iCount
            sEAinfo = xmlNlist(iLoop).OuterXml
            openEAattrib(sEAinfo, cAttIndex)
        Next
        oNewDetail.AttribColl = cAttIndex 'put index collection into object

        'update main detailed collection and list box display
        cEAentity.Add(oNewDetail) 'add new detailed description to collection
        sList = oNewDetail.EntityLabel
        cboxEntity.Items.Add(sList)  'add new detailed description to list box
        Return
    End Sub

    Private Sub openEAattrib(ByVal sAttrib As String, ByRef cAttIndex As Collection)
        Dim xmlEADoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim xmlEAnode As XmlNode
        Dim sEAinfo As String = ""
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim sList As String
        Dim bReal As Boolean = False
        Dim bReal2 As Boolean = False
        Dim rVal As Double = 0.0
        Dim oNewAttrib As New AttribClass
        Dim cDomIndex As New Collection 'collection of index values for Domain Values
        Dim sDateVals As New StringCollection

        xmlEADoc.LoadXml(sAttrib)
        oNewAttrib = New AttribClass
        cDomIndex = New Collection
        sDateVals = New StringCollection
        sTitle = "Entity & Attribute Information"

        'retrieve Attribute Label
        xmlNlist = xmlEADoc.SelectNodes("/attr/attrlabl")
        If (xmlNlist.Count > 0) Then
            oNewAttrib.Label = xmlNlist(0).InnerText.Trim
        End If

        'retrieve Attribute Definition
        xmlNlist = xmlEADoc.SelectNodes("/attr/attrdef")
        If (xmlNlist.Count > 0) Then
            oNewAttrib.Definition = xmlNlist(0).InnerText.Trim
        End If

        'retrieve Attribute Definition Source
        xmlNlist = xmlEADoc.SelectNodes("/attr/attrdefs")
        If (xmlNlist.Count > 0) Then
            oNewAttrib.DefSource = xmlNlist(0).InnerText.Trim
        End If

        'retrieve Attribute Domain Value(s)
        xmlNlist = xmlEADoc.SelectNodes("/attr/attrdomv")
        iCount = xmlNlist.Count - 1
        For iLoop = 0 To iCount
            sEAinfo = xmlNlist(iLoop).OuterXml
            openEAdomain(sEAinfo, cDomIndex)
        Next
        oNewAttrib.DomainValues = cDomIndex 'put collection into object

        'retrieve Dates of Attribute Values
        xmlNlist = xmlEADoc.SelectNodes("/attr/begdatea")
        iCount = xmlNlist.Count - 1
        For iLoop = 0 To iCount
            sError = "For " & oNewAttrib.Label & ":" & CrLf
            ' 1. retrieve Beginning Date
            s1 = xmlNlist(iLoop).InnerText.Trim
            evalDate(s1, bReal) 'checks for proper date structure
            If (bReal = True) Then
                ' 2. look for Ending Date of Attribute Values
                xmlEAnode = xmlNlist(iLoop).NextSibling
                If (xmlEAnode Is Nothing) Then
                    'there was no next sibling node; do nothing additional
                Else
                    'evaluate whether next sibling was an Ending Date node; process accordingly
                    If (xmlEAnode.Name = "enddatea") Then
                        s2 = xmlEAnode.InnerText.Trim
                        evalDate(s2, bReal2)
                        If (bReal2 = True) Then
                            s1 += sPdelim & s2
                        Else
                            sError += "Ending Date of Attribute Values of " & s1 & " is not in correct date format." & CrLf
                            sError += "Value ignored."
                            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        End If
                    End If
                End If
                sDateVals.Add(s1)
            Else
                sError += "Beginning Date of Attribute Values of " & s1 & " is not in correct date format." & CrLf
                sError += "Value ignored."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        Next
        If (sDateVals.Count > 0) Then
            oNewAttrib.ValueDates = sDateVals
        End If

        'retrieve Attribute Accuracy Information
        xmlNlist = xmlEADoc.SelectNodes("/attr/attrvai")
        If (xmlNlist.Count > 0) Then
            ' 1. retrieve Attribute Value Accuracy
            xmlPlist = xmlNlist(0).SelectNodes("attrva")
            If (xmlPlist.Count > 0) Then
                sError = "For " & oNewAttrib.Label & ":" & CrLf
                s1 = xmlPlist(0).InnerText.Trim
                realCheck(s1, rVal, bReal)
                If (bReal = True) Then
                    If (rVal > 100000.0) Then
                        sError += "Attribute Value Accuracy of " & s1 & " exceeds maximum of 100,000.0." & CrLf
                        sError += "Value truncated to 100,000.0"
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        rVal = 100000.0
                    ElseIf (rVal < -100000.0) Then
                        sError = "Attribute Value Accuracy of " & s1 & " < -100,000.0." & CrLf
                        sError += "Value truncated to -100,000.0."
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        rVal = -100000.0
                    Else
                        'satisfactory value
                    End If
                Else
                    sError = "Attribute Value Accuracy of " & s1 & " could not be converted to a number."
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    rVal = 0.0
                End If
                oNewAttrib.Accuracy = Convert.ToDecimal(rVal)
            End If
            ' 2. retrieve Attribute Value Accuracy Explanation
            xmlPlist = xmlNlist(0).SelectNodes("attrvae")
            If (xmlPlist.Count > 0) Then
                oNewAttrib.AccExplain = xmlPlist(0).InnerText.Trim
            End If
        End If

        'retrieve Attribute Measurement Frequency
        xmlNlist = xmlEADoc.SelectNodes("/attr/attrmfrq")
        If (xmlNlist.Count > 0) Then
            oNewAttrib.MeasureFreq = xmlNlist(0).InnerText.Trim
        End If

        'update main attribute collection and combo box display
        cEAttribs.Add(oNewAttrib) 'add the new attribute to collection
        cboxAttrib.Items.Add(oNewAttrib.Label)

        'add attribute index to collection
        iCount = cEAttribs.Count
        cAttIndex.Add(iCount)
        Return
    End Sub

    Private Sub openEAdomain(ByVal sDomain As String, ByRef cDomIndex As Collection)
        Dim xmlEADoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim sEAinfo As String = ""
        Dim s1 As String = ""
        Dim sTest As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim kCount As Integer = 0
        Dim kLoop As Integer = 0
        Dim sList As String
        Dim sCurDomType As String = ""
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False
        Dim oNewEnum As New AttribDomain_Enum
        Dim oNewRange As New AttribDomain_Range
        Dim cMoreAttribs As New Collection

        xmlEADoc.LoadXml(sDomain)
        oNewEnum = New AttribDomain_Enum
        oNewRange = New AttribDomain_Range
        cMoreAttribs = New Collection

        'retrieve Unrepresentable Domain
        xmlNlist = xmlEADoc.SelectNodes("/attrdomv/udom")
        If (xmlNlist.Count > 0) Then
            sCurDomType = "unrep"
            s1 = xmlNlist(0).InnerText.Trim
            'see if already exists in collection of Unrepresentable Domains
            iCount = cEAdomains.Count
            For iLoop = 1 To iCount
                If (cEAdomtype(iLoop) = sCurDomType) Then
                    sTest = CType(cEAdomains(iLoop), String)
                    If (s1 = sTest) Then
                        'domain value already present; place index into collection and return
                        cDomIndex.Add(iLoop)
                        Return
                    End If
                End If
            Next
            'process novel Unrepresentable Domain
            cEAdomains.Add(s1) 'put into main domain collection
            cEAdomtype.Add(sCurDomType) 'put type into its main collection
            sList = "Unrepresentable: " & s1
            cboxDomains.Items.Add(sList) 'update the combo box
            iCount = cEAdomains.Count
            cDomIndex.Add(iCount) 'update the index collection of domains
            Return
        End If

        'retrieve Codeset Domain
        xmlNlist = xmlEADoc.SelectNodes("/attrdomv/codesetd")
        If (xmlNlist.Count > 0) Then
            sCurDomType = "codeset"
            s1 = ""
            ' 1. retrieve the Codeset Name
            xmlPlist = xmlNlist(0).SelectNodes("codesetn")
            If (xmlPlist.Count > 0) Then
                s1 = xmlPlist(0).InnerText.Trim
                sList = s1
            End If
            ' 2. retrieve the Codeset Source
            xmlPlist = xmlNlist(0).SelectNodes("codesets")
            If (xmlPlist.Count > 0) Then
                s1 += sPdelim & xmlPlist(0).InnerText.Trim
            End If
            'see if already exists in collection of Unrepresentable Domains
            iCount = cEAdomains.Count
            For iLoop = 1 To iCount
                If (cEAdomtype(iLoop) = sCurDomType) Then
                    sTest = CType(cEAdomains(iLoop), String)
                    If (s1 = sTest) Then
                        'domain value already present; place index into collection and return
                        cDomIndex.Add(iLoop)
                        Return
                    End If
                End If
            Next
            'process novel Codeset Domain
            cEAdomains.Add(s1) 'put into main domain collection
            cEAdomtype.Add(sCurDomType) 'put type into its main collection
            sList = "Codeset: " & sList
            cboxDomains.Items.Add(sList) 'update the combo box
            iCount = cEAdomains.Count
            cDomIndex.Add(iCount) 'update the index collection of domains
            Return
        End If

        'retrieve Range Domain
        sTitle = "Entity & Attribute Info error"
        oNewRange = New AttribDomain_Range
        cMoreAttribs = New Collection
        xmlNlist = xmlEADoc.SelectNodes("/attrdomv/rdom")
        If (xmlNlist.Count > 0) Then
            ' 1. retrieve the Range Domain Minimum
            xmlPlist = xmlNlist(0).SelectNodes("rdommin")
            If (xmlPlist.Count > 0) Then
                oNewRange.DomMinimum = xmlPlist(0).InnerText.Trim
            End If
            ' 2. retrieve the Range Domain Maximum
            xmlPlist = xmlNlist(0).SelectNodes("rdommax")
            If (xmlPlist.Count > 0) Then
                oNewRange.DomMaximum = xmlPlist(0).InnerText.Trim
            End If
            ' 3. retrieve Attribute Units of Measure
            xmlPlist = xmlNlist(0).SelectNodes("attrunit")
            If (xmlPlist.Count > 0) Then
                oNewRange.MeasureUnits = xmlPlist(0).InnerText.Trim
            End If
            ' 4. retrieve Attribute Measurement Resolution
            xmlPlist = xmlNlist(0).SelectNodes("attrmres")
            If (xmlPlist.Count > 0) Then
                sError = "AttributeRange Domain Values" & CrLf
                s1 = xmlPlist(0).InnerText.Trim
                realCheck(s1, rVal, bReal)
                If (bReal = True) Then
                    If (rVal > 100000.0) Then
                        sError += "Measurement Resolution of " & s1 & " is > 100,000." & CrLf
                        sError += "Value set to 100,000."
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        oNewRange.Resolution = 100000D
                    ElseIf (rVal > 0.0) Then
                        'valid value
                        oNewRange.Resolution = Convert.ToDecimal(rVal)
                    Else
                        sError += "Measurement Resolution of " & s1 & " is not > 0.0." & CrLf
                        sError += "Value set to 0.0."
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        oNewRange.Resolution = 0D
                    End If
                Else
                    sError += "Measurement Resolution of " & s1 & " could not be converted to a number." & CrLf
                    sError += "Value ignored."
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    oNewRange.Resolution = 0D
                End If
            End If
            ' 5. retrieve Attribute(s)
            xmlPlist = xmlNlist(0).SelectNodes("attr")
            iCount = xmlPlist.Count - 1
            For iLoop = 0 To iCount
                sEAinfo = xmlPlist(iLoop).OuterXml
                openEAattrib(sEAinfo, cMoreAttribs)
            Next
            If (cMoreAttribs.Count > 0) Then oNewRange.MoreAttributes = cMoreAttribs
            'update objects and display
            cEAdomains.Add(oNewRange) 'put into main domain collection
            sCurDomType = "range"
            cEAdomtype.Add(sCurDomType) 'put type into its main collection
            sList = "Range: min = " & oNewRange.DomMinimum & "  max = " & oNewRange.DomMaximum
            cboxDomains.Items.Add(sList) 'update the combo box
            iCount = cEAdomains.Count
            cDomIndex.Add(iCount) 'update the index collection of domains
            Return
        End If

        'retrieve Enumerated Domain(s)
        xmlNlist = xmlEADoc.SelectNodes("/attrdomv/edom")
        iCount = xmlNlist.Count - 1
        For iLoop = 0 To iCount
            oNewEnum = New AttribDomain_Enum
            oNewRange = New AttribDomain_Range
            cMoreAttribs = New Collection
            ' 1. retrieve the Enumerated Domain Value
            xmlPlist = xmlNlist(iLoop).SelectNodes("edomv")
            If (xmlPlist.Count > 0) Then
                oNewEnum.DomainValue = xmlPlist(0).InnerText.Trim
            End If
            ' 2. retrieve the Enumerated Domain Value Definition
            xmlPlist = xmlNlist(iLoop).SelectNodes("edomvd")
            If (xmlPlist.Count > 0) Then
                oNewEnum.ValueDef = xmlPlist(0).InnerText.Trim
            End If
            ' 3. retrieve Enumerated Domain Value Definition Source
            xmlPlist = xmlNlist(iLoop).SelectNodes("edomvds")
            If (xmlPlist.Count > 0) Then
                oNewEnum.DefSource = xmlPlist(0).InnerText.Trim
            End If
            ' 4. retrieve Attribute(s)
            xmlPlist = xmlNlist(iLoop).SelectNodes("attr")
            kCount = xmlPlist.Count - 1
            For kLoop = 0 To kCount
                sEAinfo = xmlPlist(kLoop).OuterXml
                openEAattrib(sEAinfo, cMoreAttribs)
            Next
            If (cMoreAttribs.Count > 0) Then oNewEnum.MoreAttributes = cMoreAttribs
            'update objects and display
            cEAdomains.Add(oNewEnum) 'put into main domain collection
            sCurDomType = "enum"
            cEAdomtype.Add(sCurDomType) 'put type into its main collection
            sList = "Enumerated: " & oNewEnum.DomainValue
            cboxDomains.Items.Add(sList) 'update the combo box
            iCount = cEAdomains.Count
            cDomIndex.Add(iCount) 'update the index collection of domains
        Next
        Return
    End Sub

#End Region


#Region " DOM processing for Distribution Information section "

    Private Sub openDistrib(ByVal xmlOpenDI As XmlDocument)
        Dim xmlNlist As XmlNodeList
        Dim xmlTime As New XmlDocument
        Dim sDistInfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim kCount As Integer = 0
        Dim oDistrib As New DistributorClass
        Dim oContact As New ContactInfo 'goes into oDistrib
        Dim oTime As New SourceClass 'used to process Available Time Period
        Dim cAvTime As New Collection 'goes into oDistrib
        Dim oStdOrder As New StdOrderClass
        Dim cStdOrderIndex As New Collection 'goes into oDistrib

        'initialize
        oDistrib = New DistributorClass
        oContact = New ContactInfo
        oStdOrder = New StdOrderClass
        cStdOrderIndex = New Collection
        cAvTime = New Collection

        'retrieve Distributor
        xmlNlist = xmlOpenDI.SelectNodes("/distinfo/distrib/cntinfo")
        If (xmlNlist.Count > 0) Then
            'get the Contact Information XML
            sDistInfo = xmlNlist(0).OuterXml
            openContact(sDistInfo, oContact)
            oDistrib.Distributor = oContact
        End If

        'retrieve Resource Description
        xmlNlist = xmlOpenDI.SelectNodes("/distinfo/resdesc")
        If (xmlNlist.Count > 0) Then
            oDistrib.ResourceDesc = xmlNlist(0).InnerText.Trim
        End If

        'retrieve Distribution Liability
        xmlNlist = xmlOpenDI.SelectNodes("/distinfo/distliab")
        If (xmlNlist.Count > 0) Then
            oDistrib.Liability = xmlNlist(0).InnerText.Trim
        End If

        'retrieve Custom Order Process
        xmlNlist = xmlOpenDI.SelectNodes("/distinfo/custom")
        If (xmlNlist.Count > 0) Then
            oDistrib.CustomOrder = xmlNlist(0).InnerText.Trim
        End If

        'retrieve Technical Prerequisites
        xmlNlist = xmlOpenDI.SelectNodes("/distinfo/techpreq")
        If (xmlNlist.Count > 0) Then
            oDistrib.TechReq = xmlNlist(0).InnerText.Trim
        End If

        'retrieve Available Time Period
        xmlNlist = xmlOpenDI.SelectNodes("/distinfo/availabl/timeinfo")

        If (xmlNlist.Count > 0) Then
            sDistInfo = xmlNlist(0).OuterXml
            xmlTime.LoadXml(sDistInfo)
            openTimeInfo(xmlTime, oTime, cAvTime)

            If (oTime.boolSingle = True And oTime.boolRange = False) Then
                'Single Date/Time
                oDistrib.boolSingle = True
                oDistrib.boolRange = False
            ElseIf (oTime.boolSingle = False And oTime.boolRange = True) Then
                'Range of Dates
                oDistrib.boolSingle = False
                oDistrib.boolRange = True
            ElseIf (oTime.boolSingle = False And oTime.boolRange = False) Then
                'Multiple Dates; requires translation
                oDistrib.boolSingle = True
                oDistrib.boolRange = True
            Else
                'unknown or no value
                oDistrib.boolSingle = False
                oDistrib.boolRange = False
            End If
            oDistrib.TimeAvail = cAvTime
        End If

        'retrieve Standard Order Process(es)
        xmlNlist = xmlOpenDI.SelectNodes("/distinfo/stdorder")
        iCount = xmlNlist.Count - 1
        For iLoop = 0 To iCount
            sDistInfo = xmlNlist(iLoop).OuterXml
            openStdProc(sDistInfo, oStdOrder)
            'add new Standard Order to main collection
            cStdOrderProc.Add(oStdOrder)
            'add index value of new Standard Order to index collection
            kCount = cStdOrderProc.Count
            cStdOrderIndex.Add(kCount)
        Next

        'add Standard Order index collection to distributor object
        oDistrib.StdOrderColl = cStdOrderIndex

        cDistrib.Add(oDistrib) 'add new distributor to main collection
        'identify distributor in list box using required contact information
        If (oContact.PrimaryPerson = True) Then
            sDistInfo = "Distributor, person: " & oContact.Person
        Else
            sDistInfo = "Distributor, organization: " & oContact.Organization
        End If
        lboxDistrib.Items.Add(sDistInfo)
    End Sub

    Private Sub openStdProc(ByVal sOrder As String, ByRef oProcess As StdOrderClass)
        Dim xmlOrderProcDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim kCount As Integer = 0
        Dim kLoop As Integer = 0
        Dim sDistInfo As String = ""
        Dim cDigiForm As New Collection

        xmlOrderProcDoc.LoadXml(sOrder)
        oProcess = New StdOrderClass
        cDigiForm = New Collection

        'retrieve Fees
        xmlNlist = xmlOrderProcDoc.SelectNodes("/stdorder/fees")
        If (xmlNlist.Count > 0) Then
            oProcess.Fees = xmlNlist(0).InnerText.Trim
        End If

        'retrieve Ordering Instructions
        xmlNlist = xmlOrderProcDoc.SelectNodes("/stdorder/ordering")
        If (xmlNlist.Count > 0) Then
            oProcess.Instructions = xmlNlist(0).InnerText.Trim
        End If

        'retrieve Turnaround
        xmlNlist = xmlOrderProcDoc.SelectNodes("/stdorder/turnarnd")
        If (xmlNlist.Count > 0) Then
            oProcess.Turnaround = xmlNlist(0).InnerText.Trim
        End If

        'retrieve Non-digital Form
        xmlNlist = xmlOrderProcDoc.SelectNodes("/stdorder/nondig")
        If (xmlNlist.Count > 0) Then
            oProcess.NonDigitalForm = xmlNlist(0).InnerText.Trim
            Return
        End If

        'OR retrieve Digital Form(s)
        xmlNlist = xmlOrderProcDoc.SelectNodes("/stdorder/digform")
        iCount = xmlNlist.Count - 1
        For iLoop = 0 To iCount
            sDistInfo = xmlNlist(iLoop).OuterXml
            openDigitForm(sDistInfo, kCount)
            If (kCount > 0) Then
                'add Digital Form index to collection
                cDigiForm.Add(kCount)
            End If
        Next
        oProcess.DigitalForms = cDigiForm 'add index collection to std order object
        Return
    End Sub

    Private Sub openDigitForm(ByVal sOrder As String, ByRef iFormVal As Integer)
        Dim xmlOrderProcDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim sDigiInfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim kCount As Integer = 0
        Dim s1 As String = ""
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False
        Dim oDigiForm As New DigitalOrderClass
        Dim cDTransIndex As New Collection

        xmlOrderProcDoc.LoadXml(sOrder)
        cDTransIndex = New Collection
        iFormVal = 0

        'retrieve Digital Transfer Information
        xmlNlist = xmlOrderProcDoc.SelectNodes("/digform/digtinfo")
        If (xmlNlist.Count > 0) Then
            ' 1. retrieve Format Name
            xmlPlist = xmlNlist(0).SelectNodes("formname")
            If (xmlPlist.Count > 0) Then
                oDigiForm.FormatName = xmlPlist(0).InnerText.Trim
            End If
            ' 2a. retrieve Format Version Number
            bReal = False 'being used as test for presence of version number or version date
            xmlPlist = xmlNlist(0).SelectNodes("formvern")
            iCount = xmlPlist.Count
            If (iCount > 0) Then
                oDigiForm.FormatVNum = xmlPlist(0).InnerText.Trim
                bReal = True
            Else
                ' 2b. OR retrieve Format Version Date
                xmlPlist = xmlNlist(0).SelectNodes("formverd")
                If (xmlPlist.Count > 0) Then
                    oDigiForm.FormatVDate = xmlPlist(0).InnerText.Trim
                    bReal = True
                End If
            End If
            ' 3. retrieve Format Specification
            xmlPlist = xmlNlist(0).SelectNodes("formspec")
            If (xmlPlist.Count > 0) Then
                oDigiForm.FormatSpec = xmlPlist(0).InnerText.Trim
                If (bReal = False) Then oDigiForm.FormatVNum = "see Format Specification"
            End If
            ' 4. retrieve ASCII File Structure
            xmlPlist = xmlNlist(0).SelectNodes("asciistr")
            If (xmlPlist.Count > 0) Then
                sDigiInfo = xmlPlist(0).OuterXml
                openASCIIform(sDigiInfo, oDigiForm)
            End If
            ' 5. retrieve Format Information Content
            xmlPlist = xmlNlist(0).SelectNodes("formcont")
            If (xmlPlist.Count > 0) Then
                oDigiForm.FormatInfo = xmlPlist(0).InnerText.Trim
            End If
            ' 6. retrieve File Decompression Technique
            xmlPlist = xmlNlist(0).SelectNodes("filedec")
            If (xmlPlist.Count > 0) Then
                oDigiForm.Decompress = xmlPlist(0).InnerText.Trim
            End If
            ' 7. retrieve Transfer Size
            sTitle = "Distribution Information"
            xmlPlist = xmlNlist(0).SelectNodes("transize")
            If (xmlPlist.Count > 0) Then
                s1 = xmlPlist(0).InnerText.Trim
                realCheck(s1, rVal, bReal)
                If (bReal = True) Then
                    If (rVal > 0.0) Then
                        s1 = rVal.ToString
                    Else
                        sError = "Transfer Size of " & s1 & " is not > 0.0." & CrLf
                        sError += "Value set to blank."
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        s1 = ""
                    End If
                Else
                    sError = "Transfer Size of " & s1 & " could not be converted to a number."
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    s1 = ""
                End If
                oDigiForm.TransferSize = s1
            End If
        End If

        'retrieve Digital Transfer Option(s)
        xmlNlist = xmlOrderProcDoc.SelectNodes("/digform/digtopt")
        iCount = xmlNlist.Count - 1
        For iLoop = 0 To iCount
            sDigiInfo = xmlNlist(iLoop).OuterXml
            openDigitTrans(sDigiInfo, kCount)
            If (kCount > 0) Then cDTransIndex.Add(kCount) 'add index of option to collection
        Next
        If (cDTransIndex.Count > 0) Then oDigiForm.TransOptions = cDTransIndex

        'add Digital Form to main collection, get index value and return
        cDigitalForm.Add(oDigiForm)
        iFormVal = cDigitalForm.Count
        Return
    End Sub

    Private Sub openASCIIform(ByVal sASCII As String, ByRef oDigiForm As DigitalOrderClass)
        'process ASCII File Structure
        Dim xmlASCIIformat As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim kCount As Integer = 0
        Dim kLoop As Integer = 0
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim s1 As String = ""
        Dim sData As String
        Dim sDelim As String = "delim"
        Dim sWidth As String = "width"
        Dim sDataFields As New StringCollection
        Dim sTest() As String
        Dim bCheck As Boolean = False

        xmlASCIIformat.LoadXml(sASCII)
        sDataFields = New StringCollection

        '1. retrieve Record Delimiter
        xmlNlist = xmlASCIIformat.SelectNodes("/asciistr/recdel")
        If (xmlNlist.Count > 0) Then
            oDigiForm.ASCIIstruct = True
            oDigiForm.RecordDelim = xmlNlist(0).InnerText.Trim
        End If
        '2. retrieve Number Header Lines
        sTitle = "Distribution Information"
        xmlNlist = xmlASCIIformat.SelectNodes("/asciistr/numheadl")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            chkInteger(s1, iCount, bCheck)
            If (bCheck = True) Then
                If (iCount > 0) Then
                    'satisfactory value
                    s1 = iCount.ToString
                    oDigiForm.ASCIIstruct = True
                Else
                    sError = "ASCII File Structure" & CrLf
                    sError += "Number of Header Lines of " & s1 & " is not > 0." & CrLf
                    sError += "Value set to blank."
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    s1 = ""
                End If
            Else
                sError = "ASCII File Structure" & CrLf
                sError += "Number of Header Lines of " & s1 & " could not be converted to a number."
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                s1 = ""
            End If
            oDigiForm.NumHeaders = s1
        End If
        '3. retrieve Description of Header Content
        xmlNlist = xmlASCIIformat.SelectNodes("/asciistr/deschead")
        If (xmlNlist.Count > 0) Then
            oDigiForm.ASCIIstruct = True
            oDigiForm.Header = xmlNlist(0).InnerText.Trim
        End If
        '4. retrieve Orientation
        xmlNlist = xmlASCIIformat.SelectNodes("/asciistr/orienta")
        If (xmlNlist.Count > 0) Then
            oDigiForm.ASCIIstruct = True
            oDigiForm.Orientation = xmlNlist(0).InnerText.Trim
        End If
        '5. retrieve Case Sensitive
        xmlNlist = xmlASCIIformat.SelectNodes("/asciistr/casesens")
        If (xmlNlist.Count > 0) Then
            oDigiForm.ASCIIstruct = True
            oDigiForm.CaseSensitive = xmlNlist(0).InnerText.Trim
        End If
        '6. retrieve Authentication
        xmlNlist = xmlASCIIformat.SelectNodes("/asciistr/authent")
        If (xmlNlist.Count > 0) Then
            oDigiForm.ASCIIstruct = True
            oDigiForm.Authentic = xmlNlist(0).InnerText.Trim
        End If
        '7. retrieve Quote Character
        xmlNlist = xmlASCIIformat.SelectNodes("/asciistr/quotech")
        If (xmlNlist.Count > 0) Then
            oDigiForm.ASCIIstruct = True
            oDigiForm.QuoteChar = xmlNlist(0).InnerText.Trim
        End If
        '8. retrieve Data Field(s)
        xmlNlist = xmlASCIIformat.SelectNodes("/asciistr/datafiel")
        iCount = xmlNlist.Count - 1
        For iLoop = 0 To iCount
            sData = ""
            ' a. retrieve Data Field Name
            s1 = ""
            xmlPlist = xmlNlist(iLoop).SelectNodes("dfieldnm")
            If (xmlPlist.Count > 0) Then
                s1 = xmlPlist(0).InnerText.Trim
            End If
            sData += s1 & sPdelim
            ' b. retrieve Missing Value Code
            s1 = ""
            xmlPlist = xmlNlist(iLoop).SelectNodes("missingv")
            If (xmlPlist.Count > 0) Then
                s1 = xmlPlist(0).InnerText.Trim
            End If
            sData += s1 & sPdelim
            ' c1. retrieve Data Field Width Delimiter
            s1 = ""
            xmlPlist = xmlNlist(iLoop).SelectNodes("dfwidthd")
            kLoop = xmlPlist.Count
            If (kLoop > 0) Then
                s1 = xmlPlist(0).InnerText.Trim
                sData += sDelim & sPdelim & s1
            Else
                ' c2. OR retrieve Data Field Width
                xmlPlist = xmlNlist(iLoop).SelectNodes("dfwidth")
                s1 = xmlPlist(0).InnerText.Trim
                chkInteger(s1, kCount, bCheck)
                If (bCheck = True) Then
                    If (kCount > 0) Then
                        'satisfactory value
                        s1 = kCount.ToString
                        sData += sWidth & sPdelim & s1
                    Else
                        sError = "ASCII File Structure" & CrLf
                        sError += "Data Field Width of " & s1 & " is not > 0." & CrLf
                        sError += "Value set to blank."
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        s1 = ""
                    End If
                Else
                    sError = "ASCII File Structure" & CrLf
                    sError += "Data Field Width of " & s1 & " could not be converted to a number."
                    MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    s1 = ""
                End If
            End If
            sTest = Split(s1, sPdelim)
            kCount = sTest.GetLength(0)
            If (kCount < 4) Then sData += sPdelim 'ensures 3 sPdelim characters for splitting
            If (sData.Length > 3) Then sDataFields.Add(sData) 'else: no values present, just delimiters
        Next
        If (sDataFields.Count > 0) Then
            oDigiForm.ASCIIstruct = True
            oDigiForm.DataFields = sDataFields
        End If
        Return
    End Sub

    Private Sub openDigitTrans(ByVal sOption As String, ByRef iTransVal As Integer)
        Dim xmlOptionDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim xmlRlist As XmlNodeList
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim kCount As Integer = 0
        Dim kLoop As Integer = 0
        Dim rVal As Double = 0.0
        Dim bReal As Boolean = False
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim s1 As String = ""
        Dim sAddress As String = ""
        Dim oTransfer As New DTransOption

        xmlOptionDoc.LoadXml(sOption)
        oTransfer = New DTransOption
        iTransVal = 0

        'retrieve Online Option
        xmlNlist = xmlOptionDoc.SelectNodes("/digtopt/onlinopt")
        If (xmlNlist.Count > 0) Then
            oTransfer.boolOnline = True
            ' 1. retrieve Access Instructions
            xmlPlist = xmlNlist(0).SelectNodes("accinstr")
            If (xmlPlist.Count > 0) Then
                oTransfer.Access = xmlPlist(0).InnerText.Trim
            End If
            ' 2. retrieve Online Computer & Operating System
            xmlPlist = xmlNlist(0).SelectNodes("oncomp")
            If (xmlPlist.Count > 0) Then
                oTransfer.ComputerOS = xmlPlist(0).InnerText.Trim
            End If
            ' 3. retrieve Network Address Name(s)
            xmlPlist = xmlNlist(0).SelectNodes("computer/networka/networkr")
            iCount = xmlPlist.Count - 1
            sAddress = ""
            For iLoop = 0 To iCount
                s1 = xmlPlist(iLoop).InnerText.Trim
                If (s1 <> "") Then
                    sAddress += s1 & sKdelim
                End If
            Next
            oTransfer.NetworkName = sAddress
            cDTransOpt.Add(oTransfer)
            iTransVal = cDTransOpt.Count
            Return
        End If

        'OR retrieve Offline Option
        xmlNlist = xmlOptionDoc.SelectNodes("/digtopt/offoptn")
        If (xmlNlist.Count > 0) Then
            oTransfer.boolOffline = True
            ' 1. Offline Media
            xmlPlist = xmlNlist(0).SelectNodes("offmedia")
            If (xmlPlist.Count > 0) Then
                oTransfer.OfflineMedia = xmlPlist(0).InnerText.Trim
            End If
            ' 2. retrieve Recording Capacity
            xmlPlist = xmlNlist(0).SelectNodes("reccap")
            If (xmlPlist.Count > 0) Then
                ' a. retrieve Recording Density
                sTitle = "Distribution Information"
                xmlRlist = xmlPlist(0).SelectNodes("recden")
                iCount = xmlRlist.Count - 1
                sAddress = ""
                For iLoop = 0 To iCount
                    s1 = xmlRlist(iLoop).InnerText.Trim
                    realCheck(s1, rVal, bReal)
                    If (bReal = True) Then
                        If (rVal > 0.0) Then
                            s1 = rVal.ToString
                        Else
                            sError = "Recording Density of " & s1 & " is not > 0.0." & CrLf
                            sError += "Value set to blank."
                            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                            s1 = ""
                        End If
                    Else
                        sError = "Recording Density of " & s1 & " could not be converted to a number."
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        s1 = ""
                    End If
                    If (s1 <> "") Then sAddress += s1 & sKdelim
                Next
                If (sAddress <> "") Then oTransfer.RecDensity = sAddress
                ' b. retrieve Recording Density Units
                xmlRlist = xmlPlist(0).SelectNodes("recdenu")
                If (xmlRlist.Count > 0) Then
                    oTransfer.DensityUnits = xmlRlist(0).InnerText.Trim
                End If
            End If
            ' 3. retrieve Recording Format(s)
            xmlPlist = xmlNlist(0).SelectNodes("recfmt")
            iCount = xmlPlist.Count - 1
            sAddress = ""
            For iLoop = 0 To iCount
                s1 = xmlPlist(iLoop).InnerText.Trim
                If (s1 <> "") Then
                    sAddress += s1 & sKdelim
                End If
            Next
            oTransfer.RecFormat = sAddress
            ' 4. Compatibility Information
            xmlPlist = xmlNlist(0).SelectNodes("compat")
            If (xmlPlist.Count > 0) Then
                oTransfer.Compatible = xmlPlist(0).InnerText.Trim
            End If

            cDTransOpt.Add(oTransfer)
            iTransVal = cDTransOpt.Count
        End If
        Return
    End Sub

#End Region


#Region " DOM processing for Metadata Reference Information section "

    Private Sub openMR(ByVal xmlOpenMR As XmlDocument)
        Dim xmlNlist As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim iYr As Integer = 0
        Dim iMonth As Integer = 0
        Dim iDay As Integer = 0
        Dim sError As String = ""
        Dim sTitle As String = ""
        Dim sMRinfo As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim kCount As Integer = 0
        Dim bInteger As Boolean = False
        Dim oContact As New ContactInfo

        'retrieve Metadata Date
        xmlNlist = xmlOpenMR.SelectNodes("/metainfo/metd")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            readDate(s1, iYr, iMonth, iDay, bInteger)
            If (bInteger = True) Then
                dtPick1.Value = New DateTime(iYr, iMonth, iDay)
            End If
        End If

        'retrieve Metadata Review Date
        xmlNlist = xmlOpenMR.SelectNodes("/metainfo/metrd")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            readDate(s1, iYr, iMonth, iDay, bInteger)
            If (bInteger = True) Then
                ' 1. set check box so Review Date included in metadata output
                chkRevDate.Checked = True
                ' 2. set the date
                dtPick2.Value = New DateTime(iYr, iMonth, iDay)
            End If
        End If

        'retrieve Metadata Future Review Date
        xmlNlist = xmlOpenMR.SelectNodes("/metainfo/metfrd")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            readDate(s1, iYr, iMonth, iDay, bInteger)
            If (bInteger = True) Then
                ' 1. set check box so Future Review Date included in metadata output
                chkFRevDate.Checked = True
                ' 2. set the date
                dtPick3.Value = New DateTime(iYr, iMonth, iDay)
            End If
        End If

        'retrieve Metadata Contact
        oContact = New ContactInfo
        xmlNlist = xmlOpenMR.SelectNodes("/metainfo/metc/cntinfo")
        If (xmlNlist.Count > 0) Then
            'get the Contact Information XML
            sMRinfo = xmlNlist(0).OuterXml
            openContact(sMRinfo, oContact)
            objMRcontact = oContact 'update the main object
            If (objMRcontact.PrimaryPerson = True) Then 'update the form display
                txtMRcontact.Text = objMRcontact.Person
            Else
                txtMRcontact.Text = objMRcontact.Organization
            End If
        End If

        'retrieve Metadata Standard Name
        xmlNlist = xmlOpenMR.SelectNodes("/metainfo/metstdn")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            If (s1 = "FGDC Content Standards for Digital Geospatial Metadata") Then
                'fix error in ESRI output
                s1 = "FGDC Content Standard for Digital Geospatial Metadata"
            End If
            iCount = cboxStdName.FindStringExact(s1)
            If (s1 = "") Then
                cboxStdName.SelectedIndex = 0
            Else
                If (iCount = -1) Then
                    cboxStdName.Items.Add(s1)
                    cboxStdName.SelectedIndex = cboxStdName.Items.Count - 1
                Else
                    cboxStdName.SelectedIndex = iCount
                End If
            End If
        End If

        'retrieve Metadata Standard Version
        xmlNlist = xmlOpenMR.SelectNodes("/metainfo/metstdv")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            iCount = cboxStdVer.FindStringExact(s1)
            If (s1 = "") Then
                cboxStdVer.SelectedIndex = 0
            Else
                If (iCount = -1) Then
                    cboxStdVer.Items.Add(s1)
                    cboxStdVer.SelectedIndex = cboxStdVer.Items.Count - 1
                Else
                    cboxStdVer.SelectedIndex = iCount
                End If
            End If
        End If

        'retrieve Metadata Time Convention
        '  this was processed when file initially opened

        'retrieve Metadata Access Constraints
        xmlNlist = xmlOpenMR.SelectNodes("/metainfo/metac")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            txtMRaccess.Text = s1
        End If

        'retrieve Metadata Use Constraints
        xmlNlist = xmlOpenMR.SelectNodes("/metainfo/metuc")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            txtMRuse.Text = s1
        End If

        'retrieve Metadata Security Information
        xmlNlist = xmlOpenMR.SelectNodes("/metainfo/metsi")
        If (xmlNlist.Count > 0) Then
            ' 1. retrieve Metadata Security Classification System
            xmlPlist = xmlNlist(0).SelectNodes("metscs")
            If (xmlPlist.Count > 0) Then
                s1 = xmlPlist(0).InnerText.Trim
                txtMRClassSys.Text = s1
            End If
            ' 2. retrieve Metadata Security Classification
            xmlPlist = xmlNlist(0).SelectNodes("metsc")
            If (xmlPlist.Count > 0) Then
                s1 = xmlPlist(0).InnerText.Trim
                iCount = cboxMRClass.FindStringExact(s1)
                If (s1 = "") Then
                    cboxMRClass.SelectedIndex = -1
                Else
                    If (iCount = -1) Then
                        cboxMRClass.Items.Add(s1)
                        cboxMRClass.SelectedIndex = cboxMRClass.Items.Count - 1
                    Else
                        cboxMRClass.SelectedIndex = iCount
                    End If
                End If
            End If
            ' 3. retrieve Metadata Security Handling Description
            xmlPlist = xmlNlist(0).SelectNodes("metshd")
            If (xmlPlist.Count > 0) Then
                s1 = xmlPlist(0).InnerText.Trim
                txtMRSecDesc.Text = s1
            End If
        End If

        'retrieve Metadata Extensions
        '  this capability is not implemented in the current version
    End Sub

    Private Sub readDate(ByVal s1 As String, ByRef iYr As Integer, ByRef iMonth As Integer, ByRef iDay As Integer, _
                         ByRef bCheck As Boolean)
        Dim iCount As Integer = 0
        Dim sError As String = ""
        Dim sTitle As String = ""
        'process a standard date string
        'default date is January 1, 2004
        iYr = 2004
        iMonth = 1
        iDay = 1
        bCheck = False
        If (s1.Length > 8) Then
            s1 = Microsoft.VisualBasic.Left(s1, 8)
            sError = "Metadata date too long." & CrLf & "Will attempt to process truncated value."
            sTitle = "Metadata Reference Information error"
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf (s1.Length < 4) Then
            bCheck = False
            sError = "Metadata date too short." & CrLf & "No date will be processed."
            sTitle = "Metadata Reference Information error"
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        chkInteger(s1, iCount, bCheck)
        If (bCheck = True) Then
            'set the date
            iYr = Convert.ToInt32(Microsoft.VisualBasic.Left(s1, 4))
            If (s1.Length > 4) Then iMonth = Convert.ToInt32(Mid(s1, 5, 2))
            If (s1.Length > 6) Then iDay = Convert.ToInt32(Mid(s1, 7, 2))
        Else
            sError = "Metadata date not an integer." & CrLf & "No date will be processed."
            sTitle = "Metadata Reference Information error"
            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

#End Region


#Region " DOM processing routines for Citation Information section "

    Private Sub openCite(ByVal xmlCiteNode As XmlDocument, ByRef oCite As CiteInfo, ByRef bCheck As Boolean)
        'process the xmlCiteNode and place results in oCite
        'XML assumed to start with <citeinfo> compound element
        'only processes 1 citation; ignores any lworkcit branches
        'if successful, i.e., at least 1 mandatory element present, bCheck is set to True

        Dim s1 As String = ""
        Dim sTitle As String = ""
        Dim sError As String = ""
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim xmlCiteList As XmlNodeList

        bCheck = False
        oCite = New CiteInfo

        'process Originators
        s1 = ""
        xmlCiteList = xmlCiteNode.SelectNodes("/citeinfo/origin")
        iCount = xmlCiteList.Count - 1
        For iLoop = 0 To iCount
            s1 += xmlCiteList(iLoop).InnerText & CrLf
        Next
        If (s1 = "") Then
            oCite.Author = "Unknown"
        Else
            oCite.Author = fixStringCrLf(s1)
        End If

        'process Publication Date
        xmlCiteList = xmlCiteNode.SelectNodes("/citeinfo/pubdate")
        If (xmlCiteList.Count > 0) Then
            s1 = xmlCiteList(0).InnerText
            If (s1 = "Unpublished Material") Then s1 = "Unpublished material"
            Select Case s1
                Case "Unknown", "Unpublished material"
                    'valid entries
                Case Else
                    evalDate(s1, bCheck)
                    If (bCheck = True) Then
                        'have valid date
                    Else
                        sTitle = "Citation InfoPublication Date error"
                        sError = s1 & "  is not in correct date format."
                        sError += " Date set to Unknown."
                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                        s1 = "Unknown"
                    End If
            End Select
        Else
            s1 = "Unknown"
        End If
        oCite.PubDate = s1

        'process Publication Time
        xmlCiteList = xmlCiteNode.SelectNodes("/citeinfo/pubtime")
        s1 = ""
        If (xmlCiteList.Count > 0) Then
            s1 = xmlCiteList(0).InnerText
            chkTime(s1)
        End If
        oCite.PubTime = s1

        'process Title
        xmlCiteList = xmlCiteNode.SelectNodes("/citeinfo/title")
        s1 = ""
        If (xmlCiteList.Count > 0) Then
            s1 = xmlCiteList(0).InnerText
        End If
        oCite.Title = s1

        'process Edition
        xmlCiteList = xmlCiteNode.SelectNodes("/citeinfo/edition")
        s1 = ""
        If (xmlCiteList.Count > 0) Then
            s1 = xmlCiteList(0).InnerText
        End If
        oCite.Edition = s1

        'process Geospatial Data Presentation Form
        xmlCiteList = xmlCiteNode.SelectNodes("/citeinfo/geoform")
        s1 = ""
        If (xmlCiteList.Count > 0) Then
            s1 = xmlCiteList(0).InnerText
        End If
        oCite.Geoform = s1

        'process Series Information
        xmlCiteList = xmlCiteNode.SelectNodes("/citeinfo/serinfo/sername")
        s1 = ""
        If (xmlCiteList.Count > 0) Then
            s1 = xmlCiteList(0).InnerText
        End If
        oCite.SerialName = s1

        xmlCiteList = xmlCiteNode.SelectNodes("/citeinfo/serinfo/issue")
        s1 = ""
        If (xmlCiteList.Count > 0) Then
            s1 = xmlCiteList(0).InnerText
        End If
        oCite.Issue = s1

        'process Publication Information
        xmlCiteList = xmlCiteNode.SelectNodes("/citeinfo/pubinfo/pubplace")
        s1 = ""
        If (xmlCiteList.Count > 0) Then
            s1 = xmlCiteList(0).InnerText
        End If
        oCite.PubPlace = s1

        xmlCiteList = xmlCiteNode.SelectNodes("/citeinfo/pubinfo/publish")
        s1 = ""
        If (xmlCiteList.Count > 0) Then
            s1 = xmlCiteList(0).InnerText
        End If
        oCite.Publisher = s1

        'process Other Citation Details
        xmlCiteList = xmlCiteNode.SelectNodes("/citeinfo/othercit")
        s1 = ""
        If (xmlCiteList.Count > 0) Then
            s1 = xmlCiteList(0).InnerText
        End If
        oCite.OtherCit = s1

        'process Online Linkages
        s1 = ""
        xmlCiteList = xmlCiteNode.SelectNodes("/citeinfo/onlink")
        iCount = xmlCiteList.Count - 1
        For iLoop = 0 To iCount
            s1 += xmlCiteList(iLoop).InnerText & CrLf
        Next
        oCite.URLink = s1

        bCheck = True
        Return
    End Sub

#End Region


#Region " DOM processing routines for Time Period Information section "

    Private Sub openTimeInfo(ByVal xmlTimeNodes As XmlDocument, ByRef oTime As SourceClass, ByRef cTimeColl As Collection)
        Dim xmlNList As XmlNodeList
        Dim xmlNList2 As XmlNodeList
        Dim xmlNList3 As XmlNodeList
        Dim xmlNList4 As XmlNodeList
        Dim sTitle As String = ""
        Dim sError As String = ""
        Dim iCount As Integer = 0
        Dim iCount2 As Integer = 0
        Dim iCount3 As Integer = 0
        Dim iLoop As Integer = 0
        Dim oSngTimeBeg As New SngDateTime 'single date/time or beginning date/time
        Dim oSngTimeEnd As New SngDateTime 'ending date/time
        Dim oGeolBeg As New GeolAge 'beginning geologic age or single geologic age
        Dim oGeolEnd As New GeolAge 'ending geologic age
        Dim bTimeTypeSet As Boolean = False
        Dim sTimeElem As String = ""
        Dim xmlGeolNode As New XmlDocument 'for processing Geologic Age
        Dim bCheck As Boolean = False 'general boolean for checking success of subroutine

        oTime = New SourceClass
        cTimeColl = New Collection
        'initialize date type to be None/Unknown
        oTime.boolRange = True
        oTime.boolSingle = True

        'check for Single Date/Time
        xmlNList = xmlTimeNodes.SelectNodes("/timeinfo/sngdate")
        If (xmlNList.Count > 0) Then
            'working with Single Date/Time
            oTime.boolSingle = True
            oTime.boolRange = False
            xmlNList2 = xmlTimeNodes.SelectNodes("/timeinfo/sngdate/caldate")
            If (xmlNList2.Count > 0) Then
                'working with Gregorian time
                oTime.Gregorian = True
                bTimeTypeSet = True
                'get the calendar date
                sTimeElem = xmlTimeNodes.SelectSingleNode("/timeinfo/sngdate/caldate").InnerText
                Select Case sTimeElem
                    Case "Unknown"
                        oTime.boolRange = True
                        oTime.boolSingle = True
                        Return
                    Case Else
                        evalDate(sTimeElem, bCheck)
                        If (bCheck = True) Then
                            'have valid date
                        Else
                            sTitle = "Time Period Info  Date error"
                            sError = sTimeElem & "  is not in correct date format." & CrLf
                            sError += "Date set to Unknown."
                            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                            sTimeElem = "Unknown"
                            oTime.boolRange = True
                            oTime.boolSingle = True
                            Return
                        End If
                End Select
                oSngTimeBeg.SngDate = sTimeElem
                'check for time of day
                xmlNList3 = xmlTimeNodes.SelectNodes("/timeinfo/sngdate/time")
                If (xmlNList3.Count > 0) Then
                    sTimeElem = xmlTimeNodes.SelectSingleNode("/timeinfo/sngdate/time").InnerText
                    If (sTimeElem = "Unknown") Then
                        'do nothing -- Unknown times are deleted
                    Else
                        chkTime(sTimeElem) 'make sure the time string conforms to stated time convention
                        oSngTimeBeg.TimeOfDay = sTimeElem
                    End If
                End If
                cTimeColl.Add(oSngTimeBeg) 'put date/time info into collection
                Return
            End If
            xmlNList2 = xmlTimeNodes.SelectNodes("/timeinfo/sngdate/geolage")
            If (xmlNList2.Count > 0) Then
                'working with Geologic Age
                oTime.Gregorian = False
                bTimeTypeSet = True
                sTimeElem = xmlTimeNodes.SelectSingleNode("/timeinfo/sngdate/geolage").OuterXml
                xmlGeolNode.LoadXml(sTimeElem)
                openGeolAge(xmlGeolNode, oGeolBeg, bCheck)
                If (bCheck = True) Then
                    cTimeColl.Add(oGeolBeg) 'add the Geologic Age to the time period collection
                End If
            End If 'end single geologic age
            Return
        End If 'end single date/time instance

        'check for Multiple Dates/Times
        xmlNList = xmlTimeNodes.SelectNodes("/timeinfo/mdattim")
        If (xmlNList.Count > 0) Then
            'working with Multiple Dates/Times
            oTime.boolSingle = False
            oTime.boolRange = False
            xmlNList2 = xmlTimeNodes.SelectNodes("/timeinfo/mdattim/sngdate") 'get the multiple single date nodes
            If (xmlNList2.Count > 0) Then
                iCount = xmlNList2.Count - 1 'number of single date/time to process, offset for 0-based index
                xmlNList3 = xmlNList2(0).SelectNodes("caldate")
                iCount2 = xmlNList3.Count
                If (iCount2 > 0) Then
                    'working with Gregorian times
                    oTime.Gregorian = True
                    bTimeTypeSet = True
                    For iLoop = 0 To iCount
                        oSngTimeBeg = New SngDateTime 're-initialize the date/time object
                        xmlNList3 = xmlNList2(iLoop).SelectNodes("caldate")
                        If (xmlNList3.Count > 0) Then
                            'get the calendar date
                            sTimeElem = xmlNList3(0).InnerText
                            Select Case sTimeElem
                                Case "Unknown"
                                    'do nothing
                                Case Else
                                    evalDate(sTimeElem, bCheck)
                                    If (bCheck = True) Then
                                        'have valid date
                                        oSngTimeBeg.SngDate = sTimeElem
                                        'process optional Time of Day, if present
                                        xmlNList3 = xmlNList2(iLoop).SelectNodes("time")
                                        If (xmlNList3.Count > 0) Then
                                            sTimeElem = xmlNList3(0).InnerText
                                            If (sTimeElem = "Unknown") Then
                                                'do nothing -- Unknown times are deleted
                                            Else
                                                chkTime(sTimeElem) 'make sure the time string conforms to stated time convention
                                                oSngTimeBeg.TimeOfDay = sTimeElem
                                            End If
                                        End If
                                        cTimeColl.Add(oSngTimeBeg) 'put date/time info into collection
                                    Else
                                        sTitle = "Time Period Info  Multiple Date error"
                                        sError = sTimeElem & "  is not in correct date format." & CrLf
                                        sError += "Date set to Unknown."
                                        MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                                        sTimeElem = "Unknown"
                                        oTime.boolRange = True
                                        oTime.boolSingle = True
                                        Return
                                    End If
                            End Select
                        End If
                    Next
                    If (cTimeColl.Count = 0) Then
                        'value is "Unknown"
                        oTime.boolSingle = True
                        oTime.boolRange = True
                    End If
                    If (cTimeColl.Count = 1) Then
                        'type is actually Single
                        oTime.boolSingle = True
                        oTime.boolRange = False
                    End If
                    Return
                Else
                    'working with Geologic times
                    oTime.Gregorian = False
                    bTimeTypeSet = True
                    For iLoop = 0 To iCount
                        oGeolBeg = New GeolAge 're-initialize the Geologic Age object
                        xmlNList3 = xmlNList2(iLoop).SelectNodes("geolage")
                        If (xmlNList3.Count > 0) Then
                            'there should be only 1 <geolage> node for each single date/time node
                            'so only process the 1st instance
                            sTimeElem = xmlNList3(0).OuterXml
                            xmlGeolNode.LoadXml(sTimeElem)
                            openGeolAge(xmlGeolNode, oGeolBeg, bCheck)
                            If (bCheck = True) Then
                                cTimeColl.Add(oGeolBeg) 'add the Geologic Age to the time period collection
                            End If
                        End If 'end single geologic age
                    Next
                    If (cTimeColl.Count = 0) Then
                        'value is "Unknown"
                        oTime.boolSingle = True
                        oTime.boolRange = True
                    End If
                    If (cTimeColl.Count = 1) Then
                        'type is actually Single
                        oTime.boolSingle = True
                        oTime.boolRange = False
                    End If
                    Return
                End If
            Else
                'no single date/time child nodes!
            End If
        End If 'end multiple date/time instance

        'check for Range of Date/Time
        xmlNList = xmlTimeNodes.SelectNodes("/timeinfo/rngdates")
        If (xmlNList.Count > 0) Then
            'working with Range of Date/Time
            oTime.boolSingle = False
            oTime.boolRange = True
            xmlNList2 = xmlTimeNodes.SelectNodes("/timeinfo/rngdates/begdate")
            iCount = xmlNList2.Count
            If (iCount > 0) Then
                'working with Gregorian time
                oTime.Gregorian = True
                bTimeTypeSet = True
                'get the beginning calendar date
                sTimeElem = xmlNList2(0).InnerText
                Select Case sTimeElem
                    Case "Unknown"
                        oTime.boolRange = True
                        oTime.boolSingle = True
                        Return
                    Case Else
                        evalDate(sTimeElem, bCheck)
                        If (bCheck = True) Then
                            'have valid date
                        Else
                            sTitle = "Time Period Info  Range Date error"
                            sError = sTimeElem & "  is not in correct date format." & CrLf
                            sError += "Date set to Unknown."
                            MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                            sTimeElem = "Unknown"
                            oTime.boolRange = True
                            oTime.boolSingle = True
                            Return
                        End If
                End Select
                oSngTimeBeg.SngDate = sTimeElem
                'check for beginning time of day
                xmlNList2 = xmlTimeNodes.SelectNodes("/timeinfo/rngdates/begtime")
                If (xmlNList2.Count > 0) Then
                    sTimeElem = xmlNList2(0).InnerText
                    If (sTimeElem = "Unknown") Then
                        'do nothing -- Unknown times are deleted
                    Else
                        chkTime(sTimeElem) 'make sure the time string conforms to stated time convention
                        oSngTimeBeg.TimeOfDay = sTimeElem
                    End If
                End If
                cTimeColl.Add(oSngTimeBeg) 'put beginning date/time info into collection

                'get the ending calendar date
                xmlNList2 = xmlTimeNodes.SelectNodes("/timeinfo/rngdates/enddate")
                If (xmlNList2.Count > 0) Then
                    sTimeElem = xmlNList2(0).InnerText
                    Select Case sTimeElem
                        Case "Unknown"
                            oTime.boolRange = True
                            oTime.boolSingle = True
                            Return
                        Case Else
                            evalDate(sTimeElem, bCheck)
                            If (bCheck = True) Then
                                'have valid date
                            Else
                                sTitle = "Time Period Info  Range Date error"
                                sError = sTimeElem & "  is not in correct date format." & CrLf
                                sError += "Date set to Unknown."
                                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                                sTimeElem = "Unknown"
                                oTime.boolRange = True
                                oTime.boolSingle = True
                                Return
                            End If
                    End Select
                    oSngTimeEnd.SngDate = sTimeElem
                End If
                'check for ending time of day
                xmlNList2 = xmlTimeNodes.SelectNodes("/timeinfo/rngdates/endtime")
                If (xmlNList2.Count > 0) Then
                    sTimeElem = xmlNList2(0).InnerText
                    If (sTimeElem = "Unknown") Then
                        'do nothing -- Unknown times are deleted
                    Else
                        chkTime(sTimeElem) 'make sure the time string conforms to stated time convention
                        oSngTimeEnd.TimeOfDay = sTimeElem
                    End If
                End If
                cTimeColl.Add(oSngTimeEnd) 'put date/time info into collection
                If (cTimeColl.Count = 0) Then
                    'value is "Unknown"
                    oTime.boolSingle = True
                    oTime.boolRange = True
                End If
                If (cTimeColl.Count = 1) Then
                    'type is actually Single
                    oTime.boolSingle = True
                    oTime.boolRange = False
                End If
                Return
            End If

            xmlNList2 = xmlTimeNodes.SelectNodes("/timeinfo/rngdates/beggeol")
            If (xmlNList2.Count > 0) Then
                'working with Beginning Geologic Age
                oTime.Gregorian = False
                bTimeTypeSet = True
                sTimeElem = xmlTimeNodes.SelectSingleNode("/timeinfo/rngdates/beggeol").InnerXml
                xmlGeolNode.LoadXml(sTimeElem)
                openGeolAge(xmlGeolNode, oGeolBeg, bCheck)
                If (bCheck = True) Then
                    cTimeColl.Add(oGeolBeg) 'add the Geologic Age to the time period collection
                End If

                'working with Ending Geologic Age
                sTimeElem = xmlTimeNodes.SelectSingleNode("/timeinfo/rngdates/endgeol").InnerXml
                xmlGeolNode.LoadXml(sTimeElem)
                openGeolAge(xmlGeolNode, oGeolEnd, bCheck)
                If (bCheck = True) Then
                    cTimeColl.Add(oGeolEnd) 'add the Geologic Age to the time period collection
                End If
            End If 'end of geologic age
            If (cTimeColl.Count = 0) Then
                'value is "Unknown"
                oTime.boolSingle = True
                oTime.boolRange = True
            End If
            If (cTimeColl.Count = 1) Then
                'type is actually Single
                oTime.boolSingle = True
                oTime.boolRange = False
            End If
            Return
        End If 'end range of date/time instance

    End Sub

    Private Sub chkTime(ByRef sTime As String)
        Dim iPos As Integer
        Dim sConvFix1 As String = ""
        Dim sConvFix2 As String = ""

        sConvFix2 = "Time format converted to specified standard"

        'if local time is expected
        If (intTimeStyle = 1) Then
            'check for Universal Time
            iPos = sTime.IndexOf("Z") 'index starts at zero
            If (iPos > 0) Then
                'remove the Z
                sTime = sTime.Substring(0, iPos)
                sConvFix1 = "Universal Time converted to Local Time"
                MessageBox.Show(sConvFix1, sConvFix2, MessageBoxButtons.OK, MessageBoxIcon.Information)
                Return
            End If

            'check for Local + Differential
            iPos = sTime.IndexOf("+")
            If (iPos > 0) Then
                'remove the differential
                sTime = sTime.Substring(0, iPos)
                sConvFix1 = "Local + Differential Time converted to Local Time"
                MessageBox.Show(sConvFix1, sConvFix2, MessageBoxButtons.OK, MessageBoxIcon.Information)
                Return
            End If

            Return 'if already local time
        End If

        'if local + differential is expected
        If (intTimeStyle = 2) Then
            'check for Local + Differential
            iPos = sTime.IndexOf("+")
            If (iPos > 0) Then
                'right format!
                Return
            End If

            'check for Universal Time
            iPos = sTime.IndexOf("Z") 'index starts at zero
            If (iPos > 0) Then
                'remove the Z
                sTime = sTime.Substring(0, iPos)
                'add a placeholder differential
                sTime += "+0000"
                sConvFix1 = "Universal Time converted to Local Time + Differential"
                MessageBox.Show(sConvFix1, sConvFix2, MessageBoxButtons.OK, MessageBoxIcon.Information)
                Return
            End If

            'if local time, add a placeholder differential
            sTime += "+0000"
            sConvFix1 = "Local Time converted to Local Time + Differential"
            MessageBox.Show(sConvFix1, sConvFix2, MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        End If

        'if universal time is expected
        If (intTimeStyle = 3) Then
            'check for Universal Time
            iPos = sTime.IndexOf("Z") 'index starts at zero
            If (iPos > 0) Then
                'right format!
                Return
            End If

            'check for Local + Differential
            iPos = sTime.IndexOf("+")
            If (iPos > 0) Then
                'remove the differential, then add Z
                sTime = sTime.Substring(0, iPos)
                sTime += "Z"
                sConvFix1 = "Local + Differential Time converted to Universal Time"
                MessageBox.Show(sConvFix1, sConvFix2, MessageBoxButtons.OK, MessageBoxIcon.Information)
                Return
            End If

            'if local time, add a placeholder Z
            sTime += "Z"
            sConvFix1 = "Local Time converted to Universal Time"
            MessageBox.Show(sConvFix1, sConvFix2, MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        End If

    End Sub

    Private Sub openGeolAge(ByVal xmlGeolNode As XmlDocument, ByRef oGeol As GeolAge, ByRef bCheck As Boolean)
        'the root element of xmlGeolNode is <geolage>
        Dim xmlNList As XmlNodeList
        Dim xmlNList2 As XmlNodeList
        Dim iCount As Integer = 0
        Dim iCount2 As Integer = 0
        Dim iLoop As Integer = 0
        Dim sTimeElem As String = ""
        Dim xmlCiteNode As New XmlDocument 'for processing Geologic Citation
        Dim bCiteCheck As Boolean = False 'boolean for checking success of citation subroutine
        Dim bLWC As Boolean = False
        Dim oCite As New CiteInfo

        bCheck = False 'intialize subroutine success to False
        oGeol = New GeolAge
        'get the geologic time scale
        xmlNList = xmlGeolNode.SelectNodes("/geolage/geolscal")
        If (xmlNList.Count > 0) Then
            oGeol.TimeScale = xmlGeolNode.SelectSingleNode("/geolage/geolscal").InnerText
            bCheck = True
        End If
        'get the geologic age estimate
        xmlNList = xmlGeolNode.SelectNodes("/geolage/geolest")
        If (xmlNList.Count > 0) Then
            oGeol.Estim = xmlGeolNode.SelectSingleNode("/geolage/geolest").InnerText
            bCheck = True
        End If
        'get the geologic age uncertainty
        xmlNList = xmlGeolNode.SelectNodes("/geolage/geolun")
        If (xmlNList.Count > 0) Then
            oGeol.Uncert = xmlGeolNode.SelectSingleNode("/geolage/geolun").InnerText
            bCheck = True
        End If
        'get the geologic age explanation
        xmlNList = xmlGeolNode.SelectNodes("/geolage/geolexpl")
        If (xmlNList.Count > 0) Then
            oGeol.Explain = xmlGeolNode.SelectSingleNode("/geolage/geolexpl").InnerText
            bCheck = True
        End If
        'get any geologic citations
        xmlNList = xmlGeolNode.SelectNodes("/geolage/geolcit")
        If (xmlNList.Count > 0) Then
            bCheck = True
            iCount = xmlNList.Count - 1
            For iLoop = 0 To iCount
                'process the citation
                xmlCiteNode = New XmlDocument
                sTimeElem = xmlNList(iLoop).InnerXml
                xmlCiteNode.LoadXml(sTimeElem)
                'the InnerXml will get a citeinfo, including any larger work citation nodes
                'need to call the citeinfo processing routine, then place results into oGeol
                openCite(xmlCiteNode, oCite, bCiteCheck)
                If (bCiteCheck = True) Then
                    oGeol.GCiteAdd() 'add new citation to collection
                    iCount2 = oGeol.GCiteCount 'get index of the new citation
                    oGeol.GCiteUpdate(oCite, iCount2) 'update new citation with current citation info
                    'check for presence of a larger work citation
                    xmlNList2 = xmlCiteNode.SelectNodes("/citeinfo/lworkcit")
                    If (xmlNList2.Count > 0) Then
                        'process the larger work citation
                        sTimeElem = xmlCiteNode.SelectSingleNode("/citeinfo/lworkcit").InnerXml
                        xmlCiteNode.LoadXml(sTimeElem) 'holds the larger work citation
                        'the InnerXml will get the citeinfo under lworkcit
                        'need to call the citeinfo processing routine, then place results into oGeol
                        openCite(xmlCiteNode, oCite, bLWC)
                        If (bLWC = True) Then
                            oGeol.GLWCUpdate(bLWC, oCite, iCount2) 'update new citation with current LWC info
                        End If
                    End If 'end processing of larger work citation
                End If 'end processing of geologic citation
            Next
        End If 'ends handling of geologic age citations
    End Sub

#End Region


#Region " DOM processing routines for Contact Information section "

    Private Sub openContact(ByVal sContact As String, ByRef oContact As ContactInfo)
        Dim xmlContactDoc As New XmlDocument
        Dim xmlNlist As XmlNodeList
        Dim xmlPlist As XmlNodeList
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim kCount As Integer = 0
        Dim kLoop As Integer = 0
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim sAddress As String = ""

        xmlContactDoc.LoadXml(sContact)
        oContact = New ContactInfo

        'process Primary Contact
        xmlNlist = xmlContactDoc.SelectNodes("/cntinfo/cntperp")
        iCount = xmlNlist.Count
        If (iCount > 0) Then
            'Contact Person Primary
            oContact.PrimaryPerson = True
            xmlPlist = xmlNlist(0).SelectNodes("cntper")
            If (xmlPlist.Count > 0) Then 'fill in contact person
                s1 = xmlPlist(0).InnerText.Trim
                oContact.Person = s1
            End If
            xmlPlist = xmlNlist(0).SelectNodes("cntorg")
            If (xmlPlist.Count > 0) Then 'fill in contact organization
                s1 = xmlPlist(0).InnerText.Trim
                oContact.Organization = s1
            End If
        Else
            xmlNlist = xmlContactDoc.SelectNodes("/cntinfo/cntorgp")
            kCount = xmlNlist.Count
            If (kCount > 0) Then
                'Contact Organization Primary
                oContact.PrimaryPerson = False
                xmlPlist = xmlNlist(0).SelectNodes("cntorg")
                If (xmlPlist.Count > 0) Then 'fill in contact organization
                    s1 = xmlPlist(0).InnerText.Trim
                    If (s1 = sKdelim) Then s1 = ""
                    oContact.Organization = s1
                End If
                xmlPlist = xmlNlist(0).SelectNodes("cntper")
                If (xmlPlist.Count > 0) Then 'fill in contact person
                    s1 = xmlPlist(0).InnerText.Trim
                    If (s1 = sKdelim) Then s1 = ""
                    oContact.Person = s1
                End If
            End If
        End If

        'Contact Position, if present
        xmlNlist = xmlContactDoc.SelectNodes("/cntinfo/cntpos")
        If (xmlNlist.Count > 0) Then
            s1 = xmlNlist(0).InnerText.Trim
            If (s1 = sKdelim) Then s1 = ""
            oContact.Position = s1
        End If

        'process Contact Address
        xmlNlist = xmlContactDoc.SelectNodes("/cntinfo/cntaddr")
        iCount = xmlNlist.Count - 1
        For iLoop = 0 To iCount
            'build the address string
            sAddress = ""
            xmlPlist = xmlNlist(iLoop).SelectNodes("addrtype") 'get address type
            If (xmlPlist.Count > 0) Then
                sAddress += xmlPlist(0).InnerText.Trim
            End If
            sAddress += sPdelim
            xmlPlist = xmlNlist(iLoop).SelectNodes("address") 'get the address line(s)
            kCount = xmlPlist.Count - 1
            s1 = ""
            For kLoop = 0 To kCount
                s1 += xmlPlist(kLoop).InnerText.Trim & sKdelim
            Next
            sAddress += s1 & sPdelim
            xmlPlist = xmlNlist(iLoop).SelectNodes("city") 'get city
            If (xmlPlist.Count > 0) Then
                sAddress += xmlPlist(0).InnerText.Trim
            End If
            sAddress += sPdelim
            xmlPlist = xmlNlist(iLoop).SelectNodes("state") 'get state or province
            If (xmlPlist.Count > 0) Then
                sAddress += xmlPlist(0).InnerText.Trim
            End If
            sAddress += sPdelim
            xmlPlist = xmlNlist(iLoop).SelectNodes("postal") 'get postal code
            If (xmlPlist.Count > 0) Then
                sAddress += xmlPlist(0).InnerText.Trim
            End If
            sAddress += sPdelim
            xmlPlist = xmlNlist(iLoop).SelectNodes("country") 'get country
            If (xmlPlist.Count > 0) Then
                sAddress += xmlPlist(0).InnerText.Trim
            End If
            If (sAddress.Length > 6) Then
                oContact.AddressAdd(sAddress) 'put completed address into collection of addresses
            End If
        Next

        'process Voice Telephone
        xmlNlist = xmlContactDoc.SelectNodes("/cntinfo/cntvoice")
        iCount = xmlNlist.Count - 1
        sAddress = ""
        For iLoop = 0 To iCount
            'build the voice telephone string
            sAddress += xmlNlist(iLoop).InnerText.Trim & sKdelim
        Next
        oContact.VoiceTel = sAddress 'put completed telephone set into object

        'process TDD/TTY Telephone
        xmlNlist = xmlContactDoc.SelectNodes("/cntinfo/cnttdd")
        iCount = xmlNlist.Count - 1
        sAddress = ""
        For iLoop = 0 To iCount
            'build the TDD telephone string
            sAddress += xmlNlist(iLoop).InnerText.Trim & sKdelim
        Next
        oContact.TDDtel = sAddress 'put completed TDD telephone set into object

        'process Fax Telephone
        xmlNlist = xmlContactDoc.SelectNodes("/cntinfo/cntfax")
        iCount = xmlNlist.Count - 1
        sAddress = ""
        For iLoop = 0 To iCount
            'build the fax telephone string
            sAddress += xmlNlist(iLoop).InnerText.Trim & sKdelim
        Next
        oContact.FaxTel = sAddress 'put completed fax telephone set into object

        'process E-mail address(es)
        xmlNlist = xmlContactDoc.SelectNodes("/cntinfo/cntemail")
        iCount = xmlNlist.Count - 1
        sAddress = ""
        For iLoop = 0 To iCount
            'build the e-mail string
            sAddress += xmlNlist(iLoop).InnerText.Trim & sKdelim
        Next
        oContact.Email = sAddress 'put completed e-mail set into object

        'process Hours of Service
        xmlNlist = xmlContactDoc.SelectNodes("/cntinfo/hours")
        If (xmlNlist.Count > 0) Then
            oContact.Hours = xmlNlist(0).InnerText.Trim
        End If

        'process Contact Instructions
        xmlNlist = xmlContactDoc.SelectNodes("/cntinfo/cntinst")
        If (xmlNlist.Count > 0) Then
            oContact.Instructions = xmlNlist(0).InnerText.Trim
        End If
    End Sub

#End Region



#Region " Handling routines for ID Info section "

    Private Sub btnIDCite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnIDCite.Click
        Dim s1 As String = ""
        'invokes the Citation details form
        Dim frmCiteDetails As New frmCiteInfo(objCitation, objCitationLWork, bCitationLWork, intTimeStyle)
        frmCiteDetails.ShowDialog()
        If (frmCiteDetails.bUpdate = True) Then
            objCitation = frmCiteDetails.newCite
            s1 = objCitation.Author
            objCitation.Author = fixStringCrLf(s1)
            bCitationLWork = frmCiteDetails.bLWC
            If (bCitationLWork = True) Then
                objCitationLWork = frmCiteDetails.newLWC
                s1 = objCitationLWork.Author
                objCitationLWork.Author = fixStringCrLf(s1)
            End If
        End If
        txtIDCiteAuth.Text = objCitation.Author
        txtIDCiteDate.Text = objCitation.PubDate
        txtIDCiteTitle.Text = objCitation.Title
    End Sub

    'Spatial Domain tab
    Private Sub btnAddPoly_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddPoly.Click
        Dim iCount As Integer = 0
        Dim iLoop As Integer = 0
        Dim iPolyCount As Integer = 0
        Dim iExclCount As Integer = 0
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim sList As String = ""
        Dim frmNewGPoly As New frmGPoly

        frmNewGPoly.ShowDialog()
        If (frmNewGPoly.bChange = True) Then
            iCount = frmNewGPoly.sPolyCol.Count 'number of strings in the collection
            iExclCount = CInt((iCount - 2) / 2) 'number of exclusion polygons for this data set G-polygon
            For iLoop = 0 To iCount - 1
                sDataSetGPoly.Add(frmNewGPoly.sPolyCol(iLoop)) 'transfer each string to the local collection
            Next
            sCountGPoly.Add(iExclCount.ToString)
            s1 = frmNewGPoly.sPolyCol(0)
            s2 = frmNewGPoly.sPolyCol(1)
            sList = s1 & ": " & Microsoft.VisualBasic.Left(s2, 32)
            sList = sList.Replace(sPdelim, "  ")
            lboxGPoly.Items.Add(sList) 'add data set polygon to list box (outer g-ring)
        End If
    End Sub

    Private Sub btnEditPoly_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditPoly.Click
        Dim iSelInd As Integer = 0 'selection index for polygon list box
        Dim iToStart As Integer = 0
        Dim iToDelete As Integer = 0
        Dim iLoop As Integer = 0

        Dim iCount As Integer = 0
        Dim iPolyCount As Integer = 0
        Dim iExclCount As Integer = 0
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim sList As String = ""

        iCount = lboxGPoly.Items.Count
        iSelInd = lboxGPoly.SelectedIndex
        If (iCount = 1) Then iSelInd = 0
        If (iSelInd = -1) Then
            MessageBox.Show("No polygon selected for editing", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        Dim sToEdit As New StringCollection
        If (iSelInd > 0) Then
            For iLoop = 0 To iSelInd - 1 'count number of collection elements preceding start of polygon to edit
                iToStart += CInt(sCountGPoly(iLoop)) * 2 + 2
            Next
        End If
        iToDelete = 2 + 2 * CInt(sCountGPoly(iSelInd)) 'number of strings in the collection for the polygon to edit
        iPolyCount = iToStart + iToDelete - 1
        For iLoop = iToStart To iPolyCount
            sToEdit.Add(sDataSetGPoly(iLoop)) 'create string collection for polygon to edit
        Next

        Dim frmNewGPoly As New frmGPoly(sToEdit)
        frmNewGPoly.ShowDialog()
        If (frmNewGPoly.bChange = True) Then
            'delete the old version
            lboxGPoly.Items.RemoveAt(iSelInd) 'delete polygon from list box
            For iLoop = 1 To iToDelete
                sDataSetGPoly.RemoveAt(iToStart) 'delete type descriptors and descriptions of polygon & exclusions
            Next
            sCountGPoly.RemoveAt(iSelInd) 'delete count of exclusion polygons from its collection

            'append the new version
            iCount = frmNewGPoly.sPolyCol.Count 'number of strings in the collection
            iExclCount = CInt((iCount - 2) / 2) 'number of exclusion polygons for this data set G-polygon
            For iLoop = 0 To iCount - 1
                sDataSetGPoly.Add(frmNewGPoly.sPolyCol(iLoop)) 'transfer each string to the local collection
            Next
            sCountGPoly.Add(iExclCount.ToString)
            s1 = frmNewGPoly.sPolyCol(0)
            s2 = frmNewGPoly.sPolyCol(1)
            sList = s1 & ": " & Microsoft.VisualBasic.Left(s2, 32)
            sList = sList.Replace(sPdelim, "  ")
            lboxGPoly.Items.Add(sList) 'add data set polygon to list box (outer g-ring)
        End If

    End Sub

    Private Sub btnDelPoly_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelPoly.Click
        Dim iSelInd As Integer = 0 'selection index for polygon list box
        Dim iToStart As Integer = 0
        Dim iToDelete As Integer = 0
        Dim iLoop As Integer = 0

        iSelInd = lboxGPoly.SelectedIndex
        If (iSelInd = -1) Then
            MessageBox.Show("No polygon selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            lboxGPoly.Items.RemoveAt(iSelInd) 'delete polygon from list box
            If (iSelInd > 0) Then
                For iLoop = 0 To iSelInd - 1 'count number of collection elements preceding start of polygon to delete
                    iToStart += CInt(sCountGPoly(iLoop)) * 2 + 2
                Next
            End If
            iToDelete = 2 + 2 * CInt(sCountGPoly(iSelInd)) 'number of strings in the collection for the polygon
            For iLoop = 1 To iToDelete
                sDataSetGPoly.RemoveAt(iToStart) 'delete type descriptors and descriptions of polygon & exclusions
            Next
            sCountGPoly.RemoveAt(iSelInd) 'delete count of exclusion polygons from its collection
        End If

    End Sub


#End Region


#Region " Handling of Keywords panel "

    Private Sub btnThemeAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnThemeAdd.Click
        Dim sKeyArray() As String
        Dim sList As String
        Dim frmTheme As New frmKeywords("Theme")
        frmTheme.ShowDialog()
        If (frmTheme.bChange = True) Then
            sKeyTheme.Add(frmTheme.sKeyDesc) 'add theme keyword info to collection
            sKeyArray = Split(frmTheme.sKeyDesc, sPdelim)
            sList = "thesaurus: " & sKeyArray(0) & "   keywords: " & sKeyArray(1)
            sList = sList.Replace(sKdelim, "; ")
            lboxKTheme.Items.Add(sList) 'add formatted info to listbox
        End If
    End Sub

    Private Sub btnThemeEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnThemeEdit.Click
        Dim sKeyArray() As String
        Dim sList As String
        Dim sToEdit As String
        Dim iCount As Integer = lboxKTheme.Items.Count
        Dim iSelInd As Integer = lboxKTheme.SelectedIndex
        If (iCount = 1) Then iSelInd = 0
        If (iSelInd = -1) Then
            MessageBox.Show("No theme selected for editing", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            sToEdit = sKeyTheme(iSelInd)
            Dim frmTheme As New frmKeywords("Theme", sToEdit)
            frmTheme.ShowDialog()
            If (frmTheme.bChange = True) Then
                sKeyTheme.Insert(iSelInd, frmTheme.sKeyDesc) 'put revised theme keyword info to collection
                sKeyTheme.RemoveAt(iSelInd + 1) 'delete selected theme from collection
                sKeyArray = Split(frmTheme.sKeyDesc, sPdelim)
                sList = "thesaurus: " & sKeyArray(0) & "   keywords: " & sKeyArray(1)
                sList = sList.Replace(sKdelim, "; ")
                lboxKTheme.Items.Insert(iSelInd, sList) 'put revised formatted info to listbox
                lboxKTheme.Items.RemoveAt(iSelInd + 1) 'delete selected theme from listbox
            End If
        End If
    End Sub

    Private Sub btnThemeDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnThemeDelete.Click
        Dim iSelInd As Integer = 0
        iSelInd = lboxKTheme.SelectedIndex
        If (iSelInd = -1) Then
            MessageBox.Show("No theme selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            sKeyTheme.RemoveAt(iSelInd)  'delete selected theme from collection
            lboxKTheme.Items.RemoveAt(iSelInd)  'delete selected theme from listbox
        End If
    End Sub

    Private Sub btnPlaceAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPlaceAdd.Click
        Dim sKeyArray() As String
        Dim sList As String
        Dim frmPlace As New frmKeywords("Place")
        frmPlace.ShowDialog()
        If (frmPlace.bChange = True) Then
            sKeyPlace.Add(frmPlace.sKeyDesc) 'add theme keyword info to collection
            sKeyArray = Split(frmPlace.sKeyDesc, sPdelim)
            sList = "thesaurus: " & sKeyArray(0) & "   keywords: " & sKeyArray(1)
            sList = sList.Replace(sKdelim, "; ")
            lboxKPlace.Items.Add(sList) 'add formatted info to listbox
        End If
    End Sub

    Private Sub btnPlaceEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPlaceEdit.Click
        Dim sKeyArray() As String
        Dim sList As String
        Dim sToEdit As String
        Dim iCount As Integer = lboxKPlace.Items.Count
        Dim iSelInd As Integer = lboxKPlace.SelectedIndex
        If (iCount = 1) Then iSelInd = 0
        If (iSelInd = -1) Then
            MessageBox.Show("No place selected", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            sToEdit = sKeyPlace(iSelInd)
            Dim frmPlace As New frmKeywords("Place", sToEdit)
            frmPlace.ShowDialog()
            If (frmPlace.bChange = True) Then
                sKeyPlace.Insert(iSelInd, frmPlace.sKeyDesc) 'put revised theme keyword info to collection
                sKeyPlace.RemoveAt(iSelInd + 1) 'delete selected theme from collection
                sKeyArray = Split(frmPlace.sKeyDesc, sPdelim)
                sList = "thesaurus: " & sKeyArray(0) & "   keywords: " & sKeyArray(1)
                sList = sList.Replace(sKdelim, "; ")
                lboxKPlace.Items.Insert(iSelInd, sList) 'put revised formatted info to listbox
                lboxKPlace.Items.RemoveAt(iSelInd + 1) 'delete selected theme from listbox
            End If
        End If
    End Sub

    Private Sub btnPlaceDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPlaceDelete.Click
        Dim iSelInd As Integer = 0
        iSelInd = lboxKPlace.SelectedIndex
        If (iSelInd = -1) Then
            MessageBox.Show("No place selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            sKeyPlace.RemoveAt(iSelInd)  'delete selected theme from collection
            lboxKPlace.Items.RemoveAt(iSelInd)  'delete selected theme from listbox
        End If
    End Sub

    Private Sub btnStratumAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStratumAdd.Click
        Dim sKeyArray() As String
        Dim sList As String
        Dim frmStratum As New frmKeywords("Stratum")
        frmStratum.ShowDialog()
        If (frmStratum.bChange = True) Then
            sKeyStratum.Add(frmStratum.sKeyDesc) 'add theme keyword info to collection
            sKeyArray = Split(frmStratum.sKeyDesc, sPdelim)
            sList = "thesaurus: " & sKeyArray(0) & "   keywords: " & sKeyArray(1)
            sList = sList.Replace(sKdelim, "; ")
            lboxKStratum.Items.Add(sList) 'add formatted info to listbox
        End If
    End Sub

    Private Sub btnStratumEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStratumEdit.Click
        Dim sKeyArray() As String
        Dim sList As String
        Dim sToEdit As String
        Dim iCount As Integer = lboxKStratum.Items.Count
        Dim iSelInd As Integer = lboxKStratum.SelectedIndex
        If (iCount = 1) Then iSelInd = 0
        If (iSelInd = -1) Then
            MessageBox.Show("No stratum selected for editing", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            sToEdit = sKeyStratum(iSelInd)
            Dim frmStratum As New frmKeywords("Stratum", sToEdit)
            frmStratum.ShowDialog()
            If (frmStratum.bChange = True) Then
                sKeyStratum.Insert(iSelInd, frmStratum.sKeyDesc) 'put revised theme keyword info to collection
                sKeyStratum.RemoveAt(iSelInd + 1) 'delete selected theme from collection
                sKeyArray = Split(frmStratum.sKeyDesc, sPdelim)
                sList = "thesaurus: " & sKeyArray(0) & "   keywords: " & sKeyArray(1)
                sList = sList.Replace(sKdelim, "; ")
                lboxKStratum.Items.Insert(iSelInd, sList) 'put revised formatted info to listbox
                lboxKStratum.Items.RemoveAt(iSelInd + 1) 'delete selected theme from listbox
            End If
        End If
    End Sub

    Private Sub btnStratumDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStratumDelete.Click
        Dim iSelInd As Integer = 0
        iSelInd = lboxKStratum.SelectedIndex
        If (iSelInd = -1) Then
            MessageBox.Show("No stratum selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            sKeyStratum.RemoveAt(iSelInd)  'delete selected theme from collection
            lboxKStratum.Items.RemoveAt(iSelInd)  'delete selected theme from listbox
        End If
    End Sub

    Private Sub btnTemporalAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTemporalAdd.Click
        Dim sKeyArray() As String
        Dim sList As String
        Dim frmTemporal As New frmKeywords("Temporal")
        frmTemporal.ShowDialog()
        If (frmTemporal.bChange = True) Then
            sKeyTemporal.Add(frmTemporal.sKeyDesc) 'add theme keyword info to collection
            sKeyArray = Split(frmTemporal.sKeyDesc, sPdelim)
            sList = "thesaurus: " & sKeyArray(0) & "   keywords: " & sKeyArray(1)
            sList = sList.Replace(sKdelim, "; ")
            lboxKTemporal.Items.Add(sList) 'add formatted info to listbox
        End If
    End Sub

    Private Sub btnTemporalEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTemporalEdit.Click
        Dim sKeyArray() As String
        Dim sList As String
        Dim sToEdit As String
        Dim iCount As Integer = lboxKTemporal.Items.Count
        Dim iSelInd As Integer = lboxKTemporal.SelectedIndex
        If (iCount = 1) Then lboxKTemporal.SelectedIndex = 0
        If (iSelInd = -1) Then
            MessageBox.Show("No temporal keyword set selected for editing", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            sToEdit = sKeyTemporal(iSelInd)
            Dim frmTemporal As New frmKeywords("Temporal", sToEdit)
            frmTemporal.ShowDialog()
            If (frmTemporal.bChange = True) Then
                sKeyTemporal.Insert(iSelInd, frmTemporal.sKeyDesc) 'put revised theme keyword info to collection
                sKeyTemporal.RemoveAt(iSelInd + 1) 'delete selected theme from collection
                sKeyArray = Split(frmTemporal.sKeyDesc, sPdelim)
                sList = "thesaurus: " & sKeyArray(0) & "   keywords: " & sKeyArray(1)
                sList = sList.Replace(sKdelim, "; ")
                lboxKTemporal.Items.Insert(iSelInd, sList) 'put revised formatted info to listbox
                lboxKTemporal.Items.RemoveAt(iSelInd + 1) 'delete selected theme from listbox
            End If
        End If
    End Sub

    Private Sub btnTemporalDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTemporalDelete.Click
        Dim iSelInd As Integer = 0
        iSelInd = lboxKTemporal.SelectedIndex
        If (iSelInd = -1) Then
            MessageBox.Show("No temporal keyword set selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            sKeyTemporal.RemoveAt(iSelInd)  'delete selected theme from collection
            lboxKTemporal.Items.RemoveAt(iSelInd)  'delete selected theme from listbox
        End If
    End Sub

#End Region


#Region " Handling routines for Time Period Information panel "

    Private Sub btnTimeAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTimeAdd.Click
        Dim iCount As Integer = IDtimeper.Count
        Dim strNewDate As String = ""
        Dim sError As String = ""
        If (rdoTLocal.Checked = True) Then  'process Gregorian dates
            If (rdoTUnknown.Checked = True) Then
                sError = "Please specify Single, Multiple, or Range of Dates"
                MessageBox.Show(sError, "Date/Time error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            End If
            If (rdoTSingle.Checked = True And iCount = 1) Then
                sError = "Can't add another date to single date/time"
                MessageBox.Show(sError, "Add date error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            End If
            If (rdoTRange.Checked = False) Then  'add and update 1 date/time
                Dim dSingle As New SngDateTime
                Dim frmTDate As New frmTimePeriod(intTimeStyle, dSingle)
                frmTDate.ShowDialog()
                If (frmTDate.bChange = False) Then
                Else
                    dSingle = frmTDate.begDate
                    IDtimeper.Add(dSingle)
                    strNewDate = dSingle.SngDate & "  " & dSingle.TimeOfDay
                    lboxTime.Items.Add(strNewDate)
                End If
            Else
                If (rdoTRange.Checked = True And iCount > 1) Then
                    MessageBox.Show("Can only have 1 date range.", "Add date range error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Return
                End If
                Dim dBegin As New SngDateTime     'add and update date/time range
                Dim dEnding As New SngDateTime
                Dim frmTDate As New frmTimePeriod(intTimeStyle, dBegin, dEnding)
                frmTDate.ShowDialog()
                If (frmTDate.bChange = False) Then
                Else
                    dBegin = frmTDate.begDate
                    dEnding = frmtdate.endDate
                    IDtimeper.Add(dBegin)
                    IDtimeper.Add(dEnding)
                    strNewDate = "begin: " & dBegin.SngDate & "  " & "end: " & dEnding.SngDate
                    lboxTime.Items.Add(strNewDate)
                End If
            End If
        Else                              'process Geologic Age dates
            If (rdoTUnknown.Checked = True) Then
                sError = "Please specify Single, Multiple, or Range of Dates"
                MessageBox.Show(sError, "Date/Time error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            End If
            If (rdoTSingle.Checked = True And iCount = 1) Then
                MessageBox.Show("Can't add another Age to single Geologic Age", "Add Geologic Age", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            End If
            If (rdoTRange.Checked = False) Then  'add and update 1 Geologic Age
                Dim dSingle As New GeolAge
                Dim frmTDate As New frmGeolAge(dSingle)
                frmTDate.ShowDialog()
                If (frmTDate.bChange = False) Then
                Else
                    dSingle = frmTDate.beggeol
                    IDtimeper.Add(dSingle)
                    strNewDate = dSingle.TimeScale & "  " & dSingle.Estim
                    lboxTime.Items.Add(strNewDate)
                End If
            Else
                If (rdoTRange.Checked = True And iCount > 1) Then
                    MessageBox.Show("Can only have 1 Geologic Age range.", "Add Geologic Age range error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Return
                End If
                Dim dBegin As New GeolAge     'add and update Geologic Age range
                Dim dEnding As New GeolAge
                Dim frmTDate As New frmGeolAge(dBegin, dEnding)
                frmTDate.ShowDialog()
                If (frmTDate.bChange = False) Then
                Else
                    dBegin = frmTDate.beggeol
                    dEnding = frmtdate.endGeol
                    IDtimeper.Add(dBegin)
                    IDtimeper.Add(dEnding)
                    strNewDate = "begin: " & dBegin.Estim & "  " & "end: " & dEnding.Estim
                    lboxTime.Items.Add(strNewDate)
                End If
            End If
        End If
    End Sub

    Private Sub btnTimeEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTimeEdit.Click
        Dim iCount As Integer = IDtimeper.Count
        Dim iToEdit1 As Integer = 0
        Dim iToEdit2 As Integer = 0
        Dim iToRemove As Integer = 0
        Dim strNewDate As String = ""
        Dim strError As String = ""

        If (iCount = 0) Then 'Edit button pressed by mistake -- no entries to edit
            strError = "There are no Time Period entries to edit."
            MessageBox.Show(strError, "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        End If
        If (rdoTLocal.Checked = True) Then  'Gregorian dates section
            If (rdoTSingle.Checked = True) Then 'Edits a single date
                Dim dSingle As New SngDateTime
                dsingle = CType(IDtimeper(1), SngDateTime)
                Dim frmTDate1 As New frmTimePeriod(intTimeStyle, dSingle)
                frmTDate1.ShowDialog()
                If (frmTDate1.bChange = False) Then 'update was cancelled
                Else
                    dSingle = frmTDate1.begDate          'get updated single date/time
                    IDtimeper.Remove(1)                  'clear existing single date/time
                    lboxTime.Items.Clear()
                    IDtimeper.Add(dSingle)               'add updated single date/time to collection and form
                    strNewDate = dSingle.SngDate & "  " & dSingle.TimeOfDay
                    lboxTime.Items.Add(strNewDate)
                End If
                Return
            End If
            If (rdoTMult.Checked = True) Then  'Edits member of multiple date/time collection
                Dim dSingle As New SngDateTime
                iToEdit1 = lboxTime.SelectedIndex 'zero-based index
                If (iToEdit1 = -1) Then
                    strError = "One of the Time Period entries must be selected for editing."
                    MessageBox.Show(strError, "Date editing selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Return
                End If
                dsingle = CType(IDtimeper(iToEdit1 + 1), SngDateTime) 'collection is one-based index
                Dim frmTDate2 As New frmTimePeriod(intTimeStyle, dSingle)
                frmTDate2.ShowDialog()
                If (frmTDate2.bChange = False) Then 'update was cancelled
                Else
                    dSingle = frmTDate2.begDate             'get updated date/time entry
                    IDtimeper.Add(dsingle, , iToEdit1 + 1)  'add to collection before original version of entry
                    IDtimeper.Remove(iToEdit1 + 2)          'remove old version of entry from collection
                    strNewDate = dSingle.SngDate & "  " & dSingle.TimeOfDay
                    lboxTime.Items.Insert(iToEdit1, strNewDate)  'insert edited entry into listbox
                    lboxTime.Items.RemoveAt(iToEdit1 + 1)        'remove old version from listbox
                End If
                Return
            End If
            If (rdoTRange.Checked = True) Then     'Edits a date/time range
                Dim dBegin As New SngDateTime
                Dim dEnding As New SngDateTime
                dBegin = CType(IDtimeper(1), SngDateTime)
                dEnding = CType(IDtimeper(2), SngDateTime)
                Dim frmTDate As New frmTimePeriod(intTimeStyle, dBegin, dEnding)
                frmTDate.ShowDialog()
                If (frmTDate.bChange = False) Then 'update was cancelled
                Else
                    dBegin = frmTDate.begDate            'get updated date/time range
                    dEnding = frmTDate.endDate
                    IDtimeper.Remove(2)                  'remove old range entries from collection and listbox
                    IDtimeper.Remove(1)
                    lboxTime.Items.Clear()
                    IDtimeper.Add(dBegin)                 'add new range entries to collection and listbox
                    IDtimeper.Add(dEnding)
                    strNewDate = "begin: " & dBegin.SngDate & "  " & "end: " & dEnding.SngDate
                    lboxTime.Items.Add(strNewDate)
                End If
                Return
            End If
        Else        'process Geologic Ages
            If (rdoTSingle.Checked = True) Then 'Edits a single Geologic Age
                Dim dSingle As New GeolAge
                dSingle = CType(IDtimeper(1), GeolAge)
                Dim frmTGeol1 As New frmGeolAge(dsingle)
                frmTGeol1.ShowDialog()
                If (frmTGeol1.bChange = False) Then 'update was cancelled
                Else
                    dSingle = frmTGeol1.begGeol          'get updated single date/time
                    IDtimeper.Remove(1)                  'clear existing single date/time
                    lboxTime.Items.Clear()
                    IDtimeper.Add(dSingle)               'add updated single date/time to collection and form
                    strNewDate = dSingle.TimeScale & "  " & dSingle.Estim
                    lboxTime.Items.Add(strNewDate)
                End If
                Return
            End If
            If (rdoTMult.Checked = True) Then  'Edits member of multiple Geologic Age collection
                Dim dSingle As New GeolAge
                iToEdit1 = lboxTime.SelectedIndex 'zero-based index
                If (iToEdit1 = -1) Then
                    strError = "One of the Time Period entries must be selected for editing."
                    MessageBox.Show(strError, "Date editing selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Return
                End If
                dSingle = CType(IDtimeper(iToEdit1 + 1), GeolAge) 'collection is one-based index
                Dim frmTGeol2 As New frmGeolAge(dSingle)
                frmTGeol2.ShowDialog()
                If (frmTGeol2.bChange = False) Then 'update was cancelled
                Else
                    dSingle = frmTGeol2.begGeol             'get updated date/time entry
                    IDtimeper.Add(dsingle, , iToEdit1 + 1)  'add to collection before original version of entry
                    IDtimeper.Remove(iToEdit1 + 2)          'remove old version of entry from collection
                    strNewDate = dSingle.TimeScale & "  " & dSingle.Estim
                    lboxTime.Items.Insert(iToEdit1, strNewDate)  'insert edited entry into listbox
                    lboxTime.Items.RemoveAt(iToEdit1 + 1)        'remove old version from listbox
                End If
                Return
            End If
            If (rdoTRange.Checked = True) Then     'Edits a Geologic Age range
                Dim dBegin As New GeolAge
                Dim dEnding As New GeolAge
                dBegin = CType(IDtimeper(1), GeolAge)
                dEnding = CType(IDtimeper(2), GeolAge)
                Dim frmTGeol As New frmGeolAge(dBegin, dEnding)
                frmTGeol.ShowDialog()
                If (frmTGeol.bChange = False) Then 'update was cancelled
                Else
                    dBegin = frmTGeol.begGeol            'get updated date/time range
                    dEnding = frmTGeol.endGeol
                    IDtimeper.Remove(2)                  'remove old range entries from collection and listbox
                    IDtimeper.Remove(1)
                    lboxTime.Items.Clear()
                    IDtimeper.Add(dBegin)                 'add new range entries to collection and listbox
                    IDtimeper.Add(dEnding)
                    strNewDate = "begin: " & dBegin.Estim & "  " & "end: " & dEnding.Estim
                    lboxTime.Items.Add(strNewDate)
                End If
                Return
            End If
        End If
    End Sub

    Private Sub btnTimeDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTimeDelete.Click
        Dim iCount As Integer = IDtimeper.Count
        Dim iToRemove As Integer = 0
        If (iCount = 0) Then 'Delete button pressed by mistake -- no entries to delete
            MessageBox.Show("There are no time period entries to delete", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (rdoTSingle.Checked = True) Then 'Deletes a single date
            IDtimeper.Remove(1)
            lboxTime.Items.Clear()
            Return
        End If
        If (rdoTRange.Checked = True) Then 'Deletes a range
            IDtimeper.Remove(2)
            IDtimeper.Remove(1)
            lboxTime.Items.Clear()
            Return
        End If
        iToRemove = lboxTime.SelectedIndex 'zero-based index
        If (iToRemove = -1) Then
            Dim sDelError As String = "No time period selected for deletion"
            MessageBox.Show(sDelError, "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        IDtimeper.Remove(iToRemove + 1)
        lboxTime.Items.RemoveAt(iToRemove)
    End Sub

    Private Sub rdoTSingle_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles rdoTSingle.Click
        Dim iCount As Integer = IDtimeper.Count
        Dim iLoop As Integer = 0
        Dim dSingle As New SngDateTime
        Dim gSingle As New GeolAge
        Dim strNewDate As String = ""

        If (rdoTLocal.Checked = True) Then  'process Gregorian date/time
            If (rdoTSingle.Checked = True And iCount > 1) Then 'bring collection & list into conformance with being Single
                dSingle = CType(IDtimeper(1), SngDateTime)
                strNewDate = dSingle.SngDate & "  " & dSingle.TimeOfDay
                IDtimeper = New Collection
                IDtimeper.Add(dSingle)
                lboxTime.Items.Clear()
                lboxTime.Items.Add(strNewDate)
            End If
        Else                               'process Geologic Age
            If (rdoTSingle.Checked = True And iCount > 1) Then 'bring collection & list into conformance with being Single
                gSingle = CType(IDtimeper(1), GeolAge)
                strNewDate = gSingle.TimeScale & "  " & gSingle.Estim
                IDtimeper = New Collection
                IDtimeper.Add(gSingle)
                lboxTime.Items.Clear()
                lboxTime.Items.Add(strNewDate)
            End If
        End If
    End Sub

    Private Sub rdoTMult_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles rdoTMult.Click
        Dim iCount As Integer = IDtimeper.Count
        Dim iLoop As Integer = 0
        Dim strNewDate As String = ""
        Dim strNewDate2 As String = ""

        If (rdoTLocal.Checked = True) Then  'process Gregorian date/time
            If (rdoTMult.Checked = True And iCount = 2) Then
                Dim dBegin As New SngDateTime
                Dim dEnding As New SngDateTime
                dBegin = CType(IDtimeper(1), SngDateTime)
                dEnding = CType(IDtimeper(iCount), SngDateTime)
                strNewDate = dBegin.SngDate & "  " & dBegin.TimeOfDay
                strNewDate2 = dEnding.SngDate & "  " & dEnding.TimeOfDay
                lboxTime.Items.Clear()
                lboxTime.Items.Add(strNewDate)
                lboxTime.Items.Add(strNewDate2)
            End If
        Else                               'process Geologic Age
            If (rdoTMult.Checked = True And iCount = 2) Then
                Dim dBegin As New GeolAge
                Dim dEnding As New GeolAge
                dBegin = CType(IDtimeper(1), GeolAge)
                dEnding = CType(IDtimeper(iCount), GeolAge)
                strNewDate = dBegin.TimeScale & "  " & dBegin.Estim
                strNewDate2 = dEnding.TimeScale & "  " & dEnding.Estim
                lboxTime.Items.Clear()
                lboxTime.Items.Add(strNewDate)
                lboxTime.Items.Add(strNewDate2)
            End If
        End If
    End Sub

    Private Sub rdoTRange_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles rdoTRange.Click
        Dim iCount As Integer = IDtimeper.Count
        Dim iLoop As Integer = 0
        Dim strNewDate As String = ""

        If (rdoTLocal.Checked = True) Then   'process Gregorian date/time
            If (rdoTRange.Checked = True And iCount > 0) Then
                Dim dBegin As New SngDateTime
                Dim dEnding As New SngDateTime
                dBegin = CType(IDtimeper(1), SngDateTime)
                dEnding = CType(IDtimeper(iCount), SngDateTime)
                strNewDate = "begin: " & dBegin.SngDate & "  " & "end: " & dEnding.SngDate
                IDtimeper = New Collection
                IDtimeper.Add(dBegin)
                IDtimeper.Add(dEnding)
                lboxTime.Items.Clear()
                lboxTime.Items.Add(strNewDate)
            End If
        Else                                  'process Geologic Age
            If (rdoTRange.Checked = True And iCount > 0) Then
                Dim dBegin As New GeolAge
                Dim dEnding As New GeolAge
                dBegin = CType(IDtimeper(1), GeolAge)
                dEnding = CType(IDtimeper(iCount), GeolAge)
                strNewDate = "begin: " & dBegin.Estim & "  " & "end: " & dEnding.Estim
                IDtimeper = New Collection
                IDtimeper.Add(dBegin)
                IDtimeper.Add(dEnding)
                lboxTime.Items.Clear()
                lboxTime.Items.Add(strNewDate)
            End If
        End If
    End Sub

    Private Sub rdoTUnknown_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles rdoTUnknown.Click
        'initialize the controls
        lboxTime.Items.Clear()
        IDtimeper = New Collection
    End Sub

    Private Sub rdoTLocal_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles rdoTLocal.Click
        Dim iCount As Integer = IDtimeper.Count
        Dim objTest1 As New SngDateTime
        Dim objTest2 As New GeolAge

        If (iCount = 0) Then  'if no objects in collection, then no update necessary
            Return
        End If

        If (IDtimeper(1).GetType Is objTest1.GetType) Then 'click selects Gregorian; already in that type 
            Return
        ElseIf (IDtimeper(1).GetType Is objTest2.GetType) Then 'click selects Gregorian; remove Geologic collection
            IDtimeper = New Collection
            lboxTime.Items.Clear()
            Return
        Else
            MessageBox.Show("Unexpected object type. Contact program author", "Check multi-click on Gregorian date", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        End If
    End Sub

    Private Sub rdoTGeol_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles rdoTGeol.Click
        Dim iCount As Integer = IDtimeper.Count
        Dim objTest1 As New GeolAge
        Dim objTest2 As New SngDateTime

        If (iCount = 0) Then  'if no objects in collection, then no update necessary
            Return
        End If

        If (IDtimeper(1).GetType Is objTest1.GetType) Then 'click selects Geologic; already in that type 
            Return
        ElseIf (IDtimeper(1).GetType Is objTest2.GetType) Then 'click selects Geologic; remove Gregorian collection
            IDtimeper = New Collection
            lboxTime.Items.Clear()
            Return
        Else
            MessageBox.Show("Unexpected object type. Contact program author", "Check multi-click on Gregorian date", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Return
        End If
    End Sub

#End Region


#Region " Handling routines for Taxonomy panel "

    'Keywords/Taxon panel
    Private Sub btnAddTaxKey_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddTaxKey.Click
        Dim sNewKey As String = ""
        Dim frmAddKeys As New frmTaxKey(sNewKey)
        frmAddKeys.ShowDialog()
        If (frmAddKeys.bUpdate = True) Then 'add the keywords to collection
            sNewKey = frmAddKeys.sTaxKeys
            sTaxKeywords.Add(sNewKey)
            sNewKey = Replace(sNewKey, sPdelim, ":  ") 'replace  following thesaurus with colon and 2 spaces
            sNewKey = Replace(sNewKey, sKdelim, "; ") 'replace CRLF keyword spacer with semi-colon and space
            lboxTaxKey.Items.Add(sNewKey)
        End If
    End Sub

    Private Sub btnEditTaxKey_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditTaxKey.Click
        Dim iToEdit As Integer = 0
        Dim sToEdit As String = ""
        Dim iCount As Integer = lboxTaxKey.Items.Count
        iToEdit = lboxTaxKey.SelectedIndex
        If (iCount = 1) Then iToEdit = 0
        If (iToEdit = -1) Then
            'no keyword list selected
            MessageBox.Show("No set of keywords selected for editing", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        sToEdit = sTaxKeywords(iToEdit)
        Dim frmKeyToEdit As New frmTaxKey(sToEdit)
        frmKeyToEdit.ShowDialog()
        If (frmKeyToEdit.bUpdate = True) Then
            sToEdit = frmKeyToEdit.sTaxKeys 'get the keyword pair
            sTaxKeywords.Insert(iToEdit, sToEdit) 'insert new pair into string collection
            sTaxKeywords.RemoveAt(iToEdit + 1)    'remove old pair from string collection
            sToEdit = Replace(sToEdit, sPdelim, ":  ") 'replace  following thesaurus with colon and 2 spaces
            sToEdit = Replace(sToEdit, sKdelim, "; ") 'replace CRLF keyword spacer with semi-colon and space
            lboxTaxKey.Items.Insert(iToEdit, sToEdit)
            lboxTaxKey.Items.RemoveAt(iToEdit + 1)
        End If
    End Sub

    Private Sub btnDelTaxKey_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelTaxKey.Click
        Dim iToEdit As Integer = 0
        iToEdit = lboxTaxKey.SelectedIndex
        If (iToEdit = -1) Then
            'no keyword list selected
            MessageBox.Show("No set of keywords selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        lboxTaxKey.Items.RemoveAt(iToEdit) 'zero based list
        sTaxKeywords.RemoveAt(iToEdit) 'zero-based string collection
    End Sub


    'Taxonomic System: Classification System
    Private Sub btnAddTaxSys_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddTaxSys.Click
        Dim sTemp As String = ""
        Dim oNewCite As New CiteInfo 'taxonomic system classification system citation
        Dim bNewCiteLWC As Boolean = False
        Dim oNewCiteLWC As New CiteInfo 'taxonomic system classification system larger work citation
        Dim sSysMod As String = "" 'taxonomic system modifications
        Dim frmAddTaxSys As New frmTaxSysClass(oNewCite, bNewCiteLWC, oNewCiteLWC, sSysMod)

        frmAddTaxSys.ShowDialog()
        If (frmAddTaxSys.bUpdate = True) Then 'create the new taxonomic system entry
            oNewCite = frmAddTaxSys.oCite
            bNewCiteLWC = frmAddTaxSys.bCiteLWC
            oNewCiteLWC = frmAddTaxSys.oCiteLWC
            sSysMod = frmAddTaxSys.sMods
            citeTaxSys.Add(oNewCite)
            boolTaxSys.Add(bNewCiteLWC)
            citeTaxSysLWC.Add(oNewCiteLWC)
            sTaxSysMods.Add(sSysMod)
            sTemp = "cite: " & oNewCite.Author & "  " & oNewCite.Title
            lboxTaxSys.Items.Add(sTemp)
            sTemp = "  modifications: " & Microsoft.VisualBasic.Left(sSysMod, 50)
            lboxTaxSys.Items.Add(sTemp)
        End If

    End Sub

    Private Sub btnEditTaxSys_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditTaxSys.Click
        Dim sTemp As String = ""
        Dim iCount As Integer = lboxTaxSys.Items.Count
        Dim iToEdit As Integer = lboxTaxSys.SelectedIndex
        If (iCount = 1) Then iToEdit = 0
        If (iToEdit = -1) Then
            MessageBox.Show("No entry selected for editing", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        'if valid line selected, set up to edit the appropriate entries
        iToEdit = CInt(CDbl(iToEdit) / 2.0 - 0.05) 're-scales; uses zero-based index
        Dim oNewCite As CiteInfo = CType(citeTaxSys(iToEdit + 1), CiteInfo) 'taxonomic system classification system citation
        Dim bNewCiteLWC As Boolean = CType(boolTaxSys(iToEdit + 1), Boolean)
        Dim oNewCiteLWC As CiteInfo = CType(citeTaxSysLWC(iToEdit + 1), CiteInfo) 'associated larger work citation
        Dim sSysMod As String = sTaxSysMods(iToEdit) 'taxonomic system modifications; zero-based index

        Dim frmEditTaxSys As New frmTaxSysClass(oNewCite, bNewCiteLWC, oNewCiteLWC, sSysMod)
        frmEditTaxSys.ShowDialog()
        If (frmEditTaxSys.bUpdate = True) Then 'create the new taxonomic system entry
            oNewCite = frmEditTaxSys.oCite
            bNewCiteLWC = frmEditTaxSys.bCiteLWC
            oNewCiteLWC = frmEditTaxSys.oCiteLWC
            sSysMod = frmEditTaxSys.sMods
            citeTaxSys.Add(oNewCite, , iToEdit + 1)
            boolTaxSys.Add(bNewCiteLWC, , iToEdit + 1)
            citeTaxSysLWC.Add(oNewCiteLWC, , iToEdit + 1)
            sTaxSysMods.Insert(iToEdit, sSysMod)
            'delete old taxonomic system entry
            citeTaxSys.Remove(iToEdit + 2)
            boolTaxSys.Remove(iToEdit + 2)
            citeTaxSysLWC.Remove(iToEdit + 2)
            sTaxSysMods.RemoveAt(iToEdit + 1)

            iToEdit *= 2 're-expand the index for working with list box
            sTemp = "cite: " & oNewCite.Author & "  " & oNewCite.Title
            lboxTaxSys.Items.Insert(iToEdit, sTemp)
            sTemp = "  modifications: " & Microsoft.VisualBasic.Left(sSysMod, 50)
            lboxTaxSys.Items.Insert(iToEdit + 1, sTemp)
            lboxTaxSys.Items.RemoveAt(iToEdit + 2) 'removes old citation
            lboxTaxSys.Items.RemoveAt(iToEdit + 2) 'removes old modifications
        End If

    End Sub

    Private Sub btnDelTaxSys_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelTaxSys.Click
        Dim iToDelete As Integer = 0

        iToDelete = lboxTaxSys.SelectedIndex
        If (iToDelete = -1) Then
            MessageBox.Show("No entry selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        'if valid line selected, remove the appropriate entries
        iToDelete = CInt(CDbl(iToDelete) / 2.0 - 0.05) 're-scales; uses zero-based index
        citeTaxSys.Remove(iToDelete + 1) 'one-based index for collection
        boolTaxSys.Remove(iToDelete + 1)
        citeTaxSysLWC.Remove(iToDelete + 1)
        sTaxSysMods.RemoveAt(iToDelete) 'zero-based index for stringcollection
        iToDelete = iToDelete * 2 're-expands the index
        lboxTaxSys.Items.RemoveAt(iToDelete) 'removes the citation line
        lboxTaxSys.Items.RemoveAt(iToDelete) 'removes the modifications line

    End Sub


    'Taxonomic System: Identification Reference
    Private Sub btnAddTaxIDRef_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddTaxIDRef.Click
        Dim sTemp As String = ""
        Dim oNewCite As New CiteInfo 'taxonomic system classification system citation
        Dim bNewCiteLWC As Boolean = False
        Dim oNewCiteLWC As New CiteInfo 'taxonomic system classification system larger work citation
        Dim frmAddTaxIDRef As New frmCiteInfo(oNewCite, oNewCiteLWC, bNewCiteLWC, intTimeStyle)

        frmAddTaxIDRef.ShowDialog()
        If (frmAddTaxIDRef.bUpdate = True) Then 'create the new taxonomic system entry
            oNewCite = frmAddTaxIDRef.newCite
            bNewCiteLWC = frmAddTaxIDRef.bLWC
            oNewCiteLWC = frmAddTaxIDRef.newLWC
            citeTaxIDRef.Add(oNewCite)
            boolTaxIDRef.Add(bNewCiteLWC)
            citeTaxIDRefLWC.Add(oNewCiteLWC)
            sTemp = oNewCite.Author & "  " & oNewCite.Title
            lboxTaxIDRef.Items.Add(sTemp)
        End If

    End Sub

    Private Sub btnEditTaxIDRef_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditTaxIDRef.Click
        Dim sTemp As String = ""
        Dim iCount As Integer = lboxTaxIDRef.Items.Count
        Dim iToEdit As Integer = lboxTaxIDRef.SelectedIndex
        If (iCount = 1) Then iToEdit = 0
        If (iToEdit = -1) Then
            MessageBox.Show("No entry selected for editing", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        'if valid line selected, set up to edit the appropriate entries
        Dim oNewCite As CiteInfo = CType(citeTaxIDRef(iToEdit + 1), CiteInfo) 'taxonomic system ID reference citation
        Dim bNewCiteLWC As Boolean = CType(boolTaxIDRef(iToEdit + 1), Boolean)
        Dim oNewCiteLWC As CiteInfo = CType(citeTaxIDRefLWC(iToEdit + 1), CiteInfo) 'associated larger work citation

        Dim frmEditTaxIDRef As New frmCiteInfo(oNewCite, oNewCiteLWC, bNewCiteLWC, intTimeStyle)
        frmEditTaxIDRef.ShowDialog()
        If (frmEditTaxIDRef.bUpdate = True) Then 'create the new taxonomic ID reference
            oNewCite = frmEditTaxIDRef.newCite
            bNewCiteLWC = frmEditTaxIDRef.bLWC
            oNewCiteLWC = frmEditTaxIDRef.newLWC
            citeTaxIDRef.Add(oNewCite, , iToEdit + 1)
            boolTaxIDRef.Add(bNewCiteLWC, , iToEdit + 1)
            citeTaxIDRefLWC.Add(oNewCiteLWC, , iToEdit + 1)
            'delete old taxonomic system entry
            citeTaxIDRef.Remove(iToEdit + 2)
            boolTaxIDRef.Remove(iToEdit + 2)
            citeTaxIDRefLWC.Remove(iToEdit + 2)

            sTemp = oNewCite.Author & "  " & oNewCite.Title
            lboxTaxIDRef.Items.Insert(iToEdit, sTemp)
            lboxTaxIDRef.Items.RemoveAt(iToEdit + 1) 'removes old citation
        End If

    End Sub

    Private Sub btnDelTaxIDRef_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelTaxIDRef.Click
        Dim iToDelete As Integer = 0

        iToDelete = lboxTaxIDRef.SelectedIndex
        If (iToDelete = -1) Then
            MessageBox.Show("No entry selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        'if valid line selected, remove the appropriate entries
        citeTaxIDRef.Remove(iToDelete + 1) 'one-based index for collection
        boolTaxIDRef.Remove(iToDelete + 1)
        citeTaxIDRefLWC.Remove(iToDelete + 1)
        lboxTaxIDRef.Items.RemoveAt(iToDelete) 'removes the citation from the list box

    End Sub


    'Taxonomic System: Identifier
    Private Sub btnAddTaxID_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddTaxID.Click
        Dim sTemp As String = ""
        Dim oNewContact As New ContactInfo 'taxonomic system: identifier
        Dim frmAddTaxID As New frmContact(oNewContact, 1)

        frmAddTaxID.ShowDialog()
        If (frmAddTaxID.bUpdate = True) Then 'create the new taxonomic system: identifier entry
            oNewContact = frmAddTaxID.conInfo
            cntTaxID.Add(oNewContact)
            If (oNewContact.PrimaryPerson = True) Then 'update the listbox
                lboxTaxID.Items.Add(oNewContact.Person)
            Else
                lboxTaxID.Items.Add(oNewContact.Organization)
            End If
        End If

    End Sub

    Private Sub btnEditTaxID_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditTaxID.Click
        Dim iCount As Integer = lboxTaxID.Items.Count
        Dim iToEdit As Integer = lboxTaxID.SelectedIndex
        If (iCount = 1) Then iToEdit = 0
        If (iToEdit = -1) Then
            MessageBox.Show("No entry selected for editing", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        'if valid line selected, set up to edit the appropriate entries
        Dim oFixContact As ContactInfo = CType(cntTaxID(iToEdit + 1), ContactInfo) 'taxonomic system: identifier contact

        Dim frmEditTaxID As New frmContact(oFixContact, 2)
        frmEditTaxID.ShowDialog()
        If (frmEditTaxID.bUpdate = True) Then 'create the new taxonomic identifier contact
            oFixContact = frmEditTaxID.conInfo
            cntTaxID.Add(oFixContact, , iToEdit + 1)
            'delete old taxonomic system identifier entry
            cntTaxID.Remove(iToEdit + 2)

            If (oFixContact.PrimaryPerson = True) Then 'update the listbox
                lboxTaxID.Items.Insert(iToEdit, oFixContact.Person)
            Else
                lboxTaxID.Items.Insert(iToEdit, oFixContact.Organization)
            End If
            lboxTaxID.Items.RemoveAt(iToEdit + 1) 'removes old identier
        End If

    End Sub

    Private Sub btnDelTaxID_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelTaxID.Click
        Dim iToDelete As Integer = 0

        iToDelete = lboxTaxID.SelectedIndex
        If (iToDelete = -1) Then
            MessageBox.Show("No entry selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        'if valid line selected, remove the appropriate entries
        cntTaxID.Remove(iToDelete + 1) 'one-based index for collection
        lboxTaxID.Items.RemoveAt(iToDelete) 'removes the citation from the list box

    End Sub


    'Taxonomic System: Vouchers
    Private Sub btnAddVoucher_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddVoucher.Click
        Dim sTemp As String = ""
        Dim oNewContact As New ContactInfo 'taxonomic system: voucher repository contact
        Dim sVouchType As String = "" 'taxonomic system: voucher specimen description
        Dim frmAddVoucher As New frmVouchers(sVouchType, oNewContact, 1)

        frmAddVoucher.ShowDialog()
        If (frmAddVoucher.bUpdate = True) Then 'create the new taxonomic system: voucher
            oNewContact = frmAddVoucher.oVcon
            sVouchType = frmAddVoucher.sVoucher
            sVSpecimen.Add(sVouchType)
            cntVouchers.Add(oNewContact)
            sTemp = "specimen: " & Microsoft.VisualBasic.Left(sVouchType, 50)
            lboxVouchers.Items.Add(sTemp)
            If (oNewContact.PrimaryPerson = True) Then
                sTemp = "  repository: " & oNewContact.Person
            Else
                sTemp = "  repository: " & oNewContact.Organization
            End If
            lboxVouchers.Items.Add(sTemp)
        End If

    End Sub

    Private Sub btnEditVoucher_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditVoucher.Click
        Dim iCount As Integer = lboxVouchers.Items.Count
        Dim iToEdit As Integer = lboxVouchers.SelectedIndex
        If (iCount = 1) Then iToEdit = 0
        If (iToEdit = -1) Then
            MessageBox.Show("No entry selected for editing", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        'if valid line selected, remove the appropriate entries
        iToEdit = CInt(CDbl(iToEdit) / 2.0 - 0.05) 're-scales; uses zero-based index
        Dim sTemp As String = ""
        Dim oNewContact As ContactInfo = CType(cntVouchers(iToEdit + 1), ContactInfo) 'taxonomic system: voucher repository contact
        Dim sVouchType As String = sVSpecimen(iToEdit) 'taxonomic system: voucher specimen description
        Dim frmEditVoucher As New frmVouchers(sVouchType, oNewContact, 2)

        frmEditVoucher.ShowDialog()
        If (frmEditVoucher.bUpdate = True) Then 'update the taxonomic system: voucher
            oNewContact = frmEditVoucher.oVcon
            sVouchType = frmEditVoucher.sVoucher
            sVSpecimen.Insert(iToEdit, sVouchType)
            cntVouchers.Add(oNewContact, , iToEdit + 1)

            iToEdit *= 2
            sTemp = "specimen: " & Microsoft.VisualBasic.Left(sVouchType, 50)
            lboxVouchers.Items.Insert(iToEdit, sTemp)
            If (oNewContact.PrimaryPerson = True) Then
                sTemp = "  repository: " & oNewContact.Person
            Else
                sTemp = "  repository: " & oNewContact.Organization
            End If
            lboxVouchers.Items.Insert(iToEdit + 1, sTemp)
            lboxVouchers.Items.RemoveAt(iToEdit + 2) 'removes specimen description
            lboxVouchers.Items.RemoveAt(iToEdit + 2) 'removes repository contact
        End If

    End Sub

    Private Sub btnDelVoucher_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelVoucher.Click
        Dim iToDelete As Integer = 0

        iToDelete = lboxVouchers.SelectedIndex
        If (iToDelete = -1) Then
            MessageBox.Show("No entry selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        'if valid line selected, remove the appropriate entries
        iToDelete = CInt(CDbl(iToDelete) / 2.0 - 0.05) 're-scales; uses zero-based index
        sVSpecimen.RemoveAt(iToDelete) 'zero-based index for stringcollection
        cntVouchers.Remove(iToDelete + 1) 'one-based index for collection
        iToDelete = iToDelete * 2 're-expands the index
        lboxVouchers.Items.RemoveAt(iToDelete) 'removes the speciment line
        lboxVouchers.Items.RemoveAt(iToDelete) 'removes the contact info line

    End Sub


    'Taxonomic Classification
    Private Sub btnAddTaxRank_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddTaxRank.Click
        'create new node and either set as top node or attach as child to selected node, update collection and listbox
        Dim iTaxaCount As Integer = TaxaClasses.Count
        Dim iSelIndex As Integer = lboxLinneaus.SelectedIndex
        If (iSelIndex = -1 And iTaxaCount > 0) Then
            MessageBox.Show("No parent node selected for child to be added to.", "Taxonomic selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        Dim xmlNList As XmlNodeList
        Dim xmlTaxaNode As XmlNode
        Dim sTaxaInfo As String = ""
        Dim oNewTaxa As New TaxonClass
        Dim oTaxaNode As TaxonClass 'generic taxon node
        Dim frmNewTaxRank As New frmTaxonClass(oNewTaxa)
        frmNewTaxRank.ShowDialog()
        If (frmNewTaxRank.bUpdate = True) Then
            'add newly described taxonomic classification node
            oNewTaxa = frmNewTaxRank.oTaxRank
            xmlTaxaNode = xmlNewTaxonClassNode(oNewTaxa) 'creates the new XML node
            If (iSelIndex = -1) Then
                xmlTaxonClass.AppendChild(xmlTaxaNode) 'put node into empty XML document
            Else
                'attach to selected node
                xmlNList = xmlTaxonClass.GetElementsByTagName("taxoncl")
                xmlNList.Item(iSelIndex).AppendChild(xmlTaxaNode)
            End If

            ' 1. re-build the TaxaClasses collection
            TaxaClasses = New Collection
            xmlNList = xmlTaxonClass.SelectNodes("/taxoncl")
            If (xmlNList.Count > 0) Then
                sTaxaInfo = xmlNList(0).OuterXml
                openIDtaxclass(sTaxaInfo)
            End If

            ' 2. re-create the display
            lboxLinneausBuild() 'rebuild listbox from the updated TaxaClasses collection
        End If
    End Sub

    Private Sub btnEditTaxRank_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditTaxRank.Click
        'simple edit of existing node with re-insertion, update listbox
        Dim sIndent As String = "   "
        Dim iLoop As Integer = 0
        Dim iToStart As Integer = 0
        Dim iToEnd As Integer = 0
        Dim sTemp As String = ""
        Dim xmlNList As XmlNodeList
        Dim xmlChildList As XmlNodeList
        Dim oTaxaToEdit As TaxonClass
        Dim iCommonName As Integer = 0
        Dim s1 As String = ""
        Dim sGenArray() As String
        Dim xmlTempNode As XmlNode 'transient node for <common> elements
        Dim xmlTaxaFrag As XmlDocumentFragment 'container for <common> elements
        Dim iCount As Integer = lboxLinneaus.Items.Count
        Dim iToEdit As Integer = lboxLinneaus.SelectedIndex '0-based listbox index
        If (iCount = 1) Then iToEdit = 0
        If (iToEdit = -1) Then
            MessageBox.Show("No taxonomic node selected for editing.", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        oTaxaToEdit = CType(TaxaClasses(iToEdit + 1), TaxonClass) '1-based collection index
        Dim frmEditTaxRank As New frmTaxonClass(oTaxaToEdit)
        frmEditTaxRank.ShowDialog()
        If (frmEditTaxRank.bUpdate = True) Then
            oTaxaToEdit = frmEditTaxRank.oTaxRank

            'update the taxonomic classification collection
            TaxaClasses.Add(oTaxaToEdit, , iToEdit + 1) 'inserts the edited node
            TaxaClasses.Remove(iToEdit + 2) 'removes the old node

            'update the XML taxonomic classification document
            xmlNList = xmlTaxonClass.GetElementsByTagName("taxoncl")
            'xmlNList.Item(iToEdit).ParentNode.ReplaceChild(xmlTaxaNode, xmlNList.Item(iToEdit)) 'takes out too much -- all descendant <taxoncl> nodes
            'xmlChildList = xmlNList.Item(iToEdit).ChildNodes
            'update the Taxon Rank Name
            xmlNList.Item(iToEdit).SelectSingleNode("taxonrn").InnerXml = oTaxaToEdit.RankName
            'update the Taxon Rank Value
            xmlNList.Item(iToEdit).SelectSingleNode("taxonrv").InnerXml = oTaxaToEdit.RankValue
            'remove existing common names
            xmlChildList = xmlNList.Item(iToEdit).SelectNodes("common")
            iToEnd = xmlChildList.Count
            For iLoop = 1 To iToEnd
                xmlNList.Item(iToEdit).RemoveChild(xmlNList.Item(iToEdit).SelectSingleNode("common"))
            Next
            'create fragment containing common name nodes and insert
            iCommonName = 0
            xmlTaxaFrag = xmlTaxonClass.CreateDocumentFragment
            If (oTaxaToEdit.CommonName <> "") Then
                sGenArray = Split(oTaxaToEdit.CommonName, sKdelim)
                iToEnd = sGenArray.GetUpperBound(0)
                For iToStart = 0 To iToEnd
                    s1 = sGenArray(iToStart).Trim
                    If (s1 <> "") Then
                        xmlTempNode = xmlTaxonClass.CreateElement("common")
                        xmlTempNode.InnerText = s1
                        xmlTaxaFrag.AppendChild(xmlTempNode)
                        iCommonName += 1 'increment counter
                    End If
                Next
                If (iCommonName > 0) Then
                    xmlNList.Item(iToEdit).InsertAfter(xmlTaxaFrag, xmlNList.Item(iToEdit).SelectSingleNode("taxonrv"))
                End If
            End If

            'update the list box
            iToEnd = oTaxaToEdit.Level
            For iLoop = 1 To iToEnd
                sTemp = sTemp & sIndent 'indent the node
            Next
            sTemp = sTemp & "rank: " & oTaxaToEdit.RankName & "  value: " & oTaxaToEdit.RankValue
            lboxLinneaus.Items.Insert(iToEdit, sTemp) 'insert edited taxonomic node
            lboxLinneaus.Items.RemoveAt(iToEdit + 1) 'remove old node
        End If
    End Sub

    Private Function xmlNewTaxonClassNode(ByVal oCurTaxa As TaxonClass) As XmlNode
        Dim iToStart As Integer = 0
        Dim iToEnd As Integer = 0
        Dim s1 As String = ""
        Dim sGenArray() As String
        Dim xmlTempNode As XmlNode 'transient node for pieces of xmlNewTaxonClassNode

        'process taxonomic classification
        xmlNewTaxonClassNode = xmlTaxonClass.CreateElement("taxoncl") 'set the root element
        xmlTempNode = xmlTaxonClass.CreateElement("taxonrn") 'set the root rank name
        xmlTempNode.InnerText = oCurTaxa.RankName
        xmlNewTaxonClassNode.AppendChild(xmlTempNode)
        xmlTempNode = xmlTaxonClass.CreateElement("taxonrv") 'set the root rank value
        xmlTempNode.InnerText = oCurTaxa.RankValue
        xmlNewTaxonClassNode.AppendChild(xmlTempNode)
        If (oCurTaxa.CommonName <> "") Then
            sGenArray = Split(oCurTaxa.CommonName, sKdelim)
            iToEnd = sGenArray.GetUpperBound(0)
            For iToStart = 0 To iToEnd
                s1 = sGenArray(iToStart).Trim
                If (s1 <> "") Then
                    xmlTempNode = xmlTaxonClass.CreateElement("common")
                    xmlTempNode.InnerText = s1
                    xmlNewTaxonClassNode.AppendChild(xmlTempNode)
                End If
            Next
        End If
    End Function

    Private Sub btnDelTaxRank_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelTaxRank.Click
        'need to delete selected taxonomic node and its children, if any; decrement parent node child count, update listbox
        Dim xmlNList As XmlNodeList
        Dim iToDelete As Integer = lboxLinneaus.SelectedIndex
        Dim sTaxaInfo As String = ""
        Dim oTaxaInfo As New TaxonClass
        Dim xmlNodeDel As XmlNode

        'process error of no node selected for deletion
        If (iToDelete = -1) Then
            MessageBox.Show("No taxonomic node selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        'process deletion of root taxonomic classification node
        If (iToDelete = 0) Then
            xmlTaxonClass = New XmlDocument
            TaxaClasses = New Collection
            lboxLinneaus.Items.Clear()
            Return
        End If

        'process deletion of interior taxonomic classification node
        xmlNList = xmlTaxonClass.GetElementsByTagName("taxoncl")
        xmlNList.Item(iToDelete).RemoveAll()

        'remove empty taxoncl node
        xmlNList.Item(iToDelete).ParentNode.RemoveChild(xmlNList.Item(iToDelete))

        ' 1. re-build the TaxaClasses collection
        TaxaClasses = New Collection
        xmlNList = xmlTaxonClass.SelectNodes("/taxoncl")
        If (xmlNList.Count > 0) Then
            sTaxaInfo = xmlNList(0).OuterXml
            openIDtaxclass(sTaxaInfo)
        End If

        ' 2. re-create the display
        lboxLinneausBuild()
    End Sub

    Private Sub btnExpTaxa_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExpTaxa.Click
        'exports XML taxonomic description to file: selected node, all children, and parental lineage
        Dim sTemp As String = ""
        Dim xmlNList As XmlNodeList
        Dim xmlChildList As XmlNodeList 'works with <common> elements
        Dim sOutputXML As String = ""
        Dim xmlExportDoc As XmlDocument
        Dim xmlExportNode As XmlNode 'container for taxonomic tree to be exported
        Dim xmlParentNode As XmlNode 'placeholder for navigating tree
        Dim xmlParentTree As XmlNode 'container for parent node content
        Dim xmlTempNode As XmlNode 'transient node
        Dim xmlTempNode2 As XmlNode 'another transient node
        Dim xmlTempNode3 As XmlNode 'another transient node
        Dim bParent As Boolean = True 'parent node is present
        Dim sRankName As String = ""
        Dim sRankValue As String = ""
        Dim sTestName As String = ""
        Dim sTestValue As String = ""
        Dim iToStart As Integer = 0
        Dim iToEnd As Integer = 0
        Dim iCount As Integer = lboxLinneaus.Items.Count
        Dim iToEdit As Integer = lboxLinneaus.SelectedIndex '0-based listbox index

        If (iCount = 0) Then 'no nodes defined yet
            sTemp = "No taxonomic nodes are currently defined." & vbCrLf & "Export to file not available."
            MessageBox.Show(sTemp, "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (iToEdit = -1) Then 'nodes exist but none are selected
            MessageBox.Show("No taxonomic node selected for export.", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        If (iToEdit = 0) Then 'export complete tree
            SaveTaxonDialog.ShowDialog()
            sOutputXML = SaveTaxonDialog.FileName
            If (sOutputXML <> "") Then
                xmlTaxonClass.Save(sOutputXML) 'write the XML node to the specified file
            Else
                sTemp = "No file name given. Save terminated!"
                MessageBox.Show(sTemp, "File save error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
            Return
        End If

        'selected node is in tree interior
        xmlNList = xmlTaxonClass.GetElementsByTagName("taxoncl")
        'locate the selected node and place it and descendants into output container
        xmlTempNode = xmlNList.Item(iToEdit) 'sets the context node
        xmlExportNode = xmlTempNode.CloneNode(True) 'put context node and all children into export container

        'add parent nodes
        sRankName = xmlTaxonClass.DocumentElement.SelectSingleNode("taxonrn").InnerXml
        sRankValue = xmlTaxonClass.DocumentElement.SelectSingleNode("taxonrv").InnerXml
        While bParent = True
            xmlParentNode = xmlTempNode.ParentNode
            xmlParentTree = xmlTempNode.ParentNode.CloneNode(True) 'get parent node (includes all children)
            sTemp = xmlParentTree.SelectSingleNode("taxonrn").InnerXml
            If (sTemp = "Empire") Then
                bParent = False 'reached the top and do not include "Empire"
            Else
                'add parent to export node tree
                xmlTempNode2 = xmlTaxonClass.CreateElement("taxoncl")
                xmlTempNode3 = xmlParentTree.SelectSingleNode("taxonrn").Clone
                xmlTempNode2.AppendChild(xmlTempNode3) 'add Rank Name
                xmlTempNode3 = xmlParentTree.SelectSingleNode("taxonrv").Clone
                xmlTempNode2.AppendChild(xmlTempNode3) 'add Rank Value
                xmlChildList = xmlParentTree.SelectNodes("common") 'retrieve common names, if any
                iToEnd = xmlChildList.Count
                If (iToEnd > 0) Then 'add common names to output tree
                    For iToStart = 0 To iToEnd - 1
                        xmlTempNode3 = xmlChildList(iToStart).Clone
                        xmlTempNode2.AppendChild(xmlTempNode3)
                    Next
                End If

                xmlTempNode2.AppendChild(xmlExportNode) 'add rest of descendants
                xmlExportNode = xmlTempNode2.CloneNode(True)

                'test for root position and update nodes
                sTestName = xmlParentTree.SelectSingleNode("taxonrn").InnerXml
                sTestValue = xmlParentTree.SelectSingleNode("taxonrv").InnerXml
                If (sTestName = sRankName And sTestValue = sRankValue) Then bParent = False

                'update context node
                xmlTempNode = xmlParentNode 'update position in tree
            End If
        End While

        xmlExportDoc = New XmlDocument
        sTemp = xmlExportNode.OuterXml
        xmlExportDoc.LoadXml(sTemp)
        SaveTaxonDialog.ShowDialog()
        sOutputXML = SaveTaxonDialog.FileName
        If (sOutputXML <> "") Then
            xmlExportDoc.Save(sOutputXML) 'write the XML node to the specified file
            SaveTaxonDialog.Dispose()
        Else
            sTemp = "No file name given. Save terminated!"
            MessageBox.Show(sTemp, "File save error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

    End Sub

    Private Sub btnImpTaxa_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnImpTaxa.Click
        'imports XML taxonomic description from file and attaches to taxonomic classification at selected node
        'will bring in all child nodes descending from matching selected node

        Dim xmlImportTaxDOM As XmlDocument
        Dim sError As String = ""
        Dim xmlNList As XmlNodeList
        Dim xmlNList2 As XmlNodeList
        Dim iTaxoncl As Integer = 0
        Dim iTaxonrn As Integer = 0
        Dim iTaxonrv As Integer = 0
        Dim iTaxonIndex As Integer = 0
        Dim iTaxonCount As Integer = 0
        Dim sTaxonrn As String = ""
        Dim sTaxonrv As String = ""
        Dim xmlTaxaNode As XmlNode
        Dim xmlTaxaFrag As XmlDocumentFragment
        Dim sTaxaInfo As String = ""
        Dim sTaxaClass As String = ""
        Dim sTaxaClass2 As String = ""
        Dim sTaxaImportClass As String = ""
        Dim oTaxonClass As New TaxonClass
        Dim iSelIndex As Integer = 0
        Dim bComplete As Boolean = False
        Dim bTaxonRN As Boolean = False
        Dim bTaxonRV As Boolean = False
        Dim iTaxaCount As Integer = lboxLinneaus.Items.Count

        xmlImportTaxDOM = New XmlDocument 'initialize the DOM
        iSelIndex = lboxLinneaus.SelectedIndex

        'if there are multiple nodes present, make sure one is chosen for processing
        If (iSelIndex = -1 And iTaxaCount > 1) Then
            sError = "No taxon node chosen for appending file"
            MessageBox.Show(sError, "Importing Taxonomic Classification", MessageBoxButtons.OK)
            Return
        End If

        'get the file to import and load to DOM
        If OpenTaxonFileDialog.ShowDialog() = DialogResult.OK Then
            Try
                'load XML into Document Object Model (DOM)
                xmlImportTaxDOM.Load(OpenTaxonFileDialog.FileName)
            Catch ex As Exception
                sError = "Error loading taxonomic classification XML from specified file"
                MessageBox.Show(ex.Message, sError, MessageBoxButtons.OK, MessageBoxIcon.Error)
                OpenTaxonFileDialog.Dispose()
                Return
            End Try
            OpenTaxonFileDialog.Dispose()
        Else
            Return
        End If

        'file succesfully opened and XML loaded into xmlImportTaxDOM

        'check file for minimal taxonomic classification structure
        xmlNList = xmlImportTaxDOM.GetElementsByTagName("taxoncl")
        iTaxoncl = xmlNList.Count
        xmlNList = xmlImportTaxDOM.GetElementsByTagName("taxonrn")
        iTaxonrn = xmlNList.Count
        xmlNList = xmlImportTaxDOM.GetElementsByTagName("taxonrv")
        iTaxonrv = xmlNList.Count
        If (iTaxoncl = 0 Or iTaxonrn = 0 Or iTaxonrv = 0) Then
            sError = "XML structure is not consistent with a taxonomic classification"
            MessageBox.Show(sError, "Import error", MessageBoxButtons.OK)
            Return
        End If

        'determine whether any Taxonomic Classification already exists
        'CASE 1: if none exists, then make imported classification the classification; update
        'CASE 2: if only "Empire" exists, then add imported classification to "Empire"; update
        'CASE 3: many nodes, but selected node is "Empire", then add imported classification to "Empire"; update
        'CASE 4: if nodes other than "Empire" exist, then attempt node matching

        bComplete = False 'import not complete yet

        'Handle CASE 1
        If (iTaxaCount = 0) Then
            'make imported classification the classification
            sTaxaClass = xmlImportTaxDOM.DocumentElement.OuterXml
            xmlTaxonClass.LoadXml(sTaxaClass)
            bComplete = True
        End If

        'Handle CASE 2
        If (iTaxaCount = 1) Then
            oTaxonClass = CType(TaxaClasses.Item(1), TaxonClass)
            sTaxaInfo = oTaxonClass.RankName
            If (sTaxaInfo = "Empire") Then
                sTaxaImportClass = xmlImportTaxDOM.DocumentElement.SelectSingleNode("taxonrn").InnerXml
                If (sTaxaImportClass = "Empire") Then
                    'make imported classification the classification
                    sTaxaClass = xmlImportTaxDOM.DocumentElement.OuterXml
                    xmlTaxonClass.LoadXml(sTaxaClass)
                    bComplete = True
                Else
                    'append file classification to top node
                    sTaxaClass = xmlImportTaxDOM.DocumentElement.OuterXml
                    xmlTaxaFrag = xmlTaxonClass.CreateDocumentFragment
                    xmlTaxaFrag.InnerXml = sTaxaClass
                    xmlTaxonClass.DocumentElement.AppendChild(xmlTaxaFrag)
                    bComplete = True
                End If
            Else
                iSelIndex = 0 'if single existing node isn't "Empire" then setup for node matching
            End If

        End If

        'Handle CASE 3
        If (iTaxaCount > 1 And iSelIndex = 0) Then  'multiple nodes; top node selected
            oTaxonClass = CType(TaxaClasses.Item(1), TaxonClass)
            sTaxaInfo = oTaxonClass.RankName
            If (sTaxaInfo = "Empire") Then
                'append file classification to top node
                sTaxaClass = xmlImportTaxDOM.DocumentElement.OuterXml
                xmlTaxaFrag = xmlTaxonClass.CreateDocumentFragment
                xmlTaxaFrag.InnerXml = sTaxaClass
                xmlTaxonClass.DocumentElement.AppendChild(xmlTaxaFrag)
                bComplete = True
            End If
        Else
        End If

        'Handle CASE 4
        If (bComplete = False) Then
            'working with a node selected for appending
            'get the Rank Name and Rank Value of selected node (for matching in the imported file)
            oTaxonClass = CType(TaxaClasses.Item(iSelIndex + 1), TaxonClass)
            sTaxonrn = oTaxonClass.RankName
            sTaxonrv = oTaxonClass.RankValue
            xmlNList = xmlImportTaxDOM.GetElementsByTagName("taxoncl")
            iTaxoncl = xmlNList.Count - 1
            sTaxaClass = "taxonrn[text() = '" & sTaxonrn & "']"   'sets XPath params for taxonrn nodes
            sTaxaClass2 = "taxonrv[text() = '" & sTaxonrv & "']"  'sets XPath params for taxonrv nodes
            bTaxonRN = False
            bTaxonRV = False
            iTaxaCount = 0
            For iTaxonrn = 0 To iTaxoncl
                xmlNList2 = xmlNList.Item(iTaxonrn).SelectNodes(sTaxaClass)
                If (xmlNList2.Count > 0) Then 'found a taxonrn match at iTaxonrn
                    xmlNList2 = xmlNList.Item(iTaxonrn).SelectNodes(sTaxaClass2)
                    If (xmlNList2.Count > 0) Then  'found a taxonrv match at iTaxonrn
                        iTaxonIndex = iTaxonrn
                        bTaxonRV = True
                        iTaxaCount = iTaxaCount + 1
                    End If
                End If
            Next
            If (iTaxaCount = 0) Then
                sError = "No matching node found in the import file" & vbCrLf & "No import performed"
                MessageBox.Show(sError, "Import Taxonomic Classification error", MessageBoxButtons.OK)
                Return
            End If
            If (iTaxaCount > 1) Then
                sError = "More than one matching node in the import file" & vbCrLf & "Cannot determine which to append"
                sError = sError & vbCrLf & "No import performed"
                MessageBox.Show(sError, "Import Taxonomic Classification error", MessageBoxButtons.OK)
                Return
            End If
            xmlTaxaNode = xmlNList.Item(iTaxonIndex).CloneNode(True)
            sTaxaInfo = xmlTaxaNode.OuterXml
            xmlTaxaNode.RemoveChild(xmlTaxaNode.SelectSingleNode("taxonrn")) 'eliminates duplicate taxonrn
            xmlTaxaNode.RemoveChild(xmlTaxaNode.SelectSingleNode("taxonrv")) 'eliminates duplicate taxonrv
            xmlNList = xmlTaxaNode.SelectNodes("/common")                    'determine whether any "common" elements
            iTaxoncl = xmlNList.Count                                        '  are present; if so, delete
            For iTaxonrn = 1 To iTaxoncl
                xmlTaxaNode.RemoveChild(xmlTaxaNode.SelectSingleNode("common"))
            Next
            sTaxaInfo = xmlTaxaNode.InnerXml                                'get XML to be imported
            xmlTaxaFrag = xmlTaxonClass.CreateDocumentFragment
            xmlTaxaFrag.InnerXml = sTaxaInfo                                'put import XML into DocFrag of right type
            xmlNList = xmlTaxonClass.GetElementsByTagName("taxoncl")        'get all existing taxoncl elements
            xmlNList(iSelIndex).AppendChild(xmlTaxaFrag)                    'append import XML to selected existing node
            bComplete = True
        End If

        If (bComplete = True) Then
            'Update interface
            ' 1. re-build the TaxaClasses collection
            TaxaClasses = New Collection
            xmlNList = xmlTaxonClass.SelectNodes("/taxoncl")
            If (xmlNList.Count > 0) Then
                sTaxaInfo = xmlNList(0).OuterXml
                openIDtaxclass(sTaxaInfo)
            End If

            ' 2. re-create the display
            lboxLinneausBuild() 'rebuild listbox from the updated TaxaClasses collection
        Else
            sError = "Serious error resulting in no update"
            sError = sError & vbCrLf & "Record what you did and send information to Dave"
            sError = sError & vbCrLf & "(Contact info under Help)"
            MessageBox.Show(sError, "Taxonomic Import Error", MessageBoxButtons.OK)
        End If

    End Sub

    Private Sub lboxLinneausBuild()
        Dim sIndent As String = "   "
        Dim iLoop As Integer = 0
        Dim iLoop2 As Integer = 0
        Dim iNodes As Integer = 0
        Dim iToEnd As Integer = 0
        Dim sTemp As String = ""
        Dim oTaxaInfo As TaxonClass

        lboxLinneaus.Items.Clear() 'clear the existing list structure
        iNodes = TaxaClasses.Count 'get number of taxa nodes to process
        For iLoop = 1 To iNodes
            sTemp = ""
            oTaxaInfo = CType(TaxaClasses(iLoop), TaxonClass) 'get taxa node
            iToEnd = oTaxaInfo.Level
            For iLoop2 = 1 To iToEnd
                sTemp = sTemp & sIndent 'indent the node
            Next
            sTemp = sTemp & "rank: " & oTaxaInfo.RankName & "  value: " & oTaxaInfo.RankValue
            lboxLinneaus.Items.Add(sTemp) 'add the taxonomic node
        Next
    End Sub

#End Region


#Region " Handling routines for Access and Miscellaneous panels "
    'Access panel edit button
    Private Sub btnDataContact_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDataContact.Click
        Dim iConType As Integer = 0
        Dim frmDataCont As frmContact
        If (txtDataContact.Text = "") Then
            frmDataCont = New frmContact(objDataContact, 1)
        Else
            frmDataCont = New frmContact(objDataContact, 2)
        End If
        frmDataCont.ShowDialog()
        If (frmDataCont.bUpdate = True) Then
            objDataContact = frmDataCont.conInfo 'update the contact object
            If (objDataContact.PrimaryPerson = True) Then 'update the form display
                txtDataContact.Text = objDataContact.Person
            Else
                txtDataContact.Text = objDataContact.Organization
            End If
        End If
    End Sub

    Private Sub btnGraphicAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGraphicAdd.Click
        Dim sGenArray() As String
        Dim s1 As String
        Dim frmAddBG As New frmBrowseGraphic

        frmAddBG.ShowDialog()
        If (frmAddBG.bUpdate = True) Then
            s1 = frmAddBG.sBrowseG
            sBrowseGraphics.Add(s1)
            sGenArray = Split(s1, sPdelim)
            s1 = sGenArray(0) & "    " & sGenArray(1)
            lboxBrGraphic.Items.Add(s1)
        End If
    End Sub

    Private Sub btnGraphicEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGraphicEdit.Click
        Dim iCount As Integer = lboxBrGraphic.Items.Count
        Dim iSelInd As Integer = lboxBrGraphic.SelectedIndex
        If (iCount = 1) Then iSelInd = 0
        If (iSelInd = -1) Then 'no index selected
            MessageBox.Show("No graphic selected for editing", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        Dim sGenArray() As String
        Dim s1 As String = sBrowseGraphics(iSelInd) 'get info on selected browse graphic
        Dim frmEditBG As New frmBrowseGraphic(s1)   'and send to editing window

        frmEditBG.ShowDialog()
        If (frmEditBG.bUpdate = True) Then
            sBrowseGraphics.Insert(iSelInd, frmEditBG.sBrowseG) 'put edited browse graphic into collection
            sGenArray = Split(frmEditBG.sBrowseG, sPdelim)      'create entry to insert into display list
            s1 = sGenArray(0) & "    " & sGenArray(1)
            lboxBrGraphic.Items.Insert(iSelInd, s1)
            sBrowseGraphics.RemoveAt(iSelInd + 1) 'remove old version of graphic from collection
            lboxBrGraphic.Items.RemoveAt(iSelInd + 1) 'remove old version of graphic from displayed list
        End If
    End Sub

    Private Sub btnGraphicDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGraphicDelete.Click
        Dim iSelInd As Integer = 0

        iSelInd = lboxBrGraphic.SelectedIndex
        If (iSelInd = -1) Then 'no index selected
            MessageBox.Show("No graphic selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        sBrowseGraphics.RemoveAt(iSelInd) 'remove selected graphic from collection
        lboxBrGraphic.Items.RemoveAt(iSelInd) 'remove selected graphic from displayed list
    End Sub

    Private Sub btnXRefAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnXRefAdd.Click
        Dim tmpCite As New CiteInfo
        Dim tmpLWC As New CiteInfo
        Dim tmpLWCb As Boolean = False
        Dim strCite As String = ""
        Dim iCount As Integer = 0

        Dim frmXRef As New frmCiteInfo(tmpCite, tmpLWC, tmpLWCb, intTimeStyle)
        frmXRef.ShowDialog()

        If (frmXRef.bUpdate = False) Then  'no citation was provided so no updating
            Return
        End If
        tmpCite = frmXRef.newCite
        tmpLWCb = frmXRef.bLWC
        If (tmpLWCb = True) Then
            tmpLWC = frmXRef.newLWC
        End If

        XRefBase.Add(tmpCite) 'add new citation to the collection
        bXRefLWC.Add(tmpLWCb) 'add new larger work Boolean to its collection
        XRefLarge.Add(tmpLWC) 'add new larger work citation to its collection

        strCite = Microsoft.VisualBasic.Left(tmpCite.Author, 25) & "   " & Microsoft.VisualBasic.Left(tmpCite.Title, 25)
        lboxXRef.Items.Add(strCite)

    End Sub

    Private Sub btnXRefEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnXRefEdit.Click
        Dim iCount As Integer = lboxXRef.Items.Count
        Dim iSelInd As Integer = lboxXRef.SelectedIndex
        If (iCount = 1) Then iSelInd = 0
        If (iSelInd = -1) Then 'no index selected; zero-based
            MessageBox.Show("No cross-reference selected for editing", "Cross-reference selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        Dim tmpCite As CiteInfo = CType(XRefBase(iSelInd + 1), CiteInfo) 'get base citation from collection; one-based
        Dim tmpLWC As CiteInfo = CType(XRefLarge(iSelInd + 1), CiteInfo) 'get larger work citation from collection; one-based
        Dim tmpLWCb As Boolean = CType(bXRefLWC(iSelInd + 1), Boolean) 'get Boolean for LWC from collection; one-based
        Dim strCite As String = ""

        Dim frmXRefEdit As New frmCiteInfo(tmpCite, tmpLWC, tmpLWCb, intTimeStyle)
        frmXRefEdit.ShowDialog()

        If (frmXRefEdit.bUpdate = False) Then  'no citation was provided so no updating
            Return
        End If
        tmpCite = frmXRefEdit.newCite
        tmpLWCb = frmXRefEdit.bLWC
        If (tmpLWCb = True) Then
            tmpLWC = frmXRefEdit.newLWC
        End If

        XRefBase.Add(tmpCite, , iSelInd + 1) 'add edited citation to the collection
        bXRefLWC.Add(tmpLWCb, , iSelInd + 1) 'add edited larger work Boolean to its collection
        XRefLarge.Add(tmpLWC, , iSelInd + 1) 'add edited larger work citation to its collection

        XRefBase.Remove(iSelInd + 2) 'remove old citation to the collection
        bXRefLWC.Remove(iSelInd + 2) 'remove old larger work Boolean to its collection
        XRefLarge.Remove(iSelInd + 2) 'remove old larger work citation to its collection

        strCite = Microsoft.VisualBasic.Left(tmpCite.Author, 25) & "   " & Microsoft.VisualBasic.Left(tmpCite.Title, 25)
        lboxXRef.Items.Insert(iSelInd, strCite)
        lboxXRef.Items.RemoveAt(iSelInd + 1)

    End Sub

    Private Sub btnXRefDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnXRefDelete.Click
        Dim iSelInd As Integer = 0

        iSelInd = lboxXRef.SelectedIndex
        If (iSelInd = -1) Then 'no index selected
            MessageBox.Show("No cross-reference selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        XRefBase.Remove(iSelInd + 1)  'remove main cross-reference citation collection (one-based)
        bXRefLWC.Remove(iSelInd + 1)  'remove associated Boolean for larger work citation
        XRefLarge.Remove(iSelInd + 1) 'remove entry for larger work citation
        lboxXRef.Items.RemoveAt(iSelInd) 'remove selected graphic from displayed list
    End Sub

#End Region


#Region " Handling routines for Analytical Tools panel"

    Private Sub btnToolAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnToolAdd.Click
        Dim sList As String = ""
        Dim aTool As New ToolClass
        Dim frmNewTool As New frmTools
        frmNewTool.ShowDialog()
        If (frmNewTool.bUpdate = True) Then
            aTool = frmNewTool.objTool
            idTools.Add(aTool)
            sList = aTool.ToolDesc
            lboxTool.Items.Add(sList)
        End If

    End Sub

    Private Sub btnToolEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnToolEdit.Click
        Dim iCount As Integer = lboxTool.Items.Count
        Dim iToEdit As Integer = lboxTool.SelectedIndex
        If (iCount = 1) Then iToEdit = 0
        If (iToEdit = -1) Then
            MessageBox.Show("No tool chosen for editing", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        Dim slist As String = ""
        Dim editTool As ToolClass = CType(idTools(iToEdit + 1), ToolClass)
        Dim frmEditTool As New frmTools(editTool)
        frmEditTool.ShowDialog()
        If (frmEditTool.bUpdate = True) Then
            editTool = frmEditTool.objTool
            idTools.Add(editTool, , iToEdit + 1) 'one-based index
            idTools.Remove(iToEdit + 2)
            slist = editTool.ToolDesc
            lboxTool.Items.Insert(iToEdit, slist) 'zero-based index
            lboxTool.Items.RemoveAt(iToEdit + 1)
        End If

    End Sub

    Private Sub btnToolDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnToolDelete.Click
        Dim iToDelete As Integer = lboxTool.SelectedIndex
        If (iToDelete = -1) Then
            MessageBox.Show("No tool chosen for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        lboxTool.Items.RemoveAt(iToDelete) 'zero-based index
        idTools.Remove(iToDelete + 1) 'one-based index
    End Sub

#End Region


#Region " Handling routines for Data Quality Information section "

    'Attribute Accuracy
    Private Sub btnAddAttribAcc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddAttribAcc.Click
        Dim sNewAttrib As String = sPdelim 'create blank attribute accuracy assessment pair
        Dim frmNewAttrib As New frmAttribAcc(sNewAttrib)
        frmNewAttrib.ShowDialog()
        If (frmNewAttrib.bUpdate = True) Then 'add the new assessment
            sNewAttrib = frmNewAttrib.sAttrib
            sAttribAcc.Add(sNewAttrib)
            sNewAttrib = Replace(sNewAttrib, sPdelim, ":  ")
            lboxAttribAcc.Items.Add(sNewAttrib)
        End If
    End Sub

    Private Sub btnEditAttribAcc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditAttribAcc.Click
        Dim iCount As Integer = lboxAttribAcc.Items.Count
        Dim iSelInd As Integer = lboxAttribAcc.SelectedIndex 'get selected assessment to delete
        If (iCount = 1) Then iSelInd = 0
        If (iSelInd = -1) Then
            MessageBox.Show("No Attribute Assessment selected for editing!", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        Dim sNewAttrib As String = sAttribAcc(iSelInd) 'retrieve selected attribute accuracy assessment pair
        Dim frmEditAttrib As New frmAttribAcc(sNewAttrib)
        frmEditAttrib.ShowDialog()
        If (frmEditAttrib.bUpdate = True) Then 'update the assessment
            sNewAttrib = frmEditAttrib.sAttrib
            sAttribAcc.RemoveAt(iSelInd) 'remove old version
            sAttribAcc.Insert(iSelInd, sNewAttrib) 'put new version into collection at same point
            sNewAttrib = Replace(sNewAttrib, sPdelim, ":  ")
            lboxAttribAcc.Items.RemoveAt(iSelInd) 'update list box -- remove old version
            lboxAttribAcc.Items.Insert(iSelInd, sNewAttrib) 'update list box -- insert new version
        End If
    End Sub

    Private Sub btnDelAttribAcc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelAttribAcc.Click
        Dim iSelInd As Integer = lboxAttribAcc.SelectedIndex 'get selected assessment to delete
        If (iSelInd = -1) Then
            MessageBox.Show("No Attribute Assessment selected for deletion!", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        sAttribAcc.RemoveAt(iSelInd) 'update string collection
        lboxAttribAcc.Items.RemoveAt(iSelInd) 'update list box
    End Sub

    'Positional Accuracy
    Private Sub btnAddHPosAcc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddHPosAcc.Click
        Dim sNewPosAcc As String = sPdelim 'create blank attribute accuracy assessment pair
        Dim frmNewPosAcc As New frmPosAcc(sNewPosAcc, "H")
        frmNewPosAcc.ShowDialog()
        If (frmNewPosAcc.bUpdate = True) Then 'add the new assessment
            sNewPosAcc = frmNewPosAcc.sPosAcc
            sHPosAcc.Add(sNewPosAcc)
            sNewPosAcc = Replace(sNewPosAcc, sPdelim, " m:  ")
            lboxHPosAcc.Items.Add(sNewPosAcc)
        End If
    End Sub

    Private Sub btnEditHPosAcc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditHPosAcc.Click
        Dim iCount As Integer = lboxHPosAcc.Items.Count
        Dim iSelInd As Integer = lboxHPosAcc.SelectedIndex 'get selected assessment to edit
        If (iCount = 1) Then iSelInd = 0
        If (iSelInd = -1) Then
            MessageBox.Show("No Positional Assessment selected for editing!", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        Dim sNewPosAcc As String = sHPosAcc(iSelInd) 'retrieve selected positional accuracy assessment pair
        Dim frmEditPosAcc As New frmPosAcc(sNewPosAcc, "H")
        frmEditPosAcc.ShowDialog()
        If (frmEditPosAcc.bUpdate = True) Then 'update the assessment
            sNewPosAcc = frmEditPosAcc.sPosAcc
            sHPosAcc.RemoveAt(iSelInd) 'remove old version
            sHPosAcc.Insert(iSelInd, sNewPosAcc) 'put new version into collection at same point
            sNewPosAcc = Replace(sNewPosAcc, sPdelim, " m:  ")
            lboxHPosAcc.Items.RemoveAt(iSelInd) 'update list box -- remove old version
            lboxHPosAcc.Items.Insert(iSelInd, sNewPosAcc) 'update list box -- insert new version
        End If
    End Sub

    Private Sub btnDelHPosAcc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelHPosAcc.Click
        Dim iSelInd As Integer = lboxHPosAcc.SelectedIndex 'get selected assessment to delete
        If (iSelInd = -1) Then
            MessageBox.Show("No Positional Assessment selected for deletion!", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        sHPosAcc.RemoveAt(iSelInd) 'update string collection
        lboxHPosAcc.Items.RemoveAt(iSelInd) 'update list box
    End Sub

    Private Sub btnAddVPosAcc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddVPosAcc.Click
        Dim sNewPosAcc As String = sPdelim 'create blank attribute accuracy assessment pair
        Dim frmNewPosAcc As New frmPosAcc(sNewPosAcc, "V")
        frmNewPosAcc.ShowDialog()
        If (frmNewPosAcc.bUpdate = True) Then 'add the new assessment
            sNewPosAcc = frmNewPosAcc.sPosAcc
            sVPosAcc.Add(sNewPosAcc)
            sNewPosAcc = Replace(sNewPosAcc, sPdelim, " m:  ")
            lboxVPosAcc.Items.Add(sNewPosAcc)
        End If
    End Sub

    Private Sub btnEditVPosAcc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditVPosAcc.Click
        Dim iCount As Integer = lboxVPosAcc.Items.Count
        Dim iSelInd As Integer = lboxVPosAcc.SelectedIndex 'get selected assessment to edit
        If (iCount = 1) Then iSelInd = 0 'default to editing the solitary value
        If (iSelInd = -1) Then
            MessageBox.Show("No Positional Assessment selected for editing!", "Assessment selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        Dim sNewPosAcc As String = sVPosAcc(iSelInd) 'retrieve selected positional accuracy assessment pair
        Dim frmEditPosAcc As New frmPosAcc(sNewPosAcc, "V")
        frmEditPosAcc.ShowDialog()
        If (frmEditPosAcc.bUpdate = True) Then 'update the assessment
            sNewPosAcc = frmEditPosAcc.sPosAcc
            sVPosAcc.RemoveAt(iSelInd) 'remove old version
            sVPosAcc.Insert(iSelInd, sNewPosAcc) 'put new version into collection at same point
            sNewPosAcc = Replace(sNewPosAcc, sPdelim, " m:  ")
            lboxVPosAcc.Items.RemoveAt(iSelInd) 'update list box -- remove old version
            lboxVPosAcc.Items.Insert(iSelInd, sNewPosAcc) 'update list box -- insert new version
        End If
    End Sub

    Private Sub btnDelVPosAcc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelVPosAcc.Click
        Dim iSelInd As Integer = lboxVPosAcc.SelectedIndex 'get selected assessment to delete
        If (iSelInd = -1) Then
            MessageBox.Show("No Positional Assessment selected for deletion!", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        sVPosAcc.RemoveAt(iSelInd) 'update string collection
        lboxVPosAcc.Items.RemoveAt(iSelInd) 'update list box
    End Sub

    'Lineage
    Private Sub btnAddMeth_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddMeth.Click
        Dim oNewMethod As New MethodClass ' create new Method object
        Dim sMethDisplay As String = ""
        Dim frmNewMethod As New frmMethod(oNewMethod, "N")
        frmNewMethod.ShowDialog()
        If (frmNewMethod.bUpdate = True) Then 'add the new methodology
            oNewMethod = frmNewMethod.oMethod
            cMethods.Add(oNewMethod)
            sMethDisplay = oNewMethod.MethodType & ":  " & Microsoft.VisualBasic.Left(oNewMethod.MethodDesc, 60)
            lboxMeth.Items.Add(sMethDisplay)
        End If
    End Sub

    Private Sub btnEditMeth_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditMeth.Click
        Dim iCount As Integer = lboxMeth.Items.Count
        Dim iSelInd As Integer = lboxMeth.SelectedIndex 'get selected methodology to edit
        If (iCount = 1) Then iSelInd = 0 'default to edit unique entry if only one present
        If (iSelInd = -1) Then
            MessageBox.Show("No Methodology selected for editing!", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        Dim oNewMethod As MethodClass = CType(cMethods(iSelInd + 1), MethodClass) 'retrieve Method object
        Dim sMethDisplay As String = ""
        Dim frmEditMethod As New frmMethod(oNewMethod, "E")
        frmEditMethod.ShowDialog()
        If (frmEditMethod.bUpdate = True) Then 'update the methodology
            oNewMethod = frmEditMethod.oMethod
            cMethods.Add(oNewMethod, , iSelInd + 1) '1-based index
            cMethods.Remove(iSelInd + 2) '1-based index
            sMethDisplay = oNewMethod.MethodType & ":  " & Microsoft.VisualBasic.Left(oNewMethod.MethodDesc, 60)
            lboxMeth.Items.RemoveAt(iSelInd)
            lboxMeth.Items.Insert(iSelInd, sMethDisplay)
        End If
    End Sub

    Private Sub btnDelMeth_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelMeth.Click
        Dim iSelInd As Integer = lboxMeth.SelectedIndex 'get selected methodology to delete
        If (iSelInd = -1) Then
            MessageBox.Show("No Methodology selected for deletion!", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        cMethods.Remove(iSelInd + 1) 'update collection, 1-based index
        lboxMeth.Items.RemoveAt(iSelInd) 'update list box, 0-based index
    End Sub

    Private Sub btnAddSource_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddSource.Click
        Dim oNewSource As New SourceClass ' create new Source object
        Dim s1 As String = ""
        Dim frmNewSource As New frmSourceInfo(oNewSource)
        frmNewSource.ShowDialog()
        If (frmNewSource.bUpdate = True) Then 'add the new source info
            oNewSource = frmNewSource.oSource
            cSources.Add(oNewSource)
            s1 = oNewSource.CiteAbbrv & ":  " & Microsoft.VisualBasic.Left(oNewSource.Contrib, 40)
            lboxLinSource.Items.Add(s1)
        End If
    End Sub

    Private Sub btnEditSource_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditSource.Click
        Dim iCount As Integer = lboxLinSource.Items.Count
        Dim iSelInd As Integer = lboxLinSource.SelectedIndex 'get selected source information to edit
        If (iCount = 1) Then iSelInd = 0
        If (iSelInd = -1) Then
            MessageBox.Show("No Source selected for editing!", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        iSelInd = iSelInd + 1 'adjust to 1-based index scale
        Dim oEditSource As SourceClass = CType(cSources(iSelInd), SourceClass) 'retrieve Source object, 1-based index
        Dim s1 As String = ""
        Dim frmEditSource As New frmSourceInfo(oEditSource)
        frmEditSource.ShowDialog()
        If (frmEditSource.bUpdate = True) Then 'add the new source info
            oEditSource = frmEditSource.oSource
            cSources.Add(oEditSource, , iSelInd)
            cSources.Remove(iSelInd + 1)
            s1 = oEditSource.CiteAbbrv & ":  " & Microsoft.VisualBasic.Left(oEditSource.Contrib, 40)
            lboxLinSource.Items.Insert(iSelInd - 1, s1) '0-based index
            lboxLinSource.Items.RemoveAt(iSelInd)
        End If
    End Sub

    Private Sub btnDelSource_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelSource.Click
        Dim iSelInd As Integer = lboxLinSource.SelectedIndex 'get selected source information to delete
        If (iSelInd = -1) Then
            MessageBox.Show("No Source selected for deletion!", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        cSources.Remove(iSelInd + 1) 'update collection, 1-based index
        lboxLinSource.Items.RemoveAt(iSelInd) 'update list box, 0-based index
    End Sub

    Private Sub btnAddProc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddProc.Click
        Dim oNewProc As New ProcessClass ' create new Process Step object
        Dim s1 As String = ""
        Dim frmNewProc As New frmProcessStep(oNewProc)
        frmNewProc.ShowDialog()
        If (frmNewProc.bUpdate = True) Then 'add the new process step info
            oNewProc = frmNewProc.oCurProc
            cProcess.Add(oNewProc)
            s1 = Microsoft.VisualBasic.Left(oNewProc.Description, 60)
            lboxProcess.Items.Add(s1)
        End If
    End Sub

    Private Sub btnEditProc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditProc.Click
        Dim iCount As Integer = lboxProcess.Items.Count
        Dim iSelInd As Integer = lboxProcess.SelectedIndex 'get selected process step to edit
        If (iCount = 1) Then iSelInd = 0
        If (iSelInd = -1) Then
            MessageBox.Show("No Process Step selected for editing!", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        iSelInd = iSelInd + 1 'adjust to 1-based index scale
        Dim oEditProc As ProcessClass = CType(cProcess(iSelInd), ProcessClass) 'retrieve Process Step object, 1-based index
        Dim s1 As String = ""
        Dim frmEditProc As New frmProcessStep(oEditProc)
        frmEditProc.ShowDialog()
        If (frmEditProc.bUpdate = True) Then 'add the new source info
            oEditProc = frmEditProc.oCurProc
            cProcess.Add(oEditProc, , iSelInd)
            cProcess.Remove(iSelInd + 1)
            s1 = Microsoft.VisualBasic.Left(oEditProc.Description, 60)
            lboxProcess.Items.Insert(iSelInd - 1, s1) '0-based index
            lboxProcess.Items.RemoveAt(iSelInd)
        End If
    End Sub

    Private Sub btnDelProc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelProc.Click
        Dim iSelInd As Integer = lboxProcess.SelectedIndex 'get selected process step to delete
        If (iSelInd = -1) Then
            MessageBox.Show("No Process Step selected for deletion!", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        cProcess.Remove(iSelInd + 1) 'update collection, 1-based index
        lboxProcess.Items.RemoveAt(iSelInd) 'update list box, 0-based index
    End Sub

    'Cloud Cover
    Private Sub rdoCloud_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoCloud.CheckedChanged
        If (rdoCloud.Checked = True) Then
            pnlCloud.Visible = True
            numCloud.Value = 0
        Else
            pnlCloud.Visible = False
            numCloud.Value = 0
        End If
    End Sub

#End Region


#Region " Handling routines for Spatial Data Organization Information section "

    Private Sub cboxDirect_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboxDirect.SelectedIndexChanged
        Dim iSelInd As Integer
        iSelInd = cboxDirect.SelectedIndex
        If (iSelInd < 1) Then 'no direct spatial reference method chosen, so disable Vector and Raster Information 
            lblVector.Visible = True
            Panel12.Visible = False
            rdoNoDesc.Checked = True
            lboxTerms.Items.Clear()
            sSDTS = New StringCollection
            cboxVPF.SelectedIndex = -1

            lblRaster.Visible = True
            Panel10.Visible = False
            cboxRasType.SelectedIndex = -1
            numRasRow.Value = 0
            numRasCol.Value = 0
            numRasVert.Value = 0
            Return
        End If
        If (iSelInd < 3) Then 'point or vector chosen, enable Vector, disable Raster
            lblVector.Visible = False
            Panel12.Visible = True
            rdoNoDesc.Checked = True
            Panel14.Visible = False
            lboxTerms.Items.Clear()
            sSDTS = New StringCollection
            Panel15.Visible = False
            cboxVPF.SelectedIndex = -1

            lblRaster.Visible = True
            Panel10.Visible = False
            cboxRasType.SelectedIndex = -1
            numRasRow.Value = 0
            numRasCol.Value = 0
            numRasVert.Value = 0
            Return
        End If
        If (iSelInd < 4) Then 'raster chosen, disable Vector, enable Raster
            lblVector.Visible = True
            Panel12.Visible = False
            rdoNoDesc.Checked = True
            lboxTerms.Items.Clear()
            sSDTS = New StringCollection
            cboxVPF.SelectedIndex = -1

            lblRaster.Visible = False
            Panel10.Visible = True
            Return
        End If
    End Sub

    Private Sub rdoNoDesc_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoNoDesc.CheckedChanged
        If (rdoNoDesc.Checked = True) Then
            bSDTS = False
            bVPF = False
            Panel14.Visible = False
            lboxTerms.Items.Clear()
            sSDTS = New StringCollection
            Panel15.Visible = False
            cboxVPF.SelectedIndex = -1
            Return
        End If
    End Sub

    Private Sub rdoSDTS_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoSDTS.CheckedChanged
        If (rdoSDTS.Checked = True) Then
            If (bSDTS = False) Then 'if click is a change
                bSDTS = True
                bVPF = False
                Panel14.Visible = True
                lblSDTS.Text = "SDTS Terms Description"
                lboxTerms.Items.Clear()
                sSDTS = New StringCollection
                Panel15.Visible = False
                cboxVPF.SelectedIndex = -1
                Return
            End If
        End If
    End Sub

    Private Sub rdoVPF_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoVPF.CheckedChanged
        If (rdoVPF.Checked = True) Then
            If (bVPF = False) Then 'if click is a change
                bSDTS = False
                bVPF = True
                Panel14.Visible = True
                lblSDTS.Text = "VPF Terms Description"
                lboxTerms.Items.Clear()
                sSDTS = New StringCollection
                Panel15.Visible = True
                cboxVPF.SelectedIndex = -1
                Return
            End If
        End If
    End Sub

    Private Sub btnAddTerm_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddTerm.Click
        Dim sObjCount As String
        sObjCount = "" & sPdelim & "" 'blank object type and blank count
        Dim bObjType As Boolean
        If (rdoSDTS.Checked = True) Then
            bObjType = True
        Else
            bObjType = False
        End If
        Dim frmAddTerm As New frmTermsDesc(sObjCount, bObjType)
        frmAddTerm.ShowDialog()
        If (frmAddTerm.bUpdate = False) Then Return 'no object to be added
        sObjCount = frmAddTerm.sTerm
        sSDTS.Add(sObjCount)
        sObjCount = Replace(sObjCount, sPdelim, "  :  ")
        lboxTerms.Items.Add(sObjCount)
        Return
    End Sub

    Private Sub btnEditTerm_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditTerm.Click
        Dim iCount As Integer = lboxTerms.Items.Count
        Dim iSelInd As Integer = lboxTerms.SelectedIndex
        If (iCount = 1) Then iSelInd = 0
        If (iSelInd = -1) Then 'no term description selected
            MessageBox.Show("No description selected for editing.", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        'if valid description selected for editing, then process
        Dim sObjCount As String
        sObjCount = sSDTS(iSelInd) 'get the selected object type information
        Dim bObjType As Boolean
        If (rdoSDTS.Checked = True) Then
            bObjType = True
        Else
            bObjType = False
        End If
        Dim frmEditTerm As New frmTermsDesc(sObjCount, bObjType)
        frmEditTerm.ShowDialog()
        If (frmEditTerm.bUpdate = False) Then Return 'no object to be added
        sObjCount = frmEditTerm.sTerm
        sSDTS.RemoveAt(iSelInd) 'remove old version
        sSDTS.Insert(iSelInd, sObjCount)   'insert new version
        sObjCount = Replace(sObjCount, sPdelim, "  :  ")
        lboxTerms.Items.RemoveAt(iSelInd)
        lboxTerms.Items.Insert(iSelInd, sObjCount)
        Return
    End Sub

    Private Sub btnDelTerm_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelTerm.Click
        Dim iSelInd As Integer = lboxTerms.SelectedIndex
        If (iSelInd = -1) Then 'no term description selected
            MessageBox.Show("No description selected for deletion.", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        sSDTS.RemoveAt(iSelInd) 'string collection has zero-based index
        lboxTerms.Items.RemoveAt(iSelInd) 'list box has zero-based index
        Return
    End Sub

#End Region


#Region " Handling routines for Spatial Reference Information section "
    'Horizontal Coordinate System Definition tab
    Private Sub rdoGeographic_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoGeographic.CheckedChanged
        If (rdoGeographic.Checked = True) Then
            pnlGeographic.Enabled = True
        Else
            pnlGeographic.Enabled = False
        End If
    End Sub

    Private Sub rdoPlanar_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoPlanar.CheckedChanged
        If (rdoPlanar.Checked = True) Then
            pnlPlanar.Enabled = True
        Else
            pnlPlanar.Enabled = False
        End If
    End Sub

    Private Sub rdoLocal_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoLocal.CheckedChanged
        If (rdoLocal.Checked = True) Then
            pnlLocal.Enabled = True
        Else
            pnlLocal.Enabled = False
        End If
    End Sub

    Private Sub rdoNone_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoNone.CheckedChanged
        If (rdoNone.Checked = True) Then
            pnlGeographic.Enabled = False
            pnlPlanar.Enabled = False
            pnlLocal.Enabled = False
        End If
    End Sub

    'Planar System Definition
    Private Sub btnAddPlanar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddPlanar.Click
        Dim s1 As String = ""
        Dim oTempPlanar As New PlanarClass
        Dim frmNewPlanar As New frmPlanar
        frmNewPlanar.ShowDialog()
        If (frmNewPlanar.bUpdate = True) Then
            oTempPlanar = frmNewPlanar.oPlanar
            cPlanar.Add(oTempPlanar)
            If (oTempPlanar.MapProj = True) Then
                s1 = "Map: " & oTempPlanar.MapProjName
            ElseIf (oTempPlanar.GridSys = True) Then
                s1 = "Grid: " & oTempPlanar.GridName
                If (oTempPlanar.GridName <> "other grid system") Then
                    s1 += ", Projection: " & oTempPlanar.GridProjName
                End If
            Else
                s1 = "Local Planar: " & Microsoft.VisualBasic.Left(oTempPlanar.LocalDesc, 40)
            End If
            lboxPlanar.Items.Add(s1)
        End If
    End Sub

    Private Sub btnEditPlanar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditPlanar.Click
        Dim sError As String = ""
        Dim iCount As Integer = lboxPlanar.Items.Count
        Dim iSelInd As Integer = lboxPlanar.SelectedIndex 'get selected planar definition to edit
        If (iCount = 1) Then iSelInd = 0 'if only 1 entry, default to edit it
        If (iSelInd = -1) Then
            sError = "No Planar Definition selected for editing!"
            MessageBox.Show(sError, "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        Dim s1 As String = ""
        Dim oTempPlanar As New PlanarClass
        oTempPlanar = CType(cPlanar(iSelInd + 1), PlanarClass)
        Dim frmEditPlanar As New frmPlanar(oTempPlanar)
        frmEditPlanar.ShowDialog()
        If (frmEditPlanar.bUpdate = True) Then
            cPlanar.Add(frmEditPlanar.oPlanar, , iSelInd + 1) 'insert updated Planar Def
            cPlanar.Remove(iSelInd + 2) 'remove obsolete Planar Def
            oTempPlanar = frmEditPlanar.oPlanar
            If (oTempPlanar.MapProj = True) Then
                s1 = "Map: " & oTempPlanar.MapProjName
            ElseIf (oTempPlanar.GridSys = True) Then
                s1 = "Grid: " & oTempPlanar.GridName
                If (oTempPlanar.GridName <> "other grid system") Then
                    s1 += ", Projection: " & oTempPlanar.GridProjName
                End If
            Else
                s1 = "Local Planar: " & Microsoft.VisualBasic.Left(oTempPlanar.LocalDesc, 40)
            End If
            lboxPlanar.Items.Insert(iSelInd, s1) 'insert updated Planar Def
            lboxPlanar.Items.RemoveAt(iSelInd + 1) 'remove obsolete Planar Def
        End If
    End Sub

    Private Sub btnDelPlanar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelPlanar.Click
        Dim sError As String = ""
        Dim iSelIndex As Integer = lboxPlanar.SelectedIndex
        If (iSelIndex = -1) Then
            sError = "No Planar Definition selected for deletion!"
            MessageBox.Show(sError, "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        cPlanar.Remove(iSelIndex + 1) '1-based index
        lboxPlanar.Items.RemoveAt(iSelIndex) '0-based index
    End Sub

    'Vertical Coordinate System Definition tab
    Private Sub btnAddAltRes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddAltRes.Click
        Dim s1 As String = ""
        Dim s2 As String = numAltRes.Value.ToString
        Dim iPos As Integer = 0

        iPos = s2.IndexOf(".")
        If (iPos < 0) Then
            s2 += ".0" 'make sure the value is a real
        End If
        s1 = txtAltRes.Text 'retrieve current set of resolutions
        If (s1 = "") Then
            s1 = s2 'put new resolution into string
        Else
            s1 += sKdelim & s2 'add new resolution to string, with delimiter
        End If
        txtAltRes.Text = s1 'update the text box
    End Sub

    Private Sub btnClearAltRes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearAltRes.Click
        txtAltRes.Text = ""
        numAltRes.Value = 0
    End Sub

    Private Sub btnAddDepth_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddDepth.Click
        Dim s1 As String = ""
        Dim s2 As String = numDepthRes.Value.ToString
        Dim iPos As Integer = 0

        iPos = s2.IndexOf(".")
        If (iPos < 0) Then
            s2 += ".0" 'make sure the value is a real
        End If
        s1 = txtDepthRes.Text 'retrieve current set of resolutions
        If (s1 = "") Then
            s1 = s2 'put new resolution into string
        Else
            s1 += sKdelim & s2 'add new resolution to string, with delimiter
        End If
        txtDepthRes.Text = s1 'update the text box
    End Sub

    Private Sub btnClrDepthRes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClrDepthRes.Click
        txtDepthRes.Text = ""
        numDepthRes.Value = 0
    End Sub

#End Region


#Region " Handling routines for Entity and Attribute Information "

    Private Sub btnAddEOver_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddEOver.Click
        Dim s1 As String = ""
        Dim oNewOver As New EAoverClass
        Dim frmNewOver As New frmEAover(oNewOver)
        frmNewOver.ShowDialog()
        If (frmNewOver.bUpdate = True) Then 'add the new overview
            oNewOver = frmNewOver.oEAOver
            s1 = oNewOver.Overview
            s1 = Replace(s1, sKdelim, "  ")
            s1 = Microsoft.VisualBasic.Left(s1, 80)
            cEAttrOver.Add(oNewOver)
            lboxOverView.Items.Add(s1)
        End If
    End Sub

    Private Sub btnEditEOver_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditEOver.Click
        Dim iCount As Integer = lboxOverView.Items.Count
        Dim iSelInd As Integer = lboxOverView.SelectedIndex
        If (iCount = 1) Then iSelInd = 0
        If (iSelInd = -1) Then
            MessageBox.Show("No entity overview selected for editing", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        Dim s1 As String = ""
        Dim oNewOver As EAoverClass = CType(cEAttrOver(iSelInd + 1), EAoverClass) '1-based index
        Dim frmNewOver As New frmEAover(oNewOver)
        frmNewOver.ShowDialog()
        If (frmNewOver.bUpdate = True) Then 'update the overview containers
            oNewOver = frmNewOver.oEAOver
            s1 = oNewOver.Overview
            s1 = Replace(s1, sKdelim, "  ")
            s1 = Microsoft.VisualBasic.Left(s1, 80)
            cEAttrOver.Add(oNewOver, , iSelInd + 1) 'insert before old version in collection; 1-based index
            cEAttrOver.Remove(iSelInd + 2)          'remove old version from collection
            lboxOverView.Items.Insert(iSelInd, s1) 'update list box; 0-based index
            lboxOverView.Items.RemoveAt(iSelInd + 1)
        End If
    End Sub

    Private Sub btnDelEOver_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelEOver.Click
        Dim iSelInd As Integer = lboxOverView.SelectedIndex

        If (iSelInd = -1) Then
            MessageBox.Show("No entity overview selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        cEAttrOver.Remove(iSelInd + 1) 'update collection, 1-based index
        lboxOverView.Items.RemoveAt(iSelInd) 'update list box
    End Sub

    Private Sub btnAddEDtl_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddEDtl.Click
        Dim s1 As String = ""
        Dim iCount As Integer = 0
        Dim frmNewDetails As New frmEAdetail
        frmNewDetails.ShowDialog()
        If (frmNewDetails.bUpdate = True) Then
            cEAentity.Add(frmNewDetails.oEntity) 'add new detailed description to collection
            s1 = frmNewDetails.oEntity.EntityLabel
            cboxEntity.Items.Add(s1)  'add new detailed description to list box
            iCount = cboxEntity.Items.Count
            cboxEntity.SelectedIndex = iCount - 1 'set selected entity to the just added entity
        End If
    End Sub

    Private Sub btnEditEDtl_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditEDtl.Click
        Dim iCount As Integer = cboxEntity.Items.Count
        Dim iSelInd As Integer = cboxEntity.SelectedIndex
        If (iCount = 1) Then iSelInd = 0 'default to editing single member when only one is present
        If (iSelInd = -1) Then
            MessageBox.Show("No entity detailed description selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        Dim oToEdit As EAdetailClass = CType(cEAentity(iSelInd + 1), EAdetailClass)
        Dim s1 As String = ""
        Dim frmEditDetails As New frmEAdetail(oToEdit)
        frmEditDetails.ShowDialog()
        If (frmEditDetails.bUpdate = True) Then
            cEAentity.Add(frmEditDetails.oEntity, , iSelInd + 1) 'update detailed description collection
            cEAentity.Remove(iSelInd + 2)
            s1 = frmEditDetails.oEntity.EntityLabel
            cboxEntity.Items.Insert(iSelInd, s1) 'update the list box
            cboxEntity.Items.RemoveAt(iSelInd + 1)
            cboxEntity.SelectedIndex = iSelInd
        End If
    End Sub

    Private Sub btnDelEDetl_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelEDetl.Click
        Dim iSelInd As Integer = cboxEntity.SelectedIndex

        If (iSelInd = -1) Then
            MessageBox.Show("No entity detailed description selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        cEAentity.Remove(iSelInd + 1) 'update collection, 1-based index
        cboxEntity.Items.RemoveAt(iSelInd) 'update list box
        Select Case cboxEntity.Items.Count
            Case 0
                iSelInd = -1
            Case 1
                iSelInd = 0
            Case Else
                iSelInd = Math.Max(iSelInd - 1, 0)
        End Select
        cboxEntity.SelectedIndex = iSelInd
    End Sub

    Private Sub btnEAattribAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEAattribAdd.Click
        Dim frmNewAttrib As New frmAttributes
        Dim iCount As Integer = 0
        frmNewAttrib.ShowDialog()
        If (frmNewAttrib.bUpdate = True) Then
            cEAttribs.Add(frmNewAttrib.oAttrib) 'add the new attribute to collection
            cboxAttrib.Items.Add(frmNewAttrib.oAttrib.Label)
            iCount = cboxAttrib.Items.Count
            cboxAttrib.SelectedIndex = iCount - 1 'set selected attribute to the just added attribute
        End If
    End Sub

    Private Sub btnEAattribEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEAattribEdit.Click
        Dim iCount As Integer = cboxAttrib.Items.Count
        Dim iSelInd As Integer = cboxAttrib.SelectedIndex
        If (iCount = 1) Then iSelInd = 0
        If (iSelInd = -1) Then
            MessageBox.Show("No attribute selected for editing", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        Dim oToEdit As AttribClass = CType(cEAttribs(iSelInd + 1), AttribClass) '1-based index
        Dim frmEditAttrib As New frmAttributes(oToEdit)
        frmEditAttrib.ShowDialog()
        If (frmEditAttrib.bUpdate = True) Then
            cEAttribs.Add(frmEditAttrib.oAttrib, , iSelInd + 1) 'update attribute collection
            cEAttribs.Remove(iSelInd + 2)
            cboxAttrib.Items.Insert(iSelInd, frmEditAttrib.oAttrib.Label) 'update list box, 0-based index
            cboxAttrib.Items.RemoveAt(iSelInd + 1)
            cboxAttrib.SelectedIndex = iSelInd
        End If
    End Sub

    Private Sub btnEAattribDel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEAattribDel.Click
        Dim iSelInd As Integer = cboxAttrib.SelectedIndex

        If (iSelInd = -1) Then
            MessageBox.Show("No attribute selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        RemoveAttribLinks(iSelInd + 1) 'remove references to deleted attribute from entities and domain values
        cEAttribs.Remove(iSelInd + 1) 'update the attribute collection, 1-based index
        cboxAttrib.Items.RemoveAt(iSelInd) 'update list box
        Select Case cboxAttrib.Items.Count
            Case 0
                iSelInd = -1
            Case 1
                iSelInd = 0
            Case Else
                iSelInd = Math.Max(iSelInd - 1, 0)
        End Select
        cboxAttrib.SelectedIndex = iSelInd
    End Sub

    Private Sub btnEAdomainAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEAdomainAdd.Click
        Dim sCurDomType As String = ""
        Dim sGenArray() As String
        Dim s1 As String = ""
        Dim iCount As Integer = 0
        Dim frmNewValue As New frmAttribDomain

        frmNewValue.ShowDialog()
        If (frmNewValue.bUpdate = True) Then
            sCurDomType = frmNewValue.sDomType
            cEAdomtype.Add(sCurDomType) 'add domain type to collection

            If (sCurDomType = "enum") Then
                cEAdomains.Add(frmNewValue.oDomainED) 'add domain value to collection
                s1 = "Enumerated: " & frmNewValue.oDomainED.DomainValue 'add value description to list box
            ElseIf (sCurDomType = "range") Then
                cEAdomains.Add(frmNewValue.oDomainRD)
                s1 = "Range: min = " & frmNewValue.oDomainRD.DomMinimum & "  max = " & frmNewValue.oDomainRD.DomMaximum
            ElseIf (sCurDomType = "codeset") Then
                cEAdomains.Add(frmNewValue.sCodeSet)
                sGenArray = Split(frmNewValue.sCodeSet, sPdelim)
                s1 = "Codeset: " & sGenArray(0)
            Else
                cEAdomains.Add(frmNewValue.sUnrepped)
                s1 = "Unrepresentable: " & frmNewValue.sUnrepped
            End If
            cboxDomains.Items.Add(s1)
            iCount = cboxDomains.Items.Count
            cboxDomains.SelectedIndex = iCount - 1 'set selected domain to the just added domain
        End If
    End Sub

    Private Sub btnEAdomainEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEAdomainEdit.Click
        Dim iCount As Integer = cboxDomains.Items.Count
        Dim iSelInd As Integer = cboxDomains.SelectedIndex
        If (iCount = 1) Then iSelInd = 0
        If (iSelInd = -1) Then
            MessageBox.Show("No domain value selected for editing", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        Dim sCurDomType As String = ""
        Dim sGenArray() As String
        Dim s1 As String = ""
        sCurDomType = cEAdomtype(iSelInd + 1) 'retrieve the domain value type
        Select Case sCurDomType
            Case "enum" 'Enumerated Domain
                Dim oDomToEdit As New AttribDomain_Enum
                oDomToEdit = CType(cEAdomains(iSelInd + 1), AttribDomain_Enum)
                Dim frmEditValue As New frmAttribDomain(oDomToEdit)
                frmEditValue.ShowDialog()
                If (frmEditValue.bUpdate = True) Then ProcEditDomain(frmEditValue, iSelInd)
            Case "range" 'Range Domain
                Dim oDomToEdit As New AttribDomain_Range
                oDomToEdit = CType(cEAdomains(iSelInd + 1), AttribDomain_Range)
                Dim frmEditValue As New frmAttribDomain(oDomToEdit)
                frmEditValue.ShowDialog()
                If (frmEditValue.bUpdate = True) Then ProcEditDomain(frmEditValue, iSelInd)
            Case "codeset" 'Codeset Domain
                Dim sDomToEdit As String = ""
                sDomToEdit = CType(cEAdomains(iSelInd + 1), String)
                Dim frmEditValue As New frmAttribDomain(sCurDomType, sDomToEdit)
                frmEditValue.ShowDialog()
                If (frmEditValue.bUpdate = True) Then ProcEditDomain(frmEditValue, iSelInd)
            Case "unrep" 'Unrepresentable Domain
                Dim sDomToEdit As String = ""
                sDomToEdit = CType(cEAdomains(iSelInd + 1), String)
                Dim frmEditValue As New frmAttribDomain(sCurDomType, sDomToEdit)
                frmEditValue.ShowDialog()
                If (frmEditValue.bUpdate = True) Then ProcEditDomain(frmEditValue, iSelInd)
        End Select
    End Sub

    Private Sub btnEAdomainDel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEAdomainDel.Click
        Dim iSelInd As Integer = cboxDomains.SelectedIndex

        If (iSelInd = -1) Then
            MessageBox.Show("No domain value selected for deletion", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        RemoveDomains(iSelInd + 1) 'update attribute domain index collections
        cEAdomains.Remove(iSelInd + 1) 'update domain collection, 1-based index
        cEAdomtype.RemoveAt(iSelInd + 1) 'update domain type string collection, effective 1-based index
        cboxDomains.Items.RemoveAt(iSelInd) 'update list box
        Select Case cboxDomains.Items.Count
            Case 0
                iSelInd = -1
            Case 1
                iSelInd = 0
            Case Else
                iSelInd = Math.Max(iSelInd - 1, 0)
        End Select
        cboxDomains.SelectedIndex = iSelInd
    End Sub

    Private Sub RemoveAttribLinks(ByVal iSelIndex As Integer)
        'remove references to selected attribute from entities and domain values
        'decrement index values greater than index value of attribute being deleted
        Dim iCount As Integer = 0
        Dim iCountInner As Integer = 0
        Dim iLoop As Integer = 0
        Dim jLoop As Integer = 0
        Dim oEntity As New EAdetailClass
        Dim sDomType As String = ""
        Dim oDomEnum As New AttribDomain_Enum
        Dim oDomRange As New AttribDomain_Range
        Dim cIndex As New Collection 'local copy of attribute index values
        Dim iTest As Integer = 0
        Dim iTrack As Integer = 0

        'update the entities
        iCount = cEAentity.Count
        For iLoop = 1 To iCount
            oEntity = CType(cEAentity(iLoop), EAdetailClass) 'retrieve entity to examine
            cIndex = oEntity.AttribColl
            iCountInner = cIndex.Count
            iTrack = 0
            For jLoop = iCountInner To 1 Step -1
                iTest = CType(cIndex(jLoop), Integer) 'retrieve current index value
                If (iTest > iSelIndex) Then
                    cIndex.Add(iTest - 1, , jLoop) 'decrement attribute index if greater than index being deleted
                    cIndex.Remove(jLoop + 1) 'remove old index value
                    iTrack += 1          'set indicator that attribute index collection has changed
                ElseIf (iTest = iSelIndex) Then
                    cIndex.Remove(jLoop) 'remove attribute link if present
                    iTrack += 1          'set indicator that attribute index collection has changed
                End If
            Next
            If (iTrack > 0) Then
                'update the entity
                oEntity.AttribColl = cIndex 'update the entity's index collection
                cEAentity.Add(oEntity, , iLoop) 'insert updated entity into main collection
                cEAentity.Remove(iLoop + 1) 'remove old version from main collection
            End If
        Next

        'update the domain values
        iCount = cEAdomains.Count
        For iLoop = 1 To iCount
            sDomType = cEAdomtype(iLoop) 'retrieve domain type
            If (sDomType = "enum") Then
                oDomEnum = CType(cEAdomains(iLoop), AttribDomain_Enum) 'retrieve enumerated domain to examine
                cIndex = oDomEnum.MoreAttributes
                iCountInner = cIndex.Count
                iTrack = 0
                For jLoop = iCountInner To 1 Step -1
                    iTest = CType(cIndex(jLoop), Integer) 'retrieve current index value
                    If (iTest > iSelIndex) Then
                        cIndex.Add(iTest - 1, , jLoop) 'decrement attribute index if greater than index being deleted
                        cIndex.Remove(jLoop + 1) 'remove old index value
                        iTrack += 1          'set indicator that attribute index collection has changed
                    ElseIf (iTest = iSelIndex) Then
                        cIndex.Remove(jLoop) 'remove attribute link if present
                        iTrack += 1          'set indicator that attribute index collection has changed
                    End If
                Next
                If (iTrack > 0) Then
                    'update the domain
                    oDomEnum.MoreAttributes = cIndex 'update the domain's index collection
                    cEAdomains.Add(oDomEnum, , iLoop) 'insert updated domain into main collection
                    cEAdomains.Remove(iLoop + 1) 'remove old version from main collection
                End If
            ElseIf (sDomType = "range") Then
                oDomRange = CType(cEAdomains(iLoop), AttribDomain_Range) 'retrieve enumerated domain to examine
                cIndex = oDomRange.MoreAttributes
                iCountInner = cIndex.Count
                iTrack = 0
                For jLoop = iCountInner To 1 Step -1
                    iTest = CType(cIndex(jLoop), Integer) 'retrieve current index value
                    If (iTest > iSelIndex) Then
                        cIndex.Add(iTest - 1, , jLoop) 'decrement attribute index if greater than index being deleted
                        cIndex.Remove(jLoop + 1) 'remove old index value
                        iTrack += 1          'set indicator that attribute index collection has changed
                    ElseIf (iTest = iSelIndex) Then
                        cIndex.Remove(jLoop) 'remove attribute link if present
                        iTrack += 1          'set indicator that attribute index collection has changed
                    End If
                Next
                If (iTrack > 0) Then
                    'update the domain
                    oDomRange.MoreAttributes = cIndex 'update the domain's index collection
                    cEAdomains.Add(oDomEnum, , iLoop) 'insert updated domain into main collection
                    cEAdomains.Remove(iLoop + 1) 'remove old version from main collection
                End If
            Else
                'do nothing in cases of Codeset or Unrepresentable domain values
            End If
        Next
    End Sub

    Private Sub ProcEditDomain(ByRef frmValue As frmAttribDomain, ByVal iSelInd As Integer)
        'iSelInd is index from 0-based collection
        Dim sGenArray() As String
        Dim s1 As String = ""
        Dim sCurDomType As String = ""

        sCurDomType = frmValue.sDomType
        cEAdomtype.Insert(iSelInd + 1, sCurDomType) 'insert new domain value type
        cEAdomtype.RemoveAt(iSelInd + 2) 'remove old domain value type
        If (sCurDomType = "enum") Then
            cEAdomains.Add(frmValue.oDomainED, , iSelInd + 1) 'insert new domain value description
            cEAdomains.Remove(iSelInd + 2) 'remove old domain value description
            s1 = "Enumerated: " & frmValue.oDomainED.DomainValue
        ElseIf (sCurDomType = "range") Then
            cEAdomains.Add(frmValue.oDomainRD, , iSelInd + 1) 'insert new domain value description
            cEAdomains.Remove(iSelInd + 2) 'remove old domain value description
            s1 = "Range: min = " & frmValue.oDomainRD.DomMinimum & "  max = " & frmValue.oDomainRD.DomMaximum
        ElseIf (sCurDomType = "codeset") Then
            cEAdomains.Add(frmValue.sCodeSet, , iSelInd + 1) 'insert new domain value description
            cEAdomains.Remove(iSelInd + 2) 'remove old domain value description
            sGenArray = Split(frmValue.sCodeSet, sPdelim)
            s1 = "Codeset: " & sGenArray(0)
        Else
            cEAdomains.Add(frmValue.sUnrepped, , iSelInd + 1) 'insert new domain value description, 1-based index
            cEAdomains.Remove(iSelInd + 2) 'remove old domain value description
            s1 = "Unrepresentable: " & frmValue.sUnrepped
        End If
        cboxDomains.Items.Insert(iSelInd, s1) '0-based index
        cboxDomains.Items.RemoveAt(iSelInd + 1)
        cboxDomains.SelectedIndex = iSelInd
    End Sub

    Private Sub RemoveDomains(ByVal iSelIndex As Integer)
        'remove references to selected domain value from attributes
        'decrement index values greater than index value of domain value being deleted
        Dim iCount As Integer = 0
        Dim iCountInner As Integer = 0
        Dim iLoop As Integer = 0
        Dim jLoop As Integer = 0
        Dim oAttrib As New AttribClass
        Dim cIndex As New Collection 'local copy of attribute index values
        Dim iTest As Integer = 0
        Dim iTrack As Integer = 0

        'update the each attributes domain value index collection
        iCount = cEAttribs.Count
        For iLoop = 1 To iCount
            oAttrib = CType(cEAttribs(iLoop), AttribClass)  'retrieve attribute to examine
            cIndex = oAttrib.DomainValues
            iCountInner = cIndex.Count
            iTrack = 0
            For jLoop = iCountInner To 1 Step -1
                iTest = CType(cIndex(jLoop), Integer) 'retrieve current index value
                If (iTest > iSelIndex) Then
                    cIndex.Add(iTest - 1, , jLoop) 'decrement attribute index if greater than index being deleted
                    cIndex.Remove(jLoop + 1) 'remove old index value
                    iTrack += 1          'set indicator that attribute index collection has changed
                ElseIf (iTest = iSelIndex) Then
                    cIndex.Remove(jLoop) 'remove attribute link if present
                    iTrack += 1          'set indicator that attribute index collection has changed
                End If
            Next
            If (iTrack > 0) Then
                'update the attribute
                oAttrib.DomainValues = cIndex 'update the attribute's index collection
                cEAttribs.Add(oAttrib, , iLoop) 'insert updated attribute into main collection
                cEAttribs.Remove(iLoop + 1) 'remove old version from main collection
            End If
        Next
    End Sub

    Private Sub btnSelEntity_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelEntity.Click
        Dim iCount As Integer = cboxEntity.Items.Count
        Dim iSelInd As Integer = cboxEntity.SelectedIndex
        If (iCount = 1) Then iSelInd = 0
        If (iSelInd = -1) Then
            MessageBox.Show("No entity selected", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        lblEAroot.Text = CType(cboxEntity.SelectedItem, String) 'get entity short description
        iRootIndex = iSelInd + 1
        sRootType = "entity"
    End Sub

    Private Sub btnSelAttrib_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelAttrib.Click
        Dim iCount As Integer = cboxAttrib.Items.Count
        Dim iSelInd As Integer = cboxAttrib.SelectedIndex
        If (iCount = 1) Then iSelInd = 0
        If (iSelInd = -1) Then
            MessageBox.Show("No attribute selected", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        If (lblEAroot.Text <> "" And txtEAbranch.Text <> "") Then
            MessageBox.Show("No blank field. Cannot determine destination.", "Transfer error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        If (lblEAroot.Text = "") Then 'put chosen attribute into Root position
            lblEAroot.Text = CType(cboxAttrib.SelectedItem, String) 'get attribute short description
            iRootIndex = iSelInd + 1
            sRootType = "attribute"
        Else
            If (sRootType = "entity" Or sRootType = "domain") Then
                'put attribute into Branch position
                txtEAbranch.Text = CType(cboxAttrib.SelectedItem, String) 'get attribute short description
                iBranchIndex = iSelInd + 1
                sBranchType = "attribute"
            Else
                MessageBox.Show("Attribute branch not valid with attribute root.", "Transfer error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        End If
    End Sub

    Private Sub btnSelDomain_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelDomain.Click
        Dim iCount As Integer = cboxDomains.Items.Count
        Dim iSelInd As Integer = cboxDomains.SelectedIndex
        If (iCount = 1) Then iSelInd = 0
        If (iSelInd = -1) Then
            MessageBox.Show("No domain value selected", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        Dim sError As String = ""
        Dim sDomType As String = cEAdomtype(iSelInd + 1) 'retrieve domain value type

        'process cases of Codeset and Unrepresentable Domain Values
        If (sDomType = "codeset" Or sDomType = "unrep") Then
            If (lblEAroot.Text = "") Then
                sError = "Root field not filled." & CrLf
                sError += "Cannot determine if Branch is valid destination for this domain value."
                MessageBox.Show(sError, "Transfer error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            ElseIf (sRootType <> "attribute") Then
                sError = "Cannot link this domain value to the specified root type."
                MessageBox.Show(sError, "Transfer error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Else
                txtEAbranch.Text = CType(cboxDomains.SelectedItem, String)
                iBranchIndex = iSelInd + 1
                sBranchType = "domain"
            End If
            Return
        End If

        'process cases of Enumerated and Range Domain Values
        If (lblEAroot.Text = "") Then
            'Root field is blank, place domain value there
            lblEAroot.Text = CType(cboxDomains.SelectedItem, String)
            iRootIndex = iSelInd + 1
            sRootType = "domain"
        ElseIf (sRootType <> "attribute") Then
            sError = "Cannot link this domain value to the specified root type."
            MessageBox.Show(sError, "Transfer error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            txtEAbranch.Text = CType(cboxDomains.SelectedItem, String)
            iBranchIndex = iSelInd + 1
            sBranchType = "domain"
        End If
    End Sub

    Private Sub btnViewLinks_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnViewLinks.Click
        If (iRootIndex = 0) Then
            MessageBox.Show("Empty root field", "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        'Dim frmNewView As New frmEAlinks(lblEAroot.Text, iRootIndex, sRootType)
        'frmNewView.Show()
    End Sub

    Private Sub btnCrLink_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCrLink.Click
        Dim oEntity As New EAdetailClass
        Dim oAttrib As New AttribClass
        Dim oDomEnum As New AttribDomain_Enum
        Dim oDomRange As New AttribDomain_Range
        Dim sDomCode As String = ""
        Dim sDomUnrep As String = ""
        Dim cBranches As New Collection
        Dim sDomType As String = ""
        Dim sError As String = ""
        Dim bTest As Boolean = False

        If (lblEAroot.Text = "" Or txtEAbranch.Text = "") Then
            sError = "Lacking Root or Branch. Cannot create link."
            MessageBox.Show(sError, "Insufficient information", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        If (sRootType = "entity") Then
            oEntity = CType(cEAentity(iRootIndex), EAdetailClass) 'retrieve entity
            cBranches = oEntity.AttribColl 'get collection of attribute index values
            chkAddIndex(cBranches, bTest)
            If (bTest = False) Then
                'chkAddIndex has updated the index collection; now update object
                oEntity.AttribColl = cBranches 'update entity with new collection
                cEAentity.Add(oEntity, , iRootIndex) 'put updated version of entity into collection
                cEAentity.Remove(iRootIndex + 1) 'remove old version of entity
            End If
        ElseIf (sRootType = "attribute") Then
            oAttrib = CType(cEAttribs(iRootIndex), AttribClass) 'retrieve attribute
            cBranches = oAttrib.DomainValues 'get collection of domain index values
            chkAddIndex(cBranches, bTest)
            If (bTest = False) Then
                'chkAddIndex has updated the index collection; now update object
                oAttrib.DomainValues = cBranches 'update attribute with new collection
                cEAttribs.Add(oAttrib, , iRootIndex) 'put updated version of attribute into collection
                cEAttribs.Remove(iRootIndex + 1) 'remove old version of attribute
            End If
        Else 'sRootType = "domain"
            sDomType = cEAdomtype(iRootIndex) 'retrieve type of domain
            If (sDomType = "enum") Then
                'process Enumerated Domain
                oDomEnum = CType(cEAdomains(iRootIndex), AttribDomain_Enum) 'retrieve enumerated domain value
                cBranches = oDomEnum.MoreAttributes 'get collection of attribute index values
                chkAddIndex(cBranches, bTest)
                If (bTest = False) Then
                    'chkAddIndex has updated the index collection; now update object
                    oDomEnum.MoreAttributes = cBranches 'update domain with new collection
                    cEAdomains.Add(oDomEnum, , iRootIndex) 'put update version of domain into collection
                    cEAdomains.Remove(iRootIndex + 1) 'remove old version of domain
                End If
            Else
                'process Range Domain
                oDomRange = CType(cEAdomains(iRootIndex), AttribDomain_Range) 'retrieve range domain value
                cBranches = oDomRange.MoreAttributes 'get collection of attribute index values
                chkAddIndex(cBranches, bTest)
                If (bTest = False) Then
                    'chkAddIndex has updated the index collection; now update object
                    oDomRange.MoreAttributes = cBranches 'update domain with new collection
                    cEAdomains.Add(oDomRange, , iRootIndex) 'put update version of domain into collection
                    cEAdomains.Remove(iRootIndex + 1) 'remove old version of domain
                End If
            End If
        End If
    End Sub

    Private Sub chkAddIndex(ByRef cBranches As Collection, ByRef bCheck As Boolean)
        Dim iCount As Integer = cBranches.Count
        Dim iLoop As Integer = 0
        Dim iTest As Integer = 0
        Dim sTitle As String = "Error adding branch to root"
        Dim sError As String = "Candidate branch already attached to the root."

        bCheck = False
        'evaluate whether candidate branch is already in the index collection
        For iLoop = 1 To iCount
            iTest = CType(cBranches(iLoop), Integer) 'retrieve index value
            If (iTest = iBranchIndex) Then
                bCheck = True 'index already present; display error msg and return
                MessageBox.Show(sError, sTitle, MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            End If
        Next
        'if candidate not present, then add and return
        cBranches.Add(iBranchIndex)
    End Sub

    Private Sub btnDelLink_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelLink.Click
        Dim oEntity As New EAdetailClass
        Dim oAttrib As New AttribClass
        Dim oDomEnum As New AttribDomain_Enum
        Dim oDomRange As New AttribDomain_Range
        Dim sDomCode As String = ""
        Dim sDomUnrep As String = ""
        Dim cBranches As New Collection
        Dim sDomType As String = ""
        Dim sError As String = ""

        If (lblEAroot.Text = "" Or txtEAbranch.Text = "") Then
            sError = "Lacking Root or Branch. Cannot delete link."
            MessageBox.Show(sError, "Insufficient information", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        If (sRootType = "entity") Then
            oEntity = CType(cEAentity(iRootIndex), EAdetailClass) 'retrieve entity
            cBranches = oEntity.AttribColl 'get collection of attribute index values
            DelIndex(cBranches)
            oEntity.AttribColl = cBranches 'update entity with new collection
            cEAentity.Add(oEntity, , iRootIndex) 'put updated version of entity into collection
            cEAentity.Remove(iRootIndex + 1) 'remove old version of entity
        ElseIf (sRootType = "attribute") Then
            oAttrib = CType(cEAttribs(iRootIndex), AttribClass) 'retrieve attribute
            cBranches = oAttrib.DomainValues 'get collection of domain index values
            DelIndex(cBranches)
            oAttrib.DomainValues = cBranches 'update attribute with new collection
            cEAttribs.Add(oAttrib, , iRootIndex) 'put updated version of attribute into collection
            cEAttribs.Remove(iRootIndex + 1) 'remove old version of attribute
        Else 'sRootType = "domain"
            sDomType = cEAdomtype(iRootIndex) 'retrieve type of domain
            If (sDomType = "enum") Then
                'process Enumerated Domain
                oDomEnum = CType(cEAdomains(iRootIndex), AttribDomain_Enum) 'retrieve enumerated domain value
                cBranches = oDomEnum.MoreAttributes 'get collection of attribute index values
                DelIndex(cBranches)
                oDomEnum.MoreAttributes = cBranches 'update domain with new collection
                cEAdomains.Add(oDomEnum, , iRootIndex) 'put update version of domain into collection
                cEAdomains.Remove(iRootIndex + 1) 'remove old version of domain
            Else
                'process Range Domain
                oDomRange = CType(cEAdomains(iRootIndex), AttribDomain_Range) 'retrieve range domain value
                cBranches = oDomRange.MoreAttributes 'get collection of attribute index values
                DelIndex(cBranches)
                oDomRange.MoreAttributes = cBranches 'update domain with new collection
                cEAdomains.Add(oDomRange, , iRootIndex) 'put update version of domain into collection
                cEAdomains.Remove(iRootIndex + 1) 'remove old version of domain
            End If
        End If
    End Sub

    Private Sub DelIndex(ByRef cBranches As Collection)
        Dim iCount As Integer = cBranches.Count
        Dim iLoop As Integer = 0
        Dim iTest As Integer = 0

        For iLoop = iCount To 1 Step -1
            iTest = CType(cBranches(iLoop), Integer) 'retrieve index value
            If (iTest = iBranchIndex) Then
                cBranches.Remove(iLoop) 'update the index collection
            End If
        Next
    End Sub

    Private Sub btnClearElem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearElem.Click
        ClearElem()
    End Sub

    Private Sub ClearElem()
        'reset Root field
        lblEAroot.Text = ""
        iRootIndex = 0
        sRootType = ""
        'reset Branch field
        txtEAbranch.Text = ""
        iBranchIndex = 0
        sBranchType = ""
    End Sub

#End Region


#Region "Handling routines for Distribution Information "

    Private Sub btnAddDistrib_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddDistrib.Click
        Dim s1 As String = ""
        Dim iCount As Integer = 0
        Dim oNewDistrib As New DistributorClass
        Dim oNewContact As New ContactInfo
        Dim frmNewDist As New frmDistribution(iCount)
        frmNewDist.ShowDialog()
        If (frmNewDist.bUpdate = True) Then
            oNewDistrib = frmNewDist.oCurDistrib
            cDistrib.Add(frmNewDist.oCurDistrib) 'add new distributor to main collection
            'identify distributor in list box using required contact information
            oNewContact = oNewDistrib.Distributor
            If (oNewContact.PrimaryPerson = True) Then
                s1 = "Distributor, person: " & oNewContact.Person
            Else
                s1 = "Distributor, organization: " & oNewContact.Organization
            End If
            lboxDistrib.Items.Add(s1)
        End If
    End Sub

    Private Sub btnEditDistrib_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEditDistrib.Click
        Dim iCount As Integer = lboxDistrib.Items.Count
        Dim indexVal As Integer = lboxDistrib.SelectedIndex
        Dim s1 As String = ""
        If (indexVal = -1) Then
            If (iCount = 0) Then
                s1 = "No Distributor available to edit."
                MessageBox.Show(s1, "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            ElseIf (iCount = 1) Then
                indexVal = 0
            Else
                s1 = "No Distributor chosen for editing."
                MessageBox.Show(s1, "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            End If
        End If

        Dim oEditDistrib As New DistributorClass
        Dim oEditContact As New ContactInfo
        Dim frmEditDist As New frmDistribution(indexVal + 1) 'convert from 0-based list to 1-based collection
        frmEditDist.ShowDialog()
        If (frmEditDist.bUpdate = True) Then
            oEditDistrib = frmEditDist.oCurDistrib
            cDistrib.Add(oEditDistrib, , indexVal + 1) 'insert edited distributor into main collection
            cDistrib.Remove(indexVal + 2) 'remove old version; 1-based index
            'update distributor identification in list box using required contact information
            oEditContact = oEditDistrib.Distributor
            If (oEditContact.PrimaryPerson = True) Then
                s1 = "Distributor, person: " & oEditContact.Person
            Else
                s1 = "Distributor, organization: " & oEditContact.Organization
            End If
            lboxDistrib.Items.Insert(indexVal, s1) 'insert edited identifier into list box
            lboxDistrib.Items.RemoveAt(indexVal + 1) 'remove old version; 0-based index
        End If
    End Sub

    Private Sub btnDelDistrib_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelDistrib.Click
        Dim indexVal As Integer = lboxDistrib.SelectedIndex
        Dim s1 As String = ""
        If (indexVal = -1) Then
            s1 = "No Distributor chosen for deletion."
            MessageBox.Show(s1, "Selection error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        cDistrib.Remove(indexVal + 1) '1-based collection of Distributors
        lboxDistrib.Items.RemoveAt(indexVal) '0-based collection in list box
    End Sub

#End Region


#Region " Handling routines for Metadata Reference section "

    Private Sub btnMRedit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMRedit.Click
        Dim iConType As Integer = 0
        Dim frmMRcontact As frmContact
        If (txtMRcontact.Text = "") Then
            frmMRcontact = New frmContact(objMRcontact, 1)
        Else
            frmMRcontact = New frmContact(objMRcontact, 2)
        End If
        frmMRcontact.ShowDialog()
        If (frmMRcontact.bUpdate = True) Then
            objMRcontact = frmMRcontact.conInfo 'update the contact object
            If (objMRcontact.PrimaryPerson = True) Then 'update the form display
                txtMRcontact.Text = objMRcontact.Person
            Else
                txtMRcontact.Text = objMRcontact.Organization
            End If
        End If
    End Sub

    Private Sub chkRevDate_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkRevDate.CheckedChanged
        If (chkRevDate.Checked = True) Then
            dtPick2.Enabled = True
        Else
            dtPick2.Enabled = False
        End If
    End Sub

    Private Sub chkFRevDate_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkFRevDate.CheckedChanged
        If (chkFRevDate.Checked = True) Then
            dtPick3.Enabled = True
        Else
            dtPick3.Enabled = False
        End If
    End Sub

#End Region


#Region " Handling routines for Citations "

    Private Function fixStringCrLf(ByVal strInput As String) As String
        'routine to remove extraneous CR/LF from string
        ' result is string containing non-empty substrings separated by single CR/LF
        Dim strValues() As String
        Dim intLen As Integer = 0
        Dim intPos As Integer = 0
        Dim bAdd As Boolean = False
        Dim strSingle As String = CrLf

        If (Len(strInput) = 0) Then 'if blank, return blank string
            Return strInput
        End If

        strValues = Split(strInput, strSingle)  'split using CR/LF as delimiter
        intLen = strValues.GetLength(0)         'get number of substrings found

        strInput = ""                           're-initialize string being parsed
        bAdd = False
        For intPos = 0 To intLen - 1            'add non-zero length substrings, separate with CR/LF
            If (strValues(intPos) <> "") Then
                If (bAdd = True) Then
                    strInput = strInput & CrLf & strValues(intPos)
                Else
                    'first non-blank entry is not preceded by CrLf
                    strInput = strValues(intPos)
                    bAdd = True
                End If
            End If
        Next

        Return strInput
    End Function

#End Region


#Region " File saving procedures -- XML creation, ID section "

    Private Sub updateIDsection()
        'create Citation, Description, Time Period of Content, and Status
        xmlCiteToStatus()

        'create Spatial Domain
        xmlSpaDom()

        'create Keywords
        xmlKeywords()

        'create Taxonomy
        xmlTaxonomy()

        'create Access and Miscellaneous
        xmlAccessEtc()

        'create Analytical Tools
        xmlAnalyticTools()

    End Sub

    Private Sub xmlCiteToStatus()
        Dim iLoop As Integer = 0
        Dim iLoop2 As Integer = 0
        Dim iLoop3 As Integer = 0
        Dim iToStart As Integer = 0
        Dim iToEnd As Integer = 0
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim sGenArray() As String
        Dim xmlTempNode As XmlNode  'main node for a sub-section
        Dim xmlTempNode2 As XmlNode '1st level subsidiary node for a sub-section
        Dim xmlTempNode3 As XmlNode '2nd level subsidiary node for a subsection
        Dim xmlTempNode4 As XmlNode '3rd level subsidiary node for a subsection
        Dim xmlPiece1 As XmlNode
        Dim xmlPiece2 As XmlNode

        'create Citation
        xmlTempNode = xmlHeader.CreateElement("citation")
        xmlCiteinfo(objCitation, xmlPiece1) 'generate main citation in xmlPiece1
        If (bCitationLWork = True) Then  'generate larger work citation, if present, in xmlPiece2
            xmlTempNode2 = xmlHeader.CreateElement("lworkcit")
            xmlCiteinfo(objCitationLWork, xmlPiece2)
            xmlTempNode2.AppendChild(xmlPiece2) 'put LWC into lworkcit
            xmlPiece1.AppendChild(xmlTempNode2) 'put lworkcit into primary citeinfo, i.e, xmlPiece1
        End If
        xmlTempNode.AppendChild(xmlPiece1)  'add citeinfo to citation node
        xmlIDsection.AppendChild(xmlTempNode) 'add citation node to ID section node as first child

        'create Description
        Dim xmlDescNode As XmlNode = xmlHeader.CreateElement("descript")
        xmlTempNode = xmlHeader.CreateElement("abstract")  'add the abstract
        If (txtAbstract.Text = "") Then
            Dim xmlAttrib As XmlAttribute = xmlHeader.CreateAttribute("missing")
            xmlAttrib.Value = "True"
            xmlTempNode.Attributes.Append(xmlAttrib) 'adds the "missing" attribute
        Else
            s1 = txtAbstract.Text
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode.InnerText = s1
        End If
        xmlDescNode.AppendChild(xmlTempNode)
        xmlTempNode = xmlHeader.CreateElement("purpose")  'add the purpose
        If (txtPurpose.Text = "") Then
            Dim xmlAttrib2 As XmlAttribute = xmlHeader.CreateAttribute("missing")
            xmlAttrib2.Value = "True"
            xmlTempNode.Attributes.Append(xmlAttrib2) 'add the "missing" attribute
        Else
            s1 = txtPurpose.Text
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode.InnerText = s1
        End If
        xmlDescNode.AppendChild(xmlTempNode)
        If (txtSupplInfo.Text = "") Then  'add supplemental information if present (optional)
        Else
            xmlTempNode = xmlHeader.CreateElement("supplinf")
            s1 = txtSupplInfo.Text
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode.InnerText = s1
            xmlDescNode.AppendChild(xmlTempNode)
        End If
        xmlIDsection.AppendChild(xmlDescNode)  'add description node to ID section node as second child

        'create Time Period of Content
        Dim xmlTimePerContNode As XmlNode = xmlHeader.CreateElement("timeperd")
        Dim iRange As Integer = 0  '1=single, 2=range, 3=multiple
        Dim iTType As Integer = 0  '1=Gregorian, 2=Geologic
        If (rdoTLocal.Checked = True) Then
            iTType = 1
        Else
            iTType = 2
        End If
        If (rdoTSingle.Checked = True) Then
            iRange = 1
        ElseIf (rdoTRange.Checked = True) Then
            iRange = 2
        ElseIf (rdoTMult.Checked = True) Then
            iRange = 3
        Else
            iRange = 4 'Unknown
        End If
        xmlTimePeriodInfo(IDtimeper, iRange, iTType, xmlPiece1) 'generate timeinfo in xmlPiece1
        xmlTimePerContNode.AppendChild(xmlPiece1)  'add timeinfo to time period of content node

        xmlTempNode = xmlHeader.CreateElement("current")  'add currentness
        If (cboxCurRef.Text = "") Then
            Dim xmlAttrib As XmlAttribute = xmlHeader.CreateAttribute("missing")
            xmlAttrib.Value = "True"
            xmlTempNode.Attributes.Append(xmlAttrib) 'add the "missing" attribute
        End If
        xmlTempNode.InnerText = cboxCurRef.Text
        xmlTimePerContNode.AppendChild(xmlTempNode)
        xmlIDsection.AppendChild(xmlTimePerContNode) 'add time period of content node to ID section node as third child

        'create Status
        Dim xmlStatusNode As XmlNode = xmlHeader.CreateElement("status")
        xmlTempNode = xmlHeader.CreateElement("progress")  'add progress
        If (lboxProg.Text = "") Then
            Dim xmlAttrib3 As XmlAttribute = xmlHeader.CreateAttribute("missing")
            xmlAttrib3.Value = "True"
            xmlTempNode.Attributes.Append(xmlAttrib3) 'add the "missing" attribute
        End If
        xmlTempNode.InnerText = lboxProg.Text
        xmlStatusNode.AppendChild(xmlTempNode)
        xmlTempNode = xmlHeader.CreateElement("update")  'add maintenance & update frequency
        If (cboxUpdate.Text = "") Then
            Dim xmlAttrib4 As XmlAttribute = xmlHeader.CreateAttribute("missing")
            xmlAttrib4.Value = "True"
            xmlTempNode.Attributes.Append(xmlAttrib4) 'add the "missing" attribute
        End If
        xmlTempNode.InnerText = cboxUpdate.Text
        xmlStatusNode.AppendChild(xmlTempNode)
        xmlIDsection.AppendChild(xmlStatusNode)  'add status node to ID section node as fourth child

    End Sub

    Private Sub xmlSpaDom()
        Dim iLoop As Integer = 0
        Dim iLoop2 As Integer = 0
        Dim iLoop3 As Integer = 0
        Dim iToStart As Integer = 0
        Dim iToEnd As Integer = 0
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim sGenArray() As String
        Dim xmlTempNode As XmlNode  'main node for a sub-section
        Dim xmlTempNode2 As XmlNode '1st level subsidiary node for a sub-section
        Dim xmlTempNode3 As XmlNode '2nd level subsidiary node for a subsection
        Dim xmlTempNode4 As XmlNode '3rd level subsidiary node for a subsection
        Dim xmlPiece1 As XmlNode
        Dim xmlPiece2 As XmlNode

        'create Spatial Domain
        Dim xmlSpDomNode As XmlNode = xmlHeader.CreateElement("spdom")
        If (txtGeoExt.Text = "") Then
            'do nothing
        Else
            xmlTempNode = xmlHeader.CreateElement("descgeog") 'Description of Geographic Extent
            xmlTempNode.InnerText = txtGeoExt.Text
            xmlSpDomNode.AppendChild(xmlTempNode)
        End If
        If (numWestBC.Value = 0 And numEastBC.Value = 0 And numNorthBC.Value = 0 And numSouthBC.Value = 0) Then
            'do nothing
        Else
            'process Bounding Coordinates
            xmlTempNode = xmlHeader.CreateElement("bounding") 'Bounding Coordinates
            xmlTempNode2 = xmlHeader.CreateElement("westbc")     'west bounding coordinate
            xmlTempNode2.InnerText = numWestBC.Value.ToString
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlTempNode2 = xmlHeader.CreateElement("eastbc")     'east bounding coordinate
            xmlTempNode2.InnerText = numEastBC.Value.ToString
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlTempNode2 = xmlHeader.CreateElement("northbc")     'north bounding coordinate
            xmlTempNode2.InnerText = numNorthBC.Value.ToString
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlTempNode2 = xmlHeader.CreateElement("southbc")     'south bounding coordinate
            xmlTempNode2.InnerText = numSouthBC.Value.ToString
            xmlTempNode.AppendChild(xmlTempNode2)

            'process bounding altitudes if present
            If (numAltMin.Value = 0 And numAltMax.Value = 0) Then
                'do nothing
            Else
                xmlTempNode2 = xmlHeader.CreateElement("boundalt") 'Bounding Altitudes
                xmlTempNode3 = xmlHeader.CreateElement("altmin")      'Altitude Minimum
                xmlTempNode3.InnerText = numAltMin.Value.ToString
                xmlTempNode2.AppendChild(xmlTempNode3)
                xmlTempNode3 = xmlHeader.CreateElement("altmax")      'Altitude Maximum
                xmlTempNode3.InnerText = numAltMax.Value.ToString
                xmlTempNode2.AppendChild(xmlTempNode3)
                xmlTempNode3 = xmlHeader.CreateElement("altunits")    'Altitude Distance Units
                xmlTempNode3.InnerText = cboxIDaltDistU.Text
                xmlTempNode2.AppendChild(xmlTempNode3)
                xmlTempNode.AppendChild(xmlTempNode2) 'add bounding altitudes to bounding coordinates
            End If
            xmlSpDomNode.AppendChild(xmlTempNode)
        End If

        If (sDataSetGPoly.Count = 0) Then
            'do nothing
        Else
            Dim iPolyCount As Integer = sCountGPoly.Count  'process G-polygons
            Dim iExPolyCount As Integer = 0
            Dim sPoints() As String
            iToStart = 0
            iToEnd = 0

            For iLoop = 0 To iPolyCount - 1
                xmlTempNode = xmlHeader.CreateElement("dsgpoly")    'Data Set G-Polygon
                xmlTempNode2 = xmlHeader.CreateElement("dsgpolyo")      'outer G-ring
                If (sDataSetGPoly(iToStart) = "string") Then
                    xmlTempNode3 = xmlHeader.CreateElement("gring")     'create g-ring description
                    xmlTempNode3.InnerText = sDataSetGPoly(iToStart + 1)
                    xmlTempNode2.AppendChild(xmlTempNode3)
                Else
                    sGenArray = Split(sDataSetGPoly(iToStart + 1), sPdelim) 'contains the point strings
                    iExPolyCount = sGenArray.GetUpperBound(0)
                    For iLoop2 = 0 To iExPolyCount
                        sPoints = Split(sGenArray(iLoop2))    'contains the lat and long for the g-ring point
                        xmlTempNode3 = xmlHeader.CreateElement("grngpoin")  'G-ring point
                        xmlTempNode4 = xmlHeader.CreateElement("gringlat")     'set latitude
                        xmlTempNode4.InnerText = sPoints(0)
                        xmlTempNode3.AppendChild(xmlTempNode4)
                        xmlTempNode4 = xmlHeader.CreateElement("gringlon")     'set longitude
                        xmlTempNode4.InnerText = sPoints(1)
                        xmlTempNode3.AppendChild(xmlTempNode4)
                        xmlTempNode2.AppendChild(xmlTempNode3) 'add g-ring point to outer g-ring
                    Next
                End If
                xmlTempNode.AppendChild(xmlTempNode2)  'add outer G-ring to the G-Polygon description
                iToStart += 2
                iExPolyCount = CInt(sCountGPoly(iLoop)) 'number of exclusion polygons for particular G-polygon
                iToEnd = iToStart + iExPolyCount * 2 - 1 '2 strings per polygon
                For iLoop2 = iToStart To iToEnd Step 2
                    If (iExPolyCount = 0) Then Exit For
                    xmlTempNode2 = xmlHeader.CreateElement("dsgpolyx") 'an exclusion g-ring
                    If (sDataSetGPoly(iLoop2) = "string") Then
                        xmlTempNode3 = xmlHeader.CreateElement("gring")     'create g-ring description
                        xmlTempNode3.InnerText = sDataSetGPoly(iLoop2 + 1)
                        xmlTempNode2.AppendChild(xmlTempNode3)
                    Else
                        sGenArray = Split(sDataSetGPoly(iLoop2 + 1), sPdelim) 'contains the point strings
                        iExPolyCount = sGenArray.GetUpperBound(0)
                        For iLoop3 = 0 To iExPolyCount
                            sPoints = Split(sGenArray(iLoop3))    'contains the lat and long for the g-ring point
                            xmlTempNode3 = xmlHeader.CreateElement("grngpoin")  'G-ring point
                            xmlTempNode4 = xmlHeader.CreateElement("gringlat")     'set latitude
                            xmlTempNode4.InnerText = sPoints(0)
                            xmlTempNode3.AppendChild(xmlTempNode4)
                            xmlTempNode4 = xmlHeader.CreateElement("gringlon")     'set longitude
                            xmlTempNode4.InnerText = sPoints(1)
                            xmlTempNode3.AppendChild(xmlTempNode4)
                            xmlTempNode2.AppendChild(xmlTempNode3) 'add g-ring point to exclusion g-ring
                        Next
                    End If
                    xmlTempNode.AppendChild(xmlTempNode2) 'add exclusion g-ring to G-Polygon
                Next
                If (iToStart < iToEnd) Then iToStart = iToEnd + 1 'if handled exclusion polygons, need to update start index
                xmlSpDomNode.AppendChild(xmlTempNode) 'appends each Data Set G-Polygon to Spatial Domain
            Next
        End If
        If (xmlSpDomNode.HasChildNodes = True) Then
            xmlIDsection.AppendChild(xmlSpDomNode)
        End If
    End Sub

    Private Sub xmlKeywords()
        Dim iLoop As Integer = 0
        Dim iLoop2 As Integer = 0
        Dim iLoop3 As Integer = 0
        Dim iToStart As Integer = 0
        Dim iToEnd As Integer = 0
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim sGenArray() As String
        Dim xmlTempNode As XmlNode  'main node for a sub-section
        Dim xmlTempNode2 As XmlNode '1st level subsidiary node for a sub-section
        Dim xmlTempNode3 As XmlNode '2nd level subsidiary node for a subsection
        Dim xmlTempNode4 As XmlNode '3rd level subsidiary node for a subsection
        Dim xmlPiece1 As XmlNode
        Dim xmlPiece2 As XmlNode

        'create Keywords
        Dim xmlKeywords As XmlNode = xmlHeader.CreateElement("keywords")
        iToStart = lboxKTheme.Items.Count - 1 'determine number of Themes (zero-based)
        If (iToStart = -1) Then 'Theme is mandatory, so needs to show up in output
            xmlTempNode = xmlHeader.CreateElement("theme")
            xmlTempNode2 = xmlHeader.CreateElement("themekt")  'set the thesaurus
            xmlTempNode2.InnerText = "None"
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlTempNode2 = xmlHeader.CreateElement("themekey") 'set the keywords
            Dim xmlAttrib As XmlAttribute = xmlHeader.CreateAttribute("missing")
            xmlAttrib.Value = "True"
            xmlTempNode2.Attributes.Append(xmlAttrib) 'add the "missing" attribute
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlKeywords.AppendChild(xmlTempNode)
        End If
        For iLoop = 0 To iToStart 'create Theme Keywords
            xmlTempNode = xmlHeader.CreateElement("theme")
            sGenArray = Split(sKeyTheme(iLoop), sPdelim)       'break up string into 2 pieces
            xmlTempNode2 = xmlHeader.CreateElement("themekt")  'set the thesaurus
            xmlTempNode2.InnerText = sGenArray(0)
            xmlTempNode.AppendChild(xmlTempNode2)
            s1 = sGenArray(1) 'move keywords into string
            sGenArray = Split(s1, sKdelim) 'break up the keywords into individual elements
            iToEnd = sGenArray.GetUpperBound(0)
            For iLoop2 = 0 To iToEnd
                s2 = sGenArray(iLoop2) 'get a keyword
                If (s2 = "") Then
                Else                   'if not blank, add themekey element to theme
                    xmlTempNode2 = xmlHeader.CreateElement("themekey")
                    xmlTempNode2.InnerText = s2
                    xmlTempNode.AppendChild(xmlTempNode2)
                End If
            Next
            xmlKeywords.AppendChild(xmlTempNode)
        Next

        iToStart = lboxKPlace.Items.Count - 1 'determine number of Places (zero-based)
        For iLoop = 0 To iToStart 'create Place Keywords
            xmlTempNode = xmlHeader.CreateElement("place")
            sGenArray = Split(sKeyPlace(iLoop), sPdelim)       'break up string into 2 pieces
            xmlTempNode2 = xmlHeader.CreateElement("placekt")  'set the thesaurus
            xmlTempNode2.InnerText = sGenArray(0)
            xmlTempNode.AppendChild(xmlTempNode2)
            s1 = sGenArray(1) 'move keywords into string
            sGenArray = Split(s1, sKdelim) 'break up the keywords into indiviual elements
            iToEnd = sGenArray.GetUpperBound(0)
            For iLoop2 = 0 To iToEnd
                s2 = sGenArray(iLoop2) 'get a keyword
                If (s2 = "") Then
                Else                   'if not blank, add themekey element to theme
                    xmlTempNode2 = xmlHeader.CreateElement("placekey")
                    xmlTempNode2.InnerText = s2
                    xmlTempNode.AppendChild(xmlTempNode2)
                End If
            Next
            xmlKeywords.AppendChild(xmlTempNode)
        Next

        iToStart = lboxKStratum.Items.Count - 1 'determine number of Strata (zero-based)
        For iLoop = 0 To iToStart 'create Stratum Keywords
            xmlTempNode = xmlHeader.CreateElement("stratum")
            sGenArray = Split(sKeyStratum(iLoop), sPdelim)       'break up string into 2 pieces
            xmlTempNode2 = xmlHeader.CreateElement("stratkt")  'set the thesaurus
            xmlTempNode2.InnerText = sGenArray(0)
            xmlTempNode.AppendChild(xmlTempNode2)
            s1 = sGenArray(1) 'move keywords into string
            sGenArray = Split(s1, sKdelim) 'break up the keywords into indiviual elements
            iToEnd = sGenArray.GetUpperBound(0)
            For iLoop2 = 0 To iToEnd
                s2 = sGenArray(iLoop2) 'get a keyword
                If (s2 = "") Then
                Else                   'if not blank, add themekey element to theme
                    xmlTempNode2 = xmlHeader.CreateElement("stratkey")
                    xmlTempNode2.InnerText = s2
                    xmlTempNode.AppendChild(xmlTempNode2)
                End If
            Next
            xmlKeywords.AppendChild(xmlTempNode)
        Next

        iToStart = lboxKTemporal.Items.Count - 1 'determine number of Temporal items (zero-based)
        For iLoop = 0 To iToStart 'create Place Keywords
            xmlTempNode = xmlHeader.CreateElement("temporal")
            sGenArray = Split(sKeyTemporal(iLoop), sPdelim)       'break up string into 2 pieces
            xmlTempNode2 = xmlHeader.CreateElement("tempkt")  'set the thesaurus
            xmlTempNode2.InnerText = sGenArray(0)
            xmlTempNode.AppendChild(xmlTempNode2)
            s1 = sGenArray(1) 'move keywords into string
            sGenArray = Split(s1, sKdelim) 'break up the keywords into indiviual elements
            iToEnd = sGenArray.GetUpperBound(0)
            For iLoop2 = 0 To iToEnd
                s2 = sGenArray(iLoop2) 'get a keyword
                If (s2 = "") Then
                Else                   'if not blank, add themekey element to theme
                    xmlTempNode2 = xmlHeader.CreateElement("tempkey")
                    xmlTempNode2.InnerText = s2
                    xmlTempNode.AppendChild(xmlTempNode2)
                End If
            Next
            xmlKeywords.AppendChild(xmlTempNode)
        Next

        xmlIDsection.AppendChild(xmlKeywords)

    End Sub

    Private Sub xmlTaxonomy()
        Dim iLoop As Integer = 0
        Dim iLoop2 As Integer = 0
        Dim iLoop3 As Integer = 0
        Dim iToStart As Integer = 0
        Dim iToEnd As Integer = 0
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim sGenArray() As String
        Dim xmlTempNode As XmlNode  'main node for a sub-section
        Dim xmlTempNode2 As XmlNode '1st level subsidiary node for a sub-section
        Dim xmlTempNode3 As XmlNode '2nd level subsidiary node for a subsection
        Dim xmlTempNode4 As XmlNode '3rd level subsidiary node for a subsection
        Dim xmlPiece1 As XmlNode
        Dim xmlPiece2 As XmlNode

        'create Taxonomy, if needed
        iToStart = sTaxKeywords.Count
        If (iToStart > 0) Then
            xmlTempNode = xmlHeader.CreateElement("taxonomy")
        Else
            Return
        End If

        'create Keywords/Taxon
        For iLoop = 1 To iToStart
            sGenArray = Split(sTaxKeywords(iLoop - 1), sPdelim)
            xmlTempNode2 = xmlHeader.CreateElement("keywtax") 'create main node
            xmlTempNode3 = xmlHeader.CreateElement("taxonkt") 'create keyword thesaurus
            xmlTempNode3.InnerText = sGenArray(0)
            xmlTempNode2.AppendChild(xmlTempNode3) 'add thesaurus to keyword/taxon
            s1 = sGenArray(1) 'string of keywords
            sGenArray = Split(s1, sKdelim) 'break into component keywords
            iToEnd = sGenArray.GetUpperBound(0) 'number of possible keywords
            For iLoop2 = 0 To iToEnd
                If (sGenArray(iLoop2) = "") Then 'do nothing
                Else                             'if not empty, then create keyword node
                    xmlTempNode3 = xmlHeader.CreateElement("taxonkey")
                    xmlTempNode3.InnerText = sGenArray(iLoop2)
                    xmlTempNode2.AppendChild(xmlTempNode3) 'add keyword to keyword/taxon
                End If
            Next
            xmlTempNode.AppendChild(xmlTempNode2) 'add keyword/taxon to taxonomy
        Next

        Dim curCite As CiteInfo 'will hold the current citation
        Dim bCiteLWC As Boolean
        Dim xmlCiteNode As XmlNode 'parent node for classification system citation
        Dim curContact As ContactInfo

        'create taxonomic system, if needed
        iToStart = citeTaxSys.Count
        If (iToStart > 0 Or txtTaxProc.Text <> "") Then 'check presence of required elements and process taxonomic system
            xmlTempNode2 = xmlHeader.CreateElement("taxonsys")
            If (iToStart > 0) Then 'process classification system information

                For iLoop = 1 To iToStart
                    xmlTempNode3 = xmlHeader.CreateElement("classsys")
                    xmlCiteNode = xmlHeader.CreateElement("classcit")
                    curCite = CType(citeTaxSys(iLoop), CiteInfo)
                    xmlCiteinfo(curCite, xmlPiece1) 'generate main citation in xmlPiece1
                    bCiteLWC = CType(boolTaxSys(iLoop), Boolean) 'Boolean for larger work citation
                    If (bCiteLWC = True) Then  'generate larger work citation, if present, in xmlPiece2
                        xmlTempNode4 = xmlHeader.CreateElement("lworkcit")
                        curCite = CType(citeTaxSysLWC(iLoop), CiteInfo)
                        xmlCiteinfo(curCite, xmlPiece2)
                        xmlTempNode4.AppendChild(xmlPiece2) 'put LWC into lworkcit
                        xmlPiece1.AppendChild(xmlTempNode4) 'put lworkcit into primary citeinfo, i.e, xmlPiece1
                    End If
                    xmlCiteNode.AppendChild(xmlPiece1)  'add citeinfo to classification system citation node
                    xmlTempNode3.AppendChild(xmlCiteNode) 'add class system citation to class system
                    If (sTaxSysMods(iLoop - 1) <> "") Then 'add classification system modifications, if present
                        xmlTempNode4 = xmlHeader.CreateElement("classmod")
                        s1 = sTaxSysMods(iLoop - 1)
                        If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                        xmlTempNode4.InnerText = s1
                        xmlTempNode3.AppendChild(xmlTempNode4)
                    End If
                    xmlTempNode2.AppendChild(xmlTempNode3) 'add classification system to taxonomic system
                Next
            End If

            iToStart = citeTaxIDRef.Count 'number of identification references
            For iLoop = 1 To iToStart
                xmlTempNode3 = xmlHeader.CreateElement("idref")
                curCite = CType(citeTaxIDRef(iLoop), CiteInfo)
                xmlCiteinfo(curCite, xmlPiece1) 'generate main citation in xmlPiece1
                bCiteLWC = CType(boolTaxIDRef(iLoop), Boolean) 'Boolean for larger work citation
                If (bCiteLWC = True) Then  'generate larger work citation, if present, in xmlPiece2
                    xmlTempNode4 = xmlHeader.CreateElement("lworkcit")
                    curCite = CType(citeTaxIDRefLWC(iLoop), CiteInfo)
                    xmlCiteinfo(curCite, xmlPiece2)
                    xmlTempNode4.AppendChild(xmlPiece2) 'put LWC into lworkcit
                    xmlPiece1.AppendChild(xmlTempNode4) 'put lworkcit into primary citeinfo, i.e, xmlPiece1
                End If
                xmlTempNode3.AppendChild(xmlPiece1)  'add citeinfo to ID Reference node
                xmlTempNode2.AppendChild(xmlTempNode3) 'add ID Reference to taxonomic system
            Next

            iToStart = cntTaxID.Count 'number of identifier contacts
            For iLoop = 1 To iToStart
                xmlTempNode3 = xmlHeader.CreateElement("ider")
                curContact = CType(cntTaxID(iLoop), ContactInfo) 'get contact information
                xmlContactInfo(curContact, xmlTempNode4) 'process contact information
                xmlTempNode3.AppendChild(xmlTempNode4) 'add contact info to identifier node
                xmlTempNode2.AppendChild(xmlTempNode3) 'add identifier node to taxonomic system node
            Next

            xmlTempNode3 = xmlHeader.CreateElement("taxonpro") 'add taxonomic procedures
            s1 = txtTaxProc.Text
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode3.InnerText = s1
            xmlTempNode2.AppendChild(xmlTempNode3)

            If (txtTaxComplete.Text <> "") Then 'add taxonomic completeness if present
                xmlTempNode3 = xmlHeader.CreateElement("taxoncom")
                s1 = txtTaxComplete.Text
                If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                xmlTempNode3.InnerText = s1
                xmlTempNode2.AppendChild(xmlTempNode3)
            End If

            iToStart = cntVouchers.Count 'number of vouchers
            For iLoop = 1 To iToStart
                xmlTempNode3 = xmlHeader.CreateElement("vouchers")
                xmlTempNode4 = xmlHeader.CreateElement("specimen")
                xmlTempNode4.InnerText = sVSpecimen(iLoop - 1)
                xmlTempNode3.AppendChild(xmlTempNode4) 'add specimen to voucher
                curContact = CType(cntVouchers(iLoop), ContactInfo)
                xmlContactInfo(curContact, xmlTempNode4)
                xmlCiteNode = xmlHeader.CreateElement("reposit")
                xmlCiteNode.AppendChild(xmlTempNode4) 'add contact information to repository
                xmlTempNode3.AppendChild(xmlCiteNode) 'add repository to voucher
                xmlTempNode2.AppendChild(xmlTempNode3) 'add voucher to taxonomic system
            Next

            xmlTempNode.AppendChild(xmlTempNode2) 'add taxonomic system to taxonomy
        End If

        If (txtTaxCover.Text <> "") Then 'add general taxonomic coverage if present
            xmlTempNode2 = xmlHeader.CreateElement("taxongen")
            s1 = txtTaxCover.Text
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode2.InnerText = s1
            xmlTempNode.AppendChild(xmlTempNode2)
        End If

        'process taxonomic classification
        Dim bTaxLen As Boolean
        Dim xmlTaxNode As XmlNode

        bTaxLen = xmlTaxonClass.HasChildNodes
        If (bTaxLen) Then
            xmlTaxNode = xmlHeader.ImportNode(xmlTaxonClass.SelectSingleNode("/taxoncl"), True)
            xmlTempNode.AppendChild(xmlTaxNode) 'add taxonomic classification to taxonomy
        Else
        End If
        xmlIDsection.AppendChild(xmlTempNode)  'add taxonomy node to ID section node

    End Sub

    Private Sub xmlTaxaChild(ByVal iSelIndex As Integer, ByRef xmlTaxaNode As XmlNode, ByRef iStartIndexNew As Integer)
        Dim xmlTemp As XmlNode
        Dim xmlTemp2 As XmlNode
        Dim xmltemp3 As XmlNode
        Dim oCurTaxa As TaxonClass
        Dim iToStart As Integer = 0
        Dim iChild As Integer = 0
        Dim iLoop As Integer = 0
        Dim iLoop2 As Integer = 0
        Dim sGenArray() As String
        Dim s1 As String = ""
        Dim iToEnd As Integer = 0

        If (iSelIndex > TaxaClasses.Count) Then 'reached end of collection
            iStartIndexNew = iSelIndex
            Return
        End If

        oCurTaxa = CType(TaxaClasses(iSelIndex), TaxonClass)
        xmlTaxaNode = xmlHeader.CreateElement("taxoncl") 'create root element
        xmlTemp = xmlHeader.CreateElement("taxonrn")     'add rank name
        xmlTemp.InnerText = oCurTaxa.RankName
        xmlTaxaNode.AppendChild(xmlTemp)
        xmlTemp = xmlHeader.CreateElement("taxonrv")     'add rank value
        xmlTemp.InnerText = oCurTaxa.RankValue
        xmlTaxaNode.AppendChild(xmlTemp)
        If (oCurTaxa.CommonName <> "") Then
            sGenArray = Split(oCurTaxa.CommonName, sKdelim)
            iToEnd = sGenArray.GetUpperBound(0)
            For iToStart = 0 To iToEnd
                s1 = sGenArray(iToStart).Trim
                If (s1 <> "") Then
                    xmlTemp = xmlHeader.CreateElement("common")
                    xmlTemp.InnerText = s1
                    xmlTaxaNode.AppendChild(xmlTemp)
                End If
            Next

        End If

        iChild = oCurTaxa.Nchildren 'get number of children for this node
        iToStart = iSelIndex + 1    'set starting index to be next index value

        If (iChild = 0) Then 'done with this lineage, set new start index and return
            iStartIndexNew = iToStart
            Return
        End If
        For iLoop = 1 To iChild     'process children if present
            xmlTaxaChild(iToStart, xmlTemp2, iLoop2)
            xmlTaxaNode.AppendChild(xmlTemp2)
            iToStart = iLoop2
            iStartIndexNew = iLoop2
        Next
    End Sub

    Private Sub xmlAccessEtc()
        Dim iLoop As Integer = 0
        Dim iLoop2 As Integer = 0
        Dim iLoop3 As Integer = 0
        Dim iToStart As Integer = 0
        Dim iToEnd As Integer = 0
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim sGenArray() As String
        Dim xmlTempNode As XmlNode  'main node for a sub-section
        Dim xmlTempNode2 As XmlNode '1st level subsidiary node for a sub-section
        Dim xmlTempNode3 As XmlNode '2nd level subsidiary node for a subsection
        Dim xmlTempNode4 As XmlNode '3rd level subsidiary node for a subsection
        Dim xmlPiece1 As XmlNode
        Dim xmlPiece2 As XmlNode

        'Access and Miscellaneous
        xmlTempNode = xmlHeader.CreateElement("accconst") 'set the access constraints element
        If (txtIDaccess.Text = "") Then
            xmlTempNode.InnerText = "None"
        Else
            s1 = txtIDaccess.Text
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode.InnerText = s1
        End If
        xmlIDsection.AppendChild(xmlTempNode)
        xmlTempNode = xmlHeader.CreateElement("useconst") 'set the use constraints element
        If (txtIDuse.Text = "") Then
            xmlTempNode.InnerText = "None"
        Else
            s1 = txtIDuse.Text
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode.InnerText = s1
        End If
        xmlIDsection.AppendChild(xmlTempNode)
        If (txtDataContact.Text = "") Then 'set the data point of contact information if present
        Else
            xmlTempNode = xmlHeader.CreateElement("ptcontac")
            xmlContactInfo(objDataContact, xmlTempNode2)
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlIDsection.AppendChild(xmlTempNode)
        End If
        'set the browse graphics if present
        iToEnd = sBrowseGraphics.Count
        If (iToEnd > 0) Then
            For iLoop = 0 To iToEnd - 1
                sGenArray = Split(sBrowseGraphics(iLoop), sPdelim) 'break the string into 3 parts
                xmlTempNode = xmlHeader.CreateElement("browse")    'parent element
                xmlTempNode2 = xmlHeader.CreateElement("browsen")  'browse file name child
                xmlTempNode2.InnerText = sGenArray(0)
                xmlTempNode.AppendChild(xmlTempNode2)
                xmlTempNode2 = xmlHeader.CreateElement("browsed")  'browse description child
                s1 = sGenArray(1)
                If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                xmlTempNode2.InnerText = s1
                xmlTempNode.AppendChild(xmlTempNode2)
                xmlTempNode2 = xmlHeader.CreateElement("browset")  'browse file type child
                xmlTempNode2.InnerText = sGenArray(2)
                xmlTempNode.AppendChild(xmlTempNode2)
                xmlIDsection.AppendChild(xmlTempNode)  'add graphic to ID section
            Next
        End If
        'set the data set credit if present
        If (txtDScredit.Text = "") Then
        Else
            xmlTempNode = xmlHeader.CreateElement("datacred")
            s1 = txtDScredit.Text
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode.InnerText = s1
            xmlIDsection.AppendChild(xmlTempNode)
        End If
        'set the data security information if present
        s1 = txtDataSecSys.Text & cboxDataSecClass.Text & txtDataSecDesc.Text
        If (s1 = "") Then
        Else
            xmlTempNode = xmlHeader.CreateElement("secinfo")
            xmlTempNode2 = xmlHeader.CreateElement("secsys") 'set the security classification system
            s1 = txtDataSecSys.Text
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode2.InnerText = s1
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlTempNode2 = xmlHeader.CreateElement("secclass") 'set the security classification
            xmlTempNode2.InnerText = cboxDataSecClass.Text
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlTempNode2 = xmlHeader.CreateElement("sechandl") 'set the security handling description
            s1 = txtDataSecDesc.Text
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode2.InnerText = s1
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlIDsection.AppendChild(xmlTempNode)
        End If
        'set the native data set environment if present
        If (txtDSenviron.Text = "") Then
        Else
            xmlTempNode = xmlHeader.CreateElement("native")
            s1 = txtDSenviron.Text
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode.InnerText = s1
            xmlIDsection.AppendChild(xmlTempNode)
        End If

        'process Cross References if present
        iToEnd = XRefBase.Count 'number of cross references
        If (iToEnd > 0) Then
            Dim curCite As CiteInfo  'will hold the current citation
            Dim bXref As Boolean = False
            Dim xmlXRef As XmlNode 'parent node for a cross reference

            For iLoop = 1 To iToEnd
                xmlXRef = xmlHeader.CreateElement("crossref")
                curCite = CType(XRefBase(iLoop), CiteInfo)
                xmlCiteinfo(curCite, xmlPiece1) 'generate main citation in xmlPiece1
                bXref = CType(bXRefLWC(iLoop), Boolean) 'Boolean for larger work citation
                If (bXref = True) Then  'generate larger work citation, if present, in xmlPiece2
                    xmlTempNode2 = xmlHeader.CreateElement("lworkcit")
                    curCite = CType(XRefLarge(iLoop), CiteInfo)
                    xmlCiteinfo(curCite, xmlPiece2)
                    xmlTempNode2.AppendChild(xmlPiece2) 'put LWC into lworkcit
                    xmlPiece1.AppendChild(xmlTempNode2) 'put lworkcit into primary citeinfo, i.e, xmlPiece1
                End If
                xmlXRef.AppendChild(xmlPiece1)  'add citeinfo to crossref node
                xmlIDsection.AppendChild(xmlXRef)  'add the cross reference to the ID section XML
            Next
        End If

    End Sub

    Private Sub xmlAnalyticTools()
        Dim iLoop As Integer = 0
        Dim iLoop2 As Integer = 0
        Dim iLoop3 As Integer = 0
        Dim iToStart As Integer = 0
        Dim iToEnd As Integer = 0
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim sGenArray() As String
        Dim xmlTempNode As XmlNode  'main node for a sub-section
        Dim xmlTempNode2 As XmlNode '1st level subsidiary node for a sub-section
        Dim xmlTempNode3 As XmlNode '2nd level subsidiary node for a subsection
        Dim xmlTempNode4 As XmlNode '3rd level subsidiary node for a subsection
        Dim xmlPiece1 As XmlNode
        Dim xmlPiece2 As XmlNode
        Dim curTool As New ToolClass
        Dim curContact As New ContactInfo
        Dim curCite As New CiteInfo

        iToStart = idTools.Count  'number of tools descriptions in collection
        For iLoop = 1 To iToStart
            curTool = CType(idTools(iLoop), ToolClass)
            xmlTempNode = xmlHeader.CreateElement("tool")  'create top-most tool tag

            xmlTempNode2 = xmlHeader.CreateElement("tooldesc") 'add the analytical tool description
            s1 = curTool.ToolDesc
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode2.InnerText = s1
            xmlTempNode.AppendChild(xmlTempNode2)

            xmlTempNode2 = xmlHeader.CreateElement("toolacc") 'create Tool Access Information node
            sGenArray = Split(curTool.ToolLink, sKdelim) 'break string of links into component pieces
            iToEnd = sGenArray.GetUpperBound(0) 'get upper bound of array
            For iLoop2 = 0 To iToEnd 'process the links if present
                If (sGenArray(iLoop2) = "") Then 'no link actually present
                Else
                    xmlTempNode3 = xmlHeader.CreateElement("onlink") 'put the link into the Access Information node
                    xmlTempNode3.InnerText = sGenArray(iLoop2)
                    xmlTempNode2.AppendChild(xmlTempNode3)
                End If
            Next
            xmlTempNode3 = xmlHeader.CreateElement("toolinst") 'add the Tool Access Instructions to Access Information
            s1 = curTool.ToolAccess
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode3.InnerText = s1
            xmlTempNode2.AppendChild(xmlTempNode3)
            If (curTool.ToolOS = "") Then  'add Tool Computer and Operating System if present
            Else
                xmlTempNode3 = xmlHeader.CreateElement("toolcomp")
                s1 = curTool.ToolOS
                If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                xmlTempNode3.InnerText = s1
                xmlTempNode2.AppendChild(xmlTempNode3)
            End If
            xmlTempNode.AppendChild(xmlTempNode2) 'add tool access information to the tool node

            If (curTool.boolContact = True) Then 'add tool contact if present
                curContact = curTool.ToolContact
                xmlTempNode2 = xmlHeader.CreateElement("toolcont") 'set Tool Contact node
                xmlContactInfo(curContact, xmlTempNode3) 'process the contact information
                xmlTempNode2.AppendChild(xmlTempNode3)   'add it to the Tool Contact node
                xmlTempNode.AppendChild(xmlTempNode2)    'add Tool Contact node to Tool node
            End If

            If (curTool.boolCitation = True) Then 'add tool citation if present
                curCite = curTool.ToolCite 'tool citation information
                xmlTempNode2 = xmlHeader.CreateElement("toolcite") 'set the Tool Citation node
                xmlCiteinfo(curCite, xmlPiece1) 'generate main citation in xmlPiece1
                If (curTool.boolCiteLWC = True) Then 'generate larger work citation, if present, in xmlPiece2
                    curCite = curTool.ToolCiteLWC
                    xmlTempNode3 = xmlHeader.CreateElement("lworkcit")
                    xmlCiteinfo(curCite, xmlPiece2)
                    xmlTempNode3.AppendChild(xmlPiece2) 'put LWC into lworkcit
                    xmlPiece1.AppendChild(xmlTempNode3) 'put lworkcit into primary citeinfo, i.e, xmlPiece1
                End If
                xmlTempNode2.AppendChild(xmlPiece1) 'add citeinfo to tool citation node
            End If

            xmlTempNode.AppendChild(xmlTempNode2) 'add tool citation to tool node
            xmlIDsection.AppendChild(xmlTempNode) 'add tool node to ID section node
        Next
    End Sub

#End Region


#Region " File saving procedures -- XML creation, Data Quality section "

    Private Sub updateDQsection()
        Dim iLoop As Integer = 0
        Dim iLoop2 As Integer = 0
        Dim iLoop3 As Integer = 0
        Dim iCount As Integer = 0
        Dim iCount2 As Integer = 0
        Dim iCount3 As Integer = 0
        Dim s1 As String = ""
        Dim sGenArray() As String
        Dim xmlTempNode As XmlNode 'main node for a sub-section
        Dim xmlTempNode2 As XmlNode '1st subsidiary node
        Dim xmlTempNode3 As XmlNode '2nd subsidiary node
        Dim xmlTempNode4 As XmlNode '3rd subsidiary node
        Dim xmlPiece1 As XmlNode
        Dim xmlPiece2 As XmlNode
        Dim oCite As CiteInfo 'citations used in lineage
        Dim bLWC As Boolean
        Dim oCiteLWC As CiteInfo
        Dim cGenColl As Collection 'general collection, used in time period info
        Dim oSource As SourceClass
        Dim oProcess As ProcessClass
        Dim oProcContact As ContactInfo
        Dim bContact As Boolean

        'if no mandatory elements are present, assume that there are no child nodes to process and return
        iCount = cProcess.Count 'number of Process Steps created
        If (txtLogic.Text = "" And txtComplete.Text = "" And iCount = 0) Then Return

        If (txtAttribAcc.Text = "") Then
            'no Attribute Accuracy sub-section
        Else
            xmlTempNode = xmlHeader.CreateElement("attracc") 'create Attribute Accuracy node
            xmlTempNode2 = xmlHeader.CreateElement("attraccr") 'create Attribut Accuracy Report node
            s1 = txtAttribAcc.Text
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode2.InnerText = s1 'fill the Report node
            xmlTempNode.AppendChild(xmlTempNode2) 'and add it to the Attribute Accuracy node
            iCount = sAttribAcc.Count
            If (iCount > 0) Then 'process Quantitative Attribute Accuracy Assessments
                iCount = iCount - 1
                For iLoop = 0 To iCount
                    xmlTempNode2 = xmlHeader.CreateElement("qattracc") 'create the Assessment node
                    sGenArray = Split(sAttribAcc(iLoop), sPdelim)
                    xmlTempNode3 = xmlHeader.CreateElement("attraccv") 'create Value node
                    s1 = sGenArray(0)
                    If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                    xmlTempNode3.InnerText = s1
                    xmlTempNode2.AppendChild(xmlTempNode3) 'add Value node to Assessment node
                    xmlTempNode3 = xmlHeader.CreateElement("attracce") 'create Explanation node
                    s1 = sGenArray(1)
                    If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                    xmlTempNode3.InnerText = s1
                    xmlTempNode2.AppendChild(xmlTempNode3) 'add Explanation node to Assessment node
                    xmlTempNode.AppendChild(xmlTempNode2) 'add Assessment node to Attribute Accuracy node
                Next
            End If
            xmlDQIsection.AppendChild(xmlTempNode) 'add Attribute Accuracy sub-section to DQ section
        End If

        'add Logical Consistency Report
        xmlTempNode = xmlHeader.CreateElement("logic")
        s1 = txtLogic.Text
        If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
        xmlTempNode.InnerText = s1
        xmlDQIsection.AppendChild(xmlTempNode)

        'add Completeness Report
        xmlTempNode = xmlHeader.CreateElement("complete")
        s1 = txtComplete.Text
        If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
        xmlTempNode.InnerText = s1
        xmlDQIsection.AppendChild(xmlTempNode)

        'add Positional Accuracy sub-section if needed
        If (txtHorAccRpt.Text = "" And txtVertAccRpt.Text = "") Then 'no sub-section
        Else
            xmlTempNode = xmlHeader.CreateElement("posacc") 'Positional Accuracy node
            If (txtHorAccRpt.Text <> "") Then 'process horizontal accuracy
                xmlTempNode2 = xmlHeader.CreateElement("horizpa") 'Horizontal Positional Accuracy
                xmlTempNode3 = xmlHeader.CreateElement("horizpar") 'HPA report
                s1 = txtHorAccRpt.Text
                If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                xmlTempNode3.InnerText = s1
                xmlTempNode2.AppendChild(xmlTempNode3) 'add report to sub-section
                iCount = sHPosAcc.Count
                If (iCount > 0) Then 'process quantitative assessments
                    iCount = iCount - 1 'to adjust for zero-based index
                    For iLoop = 0 To iCount
                        xmlTempNode3 = xmlHeader.CreateElement("qhorizpa") 'create quantitative assessment node
                        sGenArray = Split(sHPosAcc(iLoop), sPdelim)
                        xmlTempNode4 = xmlHeader.CreateElement("horizpav") 'create value node
                        xmlTempNode4.InnerText = sGenArray(0)
                        xmlTempNode3.AppendChild(xmlTempNode4) 'append to quantitative assessment node
                        xmlTempNode4 = xmlHeader.CreateElement("horizpae") 'create explanation node
                        s1 = sGenArray(1)
                        If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                        xmlTempNode4.InnerText = s1
                        xmlTempNode3.AppendChild(xmlTempNode4) 'append to quantitative assessment node
                        xmlTempNode2.AppendChild(xmlTempNode3) 'append quantitative assessment to horizontal accuracy node
                    Next
                End If
                xmlTempNode.AppendChild(xmlTempNode2) 'append horizontal node to positional accuracy node
            End If
            If (txtVertAccRpt.Text <> "") Then 'process vertical accuracy
                xmlTempNode2 = xmlHeader.CreateElement("vertacc") 'Vertical Positional Accuracy
                xmlTempNode3 = xmlHeader.CreateElement("vertaccr") 'VPA report
                s1 = txtVertAccRpt.Text
                If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                xmlTempNode3.InnerText = s1
                xmlTempNode2.AppendChild(xmlTempNode3) 'add report to sub-section
                iCount = sVPosAcc.Count
                If (iCount > 0) Then 'process quantitative assessments
                    iCount = iCount - 1 'to adjust for zero-based index
                    For iLoop = 0 To iCount
                        xmlTempNode3 = xmlHeader.CreateElement("qvertpa") 'create quantitative assessment node
                        sGenArray = Split(sHPosAcc(iLoop), sPdelim)
                        xmlTempNode4 = xmlHeader.CreateElement("vertaccv") 'create value node
                        xmlTempNode4.InnerText = sGenArray(0)
                        xmlTempNode3.AppendChild(xmlTempNode4) 'append to quantitative assessment node
                        xmlTempNode4 = xmlHeader.CreateElement("vertacce") 'create explanation node
                        s1 = sGenArray(1)
                        If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                        xmlTempNode4.InnerText = s1
                        xmlTempNode3.AppendChild(xmlTempNode4) 'append to quantitative assessment node
                        xmlTempNode2.AppendChild(xmlTempNode3) 'append quantitative assessment to vertical accuracy node
                    Next
                End If
                xmlTempNode.AppendChild(xmlTempNode2) 'append vertical node to positional accuracy node
            End If
            xmlDQIsection.AppendChild(xmlTempNode) 'append positional accuracy node to DQI section
        End If

        'process Lineage
        xmlTempNode = xmlHeader.CreateElement("lineage") 'main lineage node
        If (cMethods.Count > 0) Then 'process methodology sub-section
            Dim oMethod As MethodClass
            Dim cMethID As New StringCollection
            iCount = cMethods.Count 'number of methods
            For iLoop = 1 To iCount
                oMethod = CType(cMethods(iLoop), MethodClass) 'get the method to be processed
                xmlTempNode2 = xmlHeader.CreateElement("method")
                xmlTempNode3 = xmlHeader.CreateElement("methtype") 'process Methodology Type
                xmlTempNode3.InnerText = oMethod.MethodType
                xmlTempNode2.AppendChild(xmlTempNode3) 'attach Meth Type to Method
                cMethID = oMethod.MethodID 'get the collection of Meth IDs, process
                If (cMethID.Count > 0) Then
                    iCount2 = cMethID.Count - 1 'number of identifiers, 0-based index for string collection
                    For iLoop2 = 0 To iCount2
                        sGenArray = Split(cMethID(iLoop2), sPdelim)
                        xmlTempNode3 = xmlHeader.CreateElement("methodid") 'create the identifier node
                        xmlTempNode4 = xmlHeader.CreateElement("methkt")   'create the thesaurus node
                        s1 = sGenArray(0)
                        If (s1 = "") Then s1 = "None"
                        xmlTempNode4.InnerText = s1
                        xmlTempNode3.AppendChild(xmlTempNode4)
                        s1 = sGenArray(1) 'retrieve the collection of keywords
                        sGenArray = Split(s1, sKdelim) 'break the collection into pieces
                        iCount3 = sGenArray.GetLength(0) - 1
                        For iLoop3 = 0 To iCount3
                            If (sGenArray(iLoop3) <> "") Then 'do not process blanks
                                xmlTempNode4 = xmlHeader.CreateElement("methkey")
                                xmlTempNode4.InnerText = sGenArray(iLoop3)
                                xmlTempNode3.AppendChild(xmlTempNode4)
                            End If
                        Next
                        xmlTempNode2.AppendChild(xmlTempNode3) 'attach Meth ID to Method
                    Next
                End If
                xmlTempNode3 = xmlHeader.CreateElement("methdesc") 'create the Description node
                s1 = oMethod.MethodDesc
                If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                xmlTempNode3.InnerText = s1
                xmlTempNode2.AppendChild(xmlTempNode3) 'attach Description to Method
                iCount2 = oMethod.CiteCount 'number of citations
                For iLoop2 = 1 To iCount2
                    oCite = oMethod.FetchCite(iLoop2)
                    bLWC = oMethod.FetchLWC_b(iLoop2)
                    oCiteLWC = oMethod.FetchLWC(iLoop2)

                    'create Citation
                    xmlTempNode3 = xmlHeader.CreateElement("methcite")
                    xmlCiteinfo(oCite, xmlPiece1) 'generate main citation in xmlPiece1
                    If (bLWC = True) Then  'generate larger work citation, if present, in xmlPiece2
                        xmlTempNode4 = xmlHeader.CreateElement("lworkcit")
                        xmlCiteinfo(oCiteLWC, xmlPiece2)
                        xmlTempNode4.AppendChild(xmlPiece2) 'put LWC into lworkcit
                        xmlPiece1.AppendChild(xmlTempNode4) 'put lworkcit into primary citeinfo, i.e, xmlPiece1
                    End If
                    xmlTempNode3.AppendChild(xmlPiece1)  'add citeinfo to Meth Citation node
                    xmlTempNode2.AppendChild(xmlTempNode3) 'attach citation to Method
                Next
                xmlTempNode.AppendChild(xmlTempNode2) 'attach Method to Lineage
            Next
        End If

        'process Lineage: Source Information
        iCount = cSources.Count 'number of source information items
        For iLoop = 1 To iCount
            xmlTempNode2 = xmlHeader.CreateElement("srcinfo")
            oSource = CType(cSources(iLoop), SourceClass)
            oCite = oSource.SourceCite
            bLWC = oSource.boolLWC
            oCiteLWC = oSource.SourceLWC

            'create Citation
            xmlTempNode3 = xmlHeader.CreateElement("srccite")
            xmlCiteinfo(oCite, xmlPiece1) 'generate main citation in xmlPiece1
            If (bLWC = True) Then  'generate larger work citation, if present, in xmlPiece2
                xmlTempNode4 = xmlHeader.CreateElement("lworkcit")
                xmlCiteinfo(oCiteLWC, xmlPiece2)
                xmlTempNode4.AppendChild(xmlPiece2) 'put LWC into lworkcit
                xmlPiece1.AppendChild(xmlTempNode4) 'put lworkcit into primary citeinfo, i.e, xmlPiece1
            End If
            xmlTempNode3.AppendChild(xmlPiece1)  'add citeinfo to Source Citation node
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach Source Citation to Source Information

            'Source Scale Denominator
            If (oSource.ScaleDenom = "") Then
                'do nothing
            Else
                xmlTempNode3 = xmlHeader.CreateElement("srcscale")
                xmlTempNode3.InnerText = oSource.ScaleDenom
                xmlTempNode2.AppendChild(xmlTempNode3) 'attach Source Scale to Source Info
            End If

            'Type of Source Media
            xmlTempNode3 = xmlHeader.CreateElement("typesrc")
            xmlTempNode3.InnerText = oSource.Media
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach Source Media Type to Source Info

            'Time Period of Content
            xmlTempNode3 = xmlHeader.CreateElement("srctime") 'create Source Time Period of Content node
            Dim iRange As Integer = 0  '1=single, 2=range, 3=multiple
            Dim iTType As Integer = 0  '1=Gregorian, 2=Geologic
            If (oSource.Gregorian = True) Then
                iTType = 1
            Else
                iTType = 2
            End If
            If (oSource.boolSingle = True) Then
                iRange = 1
            ElseIf (oSource.boolRange = True) Then
                iRange = 2
            Else
                iRange = 3
            End If
            cGenColl = oSource.TimePeriod 'time period collection
            xmlTimePeriodInfo(cGenColl, iRange, iTType, xmlPiece1) 'generate timeinfo in xmlPiece1
            xmlTempNode3.AppendChild(xmlPiece1) 'attach timeinfo to Source Time Period of Content

            'Source Currentness Reference
            xmlTempNode4 = xmlHeader.CreateElement("srccurr") 'create currentness node
            xmlTempNode4.InnerText = oSource.Currentness
            xmlTempNode3.AppendChild(xmlTempNode4) 'attach to Source Time Period of Content
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach Time Period of Content to Source Information

            'Source Citation Abbreviation
            xmlTempNode3 = xmlHeader.CreateElement("srccitea")
            xmlTempNode3.InnerText = oSource.CiteAbbrv
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach Citation Abbreviation to Source Info

            'Source Contribution
            xmlTempNode3 = xmlHeader.CreateElement("srccontr")
            s1 = oSource.Contrib
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode3.InnerText = s1
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach Contribution to Source Info

            xmlTempNode.AppendChild(xmlTempNode2) 'attach Source Info to Lineage
        Next

        'Process Step(s)
        iCount = cProcess.Count 'number of Process Steps created
        If (iCount = 0) Then
            'no process steps in collection, but Process Step is mandatory; so create default
            xmlTempNode2 = xmlHeader.CreateElement("procstep") 'Process Step node
            xmlTempNode3 = xmlHeader.CreateElement("procdesc") 'process description node, required
            xmlTempNode3.InnerText = "No process steps have been described for this data set"
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach process description to process step
            xmlTempNode3 = xmlHeader.CreateElement("procdate") 'process date node, required
            xmlTempNode3.InnerText = "Unknown"
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach process date to process step
            xmlTempNode.AppendChild(xmlTempNode2) 'attach Process Step to Lineage
        Else
            For iLoop = 1 To iCount 'process the collection of Process Steps
                oProcess = CType(cProcess(iLoop), ProcessClass)
                xmlTempNode2 = xmlHeader.CreateElement("procstep") 'Process Step node
                xmlTempNode3 = xmlHeader.CreateElement("procdesc") 'process description node, required
                s1 = oProcess.Description
                If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                xmlTempNode3.InnerText = s1
                xmlTempNode2.AppendChild(xmlTempNode3) 'attach process description to process step
                'Source Used Citation Abbreviations
                sGenArray = Split(oProcess.UsedAbbrv, sKdelim)
                iCount2 = sGenArray.GetLength(0) - 1 'number of abbreviations, adjusted for 0-based index
                For iLoop2 = 0 To iCount2
                    If (sGenArray(iLoop2) = "") Then
                        'do nothing
                    Else
                        xmlTempNode3 = xmlHeader.CreateElement("srcused") 'source used node
                        xmlTempNode3.InnerText = sGenArray(iLoop2)
                        xmlTempNode2.AppendChild(xmlTempNode3) 'attach to Process Step
                    End If
                Next
                xmlTempNode3 = xmlHeader.CreateElement("procdate") 'Process Date node
                xmlTempNode3.InnerText = oProcess.ProcessDate
                xmlTempNode2.AppendChild(xmlTempNode3) 'attach process date to process step
                If (oProcess.ProcessTime = "") Then
                    'optional Process Time not present, do nothing
                Else
                    xmlTempNode3 = xmlHeader.CreateElement("proctime") 'Process Time node
                    xmlTempNode3.InnerText = oProcess.ProcessTime
                    xmlTempNode2.AppendChild(xmlTempNode3) 'attach process time to process step
                End If
                'Source Produced Citation Abbreviations
                sGenArray = Split(oProcess.ProducedAbbrv, sKdelim)
                iCount2 = sGenArray.GetLength(0) - 1 'number of abbreviations, adjusted for 0-based index
                For iLoop2 = 0 To iCount2
                    If (sGenArray(iLoop2) = "") Then
                        'do nothing
                    Else
                        xmlTempNode3 = xmlHeader.CreateElement("srcprod") 'source produced node
                        xmlTempNode3.InnerText = sGenArray(iLoop2)
                        xmlTempNode2.AppendChild(xmlTempNode3) 'attach to Process Step
                    End If
                Next
                'Process Contact, optional
                'detect presence of contact by presence of PrimaryContact field
                oProcContact = oProcess.ProcessContact
                bContact = False
                If (oProcContact.PrimaryPerson = True) Then
                    If (oProcContact.Person <> "") Then bContact = True
                Else
                    If (oProcContact.Organization <> "") Then bContact = True
                End If
                If (bContact = True) Then 'add process step contact
                    xmlTempNode3 = xmlHeader.CreateElement("proccont") 'set Process Contact node
                    xmlContactInfo(oProcContact, xmlPiece1) 'process the contact information
                    xmlTempNode3.AppendChild(xmlPiece1)   'add it to the Process Contact node
                    xmlTempNode2.AppendChild(xmlTempNode3)    'add Process Contact node to Process Step node
                End If
                xmlTempNode.AppendChild(xmlTempNode2) 'attach Process Step to Lineage
            Next
        End If

        'attach Lineage sub-section to Data Quality Information
        xmlDQIsection.AppendChild(xmlTempNode)

        'process Cloud Cover if present
        xmlTempNode = xmlHeader.CreateElement("cloud") 'create cloud cover node in case needed
        If (rdoNoCloud.Checked = True) Then 'no cloud cover to process
            Return
        ElseIf (rdoCloudUnk.Checked = True) Then
            xmlTempNode.InnerText = "Unknown"
        Else
            xmlTempNode.InnerText = numCloud.Value.ToString 'integer percentage
        End If
        xmlDQIsection.AppendChild(xmlTempNode) 'append cloud cover to DQ section

    End Sub

#End Region


#Region " File saving procedures -- XML creation, Spatial Data Org section "

    Private Sub updateSPDOsection()
        Dim iLoop As Integer = 0
        Dim iCount As Integer = 0
        Dim iDimenCount As Integer = 0 'intermediary for row, column, vertical counts
        Dim sGenArray() As String
        Dim s1 As String = ""
        Dim xmlTempNode As XmlNode 'main node for a sub-section
        Dim xmlTempNode2 As XmlNode '1st subsidiary node
        Dim xmlTempNode3 As XmlNode '2nd subsidiary node
        Dim xmlTempNode4 As XmlNode '3rd subsidiary node

        If (txtIndirect.Text = "" And cboxDirect.SelectedIndex < 1) Then Return 'no child nodes to process

        If (txtIndirect.Text = "") Then
        Else
            xmlTempNode = xmlHeader.CreateElement("indspref") 'create Indirect Spatial Reference
            s1 = txtIndirect.Text
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode.InnerText = s1
            xmlSDOsection.AppendChild(xmlTempNode)
        End If

        If (cboxDirect.SelectedIndex < 1) Then 'no direct spatial reference used
            Return
        End If

        'process Direct Spatial Reference Method
        xmlTempNode = xmlHeader.CreateElement("direct")
        xmlTempNode.InnerText = cboxDirect.Text
        xmlSDOsection.AppendChild(xmlTempNode)

        If (cboxDirect.SelectedIndex < 3 And sSDTS.Count = 0) Then Return 'no point & vector object information

        If (cboxDirect.SelectedIndex < 3) Then 'process point & vector object information
            xmlTempNode = xmlHeader.CreateElement("ptvctinf") 'create point & vector obj info main node
            If (rdoSDTS.Checked = True) Then 'process SDTS terms description
                iCount = sSDTS.Count - 1
                For iLoop = 0 To iCount
                    sGenArray = Split(sSDTS(iLoop), sPdelim)
                    xmlTempNode2 = xmlHeader.CreateElement("sdtsterm")
                    xmlTempNode3 = xmlHeader.CreateElement("sdtstype")
                    xmlTempNode3.InnerText = sGenArray(0) 'set the SDTS object type
                    xmlTempNode2.AppendChild(xmlTempNode3) 'add object type child

                    If (sGenArray(1) = "0") Then
                    Else
                        xmlTempNode3 = xmlHeader.CreateElement("ptvctcnt") 'process object count if present
                        xmlTempNode3.InnerText = sGenArray(1)
                        xmlTempNode2.AppendChild(xmlTempNode3)
                    End If
                    xmlTempNode.AppendChild(xmlTempNode2) 'append SDTS point & object information child
                Next
                xmlSDOsection.AppendChild(xmlTempNode) 'append point & vector info to main node
            Else 'process VPF terms description
                xmlTempNode2 = xmlHeader.CreateElement("vpfterm")
                xmlTempNode3 = xmlHeader.CreateElement("vpflevel") 'set the VPF topology level
                xmlTempNode3.InnerText = cboxVPF.Text
                xmlTempNode2.AppendChild(xmlTempNode3)
                iCount = sSDTS.Count - 1 'recall that sSDTS contains the strings for both descriptor styles
                For iLoop = 0 To iCount
                    sGenArray = Split(sSDTS(iLoop), sPdelim)
                    xmlTempNode3 = xmlHeader.CreateElement("vpfinfo")
                    xmlTempNode4 = xmlHeader.CreateElement("vpftype")
                    xmlTempNode4.InnerText = sGenArray(0) 'set the VPF object type
                    xmlTempNode3.AppendChild(xmlTempNode4) 'add object type child

                    If (sGenArray(1) = "0") Then
                    Else
                        xmlTempNode4 = xmlHeader.CreateElement("ptvctcnt") 'process object count if present
                        xmlTempNode4.InnerText = sGenArray(1)
                        xmlTempNode3.AppendChild(xmlTempNode4)
                    End If
                    xmlTempNode2.AppendChild(xmlTempNode3) 'add object description to vpfterm node
                Next
                xmlTempNode.AppendChild(xmlTempNode2) 'add vpfterm node to object information node
                xmlSDOsection.AppendChild(xmlTempNode) 'append point & vector info to main node
            End If
            Return
        End If

        If (cboxDirect.SelectedIndex = 3 And cboxRasType.SelectedIndex = -1) Then Return 'no raster information to process

        'process raster object information
        xmlTempNode = xmlHeader.CreateElement("rastinfo") 'main raster info node
        xmlTempNode2 = xmlHeader.CreateElement("rasttype") 'raster object type node
        xmlTempNode2.InnerText = cboxRasType.Text
        xmlTempNode.AppendChild(xmlTempNode2)

        If (numRasRow.Value = 0 Or numRasCol.Value = 0) Then 'no count info to process
            xmlSDOsection.AppendChild(xmlTempNode) 'append raster info to spatial data org section
            Return
        End If

        'process count info
        xmlTempNode2 = xmlHeader.CreateElement("rowcount") 'process row count
        iDimenCount = Convert.ToInt32(numRasRow.Value)
        xmlTempNode2.InnerText = iDimenCount.ToString
        xmlTempNode.AppendChild(xmlTempNode2)
        xmlTempNode2 = xmlHeader.CreateElement("colcount") 'process column count
        iDimenCount = Convert.ToInt32(numRasCol.Value)
        xmlTempNode2.InnerText = iDimenCount.ToString
        xmlTempNode.AppendChild(xmlTempNode2)
        If (numRasVert.Value > 0) Then
            xmlTempNode2 = xmlHeader.CreateElement("vrtcount") 'process vertical count if present
            iDimenCount = Convert.ToInt32(numRasVert.Value)
            xmlTempNode2.InnerText = iDimenCount.ToString
            xmlTempNode.AppendChild(xmlTempNode2)
        End If
        xmlSDOsection.AppendChild(xmlTempNode) 'append raster info with counts to spatial data org section
        Return
    End Sub

#End Region


#Region " File saving procedures -- XML creation, Spatial Reference section "

    Private Sub updateSpRef()
        Dim iLoop As Integer = 0
        Dim iLoop2 As Integer = 0
        Dim iCount As Integer = 0
        Dim iCount2 As Integer = 0
        Dim bGeog As Boolean = False 'tells whether a projection system used
        Dim s1 As String = ""
        Dim s2 As String = ""
        Dim sGenArray() As String
        Dim xmlTempNode As XmlNode 'main node for a sub-section
        Dim xmlTempNode2 As XmlNode '1st subsidiary node
        Dim xmlTempNode3 As XmlNode '2nd subsidiary node
        Dim xmlTempNode4 As XmlNode '3rd subsidiary node
        Dim xmlNode5 As XmlNode '4th subsidiary node
        Dim xmlNode6 As XmlNode '5th subsidiary node
        Dim xmlFrag1 As XmlDocumentFragment 'an XML fragment

        'Horizontal Coordinate System Definition
        xmlTempNode = xmlHeader.CreateElement("horizsys") 'create Horizontal Definition node

        '1. process the projection system if present
        If (rdoGeographic.Checked = True) Then
            'Geographic model
            xmlTempNode2 = xmlHeader.CreateElement("geograph") 'main Geographic node
            xmlTempNode3 = xmlHeader.CreateElement("latres") 'latitude resolution
            xmlTempNode3.InnerText = numLatRes.Value.ToString
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach latitude res to Geographic
            xmlTempNode3 = xmlHeader.CreateElement("longres") 'longitude resolution
            xmlTempNode3.InnerText = numLongRes.Value.ToString
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach longitude res to Geographic
            xmlTempNode3 = xmlHeader.CreateElement("geogunit") 'geographic coordinate units
            xmlTempNode3.InnerText = cboxGeoCoorUnits.Text
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach units to geographic
            xmlTempNode.AppendChild(xmlTempNode2) 'attach geographic to horizontal def
        End If

        If (rdoPlanar.Checked = True) Then
            Dim oPlanar As New PlanarClass
            iCount = cPlanar.Count
            For iLoop = 1 To iCount
                oPlanar = CType(cPlanar(iLoop), PlanarClass) 'get the Planar description
                iCount2 = oPlanar.nParams - 1
                For iLoop2 = 0 To iCount2
                    sPlanProjParams(iLoop2) = oPlanar.getParam(iLoop2)
                Next
                xmlTempNode2 = xmlHeader.CreateElement("planar") 'main Planar node
                If (oPlanar.MapProj = True) Then
                    xmlTempNode3 = xmlHeader.CreateElement("mapproj") 'Map Projection node
                    xmlTempNode4 = xmlHeader.CreateElement("mapprojn") 'Map Projection name
                    s1 = oPlanar.MapProjName
                    xmlTempNode4.InnerText = s1
                    xmlTempNode3.AppendChild(xmlTempNode4) 'add projection name to projection info
                    Select Case s1
                        Case "Albers Conical Equal Area"
                            xmlTempNode4 = xmlHeader.CreateElement("albers") 'Albers Conical Equal Area node
                            '2 standard parallels
                            xmlStdParallel(2, xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            'Longitude of Central Meridian
                            xmlLongCentMerid(xmlNode5)
                            xmlTempNode4.AppendChild(xmlNode5)
                            'Latitude of Projection Origin
                            xmlLatProjOrig(xmlNode5)
                            xmlTempNode4.AppendChild(xmlNode5)
                            'False Easting and False Northing
                            xmlEastNorth(xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "Azimuthal Equidistant"
                            xmlAzimuthal(xmlTempNode4)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "Equidistant Conic"
                            xmlTempNode4 = xmlHeader.CreateElement("equicon")
                            '2 standard parallels
                            xmlStdParallel(2, xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            'Longitude of Central Meridian
                            xmlLongCentMerid(xmlNode5)
                            xmlTempNode4.AppendChild(xmlNode5)
                            'Latitude of Projection Origin
                            xmlLatProjOrig(xmlNode5)
                            xmlTempNode4.AppendChild(xmlNode5)
                            'False Easting and False Northing
                            xmlEastNorth(xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "Equirectangular"
                            xmlEquirectangular(xmlTempNode4)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "General Vertical Near-sided Projection"
                            xmlTempNode4 = xmlHeader.CreateElement("gvnsp")
                            'Height of Perspective Point Above Surface
                            xmlPersPoint(xmlNode5)
                            xmlTempNode4.AppendChild(xmlNode5)
                            'Longitude and Latitude of Projection Center
                            xmlProjCenter(2, xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            'False Easting and False Northing
                            xmlEastNorth(xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "Gnomonic"
                            xmlTempNode4 = xmlHeader.CreateElement("gnomonic")
                            'Longitude and Latitude of Projection Center
                            xmlProjCenter(2, xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            'False Easting and False Northing
                            xmlEastNorth(xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "Lambert Azimuthal Equal Area"
                            xmlTempNode4 = xmlHeader.CreateElement("lamberta")
                            'Longitude and Latitude of Projection Center
                            xmlProjCenter(2, xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            'False Easting and False Northing
                            xmlEastNorth(xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "Lambert Conformal Conic"
                            xmlLambert(xmlTempNode4)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "Mercator"
                            xmlTempNode4 = xmlHeader.CreateElement("mercator")
                            'Standard Parallel or Scale Factor at Equator
                            If (sPlanProjParams(2) = "" And sPlanProjParams(8) = "") Then
                                'choice not made, permit error in XML structure
                            ElseIf (sPlanProjParams(2) <> "") Then 'std parallel
                                '1 standard parallel
                                xmlStdParallel(1, xmlFrag1)
                                xmlTempNode4.AppendChild(xmlFrag1)
                            Else
                                'scale factor at equator
                                xmlNode5 = xmlHeader.CreateElement("sfequat")
                                xmlNode5.InnerText = sPlanProjParams(8)
                                xmlTempNode4.AppendChild(xmlNode5)
                            End If
                            'Longitude of Central Meridian
                            xmlLongCentMerid(xmlNode5)
                            xmlTempNode4.AppendChild(xmlNode5)
                            'False Easting and False Northing
                            xmlEastNorth(xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "Modified Stereographic for Alaska"
                            xmlTempNode4 = xmlHeader.CreateElement("modsak")
                            'False Easting and False Northing
                            xmlEastNorth(xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "Miller Cylindrical"
                            xmlTempNode4 = xmlHeader.CreateElement("miller")
                            'Longitude of Central Meridian
                            xmlLongCentMerid(xmlNode5)
                            xmlTempNode4.AppendChild(xmlNode5)
                            'False Easting and False Northing
                            xmlEastNorth(xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "Oblique Mercator"
                            xmlObliqMercator(xmlTempNode4)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "Orthographic"
                            xmlTempNode4 = xmlHeader.CreateElement("orthogr")
                            'Longitude and Latitude of Projection Center
                            xmlProjCenter(2, xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            'False Easting and False Northing
                            xmlEastNorth(xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "Polar Stereographic"
                            xmlPolarStereo(xmlTempNode4)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "Polyconic"
                            xmlPolyconic(xmlTempNode4)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "Robinson"
                            xmlTempNode4 = xmlHeader.CreateElement("robinson")
                            'Longitude, but no Latitude, of Projection Center
                            xmlProjCenter(1, xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            'False Easting and False Northing
                            xmlEastNorth(xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "Sinusoidal"
                            xmlTempNode4 = xmlHeader.CreateElement("sinusoid")
                            'Longitude of Central Meridian
                            xmlLongCentMerid(xmlNode5)
                            xmlTempNode4.AppendChild(xmlNode5)
                            'False Easting and False Northing
                            xmlEastNorth(xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "Space Oblique Mercator"
                            xmlTempNode4 = xmlHeader.CreateElement("spaceobq")
                            'Landsat Number
                            xmlNode5 = xmlHeader.CreateElement("landsat")
                            xmlNode5.InnerText = sPlanProjParams(21)
                            xmlTempNode4.AppendChild(xmlNode5)
                            'Path Number
                            xmlNode5 = xmlHeader.CreateElement("pathnum")
                            xmlNode5.InnerText = sPlanProjParams(22)
                            xmlTempNode4.AppendChild(xmlNode5)
                            'False Easting and False Northing
                            xmlEastNorth(xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "Stereographic"
                            xmlTempNode4 = xmlHeader.CreateElement("stereo")
                            'Longitude and Latitude of Projection Center
                            xmlProjCenter(2, xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            'False Easting and False Northing
                            xmlEastNorth(xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "Transverse Mercator"
                            xmlTransMercator(xmlTempNode4)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case "van der Grinten"
                            xmlTempNode4 = xmlHeader.CreateElement("vdgrin")
                            'Longitude of Central Meridian
                            xmlLongCentMerid(xmlNode5)
                            xmlTempNode4.AppendChild(xmlNode5)
                            'False Easting and False Northing
                            xmlEastNorth(xmlFrag1)
                            xmlTempNode4.AppendChild(xmlFrag1)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                        Case Else
                            'other map projection system
                            xmlTempNode4 = xmlHeader.CreateElement("otherprj")
                            xmlTempNode4.InnerText = sPlanProjParams(28)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'add projection parameters to projection info
                    End Select
                    xmlTempNode2.AppendChild(xmlTempNode3) 'add Map Projection to Planar
                ElseIf (oPlanar.GridSys = True) Then
                    xmlTempNode3 = xmlHeader.CreateElement("gridsys") 'Grid Coordinate System node
                    xmlTempNode4 = xmlHeader.CreateElement("gridsysn") 'Grid Coordinate System name
                    s1 = oPlanar.GridName
                    s2 = oPlanar.GridProjName
                    xmlTempNode4.InnerText = s1
                    xmlTempNode3.AppendChild(xmlTempNode4) 'add grid name to grid system info
                    'begin grid systems 
                    Select Case s1
                        Case "Universal Transverse Mercator"
                            xmlTempNode4 = xmlHeader.CreateElement("utm") 'UTM node
                            'UTM Zone Number
                            xmlNode5 = xmlHeader.CreateElement("utmzone") 'UTM Zone node
                            xmlNode5.InnerText = sPlanProjParams(24)
                            xmlTempNode4.AppendChild(xmlNode5) 'attach UTM Zone to UTM
                            'Transverse Mercator
                            xmlTransMercator(xmlNode5)
                            xmlTempNode4.AppendChild(xmlNode5) 'attach Trans Merc to UTM
                            xmlTempNode3.AppendChild(xmlTempNode4) 'attach UTM to Grid info
                        Case "Universal Polar Stereographic"
                            xmlTempNode4 = xmlHeader.CreateElement("ups") 'UPS node
                            'UPS Zone Identifier
                            xmlNode5 = xmlHeader.CreateElement("upszone")
                            xmlNode5.InnerText = sPlanProjParams(25)
                            xmlTempNode4.AppendChild(xmlNode5) 'attach UPS Zone to UPS
                            'Polar Stereographic
                            xmlPolarStereo(xmlNode5)
                            xmlTempNode4.AppendChild(xmlNode5) 'attach Polar Stereo to UPS
                            xmlTempNode3.AppendChild(xmlTempNode4) 'attach UPS to Grid info
                        Case "State Plane Coordinate System 1927", "State Plane Coordinate System 1983"
                            xmlTempNode4 = xmlHeader.CreateElement("spcs") 'SPCS node
                            'SPCS Zone Identifier
                            xmlNode5 = xmlHeader.CreateElement("spcszone") 'SPCS Zone node
                            xmlNode5.InnerText = sPlanProjParams(26)
                            xmlTempNode4.AppendChild(xmlNode5) 'attach SPCS Zone to SPCS
                            Select Case s2
                                Case "Lambert Conformal Conic"
                                    xmlLambert(xmlNode5)
                                    xmlTempNode4.AppendChild(xmlNode5)
                                Case "Transverse Mercator"
                                    xmlTransMercator(xmlNode5)
                                    xmlTempNode4.AppendChild(xmlNode5)
                                Case "Oblique Mercator"
                                    xmlObliqMercator(xmlNode5)
                                    xmlTempNode4.AppendChild(xmlNode5)
                                Case "Polyconic"
                                    xmlPolyconic(xmlNode5)
                                    xmlTempNode4.AppendChild(xmlNode5)
                                Case Else
                                    'illegal structure; disregard
                            End Select
                            xmlTempNode3.AppendChild(xmlTempNode4) 'attach SPCS to Grid info
                        Case "ARC Coordinate System"
                            xmlTempNode4 = xmlHeader.CreateElement("arcsys") 'ARC node
                            'ARC System Zone Identifier
                            xmlNode5 = xmlHeader.CreateElement("arczone")
                            xmlNode5.InnerText = sPlanProjParams(27)
                            xmlTempNode4.AppendChild(xmlNode5) 'attach ARC Zone to ARC
                            Select Case s2
                                Case "Equirectangular"
                                    xmlEquirectangular(xmlNode5)
                                    xmlTempNode4.AppendChild(xmlNode5)
                                Case "Azimuthal Equidistant"
                                    xmlAzimuthal(xmlNode5)
                                    xmlTempNode4.AppendChild(xmlNode5)
                            End Select
                            xmlTempNode3.AppendChild(xmlTempNode4) 'attach ARC to Grid info
                        Case "other grid system"
                            xmlTempNode4 = xmlHeader.CreateElement("othergrd")
                            xmlTempNode4.InnerText = sPlanProjParams(28)
                            xmlTempNode3.AppendChild(xmlTempNode4) 'attach Other Grid to Grid info
                        Case Else
                            'error in grid system entry; do nothing
                    End Select
                    xmlTempNode2.AppendChild(xmlTempNode3) 'add Grid System to Planar
                ElseIf (oPlanar.LocalPlanar = True) Then
                    xmlTempNode3 = xmlHeader.CreateElement("localp") 'Local Planar node
                    xmlTempNode4 = xmlHeader.CreateElement("localpd") 'Local Planar description
                    s1 = oPlanar.LocalDesc
                    If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                    xmlTempNode4.InnerText = s1
                    xmlTempNode3.AppendChild(xmlTempNode4) 'attach description to Local Planar
                    xmlTempNode4 = xmlHeader.CreateElement("localpgi") 'georeference info
                    s1 = oPlanar.LocalGeoRef
                    If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                    xmlTempNode4.InnerText = s1
                    xmlTempNode3.AppendChild(xmlTempNode4) 'attach georeference to Local Planar
                    xmlTempNode2.AppendChild(xmlTempNode3) 'attach Local Planar to Planar
                Else
                    'no planar system specified; do nothing -- illegal structure allowed
                End If

                'Planar Coordinate Information
                xmlTempNode3 = xmlHeader.CreateElement("planci") 'Planar Coordinate Info node
                xmlTempNode4 = xmlHeader.CreateElement("plance") 'Encoding Method
                xmlTempNode4.InnerText = oPlanar.Encoding
                xmlTempNode3.AppendChild(xmlTempNode4) 'attach Encoding to PCI node
                If (oPlanar.CoorRep = True) Then
                    xmlTempNode4 = xmlHeader.CreateElement("coordrep") 'Coordinate Representation
                    xmlNode5 = xmlHeader.CreateElement("absres") 'Abscissa Resolution
                    xmlNode5.InnerText = oPlanar.Abscissa.ToString
                    xmlTempNode4.AppendChild(xmlNode5) 'attach Abscissa to CR
                    xmlNode5 = xmlHeader.CreateElement("ordres") 'Ordinate Resolution
                    xmlNode5.InnerText = oPlanar.Ordinate.ToString
                    xmlTempNode4.AppendChild(xmlNode5) 'attach Ordinate to CR
                    xmlTempNode3.AppendChild(xmlTempNode4) 'attach CR to PCI
                ElseIf (oPlanar.BearingRep = True) Then
                    xmlTempNode4 = xmlHeader.CreateElement("distbrep") 'Distance and Bearing Representation
                    xmlNode5 = xmlHeader.CreateElement("distres") 'Distance Resolution
                    xmlNode5.InnerText = oPlanar.DistanceRes.ToString
                    xmlTempNode4.AppendChild(xmlNode5) 'attach Distance Resolution to DBR
                    xmlNode5 = xmlHeader.CreateElement("bearres") 'Bearing Resolution
                    xmlNode5.InnerText = oPlanar.BearingRes.ToString
                    xmlTempNode4.AppendChild(xmlNode5) 'attach Bearing Resolution to DBR
                    xmlNode5 = xmlHeader.CreateElement("bearunit") 'Bearing Units
                    xmlNode5.InnerText = oPlanar.BearingUnits
                    xmlTempNode4.AppendChild(xmlNode5) 'attach Bearing Units to DBR
                    xmlNode5 = xmlHeader.CreateElement("bearrefd") 'Bearing Reference Direction
                    xmlNode5.InnerText = oPlanar.BearingDir
                    xmlTempNode4.AppendChild(xmlNode5) 'attach Bearing Reference Direction to DBR
                    xmlNode5 = xmlHeader.CreateElement("bearrefm") 'Bearing Reference Meridian
                    xmlNode5.InnerText = oPlanar.BearingMerid
                    xmlTempNode4.AppendChild(xmlNode5) 'attach Bearing Reference Meridian to DBR
                    xmlTempNode3.AppendChild(xmlTempNode4) 'attach DBR to PCI
                Else
                    'do nothing; permit structure error
                End If

                xmlTempNode4 = xmlHeader.CreateElement("plandu") 'Planar Distance Units
                xmlTempNode4.InnerText = oPlanar.PlanarUnits
                xmlTempNode3.AppendChild(xmlTempNode4) 'attach Planar Distance Units to PCI
                xmlTempNode2.AppendChild(xmlTempNode3) 'attach PCI to Planar
                xmlTempNode.AppendChild(xmlTempNode2) 'attach Planar to Horizontal Coordinate System Def
            Next
        End If

        If (rdoLocal.Checked = True) Then
            'Local model
            xmlTempNode2 = xmlHeader.CreateElement("local") 'main Local node
            xmlTempNode3 = xmlHeader.CreateElement("localdes") 'local description
            s1 = txtLocalDesc.Text
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode3.InnerText = s1
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach local desc to Local
            xmlTempNode3 = xmlHeader.CreateElement("localgeo") 'local georeference information
            s1 = txtLocalGeoInfo.Text
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode3.InnerText = s1
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach georef info to Local
            xmlTempNode.AppendChild(xmlTempNode2) 'attach local to horizontal def
        End If

        '2. process geodetic model
        If (cboxEllipsoid.Text = "") Then
            'do nothing
        Else
            xmlTempNode2 = xmlHeader.CreateElement("geodetic") 'main Geodetic node
            If (cboxHorizName.Text = "") Then
                'do nothing
            Else
                xmlTempNode3 = xmlHeader.CreateElement("horizdn") 'horizontal datum name
                xmlTempNode3.InnerText = cboxHorizName.Text
                xmlTempNode2.AppendChild(xmlTempNode3) 'attach datum name to geodetic
            End If
            xmlTempNode3 = xmlHeader.CreateElement("ellips") 'ellipsoid name
            xmlTempNode3.InnerText = cboxEllipsoid.Text
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach ellipsoid to geodetic
            xmlTempNode3 = xmlHeader.CreateElement("semiaxis") 'semi-major axis
            xmlTempNode3.InnerText = numSemiMajor.Value.ToString
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach semi-major axis to geodetic
            xmlTempNode3 = xmlHeader.CreateElement("denflat") 'denominator of flattening
            xmlTempNode3.InnerText = numFlatten.Value.ToString
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach denominator to geodetic
            xmlTempNode.AppendChild(xmlTempNode2) 'attach geodetic to horizontal
        End If

        '3. attach Horizontal Def to Spatial Ref section, if present
        If (xmlTempNode.HasChildNodes = True) Then xmlSpaRefSection.AppendChild(xmlTempNode)


        'Vertical Coordinate System Definition
        xmlTempNode = xmlHeader.CreateElement("vertdef") 'create Vertical Definition node

        '1. process the Altitude System Definition
        If (cboxAltDatum.Text = "" And txtAltRes.Text = "" And cboxAltUnits.Text = "" And cboxAltEncode.Text = "") Then
            'do nothing
        Else
            xmlVertAlt(xmlTempNode2)
            xmlTempNode.AppendChild(xmlTempNode2) 'attach altitude definition to vertical definition
        End If

        '2. process the Depth System Definition
        If (cboxDepthDatum.Text = "" And txtDepthRes.Text = "" And cboxDepthUnits.Text = "" And cboxDepthEncode.Text = "") Then
            'do nothing
        Else
            xmlVertDepth(xmlTempNode2)
            xmlTempNode.AppendChild(xmlTempNode2) 'attach depth definition to vertical definition
        End If

        '3. attach Vertical Def to Spatial Ref section, if present
        If (xmlTempNode.HasChildNodes = True) Then xmlSpaRefSection.AppendChild(xmlTempNode)
        Return
    End Sub


    Private Sub xmlStdParallel(ByVal iNum As Integer, ByRef xmlFrag As XmlDocumentFragment)
        Dim xmlNode1 As XmlNode
        xmlFrag = xmlHeader.CreateDocumentFragment
        'set Standard Parallel 1
        xmlNode1 = xmlHeader.CreateElement("stdparll")
        xmlNode1.InnerText = sPlanProjParams(2)
        xmlFrag.AppendChild(xmlNode1)
        'set Standard Parallel 2 if needed
        If (iNum = 2) Then
            xmlNode1 = xmlHeader.CreateElement("stdparll")
            xmlNode1.InnerText = sPlanProjParams(3)
            If (sPlanProjParams(3) = "") Then
                'do nothing
            Else
                xmlFrag.AppendChild(xmlNode1)
            End If
        End If
    End Sub

    Private Sub xmlLongCentMerid(ByRef xmlNode1 As XmlNode)
        'set Longitude of Central Meridian
        xmlNode1 = xmlHeader.CreateElement("longcm")
        xmlNode1.InnerText = sPlanProjParams(4)
    End Sub

    Private Sub xmlLatProjOrig(ByRef xmlNode1 As XmlNode)
        'set Latitude of Projection Origin
        xmlNode1 = xmlHeader.CreateElement("latprjo")
        xmlNode1.InnerText = sPlanProjParams(5)
    End Sub

    Private Sub xmlEastNorth(ByRef xmlFrag As XmlDocumentFragment)
        Dim xmlNode1 As XmlNode
        xmlFrag = xmlHeader.CreateDocumentFragment
        'set False Easting
        xmlNode1 = xmlHeader.CreateElement("feast")
        xmlNode1.InnerText = sPlanProjParams(6)
        xmlFrag.AppendChild(xmlNode1)
        'set False Northing
        xmlNode1 = xmlHeader.CreateElement("fnorth")
        xmlNode1.InnerText = sPlanProjParams(7)
        xmlFrag.AppendChild(xmlNode1)
    End Sub

    Private Sub xmlPersPoint(ByRef xmlNode1 As XmlNode)
        'set Height of Perspective Point Above Surface
        xmlNode1 = xmlHeader.CreateElement("heightpt")
        xmlNode1.InnerText = sPlanProjParams(9)
    End Sub

    Private Sub xmlProjCenter(ByVal iNum As Integer, ByRef xmlFrag As XmlDocumentFragment)
        Dim xmlNode1 As XmlNode
        xmlFrag = xmlHeader.CreateDocumentFragment
        'set Longitude of Projection Center
        xmlNode1 = xmlHeader.CreateElement("longpc")
        xmlNode1.InnerText = sPlanProjParams(10)
        xmlFrag.AppendChild(xmlNode1)
        'set Latitude of Projection Center, if needed
        If (iNum = 2) Then
            xmlNode1 = xmlHeader.CreateElement("latprjc")
            xmlNode1.InnerText = sPlanProjParams(11)
            xmlFrag.AppendChild(xmlNode1)
        End If
    End Sub

    Private Sub xmlTransMercator(ByRef xmlMainNode As XmlNode)
        Dim xmlSubNode As XmlNode
        Dim xmlFrag As XmlDocumentFragment
        xmlMainNode = xmlHeader.CreateElement("transmer")
        'Scale Factor at Central Meridian
        xmlSubNode = xmlHeader.CreateElement("sfctrmer")
        xmlSubNode.InnerText = sPlanProjParams(23)
        xmlMainNode.AppendChild(xmlSubNode)
        'Longitude of Central Meridian
        xmlLongCentMerid(xmlSubNode)
        xmlMainNode.AppendChild(xmlSubNode)
        'Latitude of Projection Origin
        xmlLatProjOrig(xmlSubNode)
        xmlMainNode.AppendChild(xmlSubNode)
        'False Easting and False Northing
        xmlEastNorth(xmlFrag)
        xmlMainNode.AppendChild(xmlFrag)
    End Sub

    Private Sub xmlPolarStereo(ByRef xmlMainNode As XmlNode)
        Dim xmlSubNode As XmlNode
        Dim xmlFrag As XmlDocumentFragment
        xmlMainNode = xmlHeader.CreateElement("polarst")
        'straight vertical longitude from pole
        xmlSubNode = xmlHeader.CreateElement("svlong")
        xmlSubNode.InnerText = sPlanProjParams(19)
        xmlMainNode.AppendChild(xmlSubNode)
        'Standard Parallel or Scale Factor at Projection Origin
        If (sPlanProjParams(2) = "" And sPlanProjParams(20) = "") Then
            'choice not made, allow illegal XML structure
        ElseIf (sPlanProjParams(2) <> "") Then 'std parallel
            '1 standard parallel
            xmlStdParallel(1, xmlFrag)
            xmlMainNode.AppendChild(xmlFrag)
        Else
            'scale factor at projection origin
            xmlSubNode = xmlHeader.CreateElement("sfprjorg")
            xmlSubNode.InnerText = sPlanProjParams(20)
            xmlMainNode.AppendChild(xmlSubNode)
        End If
        'False Easting and False Northing
        xmlEastNorth(xmlFrag)
        xmlMainNode.AppendChild(xmlFrag)
    End Sub

    Private Sub xmlLambert(ByRef xmlMainNode As XmlNode)
        Dim xmlSubNode As XmlNode
        Dim xmlSubFrag As XmlDocumentFragment
        xmlMainNode = xmlHeader.CreateElement("lambertc")
        xmlSubFrag = xmlHeader.CreateDocumentFragment
        '2 standard parallels
        xmlStdParallel(2, xmlSubFrag)
        xmlMainNode.AppendChild(xmlSubFrag)
        'Longitude of Central Meridian
        xmlLongCentMerid(xmlSubNode)
        xmlMainNode.AppendChild(xmlSubNode)
        'Latitude of Projection Origin
        xmlLatProjOrig(xmlSubNode)
        xmlMainNode.AppendChild(xmlSubNode)
        'False Easting and False Northing
        xmlEastNorth(xmlSubFrag)
        xmlMainNode.AppendChild(xmlSubFrag)
    End Sub

    Private Sub xmlObliqMercator(ByRef xmlMainNode As XmlNode)
        Dim xmlSubNode1 As XmlNode
        Dim xmlSubNode2 As XmlNode
        Dim xmlFrag As XmlDocumentFragment
        xmlMainNode = xmlHeader.CreateElement("obqmerc")
        'Scale Factor at Center Line
        xmlSubNode1 = xmlHeader.CreateElement("sfctrlin")
        xmlSubNode1.InnerText = sPlanProjParams(12)
        xmlMainNode.AppendChild(xmlSubNode1) 'attach scale factor to Oblique Mercator
        'Oblique Line Azimuth or Oblique Line Point
        If (sPlanProjParams(13) = "" And sPlanProjParams(15) = "") Then
            'choice not made, allow illegal XML structure
        ElseIf (sPlanProjParams(13) <> "") Then 'oblique line azimuth
            xmlSubNode1 = xmlHeader.CreateElement("obqlazim")
            xmlSubNode2 = xmlHeader.CreateElement("azimangl") 'Azimuthal Angle
            xmlSubNode2.InnerText = sPlanProjParams(13)
            xmlSubNode1.AppendChild(xmlSubNode2)
            xmlSubNode2 = xmlHeader.CreateElement("azimptl") 'Azimuth Measure Point Longitude
            xmlSubNode2.InnerText = sPlanProjParams(14)
            xmlSubNode1.AppendChild(xmlSubNode2)
            xmlMainNode.AppendChild(xmlSubNode1) 'attach oblique line azimuth to Oblique Mercator
        Else
            'oblique line point == 2 [Oblique Line Latitude + Oblique Line Longitude]
            xmlSubNode1 = xmlHeader.CreateElement("obqlpt")
            xmlSubNode2 = xmlHeader.CreateElement("obqllat")
            xmlSubNode2.InnerText = sPlanProjParams(15)
            xmlSubNode1.AppendChild(xmlSubNode2) 'attach 1st latitude to Oblique Line Point
            xmlSubNode2 = xmlHeader.CreateElement("obqllong")
            xmlSubNode2.InnerText = sPlanProjParams(16)
            xmlSubNode1.AppendChild(xmlSubNode2) 'attach 1st longitude to Oblique Line Point
            xmlSubNode2 = xmlHeader.CreateElement("obqllat")
            xmlSubNode2.InnerText = sPlanProjParams(17)
            xmlSubNode1.AppendChild(xmlSubNode2) 'attach 2nd latitude to Oblique Line Point
            xmlSubNode2 = xmlHeader.CreateElement("obqllong")
            xmlSubNode2.InnerText = sPlanProjParams(18)
            xmlSubNode1.AppendChild(xmlSubNode2) 'attach 2nd longitude to Oblique Line Point
            xmlMainNode.AppendChild(xmlSubNode1) 'attach oblique line point to Oblique Mercator
        End If
        'Latitude of Projection Origin
        xmlLatProjOrig(xmlSubNode1)
        xmlMainNode.AppendChild(xmlSubNode1)
        'False Easting and False Northing
        xmlEastNorth(xmlFrag)
        xmlMainNode.AppendChild(xmlFrag)
    End Sub

    Private Sub xmlPolyconic(ByRef xmlMainNode As XmlNode)
        Dim xmlSubNode As XmlNode
        Dim xmlFrag As XmlDocumentFragment
        xmlMainNode = xmlHeader.CreateElement("polycon")
        'Longitude of Central Meridian
        xmlLongCentMerid(xmlSubNode)
        xmlMainNode.AppendChild(xmlSubNode)
        'Latitude of Projection Origin
        xmlLatProjOrig(xmlSubNode)
        xmlMainNode.AppendChild(xmlSubNode)
        'False Easting and False Northing
        xmlEastNorth(xmlFrag)
        xmlMainNode.AppendChild(xmlFrag)
    End Sub

    Private Sub xmlEquirectangular(ByRef xmlNode1 As XmlNode)
        Dim xmlSubNode As XmlNode
        Dim xmlSubFrag As XmlDocumentFragment
        xmlNode1 = xmlHeader.CreateElement("equirect")
        '1 standard parallel
        xmlStdParallel(1, xmlSubFrag)
        xmlNode1.AppendChild(xmlSubFrag)
        'Longitude of Central Meridian
        xmlLongCentMerid(xmlSubNode)
        xmlNode1.AppendChild(xmlSubNode)
        'False Easting and False Northing
        xmlEastNorth(xmlSubFrag)
        xmlNode1.AppendChild(xmlSubFrag)
    End Sub

    Private Sub xmlAzimuthal(ByRef xmlNode1 As XmlNode)
        Dim xmlSubNode As XmlNode
        Dim xmlSubFrag As XmlDocumentFragment
        xmlNode1 = xmlHeader.CreateElement("azimequi")
        'Longitude of Central Meridian
        xmlLongCentMerid(xmlSubNode)
        xmlNode1.AppendChild(xmlSubNode)
        'Latitude of Projection Origin
        xmlLatProjOrig(xmlSubNode)
        xmlNode1.AppendChild(xmlSubNode)
        'False Easting and False Northing
        xmlEastNorth(xmlSubFrag)
        xmlNode1.AppendChild(xmlSubFrag)
    End Sub

    Private Sub xmlVertAlt(ByRef xmlPiece As XmlNode)
        'Vertical Coordinate System Definition, Altitude System Definition
        Dim iLoop As Integer = 0
        Dim iCount As Integer = 0
        Dim sGenArray() As String
        Dim xmlTempNode As XmlNode 'main node for a sub-section

        xmlPiece = xmlHeader.CreateElement("altsys") 'create the altitude system definition node

        'create the altitude datum name
        xmlTempNode = xmlHeader.CreateElement("altdatum")
        xmlTempNode.InnerText = cboxAltDatum.Text
        xmlPiece.AppendChild(xmlTempNode)

        'create the altitude resolutions
        sGenArray = Split(txtAltRes.Text, sKdelim) 'generate the list of resolution values
        iCount = sGenArray.GetUpperBound(0)
        For iLoop = 0 To iCount
            If (sGenArray(iLoop) <> "") Then
                xmlTempNode = xmlHeader.CreateElement("altres")
                xmlTempNode.InnerText = sGenArray(iLoop)
                xmlPiece.AppendChild(xmlTempNode)
            End If
        Next

        'create the altitude distance units
        xmlTempNode = xmlHeader.CreateElement("altunits")
        xmlTempNode.InnerText = cboxAltUnits.Text
        xmlPiece.AppendChild(xmlTempNode)

        'create the altitude encoding method
        xmlTempNode = xmlHeader.CreateElement("altenc")
        xmlTempNode.InnerText = cboxAltEncode.Text
        xmlPiece.AppendChild(xmlTempNode)
    End Sub

    Private Sub xmlVertDepth(ByRef xmlPiece As XmlNode)
        'Vertical Coordinate System Definition, Altitude System Definition
        Dim iLoop As Integer = 0
        Dim iCount As Integer = 0
        Dim sGenArray() As String
        Dim xmlTempNode As XmlNode 'main node for a sub-section

        xmlPiece = xmlHeader.CreateElement("depthsys") 'create the depth system definition node

        'create the depth datum name
        xmlTempNode = xmlHeader.CreateElement("depthdn")
        xmlTempNode.InnerText = cboxDepthDatum.Text
        xmlPiece.AppendChild(xmlTempNode)

        'create the depth resolutions
        sGenArray = Split(txtDepthRes.Text, sKdelim) 'generate the list of resolution values
        iCount = sGenArray.GetUpperBound(0)
        For iLoop = 0 To iCount
            If (sGenArray(iLoop) <> "") Then
                xmlTempNode = xmlHeader.CreateElement("depthres")
                xmlTempNode.InnerText = sGenArray(iLoop)
                xmlPiece.AppendChild(xmlTempNode)
            End If
        Next

        'create the depth distance units
        xmlTempNode = xmlHeader.CreateElement("depthdu")
        xmlTempNode.InnerText = cboxDepthUnits.Text
        xmlPiece.AppendChild(xmlTempNode)

        'create the depth encoding method
        xmlTempNode = xmlHeader.CreateElement("depthem")
        xmlTempNode.InnerText = cboxDepthEncode.Text
        xmlPiece.AppendChild(xmlTempNode)
    End Sub

#End Region


#Region " File saving procedures -- XML creation, Entity & Attribute Information "

    Private Sub updateEAsection()
        Dim iLoop As Integer = 0
        Dim iLoop2 As Integer = 0
        Dim iLoop3 As Integer = 0
        Dim iCount As Integer = 0
        Dim iCount2 As Integer = 0
        Dim iCount3 As Integer = 0
        Dim iIndex As Integer = 0
        Dim s1 As String = ""
        Dim sGenArray() As String
        Dim xmlTempNode As XmlNode 'main node for a sub-section
        Dim xmlTempNode2 As XmlNode '1st subsidiary node
        Dim xmlTempNode3 As XmlNode '2nd subsidiary node
        Dim xmlTempNode4 As XmlNode '3rd subsidiary node
        Dim xmlPiece1 As XmlNode
        Dim xmlPiece2 As XmlNode
        Dim cGenColl As Collection 'general collection

        'for detailed descriptions
        Dim oDetailed As EAdetailClass
        Dim oAttrib As AttribClass

        'for overview descriptions
        Dim oOverView As EAoverClass
        Dim sOverCite As StringCollection

        iCount = cEAentity.Count
        iCount2 = cEAttrOver.Count

        'are there nodes to process or is EA to be skipped?
        If (iCount = 0 And iCount2 = 0) Then Return 'no child nodes to process
        xmlEAsection = xmlHeader.CreateElement("eainfo")

        'process Detailed Descriptions if present
        iCount = cEAentity.Count
        For iLoop = 1 To iCount
            oDetailed = CType(cEAentity(iLoop), EAdetailClass)
            xmlTempNode = xmlHeader.CreateElement("detailed") 'create detailed description node
            xmlTempNode2 = xmlHeader.CreateElement("enttyp") 'create entity type node
            xmlTempNode3 = xmlHeader.CreateElement("enttypl") 'create entity type label node
            xmlTempNode3.InnerText = oDetailed.EntityLabel
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach label to entity type
            xmlTempNode3 = xmlHeader.CreateElement("enttypd") 'create entity type definition node
            s1 = oDetailed.EntityDef
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode3.InnerText = s1
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach definition to entity type
            xmlTempNode3 = xmlHeader.CreateElement("enttypds") 'create entity type definition source node
            s1 = oDetailed.DefSource
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode3.InnerText = s1
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach definition source to entity type
            xmlTempNode.AppendChild(xmlTempNode2) 'attach entity type to detailed description node

            'process Attributes if present
            cGenColl = oDetailed.AttribColl 'retrieve the collection of attribute index values
            iCount2 = cGenColl.Count
            For iLoop2 = 1 To iCount2
                iIndex = CType(cGenColl(iLoop2), Integer) 'retrieve attribute index
                oAttrib = CType(cEAttribs(iIndex), AttribClass) 'retrieve indexed attribute from collection
                ProcAttrib(oAttrib, xmlPiece1)
                xmlTempNode.AppendChild(xmlPiece1) 'attach attribute to detailed description node
            Next

            xmlEAsection.AppendChild(xmlTempNode) 'attach detailed description to EA section
        Next

        'process Overview Descriptions if present
        iCount = cEAttrOver.Count
        For iLoop = 1 To iCount
            oOverView = CType(cEAttrOver(iLoop), EAoverClass)
            xmlTempNode = xmlHeader.CreateElement("overview") 'overview description node
            xmlTempNode2 = xmlHeader.CreateElement("eaover") 'overview node
            s1 = oOverView.Overview
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode2.InnerText = s1
            xmlTempNode.AppendChild(xmlTempNode2) 'attach overview to overview description

            sOverCite = oOverView.DetailCite
            iCount2 = sOverCite.Count - 1 'adjust for 0-based index
            iCount3 = 0 'counter for number of citations processed
            For iLoop2 = 0 To iCount2
                If (sOverCite(iLoop2) = "") Then
                    'ignore
                Else
                    xmlTempNode2 = xmlHeader.CreateElement("eadetcit") 'detail citation, not in Citation Info format
                    s1 = sOverCite(iLoop2)
                    If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                    xmlTempNode2.InnerText = s1
                    xmlTempNode.AppendChild(xmlTempNode2) 'attach citation to overview description
                    iCount3 += 1 'increment citation counter
                End If
            Next
            If (iCount3 = 0) Then
                'no citations processed, but citation is mandatory -- add empty node
                xmlTempNode2 = xmlHeader.CreateElement("eadetcit") 'detail citation
                xmlTempNode.AppendChild(xmlTempNode2) 'attach citation to overview description
            End If
            xmlEAsection.AppendChild(xmlTempNode) 'attach overview description to EA section node
        Next
    End Sub

    Private Sub ProcAttrib(ByRef oAttrib As AttribClass, ByRef xmlPiece As XmlNode)
        Dim iLoop As Integer = 0
        Dim iLoop2 As Integer = 0
        Dim iCount As Integer = 0
        Dim iCount2 As Integer = 0
        Dim iIndex As Integer = 0
        Dim sGenArray() As String
        Dim s1 As String = ""
        Dim xmlTempNode As XmlNode 'main node for a sub-section
        Dim xmlTempNode2 As XmlNode '1st subsidiary node
        Dim xmlTempNode3 As XmlNode '2nd subsidiary node
        Dim xmlAttribPiece As XmlNode

        Dim sDomType As String = "" 'current domain value type
        Dim cDomValues As New Collection 'contains the domain value index values
        Dim oEnum As New AttribDomain_Enum
        Dim oRange As New AttribDomain_Range
        Dim sCodeset As String = ""
        Dim sUnrep As String = ""

        Dim cMoreAttribs As New Collection 'collection of additional attribute index values
        Dim iMoreIndex As Integer = 0 'current index value of attribute in oEAttributes from cMoreAttribs
        Dim oAttribNextLevel As New AttribClass 'local copy of attribute from main collection

        Dim sValDates As New StringCollection 'holds the collection of attribute value dates

        xmlPiece = xmlHeader.CreateElement("attr") 'primary attribute node
        xmlTempNode = xmlHeader.CreateElement("attrlabl") 'attribute label node
        xmlTempNode.InnerText = oAttrib.Label
        xmlPiece.AppendChild(xmlTempNode) 'attach label to attribute node
        xmlTempNode = xmlHeader.CreateElement("attrdef") 'attribute definition node
        s1 = oAttrib.Definition
        If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
        xmlTempNode.InnerText = s1
        xmlPiece.AppendChild(xmlTempNode) 'attach definition to attribute node
        xmlTempNode = xmlHeader.CreateElement("attrdefs") 'attribute definition source node
        s1 = oAttrib.DefSource
        If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
        xmlTempNode.InnerText = s1
        xmlPiece.AppendChild(xmlTempNode) 'attach def source to attribute node

        'process Domain Values
        cDomValues = oAttrib.DomainValues 'domain index values
        iCount = cDomValues.Count
        For iLoop = 1 To iCount
            xmlTempNode = xmlHeader.CreateElement("attrdomv") 'create domain value node
            iIndex = CType(cDomValues(iLoop), Integer) 'retrieve domain value index
            sDomType = cEAdomtype(iIndex) 'retrieve domain values type
            Select Case sDomType
                Case "enum" 'enumerated domain
                    oEnum = CType(cEAdomains(iIndex), AttribDomain_Enum)
                    xmlTempNode2 = xmlHeader.CreateElement("edom") 'create enumerated domain node
                    xmlTempNode3 = xmlHeader.CreateElement("edomv") 'create value node
                    xmlTempNode3.InnerText = oEnum.DomainValue
                    xmlTempNode2.AppendChild(xmlTempNode3) 'attach value to enum domain
                    xmlTempNode3 = xmlHeader.CreateElement("edomvd") 'create value definition node
                    s1 = oEnum.ValueDef
                    If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                    xmlTempNode3.InnerText = s1
                    xmlTempNode2.AppendChild(xmlTempNode3) 'attach value def to enum domain
                    xmlTempNode3 = xmlHeader.CreateElement("edomvds") 'create value definition source node
                    s1 = oEnum.DefSource
                    If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                    xmlTempNode3.InnerText = s1
                    xmlTempNode2.AppendChild(xmlTempNode3) 'attach definition source to enum domain

                    'process attributes
                    cMoreAttribs = oEnum.MoreAttributes 'retrieve collection of attribute index values
                    iCount2 = cMoreAttribs.Count
                    For iLoop2 = 1 To iCount2
                        iMoreIndex = CType(cMoreAttribs(iLoop2), Integer) 'retrieve attribute index value
                        oAttribNextLevel = CType(cEAttribs(iMoreIndex), AttribClass) 'retrieve attribute
                        ProcAttrib(oAttribNextLevel, xmlAttribPiece)
                        xmlTempNode2.AppendChild(xmlAttribPiece) 'attach attribute to enum domain
                    Next

                Case "range" 'range domain
                    oRange = CType(cEAdomains(iIndex), AttribDomain_Range)
                    xmlTempNode2 = xmlHeader.CreateElement("rdom") 'create range domain node
                    xmlTempNode3 = xmlHeader.CreateElement("rdommin") 'create range minimum node
                    xmlTempNode3.InnerText = oRange.DomMinimum
                    xmlTempNode2.AppendChild(xmlTempNode3) 'attach minimum to range domain
                    xmlTempNode3 = xmlHeader.CreateElement("rdommax") 'create range maximum node
                    xmlTempNode3.InnerText = oRange.DomMaximum
                    xmlTempNode2.AppendChild(xmlTempNode3) 'attach maximum to range domain
                    If (oRange.MeasureUnits = "") Then
                        'do nothing
                    Else
                        xmlTempNode3 = xmlHeader.CreateElement("attrunit") 'create units of measure node
                        xmlTempNode3.InnerText = oRange.MeasureUnits
                        xmlTempNode2.AppendChild(xmlTempNode3) 'attach units to range domain
                    End If
                    If (oRange.Resolution = 0) Then
                        'do nothing
                    Else
                        xmlTempNode3 = xmlHeader.CreateElement("attrmres") 'create measurement resolution node
                        xmlTempNode3.InnerText = oRange.Resolution.ToString
                        xmlTempNode2.AppendChild(xmlTempNode3) 'attach resolution to range domain
                    End If

                    'process attributes
                    cMoreAttribs = oRange.MoreAttributes 'retrieve collection of attribute index values
                    iCount2 = cMoreAttribs.Count
                    For iLoop2 = 1 To iCount2
                        iMoreIndex = CType(cMoreAttribs(iLoop2), Integer) 'retrieve attribute index value
                        oAttribNextLevel = CType(cEAttribs(iMoreIndex), AttribClass) 'retrieve attribute
                        ProcAttrib(oAttribNextLevel, xmlAttribPiece)
                        xmlTempNode2.AppendChild(xmlAttribPiece) 'attach attribute to range domain
                    Next

                Case "codeset" 'codeset domain
                    sCodeset = CType(cEAdomains(iIndex), String)
                    sGenArray = Split(sCodeset, sPdelim)
                    xmlTempNode2 = xmlHeader.CreateElement("codesetd") 'create codeset domain node
                    xmlTempNode3 = xmlHeader.CreateElement("codesetn") 'create codeset name node
                    s1 = sGenArray(0)
                    If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                    xmlTempNode3.InnerText = s1
                    xmlTempNode2.AppendChild(xmlTempNode3) 'attach codeset name to codeset
                    xmlTempNode3 = xmlHeader.CreateElement("codesets") 'create codeset source node
                    If (sGenArray.GetLength(0) > 1) Then
                        s1 = sGenArray(1)
                        If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                        xmlTempNode3.InnerText = s1
                    Else
                        xmlTempNode3.InnerText = "Unknown"
                    End If
                    xmlTempNode2.AppendChild(xmlTempNode3) 'attach source to codeset node

                Case "unrep" 'unrepresentable domain
                    sUnrep = CType(cEAdomains(iIndex), String)
                    If (iSaveType = 2) Then sUnrep = sUnrep.Replace(CrLf, strParaMarker) 'HTML prep
                    xmlTempNode2 = xmlHeader.CreateElement("udom") 'create unrepresentable domain node
                    xmlTempNode2.InnerText = sUnrep
            End Select
            xmlTempNode.AppendChild(xmlTempNode2) 'attach domain to domain value
            xmlPiece.AppendChild(xmlTempNode) 'attach domain value to attribute
        Next

        'process optional dates if present
        sValDates = oAttrib.ValueDates 'retrieve dates string collection
        iCount = sValDates.Count
        If (iCount > 0) Then
            iCount -= 1 'adjust for 0-based index
            For iLoop = 0 To iCount
                sGenArray = Split(sValDates(iLoop), sPdelim)
                xmlTempNode = xmlHeader.CreateElement("begdatea") 'create beginning date node
                xmlTempNode.InnerText = sGenArray(0)
                xmlPiece.AppendChild(xmlTempNode) 'attach beginning date to attribute
                If (sGenArray.GetLength(0) > 1) Then
                    xmlTempNode = xmlHeader.CreateElement("enddatea") 'create ending date node
                    xmlTempNode.InnerText = sGenArray(1)
                    xmlPiece.AppendChild(xmlTempNode) 'attach ending date to attribute
                End If
            Next
        End If

        'process optional value accuracy information if present
        If (oAttrib.Accuracy <> 0) Then
            xmlTempNode = xmlHeader.CreateElement("attrvai") 'create value accuracy information node
            xmlTempNode2 = xmlHeader.CreateElement("attrva") 'create value accuracy node
            xmlTempNode2.InnerText = oAttrib.Accuracy.ToString
            xmlTempNode.AppendChild(xmlTempNode2) 'attach value accuracy to accuracy information node
            xmlTempNode2 = xmlHeader.CreateElement("attrvae") 'create accuracy explanation node
            s1 = oAttrib.AccExplain
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode2.InnerText = s1
            xmlTempNode.AppendChild(xmlTempNode2) 'attach accuracy explanation to accuracy information node
            xmlPiece.AppendChild(xmlTempNode) 'attach accuracy information to attribute node
        End If

        'process optional measurement frequency information if present
        If (oAttrib.MeasureFreq = "") Then
            'do nothing
        Else
            xmlTempNode = xmlHeader.CreateElement("attrmfrq") 'create measurement frequency node
            xmlTempNode.InnerText = oAttrib.MeasureFreq
            xmlPiece.AppendChild(xmlTempNode) 'attach measurement frequency to attribute node
        End If
    End Sub

#End Region


#Region " File saving procedure -- XML creation, Distribution Information "

    Private Sub updateDIsection()
        Dim iLoop As Integer = 0
        Dim iLoop2 As Integer = 0
        Dim iCountDist As Integer = 0
        Dim iCountSOP As Integer = 0
        Dim iCountTime As Integer = 0
        Dim iIndex As Integer = 0
        Dim s1 As String = ""
        Dim xmlTempNode As XmlNode 'main node for a sub-section
        Dim xmlTempNode2 As XmlNode '1st subsidiary node
        Dim xmlTempNode3 As XmlNode '2nd subsidiary node
        Dim xmlPiece1 As XmlNode
        Dim oDistrib As New DistributorClass 'local copy of distributor object
        Dim oCurContact As New ContactInfo 'local copy of distributor contact information
        Dim cStdOrderIndex As Collection 'index values linked to standard order process collection, cStdOrderProc
        Dim cAvTime As New Collection 'local copy of Time Available collection
        Dim iRange As Integer = 0  '1=single, 2=range, 3=multiple
        Dim iTType As Integer = 1  '1=Gregorian, 2=Geologic

        iCountDist = cDistrib.Count 'number of distributors to process
        If (iCountDist = 0) Then
            'no distribution information avaialable
            Return
        End If

        For iLoop = 1 To iCountDist
            oDistrib = CType(cDistrib(iLoop), DistributorClass) 'retrieve Distribution Info object
            oCurContact = oDistrib.Distributor 'retrieve Distributor object
            cAvTime = oDistrib.TimeAvail 'Available Time Period Info
            cStdOrderIndex = oDistrib.StdOrderColl 'index values for Standard Order Processes
            xmlTempNode = xmlHeader.CreateElement("distinfo") 'create a Distribution Info node

            'process Distributor contact info
            xmlTempNode2 = xmlHeader.CreateElement("distrib") 'create required Distributor node
            xmlContactInfo(oCurContact, xmlTempNode3)
            xmlTempNode2.AppendChild(xmlTempNode3) 'append to Distributor node
            xmlTempNode.AppendChild(xmlTempNode2) 'append Distributor to Distribution Info

            'process Resource Description if present
            If (oDistrib.ResourceDesc = "") Then
                'do nothing
            Else
                xmlTempNode2 = xmlHeader.CreateElement("resdesc")
                s1 = oDistrib.ResourceDesc
                If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                xmlTempNode2.InnerText = s1
                xmlTempNode.AppendChild(xmlTempNode2) 'add Resource Desc to Distribution Info
            End If

            'process Distribution Liability
            xmlTempNode2 = xmlHeader.CreateElement("distliab")
            s1 = oDistrib.Liability
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode2.InnerText = s1
            xmlTempNode.AppendChild(xmlTempNode2) 'add Dist Liability to Distribution Info

            'process Standard Order Processes
            iCountSOP = cStdOrderIndex.Count
            For iLoop2 = 1 To iCountSOP
                iIndex = CType(cStdOrderIndex(iLoop2), Integer) 'get the index value
                xmlStdOP(iIndex, xmlTempNode2) 'process the Standard Order Process
                xmlTempNode.AppendChild(xmlTempNode2) 'add SOP to Distribution Info
            Next

            'process Custom Order Process if present
            If (oDistrib.CustomOrder = "") Then
                'do nothing
            Else
                xmlTempNode2 = xmlHeader.CreateElement("custom")
                s1 = oDistrib.CustomOrder
                If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                xmlTempNode2.InnerText = s1
                xmlTempNode.AppendChild(xmlTempNode2) 'add Custom Order to Distribution Info
            End If

            'process Technical Prerequisites if present
            If (oDistrib.TechReq = "") Then
                'do nothing
            Else
                xmlTempNode2 = xmlHeader.CreateElement("techpreq")
                s1 = oDistrib.TechReq
                If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                xmlTempNode2.InnerText = s1
                xmlTempNode.AppendChild(xmlTempNode2) 'add Tech Prereq to Distribution Info
            End If

            'process Available Time Period if present
            iCountTime = cAvTime.Count
            If (iCountTime = 0) Then
                'do nothing
            Else
                xmlTempNode2 = xmlHeader.CreateElement("availabl")
                If (oDistrib.boolSingle = True And oDistrib.boolRange = False) Then
                    iRange = 1 'Single
                ElseIf (oDistrib.boolSingle = False And oDistrib.boolRange = True) Then
                    iRange = 2 'range
                Else
                    iRange = 3 'multiple
                End If
                xmlTimePeriodInfo(cAvTime, iRange, iTType, xmlPiece1) 'generate timeinfo in xmlPiece1
                xmlTempNode2.AppendChild(xmlPiece1)  'add timeinfo to available time period node
                xmlTempNode.AppendChild(xmlTempNode2) 'add available time period node to Distribution Info
            End If

            'append Distribution Info to DI section fragment
            xmlDistSection.AppendChild(xmlTempNode)
        Next
    End Sub

    Private Sub xmlStdOP(ByVal indexVal As Integer, ByRef xmlSOP As XmlNode)
        'process a Standard Ordering Process
        'retrieve the indexVal member of the collection, put XML into xmlSOP
        Dim iLoop As Integer = 0
        Dim iCount As Integer = 0
        Dim iCount2 As Integer = 0
        Dim iIndex As Integer = 0
        Dim s1 As String = ""
        Dim xmlTempNode As XmlNode 'main node for a sub-section
        Dim xmlTempNode2 As XmlNode '1st subsidiary node
        Dim xmlTempNode3 As XmlNode '2nd subsidiary node
        Dim xmlPiece1 As XmlNode
        Dim oStdOrder As New StdOrderClass 'local copy of standard order object
        Dim cDigitalIndex As Collection 'index values linked to digital form collection, cDigitalForm

        xmlSOP = xmlHeader.CreateElement("stdorder")
        oStdOrder = CType(cStdOrderProc(indexVal), StdOrderClass)
        cDigitalIndex = oStdOrder.DigitalForms

        'process Non-digital Form
        If (oStdOrder.NonDigitalForm <> "") Then
            xmlTempNode = xmlHeader.CreateElement("nondig")
            s1 = oStdOrder.NonDigitalForm
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode.InnerText = s1
            xmlSOP.AppendChild(xmlTempNode)
        End If

        'process Digital Form
        iCount = cDigitalIndex.Count 'number of digital forms to process
        For iLoop = 1 To iCount
            iIndex = CType(cDigitalIndex(iLoop), Integer) 'retrieve the index from collection
            xmlDigitalForm(iIndex, xmlPiece1)
            xmlSOP.AppendChild(xmlPiece1) 'attach digital form to standard order process
        Next

        'process Fees
        xmlTempNode = xmlHeader.CreateElement("fees")
        s1 = oStdOrder.Fees
        If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
        xmlTempNode.InnerText = s1
        xmlSOP.AppendChild(xmlTempNode)

        'process Ordering Instructions if present
        If (oStdOrder.Instructions = "") Then
            'do nothing
        Else
            xmlTempNode = xmlHeader.CreateElement("ordering")
            s1 = oStdOrder.Instructions
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode.InnerText = s1
            xmlSOP.AppendChild(xmlTempNode)
        End If

        'process Turnaround if present
        If (oStdOrder.Turnaround = "") Then
            'do nothing
        Else
            xmlTempNode = xmlHeader.CreateElement("turnarnd")
            s1 = oStdOrder.Turnaround
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode.InnerText = s1
            xmlSOP.AppendChild(xmlTempNode)
        End If
    End Sub

    Private Sub xmlDigitalForm(ByVal indexVal As Integer, ByRef xmlPiece As XmlNode)
        'process a Digital Form
        'retrieve the indexVal member of the collection, put XML into xmlPiece
        Dim iLoop As Integer = 0
        Dim iCount As Integer = 0
        Dim iIndex As Integer = 0
        Dim s1 As String = ""
        Dim bTest As Boolean
        Dim xmlTempNode As XmlNode 'main node for a sub-section
        Dim xmlTempNode2 As XmlNode '1st subsidiary node
        Dim xmlTempNode3 As XmlNode '2nd subsidiary node
        Dim xmlTempNode4 As XmlNode '3rd subsidiary node
        Dim xmlPieceNew As XmlNode
        Dim oDigiForm As New DigitalOrderClass 'local copy of digital form object
        Dim cTransferIndex As Collection 'index values linked to transfer options collection, cDTransOpt

        'set up Digital Form
        oDigiForm = CType(cDigitalForm(indexVal), DigitalOrderClass) 'retrieve the digital form
        cTransferIndex = oDigiForm.TransOptions 'collection of transfer option index values
        xmlPiece = xmlHeader.CreateElement("digform") 'create digital transfer info node

        'process Digital Transfer Information
        xmlTempNode = xmlHeader.CreateElement("digtinfo") 'create digital transfer info node
        xmlTempNode2 = xmlHeader.CreateElement("formname") 'create required format name
        xmlTempNode2.InnerText = oDigiForm.FormatName
        xmlTempNode.AppendChild(xmlTempNode2) 'attach format name to digital transfer info

        'process optional format information elements
        bTest = False
        If (oDigiForm.FormatVNum <> "") Then
            xmlTempNode2 = xmlHeader.CreateElement("formvern")
            xmlTempNode2.InnerText = oDigiForm.FormatVNum
            xmlTempNode.AppendChild(xmlTempNode2) 'attach format version number to digital transfer info
            bTest = True
        End If
        If (oDigiForm.FormatVDate <> "" And bTest = False) Then
            xmlTempNode2 = xmlHeader.CreateElement("formverd")
            xmlTempNode2.InnerText = oDigiForm.FormatVDate
            xmlTempNode.AppendChild(xmlTempNode2) 'attach format version date to digital transfer info
            bTest = True
        End If
        If (oDigiForm.FormatSpec <> "") Then
            xmlTempNode2 = xmlHeader.CreateElement("formspec")
            s1 = oDigiForm.FormatSpec
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode2.InnerText = s1
            xmlTempNode.AppendChild(xmlTempNode2) 'attach format specification to digital transfer info
        End If

        'process ASCII File Structure if present
        If (oDigiForm.ASCIIstruct = True) Then
            xmlTempNode2 = xmlHeader.CreateElement("asciistr") 'ASCII main node

            'process Record Delimiter if present
            If (oDigiForm.RecordDelim = "") Then
                'do nothing
            Else
                xmlTempNode3 = xmlHeader.CreateElement("recdel")
                xmlTempNode3.InnerText = oDigiForm.RecordDelim
                xmlTempNode2.AppendChild(xmlTempNode3) 'attach record delimiter to ASCII node
            End If

            'process Number of Header Lines
            xmlTempNode3 = xmlHeader.CreateElement("numheadl")
            xmlTempNode3.InnerText = oDigiForm.NumHeaders
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach # of headers to ASCII node

            'process Description of Header Content if present
            If (oDigiForm.Header = "") Then
                'do nothing
            Else
                xmlTempNode3 = xmlHeader.CreateElement("deschead")
                s1 = oDigiForm.Header
                If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                xmlTempNode3.InnerText = s1
                xmlTempNode2.AppendChild(xmlTempNode3) 'attach header info to ASCII node
            End If

            'process Orientation and Case Sensitive
            xmlTempNode3 = xmlHeader.CreateElement("orienta")
            xmlTempNode3.InnerText = oDigiForm.Orientation
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach Orientation to ASCII node
            xmlTempNode3 = xmlHeader.CreateElement("casesens")
            xmlTempNode3.InnerText = oDigiForm.CaseSensitive
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach Case Sensitive to ASCII node

            'process Authentication and Quote Character if present
            If (oDigiForm.Authentic = "") Then
                'do nothing
            Else
                xmlTempNode3 = xmlHeader.CreateElement("authent")
                s1 = oDigiForm.Authentic
                If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                xmlTempNode3.InnerText = s1
                xmlTempNode2.AppendChild(xmlTempNode3) 'attach authentication to ASCII node
            End If
            If (oDigiForm.QuoteChar = "") Then
                'do nothing
            Else
                xmlTempNode3 = xmlHeader.CreateElement("quotech")
                xmlTempNode3.InnerText = oDigiForm.QuoteChar
                xmlTempNode2.AppendChild(xmlTempNode3) 'attach quote character to ASCII node
            End If

            'process Data Fields
            Dim sDataFields As New StringCollection
            Dim sGenArray() As String
            sDataFields = oDigiForm.DataFields
            iCount = sDataFields.Count - 1 'adjusts for 0-based index
            For iLoop = 0 To iCount
                sGenArray = Split(sDataFields(iLoop), sPdelim)
                xmlTempNode3 = xmlHeader.CreateElement("datafiel") 'data field node

                'process Data Field Name
                xmlTempNode4 = xmlHeader.CreateElement("dfieldnm") 'data field name
                xmlTempNode4.InnerText = sGenArray(0)
                xmlTempNode3.AppendChild(xmlTempNode4) 'attach data field name to data field

                'process Missing Value Code if present
                If (sGenArray(1) = "") Then
                    'do nothing
                Else
                    xmlTempNode4 = xmlHeader.CreateElement("missingv") 'missing value code node
                    xmlTempNode4.InnerText = sGenArray(1)
                    xmlTempNode3.AppendChild(xmlTempNode4) 'attach missing value code to data field
                End If

                'process field separation info
                If (sGenArray(2) = "delim") Then
                    xmlTempNode4 = xmlHeader.CreateElement("dfwidthd") 'data field width delimiter
                    xmlTempNode4.InnerText = sGenArray(3)
                    xmlTempNode3.AppendChild(xmlTempNode4) 'attach data field width delimiter to data field
                ElseIf (sGenArray(2) = "width") Then
                    xmlTempNode4 = xmlHeader.CreateElement("dfwidth") 'data field width
                    xmlTempNode4.InnerText = sGenArray(3)
                    xmlTempNode3.AppendChild(xmlTempNode4) 'attach data field width to data field
                Else
                    'do nothing -- error condition!
                End If

                xmlTempNode2.AppendChild(xmlTempNode3) 'attach data field to ASCII
            Next
            xmlTempNode.AppendChild(xmlTempNode2) 'attach ASCII to Digital Transfer Info
        End If

        'process Format Information Content, if present
        If (oDigiForm.FormatInfo = "") Then
            'do nothing
        Else
            xmlTempNode2 = xmlHeader.CreateElement("formcont")
            s1 = oDigiForm.FormatInfo
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode2.InnerText = s1
            xmlTempNode.AppendChild(xmlTempNode2) 'attach format info content to digital transfer info
        End If

        'process File Decompression, if present
        If (oDigiForm.Decompress = "") Then
            'do nothing
        Else
            xmlTempNode2 = xmlHeader.CreateElement("filedec")
            s1 = oDigiForm.Decompress
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode2.InnerText = s1
            xmlTempNode.AppendChild(xmlTempNode2) 'attach File Decompression to digital transfer info
        End If

        'process Transfer Size if present
        If (oDigiForm.TransferSize = "") Then
            'do nothing
        Else
            xmlTempNode2 = xmlHeader.CreateElement("transize")
            xmlTempNode2.InnerText = oDigiForm.TransferSize
            xmlTempNode.AppendChild(xmlTempNode2) 'attach transfer size to digital transfer info
        End If

        xmlPiece.AppendChild(xmlTempNode) 'attach digital transfer info to digital form node

        'process Digital Transfer Options
        iCount = cTransferIndex.Count 'number of digital transfer options to process
        For iLoop = 1 To iCount
            iIndex = CType(cTransferIndex(iLoop), Integer) 'retrieve the index from collection
            xmlTransOpt(iIndex, xmlPieceNew)
            xmlPiece.AppendChild(xmlPieceNew) 'attach Transfer Option to Digital Form node
        Next
    End Sub

    Private Sub xmlTransOpt(ByVal indexVal As Integer, ByRef xmlPiece As XmlNode)
        'processes Digital Transfer Option information
        'retrieve the indexVal member of the collection, put XML into xmlPiece
        Dim iLoop As Integer = 0
        Dim iCount As Integer = 0
        Dim iIndex As Integer = 0
        Dim s1 As String = ""
        Dim sGenArray() As String
        Dim xmlTempNode As XmlNode 'main node for a sub-section
        Dim xmlTempNode2 As XmlNode '1st subsidiary node
        Dim xmlTempNode3 As XmlNode '2nd subsidiary node
        Dim xmlTempNode4 As XmlNode '3rd subsidiary node
        Dim xmlPieceNew As XmlNode
        Dim oTransOpt As New DTransOption 'local copy of digital transfer option object

        'set up Digital Transfer Option
        oTransOpt = CType(cDTransOpt(indexVal), DTransOption) 'retrieve the digital transfer option
        xmlPiece = xmlHeader.CreateElement("digtopt") 'create digital transfer option node

        'process Digital Transfer Option Information
        If (oTransOpt.boolOnline = True) Then
            'process an Online option
            xmlTempNode = xmlHeader.CreateElement("onlinopt") 'create Online Option node
            xmlTempNode2 = xmlHeader.CreateElement("computer") 'create Computer Contact Info
            xmlTempNode3 = xmlHeader.CreateElement("networka") 'create Network Address
            sGenArray = Split(oTransOpt.NetworkName, sKdelim) 'extract Network Resource Names
            iCount = sGenArray.GetUpperBound(0)
            For iLoop = 0 To iCount
                If (sGenArray(iLoop) = "") Then
                    'do nothing
                Else
                    xmlTempNode4 = xmlHeader.CreateElement("networkr") 'create Network Resource Name
                    xmlTempNode4.InnerText = sGenArray(iLoop)
                    xmlTempNode3.AppendChild(xmlTempNode4) 'attach Resource Name to Network Address
                End If
            Next
            xmlTempNode2.AppendChild(xmlTempNode3) 'attach Network Address to Computer Contact
            xmlTempNode.AppendChild(xmlTempNode2) 'attach Computer Contact to Online Option

            'process Access Instructions if present
            If (oTransOpt.Access = "") Then
                'do nothing
            Else
                xmlTempNode2 = xmlHeader.CreateElement("accinstr") 'create Access Instructions
                s1 = oTransOpt.Access
                If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                xmlTempNode2.InnerText = s1
                xmlTempNode.AppendChild(xmlTempNode2) 'attach Access Instructions to Online Option
            End If

            'process Operating System if present
            If (oTransOpt.ComputerOS = "") Then
                'do nothing
            Else
                xmlTempNode2 = xmlHeader.CreateElement("oncomp") 'create Online Computer
                s1 = oTransOpt.ComputerOS
                If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                xmlTempNode2.InnerText = s1
                xmlTempNode.AppendChild(xmlTempNode2) 'attach Online Computer to Online Option
            End If

            xmlPiece.AppendChild(xmlTempNode) 'attach Online Option to Digital Transfer Option

        ElseIf (oTransOpt.boolOffline = True) Then
            xmlTempNode = xmlHeader.CreateElement("offoptn") 'create Offline Option node

            'process Offline Media
            xmlTempNode2 = xmlHeader.CreateElement("offmedia") 'Offline Media node
            xmlTempNode2.InnerText = oTransOpt.OfflineMedia
            xmlTempNode.AppendChild(xmlTempNode2)

            'process Recording Capacity if present
            If (oTransOpt.RecDensity = "" And oTransOpt.DensityUnits = "") Then
                'do nothing
            Else
                xmlTempNode2 = xmlHeader.CreateElement("reccap") 'Recording Capacity node
                'process Recording Density
                sGenArray = Split(oTransOpt.RecDensity, sKdelim) 'extract recording densities
                iCount = sGenArray.GetUpperBound(0)
                For iLoop = 0 To iCount
                    If (sGenArray(iLoop) = "") Then
                        'do nothing
                    Else
                        xmlTempNode3 = xmlHeader.CreateElement("recden") 'Recording Density node
                        xmlTempNode3.InnerText = sGenArray(iLoop)
                        xmlTempNode2.AppendChild(xmlTempNode3) 'attach recording density to recording capacity
                    End If
                Next
                'process Recording Density Units
                xmlTempNode3 = xmlHeader.CreateElement("recdenu") 'Recording Density Units node
                xmlTempNode3.InnerText = oTransOpt.DensityUnits
                xmlTempNode2.AppendChild(xmlTempNode3) 'attach recording density units to recording capacity
            End If
            xmlTempNode.AppendChild(xmlTempNode2) 'attach recording capacity to offline option

            'process Recording Format
            sGenArray = Split(oTransOpt.RecFormat, sKdelim) 'extract recording formats
            iCount = sGenArray.GetUpperBound(0)
            For iLoop = 0 To iCount
                If (sGenArray(iLoop) = "") Then
                    'do nothing
                Else
                    xmlTempNode2 = xmlHeader.CreateElement("recfmt") 'Recording Format node
                    xmlTempNode2.InnerText = sGenArray(iLoop)
                    xmlTempNode.AppendChild(xmlTempNode2) 'attach recording format to offline option
                End If
            Next

            'process Compatibility Information if present
            If (oTransOpt.Compatible = "") Then
                'do nothing
            Else
                xmlTempNode2 = xmlHeader.CreateElement("compat") 'Compatibility Info node
                s1 = oTransOpt.Compatible
                If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
                xmlTempNode2.InnerText = s1
                xmlTempNode.AppendChild(xmlTempNode2) 'attach compat info to offline option
            End If

            'attach offline option to Digital Transfer Option
            xmlPiece.AppendChild(xmlTempNode)

        Else
            'do nothing -- error condition or not yet filled in
        End If
        Return
    End Sub

#End Region


#Region " File saving procedures -- XML creation, Metadata Reference section "

    Private Sub updateMRsection()
        Dim iLoop As Integer = 0
        Dim xmlTempNode As XmlNode 'main node for a sub-section
        Dim xmlTempNode2 As XmlNode '1st subsidiary node
        Dim dTempDate As Date
        Dim sXMLString As String = ""
        Dim sTempString As String = ""
        Dim s1 As String = ""

        sXMLString = dtPick1.Value.Year.ToString 'get the Metadata Date element
        sTempString = dtPick1.Value.Month.ToString
        If (Len(sTempString) = 1) Then
            sTempString = "0" & sTempString
        End If
        sXMLString += sTempString
        sTempString = dtPick1.Value.Day.ToString
        If (Len(sTempString) = 1) Then
            sTempString = "0" & sTempString
        End If
        sXMLString += sTempString
        xmlTempNode = xmlHeader.CreateElement("metd")
        xmlTempNode.InnerText = sXMLString
        xmlMetaRefSection.AppendChild(xmlTempNode)

        If (chkRevDate.Checked = True) Then 'get the Metadata Review Date element
            sXMLString = dtPick2.Value.Year.ToString
            sTempString = dtPick2.Value.Month.ToString
            If (Len(sTempString) = 1) Then
                sTempString = "0" & sTempString
            End If
            sXMLString += sTempString
            sTempString = dtPick2.Value.Day.ToString
            If (Len(sTempString) = 1) Then
                sTempString = "0" & sTempString
            End If
            sXMLString += sTempString
            xmlTempNode = xmlHeader.CreateElement("metrd")
            xmlTempNode.InnerText = sXMLString
            xmlMetaRefSection.AppendChild(xmlTempNode)
        End If

        If (chkFRevDate.Checked = True) Then 'get the Metadata Future Review Date element
            sXMLString = dtPick3.Value.Year.ToString
            sTempString = dtPick3.Value.Month.ToString
            If (Len(sTempString) = 1) Then
                sTempString = "0" & sTempString
            End If
            sXMLString += sTempString
            sTempString = dtPick3.Value.Day.ToString
            If (Len(sTempString) = 1) Then
                sTempString = "0" & sTempString
            End If
            sXMLString += sTempString
            xmlTempNode = xmlHeader.CreateElement("metfrd")
            xmlTempNode.InnerText = sXMLString
            xmlMetaRefSection.AppendChild(xmlTempNode)
        End If

        xmlTempNode = xmlHeader.CreateElement("metc") 'set the metadata contact information
        xmlContactInfo(objMRcontact, xmlTempNode2)
        xmlTempNode.AppendChild(xmlTempNode2)
        xmlMetaRefSection.AppendChild(xmlTempNode)

        xmlTempNode = xmlHeader.CreateElement("metstdn") 'set the metadata standard name
        xmlTempNode.InnerText = cboxStdName.Text
        xmlMetaRefSection.AppendChild(xmlTempNode)

        xmlTempNode = xmlHeader.CreateElement("metstdv") 'set the metadata standard version
        xmlTempNode.InnerText = cboxStdVer.Text
        xmlMetaRefSection.AppendChild(xmlTempNode)

        If (bTimeUsed = True) Then
            xmlTempNode = xmlHeader.CreateElement("mettc") 'set the metadata time convention if applicable
            Select Case intTimeStyle
                Case 1
                    xmlTempNode.InnerText = "local time"
                Case 2
                    xmlTempNode.InnerText = "local time with time differential factor"
                Case 3
                    xmlTempNode.InnerText = "universal time"
            End Select
            xmlMetaRefSection.AppendChild(xmlTempNode)
        End If

        If (txtMRaccess.Text = "") Then
        Else
            xmlTempNode = xmlHeader.CreateElement("metac") 'set the metadata access constraints if present
            s1 = txtMRaccess.Text
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode.InnerText = s1
            xmlMetaRefSection.AppendChild(xmlTempNode)
        End If

        If (txtMRuse.Text = "") Then
        Else
            xmlTempNode = xmlHeader.CreateElement("metuc") 'set the metadata use constraints if present
            s1 = txtMRuse.Text
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode.InnerText = s1
            xmlMetaRefSection.AppendChild(xmlTempNode)
        End If

        sTempString = txtMRClassSys.Text & cboxMRClass.Text & txtMRSecDesc.Text
        If (sTempString = "") Then
        Else
            xmlTempNode = xmlHeader.CreateElement("metsi") 'set the metadata security information if present
            xmlTempNode2 = xmlHeader.CreateElement("metscs") 'set the security classification system
            s1 = txtMRClassSys.Text
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode2.InnerText = s1
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlTempNode2 = xmlHeader.CreateElement("metsc") 'set the security classification
            xmlTempNode2.InnerText = cboxMRClass.Text
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlTempNode2 = xmlHeader.CreateElement("metshd") 'set the security handling description
            s1 = txtMRSecDesc.Text
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode2.InnerText = s1
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlMetaRefSection.AppendChild(xmlTempNode)
        End If

    End Sub

#End Region


#Region " File saving procedures -- XML creation, Citation Information section "

    Private Sub xmlCiteinfo(ByRef objCite As CiteInfo, ByRef xmlCite As XmlNode)
        'creates the core of a citeinfo node from the information in objCite, passes back as xmlCite
        'objCite might be a primary citation or a larger work citation; main program handles the wrapper XML

        Dim iLoop As Integer = 0
        Dim s1 As String = ""
        Dim xmlCiteNode As XmlNode = xmlHeader.CreateElement("citeinfo")  'accumulates nodes for node in calling routine
        Dim xmlTempNode As XmlNode '1st level subsidiary node
        Dim xmlTempNode2 As XmlNode '2nd level subsidiary node

        Dim strAuthors() As String = Split(objCite.Author, CrLf) 'process author string
        Dim authCount As Integer = strAuthors.GetLength(0)
        For iLoop = 0 To authCount - 1
            xmlTempNode = xmlHeader.CreateElement("origin")
            If (strAuthors(iLoop) = "") Then
                Dim xmlAttrib3 As XmlAttribute = xmlHeader.CreateAttribute("missing")
                xmlAttrib3.Value = "True"
                xmlTempNode.Attributes.Append(xmlAttrib3) 'add the "missing" attribute 
            Else
                xmlTempNode.InnerText = strAuthors(iLoop)
            End If
            xmlCiteNode.AppendChild(xmlTempNode) 'add author to collection of nodes
        Next

        xmlTempNode = xmlHeader.CreateElement("pubdate")  'add publication date
        If (objCite.PubDate = "") Then
            Dim xmlAttrib3 As XmlAttribute = xmlHeader.CreateAttribute("missing")
            xmlAttrib3.Value = "True"
            xmlTempNode.Attributes.Append(xmlAttrib3) 'add the "missing" attribute 
        Else
            xmlTempNode.InnerText = objCite.PubDate
        End If
        xmlCiteNode.AppendChild(xmlTempNode)

        If (objCite.PubTime = "") Then  'add publication time if present (optional)
        Else
            bTimeUsed = True
            xmlTempNode = xmlHeader.CreateElement("pubtime")
            xmlTempNode.InnerText = objCite.PubTime
            xmlCiteNode.AppendChild(xmlTempNode)
        End If

        xmlTempNode = xmlHeader.CreateElement("title")  'add citation title
        If (objCite.Title = "") Then
            Dim xmlAttrib As XmlAttribute = xmlHeader.CreateAttribute("missing")
            xmlAttrib.Value = "True"
            xmlTempNode.Attributes.Append(xmlAttrib) 'add the "missing" attribute
        End If
        xmlTempNode.InnerText = objCite.Title
        xmlCiteNode.AppendChild(xmlTempNode)

        If (objCite.Edition = "") Then  'add edition if present (mandatory if applicable)
        Else
            xmlTempNode = xmlHeader.CreateElement("edition")
            xmlTempNode.InnerText = objCite.Edition
            xmlCiteNode.AppendChild(xmlTempNode)
        End If

        xmlTempNode = xmlHeader.CreateElement("geoform")  'add geospatial data presentation form
        If (objCite.Geoform = "") Then
            If (cboxStdName.Text = "FGDC Content Standard for Digital Geospatial Metadata") Then
                'geoform is not required for FGDC, do nothing
            Else
                Dim xmlAttrib2 As XmlAttribute = xmlHeader.CreateAttribute("missing")
                xmlAttrib2.Value = "True"
                xmlTempNode.Attributes.Append(xmlAttrib2) 'add the "missing" attribute
                xmlTempNode.InnerText = objCite.Geoform
                xmlCiteNode.AppendChild(xmlTempNode)
            End If
        Else
            xmlTempNode.InnerText = objCite.Geoform
            xmlCiteNode.AppendChild(xmlTempNode)
        End If

        If (objCite.SerialName = "") Then  'add series information if present (mandatory if applicable)
        Else
            xmlTempNode = xmlHeader.CreateElement("serinfo") 'create upper level series info node
            xmlTempNode2 = xmlHeader.CreateElement("sername") 'add serial name to serinfo
            xmlTempNode2.InnerText = objCite.SerialName
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlTempNode2 = xmlHeader.CreateElement("issue") 'add issue to serinfo
            xmlTempNode2.InnerText = objCite.Issue
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlCiteNode.AppendChild(xmlTempNode) 'add series info to citeinfo
        End If

        If (objCite.PubPlace = "") Then  'add publication information if present (mandatory if applicable)
        Else
            xmlTempNode = xmlHeader.CreateElement("pubinfo") 'create upper level publication info node
            xmlTempNode2 = xmlHeader.CreateElement("pubplace") 'add publication place to pubinfo
            xmlTempNode2.InnerText = objCite.PubPlace
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlTempNode2 = xmlHeader.CreateElement("publish") 'add publisher to pubinfo
            xmlTempNode2.InnerText = objCite.Publisher
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlCiteNode.AppendChild(xmlTempNode) 'add publication info to citeinfo
        End If

        If (objCite.OtherCit = "") Then  'add other citation details if present (mandatory if applicable)
        Else
            xmlTempNode = xmlHeader.CreateElement("othercit")
            s1 = objCite.OtherCit
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode.InnerText = s1
            xmlCiteNode.AppendChild(xmlTempNode)
        End If

        Dim strLinks() As String = Split(objCite.URLink, CrLf) 'process online links string (optional)
        Dim linkCount As Integer = strLinks.GetLength(0)
        For iLoop = 0 To linkCount - 1
            If (strLinks(iLoop) = "") Then
            Else
                xmlTempNode = xmlHeader.CreateElement("onlink")
                xmlTempNode.InnerText = strLinks(iLoop)
                xmlCiteNode.AppendChild(xmlTempNode) 'add online link to citeinfo
            End If
        Next

        xmlCite = xmlCiteNode
        Return
    End Sub

#End Region


#Region " File saving procedures -- XML creation, Time Period Information section "

    Private Sub xmlTimePeriodInfo(ByRef timeper As Collection, ByVal iRange As Integer, ByVal iTType As Integer, _
         ByRef xmlPiece As XmlNode)
        'timeper is collection of time period information objects
        'iRange = 1 if single, 2 if range, 3 if multiple time periods, 4 if unknown
        'iTType = 1 if Gregorian time type, 2 if Geologic Age time type
        'intTimeStyle is time style representation, if needed
        'xmlPiece will hold the final XML representation of Time Period Information

        Dim xmlTPInfo As XmlNode = xmlHeader.CreateElement("timeinfo")
        Dim xmlTPnode As XmlNode
        Dim xmlTPnode2 As XmlNode
        Dim xmlTPnode3 As XmlNode
        Dim xmlFrag As XmlDocumentFragment 'will hold individual dates
        Dim iCount As Integer = timeper.Count 'number of time periods in collection
        Dim iLoop As Integer = 0

        If (iCount = 0 Or iRange = 4) Then
            'if no dates to process, generate the required structure as "Unknown" and return
            xmlTPnode = xmlHeader.CreateElement("rngdates")
            xmlTPnode2 = xmlHeader.CreateElement("begdate")
            xmlTPnode2.InnerText = "Unknown"
            xmlTPnode.AppendChild(xmlTPnode2)
            xmlTPnode2 = xmlHeader.CreateElement("enddate")
            xmlTPnode2.InnerText = "Unknown"
            xmlTPnode.AppendChild(xmlTPnode2)
            xmlTPInfo.AppendChild(xmlTPnode)
            xmlPiece = xmlTPInfo
            Return
        End If

        If (iCount = 1) Then iRange = 1 'do Single Date/Time whenever only 1 item is in the collection

        If (iTType = 1) Then 'do Gregorian time
            Dim curTime As New SngDateTime
            If (iRange = 1) Then 'do single date
                curTime = CType(timeper(1), SngDateTime)
                xmlSngDT(curTime, xmlTPnode)
                xmlTPInfo.AppendChild(xmlTPnode)
            ElseIf (iRange = 2) Then 'do range of dates
                curTime = CType(timeper(1), SngDateTime) 'begin date
                xmlTPnode = xmlHeader.CreateElement("rngdates")
                xmlRngDT(curTime, xmlFrag, 1)
                xmlTPnode.AppendChild(xmlFrag)
                curTime = CType(timeper(2), SngDateTime) 'end date
                xmlRngDT(curTime, xmlFrag, 2)
                xmlTPnode.AppendChild(xmlFrag)
                xmlTPInfo.AppendChild(xmlTPnode)
            Else 'do multiple dates
                xmlTPnode = xmlHeader.CreateElement("mdattim")
                For iLoop = 1 To iCount
                    curTime = CType(timeper(iLoop), SngDateTime)
                    xmlSngDT(curTime, xmlTPnode2)
                    xmlTPnode.AppendChild(xmlTPnode2)
                Next
                xmlTPInfo.AppendChild(xmlTPnode)
            End If
            xmlPiece = xmlTPInfo
            Return
        ElseIf (iTType = 2) Then 'do Geologic Age
            Dim curAge As New GeolAge
            If (iRange = 1) Then 'do single Geologic Age
                curAge = CType(timeper(1), GeolAge)
                xmlTPnode = xmlHeader.CreateElement("sngdate")
                xmlSngGeol(curAge, xmlTPnode2)
                xmlTPnode.AppendChild(xmlTPnode2)
                xmlTPInfo.AppendChild(xmlTPnode)
            ElseIf (iRange = 2) Then 'do range of Geologic Ages
                curAge = CType(timeper(1), GeolAge) 'beginning Geologic Age
                xmlTPnode = xmlHeader.CreateElement("rngdates")
                xmlRngGeol(curAge, xmlTPnode2, 1)
                xmlTPnode.AppendChild(xmlTPnode2)
                curAge = CType(timeper(2), GeolAge) 'ending Geologic Age
                xmlRngGeol(curAge, xmlTPnode2, 2)
                xmlTPnode.AppendChild(xmlTPnode2)
                xmlTPInfo.AppendChild(xmlTPnode)
            Else 'do multiple Geologic Ages
                xmlTPnode = xmlHeader.CreateElement("mdattim")
                For iLoop = 1 To iCount
                    xmlTPnode2 = xmlHeader.CreateElement("sngdate")
                    curAge = CType(timeper(iLoop), GeolAge)
                    xmlSngGeol(curAge, xmlTPnode3)
                    xmlTPnode2.AppendChild(xmlTPnode3)
                    xmlTPnode.AppendChild(xmlTPnode2)
                Next
                xmlTPInfo.AppendChild(xmlTPnode)
            End If
            xmlPiece = xmlTPInfo
            Return
        Else
            MessageBox.Show("Invalid time type parameter passed to xmlTimePeriod Info. Contact author", "XML processing error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            xmlPiece = xmlTPInfo 'can always test upon return: if no children, then include or not as appropriate
            Return
        End If
    End Sub

    Private Sub xmlSngDT(ByRef curTime As SngDateTime, ByRef xmlTPnode As XmlNode)
        xmlTPnode = xmlHeader.CreateElement("sngdate")
        Dim xmlTPNode2 As XmlNode = xmlHeader.CreateElement("caldate")
        xmlTPNode2.InnerText = curTime.SngDate
        xmlTPnode.AppendChild(xmlTPNode2)
        If (curTime.TimeOfDay = "") Then
        Else
            bTimeUsed = True
            xmlTPNode2 = xmlHeader.CreateElement("time")
            xmlTPNode2.InnerText = curTime.TimeOfDay
            xmlTPnode.AppendChild(xmlTPNode2)
            bTimeUsed = True
        End If
    End Sub

    Private Sub xmlRngDT(ByRef curTime As SngDateTime, ByRef xmlFrag As XmlDocumentFragment, ByVal iPos As Integer)
        Dim xmlTempNode As XmlNode
        xmlFrag = xmlHeader.CreateDocumentFragment
        If (iPos = 1) Then 'do beginning date/time
            xmlTempNode = xmlHeader.CreateElement("begdate")
            If (curTime.SngDate = "") Then
                xmlTempNode.InnerText = "Unknown"
            Else
                xmlTempNode.InnerText = curTime.SngDate
            End If
            xmlFrag.AppendChild(xmlTempNode)
            If (curTime.TimeOfDay = "") Then
            Else
                bTimeUsed = True
                xmlTempNode = xmlHeader.CreateElement("begtime")
                xmlTempNode.InnerText = curTime.TimeOfDay
                xmlFrag.AppendChild(xmlTempNode)
                bTimeUsed = True
            End If
        ElseIf (iPos = 2) Then 'do ending date/time
            xmlTempNode = xmlHeader.CreateElement("enddate")
            If (curTime.SngDate = "") Then
                xmlTempNode.InnerText = "Unknown"
            Else
                xmlTempNode.InnerText = curTime.SngDate
            End If
            xmlFrag.AppendChild(xmlTempNode)
            If (curTime.TimeOfDay = "") Then
            Else
                bTimeUsed = True
                xmlTempNode = xmlHeader.CreateElement("endtime")
                xmlTempNode.InnerText = curTime.TimeOfDay
                xmlFrag.AppendChild(xmlTempNode)
                bTimeUsed = True
            End If
        Else
            MessageBox.Show("Invalid date range parameter!", "Error processing range XML", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

    Private Sub xmlSngGeol(ByRef curGeol As GeolAge, ByRef xmlGeol As XmlNode)
        Dim xmlTemp1 As XmlNode
        Dim xmlTemp2 As XmlNode
        Dim s1 As String = ""

        xmlGeol = xmlHeader.CreateElement("geolage")  'root element for the return node
        xmlTemp1 = xmlHeader.CreateElement("geolscal") 'add Geologic Time Scale
        xmlTemp1.InnerText = curGeol.TimeScale
        xmlGeol.AppendChild(xmlTemp1)

        xmlTemp1 = xmlHeader.CreateElement("geolest")  'add Geologic Age Estimate
        s1 = curGeol.Estim
        If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
        xmlTemp1.InnerText = s1
        xmlGeol.AppendChild(xmlTemp1)

        If (curGeol.Uncert = "") Then  'add Geologic Age Uncertainty if present (mandatory if applicable)
        Else
            xmlTemp1 = xmlHeader.CreateElement("geolun")
            s1 = curGeol.Uncert
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTemp1.InnerText = s1
            xmlGeol.AppendChild(xmlTemp1)
        End If

        If (curGeol.Explain = "") Then  'add Geologic Age Explanation if present (mandatory if applicable)
        Else
            xmlTemp1 = xmlHeader.CreateElement("geolexpl")
            s1 = curGeol.Explain
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTemp1.InnerText = s1
            xmlGeol.AppendChild(xmlTemp1)
        End If

        'process Geologic Citations (optional)
        Dim iCount As Integer = curGeol.GCiteCount
        Dim iLoop As Integer = 0
        Dim curCite As CiteInfo  'will hold the current citation
        Dim xmlGeolCite As XmlNode 'parent node for a citation
        Dim xmlPiece1 As XmlNode 'main citation
        Dim xmlPiece2 As XmlNode 'larger work citation if needed

        'create Geologic Citations
        For iLoop = 1 To iCount
            xmlGeolCite = xmlHeader.CreateElement("geolcit")
            curCite = curGeol.GCiteFetch(iLoop)
            xmlCiteinfo(curCite, xmlPiece1) 'generate main citation in xmlPiece1
            If (curGeol.GCbFetchLWC(iLoop) = True) Then  'generate larger work citation, if present, in xmlPiece2
                xmlTemp2 = xmlHeader.CreateElement("lworkcit")
                curCite = curGeol.GCiteFetchLWC(iLoop)
                xmlCiteinfo(curCite, xmlPiece2)
                xmlTemp2.AppendChild(xmlPiece2) 'put LWC into lworkcit
                xmlPiece1.AppendChild(xmlTemp2) 'put lworkcit into primary citeinfo, i.e, xmlPiece1
            End If
            xmlGeolCite.AppendChild(xmlPiece1)  'add citeinfo to geolcite node
            xmlGeol.AppendChild(xmlGeolCite)  'add the geologic citation to the Geologic Age XML
        Next
        Return
    End Sub

    Private Sub xmlRngGeol(ByRef curGeol As GeolAge, ByRef xmlGeol As XmlNode, ByVal iPos As Integer)
        Dim xmlTemp1 As XmlNode
        If (iPos = 1) Then
            xmlGeol = xmlHeader.CreateElement("beggeol")
            xmlSngGeol(curGeol, xmlTemp1)
            xmlGeol.AppendChild(xmlTemp1)
        ElseIf (iPos = 2) Then
            xmlGeol = xmlHeader.CreateElement("endgeol")
            xmlSngGeol(curGeol, xmlTemp1)
            xmlGeol.AppendChild(xmlTemp1)
        Else
            MessageBox.Show("Invalid Geologic Age range parameter!", "Error processing range XML", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

#End Region


#Region " File saving procedures -- XML creation, Contact Information section "

    Private Sub xmlContactInfo(ByRef objContact As ContactInfo, ByRef xmlContact As XmlNode)
        Dim xmlTempNode As XmlNode
        Dim xmlTempNode2 As XmlNode
        Dim sAddressParts() As String
        Dim sAddressLines() As String
        Dim sPartsDelim As String = ""
        Dim sLinesDelim As String = CrLf
        Dim s1 As String = ""
        Dim iCount As Integer = 0
        Dim iCountLines As Integer = 0
        Dim iLoop As Integer = 0
        Dim iLoop2 As Integer = 0
        Dim bVtel As Boolean = False

        xmlContact = xmlHeader.CreateElement("cntinfo")
        If (objContact.PrimaryPerson = True) Then 'contact person primary element
            xmlTempNode = xmlHeader.CreateElement("cntperp")
            xmlTempNode2 = xmlHeader.CreateElement("cntper") 'set the contact person info
            If (objContact.Person = "") Then
                Dim xmlAttrib As XmlAttribute = xmlHeader.CreateAttribute("missing")
                xmlAttrib.Value = "True"
                xmlTempNode2.Attributes.Append(xmlAttrib) 'add the "missing" attribute
            End If
            xmlTempNode2.InnerText = objContact.Person
            xmlTempNode.AppendChild(xmlTempNode2)
            If (objContact.Organization = "") Then
            Else
                xmlTempNode2 = xmlHeader.CreateElement("cntorg") 'set the contact organization, if present
                xmlTempNode2.InnerText = objContact.Organization
                xmlTempNode.AppendChild(xmlTempNode2)
            End If
        Else
            xmlTempNode = xmlHeader.CreateElement("cntorgp")
            xmlTempNode2 = xmlHeader.CreateElement("cntorg") 'set the contact organization info
            If (objContact.Organization = "") Then
                Dim xmlAttrib As XmlAttribute = xmlHeader.CreateAttribute("missing")
                xmlAttrib.Value = "True"
                xmlTempNode2.Attributes.Append(xmlAttrib) 'add the "missing" attribute
            End If
            xmlTempNode2.InnerText = objContact.Organization
            xmlTempNode.AppendChild(xmlTempNode2)
            If (objContact.Person = "") Then
            Else
                xmlTempNode2 = xmlHeader.CreateElement("cntper") 'set the contact person, if present
                xmlTempNode2.InnerText = objContact.Person
                xmlTempNode.AppendChild(xmlTempNode2)
            End If
        End If
        xmlContact.AppendChild(xmlTempNode) 'add primary contact, person or organization

        If (objContact.Position = "") Then
        Else
            xmlTempNode = xmlHeader.CreateElement("cntpos") 'set the contact position, if present
            xmlTempNode.InnerText = objContact.Position
            xmlContact.AppendChild(xmlTempNode)
        End If

        iCount = objContact.AddrCount 'get number of addresses associated with contact
        For iLoop = 0 To iCount - 1
            xmlTempNode = xmlHeader.CreateElement("cntaddr")
            sAddressParts = Split(objContact.AddrFetch(iLoop), sPartsDelim) 'break string into 6 parts
            xmlTempNode2 = xmlHeader.CreateElement("addrtype") 'set the address type
            xmlTempNode2.InnerText = sAddressParts(0)
            xmlTempNode.AppendChild(xmlTempNode2)
            sAddressLines = Split(sAddressParts(1), sLinesDelim) 'break address into lines
            iCountLines = sAddressLines.GetUpperBound(0)
            For iLoop2 = 0 To iCountLines
                If (sAddressLines(iLoop2) = "") Then
                Else
                    xmlTempNode2 = xmlHeader.CreateElement("address") 'set non-empty address lines
                    xmlTempNode2.InnerText = sAddressLines(iLoop2)
                    xmlTempNode.AppendChild(xmlTempNode2)
                End If
            Next
            xmlTempNode2 = xmlHeader.CreateElement("city") 'set the city info
            xmlTempNode2.InnerText = sAddressParts(2)
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlTempNode2 = xmlHeader.CreateElement("state") 'set the state/province info
            xmlTempNode2.InnerText = sAddressParts(3)
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlTempNode2 = xmlHeader.CreateElement("postal") 'set the postal code info
            xmlTempNode2.InnerText = sAddressParts(4)
            xmlTempNode.AppendChild(xmlTempNode2)
            If (sAddressParts(5) = "") Then
            Else
                xmlTempNode2 = xmlHeader.CreateElement("country") 'set the country info, if present
                xmlTempNode2.InnerText = sAddressParts(5)
                xmlTempNode.AppendChild(xmlTempNode2)
            End If
            xmlContact.AppendChild(xmlTempNode)
        Next

        If (iCount = 0) Then
            'put required data elements into XML; set as missing
            xmlTempNode = xmlHeader.CreateElement("cntaddr")
            xmlTempNode2 = xmlHeader.CreateElement("addrtype") 'set the address type
            Dim xmlAttrib As XmlAttribute = xmlHeader.CreateAttribute("missing")
            xmlAttrib.Value = "True"
            xmlTempNode2.Attributes.Append(xmlAttrib) 'add the "missing" attribute for Address Type
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlTempNode2 = xmlHeader.CreateElement("city") 'set the city info
            Dim xmlAttrib2 As XmlAttribute = xmlHeader.CreateAttribute("missing")
            xmlAttrib2.Value = "True"
            xmlTempNode2.Attributes.Append(xmlAttrib2) 'add the "missing" attribute for City
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlTempNode2 = xmlHeader.CreateElement("state") 'set the state/province info
            Dim xmlAttrib3 As XmlAttribute = xmlHeader.CreateAttribute("missing")
            xmlAttrib3.Value = "True"
            xmlTempNode2.Attributes.Append(xmlAttrib3) 'add the "missing" attribute for State/Province
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlTempNode2 = xmlHeader.CreateElement("postal") 'set the postal code info
            Dim xmlAttrib4 As XmlAttribute = xmlHeader.CreateAttribute("missing")
            xmlAttrib4.Value = "True"
            xmlTempNode2.Attributes.Append(xmlAttrib4) 'add the "missing" attribute for Postal Code
            xmlTempNode.AppendChild(xmlTempNode2)
            xmlContact.AppendChild(xmlTempNode)
        End If


        'set the contact voice telephone info
        sAddressLines = Split(objContact.VoiceTel, sLinesDelim)
        iCountLines = sAddressLines.GetUpperBound(0)
        For iLoop2 = 0 To iCountLines
            If (sAddressLines(iLoop2) = "") Then
            Else
                bVtel = True
                xmlTempNode2 = xmlHeader.CreateElement("cntvoice")
                xmlTempNode2.InnerText = sAddressLines(iLoop2)
                xmlContact.AppendChild(xmlTempNode2)
            End If
        Next
        If (bVtel = False) Then
            xmlTempNode2 = xmlHeader.CreateElement("cntvoice") 'minimum 1 voice telephone
            Dim xmlAttrib5 As XmlAttribute = xmlHeader.CreateAttribute("missing")
            xmlAttrib5.Value = "True"
            xmlTempNode2.Attributes.Append(xmlAttrib5) 'add the "missing" attribute for address type
            xmlContact.AppendChild(xmlTempNode2)
        End If


        If (objContact.TDDtel = "") Then
        Else
            sAddressLines = Split(objContact.TDDtel, sLinesDelim) 'set the TDD/TTY contact telephone info
            iCountLines = sAddressLines.GetUpperBound(0)
            For iLoop2 = 0 To iCountLines
                If (sAddressLines(iLoop2) = "") Then
                Else
                    xmlTempNode2 = xmlHeader.CreateElement("cnttdd")
                    xmlTempNode2.InnerText = sAddressLines(iLoop2)
                    xmlContact.AppendChild(xmlTempNode2)
                End If
            Next
        End If

        If (objContact.FaxTel = "") Then
        Else
            sAddressLines = Split(objContact.FaxTel, sLinesDelim) 'set the fax contact telephone info
            iCountLines = sAddressLines.GetUpperBound(0)
            For iLoop2 = 0 To iCountLines
                If (sAddressLines(iLoop2) = "") Then
                Else
                    xmlTempNode2 = xmlHeader.CreateElement("cntfax")
                    xmlTempNode2.InnerText = sAddressLines(iLoop2)
                    xmlContact.AppendChild(xmlTempNode2)
                End If
            Next
        End If

        If (objContact.Email = "") Then
        Else
            sAddressLines = Split(objContact.Email, sLinesDelim) 'set the e-mail contact info
            iCountLines = sAddressLines.GetUpperBound(0)
            For iLoop2 = 0 To iCountLines
                If (sAddressLines(iLoop2) = "") Then
                Else
                    xmlTempNode2 = xmlHeader.CreateElement("cntemail")
                    xmlTempNode2.InnerText = sAddressLines(iLoop2)
                    xmlContact.AppendChild(xmlTempNode2)
                End If
            Next
        End If

        If (objContact.Hours = "") Then
        Else
            xmlTempNode = xmlHeader.CreateElement("hours") 'set the hours of service, if present
            s1 = objContact.Hours
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode.InnerText = s1
            xmlContact.AppendChild(xmlTempNode)
        End If

        If (objContact.Instructions = "") Then
        Else
            xmlTempNode = xmlHeader.CreateElement("cntinst") 'set the contact instructions, if present
            s1 = objContact.Instructions
            If (iSaveType = 2) Then s1 = s1.Replace(CrLf, strParaMarker) 'HTML prep
            xmlTempNode.InnerText = s1
            xmlContact.AppendChild(xmlTempNode)
        End If

    End Sub

#End Region


#Region " General utility procedures "



#End Region

End Class
